#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

long long gcd(long long a, long long b){
    if(a<b)
        swap(a, b);
    if(b==0)
        return a;
    return gcd(b, a%b);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for(int qwe = 0; qwe<t; qwe++){
        int n, m;
        cin >> n >> m;
        vector<long long> c(n);
        for(int i = 0; i<n; i++)
            cin >> c[i];
        vector<vector<int> > g(n);
        for(int i = 0; i<m; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[a].push_back(b);
        }
        vector<bool> u(n);
        long long ans = 0;
        for(int i = 0; i<(1<<n); i++){
            bitset<20> it = i;
            u.assign(n, false);
            for(int i = 0; i<n; i++){
                if(!it[i])
                    continue;
                for(int j = 0; j<g[i].size(); j++)
                    u[g[i][j]] = true;
            }
            long long sum = 0;
            for(int i = 0; i<n; i++)
                sum += c[i]*u[i];
            ans = gcd(ans, sum);
            //cout << sum << ';';
        }
        cout << ans << '\n';
    }

    return 0;
}
