#include <iostream>
#include <vector>

#define int long long

using namespace std;

int gcd(int a, int b){
    if (!b){
        return a;
    }
    return gcd(b, a % b);
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> g(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u] = g[u] | (1 << v);
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        int cur = 0;
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1){
                cur = cur | g[i];
            }
        }
        int sum = 0;
        for (int i = 0; i < n; i++){
            if ((cur >> i) & 1){
                sum += a[i];
            }
        }
        ans = gcd(ans, sum);
    }
    cout << ans << "\n";
}

signed main()
{
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++){
        solve();
    }
    return 0;
}
