#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;

mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

const int N = 5e5 + 7;

vector<int> g[N];
ll c[N];
bool used[N];

ll gcd(ll a, ll b) {
	while (b) {
		a = a % b;
		swap(a, b);
	}
	return a;
}

void solve() {
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		fill(g, g + n, vector<int>());
		fill(c, c + n, 0);
		fill(used, used + n, false);
		for (int i = 0; i < n; i++)
			cin >> c[i];
		for (int i = 0; i < m; i++) {
			int a, b; cin >> a >> b; a--; b--;
			g[a].push_back(b);
		}
		ll ans = 0;
		for (int mask = 0; mask < (1 << n); mask++) {
			fill(used, used + n, false);
			for (int i = 0; i < n; i++) {
				if ((1 << i) & mask) {
					for (int j : g[i])
						used[j] = true;

				}
			}
			ll t = 0;
			for (int i = 0; i < n; i++) {
				if(used[i])
				t += c[i];
			}
			ans = gcd(ans, t);
		}
		cout << ans << endl;
	}
}