#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 

vector<int> g[maxn], gr[maxn];
bool u[maxn];
ll ans2 = 0;

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) {
			g[i].clear();
			gr[i].clear();
		}
		vector<ll> c(n), d(n);
		for (int i = 0; i < n; ++i) cin >> c[i];
		for (int i = 0; i < m; ++i) {
			int a, b;
			cin >> a >> b;
			a--; b--;
			d[a] += c[b];
			g[a].push_back(b);
			gr[b].push_back(a);
		}
		ll ans = 0;
		for (int i = 0; i < n; ++i) ans = gcd(ans, d[i]);
		ans2 = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) u[j] = 0;
			ll sm = 0;
			for (int j : gr[i]) {
				for (int h : g[j]) {
					if (!u[h]) {
						u[h] = 1;
						sm += c[h];
					}
				}
			}
			ans2 = gcd(ans2, sm);

		}
		cout << gcd(ans, ans2) << "\n";
	}

	return 0;
}