#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 5e5;

vector<int> g[N];
int a[N], b[N], c[N], d[N];

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
            g[i].clear();
            a[i] = b[i] = 0;
            d[i] = 0;
        }
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v, --u;
            a[v] += c[u];
            g[u].push_back(v);
            ++b[u];
        }
        int f = 0;
        for (int u = 0; u < n; ++u) {
            if (b[u] == 1) {
                d[g[u][0]] += c[u];
            }
            f += c[u] * (b[u] >= 1);
        }
        int ans = f;
        for (int v = 0; v < n; ++v) {
            ans = gcd(ans, gcd(f - d[v], a[v]));
        }
        cout << ans << '\n';
    }
    return 0;
}