#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    for (ll q = 0; q < t; q++) {
        ll n, m;
        cin >> n >> m;
        vector<ll> c(n);
        for (ll i = 0; i < n; i++) {
            cin >> c[i];
        }
        vector<vector<ll>> adj(n);
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            adj[u].push_back(v);
        }
        ll o = 0;
        for (ll i = 0; i < n; i++) {
            ll s = 0;
            for (ll j : adj[i]) {
                s += c[j];
            }
            o = gcd(o, s);
        }
        for (ll i = 0; i < n; i++) {
            for (ll k = 0; k < n; k++) {
                ll s = 0;
                for (ll j : adj[i]) {
                    if (find(adj[k].begin(), adj[k].end(), j) == adj[k].end()) {
                        s += c[j];
                    }
                }
                o = gcd(o, s);
            }
        }
        cout << o << "\n";
    }
    return 0;
}

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;
