#include <bits/stdc++.h>

using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<int>> graph(2 * n);
  vector<int> w(2 * n, 0);
  for (int i = n; i < 2 * n; i++)
    cin >> w[i];
  for (int i = 0; i < m; i++) {
    int v, u;
    cin >> v >> u;
    v--;
    u--;
    u += n;
    graph[v].push_back(u);
    graph[u].push_back(v);
  }
  long long ans = 0;
  for (int mask = 0; mask < (1 << n); mask++) {
    vector<int> used(2 * n, 0);
    long long sum = 0;
    for (int i = 0; i < n; i++) {
      if ((mask >> i) & 1) {
        for (auto u : graph[i]) {
          if (!used[u]) {
            sum += w[u];
            used[u] = 1;
          }
        }
      }
    }
    ans = gcd(ans, sum);
  }
  cout << ans << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--)
    solve();
  return 0;
}