#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<fstream>
///#pragma GCC optimize("Ofast")
#define int long long
#define all(a) a.begin(), a.end()
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n, m;
vector<int> c;
vector<int> used;
vector<vector<int>> g;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a%b);
}

void clrused() {
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
}

void init() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    cin >> n >> m;
    c.resize(n);
    used.resize(n);
    clrused();
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    g.clear();
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
    }
    ///cin.close(); cout.close();
}

signed main() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    int t;
    cin >> t;
    for (int tt = 0; tt < t; ++tt) {
        init();
        if (n <= 20 && m <= 400) {
            int ans = -1;
            for (int mask = 0; mask < (1 << n); ++mask) {
                clrused();
                for (int i = 0; i < n; ++i) {
                    if ((mask >> i) & 1) {
                        for (int u: g[i]) {
                            used[u] = 1;
                        }
                    }
                }
                int sum = 0;
                for (int i = 0; i < n; ++i) {
                    if (used[i]) {
                        sum += c[i];
                    }
                }
                if (ans == -1) {
                    ans = sum;
                }
                else {
                    ans = gcd(ans, sum);
                }
            }
            cout << ans << endl;
        }
    }

    ///cin.close(); cout.close();
    return 0;
}
