#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 5e5 + 5;

int n, m;
ll c[MAXN];
vector<int> g[MAXN];

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

ll gcd(ll a, ll b) {
	if (a == 0) return b;
	if (b == 0) return a;
	return gcd(b % a, a);
}

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		g[i] = {};
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v; --u; --v;
		g[u].push_back(v);
	}
	ll ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<bool> used(n);
		ll cost = 0;
		for (int i = 0; i < n; ++i) {
			if (check_bit(mask, i)) {
				for (auto to : g[i]) {
					if (used[to]) continue;
					else {
						used[to] = true;
						cost += c[to];
					}
				}
			}
		}
		ans = gcd(ans, cost);
	}
	cout << ans << "\n";
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}