#include "bits/stdc++.h"

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>
const int MAXN = 21;

using namespace std;

template<class T>
void read(vector<T> &a) {
    for (auto &i : a) cin >> i;
}

template<class T>
void write(vector<T> &a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

void solve() {
    int n, m; cin >> n >> m;
    vvi graph(n);
    int cnt = 0;
    vi c(n); read(c);
    for (int i = 0; i < m; ++i) {
        int v, u; cin >> v >> u;
        v--, u--;
        graph[v].pb(u);
    }
    for (int mask = 0; mask < 1 << n; ++mask) {
        set<int> in; int sum = 0;
        for (int i = 0; i < n; ++i) {
            if (1 << i & mask) {
                for (int u : graph[i]) {
                    in.insert(u);
                }
            }
        }
        for (int i : in) sum += c[i];
        cnt = __gcd(cnt, sum);
    }
    cout << cnt << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    int t; cin >> t;
    while(t--)
    solve();

    return 0;
}