#include <algorithm>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	cin >> t;

	while (t--)
	{
		int n = 0, m = 0;
		cin >> n >> m;

		vector<ll> c(n);
		for (int i = 0; i < n; ++i)
			cin >> c[i];

		vector<vector<int>> g(n);
		int u = 0, v = 0;
		for (int i = 0; i < m; ++i)
		{
			cin >> u >> v;
			g[u - 1].push_back(v - 1);
		}

		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask)
		{
			vector<bool> used(n);
			for (int i = 0; i < n; ++i)
				if (mask & (1 << i))
					for (auto v : g[i])
						used[v] = 1;
			
			ll sum = 0;
			for (int i = 0; i < n; ++i)
				if (used[i])
					sum += c[i];

			ans = gcd(ans, sum);
		}

		cout << ans << "\n";
	}


	return 0;
}