#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using namespace std;
using namespace __gnu_pbds;
#ifdef ONPC
	#define gc getchar_unlocked
#else
	#define gc _getchar_nolock
#endif

const int N = 500001;
int p[N];
ll c[N], x;
ul h[N], sh[N];
char ch;

ll ri() {
	x = 0;
	ch = gc();
	while (ch < '0' || ch > '9')
		ch = gc();
	while ('0' <= ch && ch <= '9') {
		x = x * 10 + ch - '0';
		ch = gc();
	}
	return x;
}

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	//ios_base::sync_with_stdio(0); cin.tie(0);
	int t, n, u, v, m;
	//cin >> t;
	t = ri();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<ul> dis(1, 2e18);
	rep(z, t) {
		n = ri();
		m = ri();
		//cin >> n >> m;
		rep(i, n) {
			//cin >> c[i];
			c[i] = ri();
			h[i] = dis(gen);
			sh[i] = 0;
			p[i] = i;
		}
		rep(i, m) {
			//cin >> u >> v;
			u = ri();
			v = ri();
			u--; v--;
			sh[v] ^= h[u];
		}
		sort(p, p + n, [](int p1, int p2) {return sh[p1] < sh[p2];});
		ll cs = 0, ans = 0;
		rep(i, n) {
			if (i > 0 && sh[p[i]] != sh[p[i - 1]]) {
				if (sh[p[i - 1]])
					ans = __gcd(ans, cs);
				cs = 0;
			}
			cs += c[p[i]];
		}
		if (sh[p[n - 1]])
			ans = __gcd(ans, cs);
		cout << ans << '\n';
	}
}

