#include <iostream>
#include <vector>

using namespace std;

int ans;

int gcd(int a, int b) {
	if (!(a && b))
		return a + b;
	return gcd(b % a, a);
}

void f(string sts, vector<int>& num, vector<pair<int, int> >& edges, int& n, int& m) {
	if ((int)sts.size() == n) {
		int sum = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (sts[edges[j].first] == '1' && edges[j].second == i) {
					sum += num[i];
					break;
				}
			}
		}
		ans = gcd(ans, sum);
		return;
	}
	f(sts + "0", num, edges, n, m);
	f(sts + "1", num, edges, n, m);
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
		ans = 0;

		int n, m;
		cin >> n >> m;

		vector<pair<int, int> > edges;
		vector<int> num(n);

		for (int i = 0; i < n; i++)
			cin >> num[i];
		
		int x1, x2;
		for (int i = 0; i < m; i++) {
			cin >> x1 >> x2;
			x1--; x2--;
			edges.push_back({x1, x2});
		}

		f("", num, edges, n, m);
		cout << ans << endl;
	}
}