#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;

mt19937 gen(time(NULL));

#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    void solve() {
        ll n, m;
        cin >> n >> m;
        vector<ll> g(n);
        vector<vector<int> > nxt(n);
        for (ll i = 0; i < n; i++) {
            cin >> g[i];
        }
        vector<ll> sum(n);
        ll big = 0;
        ll ans = 0;
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            --u, --v;
            nxt[u].push_back(v);
            sum[u] += g[v];
        }
        for (int i = 0; i < n; i++) {
            big += sum[i];
            ans = __gcd(ans, sum[i]);
        }
        ans = __gcd(ans, big);
        vector<int> used(n);
        ll T = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            ll now = 0;
            T++;
            for (int v = 0; v < n; v++) {
                for (auto to : nxt[v]) {
                    if (used[to] != T) {
                        now += g[to];
                    }
                    used[to] = T;
                }
            }
            ans = __gcd(ans, now);
        }
        cout << ans << "\n";
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    ll TEST_COUNT = 1;
    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
