#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <random>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

mt19937 rn(10483);

int gcd(int a, int b)
{
    while (a != 0 && b != 0)
    {
        a %= b;
        swap(a, b);
    }
    return a ^ b;
}

void solve()
{
    int n, m;
    cin >> m >> n;
    vector<pair<pair<int, int>, int>> t(m, make_pair(make_pair(0, 0), 0));
    for (int i = 0; i < m; i++) cin >> t[i].y;
    vector<int> make_hsh(m);
    for (int i = 0; i < m; i++) make_hsh[i] = rn() + 1;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        t[y].x.x += make_hsh[x];
        t[y].x.y += x + 1;
    }
    vector<bool> used(m, false);
    int ans = 0;
    for (int i = 0; i < m; i++)
    {
        if (used[i]) continue;
        if (t[i].x.y == 0) continue;
        int summ = 0;
        for (int j = i; j < m; j++)
        {
            if (t[j].x == t[i].x)
            {
                used[j] = true;
                summ += t[j].y;
            }
        }
        ans = gcd(ans, summ);
    }
    cout << ans << '\n';
    
}

int32_t main() 
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
    return 0;
}
