﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

ll gcd(ll a, ll b) {
	while (b > 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<ll> c(n);
		for (int i = 0; i < n; i++) cin >> c[i];
		map<vector<int>, ll> d;
		vector<vector<int> > sets(n);
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			sets[v - 1].push_back(u - 1);
		}
		for (int i = 0; i < n; i++) {
			sort(sets[i].begin(), sets[i].end());
			d[sets[i]] += c[i];
		}
		ll ans = 0;
		for (auto &elem : d) {
			ans = gcd(ans, elem.second);
		}
		cout << ans << '\n';
	}
}
