#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

int_fast64_t gcd(int_fast64_t a, int_fast64_t b){
    if(a<b)
        swap(a, b);
    if(b==0)
        return a;
    return gcd(b, a%b);
}

char u[20];
int git = 0;
int sz[20];
int g[20][20];
int_fast64_t c[20];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    bitset<20> it;
    for(int qwe = 0; qwe<t; qwe++){
        int n, m;
        cin >> n >> m;
        for(int i = 0; i<n; i++)
            cin >> c[i];
        git = n;
        memset(sz, 0x00, n*sizeof(sz[0]));
        for(int i = 0; i<m; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[a][sz[a]++] = b;
        }
        int_fast64_t ans = 0;
        for(int i = 0; i<(1<<n); i++){
            it = i;
            memset(u, 0x00, n*sizeof(u[0]));
            for(int i = 0; i<n; i++){
                if(!it[i])
                    continue;
                for(int j = 0; j<sz[i]; j++)
                    u[g[i][j]] = true;
            }
            int_fast64_t sum = 0;
            for(int i = 0; i<n; i++)
                sum += c[i]*u[i];
            ans = gcd(ans, sum);
            //cout << sum << ';';
        }
        cout << ans << '\n';
    }

    return 0;
}
