#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

long long c[21];
int G[21];

long long gcd(long long a, long long b) {
	if (a < b)
		swap(a, b);
	while (b != 0) {
		long long a1, b1;
		a1 = b;
		b1 = a % b;
		a = a1;
		b = b1;
		if (a < b)
			swap(a, b);
	}
	return a;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		long long g = 0;
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
			G[i] = 0;
		}
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u; --v;
			G[v] |= (1 << u);
		}
		long long sum = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			for (int i = 0; i < n; ++i) {
				if ((mask & G[i]) > 0)
					sum += c[i];
			}
			g = gcd(g, sum);
		}
		cout << g << '\n';
	}
	return 0;
}
