#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define endl "\n"
#define x first
#define y second 
#define vec vector
#define pii pair<int, int>
#define pb push_back

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	srand(time(0));
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}

void query() {
	int n, m;
	cin >> n >> m;
	vec<int> c(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> c[i];
	}

	vec<vec<int>> g(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].pb(v);
	}

	vec<int> dt;
	for (int mask = 0; mask < (1 << n); ++mask) {
		vec<int> used(n + 1);
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				for (auto u : g[i + 1]) {
					used[u] = 1;
				}
			}
		}

		int s = 0;
		for (int i = 1; i <= n; ++i) {
			if (used[i]) {
				s += c[i];	
			}
		}
		dt.pb(s);
	}

	int gg = dt[0];
	for (int i = 1; i < dt.size(); ++i) {
		gg = __gcd(gg, dt[i]);
	}

	cout << gg << endl;
}

void solve() {
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		query();
	}
}