#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

const int maxN = 21;

typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int gcd(int a, int b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n, m;
    cin >> n >> m;
    bitset<maxN> g[maxN];
    vector <int> c(n);
    for(int i = 0; i < n; ++i) cin >> c[i];
    for(int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a][b] = true;
    }
    bitset <maxN> BS;
    int ans = 0;
    for(int mask = 0; mask < (1 << n); ++mask) {
        for(int i = 0; i < maxN; ++i) BS[i] = false;
        int sum = 0;
        set <int> ver;
        for(int i = 0; i < n; ++i) {
            if((1 << i) & mask) {
                BS |= g[i];
            }
        }
        for(int i = 0; i < n; ++i) {
            if(BS[i]) sum += c[i];
        }
        ans = gcd(ans, sum);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}