#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 5e5 + 5;
const int MAX_TRIES = 100;

mt19937 mt(313);
int rng(int l, int r)
{
    return mt() % (r - l + 1) + l;
}

ll gcd(ll x, ll y)
{
    if(x > y)
        swap(x, y);
    return ((x == 0) ? y : gcd(x, y % x));
}


int n, m;
vector <int> nb[N];
ll c[N];

bool taken[N];
ll add_to_set(int u)
{
    ll res = 0;
    for(int v: nb[u])
        if(!taken[v])
        {
            taken[v] = 1;
            res += c[v];
        }

    return res;
}

void rmv_from_set(int u)
{
    for(int v: nb[u])
        taken[v] = false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int tests;
    cin >> tests;
    while(tests--)
    {
        vector <int> perm;

        cin >> n >> m;
        for(int i = 1; i <= n; i++)
        {
            nb[i].clear();
            perm.pb(i);
            cin >> c[i];
        }

        int u, v;
        for(int i = 1; i <= m; i++)
        {
            cin >> u >> v;
            nb[u].pb(v);
        }

        ll ans = 0;
        for(int it = 1; it <= MAX_TRIES; it++)
        {
            if(ans == 1)
                break;

            shuffle(perm.begin(), perm.end(), mt);
            int len = rng(1, n);
            ll sum = 0;
            for(int i = 0; i < len; i++)
                sum += add_to_set(perm[i]);

            ans = gcd(ans, sum);
            for(int i = 0; i < len; i++)
                rmv_from_set(perm[i]);
        }

        cout << ans << endl;
    }

    return 0;
}
