#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
#define int long long

bool find(int mask, int x) {
    return ((mask & (1 << x)) != 0);
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> v(n);
        vector<int> a(n);
        for (int &i : a)
            cin >> i;

        for (int i = 0; i < m; ++i) {
            int fr, to;
            cin >> fr >> to;
            fr--, to--;
            v[fr].emplace_back(to);
        }

        int ans = 0;
        for (int i = 0; i < v[0].size(); ++i)
            ans += a[v[0][i]];

        for (int mask = 2; mask < (1 << n); ++mask) {
            vector<int> used(n);
            for (int i = 0; i < n; ++i) {
                if (find(mask, i)) {
                    for (int j = 0; j < v[i].size(); ++j)
                        used[v[i][j]] = 1;
                }
            }
            int res = 0;
            for (int i = 0; i < n; ++i)
                res += used[i] * a[i];
            ans = __gcd(res, ans);
        }
        cout << ans << endl;
    }
    return 0;
}
