#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;

int gcd(int a, int b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

vector<int> p;

int find(int u){
    if (u == p[u])
        return u;
    return p[u] = find(p[u]);
}

void unite(int u, int v){
    u = find(u);
    v = find(v);
    if (rand() & 1)
        p[u]= v;
    else
        p[v] = u;

}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> c(n);
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    p.resize(n);
    for (int i = 0; i < n; ++i)
        p[i] = i;
    vvi g(n), rg(n);
    while(m--){
        int a, b; cin >> a >> b; a--; b--;
        g[a].push_back(b);
        rg[b].push_back(a);
    }
    for (int i = 0; i < n; ++i)
        sort(rg[i].begin(), rg[i].end());
    for (int i = 0; i < n; ++i)
        for (int j = i +1; j < n; ++j){
            bool o = 1;
            if (rg[i].size() == rg[j].size()){
                for (int k = 0; k < rg[i].size(); ++k)
                    if (rg[i][k] != rg[j][k])
                    o =0;
            }
            else
                o = 0;
            if (o)
                unite(i, j);
        }
    for (int i = 0; i < n; ++i)
        if (i != p[i]){
            c[find(i)] += c[i];
            c[i] = 0;
        }
    int gc = 0;
    for (int i = 0; i < n; ++i)
        gc = gcd(gc, c[i]);
    cout << gc << "\n";
}

int32_t main()
{
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}
