#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
const int MAXN = 27;
int c[MAXN], vis[MAXN];
bitset<MAXN> g[MAXN];
int gcd(int a, int b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
int solve(int n) {
	int ans = 0;
	for (int m = 1; m < (1 << n); ++m) {
		bitset<MAXN> vis;
		for (int i = 0; i < n; ++i) 
			vis[i] = 1;
		int sum = 0;
		for (int i = 0; i < n; ++i)
			if (m & (1 << i))
				vis &= g[i];
		for (int i = 0; i < n; ++i)
			if (vis[i])
				sum += c[i];
		ans = gcd(ans, sum);
	}
	return ans;
}
int popcount(int x) {
	int ans = 0;
	for (int i = 0; i < 30; ++i)
		if (x & (1 << i))
			++ans;
	return ans;
}
int solve2(int n) {
	int ans = 0;
	for (int v = 0; v < n; ++v) {
		bitset<MAXN> vis;
		for (int i = 0; i < n; ++i)
			vis[i] = 1;
		int sum = 0, ok = 0;
		for (int i = 0; i < n; ++i)
			if (g[i][v])
				vis &= g[i], ok = 1;
		for (int i = 0; i < n; ++i)
			if (vis[i])
				sum += c[i];
		if (ok)
			ans = gcd(ans, sum);
	}

	for (int v = 0; v < n; ++v) {
		bitset<MAXN> vis = g[v];
		int sum = 0;
		for (int i = 0; i < n; ++i)
			if (vis[i])
				sum += c[i];
		ans = gcd(ans, sum);
	}
	return ans;
}
signed main() {
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	mt19937 rnd;
	for (int i = 0; i < t; ++i) {
		int n, m;
		if (0) {
			for (int i = 0; i < n; ++i)
				c[i] = 1;
			for (int i = 0; i < 3; ++i)
				for (int j = 0; j < n; ++j)
					g[i][j] = (bool)max(0ll, (int)(rnd() % 3 - 1));
		} else {
			cin >> n >> m;
			for (int i = 0; i < n; ++i)
				cin >> c[i];
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < n; ++j)
					g[i][j] = 0;
			for (int i = 0; i < m; ++i) {
				int a, b;
				cin >> a >> b;
				g[a - 1][b - 1] = 1;
			}
		}
		int ans1 = solve(n);
		int ans2 = solve2(n);
		if (ans1 != ans2) {
			cout << "No" << endl;
			cout << ans1 << " " << ans2 << endl;
			for (int i = 0; i < 3; ++i) {
				for (int j = 0; j < n; ++j)
					cout << g[i][j];
				cout << "\n";
			}
			exit(1);
		}
		cout << ans1 << "\n";
	}

	return 0;
}
/*
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2 
1 3
1 4
2 2
2 4
3 1
4 3


1
6 12
1 1 1 1 1 1
1 1 
1 2
1 3
1 4
2 3
2 4
2 5
2 6
3 1
3 2
3 3
3 5
*/