#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    if (!a) return b;
    if (!b) return a;
    ll ost = a % b;
    while (ost) {
        a = b;
        b = ost;
        ost = a % b;
    }
    return b;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        vector<vector<int> > g(n + 1);
        vector<ll> sum(n + 1, 0);
        vector<ll> c(n + 1);
        ll gc = 0;
        for (int i = 1; i <= n; i++) {
            cin >> c[i];
            gc = gcd(gc, c[i]);
        }
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            sum[u] += c[v];
        }
        int ans = 0;
        for (int i = 1; i <= n; i++) {
            sort(g[i].begin(), g[i].end());
            ans = gcd(ans, sum[i]);
        }
        if (ans == 1 || ans == gc) {
            cout << ans << '\n';
            continue;
        }
        bool flag = false;
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                ll tmp = 0;
                int uk1 = 0, uk2 = 0, sz1 = g[i].size(), sz2 = g[j].size();
                while (uk1 < sz1 && uk2 < sz2) {
                    if (g[i][uk1] == g[j][uk2]) {
                        tmp += c[g[i][uk1]];
                        uk1++;
                        uk2++;
                        continue;
                    }
                    if (g[i][uk1] < g[j][uk2]) {
                        tmp += c[g[i][uk1]];
                        uk1++;
                        continue;
                    }
                    if (g[i][uk1] > g[j][uk2]) {
                        tmp += c[g[j][uk2]];
                        uk2++;
                        continue;
                    }
                }
                while (uk1 < sz1) {
                    tmp += c[g[i][uk1]];
                    uk1++;
                }
                while (uk2 < sz2) {
                    tmp += c[g[j][uk2]];
                    uk2++;
                }
                ans = gcd(ans, tmp);
                // ans = gcd(ans, sum[i] + sum[j] - tmp);
                /*if (ans == 1 || ans == gc) {
                    flag = true;
                    cout << ans << '\n';
                    break;
                }*/
            }
            if (flag) {
                break;
            }
        }
        if (!flag) {
            cout << ans << '\n';
        }
    }
    return 0;
}
