#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const int P = 47;

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

int input() {
	char c = ' ';
	int x = 0;
	while (!isdigit(c))
		c = _getchar_nolock();
	while (isdigit(c)) {
		x = x * 10 + (c - '0');
		c = _getchar_nolock();
	}
	return x;
}

void print(int x) {
	string s = to_string(x) + "\n";
	for (char c : s)
		_putchar_nolock(c);
	return;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	rn(t);
	fv(q, t) {
		int n = input(), m = input();
		vvi a(n);
		vector<int> c(n);
		for (int i = 0; i < n; ++i)
			c[i] = input();
		for (int i = 0; i < m; ++i) {
			int u = input(), v = input();
			--u; --v;
			a[v].pb(u + 1);
		}
		map<pair<int, pii>, int> b;
		fi(n) {
			if (a[i].empty())
				continue;
			sort(a[i].begin(), a[i].end());
			pii h = { 0, 0 };
			for (int u : a[i]) {
				h.first = (h.first * P + u) % MOD;
				h.second = (h.second * P + u) % MOD1;
			}
			b[{a[i].size(), h}] += c[i];
		}
		int g = 0;
		for (auto it : b)
			g = gcd(g, it.second);
		print(g);
	}

	return 0;
}