#include <iostream>
#include <set>
#include <vector>

using namespace std;

vector <int> c;
vector <vector <long long>> graph;

long long gcd(long long a, long long b)
{
    while (b != 0)
    {
        long long r = a % b;

        a = b;
        b = r;
    }

    return a;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long t, n, m;

    cin >> t;

    for (long long i = 0; i < t; i++)
    {
        c.clear();
        graph.clear();

        cin >> n >> m;

        for (long long j = 0; j < n; j++)
        {
            long long x;
            cin >> x;
            c.push_back(x);
        }

        graph.resize(n);

        for (long long j = 0; j < m; j++)
        {
            long long x, y;
            cin >> x >> y;
            graph[x - 1].push_back(y - 1);
            //graph[y - 1].push_back(x - 1);
        }

        long long mask = (1 << n);

        long long sum = 0;

        for (long long j = 0; j < mask; j++)
        {
            long long x = j;
            long long r = 0;
            long long summ = 0;
            set <long long> visited;
            while (x != 0)
            {
                long long h = x % 2;
                if (h == 1)
                {
                    for (auto k : graph[r])
                    {
                        if (visited.count(k) == 0)
                        {
                            summ += c[k];
                            visited.insert(k);
                        }
                    }
                }
                r++;
                x /= 2;
            }
            //cout << "SUMM! " << summ << " " << j << endl;
            sum = gcd(sum, summ);
        }
        cout << sum << endl;
    }
    return 0;
}
