#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    if (!a) return b;
    if (!b) return a;
    ll ost = a % b;
    while (ost) {
        a = b;
        b = ost;
        ost = a % b;
    }
    return b;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        vector<vector<int> > g(n + 1);
        vector<ll> sum(n + 1, 0);
        vector<ll> c(n + 1);
        ll gc = 0;
        for (int i = 1; i <= n; i++) {
            cin >> c[i];
            gc = gcd(gc, c[i]);
        }
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            sum[u] += c[v];
        }
        ll ans = 0;
        for (int i = 1; i <= n; i++) {
            sort(g[i].begin(), g[i].end());
            ans = gcd(ans, sum[i]);
        }
        /*if (ans == 1 || ans == gc) {
            cout << ans << '\n';
            continue;
        }*/
        for (int i = 0; i < (1 << n); i++) {
            vector<int> used(n + 1);
            for (int j = 1; j <= n; j++) {
                if (i & (1 << (j - 1))) {
                    for (auto u : g[j]) {
                        used[u] = 1;
                    }
                }
            }
            ll tmp = 0;
            for (int j = 1; j <= n; j++) {
                if (used[j]) {
                    tmp += c[j];
                }
            }
            ans = gcd(ans, tmp);
        }
        cout << ans << '\n';
    }
    return 0;
}
