#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

long long gcd(long long a, long long b) {
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	int t, n, m;
	cin >> t;
	while (cin >> n >> m) {
		long long ans = 0;
		vector<long long> r_c(n);
		cin >> r_c;

		vector<vector<int>> g(n);
		for (int i = 0, v, u; i < m; i++) {
			cin >> v >> u;
			g[v - 1].push_back(u - 1);
		}

		for (int mask = 1; mask < (1 << n); mask++) {
			vector<char> take(n, false);
			for (int v = 0; v < n; v++) {
				if ((mask >> v) & 1) {
					for (int u : g[v]) {
						take[u] = true;
					}
				}
			}

			long long sum = 0;
			for (int u = 0; u < n; u++) {
				if (take[u]) {
					sum += r_c[u];
				}
			}

			ans = gcd(ans, sum);
			if (ans == 1) {
				break;
			}
		}

		cout << ans << '\n';
	}
}