#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <math.h>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<ll> c(m);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    ll G = 0;
    vector<vector<int> > graph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        graph[v - 1].push_back(u - 1);
    }
    for (int mask = 0; mask < (1 << n); mask++) {
        ll now = 0;
        for (int i = 0; i < n; i++) {
            for (int u : graph[i]) {
                if (mask & (1 << u)) {
                    now += c[i];
                    break;
                }
            }
        }
        G = gcd(G, now);
    }
    cout << G << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int ij = 0; ij < t; ij++) {
        solve();
    }
}
//*/