#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 5e5 + 10;
pair<vector<int>, ll> cl[N];

ll gcd(ll a, ll b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> cl[i].se;
    for (int i = 0; i < n; i++) {
        cl[i].fi.clear();
        cl[i].fi.shrink_to_fit();
    }
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        cl[b].fi.pb(a);
    }
    for (int i = 0; i < n; i++) {
        sort(cl[i].fi.begin(), cl[i].fi.end());
    }
    sort(cl, cl + n);
    ll tmp = 0;
    ll res = 0;
    for (int i = 0; i < n; i++) {
        if (i > 0 && cl[i].fi != cl[i - 1].fi) {
            res = gcd(res, tmp);
            tmp = 0;
        }
        if (!cl[i].fi.empty()) tmp += cl[i].se;
    }
    if (tmp > 0) res = gcd(res, tmp);
    cout << res << '\n';
}

signed main() {
    fast();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}