#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 500005;

int n, m;
vector<int> g[MAXN];
long long c[MAXN];

bool b[MAXN];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;
    while (t--)
    {
        cin >> n >> m;
        for (int i = 1; i <= n; ++ i)
        {
            cin >> c[i];
        }
        for (int i = 1; i <= m; ++ i)
        {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
        }

        long long gcd = 0;
        for (int i = 0; i < (1 << n); ++ i)
        {
            for (int j = 1; j <= n; ++ j) b[j] = 0;
            for (int j = 1; j <= n; ++ j)
            {
                if (i & (1 << (j - 1)))
                {
                    for (int adj : g[j])
                    {
                        b[adj] = 1;
                    }
                }
            }

            long long sum = 0;
            for (int j = 1; j <= n; ++ j)
            {
                if (b[j]) sum += c[j];
            }

            if (i == 0) gcd = sum;
            else gcd = __gcd(gcd, sum);
        }

        for (int i = 1; i <= n; ++ i)
        {
            g[i].clear();
        }

        cout << gcd << endl;
    }
}

