#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(1e6) + 8;
const ll mod = ll(1e9) + 7;
const ll p = 31;

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

void solve() {
    ll n, m;
    vector<ll> vs[20];
    cin >> n >> m;
    vector<ll> c;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        c.pb(cur);
    }
    for(ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        vs[v].pb(u);
    }

    ll ans = 0;
    for(ll msk = 1; msk < (1 << n); msk++) {
        ll cur = 0;
        unordered_set<ll> verts;
        for(ll j = 0; j < n; j++) {
            if((1 << j) & msk) {
                for(auto el : vs[j]) {
                    verts.insert(el);
                }
            }
        }
        for(auto el : verts) {
            cur += c[el];
        }
        ans = gcd(ans, cur);
    }

    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q;
    cin >> q;
    for(ll i = 0; i < q; i++)
    solve();

    return 0;
}
