#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

long long gcd(long long a, long long b) {
	return (b == 0 ? a : gcd(b, a % b));
}

void build_cnt(vector <vector <int>>& a, vector <int> &cnt) {
	for (auto& u : cnt)
		u = 0;
	for (auto& u : a)
		for (auto& w : u)
			cnt[w]++;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n, m;
		long long ans = 0;
		cin >> n >> m;
		vector <long long> c(n);
		for (auto& u : c)
			cin >> u;
		vector <vector <int>> G(n);
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v, u--, v--;
			G[u].emplace_back(v);
		}
		vector <vector <int>> tmp;
		for (int i = 0; i < n; i++)
			if (G[i].size())
				tmp.emplace_back(G[i]);
		G = tmp;
		vector <vector <int>>(0).swap(tmp);
		vector <int> cnt(n), in(n, 0);
		build_cnt(G, cnt);
		while (*max_element(cnt.begin(), cnt.end()) > 1) {
			int inter = max_element(cnt.begin(), cnt.end()) - cnt.begin();
			vector <int> pos;
			for (int i = 0; i < G.size(); i++) {
				for (auto u : G[i])
					if (u == inter) {
						pos.emplace_back(i);
					}
			}
			for (auto u : G[pos[0]]) {
				in[u] = 1;
			}
			vector <int> intersec, a, b;
			for (auto u : G[pos[1]]) {
				if (in[u]) {
					intersec.emplace_back(u);
					in[u] = 0;
				}
				else {
					b.emplace_back(u);
				}
			}
			for (auto u : G[pos[0]]) {
				if (in[u]) {
					a.emplace_back(u);
					in[u] = 0;
				}
			}
			G.erase(G.begin() + pos[1]);
			G.erase(G.begin() + pos[0]);
			G.emplace_back(a);
			G.emplace_back(b);
			G.emplace_back(intersec);
			build_cnt(G, cnt);
		}
		for (auto &u : G) {
			long long tmp = 0;
			for (auto& w : u)
				tmp += c[w];
			ans = gcd(ans, tmp);
		}
		cout << ans << '\n';
	}
}