#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

int_fast64_t gcd(int_fast64_t a, int_fast64_t b){
    if(a<b)
        swap(a, b);
    if(b==0)
        return a;
    return gcd(b, a%b);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for(int qwe = 0; qwe<t; qwe++){
        int n, m;
        cin >> n >> m;
        vector<int> c(n);
        vector<vector<int> > g(n);
        for(int i = 0; i<n; i++)
            cin >> c[i];
        for(int i = 0; i<m; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[a].push_back(b);
        }
        vector<set<int> > d(n);
        for(int i = 0; i<n; i++){
            for(int j = 0; j<n; j++){
                if(i==j)
                    continue;
                d[i].insert(j);
            }
        }
        for(int i = 0; i<n; i++){
            vector<bool> u(n);
            for(int j = 0; j<g[i].size(); j++)
                u[g[i][j]] = true;
            for(int j = 0; j<n; j++){
                if(u[j])
                    continue;
                for(int y = 0; y<n; y++){
                    if(!u[y])
                        continue;
                    auto it = d[j].find(y);
                    if(it!=d[j].end())
                        d[j].erase(it);
                    it = d[y].find(j);
                    if(it!=d[y].end())
                        d[y].erase(it);
                }
            }
        }
        long long ans = 0;
        for(int i = 0; i<n; i++){
            long long sm = c[i];
            for(auto it = d[i].begin(); it!=d[i].end(); it++)
                sm += c[*it];
            ans = gcd(ans, sm);
        }
        cout << ans << '\n';
    }

    return 0;
}
