//#include <bits/stdc++.h>
//
//using namespace std;
//
//#define pb push_back
//#define forn(i, n) for(int i = 0; i < int(n); ++i)
//#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
//#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
//#define fst first
//#define snd second
//#define sz(X) (int)(X.size())
//#define all(X) X.begin(), X.end()
//
//typedef long long ll;
//typedef long double ld;
//typedef pair<int, int> pii;
//typedef vector<int> vi;
//
//const int MOD = 1e9 + 7;
//const int N = 15;
//
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
//    int n = 5;
//    set<vi> s;
//    forn(mask, 1 << n) {
//        vi a(n, 1);
//        forn(i, n) if (mask & (1 << i)) a[i]++;
//        int cnt = 0;
//        while (true) {
//            bool ch = false;
//            vi b(a);
//            forab(i, 1, n - 1) {
//                vi x{a[i - 1], a[i], a[i + 1]};
//                sort(all(x));
//                b[i] = x[1];
//                if (b[i] != a[i]) ch = true;
//            }
//            if (!ch) break;
//            cnt++;
//            a = b;
//        }
//        if (s.count(a)) continue;
//        s.insert(a);
//        for (int x : a) cout << x << " ";
//        cout << "\n";
//    }
//    return 0;
//}
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
#define fst first
#define snd second
#define sz(X) (int)(X.size())
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = 5e5;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<ll> c(n);
        forn(i, n) cin >> c[i];
        vector<vi> g(n);
        int u, v;
        forn(i, m) {
            cin >> u >> v;
            u--, v--;
            g[u].pb(v);
        }
        
        ll ans = 0;
        forn(mask, 1 << n) {
            vi used(n);
            forn(i, n) {
                if (mask & (1 << i)) {
                    for (int j : g[i]) used[j] = true;
                }
            }
            ll cur = 0;
            forn(i, n) if (used[i]) cur += c[i];
            ans = __gcd(ans, cur);
        }
        cout << ans << "\n";
    }

    return 0;
}