#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template <typename T>
struct Test {
    T data;
    bool is_ans_unique = false;
    int expected_ans = -1;
    Test(T d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = false;

typedef int TEST_TYPE;
typedef int RESULT_TYPE;

int n, m;
vector<long long> numbers;
vector<vector<int>> graph;

long long gcd(vector<long long> &a) {
    long long now = 0;
    for (const long long &e : a) {
        now = __gcd(now, e);
    }
    return now;
}

RESULT_TYPE solve() {
    return 0;
}

RESULT_TYPE stupid() {
    vector<long long> sums;
    for (int i = 0; i < (1 << n); ++i) {
        long long now = 0;
        vector<bool> was(n, false);
        for (int j = 0; j < n; ++j) {
            if (!((1 << j) & i)) continue;
            for (int u : graph[j]) {
                if (!was[u])
                now += numbers[u];
                was[u] = true;
            }
        }
        sums.emplace_back(now);
    }
    return gcd(sums);
}

void gen_test() {

}

void clean_data() {
    numbers.clear();
    graph.clear();
}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> m;
    numbers.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> numbers[i];
    }
    graph.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        graph[a].emplace_back(b);
    }
}

bool check(RESULT_TYPE stupid_ans, RESULT_TYPE smart_ans) {
    return true;
}

bool load_test(TEST_TYPE t) {
    return true;
}

vector<Test<TEST_TYPE>> pretests = {};

bool check_pretests(bool is_smart) {
    for (Test<TEST_TYPE> test : pretests) {
        if (!is_smart && !test.is_ans_unique) {
            continue;
        }
        clean_data();
        load_test(test.data);
        RESULT_TYPE stupid_ans = stupid();
        if (is_smart) {
            clean_data();
            load_test(test.data);
            RESULT_TYPE smart_ans = solve();

        } else {

        }
    }
    return true;
}

void precalc() {

}

int main() {
    precalc();
    if (IS_TESTING) {
        check_pretests(false);
    } else {
        int t;
        cin >> t;
        for (int i = 0; i < t; ++i) {
            read();
            cout << stupid() << '\n';
        }
    }

}