#include <bits/stdc++.h>
using namespace std;

#define int long long

typedef long long ll;
typedef pair < int, int > pii;
#define sz(x) int(x.size())
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 2;
const int MOD = 1e9 + 7;
const int N = 21;

struct solver {
    int n, m;
    ll c[N];
    vector < int > g[N];
    char s[N];

    void solve() {
        cin >> n >> m;
        //cout << n << " " << m << endl;
        for (int i = 1; i <= n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;

            g[u].push_back(v);
        }

        ll ans = 0;
        for (int i = 1; i <= (1 << n); i++) {
            memset(s, 0, sizeof s);
            for (int j = 0; j < n; j++) {
                if ((1 << j) & i) {
                    for (int x : g[j]) {
                        s[x] = 1;
                    }
                }
            }

            ll sum = 0;
            for (int i = 1; i <= 20; i++) {
                sum += (s[i] ? c[i] : 0);
            }


            ans = (ans ? __gcd(ans, sum) : sum);
            if (ans == 1) {
                break;
            }
        }

        cout << ans << "\n";
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int q;
    cin >> q;

    while (q--) {
        solver s1;
        s1.solve();
    }

    return 0;
}
