#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 5e5;

int n, m;
int s[N];
vector<int> g[N];
int b[N];

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            cin >> s[i];
            g[i].clear();
            b[i] = -1;
        }
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v, --u;
            g[v].push_back(u);
            if (b[u] == -1) {
                b[u] = v;
            }
        }
        int ans = 0;
        int cur = 0;
        for (int v = 0; v < n; ++v) {
            for (int u : g[v]) {
                cur += s[u] * (b[u] == v);
            }
            ans = gcd(ans, cur);
        }
        cout << ans << '\n';
    }
    return 0;
}