#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
using namespace std;
const int max_n = 5e5 + 1;
int n, m;
int f[max_n];
set<vector<int>> S;

void scan() {
    S.clear();

    cin >> n >> m;
    for(int i = 0;i < n;i++) cin >> f[i];
    vector<vector<int>> temp(n + 1);
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        temp[v1].emplace_back(v2);
    }
    for(int i = 0;i < n;i++)  {
        sort(temp[i].begin(), temp[i].end());
        if (!temp[i].empty()) S.emplace(temp[i]);
    }
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

bool eq(vector<int> a, vector<int> b) {
    if (a.size() != b.size()) return false;
    for(int i = 0;i < a.size();i++) if (a[i] != b[i]) return false;
    return true;
}

bool check(vector<int> a, vector<int> b) {
    if (eq(a, b)) return false;
    int num[n];
    for(int i = 0;i < n;i++) num[i] = 0;
    for(int i : a) num[i]++;
    for(int i : b) num[i] += 2;
    bool bad = true;
    for(int i = 0;i < n;i++) if (num[i] == 3) bad = false;
    if (bad) return false;
    vector<int> a1[3];
    for(int i = 0;i < n;i++) if (num[i] != 0) a1[num[i] - 1].emplace_back(i);

    S.erase(a);
    S.erase(b);
    for(int i = 0;i < 3;i++) if (!a1[i].empty()) S.emplace(a1[i]);
    return true;
}


void solve() {
    scan();

    while(true) {
        bool bad = false;
        for(auto one : S) {
            for(auto two : S) {
                if (check(one, two)) {
                    bad = true;
                    break;
                }
            }
            if (bad) break;
        }

        if (!bad) break;
    }

    int ans = 0;
    for(auto i : S) {
        int sum = 0;
        for(int j : i) sum += f[j];
        ans = gcd(ans, sum);
    }

    cout << ans;
}



signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}