#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int n, m;

ll c[500000];

vector<int> g[500000];

int used[500000];

ll G = 0;
ll cur = 0;

void rec(int ind) {
    if (ind == n) {
        return;
    }
    rec(ind + 1);
    for (auto to : g[ind]) {
        used[to]++;
        if (used[to] == 1) {
            cur += c[to];
        }
    }
    G = gcd(G, cur);
    rec(ind + 1);
    for (auto to : g[ind]) {
        used[to]--;
        if (used[to] == 0) {
            cur -= c[to];
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
    ///--------------------------------------------------------///
    int t;
    cin >> t;
    while (t--) {
        G = 0;
        cin >> n >> m;
        if (n > 20)
            return 0;
        for (int i = 0; i < n; i++) {
            g[i].clear();
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            g[l].push_back(r);
        }
        rec(0);
        cout << G << endl;
    }
    ///--------------------------------------------------------///
}