#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(1e6) + 8;
const ll mod = ll(1e9) + 7;
const ll p = 31;

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

ll dp[1 << 20];

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> vs(n, 0);
    vector<ll> c;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        c.pb(cur);
    }
    for(ll i = 0; i < m; i++) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        vs[v] |= (1 << u);
    }

    for(ll msk = 1; msk < (1 << n); msk++) {
        for(ll i = 0; i < n; i++) {
            if((1 << i) & msk) {
                dp[msk] = dp[msk ^ (1 << i)] + c[i];
                break;
            }
        }
    }

    ll ans = 0;
    vector<ll> nw(1, 0);
    for(ll i = 0; i < n; i++) {
        vector<ll> old = nw;
        for(auto el : old) {
            ll cur = el | vs[i];
            nw.pb(cur);
            ll val = dp[cur];
            ans = gcd(val, ans);
        }
    }

    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q;
    cin >> q;
    for(ll i = 0; i < q; i++)
    solve();

    return 0;
}
