#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

int get(int c) {
	int lm = rnd() % c;
	if (lm < 0) lm = -lm;
	return lm;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <ll> c(n);
	cin >> c;
	vector <int> g[5005];
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		g[x - 1].push_back(y - 1);
	}
	ll gcd = 0;
	bitset <5005> mask = 0;
	for (int i = 0; i < 5000; i++) {
		mask = 0;
		int lm = get(n + 1);
		for (int i = 0; i < lm; i++)
			mask[get(n)] = 1;
		ll sum = 0;
		vector <int> id;
		vector <ll> used(n, 1);
		for (int i = 0; i < n; i++) {
			if (mask[i])
				continue;
			for (auto &v : g[i]) {
				sum += used[v] * c[v];
				used[v] = 0;
			}
		}
		gcd = __gcd(gcd, sum);
	}
	cout << gcd << '\n';
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int t;
	cin >> t;

	while (t--)
		solve();

	return 0;
}