#include <iostream>
#include <vector>
#include <cmath>

#define ll long long

using namespace std;

const int max_n = 1e6;

ll c[max_n];
vector<int> g[max_n];
bool used[max_n];
vector<ll> f;

ll gcd(ll a, ll b) {
    while(a != 0 && b != 0) {
        if(a > b) {
            a %= b;
        }
        else {
            b %= a;
        }
    }
    return max(a, b);
}

ll group_1(int n) {
    f.clear();
    int d = 1;
    for(int i = 1; i <= n; i++) {
        d *= 2;
    }
    for(int i = 1; i < d; i++) {
        int ind = 1;
        int num = i;
        for(int j = 1; j <= n; j++) {
            used[j] = false;
        }
        while(num != 0) {
            if(num % 2 == 1) {
                int v = ind;
                for(int j = 0; j < g[v].size(); j++) {
                    int u = g[v][j];
                    used[u] = true;
                }
            }
            ind++;
            num /= 2;
        }
        ll sum = 0;
        for(int j = 1; j <= n; j++) {
            if(used[j]) {
                sum += c[j];
            }
        }
        f.push_back(sum);
    }
    for(int i = 1; i < f.size(); i++) {
        f[i] = gcd(f[i], f[i - 1]);
    }
    int f_s = f.size() - 1;
    return f[f_s];
}

int main() {
    int t;
    cin >> t;
    for(int ind = 1; ind <= t; ind++) {
        int n, m;
        cin >> n >> m;
        for(int i = 1; i <= n; i++) {
            cin >> c[i];
            g[i].clear();
        }
        for(int i = 1; i <= m; i++) {
            int v, u;
            cin >> v >> u;
            g[v].push_back(u);
        }
        cout << group_1(n) << '\n';
    }
    return 0;
}
