#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> used(n);
    vector<int> f(n);
    vector<int> c(n);
    vector<set<int>> g(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    int sum = 0;
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        f[a] += c[b];
        g[a].insert(b);
        if (!used[b]) {
            sum += c[b];
            used[b] = 1;
        }
    }
    ans = sum;
    for (int i = 0; i < n; ++i) {
        ans = __gcd(ans, f[i]);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int cur = f[i] + f[j];
            for (auto v : g[i]) {
                if (g[j].count(v)) {
                    cur -= c[j];
                }
            }
            ans = __gcd(ans, cur);
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}