#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

inline int get(int cc) {
	int l = rnd() % cc;
	if (l < 0) l = -l;
	return l;
}

int n, m, x, y, i, lm, u;
vector <int> g[5005];
ll c[5005];

void solve() {
	cin >> n >> m;
	for (i = 0; i < n; ++i) {
		g[i].clear();
		cin >> c[i];
	}
	for (i = 0; i < m; ++i) {
		cin >> x >> y;
		g[x - 1].push_back(y - 1);
	}
	ll gcd = 0, sum = 0;
	vector <int> used(n, 1);
	vector <int> was;
	for (int z = 0; z < 80000 && (gcd != 1); ++z) {
		lm = get(n + 1);
		sum = 0;
		for (i = 0; i < lm; ++i) {
			u = get(n);
			for (auto &v : g[u]) {
				sum += used[v] * c[v];
				if (used[v])
					was.push_back(v);
				used[v] = 0;
			}
		}
		while (!was.empty()) {
			used[was.back()] = 1;
			was.pop_back();
		}
		gcd = __gcd(gcd, sum);
	}
	cout << gcd << '\n';
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int t;
	cin >> t;

	while (t--)
		solve();

	return 0;
}