#include <bits/stdc++.h>

#define int long long

using namespace std;

int gcd(int x, int y)
{
    while (x && y)
    {
        int t = x % y;
        x = y;
        y = t;
    }
    return max(x, y);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> c(n);
    for (int i = 0; i < n; ++i) cin >> c[i];
    vector<vector<int> > gr(n);
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        gr[v].push_back(u);
    }
    vector<int> val(n);
    for (int i = 0; i < n; ++i)
    {
        val[i] = rand();
    }
    vector<pair<int, int> > all;
    for (int i = 0; i < n; ++i)
    {
        int now = 0;
        for (int j = 0; j < gr[i].size(); ++j)
            now += val[gr[i][j]];
        all.push_back({now, i});
    }
    sort(all.begin(), all.end());
    int result = 0;
    int now = c[all[0].second];
    for (int i = 1; i < all.size(); ++i)
    {
        if (all[i].first != all[i - 1].first)
        {
            if (result == 0) result = now;
            else result = gcd(now, result);
            now = 0;
        }
        now += c[all[i].second];
    }
    if (result == 0) result = now;
    else result = gcd(now, result);
    cout << result << endl;
}

signed main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}
