#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

int_fast64_t gcd(int_fast64_t a, int_fast64_t b){
    if(a<b)
        swap(a, b);
    if(b==0)
        return a;
    return gcd(b, a%b);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int_fast64_t t;
    cin >> t;
    for(int_fast64_t qwe = 0; qwe<t; qwe++){
        int_fast64_t n, m;
        cin >> n >> m;
        vector<int_fast64_t> c(n);
        vector<vector<int_fast64_t> > g(n);
        for(int_fast64_t i = 0; i<n; i++)
            cin >> c[i];
        vector<bool> u(n);
        for(int_fast64_t i = 0; i<m; i++){
            int_fast64_t a, b;
            cin >> a >> b;
            a--;
            b--;
            u[b] = true;
            g[a].push_back(b);
        }
        vector<int_fast64_t> rt(n);
        for(int i = 0; i<n; i++)
            rt[i] = u[i];
        int_fast64_t sz = 2;
        for(int_fast64_t i = 0; i<n; i++){
            int_fast64_t mx = sz;
            for(int j = 0; j<g[i].size(); j++){
                rt[g[i][j]] += sz;
                mx = max(mx, rt[g[i][j]]);
            }
            sz = mx+1;
        }
        map<int_fast64_t, int_fast64_t> sm;
        for(int i = 0; i<n; i++){
            if(rt[i]==0)
                continue;
            sm[rt[i]] += c[i];
        }
        int_fast64_t ans = 0;
        for(auto it = sm.begin(); it!=sm.end(); it++)
            ans = gcd(ans, it->second);
        cout << ans << '\n';
    }

    return 0;
}
