#include <bits/stdc++.h>

using namespace std;

const int kN = 5e5 + 7;
const int kMask = (1 << 20);

long long c[kN];
vector<int> adj[2 * kN];
int mask[kN];
long long sum_mask[kN];
bool used[kN];

long long gcd(long long a, long long b){
    if(a < b)
        swap(a, b);

    while(b != 0){
        long long c = b;
        b = a % b;
        a = c;
    }

    return a;
}

void solve(){
    int n, m;
    cin >> n >> m;

    for(int i = 1; i <= 2 * n; ++i)
        adj[i].clear();

    for(int i = 1; i <= n; ++i)
        cin >> c[i];

    for(int i = 0; i < m; ++i){
        int u, v;

        cin >> u >> v;
        adj[u + n].push_back(v);
        //adj[v].push_back(u + n);
    }

    long long ans = 0;
    for(int i = 0; i < (1 << n); ++i){
        long long curr = 0;
        for(int j = 1; j <= n; ++j)
            used[j] = false;
        for(int j = 0; j < n; ++j){
            if(i & (1 << j)){
                for(int x: adj[j + n + 1])
                    used[x] = true;
            }
        }

        for(int i = 1; i <= n; ++i)
            curr += used[i] ? c[i] : 0;

        ans = gcd(ans, curr);
    }

    cout << ans << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    cin >> t;

    while(t--)
        solve();
}
