#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<string>

using namespace std;

#define int long long

int gcd(int a, int b)
{
	if (min(a, b) == 0)
	{
		return max(a, b);
	}
	return gcd(min(a, b), max(a, b) % min(a, b));
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n, m;
		cin >> n >> m;
		if (n <= 20)
		{
			vector<int> a(n);
			for (int i = 0; i < n; i++)
			{
				cin >> a[i];
			}
			vector<vector<int>> g(n);
			for (int i = 0; i < m; i++)
			{
				int a, b;
				cin >> a >> b;
				g[a - 1].push_back(b - 1);
			}
			int ans = 0;
			for (int mask = 0; mask < (1 << n); mask++)
			{
				vector<int> vec;
				for (int i = 0; i < n; i++)
				{
					if (1 & (mask >> i))
					{
						for (auto u : g[i])
						{
							vec.push_back(u);
						}
					}
				}
				int sum = 0;
				sort(vec.begin(), vec.end());
				for (int i = 0; i < vec.size(); i++)
				{
					if (i == 0 || vec[i] != vec[i - 1])
					{
						sum += a[vec[i]];
					}
				}
				ans = gcd(ans, sum);
			}
			cout << ans << "\n";
		}
	}
}