#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;

const int N = 500001;
ll a[N];
ll gcd(ll a, ll b) {
	if (a == 0 && b == 0) return 0;
	while (b) {
		a = a % b;
		swap(a, b);
	}
	return a;
}
cc_hash_table<ll, ll> sm;
vi g[N];
ll hs[N];
const ll mod = 1111111113;
const ll p = 37;
ll rs[N];
void solve() {
	sm.clear();
	int n, m; cin >> n >> m;
	fr(i, n) cin >> a[i];
	fill(g, g + n, vi());
	fill(rs, rs + n, 0ll);
	ll t = 0;
	fr(i, m) {
		int u, v; cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
	}

	fr(i, n) {
		for (auto it : g[i]) {
			rs[it] += hs[i];
			rs[it] %= mod;
		}
	}

	for(int i = 0; i < n; ++i) if(rs[i] != 0) sm[rs[i]] += a[i];
	for(auto it : sm) t = gcd(t, it.second);
	
	cout << t << "\n";
}
int main() {
	hs[0] = 1;
	fr(i, N - 1) hs[i + 1] = hs[i] * p % mod;
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tst; cin >> tst;
	while(tst--) solve();
}