#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> used(n);
    vector<int> f(n);
    vector<int> c(n);
    vector<set<int>> g(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    int sum = 0;
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        f[a] += c[b];
        g[a].insert(b);
        if (!used[b]) {
            sum += c[b];
            used[b] = 1;
        }
    }
    ans = sum;
    for (int i = 0; i < n; ++i) {
        ans = gcd(ans, f[i]);
    }
    for (int i = 0; i < 1000; ++i) {
        used.assign(n, 0);
        int cur = 0;
        int mask = rand();
        if (mask == 0) ++mask;
        mask %= (1 << n);
        for (int j = 0; j < n; ++j) {
            if ((mask >> j) & 1) {
                for (auto v : g[j]) {
                    if (!used[v]) {
                        cur += c[v];
                        used[v] = true;
                    }
                }
            }
        }
        ans = gcd(ans, cur);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}