#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 20;
int n, m;
ll c[MAXN];
vector<int> g[MAXN];
vector<int> gr[MAXN];
int mask_from[MAXN];

void solve() {
    cin >> n >> m;
    rep(i, n) {
        cin >> c[i];
    }
    rep(i, n) {
        g[i].clear();
        gr[i].clear();
        mask_from[i] = 0;
    }
    rep(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        mask_from[v] |= (1 << u);
    }

    ll res = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        int msk = 0;
        rep(i, n) {
            if (mask & (1 << i)) {
                msk |= mask_from[i];
            }
        }

        if (msk == 0) continue;

        bool ok = true;
        rep(i, n) {
            if (mask & (1 << i)) {
                if (mask_from[i] != msk) {
                    ok = false;
                    break;
                }
            } else {
                if (mask_from[i] == msk) {
                    ok = false;
                    break;
                }
            }
        }

        if (ok) {
            ll cur = 0;
            rep(i, n) {
                if (mask & (1 << i)) {
                    cur += c[i];
                }
            }
            res = gcd(res, cur);
        }
    }

    // ll res = 0;
    // for (int mask = 1; mask < (1 << n); ++mask) {
    //     memset(used, 0, sizeof(used));
    //     ll cur = 0;
    //     rep(i, n) {
    //         if (mask & (1 << i)) {
    //             for (auto to : g[i]) {
    //                 if (!used[to]) {
    //                     used[to] = true;
    //                     cur += c[to];
    //                 }
    //             }
    //         }
    //     }
    //     res = gcd(res, cur);
    // }
    cout << res << endl;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    rep(tt, t) {
        solve();
    }
}
