#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 5e5 + 1;
const int inf = 1e9 + 1;

vector<int> g[maxn];
int used[maxn];
int c[maxn];
int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (auto &el : g[i]) {
            sum += c[el];
        }
        ans = gcd(ans, sum);
    }
    int sum = 0;
    for (int i = 1; i <= n; i++) {
        for (auto &el : g[i]) {
            if (used[el]) continue;
            used[el] = 1;
            sum += c[el];
        }
    }
    ans = gcd(ans, sum);
    cout << ans << '\n';
    for (int i = 1; i <= n; i++) {
        used[i] = 0;
        g[i].clear();
    }
}

/*
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3
 */

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
