#include <bits/stdc++.h>

using namespace std;

#define int long long

int gcd(int a, int b)
{
    if (b == 0)
    {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_)
    {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        vector<vector<int>> g(n + 1);
        for (int i = 0; i < n; ++i)
        {
            cin >> a[i];
        }
        for (int i = 0; i < m; ++i)
        {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g[u].push_back(v);
        }
        int ans = 0;
        vector<int> used(n);
        for (int i = 0; i < n + 1; ++i)
        {
            for (int j = 0; j < n + 1; ++j)
            {
                for (auto el : g[i])
                {
                    used[el] = true;
                }
                int sum = 0;
                for (auto el : g[j])
                {
                    if (!used[el])
                    {
                        sum += a[el];
                    }
                }
                ans = gcd(ans, sum);
                for (auto el : g[i])
                {
                    used[el] = false;
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
