#define _GLIBCXX_DEBUG


#include <bits/stdc++.h>


#define ll long long


#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl


using namespace std;

const ll inf = 1e9;
const ll mod = 1e9 + 7;
const double eps = 1e-7;

const int maxn = 20;


int c[maxn];
vector<int> graph[maxn];
bitset<maxn> r;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int test = 0; test < t; ++test) {
        int n, m;
        cin >> n >> m;
        int g = 0;
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
            graph[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            graph[u].emplace_back(v);
        }
        for (int mask = 0; mask < (1 << n); ++mask) {
            r = 0;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    for (int j: graph[i]) {
                        r |= (1 << j);
                    }
                }
            }
            int f = 0;
            for (int i = 0; i < n; ++i) {
                if (r[i]) {
                    f += c[i];
                }
            }
            g = gcd(g, f);
        }
        cout << g << "\n";
    }
}