#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool multitest = 1;

const int N = 20;

ll GCD(ll a, ll b){
    while (a > 0 && b > 0){
        if (a > b) a %= b; else b %= a;
    }
    return a + b;
}

void solve(){
    int n, m;
    cin >> n >> m;
    vll a(n);
    forn(i, n) cin >> a[i];
    vector<bitset<N>> g(n);
    forn(i, m){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v][u] = 1;
    }
    ll x = 0;
    forn(mask ,1 << n){
        bitset<N> b;
        forn(i, n){
            if (mask & (1 << i)) b |= g[i];
        }
        ll sum = 0;
        forn(i, n){
            if (b[i]) sum += a[i];
        }
        x = GCD(x, sum);
    }
    cout << x << '\n';
}

int main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}