#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <time.h>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)20;

int t;

ll gcd(ll a, ll b) {
    while (b) {
        ll r = a % b;
        a = b;
        b = r;
    }
    return a;
}

void solve0() {
    int n, m;
    scanf("%d%d", &n, &m);
    vector <ll> c(n);
    bitset <N> neib[N];
    rep(n, i) {
        scanf("%lld", &c[i]);
    }
    rep(m, i) {
        int v, u;
        scanf("%d%d", &v, &u);
        --v, --u;
        neib[v].set(u);
    }
    ll ans = 0;
    rep(1 << n, mask) {
        bitset <N> cur;
        rep(n, i) {
            if (mask >> i & 1) {
                cur |= neib[i];
            }
        }
        ll cur_num = 0;
        rep(n, i) {
            if (cur[i]) {
                cur_num += c[i];
            }
        }
        ans = gcd(ans, cur_num);
    }
    printf("%lld\n", ans);
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d", &t);
    rep(t, i) {
        solve0();
    }
    return 0;
}