#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, m, a[1000000];
vector <int> nx[1000000];
bool mark[1000000];

ll gcd(ll a, ll b) {
    while (a > 0 && b > 0) {
        if (a > b) a %= b;
			else b %= a;
    }
    return (a == 0 ? b : a);
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(100024);

	int q;
	cin >> q;
    int time = 100000000 / q;

    for (; q > 0; q--) {
        cin >> n >> m;
        for (ll i = 1; i <= n; i++) cin >> a[i];
        for (ll i = 1; i <= n; i++) nx[i].clear();
        for (ll i = 0; i < m; i++) {
			ll x, y;
			cin >> x >> y;
            nx[x].push_back(y);
        }
        ll ans = -1;
		for (ll i = 1; i <= n; i++) {
			ll s = 0;
            for (auto u : nx[i]) s += a[u];
            if (ans == -1) ans = s; else ans = gcd(ans, s);
		}
        for (ll i = 0; i < time / max(n, m); i++) {
			for (ll j = 1; j <= n; j++) mark[j] = false;
            for (ll j = 1; j <= n; j++) {
            	if (rand() % 2 == 0) continue;
                for (auto u : nx[j]) mark[u] = true;
			}
			ll s = 0;
            for (ll j = 1; j <= n; j++) if (mark[j]) s += a[j];
            if (ans == -1) ans = s; else ans = gcd(ans, s);
        }
        cout << ans << endl;
    }

	return 0;
}
