#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <unordered_set>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, INF = 1e9;

mt19937 rnd(time(0));

vector<vector<int>> g;
vector<int64_t> c, mask;
int64_t a, b, n, m, ans, f;
unordered_set<int64_t> S;

inline void read(){
    f = ans = 0;
    g.clear();
    S.clear();
    cin >> n >> m;
    g.resize(n+1);
    c.resize(n+1);
    mask.resize(n+1);
    for(int i = 1; i <= n; ++i)
        cin >> c[i];
    for(int i = 0; i < m; ++i){
        cin >> a >> b;
        g[a].pb(b);
    }
}

void rec(int pos = 1){
    if(pos==n+1){
        f = 0;
        S.clear();
        for(int i = 1; i <= n; ++i){
            if(mask[i]){
                for(int to: g[i]){
                    if(!S.count(to)) f+=c[to], S.insert(to);
                }
            }
        }
        ans = __gcd(f,ans);
        return;
    }
    rec(pos+1);
    mask[pos] = 1;
    rec(pos+1);
    mask[pos] = 0;
}

inline void solve(){
    rec();

}

inline void print(){
    cout << ans << "\n";
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        read();
        solve();
        print();
    }
    return 0;
}
