#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;

    vector <ll> c(n);
    for(int i = 0; i < n; i++) {
        cin >> c[i];
    }

    vector <vector <int> > g(n);
    for(int i = 0; i < m; i++) {
        int v, to;
        cin >> v >> to;
        v--, to--;

        g[v].push_back(to);
    }

    vector <ll> sums;
    for(int mask = 1; mask < (1 << n); mask++) {
        ll sum = 0;
        vector <int> used(n);
        for(int i = 0; i < n; i++) {
            int bit = (mask & (1 << i));
            if (bit) {
                for(auto to : g[i]) {
                    if (!used[to]) {
                        sum += c[to];
                        used[to] = 1;
                    }
                }
            }
        }

        if (sum) {
            sums.push_back(sum);
        }
    }

    ll gcd = sums[0];
    for(auto x : sums) {
        gcd = __gcd(gcd, x);
    }

    cout << gcd << "\n";
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int test;
    cin >> test;

    while(test--) {
        solve();
    }

    return 0;
}
