#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;


int t;

ll gcd(ll a, ll b) {
	if (a == 0)
		return b;
	return  gcd(b % a, a);
}

ll solve() {
	int n, m;
	cin >> n >> m;
	vector <ll> c(n);
	for (int i = 0; i < n; i++)
		cin >> c[i];
	vector <vi> gr;
	gr.resize(n);
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		gr[x - 1].pb(y - 1);
	}
	ll res = 0;
	for (int i = 0; i < n; i++) {
		ll sum = 0;
		for (auto it : gr[i])
			sum += c[it];
		res = gcd(res, sum);
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			vi com;
			for (auto it : gr[i])
				com.pb(it);
			for (auto it : gr[j])
				com.pb(it);
			sort(com.begin(), com.end());
			com.erase(unique(com.begin(), com.end()), com.end());
			ll sum = 0;
			for (auto it : com)
				sum += c[it];
			res = gcd(res, sum);
		}
	}
	return res;
}


int main() {
	fastIO();
	cin >> t;
	while (t--) {
		cout << solve() << '\n';
	}
	
	
	
	
	
	return 0;

}