#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;
typedef unsigned short ushort;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

#define int ll

int gcd(int a, int b) {
	while (min(a, b)) {
		if (a > b) {
			a %= b;
		}
		else {
			b %= a;
		}
	}
	return a + b;
}

vector<vector<int>> le_dol;

inline void solve() {
	int n, m;
	cin >> n >> m;
	le_dol.resize(n);
	vector<int> c(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		le_dol[a].push_back(b);
	}
	int max_mask = 1ll << n;
	int g = 0;
	for (int mask = 0; mask < max_mask; mask++) {
		vector<bool> used(n);
		for (int i = 0; i < n; i++) {
			if (mask & (1ll << i)) {
				for (auto t : le_dol[i]) {
					used[t] = 1;
				}
			}
		}
		int sum = 0;
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				sum += c[i];
			}
		}
		g = gcd(g, sum);
	}
	cout << g << nl;
}

signed main() {
	IO();
	int t;
	cin >> t;
	if (t >= 8) {
		exit(-1);
	}
	while (t--)
		solve();
}