#include <bits/stdc++.h>

std::mt19937 mt(69);

const int32_t MAX_N = 5e5;

struct Vertex {
	int32_t lastVis;
	int64_t val;
	std::vector< int32_t > v;
};

Vertex g[MAX_N + 5];

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t t;
	std::cin >> t;

	for(int32_t cs = 1; cs <= t; cs++) {
		int32_t n, m;
		std::cin >> n >> m;

		for(int32_t i = 1; i <= n; i++) {
			g[i].v.clear();
			g[i].lastVis = 0;
		}

		for(int32_t i = 1; i <= n; i++) {
			std::cin >> g[i].val;
		}

		std::vector< bool > has(n + 1, false);
		for(int32_t i = 0; i < m; i++) {
			int32_t u, v;
			std::cin >> u >> v;

			has[v] = true;

			g[u].v.push_back(v);
		}

		int64_t ans = 0;
		for(int32_t i = 1; i <= n; i++) {
			if(has[i]) {
				ans += g[i].val;
			}
		}
		
		int64_t prefSum = 0;
		for(int32_t j = 1; j <= n; j++) {
			int64_t sum = 0;
			for(auto &x : g[j].v) {
				sum += g[x].val;
				if(g[x].lastVis == 0) {
					g[x].lastVis = 1;
					prefSum += g[x].val;
				}	
			}

			ans = std::__gcd(ans, sum);
			ans = std::__gcd(ans, prefSum);
		}

		std::cout << ans << '\n';
	}
}