#include <iostream>
#include <vector>

#define int long long

using namespace std;

int gcd(int a, int b){
    if (!b){
        return a;
    }
    return gcd(b, a % b);
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> g(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u] = g[u] | (1 << v);
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        int cur = 0;
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1){
                cur = cur | g[i];
            }
        }
        int sum = 0;
        for (int i = 0; i < n; i++){
            if ((cur >> i) & 1){
                sum += a[i];
            }
        }
        ans = gcd(ans, sum);
    }
    cout << ans << "\n";
}

void solve2(){
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<vector<int> > g(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
    }
    int ans = 0;
    for (int i = 0; i < n; i++){
        int cur = 0;
        vector<bool> used(n);
        for (auto v : g[i]){
            cur += a[v];
            used[v] = 1;
        }
        ans = gcd(ans, cur);
        for (int j = i + 1; j < n; j++){
            int cur2 = cur;
            for (auto v : g[j]){
                if (!used[v]){
                    used[v] = 1;
                    cur2 += a[v];
                }
            }
            ans = gcd(ans, cur2);
        }
    }
    cout << ans << endl;
}

signed main()
{
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++){
        solve2();
    }
    return 0;
}
