#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 5e3 + 234;
const int M = 1e9 + 7;

bool w[N][N];

pair < int, int > e[N];

vector < int > g[N];

lll c[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        g[i].clear();
    }
    int x, y;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        w[x][y] = 1;
        e[i] = {x, y};
        g[x].pb(y);
    }
    lll ans = 0;
    lll cur;
    for (int i = 0; i < n; ++i) {
        cur = 0;
        for (int j = i; j < n; ++j) {
            for (auto v : g[i]) {
                cur += c[v];
            }
            for (auto v : g[j]) {
                if (!w[i][v]) {
                    cur += c[v];
                }
            }
        }
        ans = __gcd(ans, cur);
    }
    cout << ans << '\n';
    for (int i = 0; i < m; ++i) {
        w[e[i].F][e[i].S] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
