#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

const int INF = 1e9 + 1;

long long gcd(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    while (b != 0) {
        long long c = a % b;
        a = b;
        b = c;
    }
    return a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <long long> c(n);
        for (auto &l : c) {
            cin >> l;
        }
        vector <vector<int>> with(n, vector<int>(n));
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            with[u][v] = 1;
        }
        long long ans = 0;
        for (int mask = 1; mask < (1 << n); mask++) {
            vector <int> usd(n);
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    for (int j = 0; j < n; j++) {
                        if (with[i][j]) {
                            usd[j] = 1;
                        }
                    }
                }
            }
            long long sum = 0;
            for (int i = 0; i < n; i++) {
                if (usd[i]) {
                    sum += c[i];
                }
            }
            ans = gcd(ans, sum);
        }
        cout << ans << "\n";
    }
    return 0;
}
