#include <bits/stdc++.h>

#define int long long

using namespace std;

int gcd(int x, int y)
{
    while (x && y)
    {
        int t = x % y;
        x = y;
        y = t;
    }
    return max(x, y);
}

int solve1(int n, int m, vector<int> c, vector<pair<int, int> > e)
{
    vector<vector<int> > gr(n);
    for (int i = 0; i < m; ++i)
    {
        int u = e[i].first, v = e[i].second;
        --u;
        --v;
        gr[u].push_back(v);
    }
    int res = 0;
    for (int i = 0; i < (1 << n); ++i)
    {
        int cn = 0;
        for (int j = 0; j < n; ++j)
            if ((i >> j) & 1) ++cn;
        vector<int> cnt(n);
        for (int j = 0; j < n; ++j)
        if ((i >> j) & 1)
        {
            for (int k = 0; k < gr[j].size(); ++k)
                ++cnt[gr[j][k]];
        }
        int sum = 0;
        for (int j = 0; j < n; ++j)
            if (cnt[j] != 0)
                sum += c[j];
        res = gcd(res, sum);
    }
    return res;
}

int solve2(int n, int m, vector<int> c, vector<pair<int, int> > e)
{
    vector<vector<int> > gr(n);
    for (int i = 0; i < m; ++i)
    {
        int u = e[i].first, v = e[i].second;
        --u;
        --v;
        gr[v].push_back(u);
    }
    vector<int> val(n);
    for (int i = 0; i < n; ++i)
    {
        val[i] = rand() + 1;
    }
    vector<pair<int, int> > all;
    for (int i = 0; i < n; ++i)
    {
        int now = 0;
        for (int j = 0; j < gr[i].size(); ++j)
            now += val[gr[i][j]];
        all.push_back({now, i});
    }
    sort(all.begin(), all.end());
    int result = 0;
    int now = 0;
    /*cout << "all - " << endl;
    for (int i = 0; i < all.size(); ++i)
    {
        for (int j = 0; j < all[i].first.size(); ++j)
            cout << all[i].first[j] << " ";
        cout << ", " << all[i].second << endl;
    }*/
    for (int i = 0; i < all.size(); ++i)
    {
        if (all[i].first == 0) continue;
        if (all[i].first != all[i - 1].first)
        {
            if (result == 0) result = now;
            else result = gcd(now, result);
            now = 0;
        }
        now += c[all[i].second];
    }
    if (result == 0) result = now;
    else result = gcd(now, result);
    return result;
}

signed main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
    {
        int n, m;
        cin >> n >> m;
        vector<int> c(n);
        for (int j = 0; j < n; ++j) cin >> c[j];
        vector<pair<int, int> > e(m);
        for (int j = 0; j < m; ++j) cin >> e[j].first >> e[j].second;
        cout << solve2(n, m, c, e) << endl;
    }
}
