#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 20;
int n, m, g[mx], g0[mx];
ll val[mx], sum[1 << mx], sum1[1 << mx];

ll gcd(ll a, ll b) {
	return (b == 0 ? a : gcd(b, a % b));
}

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> val[i];
	}
	for (int i = 0; i < n; ++i) {
		g[i] = 0;
		g0[i] = 0;
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[v] ^= (1 << u);
		g0[u] ^= (1 << v);
	}
	fill(sum, sum + (1 << n), 0);
	for (int i = 0; i < m; ++i) {
		sum[g[i]] += val[i];
	}
	for (int bit = 0; bit < n; ++bit) {
		for (int sub = 0; sub < (1 << n); ++sub) {
			if (((sub >> bit) & 1) == 1) {
				sum[sub ^ (1 << bit)] += sum[sub];
			}
		}
	}
	// cerr << "sum:" << endl;
	// output(sum, sum + (1 << n));
	for (int sub = 1; sub < (1 << n); ++sub) {
		int mask = (1 << n) - 1;
		for (int i = 0; i < n; ++i) {
			if ((sub >> i) & 1) {
				mask &= g0[i];
			}
		}
		sum1[sub] = 0;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				sum1[sub] += val[i];
			}
		}
		// cerr << "sum1 " << sub << " " << sum1[sub] << endl;
		assert(sum1[sub] == sum[sub]);
	}
	// fill(sum1, sum1 + (1 << n), 0);
	// for (int sub = 0; sub < (1 << n); ++sub) {
	// 	for (int ssub = sub; true; ssub = ((ssub - 1) & sub)) {
	// 		sum1[sub] += sum[ssub];
	// 		if (ssub == 0) {
	// 			break;
	// 		}
	// 	}
	// }
	ll ans = 0;
	for (int sub = 1; sub < (1 << n); ++sub) {
		if (sum[sub]) {
			ans = gcd(ans, sum[sub]);
		}
	}
	cout << ans << endl;
}

signed main() {
	fast_io();
	int T;
	cin >> T;
	while (T--) {
		solve();
	}
}
