#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 20;

int n, m;
int s[N];
int mask[N];
int ss[1 << N];

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            cin >> s[i];
        }
        fill(mask, mask + n, 0);
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v; --u;
            mask[u] |= (1 << v);
        }
        fill(ss, ss + (1 << n), 0);
        for (int u = 0; u < n; ++u) {
            ss[mask[u]] += s[u];
        }
        int ans = 0;
        for (int i = 0; i < (1 << n); ++i) {
            ans = gcd(ans, ss[i]);
        }
        cout << ans << '\n';
    }
    return 0;
}