#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

#pragma GCC optimize('Ofast,no-stack-protector,unroll-loops')

const ll INF = 1e9 + 7;

void fast() {
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<ll>> grf;
vector<ll> m1;

void solve1() {
    ll n, m;
    cin >> n >> m;
    m1.clear();
    grf.clear();
    m1.resize(n + 1);
    grf.resize(n + 1);
    for (ll i = 1; i <= n; i++) {
        cin >> m1[i];
    }
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        grf[u].push_back(v);
    }
    ll ans = 0;
    for (ll mask = 0; mask < (1 << n); mask++) {
        if (mask == 0) {
            continue;
        }
        vector<bool> used(n + 1, 0);
        ll sum = 0;
        for (ll i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                for (auto& u : grf[i]) {
                    if (used[u]) {
                        continue;
                    }
                    used[u] = true;
                    sum += m1[u];
                }
            }
        }
        ans = __gcd(ans, sum);
    }
    cout << ans << endl;
}

signed main() {
    fast();

    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        solve1();
    }
    return 0;
}
