#pragma GCC optimize("-Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>


#define F first
#define S second
#define pb push_back
#define ll long long

using namespace std;
using namespace __gnu_pbds;


typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

mt19937 gen(time(0));

const int maxn = 20;
const int inf = 1e9 + 7;

ll c[maxn];
ll dp[1 << maxn];
int msk[maxn];



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t;
    cin >> t;
    for(int it = 0; it < t; ++it)
    {
        int n, m;
        cin >> n >> m;
        for(int i = 0; i < n; ++i)
            cin >> c[i];
        fill(msk, msk + n, 0);
        for(int i = 0; i < m; ++i)
        {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            msk[u] += 1 << v;
        }

        for(int i = 0; i < (1 << n); ++i)
        {
            dp[i] = 0;
            for(int j = 0; j < n; ++j)
                if (i & (1 << j)) dp[i] += c[j];
        }
        ll ans = 0;
        for(int i = 1; i < (1 << n); ++i)
        {
            int resmsk = 0;
            for(int j = 0; j < n; ++j)
                if (i & (1 << j)) resmsk |= msk[j];
            ans = __gcd(ans, dp[resmsk]);
        }
        cout << ans << '\n';
    }
    return 0;
}
