#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
int n, m;
vector<pair<vector<int>, ll> > g;

ll gcd(ll a, ll b) {
	return (b == 0 ? a : gcd(b, a % b));
}

void solve() {
	cin >> n >> m;
	g.assign(n, {vector<int> (), 0});
	for (int i = 0; i < n; ++i) {
		cin >> g[i].second;
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[v].first.push_back(u);
	}
	for (int i = 0; i < n; ++i) {
		sort(all(g[i].first));
	}
	sort(all(g));
	ll ans = 0, sum = 0;
	for (int i = 0; i < n; ++i) {
		if (!g[i].first.empty()) {
			sum += g[i].second;
			if (i == n - 1 || g[i].first != g[i + 1].first) {
				if (sum) {
					ans = gcd(ans, sum);
				}
				sum = 0;
			}
		}
	}
	cout << ans << "\n";
}

signed main() {
	fast_io();
	int T;
	cin >> T;
	while (T--) {
		solve();
	}
}
