import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class C {
    static BufferedReader in;
    static StringTokenizer st;
    static ArrayList adj[];

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        int t = nextInt();
        for (int i = 0; i < t; i++) {
            fn();
            int n = nextInt();
            int m = nextInt();
            long c[] = new long[n];
            fn();
            for (int j = 0; j < n; j++) {
                c[j] = nextLong();
            }
            adj = new ArrayList[n];
            for (int j = 0; j < n; j++) {
                adj[j] = new ArrayList();
            }
            for (int j = 0; j < m; j++) {
                fn();
                int x = nextInt() - 1;
                int y = nextInt() - 1;
                adj[x].add(y);
            }
            long ans = 0;
            for (int j = 0; j < n; j++) {
                int ms[] = new int[n];
                long sm = 0;
                for (int k = 0; k < adj[j].size(); k++) {
                    int to = (int) adj[j].get(k);
                    ms[to] = 1;
                    sm += c[to];
                }
                for (int k = 0; k < n; k++) {
                    long p = sm;
                    for (int l = 0; l < adj[k].size(); l++) {
                        int to = (int) adj[k].get(l);
                        if (ms[to] == 0) p += c[to];
                    }
                    ans=gcd(ans,p);
                }
            }
            System.out.println(ans);
            if(i!=t-1)fn();
        }
    }

    private static long gcd(long a, long b) {
        if(a==0)return b;
        return gcd(b%a,a);
    }

    private static long nextLong() {
        return Long.parseLong(st.nextToken());
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
