#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll n, m, a[1000000];
vector <ll> nx[1000000];
vector <ll> order;
ll mark[1000000];

ll gcd(ll a, ll b) {
    while (a > 0 && b > 0) {
        if (a > b) a %= b;
			else b %= a;
    }
    return (a == 0 ? b : a);
}

ll ans = 0;

void rec(ll v) {
	if (v == n+1) {
		ll s = 0;
        for (ll i = 1; i <= n; i++) {
            if (mark[i] > 0) s += a[i];
        }
        ans = gcd(ans, s);
        return ;
	}
	rec(v+1);
    for (auto u : nx[v]) mark[u]++;
    rec(v+1);
    for (auto u : nx[v]) mark[u]--;
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(100024);

	ll q;
	cin >> q;
    ll time = 30000000 / q;

    for (; q > 0; q--) {
        cin >> n >> m;
        ll g = 0;
        for (ll i = 1; i <= n; i++) cin >> a[i];
        for (ll i = 1; i <= n; i++) nx[i].clear();
        for (ll i = 0; i < m; i++) {
			ll x, y;
			cin >> x >> y;
            nx[x].push_back(y);
        }
        ans = 0;
        if (n <= 20) {
			for (ll i = 1; i <= n; i++) mark[i] = 0;
			rec(1);
			cout << ans << endl;
			continue;
        }

        order.clear();
        for (int i = 1; i <= n; i++) order.push_back(i);
        sort(order.begin(), order.end(), [](int a, int b) { return nx[a].size() < nx[b].size(); });
        for (int w = 0; w < time / max(n, m); w++) {
			for (int i = 1; i <= n; i++) mark[i] = false;
			for (auto i : order) {
				if (rand() % ((w % 5) + 2) != 0) {
					ll s = 0;
					for (auto u : nx[i]) {
                        if (mark[u]) continue;
                        mark[u] = true;
						s += a[u];
					}
                    ans = gcd(ans, s);
				}
			}
        }
        cout << ans << endl;
    }

	return 0;
}
