#include <bits/stdc++.h>

using namespace std;
#define int long long
int allrandom = 350000000;
mt19937 rng;
int __rndlast, __rnddg = -1;
inline bool randbit()
{
    __rndlast >>= 1;
    if (__rnddg < 0)
    {
        __rnddg = 16;
        __rndlast = rng();
    }
    __rnddg--;
    return (__rndlast & 1);
}
void solve(int randlim)
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int buka = a[0];
    for (int i = 0; i < n; i++)
        buka = __gcd(a[i], buka);

    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
    }

    int biaka = -1;
    {
        vector<bool> used(n, false);
        for (int i = 0; i < n; i++)
        {
            int bds = 0;
            for (int to : g[i])
                bds += a[to], used[to] = true;
            if (bds == 0)
                continue;
            if (biaka < 0)
                biaka = bds;
            else
                biaka = __gcd(biaka, bds);
        }
        int tsum = 0;
        for (int i = 0; i < n; i++)
            if (used[i])
                tsum += a[i];
        if (biaka < 0)
            biaka = tsum;
        else
            biaka = __gcd(biaka, tsum);
    }
    while (randlim > 0 && biaka > buka)
    {
        randlim -= n;
        allrandom -= n;
        int tsum = 0;
        vector<bool> used(n, false);
        for (int i = 0; i < n; i++)
        {
            if (randbit())
            {
                randlim -= g[i].size();
                allrandom -= g[i].size();
                for (int to : g[i])
                    if (!used[to])
                {
                    used[to] = true;
                    tsum += a[to];
                }
            }
        }
        if (tsum != 0)
            biaka = __gcd(biaka, tsum);
    }
    cout << biaka << "\n";
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    rng.seed(198356627);
    int t;
    cin >> t;
    while (t-->0)
        solve(allrandom / (t + 1) + rng() % 100000);
    return 0;
}
