#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <time.h>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

#define int int64_t

int func(int a, int b)
{
	if (b < a)
		swap(b, a);
	if (a == 0)
		return b;
	return func(a, b % a);
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	srand(time(0));
	srand(time(0));
	srand(time(0));
	cin >> t;
	vector<bool> numers(500000, 0);
	vector<bool> numers2(500000, 0);
	for (int q = 0; q < t; ++q)
	{
		int n, m;
		cin >> n >> m;
		vector<int> ar(n, 0);
		vector<int> ar2;
		for (int i = 0; i < n; ++i)
			cin >> ar[i];
		vector<vector<int> > g(n, vector<int>());
		for (int i = 0; i < m; ++i)
		{
			int a, b;
			cin >> a >> b;
			a--, b--;
			g[a].push_back(b);
		}
		for (int i = 0; i < n; ++i)
		{
			int cnt = 0;
			for (int j = 0; j < g[i].size(); ++j)
			{
				cnt += ar[g[i][j]];
			}
			ar2.push_back(cnt);
		}
		int gcd2 = 0;
		for (int i = 0;i < n; ++i)
			gcd2 = func(gcd2, ar[i]);
		int gcd = ar2[0];
		for (int i = 1; i < ar2.size(); ++i)
		{
			gcd = func(gcd, ar2[i]);
		}
		int cnt2 = 9517;
		int cnt = 0;
		vector<int> ar3;
		if (n < 100 && m < 500)
			cnt2 = 100000;
		while (cnt < cnt2)
		{
			cnt++;
			int sum = 0;
			int a;
			if (cnt == 1)
				a = n - 1;
			else
				a = rand() % n;
			ar3.resize(0);
			for (int i = 0; i <= a; ++i)
			{
				int b = rand() % n;
				if (numers[b] == 0)
				{
					ar3.push_back(b);
					numers[b] = 1;
				}
			}
			for (int i = 0; i < ar3.size(); ++i)
			{
				numers[ar3[i]] = 0;
				for (int j = 0; j < g[ar3[i]].size(); ++j)
				{
					if (numers2[g[ar3[i]][j]] == 0)
					{
						sum += ar[g[ar3[i]][j]];
						numers2[g[ar3[i]][j]] = 1;
					}
				}
			}
			for (int i = 0; i < ar3.size(); ++i)
			{
				for (int j = 0; j < g[ar3[i]].size(); ++j)
				{
					numers2[g[ar3[i]][j]] = 0;
				}
			}
			gcd = func(gcd, sum);
			if (gcd == gcd2)
				break;
		}
		cout << gcd << endl;
	}
}