#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define ld long double
#define w while
#define con continue
#define br break
#define elif else if
#define INF 1e18
#define inf 1e9
#define EPS 1e-8
#define eps 1e-4
#define int signed
#define datahash pair <pair <vector <ll>, vector <ll>>, vector <ll>>

ll gcd(ll a, ll b) {
    return a ? gcd(b % a, a) : b;
}

const ll p1 = 359657;
const ll m1 = 1000000007;
const ll p2 = 307;
const ll m2 = 1000000009;

datahash phash(const string &s, ll p, ll m) {
    vector <ll> ps(s.size() + 1);
    vector <ll> hs(s.size() + 1);
    vector <ll> rhs(s.size() + 1);
    ps[0] = 1;
    hs[0] = 0;
    for (ll i = 0; i < s.size(); i++) {
        ps[i + 1] = (ps[i] * p) % m;
        hs[i + 1] = (hs[i] * p + s[i]) % m;
    }
    rhs[s.size()] = 0;
    for (ll i = s.size() - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * p + s[i]) % m;
    }
    return { {hs, rhs}, ps};
}

ll gethash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.first[j + 1] - hasher.first.first[i] * hasher.second[j - i + 1] + m * m) % m;
}
ll getrhash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.second[i] - hasher.first.second[j + 1] * hasher.second[j - i + 1] + m * m) % m;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        ll n, m, a, b;
        cin >> n >> m;
        vector<ll> c(n);
        vector<vector<ll>> g(n);
        for (ll j = 0; j < n; j++) {
            cin >> c[j];
        }
        for (ll j = 0; j < m; j++) {
            cin >> a >> b;
            a--;
            b--;
            g[a].push_back(b);
        }
        vector<ll> sums;
        for (ll mask = 1; mask < (1 << n); mask++) {
            vector<char> usd(n);
            ll su = 0;
            for (ll v = 0; v < n; v++) {
                if (mask & (1 << v)) {
                    for (auto u : g[v])
                        usd[u] = 1;
                }
            }
            for (ll v = 0; v < n; v++) {
                if (usd[v])
                    su += c[v];
            }
            sums.push_back(su);
        }
        ll cur = sums[0];
        for (ll i = 1; i < sums.size(); i++) {
            if (cur == 1)
                br;
            if (sums[i] == 0)
                con;
            cur = gcd(cur, sums[i]);
        }
        cout << cur << endl;
    }
    return 0;
}
