#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(c) sort(all(c))
#define reverse(c) sort(all(c))

ostream& operator <<(ostream& out, vector<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, deque<auto> d) {
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vector<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

istream& operator >>(istream& in, pair<auto, auto>& p) {
	return (cin >> p.fi >> p.se);
}

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main() {
    int t;
    cin >> t;
    for (int _i = 0; _i < t; ++_i) {
        int n, m;
        cin >> n >> m;
        vector<ll> vec(n, 0);
        vector<vector<int>> g(n, vector<int>());
        cin >> vec;
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            g[a].pb(b);
        }
        ll ans = 0;
        for (int mask = 0; mask < (1<<n); ++mask) {
            unordered_set<int> now;
            for (int i = 0; i < n; ++i) {
                if (((1<<i)|mask) == mask) {
                    for (int j: g[i]) {
                        now.insert(j);
                    }
                }
            }
            ll sum = 0;
            for (ll a: now) {
                sum += vec[a];
            }
            ans = gcd(ans, sum);
            //cout << sum << ' ';
        }
        //cout << '\n' << ans << '\n';
        cout << ans << '\n';
    }
}
