#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

ll gcd(ll a, ll b){
    if (!b)
        return a;
    return gcd(b, a % b);
}

ll get(int mask, vector<vector<int>> &graph, vector<ll> &val){
    int n = val.size();
    vector<int> used(n);
    ll ans = 0;
    for (int i = 0; i < n; i++)
        if (mask & (1 << i))
            for (int el : graph[i])
                if (!used[el]){
                    used[el] = 1;
                    ans += val[el];
                }
    return ans;
}

void run(){
    int n, m;
    cin >> n >> m;
    vector<ll> val(n);
    for (int i = 0; i < n; i++)
        cin >> val[i];
    vector<vector<int>> graph(n);
    int a, b;
    for (int i = 0; i < m; i++){
        cin >> a >> b;
        graph[a - 1].pb(b - 1);
    }

    int mx_mask = (1 << n);
    ll ans = 0;
    for (int mask = 1; mask < mx_mask; mask++){
        ll curr = get(mask, graph, val);
        //cout << curr << endl;
        ans = gcd(ans, curr);
    }
    cout << ans << "\n";
}

signed main(){
    //freopen("inp", "r", stdin);
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t; cin >> t;
    for (int i = 0; i < t; i++)
        run();
    return 0;
}