#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define int long long

using namespace std;

const int N = 5e5 + 7;
map <vector <int>, int> summ;
vector <int> g[N];
int c[N];

void solve() {
    int n, m;
    cin >> n >> m;
    summ.clear();
    int res = -1;
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        g[u].push_back(v);
    }
    for (int i = 1; i <= n; i++) {
        sort(g[i].begin(), g[i].end());
        if (!g[i].empty()) summ[g[i]] += c[i];
    }
    for (auto elem : summ) {
        if (res == -1) res = elem.second;
        res = __gcd(res, elem.second);
    }
    cout << res << endl;
}

signed main() {
    freopen("input.txt", "r", stdin);
    vector <int> a = {3, 4};
    summ[a] = 3;
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
