#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

const int N = 500;
const ll inf = 1e18;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

ll gcd(ll a, ll b) {
    while (a > 0 && b > 0) {
        if (a > b)
            a %= b;
        else
            b %= a;
    }

    return a + b;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int> > g(n, vector <int>());

    vector <int> who(n, 0);
    int cnt = 1;

    vector <ll> ci(n);
    for (ll& x: ci)
        cin >> x;

    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].push_back(to);
    }

    for (int i = 0; i < n; i++) {

        vector <pair <int, int> > ves;
        vector <int> ve;

        for (int to: g[i])
            ves.push_back(make_pair(who[to], to));

        sort(ves.begin(), ves.end());

        for (auto e: ves)
            ve.push_back(e.first);

        ve.erase(unique(ve.begin(), ve.end()), ve.end());

        int ptr = 0;
        for (int i = 0; i < (int)ve.size(); i++) {
            while (ptr < (int)ves.size() && ves[ptr].first == ve[i]) {
                who[ves[ptr].second] = cnt + i;
                ptr++;
            }
        }

        for (int x: who)
            cout << x << ' ';
        cout << '\n';

        cnt += ve.size();
    }

    vector <ll> answ(cnt, 0);

    for (int i = 0; i < n; i++)
        answ[who[i]] += ci[i];

    ll ans = 0;
    for (int i = 1; i < cnt; i++)
        ans = gcd(ans, answ[i]);
    cout << ans << '\n';
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
