#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>

using namespace std;

typedef long long ll;

const int N = 500010;
const ll MOD = (int)1e9 + 7;

const int INF = (int)1e9 + 10;

vector < int > g[N];

ll c[N];

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

bool used[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		fill(used, used + N, false);
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i)
			g[i].clear();
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		for (int i = 0; i < m; ++i) {
			int v, to;
			cin >> v >> to;
			--v, --to;
			g[v].push_back(to);
		}
		ll alus = 0;
		ll nalus = 0;
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			ll x, y, z;
			x = y = z = 0;
			for (int to : g[i]) {
				if (used[to])
					z += c[to];
				else {
					x += c[to];
					used[to] = true;
					nalus += c[to];
				}
			}
			y = alus - z;
			ans = gcd(ans, x);
			ans = gcd(ans, y);
			ans = gcd(ans, z);
			alus += nalus;
			nalus = 0;
		}
		for (int i = 0; i < n; ++i) {
			fill(used, used + n, false);
			ll y = 0;
			for (int to : g[i]) {
				used[to] = true;
				y += c[to];
			}
			for (int j = i + 1; j < n; ++j) {
				ll x = 0, z = 0;
				for (int to : g[j]) {
					if (!used[to])
						x += c[to];
					else
						z += c[to];
				}
			}
		}
		cout << ans << '\n';
	}
}