//#define _GLIBCXX_DEBUG 1
#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<ll> c(n);
        for (auto &i : c) cin >> i;
        ll gc = 0;
        vector<ll> graph(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            graph[a] |= (1ll << b);
        }
        for (int i = 1; i < (1 << n); ++i) {
            ll get = 0;
            for (int j = 0; j < n; ++j) {
                if (!((1 << j) & i)) continue;
                get |= graph[j];
            }
            ll sum = 0;
            for (int j = 0; j < n; ++j) {
                if (!((1 << j) & get)) continue;
                sum += c[j];
            }
            gc = gcd(gc, sum);
        }
        cout << gc << '\n';
    }
}