#include <bits/stdc++.h>
#pragma GCC optimize("-Ofast,unroll-loops")
#pragma GCC target("tune=native")
using namespace std;
#define int long long
inline int gcd(int a, int b)
{
    if (a == 0 || b == 0)
        return a + b;
    return gcd(b, a & b);
}
void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int cut = a[0];
    for (int i = 1; i < n; i++)
        cut = gcd(cut, a[i]);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
    }
    random_shuffle(g.begin(), g.end());
    int buka = -1;
    vector<bool> used(n, false);
    for (int mask = 1; mask < (1 << n) && buka != cut; mask++)
    {
        for (int i = 0; i < n; i++)
            used[i] = false;
        for (int i = 0; i < n; i++)
        {
            if ((mask & (1 << i)) != 0)
            {
                for (int to : g[i])
                    used[to] = true;
            }
        }
        int ts = 0;
        for (int i = 0; i < n; i++)
            if (used[i])
                ts += a[i];
        if (buka < 0)
            buka = ts;
        else if (buka != ts)
            buka = gcd(buka, ts);
    }
    cout << buka << "\n";
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while (t-->0)
        solve();
    return 0;
}
