#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <string>
#include <set>

typedef long long ll;

using namespace std;

ll gcd(ll a, ll b){
    if(b == 0) return a;
    gcd(b, a%b);
}

int med(int a, int b, int c){
    if((a >= b && a <= c) || (a >= c && a <= b)){
        return a;
    }
    if((b >= a && b <= c) || (b >= c && b <= a)){
        return b;
    }
    return c;
}

int main() {
    int t;
    cin >> t;
    while(t--) {
        int n, m; cin >> n >> m;
        vector<vector<int>> g(n);
        vector<ll> c(n);
        for(int i = 0; i < n; i++){
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[a].push_back(b);
        }
        ll gc = 0;
        for(int i = 0; i < (1 << n); i++){
            vector<bool> used(n);
            ll sum = 0;
            for(int j = 0; j < n; j++){
                if(i & (1 << j)){
                    for(int to: g[j]){
                        if(!used[to]){
                            used[to] = true;
                            sum += c[to];
                        }
                    }
                }
            }
            gc = gcd(max(gc, sum), min(gc, sum));
        }
        cout << gc;
    }
    /*int n; cin >> n;
    //vector<vector<vector<int>>> am(2, vector<vector<int>>(2, vector<int>(2)));
    vector<ll> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
        vector<ll> cnt(1e7);
        ll ans = 0;
        for(int i = 0; i < n; i++){
            cnt[a[i]]++;
        }
        int cn = 0;
        for(int i = 1; i < 2e7 + 1; i++){
            if((cn/2)%2 == 0){
                ans ^= i;
            }
            if(i < 1e7 + 1 && (cnt[i])%2 == 1){
                cn++;
            }
        }
        cout << ans;*/
    return 0;
}