#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

int n, m;
vector<int> c;
vector<vector<int>> G;

ll gcd(ll a, ll b) {
    while (b != 0) {
        a %= b;
        swap(a, b);
    }
    return a + b;
}

void solve() {
    G.clear();
    c.clear();
    cin >> n >> m;
    G.resize(n);
    c.resize(n);
    rep(i, 0, n) cin >> c[i];
    rep(i, 0, m) {
        int v, u;
        cin >> v >> u;
        while (v > n) v--;
        while (u > n) u--;
        u--, v--;
        G[u].pb(v);
    }
    ll M = (1 << (n + 1));
    vector<ll> used(n, -1);
    ll ans = 0;
    rep(mask, 0, M) {
        rep(i, 0, n) if ((mask >> i) % 2) used[i] = mask;
        ll sum = 0;
        rep(i, 0, n) {
            bool ok = false;
            for (int v : G[i]) if (used[v] == mask) ok = true;
            if (ok) sum += c[i];
        }
        ans = gcd(ans, sum);
    }
    cout << ans << '\n';
}

signed main() {
    //ios::sync_with_stdio(false);
    //cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}
