#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <string>
#include <set>

typedef long long ll;

using namespace std;

ll gcd(ll a, ll b){
    if(b == 0) return a;
    gcd(b, a%b);
}

int med(int a, int b, int c){
    if((a >= b && a <= c) || (a >= c && a <= b)){
        return a;
    }
    if((b >= a && b <= c) || (b >= c && b <= a)){
        return b;
    }
    return c;
}

int main() {
    int t;
    cin >> t;
    vector<vector<int>> g;
    vector<ll> c;
    while(t--) {
        int n, m; cin >> n >> m;
        g.resize(n);
        c.resize(n);
        for(int i = 0; i < n; i++){
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[a].push_back(b);
        }
        ll gc = 0;
        vector<bool> used(n);
        for(int i = 0; i < (1 << n); i++){
            for(int j = 0; j < n; j++){
                used[j] = false;
            }
            ll sum = 0;
            for(int j = 0; j < n; j++){
                if(i & (1 << j)){
                    for(int to: g[j]){
                        if(!used[to]){
                            used[to] = true;
                            sum += c[to];
                        }
                    }
                }
            }
            gc = gcd(max(gc, sum), min(gc, sum));
        }
        cout << gc << endl;
    }
    return 0;
}