#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int gcd(int a, int b) {
	return b == 0 ? a : gcd(b, a % b);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> c(n);
	for (int& i : c) cin >> i;
	vector <int> w(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		w[u] |= (1ll << v);
	}
	vector <int> can(1ll << n);
	can[0] = 1;
	for (int u = 0; u < n; ++u) {
		for (int i = 0; i < (1ll << n); ++i) {
			can[i | w[u]] |= can[i];
		}
	}
	vector <int> s(1ll << n);
	for (int i = 0; i < (1ll << n); ++i) {
		for (int u = 0; u < n; ++u) {
			if ((i & (1ll << u)) != 0) {
				s[i] = s[i & ~(1ll << u)] + c[u];
			}
		}
	}
	int ans = s[0];
	for (int i = 0; i < (1ll << n); ++i) {
		if (can[i]) {
			ans = gcd(ans, s[i]);
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}