#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> c(n);
	cin >> c;

	vector <vector <int>> g(n); 
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].pb(u);
	}

	int gcd = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		int sum = 0;
		vector <bool> used(n);
		for (int i = 0; i < n; i++)
			if ((mask & (1 << i)))
				for (auto & j : g[i])
					if (!used[j])
						sum += c[j], used[j] = 1;
		gcd = __gcd(gcd, sum);
	}

	cout << gcd << endl;
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	int t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}