#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <functional>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = input();
    while (tt--) {
        int n = input();
        int m = input();
        vector<ll> c(n);
        for (ll &i : c) {
            i = input<ll>();
        }
        vector<vector<int>> g(n);
        for (int i = 0; i < m; ++i) {
            int u = input() - 1;
            int v = input() - 1;
            g[u].emplace_back(v);
        }
        ll res = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            ll cnt = 0;
            vector<int> used(n);
            for (int u = 0; u < n; ++u) {
                if (!((mask >> u) & 1)) {
                    continue;
                }
                for (int v : g[u]) {
                    if (used[v]) {
                        continue;
                    }
                    used[v] = true;
                    cnt += c[v];
                }
            }
            res = __gcd(res, cnt);
        }

        cout << res << endl;
    }
}
