#include<bits/stdc++.h>

using namespace std;

const int N 
= 21;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int c[N];
bitset<N> con[N];

void init() {
	for (int i = 0; i < N; i++) {
	 	for (int j = 0; j < N; j++) {
	 		con[i][j] = 0;
	 	}
	}
}

int solve(int n) {
	int ans = 0;
	vector<int> tk(n);
	for (int mask = 1; mask < (1 << n); mask++) {
		fill(tk.begin(), tk.end(), 0);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				tk[j] |= (con[i][j] && ((mask >> i) & 1));
			}
		}
		int g = 0;
		for (int i = 0; i < n; i++) {
			if (tk[i]) {
				g += c[i];
			}
		}	
		ans = gcd(ans, g);
	}
	return ans;
}

void kek() {
	init();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	while (m--) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		con[u][v] = 1;
	}
	cout << solve(n) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif

	int q;
	cin >> q;
	while (q--) {
		kek();	
	}
}                        