#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5e5 + 5;

vector < pair <vector <int>, ll > > e;

void source() {
    int n, m;
    cin >> n >> m;

    e.clear();
    e.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> e[i].second;
    }
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        e[u].first.push_back(v);
    }
    for (int i = 0; i < n; i++) {
        sort(e[i].first.begin(), e[i].first.end());
    }
    sort(e.begin(), e.end());
    ll res = 0, cres = 0;
    for (int i = 0; i < n; i++) {
        if (e[i].first.empty())
            continue;
        if (i && e[i].first != e[i - 1].first)
            res = __gcd(res, cres);
        cres += e[i].second;
    }
    res = __gcd(res, cres);
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int T;
    cin >> T;
    for (int i = 0; i < T; i++) {
        source();
    }
    return 0;
}
