#include <iostream>
#include <bits.h>
#include <assert.h>
#include <bitset>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define vbb vector<bool>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    for(int counter = 0; counter < t; counter++)
    {
        ll answ = 0;

        ll n, m;
        cin >> n >> m;
        vll c(n);
        for(int i = 0; i < n; i++)
            cin >> c[i];

        vector<ll> nodes(n);
        for(int i = 0; i < m; i++)
        {
            ll u, v;
            cin >> u >> v;
            u--;
            v--;
            nodes[u] |= (1 << v);
        }

        for(int mask = 0; mask < (1 << n); mask++)
        {
            ll rMask = 0;
            for(int i = 0; i < n; i++)
            {
                if((mask & (1 << i)) != 0)
                    rMask |= nodes[i];
            }

            ll sum = 0;
            for(int i = 0; i < n; i++)
            {
                if((rMask & (1 << i)) != 0)
                    sum += c[i];
            }

            answ = __gcd(answ, sum);
        }
        cout << answ << endl;
    }
    return 0;
}