
#include <iostream>
#include <algorithm>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>
#include <random>
#include <bits/stdc++.h>

#define int long long

using namespace std;

int gcd(int x, int y) {
    if (x == 0) return y;
    if (y == 0) return x;
    return gcd(y, x % y);
}

vector<vector<int>> g;
vector<int> a;
int ans;

vector<int> calc(int l, int r) {
    if (r - l <= 0) {
        return {};
    }
    if (r - l == 1) {
        vector<int> res;
        int s = 0;
        for (int to : g[l]) {
            res.push_back(to);
            s += a[to];
        }
        ans = gcd(ans, s);
        return res;
    }
    int m = (l + r) / 2;
    vector<int> x = calc(l, m), y = calc(m, r), res;
    unordered_set<int> f;
    int s = 0;
    for (int to : x) f.insert(to);
    for (int to : y) f.insert(to);
    for (int to : f) {
        res.push_back(to);
        s += a[to];
    }
    ans = gcd(s, ans);
    return res;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        a.clear();
        a.resize(n);
        g.clear();
        g.resize(n);
        ans = 0;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < m; i++) {
            int x, y;
            cin >> x >> y;
            g[x - 1].push_back(y - 1);
        }
        mt19937 rnd(11);


        for (int i = 0; i < 100; i++) {
            random_shuffle(g.begin(), g.end());
            if (n < 30) {
                for (int it = 0; it <= (1 << 9); it++) {
                    unordered_set<int> se;
                    for (int i = 0; i < n; i++) {
                        if (it & (1 << i)) {
                            for (int to : g[i]) {
                                se.insert(to);
                            }
                        }
                        int s = 0;
                        for (int to : se) {
                            s += a[to];
                        }
                        ans = gcd(ans, s);
                    }
                }
            }
            vector<int> u = calc(0, n);
            if (ans == 1) break;
        }
        /*for (int to : u) {
            cout << to + 1;
        }
        cout << endl;*/
        cout << ans << '\n';
        //cout << endl;
    }
    return 0;
}
