#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 500010;

vector<int> graph[2 * N];
int c[2 * N];
int col[2 * N];

long long gcd(long long x, long long y)
{
    if (x == 0) return y;
    if (y == 0) return x;
    return __gcd(x, y);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> c[i + n];
    }
    for (int i = 0; i < m; i++)
    {
        int v, u;
        cin >> v >> u;
        v--, u = u - 1 + n;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    long long g = 0;
    for (int v = n; v < 2 * n; v++)
    {
        vector<int> marked(2 * n);
        int s = 0;
        for (auto u : graph[v])
        {
            for (auto w : graph[u])
            {
                if (!marked[w]) marked[w] = 1, s += c[w];
            }
            g = gcd(s, g);
        }
    }
    cout << g << "\n";
    for (int i = 0; i < 2 * n; i++)
    {
        col[i] = 0;
        while (graph[i].size()) graph[i].pop_back();
    }
}


signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}

/*
3
1 93 45
*/
