#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()

ll gcd(ll a, ll b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);;
}

int n, m;
vector<ll> c;
vector<vector<int>> g1;
vector<vector<int>> g2;

void solve() {
    cin >> n >> m;
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    g1.assign(n, {});
    g2.assign(n, {});
    int u, y;
    for (int i = 0; i < m; i++) {
        cin >> u >> y;
        u--;
        y--;
        g1[u].push_back(y);
        g2[y].push_back(u);
    }

    vector<int> used(n);
    ll ans = 0;

    for (int i = 0; i < n; i++) {
        for (auto f : g1[i]) {
            used[f] = 1;
        }
        for (int j = i; j < n; j++) {
            ll sum = 0;
            for (auto f : g1[j]) {
                if (used[f] == 1) {
                    sum += c[f];
                }
            }
            ans = gcd(sum, ans);
        }
        for (auto f : g1[i]) {
            used[f] = 0;
        }
    }

    cout << ans << '\n';
    
    // int pw2 = pow(2, n);

    // vector<int> used(n);
    // ll ans = 0;
    // for (int msk = 1; msk < pw2; msk++) {
    //     for (int i = 0; i < n; i++) {
    //         if (msk & (1 << i)) {
    //             for (auto f : g1[i]) {
    //                 used[f] = 1;
    //             }
    //         }
    //     }
    //     ll sum = 0;
    //     for (int i = 0; i < n; i++) {
    //         if (used[i]) {
    //             used[i] = 0;
    //             sum += c[i];
    //         }
    //     }
    //     ans = gcd(sum, ans);
    // }
    // cout << ans << '\n';

}

signed main() {
    // ios::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

/*
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3
*/