#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MOD = 1e9 + 7;


long long evclide(long long a, long long b)
{
    if (a < b)
    {
        swap(a, b);
    }
    while (b != 0)
    {
        long long tmp = b;
        b = a % b;
        a = tmp;
    }
    return a;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector<long long> c(n);
        for (int i = 0; i < n; ++i)
        {
            cin >> c[i];
        }
        vector<vector<int> > graph(n);
        for (int i = 0; i < m; ++i)
        {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            graph[v].push_back(u);
        }
        long long ans = -1;
        vector<int> used2(n);
        for (int i = 0; i < n; ++i)
        {
            for (int h = i + 1; h < n; ++h)
            {
                int cnt = 0;
                for (int j = 0; j < graph[i].size(); ++j)
                {
                    if (!used2[graph[i][j]])
                    {
                        cnt += c[graph[i][j]];
                        used2[graph[i][j]] = 1;
                    }
                }
                for (int j = 0; j < graph[h].size(); ++j)
                {
                    if (!used2[graph[h][j]])
                    {
                        cnt += c[graph[h][j]];
                        used2[graph[h][j]] = 1;
                    }
                }
                for (int j = 0; j < graph[i].size(); ++j)
                {
                    used2[graph[i][j]] = 0;
                }
                for (int j = 0; j < graph[h].size(); ++j)
                {
                    used2[graph[h][j]] = 0;
                }
                if (ans == -1)
                {
                    ans = cnt;
                }
                else
                {
                    ans = evclide(ans, cnt);
                }
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
