#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

ll operator "" iq (ull x)
{
    return x + 35ll;
}
ll operator "" iq (ld x)
{
    return x + 35ll;
}

mt19937 mt(158956iq);

signed main()
{
    Start();
    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector <int> c(n);
        cin >> c;
        vector <vector <int>> g(n);
        for (int i = 0; i < m; ++i)
        {
            int u, v;
            cin >> u >> v, --u, --v;
            g[u].pb(v);
        }
        vector <int> p(n);
        iota(all(p), 0);
        int gd = 0;
        for (int i = 0; i < n; ++i)
        {
            int sum = 0;
            for (auto &to : g[i])
            {
                sum += c[to];
            }
            gd = gcd(sum, gd);
        }
        int IT = 4300;
        vector <int> used;
        for (int _ = 0; _ < IT; ++_)
        {
            used.assign(n, 0);
            shuffle(all(p), mt);
            int sum = 0;
            for (int v : p)
            {
                for (auto &to : g[v])
                    if (!used[to])
                        sum += c[to], used[to] = 1;
                gd = gcd(gd, sum);
            }
        }
        cout << gd << endl;
    }
    return 0;
}

