#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll nod(ll a, ll b) {
	if ( (a == 0) || ( b == 0 ) ) return a + b;
	if ( a > b ) swap(a, b);

	while ( (a != 0) && (b != 0) ) {
		b = b % a;
		swap(a, b);
	}

	return a + b;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> r(n);
	for ( int i = 0; i < n; ++i ) cin >> r[i];
	vector<vector<int>> g(n, vector<int>());
	int u, v; 
	for ( int i = 0; i < m; ++i ) {
		cin >> u >> v; u--; v--;
		g[u].push_back(v);
	}
	ll ans = 0;

	for ( int mask = 0; mask < (1<<n); ++mask ) {
		ll sm = 0;
		vector<bool> ch(n, false);
		for ( int i = 0; i < n; ++i ) if ( (mask & (1<<i)) != 0 ) ch[i] = true;

		set<int> neib = {};
		for ( int i = 0; i < n; ++i ) {
			if ( !ch[i] ) continue;
			for ( int v : g[i] ) neib.insert(v);
		}

		for ( int x : neib ) sm += r[x];
		if ( ans == 0 ) ans = sm;
		else ans = nod(ans, sm);
	}

	cout << ans << endl;
}

int main() {
	int t;
	cin >> t;

	for ( int i = 0; i < t; ++i ) {
		solve();
	}
	return 0;
}