#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;


int t;

ll gcd(ll a, ll b) {
	if (a == 0)
		return b;
	return  gcd(b % a, a);
}

ll solve() {
	int n, m;
	cin >> n >> m;
	vector <ll> c(n);
	for (int i = 0; i < n; i++)
		cin >> c[i];
	vector <vi> gr;
	gr.resize(n);
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		gr[x - 1].pb(y - 1);
	}
	ll res = 0;
	bool was[20];
	for (int mask = 0; mask < (1 << n); mask++) {
		fill(was, was + n, 0);
		ll sum = 0;
		for (int i = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				for (auto it : gr[i]) {
					if (was[it] == 0) {
						was[it] = 1;
						sum += c[it];
					}
				}
			}
		}
		res = gcd(res, sum);
	}
	return res;
}


int main() {
	fastIO();
	cin >> t;
	while (t--) {
		cout << solve() << '\n';
	}
	
	
	
	
	
	return 0;

}