#include <bits/stdc++.h>

const int32_t MAX_N = 5e5;

struct Vertex {
	int32_t vis;
	int64_t val;
	std::vector< int32_t > v;
};

Vertex g[MAX_N + 5];

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t t;
	std::cin >> t;

	for(int32_t cs = 1; cs <= t; cs++) {
		int32_t n, m;
		std::cin >> n >> m;

		for(int32_t i = 1; i <= n; i++) {
			std::cin >> g[i].val;
			g[i].v.clear();
		}

		for(int32_t i = 0; i < m; i++) {
			int32_t u, v;
			std::cin >> u >> v;

			g[u].v.push_back(v);
		}

		int64_t ans = -1;
		for(int32_t i = 1; i < (1 << n); i++) {
			int64_t sum = 0;
			for(int32_t j = 1; j <= n; j++) {
				if((i & (1 << (j - 1))) != 0) {
					for(auto &x : g[j].v) {
						if(g[x].vis != i) {
							g[x].vis = i;
							sum += g[x].val;
						}
					}
				}
			}
			if(ans == -1) {
				ans = sum;
				continue;
			}
			ans = std::__gcd(ans, sum);
		}

		std::cout << ans << '\n';
	}
}