#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define foru(i, n) for(int i = 0; i < n; ++i)
#define pb push_back
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(f, a.size()) cout << a[f] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x << '\n'
#define ff first
#define ss second
#define sz(a) (a).size()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef long double ld;

#define int ll

const int inf = 1e18;

int gcd(int a, int b){
    if(a == 0)
        return b;
    return gcd(b % a, a);
}

bool get_bit(int mask, int i){
    return mask & (1 << i);
}

vector <vector <int>> g;

void run() {
    g.clear();
    int n, m;
    cin >> n >> m;
    vector <int> c(n);
    cinm(c);
    g.resize(n);
    foru(i, m){
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].pb(b);
    }
    int ans = -1;
    for(int mask = 1; mask < (1 << n + 1); ++mask){
        int tsum = 0;
        set <int> vs;
        foru(i, n){
            if(get_bit(mask, i)){
                for(auto j : g[i]){
                    if(vs.count(j) == 0) {
                        tsum += c[j];
                        vs.insert(j);
                    }
                }
            }
        }
        if(ans == -1)
            ans = tsum;
        else
            ans = gcd(ans, tsum);
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    int t;
    cin >> t;
    foru(i, t)
        run();
    return 0;
}
