#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

long long NOD(long long a, long long b)
{
    while (b != 0)
    {
        long long x = a;
        a = b;
        b = x;
        b = b % a;
    }
    return(a);
}

int main()
{
    long long t; cin >> t;
    for (long long q = 0; q < t; q++)
    {
        long long n, m; cin >> n >> m;
        vector<vector<long long>>g(n);
        vector<long long> a(n);
        for (long long i = 0; i < n; i++)cin >> a[i];
        for (long long i = 0; i < m; i++)
        {
            long long x, y; cin >> x >> y; x--; y--;
            g[x].push_back(y);
        }
        long long nok = -1;
        for (long long i = 0; i < n; i++)
        {

            set<long long> used;
            long long summ = 0;
            for (long long j = i; j < n; j++)
            {
                for (auto x : g[j])
                {
                    if (used.count(x) == 0)
                    {
                        used.insert(x);
                        summ += a[x];
                    }
                }
                if (summ == 0) continue;
                if (nok == -1) nok = summ;
                else nok = NOD(nok, summ);
            }
        }
        cout << nok << endl;
    }

}