#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<string>

using namespace std;

long long gcd(long long a, long long b) {
	if (a < b) {
		swap(a, b);
	}
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

int main() {
	int t;
	cin >> t;
	for (int j = 0; j < t; j++) {
		int n, m;
		cin >> n >> m;
		vector<int> used(n, 0);
		vector<long long> su(n, 0);
		vector<long long> sz(n, 0);
		vector<pair<int, int>> l;
		vector<vector<int>> g(n);
		for (int i = 0; i < n; i++) {
			cin >> sz[i];
		}
		for (int i = 0; i < m; i++) {
			int x, y;
			cin >> x >> y;
			l.push_back({ x - 1,y - 1 });
			used[y - 1]++;
			su[x - 1] += sz[y - 1];
			g[x - 1].push_back(y - 1);
		}
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				ans += sz[i];
			}
		}
		for (auto i : su) {
			ans = gcd(ans, i);
		}
		for (auto i : l) {
			if (used[i.second] == 1) {
				su[i.first] += sz[i.second];
			}
		}
		for (auto i : su) {
			ans = gcd(ans, i);
		}
		for (int r = 0; r < n; r++) {
			vector<bool> used1(n, false);
			long long s1 = 0;
			for (auto i : g[r]) {
				used1[i] = true;
				s1 += sz[i];
			}
			for (int i = 0; i < n; i++) {
				long long s2 = 0;
				for (auto x : g[i]) {
					if (!used1[x]) {
						s2 += sz[x];
					}
				}
				ans = gcd(ans, s1 + s2);
			}
		}
		cout << ans << "\n";
	}
}