#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;

#define int ll

int gcd(int a, int b) {
	while (a) {
		b %= a;
		swap(a, b);
	}
	return b;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> c(n);
	vector<vector<int>> g(n);
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
	}
	for (int i = 0; i < n; i++) {
		sort(g[i].begin(), g[i].end());
		g[i].resize(unique(g[i].begin(), g[i].end()) - g[i].begin());
	}
	int gg = 0;
	vector<int> used(n);
	for (int i = 0; i < n; i++) {
		int sm1= 0;
		int sm2 = 0;
		for (int j : g[i]) {
			sm1 += c[j];
			if (used[j]) {
				sm2 += c[j];
			}
			used[j] = 1;
		}
		gg = gcd(gg, gcd(sm1, sm2));
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int sm = 0;
			for (int k : g[i]) {
				if (!used[k]) {
					sm += c[k];
					used[k] = 1;
				}
			}
			for (int k : g[j]) {
				if (!used[k]) {
					sm += c[k];
					used[k] = 1;
				}
			}
			gg = gcd(gg, sm);
			for (int k : g[i]) {
				used[k] = 0;
			}
			for (int k : g[j]) {
				used[k] = 0;
			}
		}
	}

	cout << gg << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
