#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int gcd(int a, int b) {
	if (min(a, b) == 0) return (max(a, b));
	if (a % b == 0) return b;
	return gcd(b, a % b);
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector <vector <int>> g(n);
		vector <int> a(n);
		for (int i = 0; i < n; i++)
			cin >> a[i];
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			g[u].push_back(v);
		}
		int x = 0;
		for (int mask = 1; mask < (1 << n); mask++) {
			vector <bool> tf(n);
			int copy_mask = mask;
			for (int i = 0; i < n; i++) {
				tf[i] = copy_mask % 2;
				copy_mask /= 2;
			}
			vector <bool> used(n);
			for (int i = 0; i < n; i++)
				if (tf[i])
					for (int v : g[i])
						used[v] = true;
			int sum = 0;
			for (int i = 0; i < n; i++)
				sum += (a[i] * used[i]);
			x = gcd(x, sum);
		}
		cout << x << endl;
	}
	return 0;
}

/*
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

*/