// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back


void solve() {
	int n, m;
	long long result = 0;
	cin >> n >> m;
	vector<long long> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<vector<int>> g(n);
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x; --y;
		g[x].pb(y);
	}
	for (int mask = 1; mask < (1 << n); ++mask) {
		bitset<20> bits = mask;
		unordered_set<int> N_s;
		for (int j = 0; j < 20; ++j) {
			if (bits[j]) {
				for (auto s : g[j]) N_s.emplace(s);
			}
		}
		long long sum = 0;
		for (auto now : N_s) sum += a[now];
		result = __gcd(result, sum);
	}
	cout << result << '\n';
}

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
		srand(time(0));
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int T;
	cin >> T;
	while (T --> 0) {
		solve();
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}