#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

const int INF = 1e9 + 1;

long long gcd(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    while (b != 0) {
        long long c = a % b;
        a = b;
        b = c;
    }
    return a;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <vector<int>> a(n, vector<int>(n));
        vector <long long> c(n);
        for (auto &l : c) {
            cin >> l;
        }
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            a[u][v] = 1;
        }
        vector <int> with(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (a[i][j] == 1) {
                    with[i] |= (1 << j);
                }
            }
        }
        vector <long long> pr((1 << n) + 1);
        for (int mask = 0; mask <= (1 << n); mask++) {
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    pr[mask] += c[i];
                }
            }
        }
        long long ans = 0;
        for (int mask = 1; mask < (1 << n); mask++) {
            int now_mask = 0;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    now_mask |= with[i];
                }
            }
            ans = gcd(ans, pr[now_mask]);
        }
        cout << ans << "\n";
    }
    return 0;
}
