#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define fs first
#define sc second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.end()
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()

int gcd(int a, int b) {
    return a? gcd(b % a, a) :b;
}

const int N = 5e5 + 100;
vector<int> g[N], cost(N);
int n, m;
int stupid() {
    int ans = 0;
    for (int mask = 1; mask < (1<<n); mask++) {
        int sum = 0;
        vector<int> used(n);
        for (int i = 0; i < n; i++) {
            if ((1<<i) & mask) {
                for (auto u:g[i])
                if (!used[u]) {
                    used[u] =1 ;
                    sum += cost[u];
                }
            }
        }
        ans = gcd(ans, sum);
    }
    //cout << ans << '\n';
    return ans;
}

mt19937 rng(5435);



int smart() {
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            int uk1 = 0, uk2 = 0;
            int sum = 0;
            while (uk1 < sz(g[i]) && uk2 < sz(g[j])) {
                if (g[i][uk1] < g[j][uk2]) {
                    sum += cost[g[i][uk1]];
                    uk1++;
                } else if (g[i][uk1] > g[j][uk2]) {
                    sum += cost[g[j][uk2]];
                    uk2++;
                } else {
                    sum += cost[g[i][uk1]];
                    uk1++;
                    uk2++;
                }
            }
            while(uk1 < sz(g[i]))
                sum += cost[g[i][uk1]], uk1++;
            while(uk2 < sz(g[j]))
                sum += cost[g[j][uk2]], uk2++;
            ans = gcd(ans, sum);
            //cout << i << " " << j << " " << sum << endl;
        }
    }
    cout << ans << '\n';
    return ans;
}
signed main() {
    fastio;
    #ifdef FlameDragon
        freopen("in.txt", "r", stdin);
    #endif // FlameDragon

    int q;
    cin >> q;
    while (q--) {
        cin >> n >> m;
        for (int i = 0; i < n; i++)
            cin >> cost[i];
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[a].pb(b);
        }

        for (int i = 0; i < n; i++)
            sort(all(g[i]));

        int x = smart();
        int y = stupid();
        assert(x >= y);
        for (int i = 0; i < n; i++)
            g[i].clear();
    }

}


