#include<bits/stdc++.h>
using namespace std;

long long c[20];
bool have[20][20];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> c[i];
    memset(have, false, sizeof(have));
    while (m--) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        have[v][u] = true;
    }
    vector<int> masks;
    for (int i = 0; i < n; i++) {
        int mask = 0;
        for (int j = 0; j < n; j++) {
            if (have[j][i]) mask += 1 << j;
        }
        masks.push_back(mask);
    }
    vector<int> who(n);
    for (int i = 0; i < n; i++) who[i] = masks[i];
    for (int t = 0; t < n; t++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (j != i && (masks[i] & who[j]) == who[j]) who[i] = who[j];
            }
        }
    }
    map<int, long long> sum;
    for (int i = 0; i < n; i++) sum[who[i]] += c[i];
    long long ans = 0;
    for (auto elem : sum) ans = __gcd(ans, elem.second);
    cout << ans << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
