#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/rope>

// #define Deb

#define int ll
#define f first
#define s second
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define sort stable_sort
#define push push_back
#define pop pop_back
#define out cout << fixed << setprecision(15)

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4")


using namespace std;
using namespace __gnu_cxx;

typedef long long ll;

const ll P = 8923, M = 1234567891, MAXN = 2001, N = 1e6;

mt19937 rnd(111341553);

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector <ll> c(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> c[i];
	}
	ll ans = 0;
	if (n > 20) {
		vector <vector <int>> g(n + 1);
		for (int i = 0; i < m; ++i) {
			int a, b;
			cin >> a >> b;
			g[a].push(b);
		}
		for (int i = 0; i < 30000; ++i) {
			ll tmp = 0;
			vector <int> used(n + 1);
			for (int j = 1; j <= n; ++j) {
				if (rnd() % 2) {
					for (int k: g[j]) {
						if (!used[k]) {
							tmp += c[k];
							used[k] = 1;
						}
					}
				}
			}
			ans = __gcd(ans, tmp);
		}
	} else {
		vector <int> g(n + 1);
		for (int i = 0; i < m; ++i) {
			int a, b;
			cin >> a >> b;
			g[a] |= 1 << b;
		}
		for (int i = 1; i < (1 << n); ++i) {
			ll tmp = 0;
			int mask = i;
			int used = 1;
			for (int j = 1; j <= n; ++j) {
				if (mask % 2) {
					used |= g[j];
				}
				mask /= 2;
			}
			for (int j = 0; j <= n; ++j) {
				if (used % 2) {
					tmp += c[j];
				}
				used /= 2;
			}
			ans = __gcd(ans, tmp);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	#ifdef Deb
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	#endif
	int t;
	cin >> t;
	for (;t--;) {
		solve();
	}
	return 0;
}