#include <bits/stdc++.h>

using namespace std;

long long gcd(long long a, long long b)
{
    if (b == 0ll)
    {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_)
    {
        int n, m;
        cin >> n >> m;
        vector<long long> a(n);
        vector<vector<int>> g(n);
        for (int i = 0; i < n; ++i)
        {
            cin >> a[i];
        }
        for (int i = 0; i < m; ++i)
        {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g[v].push_back(u);
        }
        for (int i = 0; i < n; ++i)
        {
            sort(g[i].begin(), g[i].end());
        }
        vector<pair<vector<int>, long long>> mp;
        for (int i = 0; i < n; ++i)
        {
            if (!g[i].empty())
            {
                mp.push_back({g[i], a[i]});
            }
        }
        sort(mp.begin(), mp.end());
        long long ans = 0;
        long long cur = 0;
        vector<int> pr = {};
        for (auto el : mp)
        {
            if (el.first == pr)
            {
                cur += el.second;
            }
            else
            {
                ans = gcd(ans, cur);
                cur = el.second;
                pr = el.first;
            }
        }
        ans = gcd(ans, cur);
        cout << ans << "\n";
    }
    return 0;
}
