#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<vector<int>> l, r;
vector<long long> c, usr;

struct dsu {
    int n;
    vector<int> p, sz, sum;

    dsu(int n) : n(n) {
        p.resize(n);
        for (int i = 0; i < n; ++i)
            p[i] = i;
        sz.resize(n);
        for (int i = 0; i < n; ++i)
            sz[i] = 1;
        sum.resize(n);
        for (int i = 0; i < n; ++i) {
            sum[i] = c[i];
        }
    }

    int leader(int v) {
        if (p[v] == v)
            return v;
        return p[v] = leader(p[v]);
    }

    void un(int v, int u) {
        v = leader(v);
        u = leader(u);
        if (v == u)
            return;
        if (sz[v] < sz[u])
            swap(u, v);
        p[u] = v;
        sz[v] += sz[u];
        sum[v] += sum[u];
    }

};

const int x = 29;
const int mod = 1791791791;

int bpw(int x, int a) {
    if (a == 0)
        return 1;
    int res = bpw(x, a / 2);
    res = (res * res) % mod;
    if (a % 2)
        res = (res * x) % mod;
    return res;
}

void add(pair<int, int> &hs, int v) {
    v += 1;
    hs.first = (hs.first + bpw(x, v)) % mod;
    hs.second = (hs.second + bpw(v, x)) % mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;
        c.resize(n);
        l.resize(n);
        r.resize(n);
        usr.resize(n);
        for (auto &now : l)
            now.clear();
        for (auto &now : r)
            now.clear();
        for (int i = 0; i < n; ++i)
            cin >> c[i];

        vector<pair<int, int>> hashs(n);

        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            l[u].push_back(v);
            r[v].push_back(u);

            add(hashs[v], u);

        }

        map<pair<int, int>, int> tr;

        dsu ch(n);

        for (int i = 0; i < n; ++i) {
            if (hashs[i].first != 0 || hashs[i].second != 0) {
                if (tr.find(hashs[i]) != tr.end()) {
                    ch.un(tr[hashs[i]], i);
                }
                tr[hashs[i]] = i;
            }
        }

        long long gg = 0;

        for (int i = 0; i < n; ++i) {
            int now = ch.sum[ch.leader(i)];
            if (gg == 0)
                gg = now;
            if (now) {
                gg = __gcd(gg, now);
            }
        }

        cout << gg << '\n';
    }

    return 0;
}

