#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

#define endl '\n'
#define ll long long

using namespace std;

ll gcd(ll a, ll b) {
	if (min(a, b) == 0) return (max(a, b));
	if (a % b == 0) return b;
	return gcd(b, a % b);
}

int main() {
	ll t;
	cin >> t;
	ios::sync_with_stdio(false);
	cin.tie(0);
	vector <ll> ans;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector <pair <ll, ll>> e(m);
		vector <ll> a(n);
		for (ll i = 0; i < n; i++)
			cin >> a[i];
		for (ll i = 0; i < m; i++) 
			cin >> e[i].first >> e[i].second;
		ll x = 0;
		for (ll cnt = 0; cnt < 100000; cnt++) {
			vector <vector <ll>> g(n);
			for (ll i = 0; i < e.size(); i++)
				g[e[i].first - 1].push_back(e[i].second - 1);
			vector <bool> tf(n);
			for (ll i = 0; i < n; i++)
				tf[i] = rand() % 2;
			vector <bool> used(n);
			for (ll i = 0; i < n; i++)
				if (tf[i])
					for (ll v : g[i])
						used[v] = true;
			ll sum = 0;
			for (ll i = 0; i < n; i++)
				sum += (a[i] * used[i]);
			x = gcd(x, sum);
			e.resize(0);
			for (ll i = 0; i < n; i++)
				for (ll v : g[i])
					if (a[v] % x)
						e.push_back({ i + 1, v + 1 });
		}
		ans.push_back(x);
	}
	for (ll x : ans)
		cout << x << endl;
	return 0;
}