#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

    int tt = input();
    while (tt--) {
        int n = input();
        int m = input();
        vector<ll> c(n);
        for (ll &i : c) {
            i = input<ll>();
        }
        vector<ull> hsh(n), who(n);
        generate(all(hsh), rnd);

        vector<vector<int>> g(n);
        for (int i = 0; i < m; ++i) {
            int u = input() - 1;
            int v = input() - 1;
            g[u].emplace_back(v);
            who[v] += hsh[u];
        }
        unordered_map<ull, ll> cnt;
        for (int v = 0; v < n; ++v) {
            if (who[v]) {
                cnt[who[v]] += c[v];
            }
        }
        ll res = 0;
        for (auto[key, val] : cnt) {
            res = __gcd(res, val);
        }
        cout << res << endl;
    }
}
