#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll

int gcd(int a, int b) {
  while (b) {
     a %= b;
     swap(a, b);
  }
  return a;
}

const int N = 5e5 + 10;
vector<int> g[N], in[N], ng[N];
int c[N], used[N], xx[20], timer;
map<ll, int> lst;
ll p_pow[N];
mt19937 rnd(time(0)); 

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  p_pow[0] = 1;
  for (int i = 1; i <= 5000; i++) {
    p_pow[i] = p_pow[i - 1] * 239017ll; 
  }
  int T;
  cin >> T;
  while (T--) {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
      cin >> c[i];
      g[i] = {};
      in[i] = {};
    }
    for (int i = 1; i <= m; i++) {
      int u, v;
      cin >> u >> v;
      g[u].pb(v);
      in[v].pb(u);
    }
    int cur_gcd = 0;
    for (int i = 1; i <= n; i++) {
      int sum = 0;
      for (auto it : g[i]) {
        sum += c[it];
      } 
      cur_gcd = gcd(cur_gcd, sum);
    }
    for (int i = 1; i <= n; i++) {
      for (int j = i + 1; j <= n; j++) {
        timer++;
        int sum = 0;
        for (auto it : g[i]) {
          if (used[it] < timer) {
            sum += c[it];
            used[it] = timer;
          }
        }
        for (auto it : g[j]) {
          if (used[it] < timer) {
            sum += c[it];
            used[it] = timer;
          }
        }
        cur_gcd = gcd(cur_gcd, sum);
      }
    }
    for (int iter = 0; iter < 50; iter++) {
      int was = cur_gcd;
      vector<int> interesting;
      timer++;
      for (int i = 1; i <= n; i++) {
        ng[i] = {};
        ll chash = 0;
        for (auto it : g[i]) {
          if (c[it] % cur_gcd != 0) {
            ng[i].pb(it);
            chash += p_pow[it] * it;
          }
        }
        if (!ng[i].empty() && lst[chash] < timer) {
          interesting.pb(i);
          lst[chash] = timer;
        }
      }
      if (interesting.empty()) {
        break;
      }
      if (SZ(interesting) <= 200) {
        for (int i : interesting) {
          for (int j : interesting) {
            for (int k : interesting) {
              timer++;
              int sum = 0;
              for (auto it : g[i]) {
                if (used[it] < timer) {
                  sum += c[it];
                  used[it] = timer;
                }
              }
              for (auto it : g[j]) {
                if (used[it] < timer) {
                  sum += c[it];
                  used[it] = timer;
                }
              }
              for (auto it : g[k]) {
                if (used[it] < timer) {
                  sum += c[it];
                  used[it] = timer;
                }
              }
              cur_gcd = gcd(cur_gcd, sum);
            }
          }
        }
      }
      for (int iter2 = 0; iter2 < 50; iter2++) {
        shuffle(all(interesting), rnd);
        timer++;
        int sum = 0;
        for (auto it : interesting) {
          for (auto it2 : g[it]) {
            if (used[it2] < timer) {
              used[it2] = timer;
              sum += c[it2];
            }
          }
          cur_gcd = gcd(cur_gcd, sum);
        }
      }
      if (was == cur_gcd) {
        break;
      }
    }
    cout << cur_gcd << '\n';
  }
}