#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
#define endl '\n'
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ldb;
typedef double db;

const int MOD = (int)1e9 + 123;
const int BASE = 511111;

int mult(int a, int b) {
    return ((ll)a * b) % MOD;
}

int sum(int a, int b) {
    return (a + b) % MOD;
}

int get_hash(const vector<int> &st) {
    int val = 0;
    for (auto &i : st) {
        val = mult(val, BASE);
        val = sum(val, i);
    }
    return val;
}

ll a[500000];
vector<int> g[500000];
map<int, ll> d;

signed main() {
    fastream;
    int t;
    cin >> t;
    for (int it = 0; it < t; it++) {
        d.clear();
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            g[i].clear();
        }
        int u, v;
        for (int i = 0; i < m; i++) {
            cin >> u >> v;
            u--, v--;
            g[v].push_back(u);
        }
        for (int i = 0; i < n; i++) {
            sort(all(g[v]));

        }
        for (int i = 0; i < n; i++) {
            if (g[i].empty()) {
                continue;
            }
            d[get_hash(g[i])] += a[i];
        }
        ll res = 0;
        for (auto &i : d) {
            res = gcd(res, i.second);
        }
        cout << res << endl;
    }
}