#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 21;
const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    init();

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<bitset<maxn>> g(n);
        vector<ll> a(n);
        for (auto &ev: a)
            cin >> ev;

        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u][v] = 1;
        }
        ll ans = -1;
        for (int mask = 1; mask < (1 << n); mask++){
            vector<int> cur;
            for (int i = 0; i< n; i++){
                if ((mask & (1 << i)) > 0)
                    cur.pb(i);
            }
            bitset<maxn> used;
            ll sum = 0;
            for (auto ev: cur)
                used |= g[ev];
            for (int i = 0; i < maxn; i++)
                if (used[i])
                    sum += a[i];
            if (ans == -1){
                ans = sum;
                continue;
            }
            ans = gcd(ans, sum);
            if (ans == 1)
                break;
        }
        cout << ans << endl;
    }
    return 0;
}