#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <bitset>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    for (ll q = 0; q < t; q++) {
        ll n, m;
        cin >> n >> m;
        vector<ll> c(n);
        for (ll i = 0; i < n; i++) {
            cin >> c[i];
        }
        vector<vector<ll>> adj(n);
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            adj[u].push_back(v);
        }
        ll o = 0;
        vector<ll> v(n);
        function<void(ll, ll)> f = [&](ll i, ll s) {
            if (i == n) {
                o = __gcd(o, s);
                return;
            }
            f(i + 1, s);
            for (ll j : adj[i]) {
                if (v[j] == 0) {
                    s += c[j];
                }
                v[j]++;
            }
            f(i + 1, s);
            for (ll j : adj[i]) {
                v[j]--;
                if (v[j] == 0) {
                    s -= c[j];
                }
            }
        };
        f(0, 0);
        cout << o << "\n";
    }
    return 0;
}
