#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 5 * 1e5 + 42;
set < int > g[MAX_N];
vector < int > gr_right[MAX_N];
set < int > gr_left[MAX_N];

void Get(int x) {
    for (auto v : gr_left[x]) {
        for (auto u : gr_right[v]) {
            g[x].insert(u);
        }
    }
}

long long c[MAX_N];
int col[MAX_N];
long long cnt[MAX_N];

int main() {
    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < n; i++) {
            g[i].clear();
            gr_right[i].clear();
            gr_left[i].clear();
            col[i] = 0;
            cnt[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            int v, u;
            cin >> u >> v;
            v--;
            u--;
            gr_right[u].push_back(v);
            gr_left[v].insert(u);
        }
        for (int i = 0; i < n; i++) {
            if (col[i] == 0) {
                col[i] = i + 1;
                cnt[i + 1] += c[i];
            }
            for (int j = i + 1; j < n; j++) {
                if (gr_left[i].size() != gr_left[j].size()) {
                    continue;
                }
                bool f = 0;
                for (auto x : gr_left[i]) {
                    if (gr_left[j].find(x) == gr_left[j].end()) {
                        f = 1;
                        break;
                    }
                }
                if (f == 0) {
                    col[j] = col[i];
                    cnt[col[j]] += c[j];
                }
            }
        }
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            ans = __gcd(ans, cnt[col[i]]);
        }
        cout << ans << endl;
    }
    return 0;
}
