#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long


int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> f(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        f[a] += c[b];
        g[a].insert(b);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = gcd(ans, f[i]);
    }
    vector<int> used(n);
    int tim = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int x = 0; x < n && ans > 1; ++x) {
                ++tim;
                int cur = 0;
                for (auto v : g[i]) {
                    if (used[v] != tim) {
                        cur += c[v];
                        used[v] = tim;
                    }
                }
                for (auto v : g[j]) {
                    if (used[v] != tim) {
                        cur += c[v];
                        used[v] = tim;
                    }
                }
                for (auto v : g[x]) {
                    if (tim != used[v]) {
                        cur += c[v];
                        used[v] = tim;
                    }
                }
                if (ans != gcd(ans, cur)) {
                    ans = gcd(ans, cur);
                    for (int l = 0;  l < n; ++l) {
                        vector<int> kil;
                        for (auto zz : g[l]) {
                            if (c[zz] % ans == 0) {
                                kil.push_back(zz);
                            }
                        }
                        for (auto zz : kil) {
                            g[l].erase(zz);
                        }
                    }
                }
            }
        }
    }
    cout << ans << endl;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}