#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e18;

int q;
int n, m;
int a[N];
vector<int> g[N];
int ans = 0;

void clear()
{
    for (int i = 0; i < 2 * n; ++i)
        g[i].clear();
}

int __gcd(int a, int b)
{
    if (a < b)
        swap(a, b);

    if (b == 0)
        return a;

    return __gcd(b, a % b);
}

void rec(int sum, int cur, vector<bool> &used)
{
    if (cur == n)
    {
        ans = __gcd(ans, sum);
        return;
    }

    rec(sum, cur + 1, used);

    vector<int> nottouse;

    for (auto u : g[cur])
        if(!used[u - n])
        {
            used[u - n] = true;
            sum += a[u - n];
            nottouse.push_back(u - n);
        }

    rec(sum, cur + 1, used);

    for (auto u : nottouse)
        used[u] = false;
}

void solve()
{
    ans = 0;

    vector<bool> used(n * 2, false);

    rec(0, 0, used);

    cout << ans << endl;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> q;

    while (q--)
    {
        cin >> n >> m;

        for (int i = 0; i < n; ++i)
            cin >> a[i];

        for (int i = 0; i < m; ++i)
        {
            int v, u;

            cin >> v >> u;

            --v;
            --u;

            g[v].push_back(u + n);
        }

        solve();
        clear();
    }
}