#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}
#define int ll
const int MAXN = 5e5 + 10;

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int n, m;
vector<int> g[MAXN];
ll c[MAXN];


int par[MAXN];
int sum[MAXN];

void make() {
	for (int i = 0; i < n; i++) {
		par[i] = i, sum[i] = c[i];
	}
}

int get_par(int v) {
	if (v == par[v]) return v;
	return par[v] = get_par(par[v]);
}

void uni(int a, int b) {
	a = get_par(a);
	b = get_par(b);
	if (a == b) return;
	par[b] = a;
	sum[a] += sum[b];
}

mt19937 rnd(time(0));

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < n; i++)
		cin >> c[i];
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);		
	}
	make();
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		int have = 0;
		if (g[i].empty()) continue;
		have += c[g[i][0]];
		for (int j = 1; j < g[i].size(); j++) {
			uni(g[i][j - 1], g[i][j]);
			have += c[g[i][j]];
		}
		ans = gcd(ans, have);
	}
	for (int i = 0; i < n; i++) {
		vector<bool> used(n, false);
		int have = 0;
		for (auto j : g[i]) {
			have += c[j];
			used[j] = true;
		}
		for (int j = i + 1; j < n; j++) {
			int fans = have;
			for (auto i : g[j]) {
				if (!used[i]) {
					fans += c[i];
				}
			}
			ans = gcd(ans, fans);
		}
	}

	for (int it = 0; it < 1000000; it++) {
		vector<bool> used(n, false);
		vector<bool> used2(n, false);
		int have = 0;
		for (int i = 0; i < n; i++) {
			int v = rnd() % n;
			while (used2[v]) {
				v = rnd() % n;
			}
			used2[v] = true;
			for (auto j : g[v]) {
				if (!used[j]) have += c[j];
				used[j] = true;
			}
			ans = gcd(ans, have);
		}
	}
	for (int i = 0; i < n; i++) {
		ans = gcd(ans, sum[get_par(i)]);
		sum[get_par(i)] = 0;
	}	
	cout << ans << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}