#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

long long c[5003];
int cnt[5003];
bool used[5003];
vector <set <int> > G, G2;

long long gcd(long long a, long long b) {
	if (a < b)
		swap(a, b);
	while (b != 0) {
		long long a1, b1;
		a1 = b;
		b1 = a % b;
		a = a1;
		b = b1;
		if (a < b)
			swap(a, b);
	}
	return a;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		long long g = 0;
		int n, m;
		cin >> n >> m;
		G.clear();
		G.resize(n);
		G2.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u; --v;
			++cnt[v];
			G[v].insert(u);
			G2[u].insert(v);
		}
		for (int i = 0; i < n; ++i)
			if (G[i].size() > 0)
				g += c[i];
		long long sum = g;
		for (int i = 0; i < n; ++i)
			used[i] = true;
		for (int v = 0; v < n; ++v) {
			if (cnt[v] > 0) {
				cnt[v] = 0;
				sum -= c[v];
				for (auto it = G[v].begin(); it != G[v].end(); ++it) {
					int u = *(it);
					G2[u].erase(v);
					vector <int> del;
					for (auto it2 = G2[u].begin(); it2 != G2[u].end(); ++it2) {
						int w = *(it2);
						cnt[w]--;
						if (cnt[w] == 0) {
							sum -= c[w];
							del.push_back(w);
						}
					}
					for (int i = 0; i < del.size(); ++i)
						G2[u].erase(del[i]);
				}
			}
			g = gcd(g, sum);
		}
		cout << g << '\n';
	}
	return 0;
}
