#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 5 * 1e5 + 42;
set < int > g[MAX_N];
vector < int > gr_right[MAX_N];
vector < int > gr_left[MAX_N];

void Get(int x) {
    for (auto v : gr_left[x]) {
        for (auto u : gr_right[v]) {
            g[x].insert(u);
        }
    }
}

long long c[MAX_N];
int col[MAX_N];
long long cnt[MAX_N];
bool used[MAX_N];

int main() {
    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < n; i++) {
            g[i].clear();
            gr_right[i].clear();
            gr_left[i].clear();
            col[i] = 0;
            cnt[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            int v, u;
            cin >> u >> v;
            v--;
            u--;
            gr_right[u].push_back(v);
            gr_left[v].push_back(u);
        }
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            long long now = 0;
            for (auto x : gr_right[i]) {
                now += c[x];
                used[x] = 1;
            }
            ans = __gcd(ans, now);
            for (int j = i + 1; j < n; j++) {
                long long sum = 0;
                for (auto x : gr_right[j]) {
                    if (used[x]) {
                        continue;
                    }
                    sum += c[x];
                }
                ans = __gcd(ans, sum);
            }
        }
        cout << ans << endl;
    }
    return 0;
}
