#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>
using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

bool multitest = 1;

ll GCD(ll a, ll b){
    while (a > 0 && b > 0){
        if (a > b) a %= b; else b %= a;
    }
    return a + b;
}

void solve(){
    int n, m;
    cin >> n >> m;
    vll a(n);
    forn(i, n) cin >> a[i];
    vvi g(n);
    forn(i, m){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u);
    }
    ll ans = 0;
    forn(i, n){
        for (int j = i + 1; j < n; ++j){
            set<int> set1;
            ll sum = 0;
            for (int v : g[i]) set1.insert(v);
            for (int v : g[j]) set1.insert(v);
            for (int v : set1) sum += a[v];
            ans = GCD(ans, sum);
        }
    }
    cout << ans << '\n';
}

int main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}