#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

mt19937 rng(time(0));
const int maxN = 500005;
vector<int> G[maxN];
ll C[maxN];
bool used[maxN];

ll gcd(ll a, ll b) {
  while (b) {
    a %= b;
    swap(a, b);
  }
  return a;
}

void solve() {
  int n, m;
  cin >> n >> m;
  for (int v = 1; v <= n; ++v) {
    cin >> C[v];
    G[v].clear();
  }
  while (m--) {
    int x, y;
    cin >> x >> y;
    G[x].push_back(y);
  }
  ll g = 0;
  for (int x0 = 0; x0 <= n; ++x0) {
    fill(used, used + n + 1, false);
    ll sum = 0;
    for (int x = 1; x <= n; ++x) if (x != x0) {
      for (int y : G[x]) {
        if (!used[y]) {
          used[y] = true;
          sum += C[y];
        }
      }
    }
    g = gcd(g, sum);
  }
  for (int x = 1; x <= n; ++x) {
    ll sum = 0;
    for (int y : G[x]) {
      sum += C[y];
    }
    g = gcd(g, sum);
  }
  cout << g << '\n';
}

signed main() {
#ifdef DEBUG
  freopen("in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int tests;
  cin >> tests;
  while (tests--) {
    solve();
  }

  return 0;
}
