#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
#include<map>
#include<cmath>
#include<time.h>
#include<deque>

using namespace std;
typedef long long ll;
int n, m;
vector<ll>c;
vector<vector<int>>ad;
vector<int>used;
ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll allg = 0;
void rec(int k, ll sum) {
	if (k == n) {
		allg = gcd(allg, sum);
		return;
	}
	rec(k + 1, sum);
	auto was = used;
	for (auto v : ad[k]) {
		if (!used[v]) {
			used[v] = 1;
			sum += c[v];
		}
	}
	rec(k + 1, sum);
	used = was;
}
void solve() {
	int t; cin >> t;
	for (int t1 = 0; t1 < t; t1++) {
		cin >> n >> m;
		c.resize(n);
		used.resize(n, 0);
		for (int i = 0; i < n; i++) {
			cin >> c[i];
		}
		ad.resize(n);
		for (int i = 0; i < m; i++) {
			int u, v; cin >> u >> v; u--; v--;
			ad[u].push_back(v);
		}
		rec(0, 0);
		cout << allg << '\n';
		allg = 0;
		ad.clear(); used.clear();
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	solve();
}