#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define int long long
using namespace std;

bitset<5047> used1, used2;

int dfs(int u, int m, vector<vector<int>> &g1, vector<vector<int>> &g2, vector<int> &c, vector<int> &mx) {
    int res = 0;
    if (m == 2) {
        used2[u] = 1;
        res += c[u];
        for (auto v : g2[u]) {
            if (!used1[v]) {
                res += dfs(v, 1, g1, g2, c, mx);
            }
        }
    } else {
        used1[u] = 1;
        res += mx[u];
        for (auto v : g1[u]) {
            if (!used2[v]) {
                res += dfs(v, 2, g1, g2, c, mx);
            }
        }
    }
    return res;
}

void PUNKS_NOT_DEAD() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> c(n);
        vector<int> mx(n);
        vector<vector<int>> g1(n, vector<int>());
        vector<vector<int>> g2 = g1;
        for (int i = 0; i < n; i++) cin >> c[i];
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v, u--, v--;
            g1[u].push_back(v);
            g2[v].push_back(u);
            mx[u] += c[v];
        }
        int ans2 = 0;
        for (int i = 0; i < n; i++) {
            ans2 = __gcd(ans2, mx[i]);
            used1.reset();
            used2.reset();
            ans2 = __gcd(ans2, dfs(i, 2, g1, g2, c, mx));
        }
        cout << ans2 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    PUNKS_NOT_DEAD();
}