#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second 
#define pb emplace_back
#pragma GCC optimize("Ofast", "unroll-loops")

using namespace std;

const int INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, ve<ll> &a) {
	for (auto &i : a) in >> i;
	return in;
}

inline ll gcd(ll a, ll b) {
	while (b) a = a % b, swap(a, b);
	return a;
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vvi g(n);
		ve<ll> cost(n);
		cin >> cost;
		int u, v;
		for (int i = 0; i < m; ++i) {
			cin >> u >> v;
			g[u - 1].pb(v - 1);
		}
		ll curgcd = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ve<bool> taken(n);
			ll sum = 0;
			for (int u = 0; u < n; ++u) {
				if ((mask | (1 << u)) == mask) {
					for (auto v : g[u]) {
						if (!taken[v]) taken[v] = true, sum += cost[v];
					}
				}
			}
			curgcd = gcd(curgcd, sum);
		}
		cout << curgcd << endl;
	}
	return 0;
}