#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<string>

using namespace std;

long long gcd(long long a, long long b) {
	if (a < b) {
		swap(a, b);
	}
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

int main() {
	int t;
	cin >> t;
	for (int j = 0; j < t; j++) {
		int n, m;
		cin >> n >> m;
		vector<long long> g(n);
		vector < long long> ms(n);
		for (int i = 0; i < n; i++) {
			cin >> ms[i];
		}
		for (int i = 0; i < m; i++) {
			int x, y;
			cin >> x >> y;
			g[x - 1] = (g[x - 1] | (1 << (y - 1)));
		}
		long long ans = 0;
		for (int i = 0; i < (1 << n); i++) {
			long long used = 0;
			for (int k = 0; k < n; k++) {
				if (i & (1 << k)) {
					used = (used | g[k]);
				}
			}
			long long t1 = 0;
			for (int k = 0; k < n; k++) {
				if (used & (1 << k)) {
					t1 += ms[k];
				}
			}
			ans = gcd(ans, t1);
		}
		cout << ans << "\n";
	}
}