#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

const int MAXN = 2000;
int a[MAXN][MAXN];
long long ans = 0;

void check(const int &i_s, const int &j_s, const int &k) {
	vector<unordered_set<int>> stl(k);
	unordered_set<int> all;
	for (int i = i_s; i < i_s + k; ++i) {
		unordered_set<int> str;
		for (int j = j_s; j < j_s + k; ++j) {
			if (str.find(a[i][j]) != str.end()) {
				// cout << "str " << i << ' ' << j << '\n';
				return;
			}
			if (stl[j - j_s].find(a[i][j]) != stl[j - j_s].end()) {
				// cout << "stl\n";
				return;
			}
			all.insert(a[i][j]);
			if ((int)all.size() > k) return;
			str.insert(a[i][j]);
			stl[j - j_s].insert(a[i][j]);
		}
		str.clear();
	}
	if ((int)all.size() == k) ++ans;
}

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
		srand(time(0));
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x;
			cin >> x;
			a[i][j] = (int)x * 1000;
			cin >> x;
			a[i][j] += (int)x;
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cout << a[i][j] << ' ';
	// 	}
	// 	cout << '\n';
	// }
	ans = n * m;
	for (int k = 2; k <= min(n, m); ++k) {
		for (int i = 0; i <= n - k; ++i) {
			for (int j = 0; j <= m - k; ++j) {
				check(i, j, k);
			}
		}
	}
	cout << ans;
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}