// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

const int MAXN = 2000;
int a[MAXN][MAXN];
unordered_map<int, int> q[100][100];
long long ans = 0;

void check(const int &i_s, const int &j_s, const int &k) {
	vector<unordered_set<int>> stl(k);
	unordered_set<int> all;
	for (int i = i_s; i < i_s + k; ++i) {
		unordered_set<int> str;
		for (int j = j_s; j < j_s + k; ++j) {
			if (str.find(a[i][j]) != str.end()) {
				// cout << "str " << i << ' ' << j << '\n';
				return;
			}
			if (stl[j - j_s].find(a[i][j]) != stl[j - j_s].end()) {
				// cout << "stl\n";
				return;
			}
			all.insert(a[i][j]);
			if ((int)all.size() > k) return;
			str.insert(a[i][j]);
			stl[j - j_s].insert(a[i][j]);
		}
		str.clear();
	}
	if ((int)all.size() == k) ++ans;
}

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
		srand(time(0));
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n, m;
	cin >> n >> m;
	ans = n * m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x;
			cin >> x;
			a[i][j] = (int)x * 1000;
			cin >> x;
			a[i][j] += (int)x;
		}
	}
	if (n <= 20 && m <= 20) {
		for (int k = 2; k <= min(n, m); ++k) {
			for (int i = 0; i <= n - k; ++i) {
				for (int j = 0; j <= m - k; ++j) {
					check(i, j, k);
				}
			}
		}
		cout << ans;
	} else {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				for (int c1 = 33; c1 <= 126; ++c1) {
					for (int c2 = 33; c2 <= 126; ++c2) {
						if (i) {
							q[i][j][c1 * 1000 + c2] += q[i - 1][j][c1 * 1000 + c2];
						}
						if (j) {
							q[i][j][c1 * 1000 + c2] += q[i][j - 1][c1 * 1000 + c2];
						}
						if (i && j) {
							q[i][j][c1 * 1000 + c2] -= q[i - 1][j - 1][c1 * 1000 + c2];
						}
					}
				}
			}
		}
		for (int k = 2; k <= min(n, m); ++k) {
			for (int i = 0; i <= n - k; ++i) {
				for (int j = 0; j <= m - k; ++j) {
					int diff = 0;
					bool flag = true;
					for (int c1 = 33; flag && c1 <= 126; ++c1) {
						for (int c2 = 33; c2 <= 126; ++c2) {
							int t = q[i + k - 1][j + k - 1][c1 * 1000 + c2];
							if (i == 0 || j == 0 || t > q[i - 1][j - 1][c1 * 1000 + c2]) ++diff;
							if (diff > k) {
								flag = false;
								break;
							}
						}
					}
					if (diff == k) ++ans;
				}
			}
		}
		cout << ans << '\n';
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}