
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
#define N 2000
int a[N][N];
int n, m;

inline bool Check(int y, int x, int d)
{
    //for (int i = y; i < y + d; ++i)
    //    for (int j = x; j < x + d; ++j)
    //        s.insert(a[i][j]);
    set<int> s;
    for (int i = y; i < y + d; ++i)
    {
        set<int> st;
        for (int j = x; j < x + d; ++j)
            st.insert(a[i][j]), s.insert(a[i][j]);
        if (st.size() != d) return false;
    }

    if (s.size() != d) return false;

    for (int j = x; j < x + d; ++j)
    {
        set<int> st;
        for (int i = y; i < y + d; ++i)
            st.insert(a[i][j]);
        if (st.size() != d) return false;
    }

    return true;
}

int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            char c1, c2;
            cin >> c1 >> c2;
            a[i][j] = (int)c1 * 1000 + (int)c2;
        }
    int g = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            for (int k = 0; i + k < n && j + k < m; ++k)
            {
                if (Check(i, j, k + 1)) ++g;
            }

    cout << g;
    return 0;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

5 10
!"#$%&’()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_‘abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&

*/