#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG
// #define int long long

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;
typedef pair <char, char> pt;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 5e5;

int get(pt a) {
	return (a.fi - 32) * 127 + (a.se - 32);
}

bool is_ok(int n, int m, vector <vector <pt>>& a, int x, int y, int xx, int yy) {
	unordered_set <int> s;
	int len = xx - x + 1;
	for (int i = x; i <= xx; ++i) {
		s.clear();
		for (int j = y; j <= yy; ++j) {
			s.insert(get(a[i][j]));
		}
		if ((int)s.size() != len) {
			return 0;
		}
	}
	for (int j = y; j <= yy; ++j) {
		s.clear();
		for (int i = x; i <= xx; ++i) {
			s.insert(get(a[i][j]));
		}
		if ((int)s.size() != len) {
			return 0;
		}
	}
	s.clear();
	for (int i = x; i <= xx; ++i) {
		for (int j = y; j <= yy; ++j) {
			s.insert(get(a[i][j]));
		}
	}
	if ((int)s.size() != len) {
		return 0;
	}
	return 1;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <pt>> a(n, vector <pt> (m));
	for (auto& v : a) {
		for (auto& i : v) {
			cin >> i.fi >> i.se;
		}
	}
	int ans = 0;
	for (int len = 1; len <= min(n, m); ++len) {
		for (int i = 0; i <= n - len; ++i) {
			for (int j = 0; j <= m - len; ++j) {
				int i2 = i + len - 1;
				int j2 = j + len - 1;
				ans += is_ok(n, m, a, i, j, i2, j2);
				// if (is_ok(n, m, a, i, j, i2, j2)) {
				// 	// cout << i << " " << j << "\n";
				// 	// cout << i2 << " " << j2 << "\n\n";
				// 	// cout << len << "\n";
				// }
			}
		}
	}
	cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		// cin >> t;
		t = 2;
	#else
		// cin >> t;
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}