#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            char c, d;
            cin >> c >> d;
            a[i][j] = (c<<7)+d;
            //cout << i << ':' << j << ' ' << a[i][j] << endl;
        }
    }
    vector<vector<vector<set<int> > > > v(n, vector<vector<set<int> > >(m, vector<set<int> >(m))),
                                        g(m, vector<vector<set<int> > >(n, vector<set<int> >(n)));
    for(int i = 0; i<n; i++)
        for(int j = 0; j<m; j++)
            for(int y = j; y<m; y++)
                for(int z = j; z<=y; z++)
                    v[i][j][y].insert(a[i][z]);
    for(int i = 0; i<m; i++)
        for(int j = 0; j<n; j++)
            for(int y = j; y<n; y++)
                for(int z = j; z<=y; z++)
                    g[i][j][y].insert(a[z][i]);
    int ans = 0;
    for(int x = 0; x<n; x++){
        for(int y = 0; y<m; y++){
            for(int ln = 0; ln<=min(x, y); ln++){
                bool kek = true;
                for(int i = x; i>=x-ln; i--){
                    if(v[i][y-ln][y].size()!=ln+1){
                        kek = false;
                        break;
                    }
                }

                for(int i = y; i>=y-ln; i--){
                    if(g[i][x-ln][x].size()!=ln+1){
                        kek = false;
                        break;
                    }
                }
                set<int> jm;
                for(int i = x-ln; i<=x; i++)
                    for(int j = y-ln; j<=y; j++)
                        jm.insert(a[i][j]);
                if(jm.size()!=ln+1)
                    kek = false;
                ans += kek;
            }
        }
    }
    cout << ans;

    return 0;
}
