#include <bits/stdc++.h>

using namespace std;
const int MAXN = 510;

int n, m;
pair < char, char > c[MAXN][MAXN];

void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            cin >> c[i][j].first >> c[i][j].second;
}

bool latin(int x, int y, int k)
{
    set < pair < char, char > > s;
    for (int i = x; i < x + k; i ++)
        for (int j = y; j < y + k; j ++)
        s.insert(c[i][j]);

    if (s.size() != k)
        return false;

    for (int i = x; i < x + k; i ++)
    {
        set < pair < char, char > > is;
        for (int j = y; j < y + k; j ++)
        {
            if (is.find(c[i][j]) != is.end())
                return false;
            is.insert(c[i][j]);
        }
    }

    for (int j = y; j < y + k; j ++)
    {
        set < pair < char, char > > is;
        for (int i = x; i < x + k; i ++)
        {
            if (is.find(c[i][j]) != is.end())
                return false;
            is.insert(c[i][j]);
        }
    }

    return true;
}
int test(int k)
{
    int cnt = 0;
    for (int i = 1; i <= n - k + 1; i ++)
        for (int j = 1; j <= m - k + 1; j ++)
        {
            if (latin(i, j, k))
                cnt ++;
        }
    return cnt;
}

void solve()
{
    int ans = 0;
    for (int k = 1; k <= min(n, m); k ++)
        ans += test(k);
    cout << ans << endl;
}
int main()
{
    read();
    solve();
    return 0;
}
/**
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
