#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e3) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, m;
char fld[2][MAX][MAX];

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> fld[0][i][j] >> fld[1][i][j];
        }
    }

    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool kill = true;
            for (int k = 1; kill && i + k - 1 < n && j + k - 1 < m; ++k) {
                // (i, j) (i + k - 1) (j + k - 1)
                bool flag = true;
                set<pair<char, char>> diff;
                for (int ii = i; flag && ii <= i + k - 1; ++ii) {
                    for (int jj = j; flag && jj <= j + k - 1; ++jj) {
                        diff.insert({fld[0][ii][jj], fld[1][ii][jj]});

                        if (len(diff) > k) {
                            flag = false;
                        }
                    }
                }

                if (flag) {
                    for (int ii = i; flag && ii <= i + k - 1; ++ii) {
                        set<pair<char, char>> dif;
                        for (int jj = j; flag && jj <= j + k - 1; ++jj) {
                            if (dif.count({fld[0][ii][jj], fld[1][ii][jj]})) {
                                flag = false;
                            }
                            dif.insert({fld[0][ii][jj], fld[1][ii][jj]});
                        }
                    }

                    if (!flag) {
                        kill = false;
                        continue;
                    }

                    for (int ii = j; flag && ii <= j + k - 1; ++ii) {
                        set<pair<char, char>> dif;
                        for (int jj = i; flag && jj <= i + k - 1; ++jj) {
                            if (dif.count({fld[0][jj][ii], fld[1][jj][ii]})) {
                                flag = false;
                            }

                            dif.insert({fld[0][jj][ii], fld[1][jj][ii]});
                        }
                    }

                    if (flag) {
                        ++ans;
                    }
                    else {
                        kill = false;
                    }
                }
            }
        }
    }


    cout << ans << '\n';
}
