#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

int n, m;

bool check(vector<vector<int>>& s, int i, int j, int k) {
	set<int> a, c;
	for (int i1 = i; i1 <= i + k; ++i1) {
		for (int j1 = j; j1 <= j + k; ++j1) {
			a.emplace(s[i1][j1]);
			c.emplace(s[i1][j1]);
		}
		if (a.size() != k + 1)
			return false;
		a.clear();
	}
	if (c.size() != k + 1)
		return false;
	for (int j1 = j; j1 <= j + k; ++j1)  {
		for (int i1 = i; i1 <= i + k; ++i1) 
			a.emplace(s[i1][j1]);
		
		if (a.size() != k + 1)
			return false;
		a.clear();
	}
	return true;
}

void solve() {
	cin >> n >> m;
	vector<vector<int>> s(n, vector<int>(m));
	char ch;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> ch;
			s[i][j] = ch * 126;
			cin >> ch;
			s[i][j] += ch;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int k = 0; k < min(n - i, m - j); ++k) {
				if (check(s, i, j, k))
					++ans;
			}
		}
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
	return 0;
}