#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

vector<vector<pair<char, char>>> arr(100, vector<pair<char, char>>(100));

bool check1(int i, int l, int r) {
    set<pair<char, char>> kek;
    for (int j = l; j <= r; j++) {
        kek.insert(arr[i][j]);
    }
    return kek.size() == (r - l + 1);
}

bool check2(int j, int l, int r) {
    set<pair<char, char>> kek;
    for (int i = l; i <= r; i++) {
        kek.insert(arr[i][j]);
    }
    return kek.size() == (r - l + 1);
}

bool check3(int x1, int y1, int x2, int y2) {
    int k = x2 - x1 + 1;
    set<pair<char, char>> kek;
    for (int j = y1; j <= y2; j++) {
        if (!check2(j, x1, x2)) {
            return false;
        }
    }
    for (int i = x1; i <= x2; i++) {
        if (!check1(i, y1, y2)) {
            return false;
        }
        for (int j = y1; j <= y2; j++) {
            kek.insert(arr[i][j]);
        }
        if (kek.size() > k) {
            return false;
        }
    }
    return kek.size() == k;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<string> kek(n);
    for (auto &x : kek) {
        cin >> x;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            arr[i][j] = {kek[i][j * 2], kek[i][j * 2 + 1]};
        }
    }
    int res = 0;
    for (int x1 = 0; x1 < n; x1++) {
        for (int y1 = 0; y1 < m; y1++) {
            for (int x2 = x1; x2 < n; x2++) {
                int y2 = y1 + (x2 - x1);
                if (y2 < m) {
                    if (check3(x1, y1, x2, y2)) {
                        res++;
                    }
                }
            }
        }
    }
    cout << res << endl;
}