#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>
#include <queue>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;
const int MOD = 1e9 + 7;

using namespace std;
int n, m;
bool check(int x, int y, vector<vector<pair<char, char>>> &a, int d) {
    if (x + d - 1 >= n || y + d - 1 >= m) return false;
    set<pair<char, char>> used;
    set<pair<char, char>> q;
    for (int i = x; i < x + d; i++) {
        used.clear();
        for (int j = y; j < y + d; j++) {
            if (used.count(a[i][j])) return false;
            used.insert(a[i][j]);
            q.insert(a[i][j]);
        }
    }
    if (q.size() != d) return false;
    for (int j = y; j < y + d; j++) {
        used.clear();
        for (int i = x; i < x + d; i++) {
            if (used.count(a[i][j])) return false;
            used.insert(a[i][j]);
        }
    }

    return true;
}
    
void solve() {
    cin >> n >> m;
    vector<vector<pair<char, char>>> a(n, vector<pair<char, char>>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0, c = 0; j < m * 2; j += 2, c++) {
            a[i][c] = { s[j], s[j + 1] };
        }
    }

    int ans = 0;
    for (int x1 = 0; x1 < n; x1++) {
        for (int y1 = 0; y1 < m; y1++) {
            vector < set<pair<int, int>>> col(m), row(n);
            set<pair<int, int>> help;
            bool good = true;
            for (int d = 1; x1 + d <= n && y1 + d <= m && good; d++) {
                for (int i = x1; i < x1 + d; i++) {
                    if (col[y1 + d - 1].count(a[i][y1 + d - 1])) good = false;
                    col[y1 + d - 1].insert(a[i][y1 + d - 1]);
                    if (row[i].count(a[i][y1 + d - 1])) good = false;
                    row[i].insert(a[i][y1 + d - 1]);
                    help.insert(a[i][y1 + d - 1]);
                }
                for (int j = y1;j < y1 + d - 1; j++) {
                    if (row[x1 + d - 1].count(a[x1 + d - 1][j])) good = false;
                    row[x1 + d - 1].insert(a[x1 + d - 1][j]);
                    if (col[j].count(a[x1 + d - 1][j])) good = false;
                    col[j].insert(a[x1 + d - 1][j]);
                    help.insert(a[x1 + d - 1][j]);
                }
                if (help.size() == d && good) ans++;
            }
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/