#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using namespace std;
using namespace __gnu_pbds;

const int N = 2001, M = 96;
char s[N];
int a[N][N], c[2][N][M], p[2][N][M], used[M];

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n, m, p1, p2, pos, t1, t2, t3, d1, d2, d3, cc, dd, ans = 0;
	cin >> n >> m;
	rep(i, n) {
		cin >> s;
		rep(j, m)
			a[i][j] = s[j] - 33;
	}
	rep(i, n) {
		p1 = i & 1;
		p2 = p1	^ 1;
		rep(j, m) {
			c[p1][j][0] = a[i][j];
			p[p1][j][0] = 1;
			if (i == 0 || j == 0) {
				p[p1][j][1] = N;
				ans++;
				continue;
			}
			memset(used, 0, M * sizeof(int));
			used[a[i][j]] = 1;
			t1 = t2 = t3 = 0;
			pos = 1;
			while (1) {
				d1 = p[p1][j - 1][t1];
				d2 = p[p2][j - 1][t2];
				d3 = p[p2][j][t3];
				//cout << i << ' ' << j << ' ' << d1 << ' ' << d2 << ' ' << d3 << '\n';
				if (d1 <= d2 && d1 <= d3) {
					cc = c[p1][j - 1][t1++];
					dd = d1;
				}
				else if (d2 <= d1 && d2 <= d3) {
					cc = c[p2][j - 1][t2++];
					dd = d2;
				}
				else {
					cc = c[p2][j][t3++];
					dd = d3;
				}
				if (dd == N) {
					p[p1][j][pos] = N;
					break;
				}
				if (!used[cc]) {
					//cout << dd << ' ' << cc << "?\n";
					used[cc] = 1;
					c[p1][j][pos] = 1;
					p[p1][j][pos] = dd + 1;
					pos++;
				}
			}
			pos = 0;
			while (pos <= i && pos <= j && p[p1][j][pos] < N) {
				if (p[p1][j][pos] <= pos + 1 && p[p1][j][pos + 1] > pos + 1) {
					ans++;
				}
				pos++;
			}
		}
	}
	cout << ans;
}

