#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

vector<vector<int>> table;
vector<int> used((126 - 33 + 2) * (126 - 33) + (126 - 33) + 5, -1);
int cnt = 0;

int check(int x1, int y1, int x2, int y2) {
    if (x2 < 0 || y2 < 0) return false;
    rep(i, x2, x1 + 1) {
        cnt++;
        rep(j, y2, y1 + 1) {
            if (used[table[i][j]] == cnt) return 0;
            used[table[i][j]] = cnt;
        }
    }
    rep(j, y2, y1 + 1) {
        cnt++;
        rep(i, x2, x1 + 1) {
            if (used[table[i][j]] == cnt) return 0; 
            used[table[i][j]] = cnt;
        }
    }
    vector<int> cur;
    rep(i, x2, x1 + 1) rep(j, y2, y1 + 1) cur.pb(table[i][j]);
    sort(all(cur));
    cur.resize(unique(all(cur)) - cur.begin());
    if (cur.size() == x1 - x2 + 1) return 1;
    else return 0;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    table.resize(n, vector<int>(m));
    rep(i, 0, n) rep(j, 0, m) {
        char a, b;
        cin >> a >> b;
        a -= 33, b -= 33;
        table[i][j] = a * (126 - 33 + 2) + b;
    }
    int ans = 0;
    rep(i, 0, n) rep(j, 0, m) rep(del, 0, min(i, j) + 1) ans += check(i, j, i - del, j - del);
    cout << ans << '\n';
}