#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ull mod = 1e9 + 7, base = 150;

const ull MAX_N = 2e3 + 10;
ull encode(char a, char b) {
    return (ull)(a - '!') * 130 + (ull)(b - '!');
}

const ull MAX_CODE = 130 * 130;

ull n, m;
ull tab[MAX_N][MAX_N];
ull pw[MAX_CODE];

struct Data {
    ull val[MAX_CODE], cnt;
    ull h;
    void add(ull ind, ull x) {
        if(val[ind] == 0) {cnt ++;}
        if(x == 1) {h += pw[ind];} else {h -= pw[ind];}
        val[ind] += x;
        if(val[ind] == 0) {cnt --;}
    }
};

Data window;
bool ok1[MAX_N][MAX_N];
bool ok2[MAX_N][MAX_N];
ull h1[MAX_N][MAX_N];
ull h2[MAX_N][MAX_N];

ll ans = 0;

void prull(ull k) {
    cout << k << endl;
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < m; j ++) {
            cout << h1[i][j] << " ";
        }
        cout << endl;
    }
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < m; j ++) {
            cout << ok1[i][j] << " ";
        }
        cout << endl;
    }
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < m; j ++) {
            cout << h2[i][j] << " ";
        }
        cout << endl;
    }
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < m; j ++) {
            cout << ok2[i][j] << " ";
        }
        cout << endl;
    }
}

void prec(ull k) {
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < n; j ++) {
            ok1[i][j] = ok2[i][j] = h1[i][j] = h2[i][j] = false;
        }
    }
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < k; j ++) {window.add(tab[i][j], 1);}
        if(window.cnt == k) {ok1[i][0] = true;}
        h1[i][0] = window.h;
        for(ull j = k; j < m; j ++) {
            window.add(tab[i][j], 1);
            window.add(tab[i][j - k], -1);
            if(window.cnt == k) {ok1[i][j - k + 1] = true; h1[i][j - k + 1] = window.h;}
        }
        for(ull j = m - k; j < m; j ++) {window.add(tab[i][j], -1);}
    }
    for(ull j = 0; j < m; j ++) {
        for(ull i = 0; i < k; i ++) {window.add(tab[i][j], 1);}
        if(window.cnt == k) {ok2[0][j] = true;}
        h2[0][j] = window.h;
        for(ull i = k; i < n; i ++) {
            window.add(tab[i][j], 1);
            window.add(tab[i - k][j], -1);
            if(window.cnt == k) {ok2[i - k + 1][j] = true; h2[i - k + 1][j] = window.h;}
        }
        for(ull i = n - k; i < n; i ++) {window.add(tab[i][j], -1);}
    }

    ll ret = (n - k + 1) * (m - k + 1);
    for(ull i = 0; i < n - k + 1; i ++) {
        for(ull j = 0; j < m - k + 1; j ++) {
            ull curr1 = h1[i][j], curr2 = h2[i][j];
            if(!ok1[i][j] || !ok2[i][j]) {ret --; continue;}
            for(ull q = 1; q < k; q ++) {
                if(!ok1[i + q][j] || !ok2[i][j + q] || h1[i + q][j] != curr1 || h2[i][j + q] != curr2) {ret --; break;}
            }
        }
    }
    ans += ret;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    pw[0] = 1; for(ull i = 1; i < MAX_CODE; i ++) {pw[i] = pw[i - 1] * base;}
    cin >> n >> m;
    for(ull i = 0; i < n; i ++) {
        for(ull j = 0; j < m; j ++) {
            char a, b;
            cin >> a >> b;
            tab[i][j] = encode(a, b);
        }
    }
    for(ull k = 1; k <= min(n, m); k ++) {
        //cout << k << endl;
        prec(k);
    }
    cout << ans << endl;
    return 0;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
