#include<iostream>
#include<vector>
#include<algorithm>
#include<time.h>
#include<random>
#include<string>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 5e5;
const ll MOD = 1e9 + 7;
const ll base = 239;

int n, m;
vector<vector<pair<char, char>>> g;

int solve(int x0, int y0, int l) {
    set<pair<char, char>> stall;
    for (int x = x0; x < x0 + l; ++x) {
        for (int y = y0; y < y0 + l; ++y) {
            stall.insert(g[x][y]);
        }
    }
    if (sz(stall) != l) {
        return 0;
    }
    for (int x = x0; x < x0 + l; ++x) {
        set<pair<char, char>> st;
        for (int y = y0; y < y0 + l; ++y) {
            st.insert(g[x][y]);
        }
        if (sz(st) != l) {
            return 0;
        }
    }
    for (int y = y0; y < y0 + l; ++y) {
        set<pair<char, char>> st;
        for (int x = x0; x < x0 + l; ++x) {
            st.insert(g[x][y]);
        }
        if (sz(st) != l) {
            return 0;
        }
    }

    return 1;
}

int main() {
    cin >> n >> m;
    g.resize(n, vector<pair<char, char>> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c1, c2;
            cin >> c1 >> c2;
            g[i][j] = {c1, c2};
        }
    }
    int ans = 0;
    for (int l = 1; l < min(n, m); ++l) {
        for (int x = 0; (x + l - 1) < n; ++x) {
            for (int y = 0; (y + l - 1) < m; ++y) {
                ans += solve(x, y, l);
            }
        }
    }
   
    cout << ans;
    //system("pause");
    return 0;
}