#include <bits/stdc++.h>
#define int long long
#define double long double
#pragma GCC optimize("O3,Ofast,no-stack-protector,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,sse2,sse3,ssse3")
using namespace std;

int join(char a, char b) {
    return ((a - 32) << 7) + (b - 32);
}

int n, m;
vector<vector<int>> matrix;
vector<vector<int>> rows;
vector<vector<int>> cols;
vector<bool> has(20000);

void again() {
    for (int i = 0; i < has.size(); i++) {
        has[i] = false;
    }
}

int ans() {
    rows.resize(n);
    for (int i = 0; i < n; i++) {
        rows[i].resize(m);
        int r = 0;
        again();
        for (int j = 0; j < m; j++) {
            while (r < m && !has[matrix[i][r]]) {
                has[matrix[i][r]] = true;
                r++;
            }
            rows[i][j] = r - 1;
            has[matrix[i][j]] = false;
        }
    }
    cols.resize(m);
    for (int j = 0; j < m; j++) {
        cols[j].resize(n);
        int r = 0;
        again();
        for (int i = 0; i < n; i++) {
            while (r < n && !has[matrix[r][j]]) {
                has[matrix[r][j]] = true;
                r++;
            }
            cols[j][i] = r - 1;
            has[matrix[i][j]] = false;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            again();
            int x = 0;
            for (int k = 1;; k++) {
                if (i + k > n || j + k > m || rows[i][j] < j + k - 1 || cols[j][i] < i + k - 1) {
                    break;
                }
                for (int c = j; c < j + k; c++) {
                    if (!has[matrix[i + k - 1][c]]) {
                        x++;
                    }
                    has[matrix[i + k - 1][c]] = true;
                }
                for (int c = i; c < i + k; c++) {
                    if (!has[matrix[c][j + k - 1]]) {
                        x++;
                    }
                    has[matrix[c][j + k - 1]] = true;
                }
                if (x == k) {
                    ans++;
                }
            }
        }
    }
    return ans;
}

int brute() {
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 1;; k++) {
                if (i + k > n || j + k > m) {
                    break;
                }
                set<int> st;
                for (int c = i; c < i + k; c++) {
                    for (int d = j; d < j + k; d++) {
                        st.insert(matrix[c][d]);
                    }
                }
                bool flag = true;
                for (int c = i; c < i + k; c++) {
                    set<int> blah;
                    for (int d = j; d < j + k; d++) {
                        blah.insert(matrix[c][d]);
                    }
                    if (blah.size() != k) flag = false;
                }
                for (int d = j; d < j + k; d++) {
                    set<int> blah;
                    for (int c = i; c < i + k; c++) {
                        blah.insert(matrix[c][d]);
                    }
                    if (blah.size() != k) flag = false;
                }
                if (st.size() == k && flag) {
                    ans++;
                }
            }
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    matrix.resize(n);
    for (int i = 0; i < n; i++) {
        matrix[i].resize(m);
        for (int j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            matrix[i][j] = join(a, b);
        }
    }
    // cout << ans() << '\n';
    cout << brute() << '\n';
    fflush(stdout);
    return 0;
}
