#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N = 2002;
const int M = 9000;

int dec(char x, char y) {
    int i = x - 33, j = y - 33;
    assert(0 <= min(i, j) && max(i, j) < 94);
    int t = 94 * i + j;
    assert(0 <= t && t < M);
    return t;
}

char s[2 * N];
int n, m, a[N][N], r[N][N], c[N][N], pos[M], tmr = 1;
ll answer = 0;

main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (int j = 0; j < m; ++j) {
            a[i][j] = dec(s[j + j], s[j + j + 1]);
        }
    }
    /*
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    */
    for (int i = 0; i < n; ++i) {
        fill_n(pos, M, N);
        for (int j = m - 1; j >= 0; --j) {
            r[i][j] = pos[a[i][j]];
            pos[a[i][j]] = j;
        }
    }
    for (int j = 0; j < m; ++j) {
        fill_n(pos, M, N);
        for (int i = n - 1; i >= 0; --i) {
            c[i][j] = pos[a[i][j]];
            pos[a[i][j]] = i;
        }
    }
    fill_n(pos, M, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int bound = N, diff = 0;
            ++tmr;
            for (int k = 0; i + k < n && j + k < m; ++k) {
                for (int t = j; t <= j + k; ++t) {
                    int v = a[i + k][t];
                    bound = min(bound, r[i + k][t] - j);
                    bound = min(bound, c[i + k][t] - i);
                    if (pos[v] < tmr) {
                        ++diff;
                        pos[v] = tmr;
                    }
                }
                for (int t = i; t < i + k; ++t) {
                    int v = a[t][j + k];
                    bound = min(bound, r[t][j + k] - j);
                    bound = min(bound, c[t][j + k] - i);
                    if (pos[v] < tmr) {
                        ++diff;
                        pos[v] = tmr;
                    }
                }
                if (k >= bound) {
                    break;
                }
                if (diff == (k + 1)) {
                    ++answer;
                }
            }
        }
    }
    cout << answer << "\n";
}

