#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2005, P = 127;

int n, m;
int a[N][N];

bool check(int i2, int j2, int k) {
    int i1 = i2 - k + 1, j1 = j2 - k + 1;
    unordered_map<int, int> cnt;
    for (int i = i1; i <= i2; ++i) {
        unordered_map<int, int> curr_cnt;
        for (int j = j1; j <= j2; ++j) {
            cnt[a[i][j]]++;
            curr_cnt[a[i][j]]++;
            if (curr_cnt[a[i][j]] == 2) {
                return false;
            }
        }
    }
    for (int j = j1; j <= j2; ++j) {
        unordered_map<int, int> curr_cnt;
        for (int i = i1; i <= i2; ++i) {
            if (cnt[a[i][j]] != k) {
                return false;
            }
            curr_cnt[a[i][j]]++;
            if (curr_cnt[a[i][j]] == 2) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            a[i][j] = s[j * 2 - 2] + s[j * 2 - 1] * P;
        }
    }
    for (int k = 1; k <= 2000; ++k) {
        for (int i = 1; i <= 2000; ++i) {
            for (int j = 1; j <= 2000; ++j) {
                a[i][j] = min(a[i][j], a[i][k] + dist[k][j]);
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int k = 1; k <= min(i, j); ++k) {
                ans += check(i, j, k);
            }
        }
    }
    cout << ans << "\n";

    return 0;
}
