#include <bits/stdc++.h>
#define len(s) (int)(s.size())
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (ll)(x * x)
#define write(x) cout << "me " << x


const int sz = 5e5 + 10, oo = 2e9;
const double eps = 1e-7;

using namespace std;

using ll = long long;
using ld = long double;
using str = string;
using vi = vector <int>;
using pii = pair <int, int>;
using vpii = vector <pii>;
using vll = vector <ll>;
using pll = pair <ll, ll>;
using vpll = vector <pll>;
using three = pair <int, pair <int, int> >;

mt19937 rnd(time(0));

const int bore = 1100;

int n, m, ans;
str field[bore][bore];

void read()
{
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char a, b;
            cin >> a >> b;
            field[i][j] += a, field[i][j] += b;
        }
    }
}

void show(vi &a)
{
    cout << "have = "; for (auto c: a) cout << c << ' ';
    cout << endl;
}

bool ok(int start_i, int start_j, int k)
{
    if (start_i + k > n || start_j + k > m) return 0;
    set <str> total;
    ///cout << start_i << ' ' << start_j << ' ' << k << endl;
    for (int i = 0; i < k; ++i) {
        set <str> was;
        for (int j = 0; j < k; ++j) {
            if (was.count(field[start_i + i][start_j + j])) return 0;
            was.insert(field[start_i + i][start_j + j]);
            total.insert(field[start_i + i][start_j + j]);
        }
    }
    for (int j = 0; j < k; ++j) {
        set <str> was;
        for (int i = 0; i < k; ++i) {
        if (was.count(field[start_i + i][start_j + j])) return 0;
            was.insert(field[start_i + i][start_j + j]);
            total.insert(field[start_i + i][start_j + j]);
        }
    }
    ///if (len(total) == k) cout << "gg " <<  start_i << ' ' << start_j << ' ' << k << endl;
    return (len(total) == k ? 1: 0);
}


void step(int start_i, int start_j)
{
    for (int k = 2; k <= min(n, m); ++k) if (ok(start_i, start_j, k)) ++ans;
}



void solve()
{
    ans = n * m;
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) step(i, j);
    cout << ans;
}


int main()
{
    ios_base::sync_with_stdio(false);cin.tie(nullptr);
    read();
    solve();
    return 0;
}
