#include <iostream>
#include <string>
#include <unordered_set>
using namespace std;
#define endl '\n'
#define MAXN 2005
typedef long long lon;
lon a, b;
string input;
lon table[MAXN][MAXN];
unordered_set<lon>* us, *row;
bool check(lon x, lon y, lon len)
{
    //if(len > 1) cout << x << ' ' << y << ' ' << len << endl;
    us = new unordered_set<lon>();
    lon gx = x - len + 1, gy = y - len + 1;
    for(lon i = gx; i <= x; ++i){
        row = new unordered_set<lon>();
        for(lon z = gy; z <= y; ++z){
            us->insert(table[i][z]);
            if(row->find(table[i][z]) != row->end()){
                //cout << "A\n";
                return false;
            }
            row->insert(table[i][z]);
        }
    }
    if(us->size() != len){
        //cout << "B\n";
        return false;
    }
    for(lon i = gy; i <= y; ++i){
        row = new unordered_set<lon>();
        for(lon z = gx; z <= x; ++z){
            if(row->find(table[z][i]) != row->end()){
                //cout << "C " << i << ' ' << z << endl;
                return false;
            }
            row->insert(table[z][i]);
        }
    }
    return true;
}
int main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> a >> b;
    lon result = 0;
    for(lon i = 0; i < a; ++i){
        cin >> input; lon sz = input.size();
        for(lon z = 0; z < sz; z += 2){
            table[i][z / 2] = input[z] * 127 + input[z + 1];
            for(lon q = 1; q <= min(i, z / 2) + 1; ++q){
                bool b = check(i, z / 2, q);
                if(b){
                    ++result;
                }
            }
        }
    }
    cout << result << endl;
    return 0;
}
