#include <iostream>
#include <assert.h>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define vbb vector<bool>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

vector<vector<string> > a;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, m;
    cin >> n >> m;

    a.resize(n, vector<string> (m));
    for(int i = 0; i < n; i++)
    {
        string cur;
        cin >> cur;
        for(int j = 0; j < m; j++)
        {
            string temp = "";
            temp += cur[j * 2];
            temp += cur[j * 2 + 1];
            a[i][j] = temp;
        }
    }

    ll answ = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            answ++;
            vector<map<string, bool> > usedHor(1);
            usedHor[0][a[i][j]] = 1;

            vector<map<string, bool> > usedVer(1);
            usedVer[0][a[i][j]] = 1;

            set<string> totalUsed;
            totalUsed.insert(a[i][j]);

       //     cerr << "start " << i << " " << j << endl;
            for(int k = 1; k < min(n - i, m - j); k++)
            {
            //    cerr << "k " << k << endl;
                bool flag = 0;
                map<string, bool> newMap;
                usedHor.pb(newMap);
                usedVer.pb(newMap);

                for(int t = 0; t <= k; t++)
                {
                    string newEl = a[i + k][j + t];
            //        cerr << "newEl " << newEl << endl;
                    totalUsed.insert(newEl);
                    if(usedVer[t].count(newEl) || usedHor.back().count(newEl))
                    {
              //          cerr << "hor flag" << endl;
                        flag = 1;
                        break;
                    }
                    usedVer[t][newEl] = 1;
                    usedHor.back()[newEl] = 1;
                }
             //   cerr << "now other side" << endl;
                for(int t = 0; t < k; t++)
                {
                    string newEl = a[i + t][j + k];
               //     cerr << "newEl " << newEl << endl;
                    totalUsed.insert(newEl);
                    if(usedHor[t].count(newEl) || usedVer.back().count(newEl))
                    {
                 //       cerr << "ver flag" << endl;
                        flag = 1;
                        break;
                    }
                    usedHor[t][newEl] = 1;
                    usedVer.back()[newEl] = 1;
                }
                if(flag)
                    break;
                if(totalUsed.size() == k + 1)
                    answ++;
            }
        }
    }
    cout << answ << endl;
    return 0;
}