#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Q = 200;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<char, char> > > a(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j].first >> a[i][j].second;
        }
    }
    ll ans = n * m;
    vector<vector<int> > col(Q * Q), str(Q * Q);
    for (int i = 0; i < Q * Q; i++) {
        col[i].resize(n);
        str[i].resize(m);
    }
    for (int len = 1; len < min(n, m); len++) {
        for (int i = 0; i + len < n; i++) {
            for (int j = 0; j + len < m; j++) {
                set<int> st;
                for (int ii = i; ii <= i + len; ii++) {
                    for (int jj = j; jj <= j + len; jj++) {
                        int idx = a[ii][jj].first * Q + a[ii][jj].second;
                        col[idx][ii] = 1;
                        str[idx][jj] = 1;
                        st.insert(idx);
                    }
                }
                int kol = 0;
                for (auto ch : st) {
                    int sum_col = 0;
                    for (int ii = i; ii <= i + len; ii++) {
                        sum_col += col[ch][ii];
                        col[ch][ii] = 0;
                    }
                    int sum_str = 0;
                    for (int jj = j; jj <= j + len; jj++) {
                        sum_str += str[ch][jj];
                        str[ch][jj] = 0;
                    }
                    if (sum_col == len + 1 && sum_str == len + 1) {
                         kol++;
                    }
                }
                if (kol == len + 1) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
