// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}
#define ld long double
#define left left228
#define right right228
#define list list228

const int N = 2007;

int n, m;
int a[N][N], right[N][N], down[N][N];

int code(char c) {
	return (int)c - 32;
}

int cnt[10000];
int diff = 0;
void init() {
	memset(cnt, 0, sizeof cnt);
	diff = 0;
}
void add(int x) {
	if (cnt[x] == 0) ++diff;
	++cnt[x];
}
void del(int x) {
	--cnt[x];
	if (cnt[x] == 0) --diff;
}

void pre() {
	for (int i = 1; i <= n; ++i) {
		int r = 0;
		for (int j = 1; j <= m; ++j) {
			while (r + 1 <= m && !cnt[a[i][r + 1]]) {
				++r;
				add(a[i][r]);
			}
			right[i][j] = r;
			del(a[i][j]);
		}
		for (int j = 1; j <= m; ++j) {
			cnt[a[i][j]] = 0;
		}
	}
	for (int j = 1; j <= m; ++j) {
		int r = 0;
		for (int i = 1; i <= n; ++i) {
			while (r + 1 <= n && !cnt[a[r + 1][j]]) {
				++r;
				add(a[r][j]);
			}
			down[i][j] = r;
			del(a[i][j]);
		}
		for (int i = 1; i <= n; ++i) {
			cnt[a[i][j]] = 0;
		}
	}
}

bool check(int x1, int y1, int x2, int y2) {
	for (int i = y1; i <= y2; ++i) {
		if (down[x1][i] < x2) return 0;
	}
	for (int i = x1; i <= x2; ++i) {
		if (right[i][y1] < y2) return 0; 
	}
	return 1;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char c1, c2;
			cin >> c1 >> c2;
			a[i][j] = code(c1) * 97 + code(c2);
		}
	}
	pre();
	long long answer = 0;
	for (int y1 = 1; y1 <= m; ++y1) {
		for (int y2 = y1; y2 <= m; ++y2) {
			init();
			int k = y2 - y1 + 1;
			if (n < k) continue;
			for (int x = 1; x <= k; ++x) {
				for (int y = y1; y <= y2; ++y) {
					add(a[x][y]);
				}
			}
			if (diff == k && check(1, y1, k, y2)) ++answer;
			for (int x = k + 1; x <= n; ++x) {
				for (int y = y1; y <= y2; ++y) {
					del(a[x - k][y]);
					add(a[x][y]);
				}
				if (diff == k && check(x - k + 1, y1, x, y2)) {
					++answer;
				}
			}
		}
	}
	cout << answer << '\n';
	return 0;
}

/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC


5 10
!"#$%&'()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_`abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&
*/
