#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

constexpr int P = 53;
constexpr int M = 1e9 + 7;

using prc = pair<char, char>;
mt19937 rnd;

constexpr int MAXN = 501;

int col[MAXN][MAXN][MAXN], row[MAXN][MAXN][MAXN];

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<prc>> f(n, vector<prc>(m));
    map<prc, int> to;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j].ff >> f[i][j].ss;
            to[f[i][j]] = rnd();
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int cr = to[f[i][j]];
            col[i][j][i] = cr;
            row[i][j][j] = cr;
            for (int k = i + 1; k < n; k++) {
                col[i][j][k] = col[i][j][k - 1] + to[f[k][j]];
            }
            for (int k = j + 1; k < m; k++) {
                row[i][j][k] = row[i][j][k - 1] + to[f[i][k]];
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int mdi = i;
            int mdj = j;
            set<prc> usd;
            for (int k = i; k < n; k++) {
                if (usd.count(f[k][j])) break;
                mdi = k;
                usd.insert(f[k][j]);
            }
            usd.clear();
            for (int k = j; k < m; k++) {
                if (usd.count(f[i][k])) break;
                mdj = k;
                usd.insert(f[i][k]);
            }
            int tt = 0;
            while (i + tt <= mdi && j + tt <= mdj) {
                bool f = true;
                for (int k = 1LL; k <= tt; k++) {
                    if (col[i][j + k][i + tt] != col[i][j + k - 1][i + tt] ||
                        row[i + k][j][j + tt] != row[i + k - 1][j][j + tt]) {
                        f = false;
                        break;
                    }
                }
                if (f) ans++;
                tt++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}