#include <iostream>
#include <string>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

string s[MAXN + 5][MAXN + 5];

bool check(int i1, int j1, int d)
{
    map<string, int> m;
    int k = 0;
    for (int i = i1; i < i1 + d; ++ i)
    {
        map<string, int> m1;
        for (int j = j1; j < j1 + d; ++ j)
        {
            if (m1[s[i][j]] == 1) return false;
            m1[s[i][j]]++;
            if (m[s[i][j]] == 0)
            {
                m[s[i][j]]++;
                k++;
            }
        }
    }

    if (k != d) return false;

    for (int j = j1; j < j1 + d; ++ j)
    {
        map<string, int> m1;
        for (int i = i1; i < i1 + d; ++ i)
        {
            if (m1[s[i][j]] == 1) return false;
            m1[s[i][j]]++;
        }
    }

    return true;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    char ch1, ch2;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            cin >> ch1 >> ch2;
            s[i][j] = ch1 + ch2;
        }
    }

    long long ans = 0;
    for (int d = 1; d <= min(m, n); ++ d)
    {
        for (int i = 0; i <= n - d; ++ i)
        {
            for (int j = 0; j <= m - d; ++ j)
            {
                if (check(i, j, d)) ans++;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
