#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second
#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, vi &a) {
	for (auto &i : a) in >> i;
	return in;
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n, m;
	char a, b, c(33);
	cin >> n >> m;
	vvi mat(n, vi(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> a >> b;
			mat[i][j] = (a - c) * 100 + (b - c);
		}
	}
	int ans = 0;
	for (int x = 0; x < m; ++x) {
		for (int y = 0; y < n; ++y) {
			int mxl = min(m - x, n - y);
			ve<ve<bool>> row(mxl, ve<bool>(10000)), col(mxl, ve<bool>(10000));
			vi ninrow(mxl, 0), nincol(mxl, 0);
			int nrows = 0, ncols = 0;
			ve<bool> square(10000);
			int ninsq = 0;
			for (int l = 0; l < mxl; ++l) {
				for (int kl = 0; kl <= l; ++kl) {
					int newn = mat[y + kl][x + l];
					if (!row[kl][newn]) ninrow[kl]++;
					row[kl][newn] = true;
					if (!col[l][newn]) nincol[l]++;
					col[l][newn] = true;
					if (!square[newn]) ninsq++;
					square[newn] = true;
				}
				for (int kl = 0; kl <= l; ++kl) {
					int newn = mat[y + l][x + kl];
					if (!row[l][newn]) ninrow[l]++;
					row[l][newn] = true;
					if (!col[kl][newn]) nincol[kl]++;
					col[kl][newn] = true;
					if (!square[newn]) ninsq++;
					square[newn] = true;
				}
				if (ninsq == l + 1) {
					bool flag = true;
					for (int j = 0; j <= l; ++j) flag = (flag && (nincol[j] == l + 1));
					for (int j = 0; j <= l; ++j) flag = (flag && (ninrow[j] == l + 1));
					if (flag) ans++;
				}
			}
		}
	}
	cout << ans << endl;
	return 0;
}
