#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <random>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long


int32_t main()
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;
    int ans = 0;
    cin >> n >> m;
    vector<string> t(n);
    for (int i = 0; i < n; i++) cin >> t[i];
    
    vector<vector<int>> a(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            a[i][j] = t[i][2 * j];
            a[i][j] *= 127;
            a[i][j] += t[i][2 * j + 1];
        }
    }

    vector<set<int>> raw(n), column(m);
    set<int> all;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int k = 0; k < n; k++) raw[k].clear();
            for (int k = 0; k < m; k++) column[k].clear();
            all.clear();
            for (int length = 0; i - length >= 0 && j - length >= 0; length++)
            {
                for (int k = 0; k <= length; k++)
                {
                    raw[length].insert(a[i - length][j - k]);
                    column[k].insert(a[i - length][j - k]);
                    all.insert(a[i - length][j - k]);
                    column[length].insert(a[i - k][j - length]);
                    raw[k].insert(a[i - k][j - length]);
                    all.insert(a[i - k][j - length]);
                }
                
                if (all.size() != length + 1) continue;
                bool flag = false;
                for (int k = 0; k <= length; k++)
                {
                    if (raw[k].size() <= length || column[k].size() <= length)
                    {
                        flag = true;
                        break;
                    }
                }
                if (flag) break;
                ans++;
                
            }
        }
    }

    cout << ans;
    return 0;
}