#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int E = (126 - 33) * 100 + 126 - 33 + 3, N = 2001;

int n, m, a[N][N], d[N][N], r[N][N];

long long p1[E], p2[E], t1[E], t2[E];

const long long P1 = 47, M1 = 1e9 + 1447, P2 = 447, M2 = 1000001531;

pair<int, int> hh[N][N];
int dd[N][N];

void upd(int x, int add, int &h1, int &h2) {
    if (add == +1) {
        h1 += t1[x];
        h2 += t2[x];
        if (h1 >= M1) h1 -= M1;
        if (h2 >= M2) h2 -= M2;
    } else {
        h1 -= t1[x];
        h2 -= t2[x];
        if (h1 < 0) h1 += M1;
        if (h2 < 0) h2 += M2;
    }
}

pair<int, int> keep[E];
long long ans;

deque<int> q;

void PUNKS_NOT_DEAD() {
    p1[0] = p2[0] = 1;
    for (int pw = 1; pw < E; pw++) {
        p1[pw] = (p1[pw - 1] * P1) % M1;
        p2[pw] = (p2[pw - 1] * P2) % M2;
        t1[pw] = (pw * p1[pw]) % M1;
        t2[pw] = (pw * p2[pw]) % M2;
    }
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char x1, x2;
            cin >> x1 >> x2;
            a[i][j] = (x1 - 33) * 100 + (x2 - 33);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            for (int k = 1; j + k - 1 <= m; k++) {
                if (keep[a[i][j + k - 1]] == make_pair(i, j)) {
                    break;
                }
                keep[a[i][j + k - 1]] = {i, j};
                r[i][j] = k + j - 1;
            }
            for (int k = 1; i + k - 1 <= n; k++) {
                if (keep[a[i + k - 1][j]] == make_pair(-i, -j)) {
                    break;
                }
                keep[a[i + k - 1][j]] = {-i, -j};
                d[i][j] = k + i - 1;
            }
        }
    }
    int t = min(n, m);
    for (int len = 1; len <= t; len++) {
        for (int i = n; i >= 1; i--) {
            int h1 = 0, h2 = 0;
            for (int j = 1; j <= len - 1; j++) {
                upd(a[i][j], +1, h1, h2);
                while (q.size() && d[i][q.back()] >= d[i][j]) q.pop_back();
                q.push_back(j);
            }
            for (int j = len; j <= m; j++) {
                while (q.size() && q.front() < j - len + 1) q.pop_front();
                if (j > len) {
                    upd(a[i][j - len], -1, h1, h2);
                }
                upd(a[i][j], +1, h1, h2);
                while (q.size() && d[i][q.back()] >= d[i][j]) q.pop_back();
                q.push_back(j);
                if (r[i][j - len + 1] < j) {
                    hh[i][j - len + 1] = {-1, -1};
                    dd[i][j - len + 1] = -1;
                } else {
                    hh[i][j - len + 1] = {h1, h2};
                    dd[i][j - len + 1] = i;
                    if (i + 1 <= n && hh[i + 1][j - len + 1] == hh[i][j - len + 1]) {
                        dd[i][j - len + 1] = dd[i + 1][j - len + 1];
                    }
                    assert(q.size() && q.front() >= j - len + 1);
                    int tt = d[i][q.front()];
                    if (dd[i][j - len + 1] >= i + len - 1 && tt >= i + len - 1) {
                        ans++;
                    }
                }
            }
            while (q.size()) q.pop_back();
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    PUNKS_NOT_DEAD();
}