#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;

typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

map < pair< pii, int >, int > fans;

void solve() {
    int n, m;
    cin >> n >> m;
    vector <string> mas(n);
    for(int i = 0; i < n; ++i) {
        cin >> mas[i];
    }
    vector < vector <int> > v(n, vector <int>(m, 0));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < 2 * m; j += 2) {
            v[i][j / 2] = min(mas[i][j], mas[i][j + 1]) * 256 + max(mas[i][j], mas[i][j + 1]);
        }
    }
    vector < vector <int> > dp1(n, vector <int>(m, 1));
    for(int i = 1; i < n; ++i) {
        for(int j = 0; j < m - 1; ++j) {
            if(v[i][j] == v[i - 1][j + 1]) {
                dp1[i][j] = dp1[i - 1][j + 1] + 1;
            }
        }
    }
    vector < vector <int> > dp2(n, vector <int>(m, 1));
    for(int i = 1; i < n; ++i) {
        for(int j = 1; j < m; ++j) {
            if(v[i][j] == v[i - 1][j - 1]) {
                dp2[i][j] = dp2[i - 1][j - 1] + 1;
            }
        }
    }
    /*for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cout << dp2[i][j] << ' ';
        }
        cout << '\n';
    }*/

    /*int ans = n * m;

    for(int i = 0; i < n - 1; ++i) {
        for(int j = 0; j < m - 1; ++j) {
            if(v[i][j] == v[i + 1][j + 1] && v[i][j + 1] == v[i + 1][j] && v[i][j] != v[i + 1][j]) ans++;
        }
    }*/

    int maxSize = min(n, m);

//    cout << "ans = " << ans << '\n';

    // 1
    for(int x = 0; x < n; ++x) {
        for(int y = 0; y < m; ++y) {
            set <int> elemsU, elemsR;
            set <int> elems;
            for(int siz = 1; siz <= maxSize && x - siz + 1 >= 0 && y + siz - 1 < m; ++siz) {
                elemsU.insert(v[x - siz + 1][y]);
                elemsR.insert(v[x][y + siz - 1]);
                elems.insert(v[x - siz + 1][y]);
                elems.insert(v[x][y + siz - 1]);
                if(elemsU.size() != siz || elemsR.size() != siz || elems.size() != siz) continue;
                bool b = true;
                int need = siz;
                for(int i = x; i >= x - siz + 1; --i) {
                    if(dp1[i][y] >= need--) continue;
                    b = false;
                    break;
                }
                if(!b) continue;
                need = siz;
                for(int i = y; i <= y + siz - 1; ++i) {
                    if(dp1[x][i] >= need--) continue;
                    b = false;
                    break;
                }
                if(!b) continue;
//                ans++;
                fans[{{x, y}, siz}]++;
            }
        }
    }

    // 2
    for(int x = 0; x < n; ++x) {
        for(int y = 0; y < m; ++y) {
            set <int> elemsU, elemsL;
            set <int> elems;
            for(int siz = 1; siz <= maxSize && x - siz + 1 >= 0 && y - siz + 1 >= 0; ++siz) {
                elemsU.insert(v[x - siz + 1][y]);
                elemsL.insert(v[x][y - siz + 1]);
                elems.insert(v[x - siz + 1][y]);
                elems.insert(v[x][y - siz + 1]);
                if(elemsU.size() != siz || elemsL.size() != siz || elems.size() != siz) continue;
                bool b = true;
                int need = siz;
                for(int i = x; i >= x - siz + 1; --i) {
                    if(dp2[i][y] >= need--) continue;
                    b = false;
                    break;
                }
                if(!b) continue;
                need = siz;
                for(int i = y; i >= y - siz + 1; --i) {
                    if(dp2[x][i] >= need--) continue;
                    b = false;
                    break;
                }
                if(!b) continue;
//                ans++;
                fans[{{x, y - siz + 1}, siz}]++;
            }
        }
    }








    cout << fans.size() << '\n';

}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int t = 1;
//    cin >> t;
    while(t--)
        solve();
    return 0;
}