#include <bits/stdc++.h>

using namespace std;

const int len = (126 - 33 + 1);

void solve() {
    int n, m;
    cin >> n >> m;
    pair <char, char> p[n][m];
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> p[i][j].first >> p[i][j].second;
    vector <vector <vector <int> > > pr(n + 1, vector <vector <int> > (m + 1, vector <int> (len * len)));
    for (int i = 0; i < len * len; ++i) {
        int str[n + 1][m + 1];
        for (int j = 0; j <= m; ++j) str[0][m] = 0;
        for (int j = 1; j <= n; ++j) {
            str[j][0] = 0;
            for (int k = 1; k <= m; ++k) {
                str[j][k] = str[j][k - 1];
                if (((int) p[j - 1][k - 1].first - 33) * len + (int) (p[j - 1][k - 1].second - 33) == i) ++str[j][k];
            }
        }
        for (int j = 0; j <= n; ++j) pr[j][0][i] = 0;
        for (int j = 0; j <= m; ++j) pr[0][j][i] = 0;
        for (int j = 1; j <= n; ++j) {
            for (int k = 1; k <= m; ++k) {
                pr[j][k][i] = pr[j - 1][k][i] + str[j][k];
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= min(n, min(m, len * len)); ++i) {
        for (int j = 0; j + i <= n; ++j) {
            for (int k = 0; k + i <= m; ++k) {
                bool ch = 0;
                for (int tc = 0; tc < len * len; ++tc) {
                    int val = pr[j + i][k + i][tc] + pr[j][k][tc] - pr[j][k + i][tc] - pr[j + i][k][tc];
                    if (val != i && val) {
                        ch = 1;
                        break;
                    }
                }
                if (!ch) ++ans;
            }
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
