#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            char c, d;
            cin >> c >> d;
            int c1 = c-33, d1 = d-33;
            a[i][j] = (c*(126-33+1))+d;
            //cout << i << ':' << j << ' ' << a[i][j] << endl;
        }
    }
    vector<vector<vector<int> > > v(n, vector<vector<int> >(m, vector<int>(m)));
    vector<vector<set<int> > > lst(m, vector<set<int> >(m));
    vector<vector<vector<bool> > > u(n, vector<vector<bool> >(m, vector<bool>(m)));
    set<int> rt;
    for(int x = 0; x<n; x++){
        for(int y1 = 0; y1<m; y1++){
            rt.clear();
            for(int y2 = y1; y2<m; y2++){
                rt.insert(a[x][y2]);
                u[x][y1][y2] = (rt==lst[y1][y2]);
                v[x][y1][y2] = rt.size();
                lst[y1][y2] = rt;
            }
        }
    }
    int ans = 0;
    for(int x = 0; x<n; x++){
        for(int y = 0; y<m; y++){
            for(int ln = 0; ln<=min(x, y); ln++){
                bool kek = true;
                if(v[x][y-ln][y]!=ln+1){
                    kek = false;
                    continue;
                }
                for(int i = x; i>x-ln; i--){
                    if(!u[i][y-ln][y]){
                        kek = false;
                        //cout << x << ':' << y << '-' << ln << ' ' << i << endl;
                        break;
                    }
                }
                ans += kek;
            }
        }
    }
    cout << ans;

    return 0;
}
