#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

const int ALP = 256;

int cnt[ALP * ALP];

bool check(int x, int y, int k, vector <string>& a) {
	for (int i = x; i < x + k; i++) {
		bool cor = 1;
		for (int j = y; j < y + 2 * k; j += 2) {
			if (cnt[a[i][j] * ALP + a[i][j + 1]])
				cor = 0;
			cnt[a[i][j] * ALP + a[i][j + 1]]++;
		}
		for (int j = y; j < y + 2 * k; j += 2) {
			cnt[a[i][j] * ALP + a[i][j + 1]] = 0;
		}
		if (!cor)
			return 0;
	}
	for (int j = y; j < y + 2 * k; j += 2) {
		bool cor = 1;
		for (int i = x; i < x + k; i++) {
			if (cnt[a[i][j] * ALP + a[i][j + 1]])
				cor = 0;
			cnt[a[i][j] * ALP + a[i][j + 1]]++;
		}
		for (int i = x; i < x + k; i++) {
			cnt[a[i][j] * ALP + a[i][j + 1]] = 0;
		}
		if (!cor)
			return 0;
	}
	int dif = 0;
	vector <int> used;
	for (int i = x; i < x + k && dif < k + 1; i++) {
		for (int j = y; j < y + 2 * k && dif < k + 1; j += 2) {
			if (!cnt[a[i][j] * ALP + a[i][j + 1]]) {
				dif++;
				cnt[a[i][j] * ALP + a[i][j + 1]]++;
				if (cnt[a[i][j] * ALP + a[i][j + 1]] > k)
					dif = k + 1;
				used.emplace_back(a[i][j] * ALP + a[i][j + 1]);
			}
		}
	}
	for (auto u : used)
		cnt[u] = 0;
	return dif == k;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <string> a(n);
	for (auto& u : a)
		cin >> u;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j += 2) {
			for (int k = 1; j + 2 * k <= 2 * m && i + k <= n; k++)
				if (check(i, j, k, a))
					ans++;
		}
	}
	cout << ans;
}