#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int(x.size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr int N = 2002;
unordered_set<int> hor[N], ver[N];
int mat[N][N];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int m = input();
    for (int i = 0; i < n; ++i) {
        auto cur = input<string>();
        for (int j = 0; j < m; ++j) {
            mat[i][j] = 100 * (cur[2 * j] - 33)
                    + (cur[2 * j + 1] - 33);
        }
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < N; ++k) {
                hor[k].clear();
                ver[k].clear();
            }
            unordered_set<int> ttl;

            for (int k = 1; i + k <= n && j + k <= m; ++k) {
                for (int x = i; x < i + k; ++x) {
                    hor[x].insert(mat[x][j + k - 1]);
                    ver[j + k - 1].insert(mat[x][j + k - 1]);
                    ttl.insert(mat[x][j + k - 1]);
                }
                for (int y = j; y < j + k; ++y) {
                    ver[y].insert(mat[i + k - 1][y]);
                    hor[i + k - 1].insert(mat[i + k - 1][y]);
                    ttl.insert(mat[i + k - 1][y]);
                }
                bool good = true;
                for (int x = i; x < i + k; ++x) {
                    if (sz(hor[x]) != k) {
                        good = false;
                        break;
                    }
                }
                for (int y = j; y < j + k; ++y) {
                    if (sz(ver[y]) != k) {
                        good = false;
                        break;
                    }
                }
                if (!good) {
                    break;
                }
//                cerr << i << ' ' << j << ' ' << k << endl;
                cnt += (sz(ttl) == k);
            }
        }
    }
    cout << cnt << endl;
}
