#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 505;

const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int f[maxn][maxn];

int main() {
    init();

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            int x = s[2 * j];
            int y = s[2 * j + 1];
            f[i][j] = x * 1000 + y;
        }
    }

    int ans = 0;

    for (int a = 0; a < n; a++) {
        for (int b = 0; b < m; b++) {
            for (int k = 1; a + k <= n && b + k <= m; k++) {
                int c = a + k;
                int d = b + k;
                bool usp = true;

                for (int i = a; i < c; i++) {
                    unordered_set<int> cur;
                    if (!usp) break;
                    for (int j = b; j < d; j++) {
                        if (cur.count(f[i][j])) {
                            usp = false;
                            break;
                        }
                        cur.insert(f[i][j]);
                    }
                }
                for (int j = b; j < d; j++) {
                    if (!usp)
                        break;
                    unordered_set<int> cur;
                    for (int i = a; i < c; i++) {
                        if (cur.count(f[i][j])) {
                            usp = false;
                            break;
                        }
                        cur.insert(f[i][j]);
                    }
                }

                if (!usp)
                    continue;

                unordered_set<int> total;
                for (int i = a; i < c; i++) {
                    for (int j = b; j < d; j++) {
                        total.insert(f[i][j]);
                    }
                }
                if (total.size() != k)
                    continue;
                ans++;
            }

        }
    }
    cout << ans << endl;

    return 0;
}