#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <string>
#include <set>

typedef long long ll;

using namespace std;

int med(int a, int b, int c){
    if((a >= b && a <= c) || (a >= c && a <= b)){
        return a;
    }
    if((b >= a && b <= c) || (b >= c && b <= a)){
        return b;
    }
    return c;
}

int main() {
    int n, m;
    cin >> n>> m;
    vector<string> table(n);
    set<pair<char, char>> contains;
    for(int i = 0; i < n; i++){
        cin >> table[i];
    }
    ll ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            vector<set<pair<char, char>>> strok, stolb;
            set<pair<char, char>> cur;
            bool can = true;
           for(int l = 0; l < min(n - i, m - j) && can; l++){
               strok.push_back({});
               stolb.push_back({});
               for(int k = i; k <= i + l && can; k++){
                   if(strok[l].find({table[k][(j + l)*2], table[k][(j + l)*2 + 1]}) != strok[l].end() || stolb[k - i].find({table[k][(j + l )*2], table[k][(j + l)*2 + 1]}) != stolb[k- i].end()){
                       can = false;
                       break;
                   } else {
                       strok[l].insert({table[k][(j + l )*2], table[k][(j + l)*2 + 1]});
                       stolb[k - i].insert({table[k][(j + l )*2], table[k][(j + l)*2 + 1]});
                       cur.insert({table[k][(j + l )*2], table[k][(j + l )*2 + 1]});
                   }
               }
               for(int k = j; k < j + l && can; k++){
                   if(strok[k - j].find({table[(i + l )][k*2 ], table[(i + l )][k*2 + 1]}) != strok[k - j].end() || stolb[l].find({table[(i + l )][k*2], table[(i + l )][k*2 + 1]}) != stolb[l].end()){
                       can = false;
                       break;
                   } else {
                       strok[k - j].insert({table[(i + l)][k*2], table[(i + l)][k*2 + 1]});
                       stolb[l].insert({table[(i + l )][k*2], table[(i + l )][k*2 + 1]});
                       cur.insert({table[(i + l)][k*2], table[(i + l ) ][k*2 + 1]});
                   }
               }
               if(can && cur.size() == l + 1){
                   ans++;
               }

           }
        }
    }
    cout << ans;
    /*int n; cin >> n;
    //vector<vector<vector<int>>> am(2, vector<vector<int>>(2, vector<int>(2)));
    vector<ll> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
        vector<ll> cnt(1e7);
        ll ans = 0;
        for(int i = 0; i < n; i++){
            cnt[a[i]]++;
        }
        int cn = 0;
        for(int i = 1; i < 2e7 + 1; i++){
            if((cn/2)%2 == 0){
                ans ^= i;
            }
            if(i < 1e7 + 1 && (cnt[i])%2 == 1){
                cn++;
            }
        }
        cout << ans;*/
    return 0;
}