#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

const int base = 317, sz = 101;
int n, m;
pair<int, int> hs[sz][sz][sz];

signed main() {
	kekek;
	cin >> n >> m;
	vector<vector<int>> kek(n, vector<int>(m));
	for (auto &i : kek) {
		for (auto &j : i) {
			char a, b;
			cin >> a >> b;
			j = a * base + b;
		}
	}

	for (int i = 0; i < sz; i++) {
		for (int j = 0; j < sz; j++) {
			for (int k = 0; k < sz; k++) {
				hs[i][j][k] = { -1, -1 };
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			unordered_set<int> zxc;
			for (int k = j; k < m; k++) {
				if (zxc.count(kek[i][k])) break;
				zxc.insert(kek[i][k]);

				int mns = j;
				for (int z = j + 1; z <= k; z++) {
					int pos1 = mns, pos2 = z;
					while (1) {
						if (kek[i][pos1] != kek[i][pos2]) {
							if (kek[i][pos2] < kek[i][pos1]) {
								mns = z;
							}
							break;
						}
						pos1++;
						if (pos1 == k + 1) pos1 = j;
						pos2++;
						if (pos2 == k + 1) pos2 = j;
					}
				}

				int hh = 0;
				for (int zxc = mns; zxc <= k; zxc++) {
					hh = hh * base * base + kek[i][zxc];
				}
				for (int zxc = j; zxc < mns; zxc++) {
					hh = hh * base * base + kek[i][zxc];
				}

				hs[i][j][k] = { hh, mns - j };
			}
		}
	}

	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = j; k < m && k - j <= n - i - 1; k++) {
				if (hs[i][j][k].first != -1) {
					unordered_set<int> aaa;
					for (int i1 = i; i1 - i <= k - j; i1++) {
						if (hs[i1][j][k].first == hs[i][j][k].first && aaa.find(hs[i1][j][k].second) == aaa.end()) {
							aaa.insert(hs[i1][j][k].second);
						} else break;
					}

					if (aaa.size() == k - j + 1) {
						ans++;
					}
				}
			}
		}
	}

	cout << ans;

	return 0;
}