#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


const int maxp = 1e6;
bool prime[maxp];
int MOD1 = 1791791791;
int MOD2 = 1e9 + 7;
const int maxc = 1e4 + 5;
const int maxn = 503;
pair<int, int> vertHash[maxn][maxn];
pair<int, int> horizHash[maxn][maxn];
int maxHorizDist[maxn][maxn];
int maxVertDist[maxn][maxn];
int cnt[maxc];
int vertDp[maxn][maxn];
int horizDp[maxn][maxn];


void invoke()
{
    for (int i = 0; i < maxn; i++)
    {
        for (int j = 0; j < maxn; j++)
        {
            vertDp[i][j] = 1;
            horizDp[i][j] = 1;
        }
    }
}


#define pa pair<int, int>
#define ft first
#define sc second


pair<int, int> mp(int a, int b)
{
    return make_pair(a, b);
}


signed main()
{
    warp();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < maxc; i++) cnt[i] = 0;
    for (int i = 0; i < maxp; i++)
    {
        prime[i] = true;
    }
    prime[0] = false;
    prime[1] = false;
    vector<int> p;
    for (int i = 2; i < maxp; i++)
    {
        if (!prime[i]) continue;
        p.push_back(i);
        for (int j = 2; i * j < maxp; j++) prime[i * j] = false;
    }
    random_shuffle(p.begin(), p.end());
    vector<vector<int> > f(n, vector<int> (m));
    int temp = 126 - 33;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char a, b;
            cin >> a >> b;
            a -= 33;
            b -= 33;
            f[i][j] = a * temp + b;
        }
    }
    for (int i = 0; i < maxn; i++)
    {
        for (int j = 0; j < maxn; j++)
        {
            vertHash[i][j] = mp(0, 0);
            horizHash[i][j] = mp(0, 0);
            maxHorizDist[i][j] = 0;
            maxVertDist[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            horizHash[i][j] = mp(p[f[i][j]], p[f[i][j]]);
            vertHash[i][j] = horizHash[i][j];
            bool flag = true;
            for (int k = i; k < n; k++)
            {
                int cur = f[k][j];
                if (cnt[cur]) flag = false;
                cnt[cur]++;
                if (flag) maxVertDist[i][j]++;
            }
            for (int k = i; k < n; k++)
            {
                int cur = f[k][j];
                cnt[cur]--;
            }
            flag = true;
            for (int k = j; k < m; k++)
            {
                int cur = f[i][k];
                if (cnt[cur]) flag = false;
                cnt[cur]++;
                if (flag) maxHorizDist[i][j]++;
            }
            for (int k = j; k < m; k++)
            {
                int cur = f[i][k];
                cnt[cur]--;
            }
        }
    }
    int ans = 0;
    for (int l = 1; l <= min(n, m); l++)
    {
        invoke();
        for (int i = n - 2; i > -1; i--)
        {
            for (int j = m - 2; j > -1; j--)
            {
                if (horizHash[i][j] == horizHash[i + 1][j]) vertDp[i][j] += vertDp[i + 1][j];
                if (vertHash[i][j] == vertHash[i][j + 1]) horizDp[i][j] += horizDp[i][j + 1];
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                if (min(maxVertDist[i][j], maxHorizDist[i][j]) < l) continue;
                if (horizHash[i][j] == mp(0, 0) || vertHash[i][j] == mp(0, 0)) continue;
                if (horizHash[i][j] != vertHash[i][j]) continue;
                if (min(vertDp[i][j], horizDp[i][j]) < l) continue;
                ans++;
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                int cur = p[f[i][j]];
                vertHash[i][j].first = cur * vertHash[i + 1][j].first;
                vertHash[i][j].first %= MOD1;
                horizHash[i][j].first = cur * horizHash[i][j + 1].first;
                horizHash[i][j].first %= MOD1;


                vertHash[i][j].second = cur * vertHash[i + 1][j].second;
                vertHash[i][j].second %= MOD2;
                horizHash[i][j].second = cur * horizHash[i][j + 1].second;
                horizHash[i][j].second %= MOD2;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
