#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#define endl '\n'
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
using namespace std;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
mt19937 rnd(2007);

const int maxn = 2007;
const int CNT = 10000;
unsigned int a[maxn][maxn], a2[maxn][maxn];
unsigned int h[maxn][maxn], lgst[maxn][maxn], h2[maxn][maxn], lgst2[maxn][maxn];

unsigned int hshvals[CNT];


int n, m;

void read_square(){
    forn (i, n){
        string s; cin >> s;
        forn (j, m){
            a[i][j] = (s[i * 2 + 1] - 33) * 95 + (s[i * 2] - 33);
        }
    }
}

void solve(){
    cin >> n >> m;
    forn (i, CNT) hshvals[i] = rnd();
    read_square();

    forn (i, n){
        forn (j, m){
            a[i][j] = hshvals[a[i][j]];
            a2[j][i] = a[i][j];
        }
    }

    long long ans = 0;
    for (int k = 1; k <= n && k <= m; ++k){
        for (int i = 0; i < n; ++i){
            h[i][m - k] = 0;
            for (int v = k; v >= 1; --v){
                h[i][m - k] += a[i][m - v];
            }
            for (int v = m - k - 1; v >= 0; --v){
                h[i][v] = h[i][v  + 1] + a[i][v] - a[i][v + k];;
            }
        }
        for (int j = 0; j + k <= m; ++j) {
            for (int i = 0; i + k <= n; ++i) {
                if (i == 0 || h[i][j] != h[i - 1][j]) lgst[i][j] = 0;
                lgst[i][j]++;
            }
        }


        swap(n, m);

        for (int i = 0; i < n; ++i){
            h2[i][m - k] = 0;
            for (int v = k; v >= 1; --v){
                h2[i][m - k] += a2[i][m - v];
            }
            for (int v = m - k - 1; v >= 0; --v){
                h2[i][v] = h2[i][v  + 1] + a2[i][v] - a2[i][v + k];;
            }
        }
        for (int j = 0; j + k <= m; ++j) {
            for (int i = 0; i + k <= n; ++i) {
                if (i == 0 || h2[i][j] != h2[i - 1][j]) lgst2[i][j] = 0;
                lgst2[i][j]++;
            }
        }

        swap(n, m);

        for (int j = 0; j + k <= m; ++j) {
            for (int i = 0; i + k <= n; ++i) {
                if (lgst[i][j] >= k && lgst2[j][i] >= k && h[i][j] == h2[j][i])
                    ++ans;
            }
        }
    }
    cout << ans << endl;
}
