#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

const int N = 2007, M = 1e4 + 7, B = 10007, M1 = 988244353, B2 = 1e9 + 7, M2 = 1e9 + 9;
int f[N][N], maxi[N][N];
long long h[N][N], vert[N][N], gor[N][N];
long long poww[M];
long long cur[N];
int diff[M];
int last[M];
bool has[M], ok[M];

signed main() {
    //freopen("input.txt", "r", stdin);
    poww[0] = 1;
    for (int i = 1; i < M; i++) {
        poww[i] = (poww[i - 1] * B) % M1;
    }
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < M; i++) ok[i] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            f[i][j] = (a - 33) * 100 + (b - 32);
            maxi[i][j] = vert[i][j] = gor[i][j] = N;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < M; j++) last[j] = m;
        int cur = m;
        for (int j = m - 1; j >= 0; j--) {
            cur = min(cur, last[f[i][j]]);
            maxi[i][j] = min(maxi[i][j], cur - j);
            gor[i][j] = cur - j;
            last[f[i][j]] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < M; i++) last[i] = n;
        int cur = n;
        for (int i = n - 1; i >= 0; i--) {
            cur = min(cur, last[f[i][j]]);
            maxi[i][j] = min(maxi[i][j], cur - i);
            vert[i][j] = cur - i;
            last[f[i][j]] = i;
        }
    }
    long long ans = 0;
    for (int j = 0; j < m - 1; j++) {
        long long curh = 0;
        for (int i = 0; i < M; i++) {
            curh *= B;
            curh += N;
            curh %= M1;
        }
        h[0][j] = curh + 1;
        for (int i = 1; i <= n; i++) {
            curh = (curh + poww[f[i - 1][j]]) % M1;
            curh = (curh - poww[f[i - 1][j + 1]]) % M1;
            if (curh < 0) curh += M1;
            h[i][j] = curh + 1;
        }
    }
    /*for (int i = 0; i <= n; i++) {
        for (int j = 0; j < m - 1; j++) {
            cout << h[i][j] << ' ';
        }
        cout << endl;
    }*/
    vector <int> curr[N];
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < N; i++) cur[i] = 0;
        for (int i = n - 1; i >= 0; i--) {
            long long curh = 0;
            ans++;
            long long nmax = maxi[i][j];
            for (int len = 1; len < N; len++) {
                if (i + len >= n) break;
                if (j + len - 1 >= m - 1) break;
                nmax = min(nmax, gor[i + len][j]);
                nmax = min(nmax, vert[i][j + len]);
                curh = (curh * B2 + h[i][j + len - 1]) % M2;
                cur[i + len] = (cur[i + len] * B2 + h[i + len + 1][j + len - 1]) % M2;
                //cout << curh - cur[i + len] << ' ' << maxi[i][j] << endl;
                //if (curr[i + len] == now && nmax > len) ans++;
                if (curh == cur[i + len] && maxi[i][j] > nmax) ans++;
            } 
            //cout << i << ' ' << j << ' ' << ans << ' ' << maxi[i][j] << endl;
        }
    }
    cout << ans << endl;
    return 0;
}
