#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "\n";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll n, m;
vector<vector<int> > A;

bool check(int i, int j, int k)
{
    for (int i1 = i; i1 <= i + k; i1++)
    {
        map<int, int> z;
        for (int j1 = j; j1 <= j + k; j1++)
        {
            int x = A[i1][j1];
            if (z[x] == 1)
                return false;
            z[x]++;
        }
    }
    for (int j1 = j; j1 <= j + k; j1++)
    {
        map<int, int> z;
        for (int i1 = i; i1 <= i + k; i1++)
        {
            ll x = A[i1][j1];
            if (z[x] == 1)
                return false;
            z[x]++;
        }
    }
    return true;
}

int main()
{
    fast();
    cin >> n >> m;
    A.resize(n, vector<int> (m));
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m * 2; j += 2)
        {
            char c = s[j];
            char c1 = s[j + 1];
            A[i][j / 2] = (int(c) - 30) * 1000 + int(c1) - 33;
        }
    }

    vector<vector<ll> > R(n, vector<ll> (m, m));
    vector<vector<ll> > B(n, vector<ll> (m, n));
    for (int i = 0; i < n; i++)
    {
        map<ll, ll> lst;
        for (int j = m - 1; j >= 0; j--)
        {
            ll x = A[i][j];
            if (lst[x] == 0)
            {
                lst[x] = j + 1;
                R[i][j] = m;
                continue;
            }
            R[i][j] = lst[x] - 1;
            lst[x] = j + 1;
        }
    }

    for (int j = 0; j < m; j++)
    {
        map<ll, ll> lst;
        for (int i = n - 1; i >= 0; i--)
        {
            ll x = A[i][j];
            if (lst[x] == 0)
            {
                B[i][j] = n;
                lst[x] = i + 1;
                continue;
            }
            B[i][j] = lst[x] - 1;
            lst[x] = i + 1;
        }
    }


    ll ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            ans++;
            ll maxr = min(B[i][j] - i, R[i][j] - j);
            set<int> S;
            S.insert(A[i][j]);
            for (ll r = 2; r <= maxr; r++)
            {
                if (r + i - 1 >= n || r + j - 1 >= m)
                    continue;
                for (ll t = i; t < i + r; t++)
                {
                    maxr = min(maxr, min(B[t][j + r - 1] - i, R[t][j + r - 1] - j));
                    S.insert(A[t][j + r - 1]);
                }
                for (ll t = j; t < j + r; t++)
                {
                    maxr = min(maxr, min(B[i + r - 1][t] - i, R[i + r - 1][t] - j));
                    S.insert(A[i + r - 1][t]);
                }
                if (S.size() != r)
                    continue;
                if (r > maxr)
                {
                    break;
                }
                ans++;
            }
        }
    }
    cout << ans;
    return 0;/**

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            for (int k = 0; k + i < n && k + j < m && k < 10000; k++)
            {
                for (ll t = i; t <= i + k; t++)
                {
                    r.insert(A[t][j + k]);
                }
                for (ll t = j; t <= j + k; t++)
                {
                    r.insert(A[i + k][t]);
                }
                if (r.size() != k + 1)
                    continue;
                if (check(i, j, k))
                {
                    ans++;
                }
            }
        }
    }
    cout << ans;*/
}
