#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
//#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'
//#define int long long

mt19937 gen(41);
mt19937_64 genl(41);

ll c[200][200], r[200][200];

ll n, m;

ll a[2000][2000];

void solve1() {
    ll res = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            for (ll k = 1; k < 100000; k++) {
                if (i + k > n || j + k > m)
                    break; 
                unordered_set<ll> S;
                unordered_map<ll, ll> M;
                bool f = true;
                for (int I = i; I < i + k; I++) {
                    if (!f)
                        break;
                    for (int J = j; J < j + k; J++) {
                        M[a[I][J]]++;
                        if (M[a[I][J]] != I - i + 1) {
                            f = false;
                            break;
                        }
                    }
                }
                if (!f)
                    continue;
                if (M.size() != k) {
                    continue;
                }
                M.clear();
                for (ll J = j; J < j + k; J++) {
                    if (!f)
                        break;
                    for (ll I = i; I < i + k; I++) {
                        M[a[I][J]]++;
                        if (M[a[I][J]] != J - j + 1) {
                            f = false;
                            break;
                        }
                    }
                }
                if (!f)
                    continue;
                if (M.size() != k) {
                    continue;
                }
                res++;
            }
        }
    }
    cout << res;
    exit(0);
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
    ///--------------------------------------------------------///
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            a[i][j] = int(x) * 1000 + int(x);
        }
    }
    solve1();
    for (int i = 0; i < n; i++) {
        unordered_map<int, int> cnt;
        int L = 0, R = 0;
        bool f = true;
        for (int j = 0; j < m; j++) {
            while (f && R < m) {
                cnt[a[i][R]]++;
                if (cnt[a[i][R]] > 1)
                    f = false;
                R++;
            }
            r[i][j] = R - j;
            if (!f)
                r[i][j]--;
            cnt[a[i][j]]--;
            if (cnt[a[i][j]] == 1)
                f = true;
        }
    }
    for (int j = 0; j < m; j++) {
        unordered_map<int, int> cnt;
        int L = 0, R = 0;
        bool f = true;
        for (int i = 0; i < n; i++) {
            while (f && R < n) {
                cnt[a[R][j]]++;
                if (cnt[a[R][j]] > 1)
                    f = false;
                R++;
            }
            c[i][j] = R - i;
            if (!f)
                c[i][j]--;
            cnt[a[i][j]]--;
            if (cnt[a[i][j]] == 1)
                f = true;
        }
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int minx = 1e6;
            unordered_set<int> s;
            for (int k = 1; k < 1000000; k++) {
                if (i + k > n || j + k > m)
                    break;
                minx = min(minx, r[i + k - 1][j]);
                minx = min(minx, c[i][j + k - 1]);
                if (minx < k)
                    break;
                for (int q = i; q < i + k; q++) {
                    s.emplace(a[q][j + k - 1]);
                }
                for (int q = j; q < j + k; q++) {
                    s.emplace(a[i + k - 1][q]);
                }
                if(s.size() == k)
                    res++;
            }
        }
    }
    cout << res;
    return 0;
    ///--------------------------------------------------------///
}