#include <bits/stdc++.h>
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define pb push_back
#define fst first
#define snd second
#define all(c) c.begin(), c.end()
using namespace std;
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int INF32 = 1e9 + 228;
const ll INF64 = 2e18 + 228;
const int SYMB = 100;
const int N = 2e3 + 5;
const int logn = 12;
int pref[N][N][SYMB];
int prefcol[N][N][SYMB];
int getpref(int row, int l, int r, int z)
{
    return pref[row][r][z] - (l == 0 ? 0 : pref[row][l - 1][z]);
}
int getprefcol(int col, int l, int r, int z)
{
    return pref[col][r][z] - (l == 0 ? 0 : pref[col][l - 1][z]);
}
bool can(int x, int y, int sz)
{
    int mx = 0;
    for(int z = 0; z < SYMB; z++)
    {
        for(int i = x; i >= x - sz; i--)
            mx = max(mx, getpref(i, y - sz, y, z));
        for(int j = y; j >= y - sz; j--)
            mx = max(mx, getprefcol(j, x - sz, x, z));
    }
    return (mx <= 1);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for(auto& it : s)
    {
        cin >> it;
        for(auto& it2 : it)
            it2 -= 33;
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            pref[i][j][s[i][j]] = 1;
            if(j)
                for(int z = 0; z < SYMB; z++)
                {
                    pref[i][j][z] += pref[i][j - 1][z];
                }
        }
    }
    for(int i = 0; i < m; i++)
    {
        for(int j = 0; j < n; j++)
        {
            prefcol[i][j][s[i][j]] = 1;
            if(j)
                for(int z = 0; z < SYMB; z++)
                {
                    prefcol[i][j][z] += prefcol[i][j - 1][z];
                }
        }
    }
    ll ans = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            int l = 0, r = min(i, j);
            while(l < r)
            {
                int m = (l + r + 1) / 2;
                if(can(i, j, m))
                    l = m;
                else
                    r = m - 1;
            }
            ans += l;
        }
    }
    cout << ans;



    return 0;
}
