#include <iostream>
using namespace std;
const int MAXN=5e2+10;
const int MAXNUM=1e4+10;
int a[MAXN][MAXN], ma[MAXNUM];
bool used[MAXNUM][MAXN];
bool check(int ib, int jb, int k) {
    for (int i=0;i<k;i++) {
        for (int j=0;j<k;j++) used[i][j]=false;
    }
    for (int i=0;i<k;i++) {
        ma[a[ib+i][jb]]=i;
        used[i][i]=true;
    }
    int s;
    for (int j=1;j<k;j++) {
        for (int i=0;i<k;i++) {
            s=ma[a[i+ib][j+jb]];
            if (s==-1) return false;
            if (used[s][i]) return false;
            used[s][i]=true;
        }
    }
    for (int i=0;i<k;i++) {
        for (int j=0;j<k;j++) {
            if (!used[i][j]) return false;
            used[i][j]=false;
        }
    }
    for (int j=0;j<k;j++) {
        s=ma[a[ib][j+jb]];
        if (s==-1) return false;
        used[s][j]=true;
    }
    for (int i=1;i<k;i++) {
        for (int j=0;j<k;j++) {
            s=ma[a[i+ib][j+jb]];
            if (s==-1) return false;
            if (used[s][j]) return false;
            used[s][j]=true;
        }
    }
    for (int i=0;i<k;i++) {
        for (int j=0;j<k;j++) {
            if (!used[i][j]) return false;
            used[i][j]=false;
        }
    }
    return true;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    string s;
    cin >> n >> m;
    for (int i=0;i<n;i++) {
        cin >> s;
        int k=0;
        for (int j=0;j<2*m;j+=2,k++) a[i][k]=(s[j]-33)*100+(s[j+1]-33);
    }
    int ans=0;
    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) {
            for (int k=0;k<MAXNUM;k++) ma[k]=-1;
            for (int k=1;i+k-1<n && j+k-1<m;k++) {
                if (check(i,j,k)) ans++;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
