#include<bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int MAXN = 2e3 + 5;

int n, m;
pair<char, char> newtb[MAXN][MAXN];
int tb[MAXN][MAXN];
int lastrow[MAXN][MAXN];
int lastcol[MAXN][MAXN];

void precalc() {
	for (int i = 0; i < n; ++i) {
		vector<int> have(n * m + 1, -1);
		for (int j = 0; j < m; ++j) {
			lastrow[i][j] = have[tb[i][j]];
			have[tb[i][j]] = j;
		}
	} 
	for (int j = 0; j < m; ++j) {
		vector<int> have(n * m + 1, -1);
		for (int i = 0; i < n; ++i) {
			;lastcol[i][j] = have[tb[i][j]];
			have[tb[i][j]] = i;
		}
	}
}

void solve() {
	precalc();
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			vector<bool> have(n * m + 1);
			int dif = 0;
			for (int sz = 1; sz < min(n, m); ++sz) {
				int newi = i + sz - 1, newj = j + sz - 1;
				if (newi >= n || newj >= m) break;
				bool ok = true;
				for (int curj = j; curj <= newj; ++curj) {
					if (lastcol[newi][curj] >= i) ok = false;
					if (!have[tb[newi][curj]]) {
						have[tb[newi][curj]] = true;
						++dif;
					}
				}
				for (int curi = i; curi <= newi; ++curi) {
					if (lastrow[curi][newj] >= j) ok = false;
					int col = tb[curi][newj];
					if (!have[col]) {
						have[col] = true;
						++dif;
					}
				}
				if (!ok) break;
				if (dif == sz) {
					//cout << "good: " << i << ' ' << j << ' ' << sz << endl;
					++ans;
				}
			}	
		}
	}
	cout << ans << endl;
}	

int main() {	
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	vector<pair<char, char>> renum;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char one, two;  
			cin >> one >> two;
			newtb[i][j] = {one, two};
			renum.push_back({one, two});
		}
	}
	sort(renum.begin(), renum.end());
	renum.resize(int(unique(renum.begin(), renum.end()) - renum.begin()));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			int ind = int(lower_bound(renum.begin(), renum.end(), newtb[i][j]) - renum.begin());
			tb[i][j] = ind;
		}
	} 
	solve();
	return 0;
}