#include <bits/stdc++.h>

using namespace std;

pair<char, char> a[2000][2000];

int n, m;

bool check(int s1, int s2, int len) {
    set<pair<char, char>> cnt;
    vector<set<pair<char, char>>> cnt1(len), cnt2(len);
    for (int i = s1; i < s1 + len; i++) {
        for (int j = s2; j < s2 + len; j++) {
            cnt.insert(a[i][j]);
            cnt1[i - s1].insert(a[i][j]);
            cnt2[j - s2].insert(a[i][j]);
        }
    }
    if (cnt.size() != len)
        return 0;
    for (int i = 0; i < len; i++) {
        if (cnt1[i].size() != len || cnt2[i].size() != len)
            return 0;
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j].first >> a[i][j].second;
    int ans = 0;
    for (int s1 = 0; s1 < n; s1++) {
        for (int s2 = 0; s2 < m; s2++) {
            for (int len = 1; len <= min(n - s1, m - s2); len++) {
                if (check(s1, s2, len))
                    ans++;
            }
        }
    }
    cout << ans;
}

