#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma GCC optimize ("Ofast")

#define ll long long

using namespace std;

int n, m;
vector < vector <string >> t;

int build (int i, int j) {
    int res = 1;
    int c = 1;
    set <string> A;
    vector < set <string> > W(1, set <string>());
    vector < set <string> > H(1, set <string>());
    A.insert(t[i][j]);
    W[0].insert(t[i][j]);
    H[0].insert(t[i][j]);
    while (i + c < n && j + c < m) {
        for (int q = 0; q < c; q ++) {
            W[q].insert(t[i + q][j + c]);
            A.insert(t[i + q][j + c]);
        }
        W.emplace_back(set <string>());
        for (int q = 0; q <= c; q ++) {
            W[c].insert(t[i + c][j + q]);
            A.insert(t[i + c][j + q]);
        }
        for (int q = 0; q < c; q ++) {
            H[q].insert(t[i + c][j + q]);
            A.insert(t[i + c][j + q]);
        }
        H.emplace_back(set < string >());
        for (int q = 0; q <= c; q ++) {
            H[c].insert(t[i + q][j + c]);
            A.insert(t[i + q][j + c]);
        }
        c ++;
        for (int i = 0; i < c; i ++) {
            if (W[i].size() != c || H[i].size() != c) {
                return res;
            }
        }
        if (A.size() > max(n - i, m - j)) {
            return res;
        }
        if (A.size() == c) {
            res ++;
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    string s, s1;
    s1 = "";
    t = vector < vector < string >>(n, vector <string>());
    for (int i = 0; i < n; i ++) {
        cin >> s;
        for (int j = 0; j < m; j ++) {
            s1 += s[2 * j];
            s1 += s[2 * j + 1];
            t[i].emplace_back(s1);
            s1 = "";
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            ans += build(i, j);
        }
    }
    cout << ans;
    return 0;
}