#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 505;
int dng[N][N][N];

void gg(vector<int>& f) {

	sort(f.begin(), f.end());
	f.resize(unique(f.begin(), f.end()) - f.begin());
}

int s1(int n, int m, vector<vector<int>> a) {
	int ans = 0;
	for (int len = 1; len <= min(n, m); ++len) {
		for (int i = n - 1; i >= 0; --i) {
			//set<int> f, s;
			for (int j = 0; j + len - 1 < n; ++j) {
				
				vector<int> f, s;
				for (int psj = j; psj <= j + len - 1; ++psj) {
					f.push_back(a[i][psj]);
					if (i < n - 1)
						s.push_back(a[i + 1][psj]);
				}
				gg(f);
				gg(s);
				if (f.size() != len) {
					dng[i][j][len] = 0;
				} else if (f != s) {
					dng[i][j][len] = 1;
				} else {
					dng[i][j][len] = dng[i + 1][j][len] + 1;
				}
			}
		}
	}

	for (int len = 2; len <= min(n, m); ++len) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (dng[i][j][len] >= len)
					++ans;
			}
		}
	}
	return ans;
}

signed main() {
	warp();
	int n, m;
	cin >> n >> m;

	vector<string> s;

	s.resize(n);
	for (string& i : s) {
		cin >> i;
	}
	if (n <= 500 && m <= 500) {
		vector<vector<int>> a(n, vector<int>(m)),
			b(n, vector<int>(m - 1));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < 2 * m; j += 2)
				a[i][j / 2] = (s[i][j] * 1000 + s[i][j + 1]);
			for (int j = 1; j < 2 * m - 1; j += 2) {
				b[i][j / 2] = (s[i][j] * 1000 + s[i][j + 1]);
			}
		}
		cout << s1(n, m, a)+ s1(n, m - 1, b) + n * m;
	} else {

	}
}