#include<iostream>
#include<ctime>
#include<random>

using namespace std;

#define int long long

mt19937_64 rnd(time(NULL));

int a[2000+5][2000+5];

unsigned long long Zobrist[20000+5];

int c1[2000+5][2000+5];

int c2[2000+5][2000+5];

int c[20000+5];

vector<unsigned long long> h[500+5][500+5];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for (int i=1; i<=n; i++)
    {
        string s;
        cin>>s;
        for (int j=0; j<m*2; j+=2)
        {
            //if (s[j]>s[j+1]) swap(s[j],s[j+1]);
            a[i][j/2+1]=(s[j]-33)*100+(s[j+1]-33)+1;
        }
    }
    for (int i=1; i<=20000; i++)
    {
        Zobrist[i]=rnd();
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            for (int k=j; k<=m; k++)
            {
               if (c[a[i][k]]==0) c1[i][j]=k;
               else break;
            }
            for (int k=j; k<=m; k++)
            {
               c[a[i][k]]=0;
            }
        }
    }
    for (int i=1; i<=m; i++)
    {
        for (int j=1; j<=n; j++)
        {
            for (int k=j; k<=n; k++)
            {
               if (c[a[k][i]]==0) c2[j][i]=k;
               else break;
            }
            for (int k=j; k<=n; k++)
            {
               c[a[k][i]]=0;
            }
        }
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            unsigned long long H=0;
            h[i][j].resize(m-j+1);
            for (int k=j; k<=m; k++)
            {
                H^=Zobrist[a[i][k]];
                h[i][j][k-j]=H;
            }
        }
    }
    int ans=n*m;
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            for (int d=2; d<=max(n,m); d++)
            {
                if (i+d-1>n||j+d-1>m) break;
                if (c1[i][j]<j+d-1) break;
                if (c2[i][j]<i+d-1) break;
                bool can=true;
                for (int k1=i+1; k1<=i+d-1; k1++)
                {
                    if (h[k1][j][d-1]!=h[k1-1][j][d-1])
                    {
                        can=false;
                        break;
                    }
                }
                if (can)
                {
                    ans++;
                }
            }
        }
    }
    cout<<ans;
}
