#include <iostream>
#include <cstdint>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstring>

int main() {
    int32_t n, m;
    std::cin >> n >> m;

    int32_t** table = new int32_t*[n];
    int32_t** max_right = new int32_t*[n];
    int32_t** max_down = new int32_t*[n];
    for(int32_t i = 0 ; i < n; i++) {
        table[i] = new int32_t[m];
        max_down[i] = new int32_t[m];
        max_right[i] = new int32_t[m];
        std::string str;
        std::cin >> str;
        for(int32_t j = 0 ; j < 2 * m; j+=2) {
            table[i][j / 2] = (int32_t)str[j] * 1000 + str[j + 1];
        }
    }

    for(int32_t i = 0 ; i < n; i++)
        for(int32_t j = 0 ; j < m; j++) {
            max_down[i][j] = 1;
            max_right[i][j] = 1;
            std::set<int32_t> unique;
            for(int32_t k = i; k < n; k++) {
                if(unique.find(table[k][j]) == unique.end()) {
                    max_down[i][j] = k - i + 1;
                    unique.insert(table[k][j]);
                }
                else {
                    break;
                }
            }
            unique.clear();
            for(int32_t k = j; k < m; k++) {
                if(unique.find(table[i][k]) == unique.end()) {
                    max_right[i][j] = k - j + 1;
                    unique.insert(table[i][k]);
                }
                else {
                    break;
                }
            }

        }

    std::vector<int32_t>** sorted_down = new std::vector<int32_t>*[500];
    for(int32_t i = 0; i < n; i++) {
        sorted_down[i] = new std::vector<int32_t>[m];
        for(int32_t j = 0; j < m; j++) {
            for (int32_t k = 0; k < n; k++)
                sorted_down[i][j].push_back(table[k][j]);
            std::sort(sorted_down[i][j].begin(), sorted_down[i][j].end());
        }
    }

    int32_t answer = 0;
    for(int32_t i = 0 ; i < n; i++)
        for(int32_t j = 0 ; j < m; j++) {
            int32_t right = INT32_MAX;
            int32_t down = INT32_MAX;
            for(int32_t k = i ; k < n; k++) {
                int32_t p = j + (k - i);
                if(p >= m)
                    continue;

                right = std::min(right, max_right[k][j]);
                down = std::min(down, max_down[i][p]);

                if(down >= k - i + 1 && right >= k - i + 1) {
                    //check different
                    bool ok = true;
                    for(int32_t x = j; x <= p; x++)
                        for(int32_t y = 0; y < k - i + 1; y++)
                            if(sorted_down[i][j][y] != sorted_down[i][x][y]) {
                                ok = false;
                                break;
                            }

                    if(ok) {
                        answer++;
                    }
                }
            }
        }


    std::cout << answer;
    return 0;
}