#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

//#define int ll

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define sz(a) (int)a.size()

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<double> vd;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int INF = 1e9;
const ll INFLL = 1e18;
//const int M = 1e9 + 7;

const int N = 2005;
int mat[N][N];
int pr_row[N][N], pr_col[N][N];
int tmp[10000];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

//    memset(pr_row, 255, sizeof(pr_row));
//    memset(pr_col, 255, sizeof(pr_col));

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            char x, y;
            cin >> x >> y;
            mat[i][j] = ((x - 33) * (127 - 33) + (y - 33));
        }

    for (int i = 0; i < n; ++i) {
        memset(tmp, 255, sizeof(tmp));
        for (int j = 0; j < m; ++j) {
            pr_row[i][j] = tmp[mat[i][j]];
            tmp[mat[i][j]] = j;
        }
    }
    for (int j = 0; j < m; ++j) {
        memset(tmp, 255, sizeof(tmp));
        for (int i = 0; i < n; ++i) {
            pr_col[i][j] = tmp[mat[i][j]];
            tmp[mat[i][j]] = i;
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool mask[10000];
            memset(mask, 0, sizeof(mask));
            int cnt = 0;
            int min_row = -1, min_col = -1;
            for (int k = 0; k <= min(i, j); ++k) {
                for (int f = 0; f <= k; ++f) {
                    min_row = max(min_row, pr_row[i - k][j - f]);
                    min_row = max(min_row, pr_row[i - f][j - k]);
                    min_col = max(min_col, pr_col[i - k][j - f]);
                    min_col = max(min_col, pr_col[i - f][j - k]);
                }
                if (j - k <= min_row || i - k <= min_col)
                    break;
                for (int f = 0; f <= k; ++f) {
                    if (!mask[mat[i - k][j - f]])
                        ++cnt;
                    mask[mat[i - k][j - f]] = true;
                    if (!mask[mat[i - f][j - k]])
                        ++cnt;
                    mask[mat[i - f][j - k]] = true;
                }
                if (cnt == k + 1) {
                    ++ans;
//                    if (k)
//                        cout << i + 1 << " " << j + 1 << " " << k + 1 << "\n";
                }
            }
        }
    }

    cout << ans;
}