#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

#define int int64_t

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int> > ar(n, vector<int>());
	char c = 33;
	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j)
		{
			ar[i].push_back((s[2 * j] - ' ') * 97 + (s[2 * j + 1] - ' '));
		}
	}
	vector<vector<int> > hashh(n, vector<int>(m + 1, 0));
	vector<vector<int> > hashh2(m, vector<int>(n + 1, 0));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			hashh[i][j] = hashh[i][j - 1] + int((1 << ar[i][j - 1]));
		}
	}
	for (int j = 0; j < m; ++j)
	{
		for (int i = 1; i <= n; ++i)
		{
			hashh2[j][i] = hashh2[j][i - 1] + int((1 << ar[i - 1][j]));
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			for (int k = 1; k <= min(n - i, m - j); ++k)
			{
				int normhash = hashh2[j][i + k] - hashh2[j][i];
				int per = 0;
				for (int q = i; q < i + k; ++q)
				{
					if (hashh[q][j + k] - hashh[q][j] != normhash){
						per = 1;
						break;
					}
				}
				if (per == 1)
					continue;
				for (int q = j; q < j + k; ++q)
				{
					if (hashh2[q][i + k] - hashh2[q][i] != normhash){
						per = 1;
						break;
					}
				}
				if (per == 0)
					ans++;
			}
		}
	}
	cout << ans << endl;
}
