#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
const int MAXN = 2007;
int a[MAXN][MAXN];
int f[MAXN][MAXN];
int ml[MAXN][MAXN];
int md[MAXN][MAXN];
int ok[MAXN], ok2[MAXN];
int v[MAXN];
int check(int i, int j, int k) {
	set<int> s;
	for (int x = 0; x < k; ++x) {
		set<int> s1, s2;
		for (int y = 0; y < k; ++y)
			s.insert(a[x + i][y + j]), s1.insert(a[x + i][y + j]), s2.insert(a[y + i][x + j]);
		if (s1.size() != k || s2.size() != k)
			return 0;
	}
	return s.size() == k;
}
void solve() {
	mt19937_64 rnd(13456136);
	map<int, int> op;
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			char x;
			cin >> x;
			char y;
			cin >> y;
			int c = (int)x * 1000 + (int)y;
			if (!op.count(c))
				op[c] = rnd();
			a[i + 1][j + 1] = op[c];
			f[i + 1][j + 1] = a[i + 1][j + 1] ^ f[i][j + 1];
		}
	for (int i = 1; i <= n; ++i) {
		map<int, int> last;
		for (int j = 1; j <= m; ++j) {
			ml[i][j] = min(ml[i][j - 1] + 1, j - last[a[i][j]]);
			last[a[i][j]] = j;
		}
	}
	for (int i = 1; i <= m; ++i) {
		map<int, int> last;
		for (int j = 1; j <= n; ++j) {
			md[j][i] = min(md[j - 1][i] + 1, j - last[a[i][j]]);
			last[a[j][i]] = j;
		}
	}
	int ans = 0;
	for (int k = 1; k <= min(n, m); ++k) {
		for (int i = 1; i + k - 1 <= n; ++i) {
			for (int j = 1; j <= m; ++j)
				ok[j] = (md[i + k - 1][j] >= k) + ok[j - 1];
			for (int j = 1; j <= m; ++j)
				v[j] = f[i - 1][j] ^ f[i + k - 1][j];
			for (int j = 1; j <= m; ++j)
				ok2[j] = (v[j] == v[j - 1]) + ok2[j - 1];
			for (int j = 1; j + k - 1 <= m; ++j) {
				bool ok1 = 1; 
				if (ok[j + k - 1] - ok[j - 1] != k)
					ok1 = 0;
				int mn = k;
				for (int p = i; p <= i + k - 1; ++p)
					mn = min(mn, ml[p][j + k - 1]);
				if (mn < k)
					ok1 = 0;
				if (k > 1 && (ok2[j + k - 1] - ok2[j] != k - 1))
					ok1 = 0;
				if (ok1 != check(i, j, k))
					exit(1);
				if (ok1)
					++ans;
			}
		}
	}
	cout << ans;
	return;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
signed main() {
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}