#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")


#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (X).rend()
ll mx(ll &a, ll &b) { return (a < b ? a = b : a); }
ll mn(ll &a, ll &b) { return (a > b ? a = b : a); }

pair<char, char> elem[100][100];
map<pair<char, char>, int> pref[100][100];

map<pair<char, char>, int> operator-(const map<pair<char, char>, int> &a, const map<pair<char, char>, int> &b) {
    map<pair<char, char>, int> ans = a;
    for(auto &i : b) ans[i.first] -= i.second;
    return ans;
}

map<pair<char, char>, int> operator+(const map<pair<char, char>, int> &a, const map<pair<char, char>, int> &b) {
    map<pair<char, char>, int> ans = a;
    for(auto &i : b) ans[i.first] += i.second;
    return ans;
}

int get_elements(int lx, int ly, int rx, int ry) {
    map<pair<char, char>, int> now = pref[rx][ry];
    if(ly != 0) now = now - pref[rx][ly - 1];
    if(lx != 0) now = now - pref[lx - 1][ry];
    if(ly != 0 && lx != 0) now = now + pref[lx - 1][ly - 1];
    ll ans = 0;
    for(auto &i : now) ans += i.second != 0;
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//freopen("input.txt", "r", stdin);
//freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++) for(int j =0 ;j  < m; j++) cin >> elem[i][j].first >> elem[i][j].second;
    int ans = 0;

    pref[0][0][elem[0][0]] = 1;
    for(int i = 1; i < m; i++) pref[0][i] = pref[0][i - 1], pref[0][i][elem[0][i]]++;
    for(int i = 1; i < n; i++) pref[i][0] = pref[i - 1][0], pref[i][0][elem[i][0]]++;
    for(int i = 1; i < n; i++) {
        for(int j = 1; j < m; j++) {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];
            pref[i][j][elem[i][j]]++;
        }
    }

    int cnt_for_row[n][m][m];
    for(auto &i : cnt_for_row) for(auto &j : i) for(auto &k : j) k = 0;
    for(int row = 0; row < n; row++) {
        for(int l = 0; l < m; l++) {
            set<pair<char, char>> elements;
            for(int r = l; r < m; r++) {
                elements.insert(elem[row][r]);
                cnt_for_row[row][l][r] = elements.size();
            }
        }
    }

    int cnt_for_col[m][n][n];
    for(auto &i : cnt_for_col) for(auto &j : i) for(auto &k : j) k = 0;
    for(int col = 0; col < m; col++) {
        for(int l = 0; l < n; l++) {
            set<pair<char, char>> elements;
            for(int r = l; r < n; r++) {
                elements.insert(elem[r][col]);
                cnt_for_col[col][l][r] = elements.size();
            }
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            ll shit = min(n - i, m - j);
            for(int k = 1; k <= shit; k++) {
                ll i1 = i + k - 1, j1 = j + k - 1;
                if(get_elements(i, j, i1, j1) != k) continue;
                bool first = true;
                for(int row = i; row <= i1; row++) first &= cnt_for_row[row][j][j1] == k;
                for(int col = j; col <= j1; col++) first &= cnt_for_col[col][i][i1] == k;
                ans += first;
            }
        }
    }

    cout << ans;
    return 0;
}