#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define _ <<' '<<

using namespace std;

mt19937 gen(time(0));

const int N = 5e5 + 7;
const int M = 1e9 + 7;

int n, m, x[505][505], sz[502][502][502];
string s[502];
bool r[502][502][502];
bool c[502][502][502];
int R[502][502][502];
int C[502][502][502];

struct my_s{
    int c = 0;
    int cnt[130*130];

    my_s(){memset(cnt, 0, sizeof(cnt));}

    void insert(int x){
        if (!cnt[x]) c++;
        cnt[x]++;
    }

    void erase(int x){
        cnt[x]--;
        if (!cnt[x]) c--;
    }

    int size(){
        return c;
    }
};

//int kol(int i, int j, int k){
//    int ret = 0;
//    for (int c = 33; c <= 126; c++) ret += (cnt(c, i, j, k));
//    return ret;
//}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n; i++)
    for (int j = 0; j < 2*m; j += 2){
        x[i][j/2] = ((int)s[i][j])*130 + ((int)s[i][j + 1]);
    }
    for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++){
        my_s rr, cc;
        for (int l = 0; l < n + m; l++){
            if (i + l < n){
                rr.insert(x[i + l][j]);
                r[i][j][l] = (rr.size() == l + 1);
            }
            if (j + l < m){
                cc.insert(x[i][j + l]);
                c[i][j][l] = (cc.size() == l + 1);
            }
        }
    }
    for (int l = 0; l < min(n, m); l++)
    for (int i = 0; i < n; i++)
    for (int j = m - 1; j >= 0; j--){
        R[i][j][l] = r[i][j][l] + R[i][j + 1][l];
        if (j + l + 1 < m) R[i][j][l] -= r[i][j + l + 1][l];
    }
    for (int l = 0; l < min(n, m); l++)
    for (int j = 0; j < m; j++)
    for (int i = n - 1; i >= 0; i--){
        C[i][j][l] = c[i][j][l] + C[i + 1][j][l];
        if (i + l + 1 < n) C[i][j][l] -= c[i + l + 1][j][l];
    }
    for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++){
        my_s all;
        for (int l = 0; i + l < n && j + l < m; l++){
            for (int I = i; I <= i + l; I++) all.insert(x[I][j + l]);
            for (int J = j; J < j + l; J++) all.insert(x[i + l][J]);
            sz[i][j][l] = all.size();
        }
    }

    int res = 0;
    for (int l = 0; l < min(n, m); l++)
        for (int i = 0; i + l < n; i++)
            for (int j = 0; j + l < m; j++)
            if (sz[i][j][l] == l + 1) res += (C[i][j][l] == l + 1 && R[i][j][l] == l + 1);
    cout << res;
    return 0;
}
