#include <bits/stdc++.h>

using namespace std;

const int kN = 2007;
const int kMinAscii = 33;
const int kMaxAscii = 126;
const int kCntAscii = kMaxAscii - kMinAscii + 1;
const int kMaxNum = kCntAscii * kCntAscii;

short a[kN][kN];
int cnt[kMaxNum], pr[kMaxNum];
short next_down[kN][kN], next_right[kN][kN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m;
    cin >> n >> m;

    for(int i = 0; i < n; ++i){
        string s;
        cin >> s;
        for(int j = 0; j < 2 * m; j += 2)
            a[i][j / 2] = (s[j] - kMinAscii) * kCntAscii + (s[j + 1] - kMinAscii);
    }

    for(int i = 0; i < n; ++i){
        for(int j = m - 1; j >= 0; --j){
            if(pr[a[i][j]] == 0)
                next_right[i][j] = m;
            else
                next_right[i][j] = pr[a[i][j]];
            pr[a[i][j]] = j;
        }
        for(int j = m - 1; j >= 0; --j)
            pr[a[i][j]] = 0;
    }

    for(int j = 0; j < m; ++j){
        for(int i = n - 1; i >= 0; --i){
            if(pr[a[i][j]] == 0)
                next_down[i][j] = n;
            else
                next_down[i][j] = pr[a[i][j]];
            pr[a[i][j]] = i;
        }
        for(int i = n - 1; i >= 0; --i)
            pr[a[i][j]] = 0;
    }

    int ans = 0;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            for(int d = 0; i + d < n && j + d < m; ++d){
                int x = i + d, y = j + d, cnt_d = 0;
                for(int i2 = i; i2 <= x; ++i2){
                    for(int j2 = j; j2 <= y; ++j2){
                        ++cnt[a[i2][j2]];
                        if(cnt[a[i2][j2]] == d + 1)
                            ++cnt_d;
                    }
                }
                for(int i2 = i; i2 <= x; ++i2)
                    for(int j2 = j; j2 <= y; ++j2)
                        --cnt[a[i2][j2]];

                if(cnt_d != d + 1)
                    continue;

                bool ok = true;
                for(int i2 = i; i2 <= x && ok; ++i2){
                    if(next_right[i2][j] <= y){
                        ok = false;
                        break;
                    }
                }

                for(int j2 = j; j2 <= y && ok; ++j2){
                    if(next_down[i][j2] <= x){
                        ok = false;
                        break;
                    }
                }

                ans += ok;
                if(ok){
                    ++d;
                    d *= 2;
                    d -= 2;
                    continue;
                }
                else
                    break;
            }
        }
    }

    cout << ans << "\n";
}
