#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

bool operator==(set<int> &a, set<int> &b){
    if(a.size()!=b.size())
        return false;
    auto it = a.begin(), it1 = b.begin();
    while(it!=a.end()){
        if((*it)!=(*it1))
            return false;
        it++;
        it1++;
    }
    return true;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            char c, d;
            cin >> c >> d;
            int c1 = c-33, d1 = d-33;
            a[i][j] = (c*(126-33+1))+d;
            //cout << i << ':' << j << ' ' << a[i][j] << endl;
        }
    }
    vector<vector<vector<int> > > u(m, vector<vector<int> >(m, vector<int>(n, 0)));
    vector<vector<vector<bool> > > u1(m, vector<vector<bool> >(m, vector<bool>(n, false)));
    for(int y1 = 0; y1<m; y1++){
        vector<set<int> > rt(n);
        for(int y2 = y1; y2<m; y2++){
            for(int x = 0; x<n; x++){
                rt[x].insert(a[x][y2]);
                if(rt[x].size()==y2-y1+1)
                    u1[y1][y2][x] = true;
                if(x&&rt[x]==rt[x-1])
                    u[y1][y2][x] = u[y1][y2][x-1]+1;
            }
        }
    }
    vector<vector<vector<int> > > u2(n, vector<vector<int> >(n, vector<int>(m, 0)));
    vector<vector<vector<bool> > > u3(n, vector<vector<bool> >(n, vector<bool>(m, false)));
    for(int y1 = 0; y1<n; y1++){
        vector<set<int> > rt(m);
        for(int y2 = y1; y2<n; y2++){
            for(int x = 0; x<m; x++){
                rt[x].insert(a[y2][x]);
                if(rt[x].size()==y2-y1+1)
                    u3[y1][y2][x] = true;
                if(x&&rt[x]==rt[x-1])
                    u2[y1][y2][x] = u2[y1][y2][x]+1;
            }
        }
    }
    int ans = 0;
    for(int x = 0; x<n; x++){
        for(int y = 0; y<m; y++){
            for(int ln = 0; ln<=min(x, y); ln++){
                bool kek = true;
                if(!u1[y-ln][y][x])
                    continue;
                if(u[y-ln][y][x]<ln)
                    continue;
                if(!u3[x-ln][x][y])
                    continue;
                if(u2[x-ln][x][y]<ln)
                    continue;
                ans += kek;
            }
        }
    }
    cout << ans;

    return 0;
}
