#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 2000 + 5;

string a[N][N];
set<string> was[N][2];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);

	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= 2 * m; ++j) {
			char x;
			cin >> x;
			a[i][(j + 1) / 2] += x;
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			set<string> full;
			for (int x = 1; x <= max(n, m); ++x) {
				if (i - x + 1 < 1 || j - x + 1 < 1) break;
				bool ok = 1;
				for (int f = i - x + 1; f <= i; ++f) {
					full.insert(a[f][j - x + 1]);
					was[j - x + 1][0].insert(a[f][j - x + 1]);
					was[f][1].insert(a[f][j - x + 1]);
					if (f != i - x + 1)
						ok &= (was[f][1].size() == x);
				}
				for (int s = j - x + 1; s <= j; ++s) {
					full.insert(a[i - x + 1][s]);
					was[i - x + 1][1].insert(a[i - x + 1][s]);
					was[s][0].insert(a[i - x + 1][s]);
					if (s != j - x + 1)
						ok &= (was[s][0].size() == x);
				}
				ok &= (was[j - x + 1][0].size() == x);
				ok &= (was[i - x + 1][1].size() == x);
				ok &= full.size() == x;
				if (ok) ans++;
			}
			for (int x = 1; x <= max(n, m); ++x) {
				was[x][0].clear();
				was[x][1].clear();
			}
		}
	}
	cout << ans << endl;
}