#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

const int C = 1000;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, m; cin >> n >> m;
	char v1, v2;

	vector <vector <int>> a(n, vector <int>(m));
	FR(i, n) FR(j, m) cin >> v1 >> v2, a[i][j] = (v1 - '!' + 1) * C + (v2 - '!' + 1);

	int ans = 0;
	vector <int> dp(n + m);

	FR(L1, n) {
		FR(R1, m) {
		
			FOR(dlt, 0, min(n - L1, m - R1)){

				int L2 = L1 + dlt;
				int R2 = R1 + dlt;

				bool A = 1;
				FOR(x, R1, R2 + 1) {

						
					FOR(i, R1, R2 + 1) dp[i] = 0;

					FOR(i, L1, L2 + 1) FOR(j, R1, R2 + 1) if (a[i][j] == a[L1][x]) dp[j]++;
					FOR(i, R1, R2 + 1) if (dp[i] != 1) A = 0;


					FOR(i, L1, L2 + 1) dp[i] = 0;
					FOR(i, L1, L2 + 1) FOR(j, R1, R2 + 1) if (a[i][j] == a[L1][x]) dp[i]++;
					FOR(i, L1, L2 + 1) if (dp[i] != 1) A = 0;

					if (!A) break;
				}

				if (A)
					ans++;
			}
		}
	}

	cout << ans;

	return 0;
}