#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 2050;

int val[N][N], pR[N][N], pC[N][N], code[200000], ans = 0, n, m;
bool met[200000];

mt19937 rng(397);

void init() {
    for (int i = 0; i < 200000; i++) {
        code[i] = rng();
    }

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 2 * m; j += 2) {
            int x = (s[j] - 33) * 100 + (s[j + 1] - 33);
            val[i][j / 2] = x;
            pC[i][j / 2] = pR[i][j / 2] = code[val[i][j / 2]];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 1; j < m; j++) {
            pR[i][j] ^= pR[i][j - 1];
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 1; i < n; i++) {
            pC[i][j] ^= pC[i - 1][j];
        }
    }
}

bool valid(int x, int y) {
    return x < n && y < m;
}

inline int getHashRow(int x, int l, int r) {
    int res = pR[x][r];
    if (l > 0)
        res ^= pR[x][l - 1];
    return res;
}
inline int getHashCol(int x, int l, int r) {
    int res = pC[r][x];
    if (l > 0)
        res ^= pC[l - 1][x];
    return res;
}

inline bool check(int x1, int y1, int x2, int y2) {
    int hsh = getHashRow(x1, y1, y2);
    for (int i = x1; i <= x2; i++) {
        if (getHashRow(i, y1, y2) != hsh)
            return false;
    }
    for (int j = y1; j <= y2; j++) {
        if (getHashCol(j, x1, x2) != hsh)
            return false;
    }
    return true;
}

signed main()
{
    fast_io;

    init();

    for (int xs = 0; xs < n; xs++) {
        for (int ys = 0; ys < m; ys++) {
            int k = 0;
            for (; k < n; k++) {
                if (!valid(xs + k, ys + k) || met[val[xs][ys + k]])
                    break;
                met[val[xs][ys + k]] = true;
                if (check(xs, ys, xs + k, ys + k))
                    ans++;
            }
            k--;
            for (; k >= 0; k--)
                met[val[xs][ys + k]] = false;
        }
    }
    cout << ans;

    return 0;
}
