#include <bits/stdc++.h>

#define y1 kek

using namespace std;
typedef long long ll;

int ans;
string a[100][100];

void solve(int x, int y, int x1, int y1, int k) {
    unordered_map <string, int> cnt;

    int diff = 0;
    for(int i = x; i <= x1; i++) {
        for(int j = y; j <= y1; j++) {
            if (!cnt[a[i][j]]) {
                diff++;
            }
            cnt[a[i][j]]++;
        }
    }

    if (diff != k) {
        return;
    }

    for(int i = x; i <= x1; i++) {
        unordered_map <string, int> cnt;
        for(int j = y; j <= y1; j++) {
            if (cnt[a[i][j]]) {
                return;
            }

            cnt[a[i][j]]++;
        }
    }

    for(int j = y; j <= y1; j++) {
        unordered_map <string, int> cnt;
        for(int i = x; i <= x1; i++) {
            if (cnt[a[i][j]]) {
                return;
            }

            cnt[a[i][j]]++;
        }
    }

    ans++;
}


int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    char c, c1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> c >> c1;

            a[i][j].push_back(c);
            a[i][j].push_back(c1);
        }
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            for(int k = 1; k <= min(n - i, m - j); k++) {
                solve(i, j, i + k - 1, j + k - 1, k);
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
