#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;

typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int ans = 0;

void solve() {
    int n, m;
    cin >> n >> m;
    vector <string> mas(n);
    for(int i = 0; i < n; ++i) {
        cin >> mas[i];
    }
    vector < vector <int> > v(n, vector <int>(m, 0));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < 2 * m; j += 2) {
            v[i][j / 2] = mas[i][j] * 256 + mas[i][j + 1];
        }
    }
    for(int x = 0; x < n; ++x) {
        for(int y = 0; y < m; ++y) {
            for(int siz = 1; x + siz - 1 < n && y + siz - 1 < m; ++siz) {
                bool b = true;
                for (int i = 0; i < siz; ++i) {
                    set<int> val;
                    for (int j = 0; j < siz; ++j) {
                        val.insert(v[x + i][y + j]);
                    }
                    if (val.size() != siz) {
                        b = false;
                        break;
                    }
                }
                for(int i = 0; i < siz; ++i) {
                    set <int> val;
                    for(int j = 0; j < siz; ++j) {
                        val.insert(v[x + j][y + i]);
                    }
                    if(val.size() != siz) {
                        b = false;
                        break;
                    }
                }
                set <int> vval;
                for(int i = 0; i < siz; ++i) {
                    for(int j = 0; j < siz; ++j) {
                        vval.insert(v[i + x][j + y]);
                    }
                }
                if(vval.size() != siz) b = false;
                if(b) ans++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}