#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <bitset>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (ll) (x - 33) * 94 + (ll) (y - 33);
        }
    }
    ll o = 0;
    for (ll s = 1; s <= min(n, m); s++) {
        for (ll i = 0; i <= n - s; i++) {
            for (ll j = 0; j <= m - s; j++) {
                vector<ll> u(8836);
                for (ll x = i; x < i + s; x++) {
                    for (ll y = j; y < j + s; y++) {
                        u[a[x][y]]++;
                    }
                }
                if (count(u.begin(), u.end(), (ll) s) != s) {
                    continue;
                }
                bool f = false;
                for (ll x = i; x < i + s; x++) {
                    vector<ll> v(8836);
                    for (ll y = j; y < j + s; y++) {
                        v[a[x][y]]++;
                    }
                    if (count(v.begin(), v.end(), (ll) 1) != s) {
                        f = true;
                    }
                }
                if (f) {
                    continue;
                }
                for (ll y = j; y < j + s; y++) {
                    vector<ll> v(8836);
                    for (ll x = i; x < i + s; x++) {
                        v[a[x][y]]++;
                    }
                    if (count(v.begin(), v.end(), (ll) 1) != s) {
                        f = true;
                    }
                }
                if (f) {
                    continue;
                }
                o++;
            }
        }
    }
    cout << o << endl;
    return 0;
}
