#include <bits/stdc++.h>

#define y1 kek

#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-avx2")

using namespace std;
typedef long long ll;

int ans;
const int N = int(5e5);
string a[100][100];
unordered_map <string, int> cnt[N];
int stn;

void solve(int x, int y, int x1, int y1, int k) {
    stn++;

    int diff = 0;
    for(int i = x; i <= x1; i++) {
        for(int j = y; j <= y1; j++) {
            if (!cnt[stn][a[i][j]]) {
                diff++;
            }
            cnt[stn][a[i][j]]++;
        }
    }

    if (diff != k) {
        return;
    }

    stn++;
    for(int i = x; i <= x1; i++) {
        for(int j = y; j <= y1; j++) {
            if (cnt[stn][a[i][j]]) {
                return;
            }

            cnt[stn][a[i][j]]++;
        }
    }
    stn++;

    for(int j = y; j <= y1; j++) {
        for(int i = x; i <= x1; i++) {
            if (cnt[stn][a[i][j]]) {
                return;
            }

            cnt[stn][a[i][j]]++;
        }
    }

    ans++;
}


int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    char c, c1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> c >> c1;

            a[i][j].push_back(c);
            a[i][j].push_back(c1);
        }
    }

    int op = 0;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            for(int k = 1; k <= min(n - i, m - j); k++) {
                solve(i, j, i + k - 1, j + k - 1, k);
            }
        }
    }

    cout << ans << "\n";
    return 0;
}
