#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//#define TIME ((clock() - start_time) / CLOCKS_PER_SEC)

//using namespace __gnu_pbds;
using namespace std;


const int maxn = 101;
const int maxc = 93 * 93 + 2;

int c[maxn][maxn][maxc];

void upd(int i, int j, int t)
{
    if (i)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] += c[i - 1][j][k];
    }
    if (j)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] += c[i][j - 1][k];
    }
    if (i && j)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] -= c[i - 1][j - 1][k];
    }
    c[i][j][t]++;
}

int get(int x1, int y1, int x2, int y2)
{
    int cnt = 0;
    for (int i = 0; i < maxc; ++i)
    {
        int res = c[x2][y2][i];
        if (x1) res -= c[x1 - 1][y2][i];
        if (y1) res -= c[x2][y1 - 1][i];
        if (x1 && y1) res += c[x1 - 1][y1 - 1][i];
        if (res) ++cnt;
    }
    return cnt;
}

vector<pair<char, char>> co;
int idx(pair<char, char> x)
{
    return lower_bound(all(co), x) - co.begin();
}

pair<char, char> ftab[maxn][maxn];
int tab[maxn][maxn];

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char inx1, inx2;
            cin >> inx1 >> inx2;
            ftab[i][j] = {inx1, inx2};
            co.pb(ftab[i][j]);
        }
    }
    sort(all(co));
    co.erase(unique(all(co)), co.end());
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            tab[i][j] = idx(ftab[i][j]);
            upd(i, j, tab[i][j]);
        }
    }
    int ans = 0;
    for (int x1 = 0; x1 < n; ++x1)
    {
        for (int y1 = 0; y1 < m; ++y1)
        {
            ++ans;
            for (int k = 1; x1 + k < n && y1 + k < m; ++k)
            {
                set<int> s;
                bool flg = true;
                for (int r = x1; r <= x1 + k; ++r)
                {
                    set<int> sr;
                    for (int t = y1; t <= y1 + k; ++t)
                    {
                        sr.insert(tab[r][t]);
                        s.insert(tab[r][t]);
                    }
                    if (sz(sr) != k + 1)
                    {
                        flg = false;
                        break;
                    }
                }
                if (!flg) continue;
                for (int r = y1; r <= y1 + k; ++r)
                {
                    set<int> sr;
                    for (int t = x1; t <= x1 + k; ++t)
                    {
                        sr.insert(tab[t][r]);
                    }
                    if (sz(sr) != k + 1)
                    {
                        flg = false;
                        break;
                    }
                }
                if (!flg) continue;
                if (sz(s) == k + 1)
                {
                    ++ans;
                    //break;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
