#pragma optimization_level 3
#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define F first
#define S second
#define vec vector
#define pb push_back
#define pll pair<ll, ll>
#define uset unordered_set
#define umap unordered_map
#define pii pair<int, int>
#define pnn pair<Node*, Node*>
#define uid uniform_int_distribution
#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
using namespace std;
typedef string str;
typedef long long ll;
typedef long double ld;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void prM(vec<vec<int>> &m){
    for(auto i : m){
        for(int u : i) cout<<u<<" ";
        cout<<"\n";
    }
    cout<<endl;
}

const int G = 94*94, I = 2001;
ll o = 0;
int a,b, m[I][I], rg[I][I], dw[I][I], MX[I][I];
ll pnr[I][I], pnd[I][I], cng[G];
vec<pii> num1[G], num2[G];

int nxt_in_row(int num, pii p){
    int l = -1, r = num1[num].size();
    for(; l+1<r;){
        int md = (l+r)/2;
        if(num1[num][md] <= p) l = md;
        else r = md;
    }
    return r==num1[num].size() || num1[num][r].F!=p.F ? -1 : num1[num][r].S-p.S;
}

int nxt_in_col(int num, pii p){
    int l = -1, r = num2[num].size();
    for(; l+1<r;){
        int md = (l+r)/2;
        if(num2[num][md] <= p) l = md;
        else r = md;
    }
    return r==num2[num].size() || num2[num][r].F!=p.F ? -1 : num2[num][r].S-p.S;
}

void calc(){
    for(int q=0; q<a; q++){
        rg[q][b-1] = 1;
        for(int w=b-2; w>=0; w--){
            int X = nxt_in_row(m[q][w], {q,w});
            if(X==-1) rg[q][w] = rg[q][w+1]+1;
            else rg[q][w] = min(rg[q][w+1]+1, X);
        }
    }
    for(int w=0; w<b; w++){
        dw[a-1][w] = 1;
        for(int q=a-2; q>=0; q--){
            int X = nxt_in_col(m[q][w], {w,q});
            if(X==-1) dw[q][w] = dw[q+1][w]+1;
            else dw[q][w] = min(dw[q+1][w]+1, X);
        }
    }
    for(int q=a-1; q>=0; q--){
        for(int w=b-1; w>=0; w--){
            MX[q][w] = min(dw[q][w], rg[q][w]);
            if(q+1<a && w+1<b) MX[q][w] = min({MX[q][w], MX[q+1][w]+1, MX[q][w+1]+1});
        }
    }
}

inline ll hsh_row(int x, int &l, int r){
    return pnr[x+1][r+1]^pnr[x+1][l];
}

inline ll hsh_col(int y, int &l, int r){
    return pnd[r+1][y+1]^pnd[l][y+1];
}

int main() {
    fast;
    uid<ll> gen(0, LONG_LONG_MAX);
    for(int q=0; q<G; q++) cng[q] = gen(rnd);
    cin>>a>>b;
    for(int q=0; q<a; q++){
        str t; cin>>t;
        for(int w=0; w<b; w++){
            m[q][w] = 94*(t[w*2]-33) + (t[w*2+1]-33);
            pnr[q+1][w+1] = pnd[q+1][w+1] = cng[m[q][w]];
            pnr[q+1][w+1] ^= pnr[q+1][w];
            pnd[q+1][w+1] ^= pnd[q][w+1];
            num1[m[q][w]].pb({q,w});
        }
    }
    for(int w=0; w<b; w++){
        for(int q=0; q<a; q++){
            num2[m[q][w]].pb({w,q});
        }
    }
    calc();
    o = a*b;
    ll HS;
    int fl, mx;
    for(int q=0; q<a; q++){
        for(int w=0; w<b; w++){
            mx = min(rg[q][w], dw[q][w]);
            for(int e=2; e<=mx; e++){
                mx = min({mx, rg[q+e-1][w], dw[q][w+e-1]});
                if(e>mx) break;
                fl = 1;
                HS = hsh_row(q, w, w+e-1);
                for(int i=0; i<min(e, 100) && fl; i++){
                    fl &= HS==hsh_row(q+i, w, w+e-1);
                    fl &= HS==hsh_col(w+i, q, q+e-1);
                }
                if(fl){
                    for(int i = e*2-1; e<i && e<mx; e++){
                        mx = min({mx, rg[q+e-1][w], dw[q][w+e-1]});
                    }
                    o++;
                }
            }
        }
    }
    cout<<o;
}