#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <deque>

#define INF 0x3f3f3f3f


using namespace std;

#define all(c) c.begin(), c.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;


template<typename T>
istream &operator>>(istream &is, vector<T> &vector_input) {
    for (int i = 0; i < vector_input.size(); ++i)
        is >> vector_input[i];
    return is;
}

vector<vector<string>> v;

bool check(int x1, int y1, int k) {
    set<string> s;
    for (int i = x1; i < x1 + k; ++i)
        for (int j = y1; j < y1 + k; ++j)
            s.insert(v[i][j]);
    if (s.size() != k)
        return false;
    for (int i = x1; i < x1 + k; ++i) {
        set<string> cur;
        for (int j = y1; j < y1 + k; ++j)
            cur.insert(v[i][j]);
        if (cur.size() != k)
            return false;
    }
    for (int j = y1; j < y1 + k; ++j) {
        set<string> cur;
        for (int i = x1; i < x1 + k; ++i)
            cur.insert(v[i][j]);
        if (cur.size() != k)
            return false;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    v.resize(n, vector<string>(m));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < 2 * m; j += 2) {
            v[i][j / 2] += s[j];
            v[i][j / 2] += s[j + 1];
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            for (int k = 1; k + i <= n && k + j <= m; ++k)
                if (check(i, j, k))
                    ++ans;
    cout << ans;
}
