#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()

vector<vector<int>> read(int n, int m) {
    vector<string> al;
    vector<vector<string>> cur(n, vector<string> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char x, y;
            cin >>x  >> y;
            string s;
            s += x;
            s += y;
            al.emplace_back(s);
            cur[i][j] = s;
        }
    }
    sort(all(al));
    al.erase(unique(all(al)), al.end());
    vector<vector<int>> v(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            v[i][j] = lower_bound(all(al), cur[i][j]) - al.begin();
        }
    }
    return v;
}

bool check(int x, int y, int len, vector<vector<int>> &a) {
    set<int> al;
    for (int i = x; i <= x + len; ++i) {
        for (int j = y; j <= y + len; ++j) {
            al.insert(a[i][j]);
        }
    }
    if (al.size() != len + 1) {
        return false;
    }
    for (int i = x; i <= x + len; ++i) {
        set<int> cur;
        for (int j = y; j <= y + len; ++j) {
            cur.insert(a[i][j]);
        }
        if (cur != al) {
            return false;
        }
    }
    for (int j = y; j <= y + len; ++j) {
        set<int> cur;
        for (int i = x; i <= x + len; ++i) {
            cur.insert(a[i][j]);
        }
        if (cur != al) {
            return false;
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a = read(n, m);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int len = min(n - i - 1, m - j - 1);
            ++ans;
            bool st = false;
            for (; len >= 1; --len) {
                if (check(i, j, len, a)) {
                    ++ans;
                    st = true;
                } else if (st) {
                    break;
                }
            }
        }
    }
    cout << ans;
}