#include <iostream>
#include <unordered_set>
#include <set>
#define endl '\n'

using namespace std;

const int MAXN = 2e3;
const int MAXM = 2e3;
const int mod = 1e9 + 7;
const int pw = 97;
int n, m;
long long p[MAXN+10][MAXM+10];
//int hr[MAXN+10][MAXM+10], hc[MAXN+10][MAXM+10];
//int ppow[MAXN+10];
long long cnt = 0;

void input()
{
    char t1, t2;
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            cin>>t1>>t2;
            p[i][j] = t1*pw+t2;
        }
    }
}

void output()
{
    cout<<cnt<<endl;
}

bool comp(const set<int> &s1, const set<int> &s2)
{
    if (s1.size() != s2.size()) return 0;

    auto id1 = s1.begin();
    auto id2 = s2.begin();
    while (id1 != s1.end())
    {
        if (*id1 != *id2) return 0;
        id1++; id2++;
    }
    return 1;
}

void solve()
{
    cnt = n*m;
    for (int z=2; z<=min(n, m); z++)
    {
        for (int i=0; i+z<=n; i++)
        {
            for (int j=0; j+z<=m; j++)
            {
                bool ch = 1;
                int siz = 0;
                set<int> s2;

                for (int pj = j; pj<z+j; pj++)
                {
                    s2.insert(p[i][pj]);
                    if (siz == s2.size())
                    {
                        ch = 0;
                        break;
                    }
                    siz++;
                }
                if (!ch) continue;

                for (int pi = i+1; pi<z+i; pi++)
                {
                    siz = 0;
                    set<int> s;
                    for (int pj = j; pj<z+j; pj++)
                    {
                        s.insert(p[pi][pj]);
                        if (s.size() == siz)
                        {
                            ch = 0;
                            break;
                        }
                        siz++;
                    }
                    if (!ch || !comp(s2, s))
                    {
                        ch = 0;
                        break;
                    }
                }
                if (!ch) continue;

                for (int pj = j; pj<z+j; pj++)
                {
                    siz = 0;
                    set<int> s;
                    for (int pi = i; pi<z+i; pi++)
                    {

                        s.insert(p[pi][pj]);
                        if (s.size() == siz)
                        {
                            ch = 0;
                            break;
                        }
                        siz++;
                    }
                    if (!ch || !comp(s, s2))
                    {
                        ch = 0;
                        break;
                    }
                }
                if (ch) cnt++;
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}


