#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define right right228
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    int *t;
    int default_value = 0;
    int n;

    int merge(int a, int b) {
        return a + b;
    }

private:
    void build(int v, int l, int r, int *arr) {
        if (r == l + 1) {
            t[v] = arr[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, arr);
        build(v * 2 + 1, m, r, arr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (r == l + 1) {
            t[v] = pos;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int al, int ar) {
        if (al <= l && r <= ar) {
            return t[v];
        }
        if (ar <= l || r <= al) {
            return default_value;
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, al, ar),
                     get(v * 2 + 1, m, r, al, ar));
    }

public:
    DO(int n, int *arr) : n(n) {
        t = new int[4 * n];
        build(1, 0, n, arr);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

};


int calc_hash(char a, char b) {
    return a * 128 + b;
}
#define set unordered_set
#define map unordered_map
#define INF 10000
#define MAX_HASH (128*128)

void smart_erase(map<int, int> &mp, int x, int d = 1) {
    mp[x] -= d;
    if (mp[x] == 0) {
        mp.erase(x);
    }
}
#define MAXN 503
int data[MAXN][MAXN];
int right[MAXN][MAXN];
int down[MAXN][MAXN];
int mx_squre[MAXN][MAXN];
map<int, int> all_hashs[MAXN];
map<int, int> cur_hash;
set<int> cur;
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            data[i][j] = calc_hash(s[j * 2], s[j * 2 + 1]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cur.clear();
            for (int k = j; k < m; ++k) {
                if (cur.count(data[i][k]) != 0) {
                    break;
                }
                cur.insert(data[i][k]);
            }
            right[i][j] = cur.size();
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cur.clear();
            for (int k = i; k < n; ++k) {
                if (cur.count(data[k][j]) != 0) {
                    break;
                }
                cur.insert(data[k][j]);
            }
            down[i][j] = cur.size();
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int mn = INF;
            int ans = 0;
            for (int k = 0; i + k < n && j + k < m; ++k) {
                mn = min(mn, down[i][j + k]);
                mn = min(mn, right[i + k][j]);
                if (mn <= k) {
                    break;
                }
                ans++;
            }
            mx_squre[i][j] = ans;
        }
    }

    int ans = 0;
    for (int len = 1; len <= min(n, m); ++len) {

        for (int i = 0; i < m; ++i) {
            all_hashs[i].clear();
            for (int j = 0; j < len; ++j) {
                all_hashs[i][data[j][i]]++;
            }
        }
        for (int up = 0; up <= n - len; ++up) {
            cur_hash.clear();
            for (int j = 0; j < len; ++j) {
                for (auto e:all_hashs[j]) {
                    cur_hash[e.first] += e.second;
                }
            }
            for (int left = 0; left <= m - len; ++left) {
                if (cur_hash.size() == len && mx_squre[up][left] >= len) {
                    ans++;
                }
                for (auto e:all_hashs[left]) {
                    smart_erase(cur_hash, e.first, e.second);
                }
                if (left != m - len) {
                    for (auto e:all_hashs[left + len]) {
                        cur_hash[e.first] += e.second;
                    }
                }
            }

            for (int i = 0; i < m; ++i) {
                smart_erase(all_hashs[i], data[up][i]);
            }
            if (up != n - len) {
                for (int i = 0; i < m; ++i) {
                    all_hashs[i][data[up + len][i]]++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}