#include <bits/stdc++.h>
#define int long long 

#define ff first 
#define ss second 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()

#define TIME (ld)clock() / CLOCKS_PER_SEC
#define debug(x) cout << #x << ": " << x << endl; 

using namespace std; 
mt19937 rnd(2007); 
typedef long long ll; 
typedef long double ld;
typedef pair<int, int> pii; 
const int maxn = 500 + 7, mod = 1e9 + 7, MAXN = 1e4 + 7; 
const ll inf = 1e18; 
int n, m;
int a[maxn][maxn];         
int row[maxn][MAXN];
int col[maxn][MAXN]; 
int have[MAXN]; 
int dif = 0; 

bool check(int xx, int yy, int xx1, int yy1) {
    int len = xx1 - xx + 1; 
    if (xx1 >= n || yy1 >= m) return false; 
    set<int> ms; 
    for (int i = xx; i <= xx1; ++i) {
        set<int> ptr;
        for (int j = yy; j <= yy1; ++j) {
            if (ptr.count(a[i][j])) return false;
            ptr.insert(a[i][j]); 
            ms.insert(a[i][j]); 
        }
    }
    for (int j = yy; j <= yy1; ++j) {
        set<int> ptr;
        for (int i = xx; i <= xx1; ++i) {
            if (ptr.count(a[i][j])) return false;
            ptr.insert(a[i][j]);
            ms.insert(a[i][j]);
        }
    }
    if (ms.size() != len) return false;
    return true; 
}                            

void add_col(int x, int st, int len) {
    for (int i = 0; i < len; ++i) {
        int val = a[st + i][x]; 
//        cout << st + i << " " << x << endl; 
        if (have[val] == 0) {
            ++dif; 
            have[val] = 1; 
        }
        if (row[st + i][val]) {
            dif = inf; 
            return; 
        }
        row[st + i][val] = 1; 
        if (col[x][val]) {
            dif = inf; 
            return; 
        }
        col[x][val] = 1;          
    }
}

void add_row(int x, int st, int len) {
    for (int i = 0; i < len; ++i) {
        int val = a[x][st + i];
        if (have[val] == 0) {
            ++dif; 
            have[val] = 1; 
        }
        if (col[st + i][val]) {
            dif = inf;   
            return; 
        }
        col[st + i][val] = 1; 
        if (row[x][val] == 1) {
            dif = inf; 
            return; 
        }
        row[x][val] = 1;         
    }
}

void add_el(int i, int j) {
    int val = a[i][j]; 
    if (have[val] == 0) {
        ++dif; 
        have[val] = 1; 
    }
    if (row[i][val]) {
        dif = inf; 
        return; 
    }
    if (col[j][val]) {
        dif = inf;  
        return; 
    }
    row[i][val] = 1; 
    col[j][val] = 1; 
}


void clear(int i1, int j1) {
    dif = 0; 
    for (int i = i1; i < n; ++i) {
        for (int j = j1; j < m; ++j) {
            have[a[i][j]] = 0; 
            col[j][a[i][j]] = 0;
            row[i][a[i][j]] = 0; 
        }
    }
}



void solve() {
    cin >> n >> m; 
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2 * m; j += 2) {
            char aa, bb; cin >> aa >> bb; 
            int a1 = aa - 33;
            int b1 = bb - 33;  
            a[i][j / 2] = a1 * 100 + b1; 
        }
    }     
    int ans = 0; 
//    add_row(3, 0, 3); 
//    add_col(3, 0, 3); 
//    return; 
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int len = 0; len < min(n - i, m - j); ++len) {
                int i1 = i + len; 
                int j1 = j + len; 
                if (i1 >= n || j1 >= m) break;  
                add_row(i1, j, len); 
//                cout << "row:" << dif << endl; 
                add_col(j1, i, len); 
//                cout << "col: " << dif << endl; 
                add_el(i + len, j + len); 
//                cout << "el: " << dif << endl; 
//                cout << dif << endl; 
                if (dif == len + 1) {
                    ++ans;
                }
                /*
                if (dif == len + 1 && !check(i, j, i1, j1)) {
                    cout << dif << endl; 
                    cout << i << " " << j << " " << i1 << " " << j1 << endl; 
                    return; 
                    ++ans; 
                } */
                if (dif == inf) break; 
            }
            clear(i, j); 
        }                                  
    }
    cout << ans; 
}

signed main() {
#ifdef LOCAL 
  freopen("TASK.in", "  r", stdin); 
  freopen("TASK.out", "w", stdout); 
#endif 
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    int t = 1; 
    for (int i = 0; i < t; ++i) solve(); 
    return 0; 
}
