#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 2e3 + 5;
const int MAXA = 1e4;

int code(char x, char y)
{
    int cx = (int)x - 33, cy = (int)y - 33;
    return cx * 100 + cy;
}

int n, m;
int tab[N][N];
int have[MAXA], cool_els;

void add_el(int i, int j, int len)
{
    have[tab[i][j]]++;
    if(have[tab[i][j]] == 1)
        cool_els++;
}

void rmv_el(int i, int j)
{
    have[tab[i][j]]--;
    if(have[tab[i][j]] == 0)
        cool_els--;
}

void add_row(int x, int y, int len)
{
    for(int j = y; j < y + len; j++)
        add_el(x, j, len);
}

void rmv_row(int x, int y, int len)
{
    for(int j = y; j < y + len; j++)
        rmv_el(x, j);
}

void add_col(int x, int y, int len)
{
    for(int i = x; i < x + len; i++)
        add_el(i, y, len);

}

void rmv_col(int x, int y, int len)
{
    for(int i = x; i < x + len; i++)
        rmv_el(i, y);
}


bool good(int len)
{
    if(cool_els == len)
        return true;
    return false;
}

int right[N][N], down[N][N];
void calc_uniq()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            down[i][j] = down[i - 1][j];
        }
    }
}

int ans;
void solve(int len)
{
    memset(have, 0, sizeof(have));
    cool_els = 0;

    for(int i = 1; i <= len; i++)
        add_row(i, 1, len);

    ans += good(len);

    for(int i = 1; i + len - 1 <= n; i++)
    {
        if(i & 1)
        {
            for(int j = len + 1; j <= m; j++)
            {
                add_col(i, j, len);
                rmv_col(i, j - len, len);

                ans += good(len);
            }

            if(i + len - 1 < n)
            {
                add_row(i + len, m - len + 1, len);
                rmv_row(i, m - len + 1, len);

                ans += good(len);
            }

        }
        else
        {
            for(int j = m - len; j >= 1; j--)
            {
                add_col(i, j, len);
                rmv_col(i, j + len, len);

                ans += good(len);
            }

            if(i + len - 1 < n)
            {
                add_row(i + len, 1, len);
                rmv_row(i, 1, len);

                ans += good(len);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    char ch1, ch2;

    cin >> n >> m;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cin >> ch1 >> ch2;
            tab[i][j] = code(ch1, ch2);
        }
    }

//    for(int i = 1; i <= n; i++)
//    {
//        for(int j = 1; j <= m; j++)
//            cerr << tab[i][j] << " ";
//        cerr << endl;
//    }

    ans = n * m;
    for(int i = 2; i <= min(n, m); i++)
        solve(i);

    cout << ans << endl;

    return 0;
}

/*

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

*/
