#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

const int mod = 1e9 + 7;
int pri = 997;
const ld PI = acos(-1);

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}
const int N = 2020;
int s[N][N];
int uniq = 0;
	
int n, m;
       
int prv[2][N][N];

int lg[N];
int st[2][N][14][N];

int get_st (int op, int id, int l, int r) {
	int len = r - l + 1;
	len = lg[len];
	return max(st[op][id][len][l], st[op][id][len][r - (1 << len) + 1]);
}

void build () {
	for (int i = 2; i < N; ++i) lg[i] = lg[i/2] + 1;
	for (int i = 0; i < n; ++i) {
		unordered_map < int, int > lst;
		for (int j = 0; j < m; ++j) {
			if (!lst.count(s[i][j])) lst[s[i][j]] = -1;
			prv[0][i][j] = lst[s[i][j]];
//			cout << i << ' ' << j << ' ' << lst[s[i][j]] << ' ';
			lst[s[i][j]] = j; 
		}
//		cout << '\n';
	}
//	exit(0);
	

	for (int j = 0; j < m; j ++) {
		unordered_map < int, int > lst;
		
		for (int i = 0; i < n; i ++) {
			if (!lst.count(s[i][j])) lst[s[i][j]] = -1;
			prv[1][i][j] = lst[s[i][j]];
			lst[s[i][j]] = i;
		}
	}

	for (int i = 0; i < n; i ++) {
		for (int j = 0; j < m; ++j) {
			st[0][i][0][j] = prv[1][i][j]; 
		}

		for (int b = 1; b <= lg[m]; ++b) {
			for (int j = 0; j + (1 << b) <= m; ++j) {
				st[0][i][b][j] = max(st[0][i][b-1][j], st[0][i][b-1][j + (1 << (b - 1))]);
			}
		}
	}

	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; i ++) {
			st[1][j][0][i] = prv[0][i][j];
		}
		for (int b = 1; b <= lg[n]; ++b) {
			for (int i = 0; i + (1 << b) <= n; ++i) {
				st[1][j][b][i] = max(st[1][j][b-1][i], st[1][j][b-1][i + (1 << (b - 1))]);
			}
		}
	}
}


ll h[N][N];
ll id[N * N];

void add (int x, int i, int j) {
	if (i) h[i][j] += h[i-1][j];
	if (j) h[i][j] += h[i][j-1];

	if (i && j) h[i][j] -= h[i-1][j-1];

	h[i][j] += id[x];
	if(h[i][j] < 0) h[i][j] += mod;
	h[i][j] %= mod;
}


ll get (int x, int y) {
	if (x < 0) return 0;
	if (y < 0) return 0;
	return h[x][y];
}

ll get (int ax, int ay, int bx, int by) {
	ax--, ay--;
	return (get(ax, ay) + get(bx, by) - (get(ax, by) + get(bx, ay)) + 2ll * mod) % mod;
}


bool check (int n, int m, int k) {
	//return 1;
	if (m - get_st(1, m, n - k + 1, n) < k) return 0;
	if (n - get_st(0, n, m - k + 1, m) < k) return 0;

	ll res = get(n-k + 1, m-k + 1, n, m) % mod;
	ll dd = get(n - k + 1, m, n, m);
	//cout << n - k << ' ' << m << ' ' << n << ' ' << m - k << '\n';
	//cout << n << ' ' << m << ' ' << res << ' ' << dd << ' ' << (dd * k) % mod << '\n';
	if ((dd * k) % mod != res) return 0;
	dd = get(n, m- k + 1, n, m);
	if ((dd * k) % mod != res) return 0;
	
	return 1;
}

void show(int n, int m, int k) {
	
	cout << "here: \n";
	cout << n << ' ' << m << ' ' << k << '\n';
	cout << get_st(1, m, n - k + 1, n) << ' ' << get_st(0, n, m - k + 1, m) << '\n';
	exit(0); 
	ll res = get(n-k + 1, m-k + 1, n, m);
	ll dd = get(n-k+1, m, n, m);
	cout << n - k + 1 << ' ' << m - k + 1 << '\n';
	cout << h[n][m] << '\n';
	cout << dd << ' ' << res << '\n';
	exit(0); 
}

bool prime (int x) {
	if (x % 2 == 0) return 0;
	if (x <= 20) return 0;

	for (int i = 3; i * (ll)i <= x; i += 2) if (x % i == 0) {
		return 0;
	}

	return 1;
}

char c[N][N+N];

int main () {
	randomizer3000 ();
	scanf("%d %d", &n, &m);
	unordered_map < int, int > was;

	for (int i = 0; i < n; ++i) {
		scanf("%s", c[i]);
		for (int j = 0; j < 2 * m; j += 2) {
			int kak = c[i][j] * 130 + c[i][j+1];
			if (!was.count(kak)) was[kak] = ++uniq;

			s[i][j/2] = was[kak];
		}
	}

	//cout << rand() << ' ' << rand() << '\n';
	/*pri = rand() + 400;
	while(!prime(pri)) --pri;
	int mk = ((rand() << 10ll) + rand()) % mod;
	mk += pri;
	while(!prime(mk)) mk++;  */
	pri = 997;
	int mk = 1e9 + 7;

	id[0] = 1;
	for (int i = 1; i < N * N; ++i) {
		id[i] = (pri * (ll)id[i-1]) % mk;
	}

	For (i, 0, n-1) {
		For(j, 0, m-1) {
			add(s[i][j], i, j);
	//		cout << h[i][j] << '\n';
		}
	}

	

	build();

	int ans = n * m;
	for (int k = 2; k <= min(n, m); ++k) {
		for (int i = k - 1; i < n; ++i) {
			for (int j = k - 1; j < m; ++j) if (check(i, j, k)) { //check(i, j, k)
									
			//	cout << i << ' ' << j << ' ' << k << '\n';
				++ans;
				
			}
		}
	} 

	printf("%d", ans);
}
