#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}
signed main() {
	fast_io();
	int n, m;
	cin >> n >> m;
	vector<vector<string>> arr(n, vector<string>(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;

			string s;
			s.push_back(a);
			s.push_back(b);

			arr[i][j] = s;
		}
	}

	int ans = 0;
	int ans1 = 0;
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			vector<map<string, int>> arr1(n);
			vector<map<string, int>> arr2(m);
			int cnt = 0;
			map<string, int> arr3;
			bool good = true;
			for (int k = 1; k <= min(n, m); k++) {
				if (k + x > n || k + y > m) {
					continue;
				}
				for (int i = x; i < x + k; i++) {
					if (arr1[i][arr[i][y + k - 1]] != 0) {
						good = false;
						break;
					}
					if (arr3[arr[i][y + k - 1]] == 0) {
						cnt++;
					}
					arr3[arr[i][y + k - 1]]++;
					arr1[i][arr[i][y + k - 1]]++;
				}

				for (int j = y; j < y + k - 1; j++) {
					if (arr2[j][arr[x + k - 1][j]] != 0) {
						good = false;
						break;
					}
					if (arr3[arr[x + k - 1][j]] == 0) {
						cnt++;
					}
					arr3[arr[x + k - 1][j]]++;
				}

				if (!good) {
					break;
				}

				if (cnt == k) {
					ans++;
				}
			}
		}
	}

	cout << ans;
    return 0;
}
