#include <iostream>
#include <string>
#include <string.h>
#include <set>

using namespace std;

const int max_n = 1000;

int p[max_n][max_n];
bool g[max_n][max_n];
set<int> str[max_n];
set<int> stb[max_n];
set<int> ss;

int main() {
    for(int i = 0; i < max_n; i++) {
        for(int j = 0; j < max_n; j++) {
            p[i][j] = 0;
        }
    }
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            char a, b;
            cin >> a >> b;
            p[i][j] = a * 1000 + b;
        }
    }
    int ans = 0;
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            ss.clear();
            for(int x = 1; x <= n; x++) {
                str[x].clear();
            }
            for(int y = 1; y <= m; y++) {
                stb[y].clear();
            }
            bool can = true;
            for(int pl = 0; i + pl <= n && j + pl <= m && can; pl++) {
                int i1 = i + pl;
                int j1 = j + pl;
                int s = pl + 1;
                for(int x = i; x < i1; x++) {
                    ss.insert(p[x][j1]);
                    stb[j1].insert(p[x][j1]);
                    str[x].insert(p[x][j1]);
                    if(str[x].size() != s) {
                        can = false;
                    }
                }
                for(int y = j; y < j1; y++) {
                    ss.insert(p[i1][y]);
                    str[i1].insert(p[i1][y]);
                    stb[y].insert(p[i1][y]);
                    if(stb[y].size() != s) {
                        can = false;
                    }
                }
                ss.insert(p[i1][j1]);
                str[i1].insert(p[i1][j1]);
                stb[j1].insert(p[i1][j1]);
                if(str[i1].size() != s || stb[j1].size() != s) {
                    break;
                }
                if(ss.size() == s && can) {
                    //cout << i << ' ' << j << ' ' << i1 << ' ' << j1 << endl;
                    ans++;
                }

            }
        }
    }
    cout << ans;
}
