#include <bits/stdc++.h>

const int32_t MAX_N = 2000;
const int32_t MAX_M = 2000;

bool generalFalse;
int32_t k;
std::pair< char, char > board[MAX_N + 5][MAX_M + 5];
std::map< std::pair< char, char >, bool > before[2][MAX_N + 5];
std::map< std::pair< char, char >, int32_t > cnt;
int32_t cntDiff, maxCnt;

bool insert_val(const std::pair< char, char > &val, int32_t aux1, int32_t aux2) {
	bool ok = true;

	cnt[val]++;
	maxCnt = std::max(maxCnt, cnt[val]);
	if(maxCnt > k) {
		ok = false;
	}

	if(cnt[val] == 1) {
		cntDiff++;
		if(cntDiff > k) {
			ok = false;
		}
	}

	if(before[0][aux1][val] || before[1][aux2][val]) {
		ok = false;
		generalFalse = true;
	}

	before[0][aux1][val] = true;
	before[1][aux2][val] = true;

	return ok;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n, m;
	std::cin >> n >> m;

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < m; j++) {
			std::cin >> board[i][j].first >> board[i][j].second;
		}
	}

	int32_t ans = 0;
	for(int32_t i1 = 0; i1 < n; i1++) {
		for(int32_t j1 = 0; j1 < m; j1++) {
			for(int32_t p = 0; p < 2; p++) {
				for(int32_t q = 0; q < std::max(n, m); q++) {
					before[p][q].clear();
				}
			}
			cnt.clear();
			cntDiff = 0;
			generalFalse = false;

			for(k = 1; k <= std::min(n - i1, m - j1); k++) {
				bool ok = true;
				for(int32_t j = j1; j < j1 + k - 1; j++) {
					ok &= insert_val(board[i1 + k - 1][j], i1 + k - 1, j);
				}

				for(int32_t i = i1; i < i1 + k; i++) {
					ok &= insert_val(board[i][j1 + k - 1], i, j1 + k - 1);
				}

				if(generalFalse) {
					break;
				}

				if(ok) {
					ans++;
				}
			}
		}
	}

	std::cout << ans << '\n';
}
