#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll solve(vector <vector <int>> a) {
 	int n = a.size();
 	int m = a[0].size();
 	/*for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			cout << a[i][j] << ' ';
 		}
 		cout << endl;
 	}
 	cout << endl;
 	exit(0);*/
 	vector <int> c;
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			c.push_back(a[i][j]);
 		}
 	}
 	sort(c.begin(), c.end());
 	c.resize(unique(c.begin(), c.end()) - c.begin());
 	int k = c.size();
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			a[i][j] = lower_bound(c.begin(), c.end(), a[i][j]) - c.begin();
		}
	}

 	vector <vector <vector <int>>> whr(k, vector <vector <int>> (n));
 	vector <vector <vector <int>>> whc(k, vector <vector <int>> (m));
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			whr[a[i][j]][i].push_back(j);
 			whc[a[i][j]][j].push_back(i);
 		}
 	}   
 	vector <vector <int>> nxr(n, vector <int> (m, m));
 	for (int i = 0; i < n; ++i) {
 	 	for (int j = 0; j < m; ++j) {
 	 	 	auto it = upper_bound(whr[a[i][j]][i].begin(), whr[a[i][j]][i].end(), j);
 	 	 	if (it != whr[a[i][j]][i].end()) {
 	 	 	 	nxr[i][j] = *it;
 	 	 	}
 	 	}
 	}
 	vector <vector <int>> nxc(n, vector <int> (m, n));
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			auto it = upper_bound(whc[a[i][j]][j].begin(), whc[a[i][j]][j].end(), i);
 			if (it != whc[a[i][j]][j].end()) {
 			 	nxc[i][j] = *it;
 			}
 		}
 	}
 	for (int i = 0; i < n; ++i) {
 		for (int j = m - 2; j >= 0; --j) {
 			nxr[i][j] = min(nxr[i][j], nxr[i][j + 1]);
 		}
 	}
 	/*for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			cout << nxr[i][j] << ' ';
 		}
 		cout << endl;
 	}
 	exit(0);*/
 	for (int i = n - 2; i >= 0; --i) {
 	 	for (int j = 0; j < m; ++j) {
 	 		nxc[i][j] = min(nxc[i][j], nxc[i + 1][j]);
 	 	}
 	}
 	ll ans = 0;
 	vector <vector <int>> used(n, vector <int> (m));
 	for (int si = n - 1; si >= 0; --si) {
 		for (int sj = m - 1; sj >= 0; --sj) {
 		 	if (used[si][sj]) continue;
 		 	int i = si, j = sj;
 		 	while (i >= 0 && j >= 0) {
 		 		used[i][j] = 1;
 		 	 	int mxr = n, mxc = m;
 		 	 	for (int sz = 1; i + sz <= n && j + sz <= m; ++sz) {
 		 	 		mxr = min(mxr, nxc[i][j + sz - 1]);
 		 	 		mxc = min(mxc, nxr[i + sz - 1][j]);
 		 			if (i + sz - 1 >= mxr) break;
 		 			if (j + sz - 1 >= mxc) break;
 	 	 			set <int> have;
 	 	 			for (int x = i; x < i + sz; ++x) {
 	 	 				for (int y = j; y < j + sz; ++y) {
 	 	 					have.insert(a[x][y]);
 	 	 				}
 	 	 			}
 	 	 			if ((int)have.size() == sz) ++ans;  	
 		 	 	}
 		 	 	--i, --j;
 		 	}
 		}
 	}
 	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	vector <vector <int>> a(n, vector <int> (m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x, y;
			cin >> x >> y;
			a[i][j] = (x - 33) * 94 + (y - 33);
		}
	}
	cout << solve(a) << '\n';
}