#include<bits/stdc++.h>

//#define int long long
#define int short
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 501, P = 97;

int n, m;

int a[N][N], len[N][N], mn[N][N], good[N][N];
unordered_map<int, int> pref[N][N];

int get(int i1, int j1, int i2, int j2, int x) {
    return pref[i2][j2][x] - pref[i1 - 1][j2][x] - pref[i2][j1 - 1][x] + pref[i1 - 1][j1 - 1][x];
}

bool check(int i1, int j1, int i2, int j2) {
    int k = i2 - i1 + 1;
    for (int i = i1; i <= i2; ++i) {
        int j = j2;
        if (get(i1, j1, i2, j2, a[i][j]) != k) {
            return false;
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m * 2; ++j) {
            s[j] -= 32;
        }
        for (int j = 1; j <= m; ++j) {
            a[i][j] = s[j * 2 - 2] + s[j * 2 - 1] * P;
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            pref[i][j] = pref[i][j - 1];
            for (int x = 1; x <= i; ++x) {
                pref[i][j][a[x][j]]++;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        unordered_map<int, int> last;
        int curr = 0;
        for (int j = 1; j <= m; ++j) {
            curr = min(curr + 1, j - last[a[i][j]]);
            len[i][j] = curr;
            last[a[i][j]] = j;
        }
    }
    int ans = 0;
    for (int i1 = 1; i1 <= n; ++i1) {
        for (int j = 1; j <= m; ++j) {
            unordered_map<int, int> cnt_col;
            for (int i2 = i1; i2 <= n; ++i2) {
                if (i1 == i2) {
                    mn[j][i2] = len[i2][j];
                    good[i2][j] = true;
                } else {
                    mn[j][i2] = min(mn[j][i2 - 1], len[i2][j]);
                    good[i2][j] = good[i2 - 1][j];
                }
                if (cnt_col[a[i2][j]]) {
                    good[i2][j] = false;
                }
                cnt_col[a[i2][j]]++;
            }
        }
        for (int i2 = i1; i2 <= n; ++i2) {
            int k = i2 - i1 + 1, last_bad = 0;
            for (int j = 1; j <= m; ++j) {
                if (!good[i2][j]) {
                    last_bad = j;
                    continue;
                }
                if (mn[j][i2] < k || j - last_bad < k) {
                    continue;
                }
                ans += check(i1, j - k + 1, i2, j);
            }
        }
    }
    cout << ans << "\n";

    return 0;
}
