#include <bits/stdc++.h>

using namespace std;

const int SIZE = 30000;

int f[1000][1000];
int used[SIZE];
int dp[600][600][600][2];
set<int> s;

int n, m;

inline bool check1(short len, short x, short y) {
    for (int i = 0; i < len; i++) {
        if (!dp[len][x + i][y][0] || !dp[len][x][y + i][1]) {
            return false;
        }
    }

    for (int i = 0; i < SIZE; i++) {
        used[i] = 0;
    }

    for (int i = x; i < x + len; i++) {
        for (int j = y; j < y + len; j++) {
            used[f[i][j]] = 1;
        }
    }

    int cnt = 0;
    for (int i = 0; i < SIZE; i++) {
        cnt += used[i];
    }

    return (cnt == len);
}


void fill_dp() {
    for (int i = 0; i < 600; i++) {
        for (int j = 0; j < 600; j++) {
            for (int k = 0; k < 600; k++) {
                dp[i][j][k][0] = dp[i][j][k][1] = 0;
            }
        }
    }

    for (int len = 1; len <= n; len++) {
        for (int x = 0; x <= n - len; x++) {
            for (int y = 0; y < m; y++) {
                s.clear();
                for (int i = x; i < x + len; i++) {
                    s.insert(f[x][y]);
                }
                if (s.size() == len) {
                    dp[x][y][len][0] = 1;
                }
            }
        }
    }
    for (int len = 1; len <= m; len++) {
        for (int y = 0; y <= len - m; y++) {
            for (int x = 0; x < n; x++) {
                s.clear();
                for (int i = y; i < y + len; i++) {
                    s.insert(f[x][y]);
                }
                if (s.size() == len) {
                    dp[x][y][len][1] = 1;
                }
            }
        }
    }
}


signed main() {
    cin >> n >> m;

    for (short i = 0; i < n; i++) {
        for (short j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            f[i][j] = 100 * int(a - 33) + int(b - 33);
        }
    }

    fill_dp();

    cout << "f = \n";
    for (int i = 0;  i< n; i++) {
        for (int j = 0; j < m; j++) {
            cout << f[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "\n";

    for (int i = 1; i <= n; i++) {
        for (int j = 0;  j< n; j++) {
            for (int k = 0; k < m; k++) {
                cout << dp[i][j][k][0] << " ";
            }
            cout << "\n";
        }
        cout << "\n\n\n";
    }
    cout << "END\n";

    for (int i = 1; i <= m; i++) {
        for (int j = 0;  j< n; j++) {
            for (int k = 0; k < m; k++) {
                cout << dp[i][j][k][1] << " ";
            }
            cout << "\n";
        }
        cout << "\n\n\n";
    }
    cout << "END\n";

    int cnt = 0;
    for (short len = 1; len <= min(n, m); len++) {
        for (short x = 0; x <= n - len; x++) {
            for (short y = 0; y <= m - len; y++) {
                cnt += check1(len, x, y);
            }
        }
    }

    cout << cnt << "\n";
    return 0;
}

