#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;
typedef long double db;

struct Vec {
    int x, y;
    Vec (int x = 0, int y = 0) : x(x), y(y) {};
    Vec operator + (Vec& a) {
        return Vec(x + a.x, y + a.y);
    }
    Vec operator - (Vec& a) {
        return Vec(x - a.x, y - a.y);
    }
    Vec operator * (int a) {
        return Vec(x * a, y * a);
    }
    Vec operator * (Vec& a) {
        return x * a.x + y * a.y;
    }
    Vec operator % (Vec& a) {
        return x * a.y - y * a.x;
    }
};

const int N = 2e3 + 5;
const int LEN = 100;
const int M = LEN * LEN;
int inp[N][N];
int cnt[2][M];
int lst[N][N];
int oh[N][N];
bool ok[N];
vector < pii > kek[2][N][N];

int n;
int dif = 0;

int f(char x, char y) {
    return x * LEN + y;
}

void upd(int t, int x, int k = 1) {
    cnt[t][x] += k;
    if (cnt[t][x] == cnt[1 - t][x]) {
        dif--;
    } else {
        dif++;
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        //cout << s << endl;
        for (int j = 0; j < 2 * m; j += 2) {
            inp[i][j / 2] = f(s[j], s[j + 1]);
        }
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            cout << inp[i][j] << ' ';
//        }
//        cout << endl;
//    }
    int ans = n * m;
    for (int i = n - 2; i >= 0; i--) {
        dif = 0;
        for (int j = 0; j < m; j++) {
            set < int > a, b, c;
            for (int p = j; p < m; p++) {
                a.insert(inp[i][p]);
                b.insert(inp[i + 1][p]);
                c.insert(inp[i][p]);
                c.insert(inp[i + 1][p]);
                int k = p - j + 1;
                if (j == p) {
                    continue;
                }
                if (sz(a) == k && sz(b) == k && sz(c) == k) {
                    kek[0][i][j].pb({k, lst[j][p] + 2});
                    lst[j][p]++;
                } else {
                    lst[j][p] = 0;
                }
            }
        }
        continue;
        //int p = 0;
        for (int j = 0; j < m; j++) {
            int st = m;
            for (int p = j; p < m; p++) {
                int x = inp[i][p];
                int y = inp[i + 1][p];
                if (x == y || cnt[0][x] || cnt[1][y]) {
                    st = p;
                    break;
                }
                upd(0, x);
                upd(1, y);
                //cout << x << ' ' << y << endl;
                if (dif == 0) {
                    kek[0][i][j].pb({p - j + 1, lst[j][p] + 2});
                    lst[j][p]++;
                } else {
                    lst[j][p] = 0;
                }
            }
            for (int p = j; p < st; p++) {
                int x = inp[i][p];
                int y = inp[i + 1][p];
                upd(0, x, -1);
                upd(1, y, -1);
            }

        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            lst[i][j] = 0;
        }
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            if (sz(kek[0][i][j])) {
//                cout << i << ' ' << j << " : "<< endl;
//            for (auto t : kek[0][i][j]) {
//                cout << t.F << ' ' << t.S << endl;
//            }
//            cout << endl;
//            }
//        }
//    }
    for (int j = m - 2; j >= 0; j--) {
        dif = 0;
        for (int i = 0; i < n; i++) {
            set < int > a, b, c;
            for (int p = i; p < n; p++) {
                a.insert(inp[p][j]);
                b.insert(inp[p][j + 1]);
                c.insert(inp[p][j]);
                c.insert(inp[p][j + 1]);
                int k = p - i + 1;
                if (i == p) {
                    continue;
                }
                if (dif == 0) {
                    kek[1][i][j].pb({k, lst[i][p] + 2});
                    lst[i][p]++;
                } else {
                    lst[i][p] = 0;
                }
            }
        }
        continue;
        for (int i = 0; i < n; i++) {
            int st = n;
            for (int p = i; p < n; p++) {
                int x = inp[p][j];
                int y = inp[p][j + 1];
                if (x == y || cnt[0][x] || cnt[1][y]) {
                    st = p;
                    break;
                }
                upd(0, x);
                upd(1, y);
                //cout << x << ' ' << y << endl;
                if (dif == 0) {
                    kek[1][i][j].pb({p - i + 1, lst[i][p] + 2});
                    lst[i][p]++;
                } else {
                    lst[i][p] = 0;
                }
            }
            for (int p = i; p < st; p++) {
                int x = inp[p][j];
                int y = inp[p][j + 1];
                upd(0, x, -1);
                upd(1, y, -1);
            }
        }
    }
//    cout << "!!\n";
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < m; j++) {
//            if (sz(kek[1][i][j])) {
//                cout << i << ' ' << j << " : "<< endl;
//            for (auto t : kek[1][i][j]) {
//                cout << t.F << ' ' << t.S << endl;
//            }
//            cout << endl;
//            }
//        }
//    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            set < int > res;
            for (auto t : kek[0][i][j]) {
                if (t.F <= t.S) {
                    res.insert(t.F);
                }
            }
            for (auto t : kek[1][i][j]) {
                if (t.F <= t.S) {
                    ans += (res.find(t.F) != res.end());
                }
            }
        }
    }
    cout << ans;
    return 0;
}
