#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

#pragma GCC optimize("Ofast")

const int N = 2005, M = 94 * 94, INF = 1e9;
string s[N];
ll a[N][N], tmp[N][N], mx_up[N][N], mx_lt[N][N], 
	used[M], last[M], nearest[N], up[N][N], w[M], sum[N][N];
// int nearest_dif_hash[N][N][N];
int fl = 0;

mt19937 rnd(time(0));

struct W {
	pair<int, int> head[N], tail[N];
	int len_h, len_t;

	W() {
		len_h = 1;
		len_t = 1;
		head[0] = {INF, INF};
		tail[0] = {INF, INF};
	}

	void rectify() {
		while (len_t > 1) {
			head[len_h++] = tail[--len_t];
			head[len_h - 1].second = min(head[len_h - 1].first, head[len_h - 2].second);
		}
	}

	void pop() {
		if (len_h == 1)
			rectify();
		len_h--;
	}

	void push(int x) {
		tail[len_t++] = {x, -1};
		tail[len_t - 1].second = min(tail[len_t - 1].first, tail[len_t - 2].second);
	}

	int get_mn() {
		return min(tail[len_t - 1].second, head[len_h - 1].second);
	}
};

void solve(int n, int m, ll b[N][N], ll res[N][N]) {
	memset(up, -1, sizeof(up));

	for (int i = 0; i < m; i++) {
		fl++;

		for (int j = 0; j < n; j++) {
			if (j > 0) {
				up[j][i] = up[j - 1][i];
			}
			if (used[b[j][i]] == fl) {
				up[j][i] = max(up[j][i], last[b[j][i]]);
			}
			used[b[j][i]] = fl;
			last[b[j][i]] = j;
		}
	}

	fill(nearest, nearest + m, -1);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			nearest[j] = max(nearest[j], up[i][j]);
		}

		// for (int k = 0, j = 0; j < m; j++) {
		// 	while (true) {
		// 		bool ok = true;
		// 		for (int h = k; h <= j; h++) {
		// 			if (i - nearest[h] < j - k + 1) {
		// 				ok = false;
		// 				break;
		// 			}
		// 		}
		// 		if (ok)
		// 			break;
		// 		k++;
		// 	}
		// 	res[i][j] = j - k + 1;
		// }
	}
}

void trans(int n, int m, ll a[N][N]) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			tmp[j][i] = a[i][j];
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			a[i][j] = tmp[i][j];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	// ll anime = 0;

	// for (int i = 1; i <= 2000; i++) {
	// 	for (int j = 1; j <= 2000; j++) {
	// 		anime += min(i, j);
	// 	}
	// }

	// cout << anime << "\n";
	// return 0;


	for (int i = 0; i < M; i++) {
		w[i] = rnd();
	}

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j += 2) {
			a[i][j / 2] = (int)(s[i][j] - 33) * 94 + s[i][j + 1] - 33;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			sum[i + 1][j + 1] = w[a[i][j]];
		}
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			sum[i][j] += sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1];
		}
	}

	// cout << sum[2][5] - sum[2][2] << "\n";
	// cout << sum[3][5] - sum[3][2] << "\n";
	// cout << sum[1][5] - sum[1][2] << "\n";
 
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << a[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	// cout << "\n";

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		for (int k = j; k < m; k++) {
	// 			nearest_dif_hash[i][j][k] = -1;
	// 			if (i > 0) {
	// 				if (sum[i][k + 1] - sum[i][j] !=
	// 					sum[i - 1][k + 1] - sum[i - 1][j]) {
	// 					nearest_dif_hash[i][j][k] = i - 1;
	// 				}
	// 				else {
	// 					nearest_dif_hash[i][j][k] = nearest_dif_hash[i - 1][j][k];
	// 				}
	// 			}
	// 		}
	// 	}
	// }

	// solve(n, m, a, mx_up);
	// trans(n, m, a);
	// solve(m, n, a, mx_lt);
	// trans(m, n, mx_lt);

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << mx_up[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	// cout << "\n";
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << mx_lt[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }


	ll ans = 0;

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			for (int k = 1; k <= min(i, j); k++) {
				if ((sum[i][j] - sum[i][j - k] - sum[i - 1][j] + sum[i - 1][j - k]) * k ==
					sum[i][j] - sum[i - k][j] - sum[i][j - k] + sum[i - k][j - k]) {
					// cout << (sum[i][j] - sum[i][j - k] - sum[i - 1][j] + sum[i - 1][j - k]) << "\n";
					// if (k > 1)
					// 	cout << i << " " << j << " " << k << "\n";
					ans++;
				}
			}
			// int x = min(mx_up[i][j], mx_lt[i][j]);
			// for (int k = 0; k < x; k++) {
			// 	if (i - nearest_dif_hash[i][j - k][j] > k) {
			// 		ans++;
			// 	}
			// }
		}
	}

	cout << ans;

	return 0;
}