#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx")
#pragma GCC target("avx2")

#include<bits/stdc++.h>

using namespace std;

const int K = 1e4 + 9;
const int N = 2001;

int n, m;

int a[N][N];

int nrl[N][N];
int nrd[N][N];
bitset<N> cn[N][N];

int cnt[K];

void init() {
	for (int i = 0; i < n; i++) {
		for (int j = m - 1; j >= 0; j--) {
			nrl[i][j] = m - j;
			for (int tj = j + 1; tj < m; tj++) {
				if (a[i][j] == a[i][tj]) {
					nrl[i][j] = tj - j;
					break;
				}
			}  
			if (j + 1 < m)
				nrl[i][j] = min(nrl[i][j], nrl[i][j + 1] + 1);
		}
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = 0; j < m; j++) {
			nrd[i][j] = n - i;
			for (int ti = i + 1; ti < n; ti++) {
				if (a[i][j] == a[ti][j]) {
					nrd[i][j] = ti - i;
					break;
				}
			}
			if (i + 1 < n)
				nrd[i][j] = min(nrd[i][j], nrd[i + 1][j] + 1);
		}                
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j + 1 < m; j++) {
			int cd = 0;
			cn[i][j][0] = 0;
			for (int ti = i; ti < i + nrd[i][j]; ti++) {
				cd -= (cnt[a[ti][j]] != 0);
				cnt[a[ti][j]]++;
				cd += (cnt[a[ti][j]] != 0);
				cd -= (cnt[a[ti][j + 1]] != 0);
				cnt[a[ti][j + 1]]--;
				cd += (cnt[a[ti][j + 1]] != 0);
				cn[i][j][ti - i + 1] = (cd);
			}
			for (int ti = 0; ti < i + nrd[i][j]; ti++) {
				cnt[a[ti][j]] = 0;
				cnt[a[ti][j + 1]] = 0;
			}
		}
	}
}

int read() {
	char a, b;
	cin >> a >> b;
	int res = 100 * (a - 33) + (b - 33);
	return res;
}

bitset<N> pot;

int solve(int i, int j) {
	int ans = 0;
	int mn = N;
	for (int i = 0; i < N; i++) pot[i] = 0;
	for (int len = 1; i + len <= n && j + len <= m; len++) {
		int ti = i + len - 1;
		int tj = j + len - 1;
		int ok = 1;
		mn = min(mn, nrl[ti][j]);
		mn = min(mn, nrd[i][tj]);
		if (mn < len) break;
		if (len > 1) pot |= cn[i][tj - 1];
		if (ok && !pot[len]) ans++;
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
   	
   	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			a[i][j] = read();
		}
	}
	init();
	int ans = 0;
	for (int i = 0; i < n; i++) {
	 	for (int j = 0; j < m; j++) {
	 		ans += solve(i, j);
	 	}
	}
	cout << ans << endl;
}                                                           