#include<iomanip>
#include<iostream>
#include<vector>
#include<set>
using namespace std;
long long c94 = 94;
int is(vector<vector<pair<char, char>>> &a, int x, int y, int t) {
    set<pair<char, char>> sp;
    for(int i = x; i <= x + t; ++i) {
        sp.clear();
        for(int j = y; j <= y + t; ++j) {
            sp.insert(a[i][j]);
        }
        if(sp.size() < t + 1) {
            return 0;
        }
    }
    for(int j = y; j <= y + t; ++j) {
        sp.clear();
        for(int i = x; i <= x + t; ++i) {
            sp.insert(a[i][j]);
        }
        if(sp.size() < t + 1) {
            return 0;
        }
    }
    sp.clear();
    for(int i = x; i <= x + t; ++i) {
        //sp.clear();
        for(int j = y; j <= y + t; ++j) {
            sp.insert(a[i][j]);
        }
    }
    if(sp.size() > t + 1)  {
        return 0;
    }
    return 1;
}
bool is(vector<vector<int>> &r, vector<vector<int>> &d, int x, int y, int t) {
    for(int i = 0; i < t; ++i) {
        if(r[x + i][y] < t) {
            return 0;
        }
    }
    for(int i = 0; i < t; ++i) {
        if(d[x][y + i] < t) {
            return 0;
        }
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int m;
    cin >> m;
    vector<vector<pair<char, char>>> a(n, vector<pair<char, char>> (m));
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cin >> a[i][j].first >> a[i][j].second;
            a[i][j].first -= 33;
            a[i][j].second -= 33;
        }
    }
    /*if(n <= 20 && m <= 20) {
        int ans = 0;
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < m; ++j) {
                for(int t = 0; j + t < m && i + t < n; ++t) {
                    ans += is(a, i, j, t);
                }
            }
        }
        cout << ans;
    }*/
    int ans = 0;
    vector<int> sum(94*94 + 1, 0);
    vector<int> pos(94*94 + 1, 0);
    vector<vector<int>> r(n, vector<int> (m));
    vector<vector<int>> d(n, vector<int> (m));
    for(int i = 0; i < n; ++i) {
        for(int j = m - 1; j >= 0; --j) {
            if(sum[a[i][j].first*c94 + a[i][j].second] == 0) {
                r[i][j] = m - j;
            }
            else {
                r[i][j] = pos[a[i][j].first*c94 + a[i][j].second] - j;
            }
            if(j != m - 1) {
                r[i][j] = min(r[i][j], r[i][j + 1] + 1);
            }
            sum[a[i][j].first*c94 + a[i][j].second] = 1;
            pos[a[i][j].first*c94 + a[i][j].second] = j;
        }
        for(int j = m - 1; j >= 0; --j) {
            sum[a[i][j].first*c94 + a[i][j].second] = 0;
        }
    }
    for(int j = 0; j < m; ++j) {
        for(int i = n - 1; i >= 0; --i) {
            if(sum[a[i][j].first*c94 + a[i][j].second] == 0) {
                d[i][j] = n - i;
            }
            else {
                d[i][j] = pos[a[i][j].first*c94 + a[i][j].second] - i;
            }
            if(i != n - 1) {
                d[i][j] = min(d[i][j], d[i + 1][j] + 1);
            }
            sum[a[i][j].first*c94 + a[i][j].second] = 1;
            pos[a[i][j].first*c94 + a[i][j].second] = i;
        }
        for(int i = n - 1; i >= 0; --i) {
            sum[a[i][j].first*c94 + a[i][j].second] = 0;
        }
    }
    /*for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cout << d[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "R\n";
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cout << r[i][j] << " ";
        }
        cout << "\n";
    }*/
    for(int i = 0; i < n; ++i) {
        for(int j = i; j < n; ++j) {
            int l = j - i  + 1;
            if(l > m) {
                continue;
            }
            int con = 0;
            for(int x = i; x <= j; ++x) {
                for(int y = 0; y < l - 1; ++y) {
                    ++sum[c94*a[x][y].first + a[x][y].second];
                    if(sum[c94*a[x][y].first + a[x][y].second] == 1) {
                        ++con;
                    }
                }
            }
            for(int y = l - 1; y < m; ++y) {
                for(int x = i; x <= j; ++x) {
                    ++sum[c94*a[x][y].first + a[x][y].second];
                    if(sum[c94*a[x][y].first + a[x][y].second] == 1) {
                        ++con;
                    }
                }
                if(l == 1) {
                    //cout << con << "\n";
                }
                if(con == l && is(r, d, i, y - l + 1, l)) {
                    if(l != 1) {
                        //cout << i  +1 << " " << y - l  + 2 << " "<< l << "\n";
                    }
                    ++ans;
                }
                for(int x = i; x <= j; ++x) {
                    --sum[c94*a[x][y - l + 1].first + a[x][y - l + 1].second];
                    if(sum[c94*a[x][y - l + 1].first + a[x][y - l + 1].second] == 0) {
                        --con;
                    }
                }
            }
            for(int y = m - l + 1; y < m; ++y) {
                for(int x = i; x <= j; ++x) {
                    --sum[c94*a[x][y].first + a[x][y].second];
                    if(sum[c94*a[x][y].first + a[x][y].second] == 0) {
                        --con;
                    }
                }
            }
        }
    }
    cout << ans;
}