#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(c) sort(all(c))
#define reverse(c) sort(all(c))

ostream& operator <<(ostream& out, vector<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, deque<auto> d) {
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vector<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

istream& operator >>(istream& in, pair<auto, auto>& p) {
	return (cin >> p.fi >> p.se);
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> vec(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            char a = s[j * 2], b = s[j * 2 + 1];
            vec[i][j] = (int(a) - 33) * 94 + (int(b) - 33);
        }
    }
    int ans = n * m;
    for (int h = 0; h < n; ++h) {
        for (int l = 0; l < m; ++l) {
            bool flag = true;
            if (!flag) continue;
            for (int len = 2; len <= min(n - h, m - l); ++len) {
                vector<int> now;
                bool nowflag = true;
                for (int i = 0; i < len; ++i) {
                    now.pb(vec[h][l + i]);
                }
                sort(now);
                if (unique(all(now)) - now.begin() != len) {
                    flag = false;
                    break;
                }
                for (int i = 0; i < len; ++i) {
                    vector<int> nownow;
                    for (int j = 0; j < len; ++j) {
                        nownow.pb(vec[h + i][l + j]);
                    }
                    sort(nownow);
                    if (nownow != now) {
                        nowflag = false;
                        break;
                    }
                }
                if (!nowflag) continue;
                for (int i = 0; i < len; ++i) {
                    vector<int> nownow;
                    for (int j = 0; j < len; ++j) {
                        nownow.pb(vec[h + j][l + i]);
                    }
                    sort(nownow);
                    if (nownow != now) {
                        nowflag = false;
                        break;
                    }
                }
                if (!nowflag) continue;
                ++ans;
            }
        }
    }
    cout << ans;
}
