#include <bits/stdc++.h>

using namespace std;

#define int long long
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i,n,m) for(int i = n; i<m; ++i)
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define sc second
#define fr first

struct pol_has
{
    const int P1 = 31, P2 = 53, MOD1 = 1e9 + 7, MOD2 = 1e9 + 53;
    vector <int> st1, st2, has1, has2;
    pol_has(string s)
    {
        int n = s.size();
        st1.resize(n + 1, 1), st2.resize(n + 1, 1), has1.resize(n + 1, 0), has2.resize(n + 1, 0);
        FOR(i, 1, n + 1) st1[i] = (st1[i - 1] * P1) % MOD1;
        FOR(i, 1, n + 1) st2[i] = (st2[i - 1] * P2) % MOD2;

        FOR(i, 1, n + 1) has1[i] = ((has1[i - 1] * P1) % MOD1 + s[i-1] - 'a' + 1 + MOD1) %MOD1;
        FOR(i, 1, n + 1) has2[i] = ((has2[i - 1] * P2) % MOD2 + s[i-1] - 'a' + 1 + MOD2) %MOD2;
    }
    int get_has(int l, int r)
    {
        int a = (has1[r + 1] - (has1[l] * st1[r - l + 1]) % MOD1 + 10 * MOD1)%MOD1;
        int b = (has2[r + 1] - (has2[l] * st2[r - l + 1]) % MOD2 + 10 * MOD2)%MOD2;
        return a * MOD2 + b;
    }
};

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n,m;
    cin >> n >> m;
    map <string,int> sc;
    vector <vector <int> > mat(n, vector <int> (m));
    int sec = 1;
    loop(i, n)
    {
        loop(j, m)
        {
            string s = "";
            char s1,s2;
            cin >> s1 >> s2;
            s.push_back(s1);
            s.push_back(s2);
            if (sc[s] == 0) sc[s] = sec, ++sec;
            mat[i][j] = sc[s];
        }
    }
    int ans = 0;
    for(int sz1 = 1; sz1<=min(n,m); ++sz1)
    {
        for(int i = 0; i<= n - sz1; ++i)
        {
            for(int j = 0; j <= m - sz1; ++j)
            {
                bool fl = 1;
                set <int> glob;
                vector <set <int> > st(max(n, m));
                for(int i1 = i; i1 < i + sz1; ++i1)
                {
                    set <int> loc;
                    for(int j1 = j; j1 < j + sz1; ++j1)
                    {
                        loc.insert(mat[i1][j1]);
                        glob.insert(mat[i1][j1]);
                        st[j1].insert(mat[i1][j1]);
                    }
                    if (loc.size() != sz1) fl = 0;
                }
                for(auto u:st) if (u.size() != sz1 && u.size() != 0) fl =0;
                if (glob.size() != sz1) fl = 0;
                if (fl) ++ans;
            }
        }
    }
    cout << ans;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/

