#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
#include <set>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int main() {
	int n, m;
	cin >> n >> m;

	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c1, c2;
			cin >> c1 >> c2;
			field[i][j] = c1 + (c2 << 7);
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			vector<set<int>> row;
			vector<set<int>> col;
			set<int> all;
			for (int sz = 0; i + sz < n && j + sz < m; sz++) {
				row.push_back({});
				col.push_back({});
				bool flag = true;
				for (int l = 0; l <= sz; l++) {
					row.back().insert(field[i + sz][j + l]);
					col[l].insert(field[i + sz][j + l]);
					col.back().insert(field[i + l][j + sz]);
					row[l].insert(field[i + l][j + sz]);
					flag &= (row[l].size() == sz + 1 && col[l].size() == sz + 1);
					all.insert(field[i + sz][j + l]);
					all.insert(field[i + l][j + sz]);
					flag &= (all.size() == sz + 1);
				}

				if (flag) {
					++ans;
				}
			}
		}
	}

	cout << ans << '\n';
}