#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 100;

ll n, m, a[maxn][maxn], ans;
bitset<10000> t1[maxn][4 * maxn];
bitset<10000> t2[maxn][4 * maxn];

void build1(int v, int tl, int tr, int row) {
    if(tl == tr) {
        t1[row][v].set(a[row][tl]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build1(v << 1, tl, tm, row);
    build1(v << 1 | 1, tm + 1, tr, row);
    t1[row][v] = t1[row][v << 1] | t1[row][v << 1 | 1];
}

void build2(int v, int tl, int tr, int col) {
    if(tl == tr) {
        t2[col][v].set(a[tl][col]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build2(v << 1, tl, tm, col);
    build2(v << 1 | 1, tm + 1, tr, col);
    t2[col][v] = t2[col][v << 1] | t2[col][v << 1 | 1];
}

bitset<10000> get1(int v, int tl, int tr, int l, int r, int row) {
    if(l > r) {
        return bitset<10000>(0);
    }
    if(tl == l && tr == r) {
        return t1[row][v];
    }
    int tm = (tl + tr) >> 1;
    return get1(v << 1, tl, tm, l, min(r, tm), row) |
        get1(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, row);
}

bitset<10000> get2(int v, int tl, int tr, int l, int r, int col) {
    if(l > r) {
        return bitset<10000>(0);
    }
    if(tl == l && tr == r) {
        return t2[col][v];
    }
    int tm = (tl + tr) >> 1;
    return get2(v << 1, tl, tm, l, min(r, tm), col) |
        get2(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, col);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m;
    fr(i, 0, n - 1) {
        fr(j, 0, m - 1) {
            char c1;
            char c2;
            cin >> c1 >> c2;
            ll id = (c1 - 32) + (c2 - 32) * 94;
            a[i][j] = id;
        }
    }
    fr(i, 0, n - 1) {
        build1(1, 0, m - 1, i);
    }
    fr(i, 0, m - 1) {
        build2(1, 0, n - 1, i);
    }
    fr(u, 0, n - 1) {
        fr(d, u, n - 1) {
            ll len = d - u + 1;
            fr(from, 0, m - len) {
                bitset<10000> have;
                bool bad = 0;
                fr(i, u, d) {
                    bitset<10000> b = get1(1, 0, m - 1, from, from + len - 1, i);
                    if(b.count() != len) {
                        bad = 1;
                        break;
                    }
                    have |= b;
                }
                if(bad) {
                    continue;
                }
                if(have.count() != len) {
                    continue;
                }
                fr(i, from, from + len - 1) {
                    bitset<10000> b = get2(1, 0, n - 1, u, d, i);
                    if(b.count() != len) {
                        bad = 1;
                        break;
                    }
                }
                if(!bad) {
                    ans++;
                }
            }
        }
    }
    cout << ans << "\n";
    return 0;
}

/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
