#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <cassert>
#include <unordered_set>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 502;
const ll MOD = (int)1e9 + 7;

const int INF = (int)1e9 + 10;

const int Max_num = (126 - 31) * 100 + (126 - 31) + 3;

int get_num(char a, char b) {
	return (a - 31) * 100 + (b - 31);
}

int t[N][N];

bitset < N > stolb[N][N];
bitset < N > strok[N][N];

bool cnt[Max_num];

set < int > s;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char s1, s2;
			cin >> s1 >> s2;
			t[i][j] = get_num(s1, s2);
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int l = 1; l <= m; ++l) {
			for (int r = l; r <= m; ++r) {
				if (cnt[t[i][r]])
					break;
				cnt[t[i][r]] = true;
				strok[i][l][r] = true;
			}
			for (int r = l; r <= m; ++r) {
				cnt[t[i][r]] = false;
			}
		}
	}
	for (int i = 1; i <= m; ++i) {
		for (int l = 1; l <= n; ++l) {
			for (int r = l; r <= n; ++r) {
				if (cnt[t[r][i]])
					break;
				cnt[t[r][i]] = true;
				stolb[i][l][r] = true;
			}
			for (int r = l; r <= n; ++r) {
				cnt[t[r][i]] = false;
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			s.clear();
			for (int k = 1; k <= min(i, j); ++k) {
				int i1 = i - k + 1, j1 = j - k + 1;
				bool ok = true;
				for (int l = j1; l <= j; ++l) {
					ok &= stolb[l][i1][i];
					if (!ok)
						break;
					s.insert(t[i1][l]);
				}
				for (int l = i1; l <= i; ++l) {
					ok &= strok[l][j1][j];
					if (!ok)
						break;
					s.insert(t[l][j1]);
				}
				if (k == 1)
					assert(ok);
				if (!ok)
					continue;
				if (s.size() != k)
					continue;
				++ans;
			}
		}
	}
	cout << ans;
}