#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

const int R = 505;

int dif_col[R][R][R], dif_row[R][R][R];
int cnt[10000] = {0};
int kol[10000] = {0};

inline void fill_dif_c(int &num, vector <int> &a) {
	int n = len(a);
	vector <int> was;
	for (int i = 0; i < n; ++i) {
		int diff = 0;
		for (int j = i; j < n; ++j) {
			cnt[a[j]]++;
			if (cnt[a[j]] == 1) {
				was.push_back(a[j]);
				++diff;
			}
			dif_col[num][i][j] = diff;
		}
		for (auto &el : was)
			cnt[el] = 0;
		was.clear();
	}
}

inline void fill_dif_r(int &num, vector <int> &a) {
	int n = len(a);
	vector <int> was;
	for (int i = 0; i < n; ++i) {
		int diff = 0;
		for (int j = i; j < n; ++j) {
			cnt[a[j]]++;
			if (cnt[a[j]] == 1) {
				was.push_back(a[j]);
				++diff;
			}
			dif_row[num][i][j] = diff;
		}
		for (auto &el : was)
			cnt[el] = 0;
		was.clear();
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n, m;
	cin >> n >> m;

	int a[R][R];
	vector <pair <char, char>> comp;
	vector <string> b(n);
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		for (int j = 0; j < (m * 2); j += 2)
			comp.push_back(make_pair(b[i][j], b[i][j + 1]));
 	}

 	sort(all(comp));
 	comp.erase(unique(all(comp)), comp.end());

 	for (int i = 0; i < n; ++i) 
 		for (int j = 0, t = 0; j < 2 * m; j += 2, ++t)
 			a[i][t] = (lower_bound(all(comp), make_pair(b[i][j], b[i][j + 1])) - comp.begin());

 	for (int i = 0; i < n; ++i) {
 		vector <int> row;
 		for (int j = 0; j < m; ++j)
 			row.push_back(a[i][j]);
 		fill_dif_r(i, row);
 	}

 	for (int i = 0; i < m; ++i) {
 		vector <int> col;
 		for (int j = 0; j < n; ++j)
 			col.push_back(a[j][i]);
 		fill_dif_c(i, col);
 	}

 	ll ans = 0;
 	vector <int> was;
 	int ii, jj, razn, d, p, k;
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			razn = 0;
 			ii = i;
 			jj = j;
 			while (ii < n && jj < m) {
 				d = ii - i + 1;
 				bool fl = 1;
 				for (p = i; p <= ii && fl; ++p)
 					fl &= (dif_row[p][j][jj] == d);
 				for (p = j; p <= jj && fl; ++p)
 					fl &= (dif_col[p][i][ii] == d);
 				if (!fl) break;

 				for (int k = i; k <= ii; ++k) {
 					kol[a[k][jj]]++;
 					if (kol[a[k][jj]] == 1) {
 						++razn;
 						was.push_back(a[k][jj]);
 					}
 				}
 				for (k = j; k < jj; ++k) {
 					kol[a[ii][k]]++;
 					if (kol[a[ii][k]] == 1) {
 						++razn;
 						was.push_back(a[ii][k]);
 					}
 				}
 				++ii; ++jj;
 				if (razn < d)
 					break;
 				if (razn == d) ans++;
 			}
 			for (auto &el : was)
				kol[el] = 0;
			was.clear();
 		}
 	}

 	cout << ans;

	return 0;
}