#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 501, P = 97;

struct triple {
    int x, y, z;

    triple() {}

    triple(int x, int y, int z): x(x), y(y), z(z) {}
};

int n, m;
int a[N][N], len[N][N], mn[N][N], good[N][N];

bool check(int i2, int j2, int k) {
    int i1 = i2 - k + 1, j1 = j2 - k + 1;
    unordered_map<int, int> cnt;
    for (int i = i1; i <= i2; ++i) {
        unordered_map<int, int> curr_cnt;
        for (int j = j1; j <= j2; ++j) {
            cnt[a[i][j]]++;
            curr_cnt[a[i][j]]++;
            if (curr_cnt[a[i][j]] == 2) {
                return false;
            }
        }
    }
    for (int j = j1; j <= j2; ++j) {
        unordered_map<int, int> curr_cnt;
        for (int i = i1; i <= i2; ++i) {
            if (cnt[a[i][j]] != k) {
                return false;
            }
            curr_cnt[a[i][j]]++;
            if (curr_cnt[a[i][j]] == 2) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m * 2; ++j) {
            s[j] -= 32;
        }
        for (int j = 1; j <= m; ++j) {
            a[i][j] = s[j * 2 - 2] + s[j * 2 - 1] * P;
        }
    }
    for (int i = 1; i <= n; ++i) {
        unordered_map<int, int> last;
        int curr = 0;
        for (int j = 1; j <= m; ++j) {
            curr = min(curr + 1, j - last[a[i][j]]);
            len[i][j] = curr;
            last[a[i][j]] = j;
        }
    }
    vector<triple> go;
    for (int i1 = 1; i1 <= n; ++i1) {
        for (int j = 1; j <= m; ++j) {
            unordered_map<int, int> cnt_col;
            for (int i2 = i1; i2 <= n; ++i2) {
                if (i1 == i2) {
                    mn[j][i2] = len[i2][j];
                    good[i2][j] = true;
                } else {
                    mn[j][i2] = min(mn[j][i2 - 1], len[i2][j]);
                    good[i2][j] = good[i2 - 1][j];
                }
                if (cnt_col[a[i2][j]]) {
                    good[i2][j] = false;
                }
                cnt_col[a[i2][j]]++;
            }
        }
        for (int i2 = i1; i2 <= n; ++i2) {
            int k = i2 - i1 + 1, last_bad = 0;
            for (int j = 1; j <= m; ++j) {
                if (!good[i2][j]) {
                    last_bad = j;
                    continue;
                }
                if (mn[j][i2] < k || j - last_bad < k) {
                    continue;
                }
                go.pb(triple(i2, j, k));
            }
        }
    }
    int ans = 0;
    for (auto &tr : go) {
        int i = tr.x, j = tr.y, k = tr.z;
        ans += check(i, j, k);
    }
    cout << ans << "\n";

    return 0;
}
