#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 510;
const int NN = 1e5;
bool cnt1[NN], cnt2[NN];
int t[N][N];
bool eq[N][N];

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c1, c2;
            cin >> c1 >> c2;
            t[i][j] = c1 * 200 + c2;
        }
    }
    int ans = 0;
    for (int j1 = 0; j1 < m; j1++) {
        memset(eq, 0, sizeof(eq));
        for (int i = 0; i + 1 < n; i++) {
            int r = 0;
            for (int z = j1; z < m; z++) {
                if (cnt1[t[i][z]] || cnt2[t[i + 1][z]]) break;
                if (t[i][z] == t[i + 1][z]) {
                    cnt1[t[i][z]] = cnt2[t[i + 1][z]] = true;
                    if (r == 0) eq[i][z] = true;
                    continue;
                }
                if (cnt2[t[i][z]]) r--;
                else r++;
                if (cnt1[t[i + 1][z]]) r--;
                else r++;
                cnt1[t[i][z]] = true;
                cnt2[t[i + 1][z]] = true;
                if (r == 0) {
                    eq[i][z] = true;
                }
            }
            for (int z = j1; z < m; z++) {
                cnt1[t[i][z]] = false;
                cnt2[t[i + 1][z]] = false;
            }
        }
        for (int j2 = j1 + 1; j2 < m; j2++) {
            int r = 0;
            int l = j2 - j1 + 1;
            for (int i = 0; i + 1 < l; i++) {
                if (!eq[i][j2]) r++;
            }
            for (int i = 0; i + l <= n; i++) {
                if (r == 0) ans++;
                if (!eq[i][j2]) r--;
                if (i + l < n && !eq[i + l - 1][j2]) r++;
            }
        }
    }
    cout << ans + n * m;
    return 0;
}