#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//#define TIME ((clock() - start_time) / CLOCKS_PER_SEC)

//using namespace __gnu_pbds;
using namespace std;


const int maxn = 501;
const int maxc = 93 * 93 + 2;
const int inf = 1e9;

int c[maxn][maxn][maxc];

vector<pair<char, char>> co;
int idx(pair<char, char> x)
{
    return lower_bound(all(co), x) - co.begin();
}

void upd(int i, int j, int t)
{
    if (i)
    {
        for (int k = 0; k < sz(co); ++k)
            c[i][j][k] += c[i - 1][j][k];
    }
    if (j)
    {
        for (int k = 0; k < sz(co); ++k)
            c[i][j][k] += c[i][j - 1][k];
    }
    if (i && j)
    {
        for (int k = 0; k < sz(co); ++k)
            c[i][j][k] -= c[i - 1][j - 1][k];
    }
    c[i][j][t]++;
}

int get(int x1, int y1, int x2, int y2)
{
    int cnt = 0;
    for (int i = 0; i < sz(co); ++i)
    {
        int res = c[x2][y2][i];
        if (x1) res -= c[x1 - 1][y2][i];
        if (y1) res -= c[x2][y1 - 1][i];
        if (x1 && y1) res += c[x1 - 1][y1 - 1][i];
        if (res) ++cnt;
    }
    return cnt;
}

pair<char, char> ftab[maxn][maxn];
int tab[maxn][maxn], nd[maxn][maxn], nr[maxn][maxn];

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char inx1, inx2;
            cin >> inx1 >> inx2;
            ftab[i][j] = {inx1, inx2};
            co.pb(ftab[i][j]);
        }
    }
    sort(all(co));
    co.erase(unique(all(co)), co.end());
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            tab[i][j] = idx(ftab[i][j]);
            upd(i, j, tab[i][j]);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        unordered_map<int, int> pos;
        for (int j = m - 1; j >= 0; --j)
        {
            int val = pos[tab[i][j]];
            if (val) nr[i][j] = val - 1;
            else nr[i][j] = inf;
            pos[tab[i][j]] = j + 1;
        }
    }
    for (int j = 0; j < m; ++j)
    {
        unordered_map<int, int> pos;
        for (int i = n - 1; i >= 0; --i)
        {
            int val = pos[tab[i][j]];
            if (val) nd[i][j] = val - 1;
            else nd[i][j] = inf;
            pos[tab[i][j]] = i + 1;
        }
    }
    int ans = 0;
    for (int x1 = 0; x1 < n; ++x1)
    {
        for (int y1 = 0; y1 < m; ++y1)
        {
            ++ans;
            int vr = nr[x1][y1], vd = nd[x1][y1];
            for (int k = 1; x1 + k < n && y1 + k < m; ++k)
            {
                for (int i = x1; i <= x1 + k; ++i)
                {
                    vr = min(vr, nr[i][y1 + k]);
                    vd = min(vd, nd[i][y1 + k]);
                }
                for (int j = y1; j <= y1 + k; ++j)
                {
                    vd = min(vd, nd[x1 + k][j]);
                    vr = min(vr, nr[x1 + k][j]);
                }

                //cout << x1 << " " << y1 << " " << vd << " " << vr << "\n";
                if (vr <= y1 + k) break;
                if (vd <= x1 + k) break;
                if (get(x1, y1, x1 + k, y1 + k) == k + 1)
                {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}