#include <iostream>
#include <cstring>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int a[MAXN + 5][MAXN + 5];

bool check(int i1, int j1, int d)
{
    int used[100005];
    memset(used, 0, sizeof(used));
    for (int i = i1; i < i1 + d; ++ i)
    {
        for (int j = j1; j < j1 + d; ++ j)
        {
            used[a[i][j]]++;
            if (used[a[i][j]] != i - i1 + 1) return false;
        }
    }

    memset(used, 0, sizeof(used));
    for (int j = j1; j < j1 + d; ++ j)
    {
        for (int i = i1; i < i1 + d; ++ i)
        {
            used[a[i][j]]++;
            if (used[a[i][j]] != j - j1 + 1) return false;
        }
    }

    return true;
}

bool check1(int i1, int j1, int d)
{
    bool used1[100005];
    memset(used1, false, sizeof(used1));
    int k = 0;
    for (int i = i1; i < i1 + d; ++ i)
    {
        for (int j = j1; j < j1 + d; ++ j)
        {
            if (!used1[a[i][j]])
            {
                used1[a[i][j]] = true;
                k++;
            }
            if (k > d) return false;
        }
    }

    if (k != d) return false;

    return true;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    char ch1, ch2;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            cin >> ch1 >> ch2;
            a[i][j] = (int(ch1) - 33) * 1000 + (int(ch2) - 33);
        }
    }

    //if (n <= 20 and m <= 20)
    {
        long long ans = 0;
        for (int d = 1; d <= min(m, n); ++ d)
        {
            for (int i = 0; i <= n - d; ++ i)
            {
                for (int j = 0; j <= m - d; ++ j)
                {
                    if (check(i, j, d)) ans++;
                }
            }
        }

        cout << ans << endl;
    }
    /*else
    {
        long long ans = 0;
        for (int d = 1; d <= min(m, n); ++ d)
        {
            for (int i = 0; i <= n - d; ++ i)
            {
                for (int j = 0; j <= m - d; ++ j)
                {
                    if (check1(i, j, d)) ans++;
                }
            }
        }

        cout << ans << endl;
    }*/

    return 0;
}
