#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(2e3) + 8;
const ll mod = ll(1e9) + 7;
const ll p = 2011;

ll paw(ll val, ll deg) {
    vector<ll> num;
    while(deg) {
        num.pb(deg % 2);
        deg /= 2;
    }
    reverse(num.begin(), num.end());
    ll res = 1;
    for(auto el : num) {
        res = (res * res) % mod;
        if(el) res = (res * val) % mod;
    }
    return res;
}

ll n, m;
vector<ll> a[maxn];
ll prefi[maxn][maxn], prefj[maxn][maxn];
ll pi[maxn][maxn], pj[maxn][maxn];

ll get_hehi(ll i1, ll i2, ll j) {
    j++;
    ll res = (prefi[i2 + 1][j] - prefi[i1][j] + mod) % mod;
    return res;
}

ll get_hehj(ll i, ll j1, ll j2) {
    i++;
    ll res = (prefj[i][j2 + 1] - prefj[i][j1] + mod) % mod;
    return res;
}

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for(ll j = 0; j < m; j++) {
            ll cur = (s[2 * j] - 'a') * 260 + (s[2 * j + 1] - 'a');
            a[i].pb(cur);
        }
    }

    for(ll i = 1; i <= n; i++) {
        for(ll j = 1; j <= m; j++) {
            prefi[i][j] = (prefi[i - 1][j] + paw(p, a[i - 1][j - 1])) % mod;
            prefj[i][j] = (prefj[i][j - 1] + paw(p, a[i - 1][j - 1])) % mod;
        }
    }

    ll ans = n * m;
    for(ll i = 0; i < n; i++) {
        for(ll j = 0; j < m; j++) {
            for(ll sz = 1; sz < min(n - i, m - j); sz++) {
                unordered_set<ll> vals;
                for(ll o = i; o <= i + sz; o++) {
                    vals.insert(a[o][j]);
                }
                if(vals.size() < sz + 1) {
                    continue;
                }
                ll pat = get_hehi(i, i + sz, j);
                bool ok = true;
                for(ll o = i; o <= i + sz; o++) {
                    ll cur = get_hehj(o, j, j + sz);
                    if(cur != pat) {
                        ok = false;
                        break;
                    }
                }
                if(!ok) continue;
                for(ll o = j; o <= j + sz; o++) {
                    ll cur = get_hehi(i, i + sz, o);
                    if(cur != pat) {
                        ok = false;
                        break;
                    }
                }
                if(!ok) continue;

                //cout << i << " " << j << " " << sz << endl;
                ans++;
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
