#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 505;
const int MX = (126 - 33 + 1) * (126 - 33 + 1);
int n, m;
int a[MAXN][MAXN];
int last[MX];
int lef[MAXN][MAXN];
int up[MAXN][MAXN];
int all_cnt;
int cnt[MX];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    rep(i, n) {
        rep(j, m) {
            char ch1, ch2;
            cin >> ch1 >> ch2;
            a[i][j] = (ch1 - 33) + (126 - 33 + 1) * (ch2 - 33);
        }
    }

    fill(last, last + MX, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            lef[i][j] = last[a[i][j]];
            last[a[i][j]] = j;
        }
        rep(j, m) {
            last[a[i][j]] = -1;
        }
    }
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            up[i][j] = last[a[i][j]];
            last[a[i][j]] = i;
        }
        rep(i, n) {
            last[a[i][j]] = -1;
        }
    }

    auto cls = [](){
        all_cnt = 0;
        memset(cnt, 0, sizeof(cnt));
    };

    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool done = false;
            for (int k = 0; i + k < n && j + k < m && !done; ++k) {
                for (int x = i; x <= i + k && !done; ++x) {
                    if (up[x][j + k] >= i || lef[x][j + k] >= j) {
                        done = true;
                        break;
                    }
                    cnt[a[x][j + k]]++;
                    if (cnt[a[x][j + k]] == 1) {
                        all_cnt++;
                    }
                }
                for (int y = j; y < j + k && !done; ++y) {
                    if (up[i + k][y] >= i || lef[i + k][y] >= j) {
                        done = true;
                        break;
                    }
                    cnt[a[i + k][y]]++;
                    if (cnt[a[i + k][y]] == 1) {
                        all_cnt++;
                    }
                }

                if (!done && all_cnt == k + 1) {
                    res++;
                }
            }
            cls();
        }
    }

    cout << res << endl;
}
