#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG
// #define int long long

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;
typedef pair <char, char> pt;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 102;

int get(pt a) {
	return (a.fi - 32) * 127 + (a.se - 32);
}

bool is_ok(int n, int m, vector <vector <pt>>& a, int x, int y, int xx, int yy, int len) {
	unordered_set <int> s;
	s.rehash(len);
	for (int i = x; i <= xx; ++i) {
		s.clear();
		for (int j = y; j <= yy; ++j) {
			s.insert(get(a[i][j]));
		}
		if ((int)s.size() != len) {
			return 0;
		}
	}
	for (int j = y; j <= yy; ++j) {
		s.clear();
		for (int i = x; i <= xx; ++i) {
			s.insert(get(a[i][j]));
		}
		if ((int)s.size() != len) {
			return 0;
		}
	}
	s.clear();
	s.rehash(len * len);
	for (int i = x; i <= xx; ++i) {
		for (int j = y; j <= yy; ++j) {
			s.insert(get(a[i][j]));
		}
	}
	if ((int)s.size() != len) {
		return 0;
	}
	return 1;
}

void stupid(int n, int m, vector <vector <pt>> a) {
	int ans = 0;
	for (int len = 1; len <= min(n, m); ++len) {
		for (int i = 0; i <= n - len; ++i) {
			for (int j = 0; j <= m - len; ++j) {
				int i2 = i + len - 1;
				int j2 = j + len - 1;
				ans += is_ok(n, m, a, i, j, i2, j2, len);
				// if (is_ok(n, m, a, i, j, i2, j2)) {
				// 	// cout << i << " " << j << "\n";
				// 	// cout << i2 << " " << j2 << "\n\n";
				// 	// cout << len << "\n";
				// }
			}
		}
	}
	cout << ans << "\n";
}

unordered_set <int> s[MAXN][MAXN][MAXN];
int cnt[MAXN][MAXN][MAXN];
int cnt1[MAXN][MAXN][MAXN];
int cnt2[MAXN][MAXN][MAXN];

// void gen() {
// 	int n = 100, m = 100;
// 	cout << n << " " << m << "\n";
// 	for (int i = 0; i < n; ++i) {
// 		for (int j = 0; j < m; ++j) {

// 		}
// 	}
// }

void solve() {
	// gen();
	// return;
	int n, m;
	cin >> n >> m;
	vector <vector <pt>> a(n, vector <pt> (m));
	for (auto& v : a) {
		for (auto& i : v) {
			cin >> i.fi >> i.se;
		}
	}

	// if (n <= 20 && m <= 20) {
	// 	stupid(n, m, a);
	// 	return;
	// }

	// for (int i = 0; i < MAXN; ++i) {
	// 	for (int j = 0; j < MAXN; ++j) {
	// 		for (int k = 0; k < MAXN; ++k) {
	// 			s[i][j][k].clear();
	// 			cnt[i][j][k] = 0;
	// 		}
	// 	}
	// }
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			s[1][i][j].insert(get(a[i][j]));
			cnt[1][i][j] = 1;
		}
	}
	for (int len = 1; len < min(n, m); ++len) {
		for (int i = 0; i < n - len; ++i) {
			for (int j = 0; j < m - len; ++j) {
				s[len + 1][i][j].swap(s[len][i][j]);
 				// s[len + 1][i][j] = s[len][i][j];
 				if (s[len + 1][i][j].size() <= min(n, m)) {
	 				for (int k = 0; k <= len; ++k) {
	 					s[len + 1][i][j].insert(get(a[i + k][j + len]));
	 					s[len + 1][i][j].insert(get(a[i + len][j + k]));
	 				}
 				}
 				cnt[len + 1][i][j] = s[len + 1][i][j].size();
			}
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cout << cnt[2][i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	for (int i = 0; i < n; ++i) {
		for (int l = 0; l < m; ++l) {
			for (int r = l; r < m; ++r) {
				unordered_set <int> sss;
				for (int j = l; j <= r; ++j) {
					sss.insert(get(a[i][j]));
				}
				cnt1[i][l][r] = sss.size();
			}
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	for (int l = 0; l < m; ++l) {
	// 		for (int r = 0; r < m; ++r) {
	// 			cout << "i = " <<i << ", l = " << l << ", r = " << r << ", cnt1 = " << cnt1[i][l][r] << "\n";
	// 		}
	// 	} 
	// }

	for (int j = 0; j < m; ++j) {
		for (int l = 0; l < n; ++l) {
			for (int r = l; r < n; ++r) {
				unordered_set <int> sss;
				for (int i = l; i <= r; ++i) {
					sss.insert(get(a[i][j]));
				}
				cnt2[j][l][r] = sss.size();
			}
		}
	}

	int ans = 0;
	for (int len = 1; len <= min(n, m); ++len) {
		for (int i = 0; i <= n - len; ++i) {
			for (int j = 0; j <= m - len; ++j) {
				bool ok = 1;
				ok &= cnt[len][i][j] == len;
				for (int k = 0; k < len; ++k) {
					ok &= cnt1[i + k][j][j + len - 1] == len;
					ok &= cnt2[j + k][i][i + len - 1] == len;
				}
				// if (ok) {
					// cout << len << "\n";
				// }
				ans += ok;
			}
		}
	}
	cout << ans << "\n";
}

int main() {
	set_program();
	int t;
	#ifdef DEBUG
		// cin >> t;
		t = 2;
	#else
		// cin >> t;
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}