﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#pragma GCC optimize("Ofast")

using namespace std;

int arr[32767];

int main()
{
	for (int i = 0; i < 32767; i++) arr[i] = (rand() << 15) + rand();
	ios::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int> > a(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c1, c2;
			cin >> c1 >> c2;
			a[i][j] = arr[c1 * 128 + c2];
		}
	}
	vector<vector<int> > left(n, vector<int>(m + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			left[i][j + 1] = left[i][j] ^ a[i][j];
		}
	}
	vector<vector<int> > up(n + 1, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			up[i + 1][j] = up[i][j] ^ a[i][j];
		}
	}
	vector<vector<int> > mx_left(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> used;
			mx_left[i][j] = -1;
			for (int k = j; k >= 0; k--) {
				if (used.find(a[i][k]) != used.end()) {
					mx_left[i][j] = k;
					break;
				}
				used.insert(a[i][k]);
			}
		}
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << mx_left[i][j] << ' ';
		}
		cout << endl;
	}*/
	vector<vector<int> > mx_up(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> used;
			mx_up[i][j] = -1;
			for (int k = i; k >= 0; k--) {
				if (used.find(a[k][j]) != used.end()) {
					mx_up[i][j] = k;
					break;
				}
				used.insert(a[k][j]);
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = 1; k <= min(i, j) + 1;) {
				//cout << i << ' ' << j << ' ' << k << endl;
				bool ok = 1;
				for (int z = i; z > i - k; z--) {
					if (mx_left[z][j] >= j - k + 1) {
						ok = 0;
						break;
					}
				}
				if (!ok) {
					k++;
					continue;
				}
				for (int z = j; z > j - k; z--) {
					if (mx_up[i][z] >= i - k + 1) {
						ok = 0;
						break;
					}
				}
				if (!ok) {
					k++;
					continue;
				}
				int x0 = left[i][j + 1] ^ left[i][j - k + 1];
				for (int z = i; z > i - k; z--) {
					if ((left[z][j + 1] ^ left[z][j - k + 1]) != x0) {
						ok = 0;
						break;
					}
				}
				if (!ok) {
					k++;
					continue;
				}
				for (int z = j; z > j - k; z--) {
					if ((up[i + 1][z] ^ up[i - k + 1][z]) != x0) {
						ok = 0;
						break;
					}
				}
				if (!ok) {
					k++;
					continue;
				}
				//cout << "plus" << endl;
				ans++;
				k *= 2;
			}
		}
	}
	cout << ans << endl;
}
