#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 2e2 + 5;
const int mod = 1e9 + 7;

int get_bit(int mask, int pos) {
    return (mask & (1LL << pos)) != 0;
}

vector<vector<int>> mapik;
int n, m;

void solve() {
    cin >> n >> m;
    rep(i, n) {
        string s;
        cin >> s;
        vector<int> mbo;
        rep(j, m) {
            mbo.pb((s[2 * j] - 33) * 100 + (s[2 * j + 1]));
        }
        mapik.pb(mbo);
    }
    int ans = 0;
    rep(i, n) {
        rep(j, m) {
            vector<unordered_set<int>> sets;
            unordered_set<int> setik;
            rep(k, min(n, m) + 1) {
                if (k == 0) continue;
                if (i + k - 1 >= n || j + k - 1 >= m) continue;
                sets.pb(unordered_set<int> ());
                for (int it = j; it <= j + k - 1; ++it) {
                    sets.back().insert(mapik[i + k - 1][it]);
                    setik.insert(mapik[i + k - 1][it]);
                }
                for (int it = i; it <= i + k - 1; ++it) {
                    sets[it - i].insert(mapik[it][j + k - 1]);
                    setik.insert(mapik[it][j + k - 1]);
                }
                if (setik.size() != k) continue;
                bool flag = true;
                rep(it, k) {
                    if (sets[it].size() != k) {
                        flag = false;
                        break;
                    }
                }
                if (!flag) continue;
                ans++;
            }
        }
    }
    cout << ans;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}