#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <random>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int short

vector<vector<int>> a;
vector<vector<int>> maxright, maxdown;
int bigrow, bigcolumn, usd;
vector<int> kolvo;

inline int check(int length)
{
    if (bigrow == 0 && bigcolumn == 0 && usd == length) return 1;
    return 0;
}

inline void moveright(int i, int j, int length)
{
    if (maxdown[i][j] < length) bigcolumn--;
    if (maxdown[i][j + length] < length) bigcolumn++;

    for (int ii = i; ii < i + length; ii++)
    {
        if (maxright[ii][j] < length) bigrow--;
        if (maxright[ii][j + 1] < length) bigrow++;

        kolvo[a[ii][j]]--;
        if (kolvo[a[ii][j]] == 0) usd--;

        if (kolvo[a[ii][j + length]] == 0) usd++;
        kolvo[a[ii][j + length]]++;
    }
}

inline void movedown(int i, int j, int length)
{
    if (maxright[i][j] < length) bigrow--;
    if (maxright[i + length][j] < length) bigrow++;

    for (int jj = j; jj < j + length; jj++)
    {
        if (maxdown[i][jj] < length) bigcolumn--;
        if (maxdown[i + 1][jj] < length) bigcolumn++;
        kolvo[a[i][jj]]--;
        if (kolvo[a[i][jj]] == 0) usd--;

        if (kolvo[a[i + length][jj]] == 0) usd++;
        kolvo[a[i + length][jj]]++;
    }
}

void min2(short &a, short b)
{
    if (b < a) a = b;
}

int32_t main()
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;
    int32_t ans = 0;
    cin >> n >> m;
    vector<string> t(n);
    for (int i = 0; i < n; i++) cin >> t[i];

    a.resize(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            a[i][j] = ((int)t[i][2 * j] - 33);
            a[i][j] *= 94;
            a[i][j] += ((int)t[i][2 * j + 1] - 33);
        }
    }


    maxright.resize(n, vector<int>(m, 3000));
    maxdown.resize(n, vector<int>(m, 3000));

    vector<int> last(9000);
    for (int i = 0; i < n; i++)
    {
        for (int k = 0; k < 9000; k++) last[k] = m;
        int curr = 0;
        for (int j = m - 1; j >= 0; j--)
        {
            if (j != m - 1) maxright[i][j] = maxright[i][j + 1] + 1;
            min2(maxright[i][j], (short)(last[a[i][j]] - j));
            last[a[i][j]] = j;
        }
    }

    for (int j = 0; j < m; j++)
    {
        for (int k = 0; k < 9000; k++) last[k] = n;
        for (int i = n - 1; i >= 0; i--)
        {
            if (i != n - 1) maxdown[i][j] = maxdown[i + 1][j] + 1;
            min2(maxdown[i][j], (short)(last[a[i][j]] - i));
            last[a[i][j]] = i;
        }
    }


    int ttt = min(n, m);
    bigrow = bigcolumn = 0;
    kolvo.resize(9000, 0);

    int bigr, bigc, biga, usd2 = 0;
    vector<int> tmp;

    vector<int> tmps(9000, 0);

    for (int length = 1; length <= ttt; length++)
    {
        bigrow = 0;
        bigcolumn = 0;

        for (int i = 0; i < length; i++)
        {
            tmps[a[i][length - 1]]++;
            tmps[a[length - 1][i]]++;
            if (tmps[a[i][length - 1]] == 1) usd2++;
            if (tmps[a[length - 1][i]] == 1) usd2++;
        }
        tmps[a[length - 1][length - 1]]--;

        for (int i = 0; i < length; i++)
        {
            if (maxright[i][0] < length) bigrow++;
            if (maxdown[0][i] < length) bigcolumn++;
        }

        usd = usd2;
        kolvo = tmps;
        for (int i = 0; i < 9000; i++)
        {
            if (kolvo[i] > 0) usd++;
        }

        tmp = kolvo;
        bigc = bigcolumn;
        bigr = bigrow;
        usd2 = usd;

        for (int i = 0; i + length < n; i++)
        {
            ans += check(length);
            for (int j = 0; j + length < m; j++)
            {

                moveright(i, j, length);
                ans += check(length);
            }
            kolvo = tmp;
            bigcolumn = bigc;
            bigrow = bigr;
            usd = usd2;
            movedown(i, 0, length);
            tmp = kolvo;
            bigc = bigcolumn;
            bigr = bigrow;
            usd2 = usd;
        }

        ans += check(length);
        for (int j = 0; j + length < m; j++)
        {
            moveright(n - length, j, length);
            ans += check(length);
        }

    }

    cout << ans;
    return 0;
}