#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

const int N = 500;
const ll inf = 1e18;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n, m;
vector <vector <int> > a;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;

    a.assign(n, vector <int>(m, 0));

    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            a[i][j] = 94 * (x - 33) + (y - 33);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 0; k < n; k++) {
                if (i + k >= n || j + k >= m)
                    continue;
                set <int> st;
                for (int ii = i; ii <= i + k; ii++)
                    st.insert(a[ii][j]);

                if ((int)st.size() != k + 1)
                    continue;

                bool fl = true;

                for (int jj = j + 1; jj <= j + k; jj++) {
                    set <int> sts;
                    for (int ii = i; ii <= i + k; ii++)
                        sts.insert(a[ii][jj]);
                    if (st != sts) {
                        fl = false;
                        break;
                    }
                }
                if (!fl)
                    continue;

                for (int ii = i; ii <= i + k; ii++) {
                    set <int> sts;
                    for (int jj = j; jj <= j + k; jj++)
                        sts.insert(a[ii][jj]);
                    if (st != sts) {
                        fl = false;
                        break;
                    }
                }

                if (!fl)
                    continue;
                ans++;
            }
        }
    }

    cout << ans;

    return 0;
}
