#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

#pragma GCC optimization("Ofast")
#pragma GCC target("avx2")

using namespace std;

int main()
{
    int n = 0, m = 0;
    scanf("%d %d", n, m);

    int table[500][500] = {};
    int i = 0, j = 0;
    while (i++ < n)
    {
        j = 0;
        while (j++ < m)
        {
            char a = 0, b = 0;
            scanf("%c%c", a, b);

            table[i][j] = ((int) a - 33) * 94 + (int) b - 33;
        }
    }

    bool h[500][500][501] = {};
    i = j = 0;
    while (i < n)
    {
        j = 0;
        while (j < m)
        {
            int unique = 0;
            int cnt[8836] = {};
            int len = 0;
            while (j + len <= m)
            {
                if (cnt[table[i][j + len - 1]] == 0)
                    ++unique;
                ++cnt[table[i][j + len - 1]];
                h[i][j][len] = (unique == len);
                ++len;
            }
            ++j;
        }
        ++i;
    }

    bool v[500][500][501] = {};
    i = 0;
    while (i < n)
    {
        j = 0;
        while (j < m)
        {
            int unique = 0;
            int cnt[8836] = {};
            int height = 1;
            while (i + height <= n)
            {
                if (cnt[table[i + height - 1][j]] == 0)
                    ++unique;
                ++cnt[table[i + height - 1][j]];
                v[i][j][height] = (unique == height);
                ++height;
            }
            ++j;
        }
        ++i;
    }
    int k = (m < n) ? m : n;
    int ans = m * n;
    int ii = 0, jj = 0;
    while (k > 1)
    {
        i = 0;
        while (i < n)
        {
            j = 0;
            while (j + k <= m)
            {
                int cnt[8836] = {};
                int unique = 0;
                ii = 0;
                while (ii < k)
                {
                    jj = 0;
                    while (jj < k)
                    {
                        if (cnt[table[i + ii][j + jj]] == 0)
                            ++unique;
                        ++cnt[table[i + ii][j + jj]];
                        ++jj;
                    }
                    ++ii;
                }
                if (unique != k)
                    continue;

                bool correct = true;
                ii = 0;
                while (ii < k)
                {
                    if (!h[i + ii][j][k] || !v[i][j + ii][k])
                    {
                        correct = false;
                        break;
                    }
                    ++ii;
                }

                if (correct)
                    ++ans;
                ++j;
            }
            ++i;
        }
        --k;
    }

    printf("%d", ans);

    return 0;
}