#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}


signed main()
{
    Start();
    int n, m;
    cin >> n >> m;
    vector <vector <int>> a(n, vector <int> (m));
    int p = 127 - 33;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char x, y;
            cin >> x >> y;
            a[i][j] = (x - 33) * (127-33) + y - 33;
        }
    }
    vector <vector <int>> row(n, vector <int> (p * p)), col(m, vector <int> (p * p));
    vector <vector <int>> added(n, vector <int> (m));
    vector <int> used(p * p);
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int hm = 0, mxl = 0;
            for (int l = 0; i + l < n && j + l < m; ++l)
            {
                int shdbr = 0;
                for (int k = 0; k < l; ++k)
                {
                    int x = i + k, y = j + l;
                    if (!added[x][y])
                    {
                        added[x][y] = 1;
                        if (row[x][a[x][y]] || col[y][a[x][y]])
                            shdbr = 1;
                        row[x][a[x][y]]++;
                        col[y][a[x][y]]++;
                        if (!used[a[x][y]])
                            ++hm;
                        used[a[x][y]]++;
                    }
                }
                for (int k = 0; k <= l; ++k)
                {
                    int x = i + l, y = j + k;
                    if (!added[x][y])
                    {
                        added[x][y] = 1;
                        if (row[x][a[x][y]] || col[y][a[x][y]])
                            shdbr = 1;
                        row[x][a[x][y]]++;
                        col[y][a[x][y]]++;
                        if (!used[a[x][y]])
                            ++hm;
                        used[a[x][y]]++;
                    }
                }
                mxl = l;
                if (shdbr)
                {
                    break;
                }
                if (hm == l + 1)
                {
                    ++ans;
                }
            }
            int l = mxl;
                    for (int x = i; x <= i + l; ++x)
                    {
                        for (int y = j; y <= j + l; ++y)
                        {
                            used[a[x][y]] = 0;
                            row[x][a[x][y]] = 0;
                            col[y][a[x][y]] = 0;
                            added[x][y] = 0;
                        }
                    }
        }
    }
    cout << ans;
    return 0;
}


