#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define ll long long

vector <int> t;
vector <int> mod;
void build_tree (int v, int tl, int tr, vector <int> & a)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr)/2;
        build_tree(v*2, tl, tm, a);
        build_tree(v*2 + 1, tm + 1, tr, a);
        t[v] = t[v*2] + t[v*2 + 1];
    }
}

void push(int v, int tl, int tr)
{
    if (mod[v]!= 0 && v*2 + 1 < t.size())
    {

        mod[v*2] = mod[v*2 + 1] = mod[v];
        mod[v] = 0;
        int tm = (tl + tr)/2;
        t[v*2] = mod[v*2]*(tm - tl + 1);
        t[v*2 + 1] = mod[v*2 + 1]*(tr - tm);
    }
}

int get_sum (int l, int r, int v, int tl, int tr)
{
    if (tl >= l && tr <= r)
        return t[v];
    if (tl > r || tr < l)
        return 0;
    push(v, tl, tr);
    int tm = (tl + tr)/2;
    return get_sum(l, r, v*2, tl, tm) + get_sum(l, r, v*2 + 1, tm + 1, tr);


}

void ass (int l, int r, int v, int tl, int tr, int val)
{
    if (tl >= l && tr <= r)
    {
        mod[v] = val;
        t[v] = (tr - tl + 1)*val;

        return;
    }
    if (tl > r || tr < l)
        return;
    push(v, tl, tr);
    int tm = (tl + tr)/2;

    ass(l, r, v*2, tl, tm, val);
    ass(l, r, v*2 + 1, tm + 1, tr, val);
    t[v] = t[v*2] + t[v*2 + 1];


}

void bfs(vector <vector <int>> & g, int st, int end, vector <int> & p, vector <vector <int>> & path, vector <bool> & used, int num)
{

    used.resize(g.size(), false);
    queue <int> q;
    p[st] = -1;
    used[st] = true;
    q.push(st);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < (int) (g[v].size()); ++i)
        {
            if (used[g[v][i]])
                continue;
            q.push(g[v][i]);
            used[g[v][i]] = true;
            p[g[v][i]] = v;

        }
    }
    int u = end;
    while (1)
    {
        path[num].push_back(u);
        u = p[u];
        if (u == -1)
            break;
    }


}

void dfs(vector <vector <int>> & g,  int v, vector <int> & c)
{
    for (int i = 0; i < (int) (g[v].size()); ++i)
    {
        if (g[v][i] != 1)
            continue;
        if (c[v] >= c[i])
            c[i] = c[v] + 1;
        dfs(g, i, c);
    }


}



int main() {
    int n, m;
    cin >> n >> m;
    vector <string> pole(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> pole[i];
    }
    int ans = n*m;
    vector <vector <string> > zhat(n);
    for (int i = 0; i < n; ++i)
        zhat[i].resize(m);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < 2*m; j+=2)
        {
            zhat[i][j/2].push_back(pole[i][j]);
            zhat[i][j/2].push_back(pole[i][j + 1]);
        }
    }

    vector <set<string>> st;
    vector <set<string>> str;
    set<string> vesb;
    for (int i = 0; i < n - 1; ++i)
    {
        for (int j = 0; j < m - 1; ++j)
        {
            for (int k = 2; k <= min(m - j, n - i); ++k)
            {

                vesb.clear();
                st.resize(k);
                str.resize(k);
                for (int l = 0; l < k; ++l)
                {
                    st[l].clear();
                    str[l].clear();
                }
                for (int l = i; l < i + k; ++l)
                {
                    for (int r = j; r < j + k; ++r)
                    {
                        str[l - i].insert(zhat[l][r]);
                        st[r - j].insert(zhat[l][r]);
                        vesb.insert(zhat[l][r]);
                    }
                }
                if (vesb.size() != k)
                    continue;
                int f = 0;
                for (int l = 0; l < k; ++l)
                {
                    if (str[l].size()!= k || st[l].size()!= k)
                    {
                        f = 1;
                        break;
                    }
                }
                if (f)
                    continue;
                ans++;


            }
        }
    }


    cout << ans;
    return 0;
}
