#include <bits/stdc++.h>
#define ll long long
#define db long double
#define pb push_back
#define ppb pop_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
//#define cerr if(false)cerr
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, 10);

const int N = 23, K = 10003, inf = 1e9;
int n, m, used[256][256], a[N][N];
int cnt, was[K], cur[K];

bool check(int x, int y, int z) {
    bool ans = true;
    for (int i = y; i <= y + x - 1; i++) {
        for (int j = z; j <= z + x - 1; j++) {
            if (was[a[i][j]]) {
                ans = false;
            }
            was[a[i][j]] = 1;
        }
        for (int j = z; j <= z + x - 1; j++) {
            was[a[i][j]] = 0;
        }
    }
    for (int j = z; j <= z + x - 1; j++) {
        for (int i = y; i <= y + x - 1; i++) {
            if (was[a[i][j]]) {
                ans = false;
            }
            was[a[i][j]] = 1;
            cur[a[i][j]]++;
        }
        for (int i = y; i <= y + x - 1; i++) {
            was[a[i][j]] = 0;
        }
    }
    for (int i = y; i <= y + x - 1; i++) {
        for (int j = z; j <= z + x - 1; j++) {
            if (cur[a[i][j]] != x && cur[a[i][j]] != 0) {
                ans = false;
            }
        }
    }
    for (int i = y; i <= y + x - 1; i++) {
        for (int j = z; j <= z + x - 1; j++) {
            cur[a[i][j]] = 0;
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL

    cin >> n >> m;
    char c1, c2;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> c1 >> c2;
            if (!used[c1][c2]) {
                used[c1][c2] = ++cnt;
            }
            a[i][j] = used[c1][c2];
        }
    }
    int ans = 0;
    for (int k = 1; k <= min(n, m); k++) {
        for (int i = 1; i + k - 1 <= n; i++) {
            for (int j = 1; j + k - 1 <= m; j++) {
                if (check(k, i, j)) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
}
