//#define _GLIBCXX_DEBUG 1
#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> arr(n, vector<int>(m));
#ifndef SHIT
    unordered_map<int, int> mp;
#endif
    int cnt = 0;
    for (auto &i : arr) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            auto[a, b] = pair{s[j * 2], s[j * 2 + 1]};
#ifndef SHIT
            int now = (int) a * 307 + b;
            if (mp.find(now) != mp.end()) {
                i[j] = mp[now];
            } else {
                mp[now] = cnt++;
                i[j] = mp[now];
            }
#else
            i[j] = (int) a * 307 + b;
#endif
        }
    }
    ll sum = n * m;
    unordered_map<int, int> megamapprev;
    int megasizeprev = 1;
    vector<unordered_map<int, int>> rowsprev(n);
    int rowscounterprev = 0;
    vector<int> rowcprev(n);
    vector<unordered_map<int, int>> keksprev(m);
    int kekscounterprev = 0;
    vector<int> kekcprev(m);
    int now = arr[0][0];
    rowsprev[0][now]++;
    keksprev[0][now]++;
    megamapprev[now]++;
    for (int k = 2; k < min(n, m); ++k) {
        //stroika
        auto rows = rowsprev;
        auto rowc = rowcprev;
        auto keks = keksprev;
        auto kekc = kekcprev;
        auto megamap = megamapprev;
        auto megasize = megasizeprev;
        auto rowscounter = rowscounterprev;
        auto kekscounter = kekscounterprev;
//        rows.emplace_back();
//        rowc.push_back(0);
        for (int i = 0; i < k - 1; ++i) {
            int now = arr[k - 1][i];
            if (rows[k - 1][now] == 1) {
                rowc[k - 1]++;
                if (rowc[k - 1] == 1) rowscounter++;
            }
            rows[k - 1][now]++;
            if (keks[i][now] == 1) {
                kekc[i]++;
                if (kekc[i] == 1) kekscounter++;
            }
            keks[i][now]++;
            if (megamap[now] == 0) megasize++;
            megamap[now]++;
        }
//        keks.emplace_back();
//        kekc.push_back(0);
        for (int i = 0; i < k; ++i) {
            int now = arr[i][k - 1];
            if (keks[k - 1][now] == 1) {
                kekc[k - 1]++;
                if (kekc[k - 1] == 1) kekscounter++;
            }
            keks[k - 1][now]++;
            if (rows[i][now] == 1) {
                rowc[i]++;
                if (rowc[i] == 1) rowscounter++;
            }
            rows[i][now]++;
            if (megamap[now] == 0) megasize++;
            megamap[now]++;
        }
        rowsprev = rows;
        rowcprev = rowc;
        keksprev = keks;
        kekcprev = kekc;
        megamapprev = megamap;
        megasizeprev = megasize;
        kekscounterprev = kekscounter;
        rowscounterprev = rowscounter;
        //stroikaend
        for (int i = 0; i < n - k + 1; ++i) {
            if (i % 2 == 0) {
                //movedown
                if (i != 0) {
                    for (int j = 0; j < k; ++j) {
                        int now;
                        //delete
                        now = arr[i - 1][j];
                        if (keks[j][now] == 2) {
                            kekc[j]--;
                            if (kekc[j] == 0) kekscounter--;
                        }
                        keks[j][now]--;
                        if (rows[i - 1][now] == 2) {
                            rowc[i - 1]--;
                            if (rowc[i - 1] == 0) rowscounter--;
                        }
                        rows[i - 1][now]--;
                        if (megamap[now] == 1) megasize--;
                        megamap[now]--;
                        //add
                        now = arr[i + k - 1][j];
                        if (keks[j][now] == 1) {
                            kekc[j]++;
                            if (kekc[j] == 1) kekscounter++;
                        }
                        keks[j][now]++;
                        if (rows[i + k - 1][now] == 1) {
                            rowc[i + k - 1]++;
                            if (rowc[i + k - 1] == 1) rowscounter++;
                        }
                        rows[i + k - 1][now]++;
                        if (megamap[now] == 0) megasize++;
                        megamap[now]++;
                    }
                }
                //movedownend
                for (int j = 0; j < m - k + 1; ++j) {
                    if (j != 0) {
                        for (int i2 = 0; i2 < k; ++i2) {
                            int now;
                            //delete
                            int row = i + i2, kek = j - 1;
                            now = arr[row][kek];
                            if (keks[kek][now] == 2) {
                                kekc[kek]--;
                                if (kekc[kek] == 0) kekscounter--;
                            }
                            keks[kek][now]--;
                            if (rows[row][now] == 2) {
                                rowc[row]--;
                                if (rowc[row] == 0) rowscounter--;
                            }
                            rows[row][now]--;
                            if (megamap[now] == 1) megasize--;
                            megamap[now]--;
                            //add
                            kek = j + k - 1;
                            now = arr[row][kek];
                            if (keks[kek][now] == 1) {
                                kekc[kek]++;
                                if (kekc[kek] == 1) kekscounter++;
                            }
                            keks[kek][now]++;
                            if (rows[row][now] == 1) {
                                rowc[row]++;
                                if (rowc[row] == 1) rowscounter++;
                            }
                            rows[row][now]++;
                            if (megamap[now] == 0) megasize++;
                            megamap[now]++;
                        }
                    }
                    if (rowscounter == 0 and kekscounter == 0 and megasize == k) sum++;
                }
            } else {
                //movedown
                for (int j = n - k; j < n; ++j) {
                    int now;
                    //delete
                    now = arr[i - 1][j];
                    if (keks[j][now] == 2) {
                        kekc[j]--;
                        if (kekc[j] == 0) kekscounter--;
                    }
                    keks[j][now]--;
                    if (rows[i - 1][now] == 2) {
                        rowc[i - 1]--;
                        if (rowc[i - 1] == 0) rowscounter--;
                    }
                    rows[i - 1][now]--;
                    if (megamap[now] == 1) megasize--;
                    megamap[now]--;
                    //add
                    now = arr[i + k - 1][j];
                    if (keks[j][now] == 1) {
                        kekc[j]++;
                        if (kekc[j] == 1) kekscounter++;
                    }
                    keks[j][now]++;
                    if (rows[i + k - 1][now] == 1) {
                        rowc[i + k - 1]++;
                        if (rowc[i + k - 1] == 1) rowscounter++;
                    }
                    rows[i + k - 1][now]++;
                    if (megamap[now] == 0) megasize++;
                    megamap[now]++;
                }
                //movedownend
                for (int j = m - k; j >= 0; --j) {
                    if (j != m - k) {
                        for (int i2 = 0; i2 < k; ++i2) {
                            int now;
                            //delete
                            int row = i + i2, kek = j + k;
                            now = arr[row][kek];
                            if (keks[kek][now] == 2) {
                                kekc[kek]--;
                                if (kekc[kek] == 0) kekscounter--;
                            }
                            keks[kek][now]--;
                            if (rows[row][now] == 2) {
                                rowc[row]--;
                                if (rowc[row] == 0) rowscounter--;
                            }
                            rows[row][now]--;
                            if (megamap[now] == 1) megasize--;
                            megamap[now]--;
                            //add
                            kek = j;
                            now = arr[row][kek];
                            if (keks[kek][now] == 1) {
                                kekc[kek]++;
                                if (kekc[kek] == 1) kekscounter++;
                            }
                            keks[kek][now]++;
                            if (rows[row][now] == 1) {
                                rowc[row]++;
                                if (rowc[row] == 1) rowscounter++;
                            }
                            rows[row][now]++;
                            if (megamap[now] == 0) megasize++;
                            megamap[now]++;
                        }
                    }
                    if (rowscounter == 0 and kekscounter == 0 and megasize == k) sum++;
                }
            }
        }
    }
    cout << sum;
}