#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 2001;
const int X = 101 * 101;

int n, m;
string s[N];
int a[N][N];
int ans;

const int MOD = 1e9 + 9;
const int B = 3;

int pr1[N][N];
int pr2[N][N];
int deg[X];

int Get1(int r, int j1, int j2)
{
    if (j1 == 0) return pr1[r][j2];
    int res = pr1[r][j2] - pr1[r][j1 - 1] + MOD;
    if (res >= MOD) res -= MOD;
    return res;
}

int Get2(int c, int i1, int i2)
{
    if (i1 == 0) return pr2[i2][c];
    int res = pr2[i2][c] - pr2[i1 - 1][c] + MOD;
    if (res >= MOD) res -= MOD;
    return res;
}

int eq(int i1, int j1, int i2, int j2)
{
    int del = Get1(i1, j1, j2);
    int x = 1;
    for (int i = i1 + 1; i <= i2; i++)
    {
        if (Get1(i, j1, j2) != del) return x;
        else x++;
    }
    for (int j = j1; j <= j2; j++)
    {
        if (Get2(j, i1, i2) != del) return x;
    }
    return x;
}

bitset<X> row[N];

signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
    }
    deg[0] = 1;
    deg[1] = 2;
    for (int i = 2; i < X; i++) deg[i] = (deg[i - 1] + deg[i - 2] + 1) % MOD;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            a[i][j] = (s[i][2 * j] - 33) * (126 - 33 + 1) + s[i][2 * j + 1];
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            pr1[i][j] = ((j > 0 ? pr1[i][j - 1] : 0) + deg[a[i][j]]) % MOD;
            pr2[i][j] = ((i > 0 ? pr2[i - 1][j] : 0) + deg[a[i][j]]) % MOD;
        }
    }
    for (int i = 0; i + 1 < n; i++)
    {
        for (int j = 0; j < m; j++) row[j] = 0;
        for (int j = 0; j < m; j++)
        {
            if (j) row[j] = row[j - 1];
            row[j][a[i][j]] = 1;
        }
        for (int j = 0; j + 1 < m; j++)
        {
            bitset<X> me;
            me[a[i][j]] = 1;
            int k2 = 0;
            for (int k = 2; i + k - 1 < n && j + k - 1 < m;)
            {
                if (me[a[i][j + k - 1]]) break;
                me[a[i][j + k - 1]] = 1;
                if (k < k2)
                {
                    k++;
                    continue;
                }
                int x = eq(i, j, i + k - 1, j + k - 1);
                if (x == k) ans++;
                k2 = k + x - 1;
                k++;
            }
        }
    }
    int ans2 = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            bitset<X> me;
            me[a[i][j]] = 1;
            for (int k = 0; i + k + 1 < n && j + k + 1 < m; k++)
            {
                if (me[a[i][j + k + 1]]) break;
                me[a[i][j + k + 1]] = 1;
                if (eq(i, j, i + k + 1, j + k + 1) == k + 2) ans2++;
            }
        }
    }
    //cout << ans << " " << ans2 << endl;
    if (ans < ans2) cout << 1 / 0;
    cout << n * m + ans;
}

/*
6 6
AABBCCAABBCC
BBCCAABBCCAA
CCAABBCCAABB
XXXXXXXXXXXX
AABBAABBAABB
BBAABBAABBAA
*/
