#include<iostream>
#include<ctime>
#include<random>

using namespace std;

#define int long long

mt19937_64 rnd(time(NULL));

const int md=1e9+7;

int a[2000+5][2000+5];

unsigned long long Zobrist[20000+5];

int c1[2000+5][2000+5];

int c2[2000+5][2000+5];

int c[20000+5];

int h[2000+5][2000+5];

int h1[2000+5][2000+5];

int st[1000000+5];

int st1[1000000+5];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for (int i=1; i<=n; i++)
    {
        string s;
        cin>>s;
        for (int j=0; j<m*2; j+=2)
        {
            //if (s[j]>s[j+1]) swap(s[j],s[j+1]);
            a[i][j/2+1]=(s[j]-33)*100+(s[j+1]-33)+1;
        }
    }
    for (int i=1; i<=20000; i++)
    {
        Zobrist[i]=rnd();
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=20000; j++)
        {
            c[j]=0;
        }
        int l=1, r=1;
        c[a[i][1]]++;
        while (l<=m)
        {
            if (c[a[i][r]]>1)
            {
                c1[i][l]=max(c1[i][l],c1[i][l-1]);
                c[a[i][l]]--;
                l++;
                continue;
            }
            c1[i][l]=max(c1[i][l],r);
            for (int j=l; j<=m; j++)
            {
                c1[i][j]=max(c1[i][j],r);
            }
            if (r==m)
            {
                break;
            }
            if (r<m)
            {
                r++;
                c[a[i][r]]++;
            }
        }
    }
    for (int i=1; i<=m; i++)
    {
        for (int j=1; j<=20000; j++)
        {
            c[j]=0;
        }
        int l=1, r=1;
        c[a[1][i]]++;
        while (l<=n)
        {
            if (c[a[r][i]]>1)
            {
                c2[l][i]=max(c2[l][i],c2[l-1][i]);
                c[a[l][i]]--;
                l++;
                continue;
            }
            c2[l][i]=max(c2[l][i],r);
            for (int j=l; j<=n; j++)
            {
                c2[j][i]=r;
            }
            if (r==n)
            {
                break;
            }
            if (r<n)
            {
                r++;
                c[a[r][i]]++;
            }
        }
    }
    st[0]=1;
    for (int i=1; i<=20000; i++)
    {
        st[i]=st[i-1]*2011;
        st[i]%=md;
    }
    st1[0]=1;
    for (int i=1; i<=20000; i++)
    {
        st1[i]=st1[i-1]*2017;
        st1[i]%=md;
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            h[i][j]=h[i][j-1]+st[a[i][j]];
            h[i][j]%=md;
            h1[i][j]=h1[i][j-1]+st1[a[i][j]];
            h1[i][j]%=md;
        }
    }
    int ans=n*m;
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            int C1=c1[i][j];
            int C2=c2[i][j];
            int u=max(n,m);
            if (u>500) u=min(c1[i][j]-i+1,c2[i][j]-j+1);
            for (int d=2; d<=u; d++)
            {
                if (i+d-1>n||j+d-1>m) break;
                C1=min(C1,c1[i+d-1][j]);
                C2=min(C2,c2[i][j+d-1]);
                if (C1<j+d-1) break;
                if (C2<i+d-1) break;
                if (max(n,m)>500)
                {
                    if (d%min(C1-i+1,C2-j+1)!=0)
                    {
                        continue;
                    }
                }
                bool can=true;
                for (int k1=i+d-1; k1>=i-1; k1--)
                {
                    if ((h[k1][j+d-1]-h[k1][j-1]+md)%md!=(h[k1-1][j+d-1]-h[k1-1][j-1]+md)%md)
                    {
                        can=false;
                        break;
                    }
                    if ((h1[k1][j+d-1]-h1[k1][j-1]+md)%md!=(h1[k1-1][j+d-1]-h1[k1-1][j-1]+md)%md)
                    {
                        can=false;
                        break;
                    }
                }
                if (can)
                {
                    ans++;
                }
            }
        }
    }
    cout<<ans;
}
