#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int Inf = 1e9;

const int N = 2007;
const int K = 9000;

int a[N][N];
vector <int> whr[K][N];
vector <int> whc[K][N];
int nxr[N][N];
int nxc[N][N];
bool used[N][N];
pair <int, int> need[K];
pair <int, int> delta[K];

ll solve(int n, int m) {
 	/*for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			cout << a[i][j] << ' ';
 		}
 		cout << endl;
 	}
 	cout << endl;
 	exit(0);*/
 	vector <int> c;
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			c.push_back(a[i][j]);
 		}
 	}
 	sort(c.begin(), c.end());
 	c.resize(unique(c.begin(), c.end()) - c.begin());
 	int k = c.size();
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			a[i][j] = lower_bound(c.begin(), c.end(), a[i][j]) - c.begin();
		}
	}

 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			whr[a[i][j]][i].push_back(j);
 			whc[a[i][j]][j].push_back(i);
 		}
 	}   
 	for (int i = 0; i < n; ++i) {
 	 	for (int j = 0; j < m; ++j) {
 	 	 	auto it = upper_bound(whr[a[i][j]][i].begin(), whr[a[i][j]][i].end(), j);
 	 	 	if (it != whr[a[i][j]][i].end()) {
 	 	 	 	nxr[i][j] = *it;
 	 	 	} else {
 	 	 	 	nxr[i][j] = m;
 	 	 	}
 	 	}
 	}
 	for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			auto it = upper_bound(whc[a[i][j]][j].begin(), whc[a[i][j]][j].end(), i);
 			if (it != whc[a[i][j]][j].end()) {
 			 	nxc[i][j] = *it;
 			} else {
				nxc[i][j] = n;
			}
 		}
 	}

 	for (int i = 0; i < n; ++i) {
 		for (int j = m - 2; j >= 0; --j) {
 			nxr[i][j] = min(nxr[i][j], nxr[i][j + 1]);
 		}
 	}
 	/*for (int i = 0; i < n; ++i) {
 		for (int j = 0; j < m; ++j) {
 			cout << nxr[i][j] << ' ';
 		}
 		cout << endl;
 	}
 	exit(0);*/
 	for (int i = n - 2; i >= 0; --i) {
 	 	for (int j = 0; j < m; ++j) {
 	 		nxc[i][j] = min(nxc[i][j], nxc[i + 1][j]);
 	 	}
 	}

 	ll ans = 0;

 	int timer = 0;

 	for (int si = n - 1; si >= 0; --si) {
 		for (int sj = m - 1; sj >= 0; --sj) {
 		 	if (used[si][sj]) continue;
 		 	++timer;
 		 	int i = si, j = sj;
 		 	while (i >= 0 && j >= 0) {
 		 		used[i][j] = 1;
 		 		for (int t = 0; t < k; ++t) {
 		 			if (need[t].second == timer) {
 		 				--delta[need[t].first].first;
 		 				++need[t].first;       
 		 				++delta[need[t].first].first;
 		 			}
 		 		}
 		 		for (int x = i; x < n; ++x) {
 		 			int id = a[x][j];
 		 			if (need[id].second != timer || x - i + 1 < need[id].first) {
 		 				if (need[id].second == timer) {
 		 				 	--delta[need[id].first].first;
 		 				}
 		 				need[id].first = x - i + 1;
 		 				need[id].second = timer;
 		 				if (delta[need[id].first].second != timer) {
 		 				 	delta[need[id].first].second = timer;
 		 				 	delta[need[id].first].first = 0;
 		 				}
 		 				++delta[need[id].first].first;
 		 			}
 		 		}
 		 		for (int y = j; y < m; ++y) {
 		 			int id = a[i][y];
 		 			if (need[id].second != timer || y - j + 1 < need[id].first) {
 		 				if (need[id].second == timer) {
 		 				 	--delta[need[id].first].first;
 		 				}
 		 				need[id].first = y - j + 1;
 		 				need[id].second = timer;
 		 				if (delta[need[id].first].second != timer) {
 		 				 	delta[need[id].first].second = timer;
 		 				 	delta[need[id].first].first = 0;
 		 				}
 		 				++delta[need[id].first].first;
 		 			}
 		 		}

 		 	 	int mxr = n, mxc = m;
 		 	 	int cnt = 0;
 		 	 	for (int sz = 1; i + sz <= n && j + sz <= m; ++sz) {
 		 	 		mxr = min(mxr, nxc[i][j + sz - 1]);
 		 	 		mxc = min(mxc, nxr[i + sz - 1][j]);
 		 			if (i + sz - 1 >= mxr) break;
 		 			if (j + sz - 1 >= mxc) break;
 	 	 			if (delta[sz].second == timer) cnt += delta[sz].first;
 	 	 			if (cnt == sz) {
 	 	 				++ans;
 	 	 			} 	                                                		 		
 		 	 	}
 		 	 	--i, --j;
 		 	}
 		}
 	}
 	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x, y;
			cin >> x >> y;
			a[i][j] = (x - 33) * 94 + (y - 33);
		}
	}
	cout << solve(n, m) << '\n';
}