#define ll long long
#define pb push_back
#include<bits/stdc++.h>

using namespace std;

template <class T>
istream& operator >>(istream &in, vector<T> &arr)
{
    for (T &i:arr)
    {
        in >> i;
    }
    return in;
}
template <class T>
ostream& operator <<(ostream &in, vector<T> &arr)
{
    for (T &i:arr)
    {
        in << i << " ";
    }
    return in;
}

int main() {
    ll n, m;
    cin >> n >> m;
    vector<vector<pair<char, char> > > g(n);
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
        {
            vector<char> o;
            o.pb(s[2 * j]);
            o.pb(s[2 * j + 1]);
            sort(o.begin(), o.end());
            g[i].pb({o[0], o[1]});
        }
    }

    vector<vector<ll> > pred(n, vector<ll>(m, 0));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            set<pair<char, char>> op;
            ll cu = 0;
            for (int k = i; k < n; ++k)
            {
                cu += 1;
                op.insert(g[k][j]);
                if (op.size() != cu)
                    {cu-=1;break;}
            }
            pred[i][j] = cu;
        }
    }

    vector<vector<ll> > pred1(n, vector<ll>(m, 0));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            set<pair<char, char>> op;
            ll cu = 0;
            for (int k = j; k < m; ++k)
            {
                cu += 1;
                op.insert(g[i][k]);
                if (op.size() != cu) {cu -= 1;break;}
            }
            pred1[i][j] = cu;
        }
    }

    ll ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            set<pair<char, char>> op;
            ll ht = 1e9;
            for (int x = 1; x + i <= n and x + j <= m and x <= ht; ++x)
            {
                ht = min(ht, pred1[i][j + x - 1]);
                ht = min(ht, pred1[i + x - 1][j]);
                if (ht < x)
                    break;
                for (int y  = j; y < j + x; ++y)
                {
                    op.insert(g[i + x - 1][y]);
                }
                for (int y = i; y < i + x; ++y)
                {
                    op.insert(g[y][j + x - 1]);
                }
                if (op.size() == x)
                    ans += 1;
            }
        }
    }
    cout << ans << endl;
}