#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
#include <set>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 510;
const int NN = 1e5;
bool cnt1[NN], cnt2[NN];
int t[N][N];
bool eq[N][N];
int dwn[N][N];
int up[N][N];
int curdwn[N];
int curup[N];
int arr[N];

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c1, c2;
            cin >> c1 >> c2;
            t[i][j] = c1 * 200 + c2;
            dwn[i][j] = n;
            up[i][j] = -1;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int z = i + 1; z < m; z++) {
                if (t[i][j] == t[z][j]) {
                    dwn[i][j] = z;
                    break;
                }
            }
        }
    }
    int ans = 0;
    for (int j1 = 0; j1 < m; j1++) {
        memset(eq, 0, sizeof(eq));
        for (int i = 0; i + 1 < n; i++) {
            int r = 0;
            for (int z = j1; z < m; z++) {
                if (cnt1[t[i][z]] || cnt2[t[i + 1][z]]) break;
                if (t[i][z] == t[i + 1][z]) {
                    cnt1[t[i][z]] = cnt2[t[i + 1][z]] = true;
                    if (r == 0) eq[i][z] = true;
                    continue;
                }
                if (cnt2[t[i][z]]) r--;
                else r++;
                if (cnt1[t[i + 1][z]]) r--;
                else r++;
                cnt1[t[i][z]] = true;
                cnt2[t[i + 1][z]] = true;
                if (r == 0) {
                    eq[i][z] = true;
                }
            }
            for (int z = j1; z < m; z++) {
                cnt1[t[i][z]] = false;
                cnt2[t[i + 1][z]] = false;
            }
        }
        for (int i = 0; i < n; i++) {
            curdwn[i] = dwn[i][j1];
        }
        for (int i = 0; i < n; i++) {
            curup[i] = up[i][j1];
        }
        for (int j2 = j1 + 1; j2 < m; j2++) {
            for (int i = 0; i < n; i++) {
                curdwn[i] = min(curdwn[i], dwn[i][j2]);
            }
            int r = 0;
            int l = j2 - j1 + 1;
            multiset<int> se;
            for (int i = 0; i + 1 < l; i++) {
                if (!eq[i][j2]) r++;
                if (curup[i] >= 0) r++;
                se.insert(curdwn[i] - 1);
            }
            se.insert(curdwn[l - 1] - 1);
            for (int i = 0; i + l <= n; i++) {
                if (r == 0 && *se.begin() >= i + l - 1) ans++;
                if (!eq[i][j2]) r--;
                se.erase(se.find(curdwn[i] - 1));
                if (i + l < n && !eq[i + l - 1][j2]) {
                    r++; se.insert(curdwn[i + l] - 1);
                }
            }
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << dwn[i][j] << ' ';
        }
        cout << '\n';
    }*/
    cout << ans + n * m;
    return 0;
}