#pragma GCC optimaze("unroll-loops")

#include <iostream>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
#define vin(v, n) for(int i = 0; i < (n); ++i) {cin >> v[i];}
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;

int f[101][101];
int di[101][101][101];
int dj[101][101][101];

signed main() {
	fastio();
	int n, m; cin >> n >> m;
	//vector<vector<int>> f(n + 1, vector<int>(m + 1, -1));
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char a, b; cin >> a >> b;
			f[i][j] = (a - 33) * (126 - 33 + 1) + (b - 33);
		}
	}
	if (/*n * n * m * (ll) m <= 8e8*/ false) {
		int ans = 0;
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				for (int k = 1; i + k - 1 <= n && j + k - 1 <= m; ++k) {
					int x = i + k;
					int y = j + k;
					bool ok = true;
					for (int lev = i; lev < x; ++lev) {
						unordered_set<int> s;
						for (int t = j; t < y; ++t) {
							s.insert(f[lev][t]);
						}
						if (s.size() != k) {
							ok = false;
						}
					}
					for (int ver = j; ver < y; ++ver) {
						unordered_set<int> s;
						for (int t = i; t < x; ++t) {
							s.insert(f[t][ver]);
						}
						if (s.size() != k) {
							ok = false;
						}
					}
					unordered_set<int> s;
					for (int t = i; t < x; ++t) {
						for (int v = j; v < y; ++v) {
							s.insert(f[t][v]);
						}
					}
					if (s.size() != k) {
						ok = false;
					}
					ans += ok;
				}
			}
		}
		cout << ans << endl;
	}
	else {
		//vector<vector<vector<int>>> di(n + 1, vector<vector<int>>(m + 1, vector<int>(m + 1, 0)));
		for (int i = 1; i <= n; ++i) {
			for (int s = 1; s <= m; ++s) {
				unordered_set<int> t;
				for (int e = s; e <= m; ++e) {
					t.insert(f[i][e]);
					di[i][s][e] = t.size();
				}
			}
		}
		//vector<vector<vector<int>>> dj(m + 1, vector<vector<int>>(n + 1, vector<int>(n + 1, 0)));
		for (int j = 1; j <= m; ++j) {
			for (int s = 1; s <= n; ++s) {
				unordered_set<int> t;
				for (int e = s; e <= n; ++e) {
					t.insert(f[e][j]);
					dj[j][s][e] = t.size();
				}
			}
		}
		int ans = 0;
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				unordered_set<int> s;
				for (int k = 1; i + k - 1 <= n && j + k - 1 <= m; ++k) {
					int x = i + k;
					int y = j + k;
					bool ok = true;
					for (int lev = i; lev < x; ++lev) {
						if (di[lev][j][y - 1] != k) {
							ok = false;
						}
					}
					for (int ver = j; ver < y; ++ver) {
						if (dj[ver][i][x - 1] != k) {
							ok = false;
						}
					}
					for (int q = i; q < x; ++q) {
						s.insert(f[q][y - 1]);
					}
					for (int q = j; q < y; ++q) {
						s.insert(f[x - 1][q]);
					}
					if (s.size() != k) {
						ok = false;
					}
					ans += ok;
				}
			}
		}
		cout << ans << endl;
	}
}