#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}
#define ld long double
#define left left228
#define right right228
#define list list228

const int N = 2007;

int n, m;
int a[N][N], right[N][N], down[N][N];

short int mind[505][505][505];
short int minr[505][505][505];

int code(char c) {
	return (int)c - 32;
}

int cnt[10000];
int diff = 0;
void init() {
	memset(cnt, 0, sizeof cnt);
	diff = 0;
}
void add(int x) {
	if (cnt[x] == 0) ++diff;
	++cnt[x];
}
void del(int x) {
	--cnt[x];
	if (cnt[x] == 0) --diff;
}

void pre() {
	for (int i = 1; i <= n; ++i) {
		int r = 0;
		for (int j = 1; j <= m; ++j) {
			while (r + 1 <= m && !cnt[a[i][r + 1]]) {
				++r;
				add(a[i][r]);
			}
			right[i][j] = r;
			del(a[i][j]);
		}
		for (int j = 1; j <= m; ++j) {
			cnt[a[i][j]] = 0;
		}
	}
	for (int j = 1; j <= m; ++j) {
		int r = 0;
		for (int i = 1; i <= n; ++i) {
			while (r + 1 <= n && !cnt[a[r + 1][j]]) {
				++r;
				add(a[r][j]);
			}
			down[i][j] = r;
			del(a[i][j]);
		}
		for (int i = 1; i <= n; ++i) {
			cnt[a[i][j]] = 0;
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int y1 = 1; y1 <= m; ++y1) {
			mind[i][y1][y1] = down[i][y1];
			for (int j = y1 + 1; j <= m; ++j) {
				mind[i][y1][j] = min(mind[i][y1][j - 1], (short int)down[i][j]);
			}
		}
	}
	for (int j = 1; j <= m; ++j) {
		for (int x1 = 1; x1 <= n; ++x1) {
			minr[j][x1][x1] = right[x1][j];
			for (int x2 = x1 + 1; x2 <= n; ++x2) {
				minr[j][x1][x2] = min(minr[j][x1][x2 - 1], (short int)right[x2][j]);
			}
		}
	}
}


bool check(int x1, int y1, int x2, int y2) {
	if (n > 500) return 1;
	if (mind[x1][y1][y2] < x2) return 0;
	if (minr[y1][x1][x2] < y2) return 0;
	// for (int i = y1; i <= y2; ++i) {
	// 	if (down[x1][i] < x2) return 0;
	// }
	// for (int i = x1; i <= x2; ++i) {
	// 	if (right[i][y1] < y2) return 0; 
	// }
	return 1;
}

bitset<10000> bs[N], df[N], col[N], row[N];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char c1, c2;
			cin >> c1 >> c2;
			a[i][j] = code(c1) * 97 + code(c2);
		}
	}
	pre();
	long long answer = 0;
	init();
	for (int y1 = 1; y1 <= m; ++y1) {
		for (int i = 1; i <= n; ++i) {
			row[i] = 0;
			df[i] = 0;
		}
		for (int y2 = y1; y2 <= m; ++y2) {
			for (int i = 1; i <= n; ++i) {
				row[i][a[i][y2]] = 1;
			}
			int k = y2 - y1 + 1;
			if (n < k) continue;
			col[1] = 0;
			for (int i = 1; i <= k; ++i) {
				col[1][a[i][y2]] = 1;
				++cnt[a[i][y2]];
			}
			for (int i = 2; i <= n - k + 1; ++i) {
				col[i] = col[i - 1];
				col[i][a[i + k - 1][y2]] = 1;
				++cnt[a[i + k - 1][y2]];
				--cnt[a[i - 1][y2]];
				if (cnt[a[i - 1][y2]] == 0) {
					col[i][a[i - 1][y2]] = 0;
				}
			}
			for (int i = 1; i <= n; ++i) {
				cnt[a[i][y2]] = 0;
			}
			for (int i = 1; i <= n - k + 1; ++i) {
				df[i] |= col[i];
				df[i] |= row[i + k - 1];
				if (df[i].count() == k && check(i, y1, i + k - 1, y2)) ++answer;
			}
			// for (int x = 1; x <= k; ++x) {
			// 	for (int y = y1; y <= y2; ++y) {
			// 		add(a[x][y]);
			// 	}
			// }
			// if (diff == k && check(1, y1, k, y2)) ++answer;
			// for (int x = k + 1; x <= n; ++x) {
			// 	for (int y = y1; y <= y2; ++y) {
			// 		del(a[x - k][y]);
			// 		add(a[x][y]);
			// 	}
			// 	if (diff == k && check(x - k + 1, y1, x, y2)) {
			// 		++answer;
			// 	}
			// }
		}
	}
	cout << answer << '\n';
	return 0;
}

/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC


5 10
!"#$%&'()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_`abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&
*/
