#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()
#define AAAAAAAAAAAAAAAAAA BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 2e3+5, INF = 1e9;

mt19937 rnd(time(0));

int n, m;
int64_t ans;
pair<char,char> mtx[N][N];


inline void read(){
    cin >> n >> m;
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= m; ++j){
            cin >> mtx[i][j].F >> mtx[i][j].S;
        }
    }
}

bool is_arab(int i1, int j1, int i2, int j2){
    if(i2-i1!=j2-j1) return false;
    static set<pair<char,char>> s;
    s.clear();
    for(int i = i1; i <= i2; ++i){
        for(int j = j1; j <= j2; ++j){
            s.insert(mtx[i][j]);
        }
    }
    if(s.size()!=i2-i1+1) return false;
    for(int i = i1; i <= i2; ++i){
        s.clear();
        for(int j = j1; j <= j2; ++j){
            if(s.count(mtx[i][j])) return false;
            s.insert(mtx[i][j]);
        }
    }
    for(int j = j1; j <= j2; ++j){
        s.clear();
        for(int i = i1; i <= i2; ++i){
            if(s.count(mtx[i][j])) return false;
            s.insert(mtx[i][j]);
        }
    }
    return true;
}

inline void solve3(){
    for(int i1  = 1; i1 <= n; ++i1){
        for(int j1 = 1; j1 <= m; ++j1){
            for(int i2 = i1; i2 <= n; ++i2){
                for(int j2 = j1; j2<= m; ++j2){
                    ans+=is_arab(i1,j1,i2,j2);
                }
            }
        }
    }
}

inline void print(){
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    solve3();
    print();

    return 0;
}
