#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define pb push_back
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

string dp[2010][2010];
int kek1[2010][2010];
int kek2[2010][2010];

gp_hash_table <string, int> s;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    string se;
    for (int i = 0; i < n; i++) {
        cin >> se;
        for (int j = 0; j < 2 * m; j+=2) {
            dp[i][j / 2] = se[j];
            dp[i][j / 2] += se[j + 1];
        }
    }
    for (int i = 0; i < n; i++) {
        int l = 0;
        s.clear();
        for (int j = 0; j < m; j++) {
            while (l < m && s[dp[i][l]] == 0) {
                s[dp[i][l]] = 1;
                l++;
            }
            kek1[i][j] = l - j;
            s[dp[i][j]] = 0;
        }
    }
    for (int j = 0; j < m; j++) {
        int l = 0;
        s.clear();
        for (int i = 0; i < n; i++) {
            while (l < n && s[dp[l][j]] == 0) {
                s[dp[l][j]] = 1;
                l++;
            }
            kek2[i][j] = l - i;
            s[dp[i][j]] = 0;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            s.clear();
            int mnx = 10000;
            int mny = 10000;
            for (int k = 1; k < 1000; k++) {
                if (i + k == n + 1 || j + k == m + 1)
                    break;
                for (int z = j; z < j + k; z++) {
                    s[dp[i + k - 1][z]] = 1;
                }
                for (int z = i; z < i + k; z++) {
                    s[dp[z][j + k - 1]] = 1;
                }
                mny = min(kek2[i][j + k - 1], mny);
                mnx = min(kek1[i + k - 1][j], mnx);
                if (mnx < k)
                    break;
                if (mny < k)
                    break;
                if (sz(s) == k)
                    ans++;
            }
        }
    }
    cout << max(ans, n * m) << endl;
    return 0;
}
