#include<bits/stdc++.h>
#define inf 1000000007
#define base 97
#define base2 9203
#define pii pair<int,int>
#define pcc pair<char,char>
#define pb push_back
using namespace std;
typedef long long ll;
char inp[2048][4096];
pcc tab[2048][2048];
int n,m;
bool check(int a,int b,int k)
{
    map<pcc,int> used;
    for(int i=0;i<k;i++)
    {
        if(used[tab[a][b+i]]) return 0;
        used[tab[a][b+i]]=1;
    }
    int br=1;
    for(int i=0;i<k;i++)
    {
        for(int j=0;j<k;j++)
        {
            if(used[tab[a+i][b+j]]++!=br) return 0;
        }
        br++;
    }
    for(int i=0;i<k;i++)
    {
        for(int j=0;j<k;j++)
        {
            if(used[tab[a+j][b+i]]++!=br) return 0;
        }
        br++;
    }
    return 1;
}
int hsh(pcc x)
{
    return (1ll*(x.first-33)*base+x.second-33)%inf;
}
ll fastpow(ll a,ll b)
{
    if(b==0) return 1;
    if(b==1) return a;
    if(b&1) return (a*fastpow(a,b-1))%inf;
    ll x=fastpow(a,(b>>1));
    return (x*x)%inf;
}
int ans;
void solve_bf()
{
    ans=m*n;
    for(int k=2;k<=min(m,n);k++)
    {
        for(int i=0;i<=n-k;i++)
        {
            for(int j=0;j<=m-k;j++)
            {
                ans+=check(i,j,k);
            }
        }
    }
}
int q[2048];
int h[2048];
void solve_hsh()
{
    ans=m*n; q[1]=1;
    for(int i=2;i<=min(n,m);i++) q[i]=(q[i-1]*base2+1)%inf;
    for(int k=2;k<=min(n,m);k++)
    {
        for(int i=1;i<k;i++)
        {
            h[i]=0;
            for(int j=0;j<k;j++) h[i]=((h[i]*base2)%inf+hsh(tab[i-1][j]))%inf;
        }
        for(int i=0;i<=n-k;i++)
        {
            for(int j=0;j<k-1;j++) h[j]=h[j+1];
            h[k-1]=0;
            for(int j=0;j<k;j++)
            {
                h[k-1]=((h[k-1]*base2)%inf+hsh(tab[i+k-1][j]))%inf;
            }
            int sum=0,sumh=0;
            for(int j=0;j<k;j++) sum=(sum+h[j])%inf;
            for(int j=0;j<k;j++) sumh=(sumh+hsh(tab[i][j]))%inf;
            if(sum==(sumh*q[k])%inf) ans++;
            for(int j=0;j<m-k;j++)
            {
                for(int l=0;l<k;l++)
                {
                    h[l]=((h[l]-hsh(tab[l+i][j])*fastpow(base2,k-1))%inf*base2+hsh(tab[l+i][j+k]))%inf;
                }
                sum=0,sumh=0;
                for(int l=0;l<k;l++) sum=(sum+h[l])%inf;
                for(int l=0;l<k;l++) sumh=(sumh+hsh(tab[i][j+l+1]))%inf;
                if(sum==(sumh*q[k])%inf) ans++;
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        cin>>inp[i];
        for(int j=0;j<2*m;j+=2) tab[i][j/2]={inp[i][j],inp[i][j+1]};
    }
    if(max(n,m)<=100) solve_bf();
    else solve_hsh();
    cout<<ans<<endl;
    return 0;
}
/**

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

5 10
!"#$%&'()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_`abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&

*/
