#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

const int base = 4e6 + 7, sz = 501, sz1 = 10005, mod = 1e9+7;
int n, m;
int hs[sz][sz];
int pw[sz1];

void prec() {
	pw[0] = 1;
	for (int i = 1; i < sz1; i++) {
		pw[i] = (pw[i - 1] * base) % mod;
	}
}

int binpow(int x, int p) {
	if (p == 0) return 1;

	if (p % 2 == 1) {
		return (binpow(x, p - 1) * x) % mod;
	} else {
		int a = binpow(x, p / 2);
		return (a * a) % mod;
	}
}

int rev(int x) {
	return binpow(x, mod - 2);
}

int geth(int x1, int y1, int x2, int y2) {
	return (((hs[x2][y2] - hs[x2][y1 - 1] - hs[x1 - 1][y2] + hs[x1 - 1][y1 - 1]) % mod) + mod) % mod;
}

signed main() {
	kekek;
	cin >> n >> m;
	vector<vector<int>> kek(n, vector<int>(m));
	for (auto &i : kek) {
		for (auto &j : i) {
			char a, b;
			cin >> a >> b;
			a -= 32;
			b -= 32;
			j = a * 97 + b;
		}
	}
	if (n > 100 || m > 100) {
		prec();

		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				hs[i][j] = (hs[i - 1][j] + hs[i][j - 1] - hs[i - 1][j - 1] + pw[kek[i - 1][j - 1]]) % mod;
				if (hs[i][j] < 0) hs[i][j] += mod;
			}
		}

		int ans = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				for (int L = 0; j + L <= m && i + L <= n; L++) {
					if ((geth(i, j, i + L, j + L) * rev(geth(i, j, i, j + L)) % mod == L + 1)) {
						ans++;
					}
				}
			}
		}
		cout << ans;
	} else {
		int ans = n * m;
		for (int i = 0; i < n && clock() < 9.9 * CLOCKS_PER_SEC; i++) {
			for (int j = 0; j < m && clock() < 9.9 * CLOCKS_PER_SEC; j++) {
				for (int L = 1; i + L < n && j + L < m && clock() < 9.9 * CLOCKS_PER_SEC; L++) {
					bool f = true;
					unordered_set<int> global;
					for (int i1 = i; i1 <= i + L; i1++) {
						unordered_set<int> now;
						for (int j1 = j; j1 <= j + L; j1++) {
							now.insert(kek[i1][j1]);
							global.insert(kek[i1][j1]);
						}
						if (now.size() != L + 1 || global.size() != L + 1) {
							f = false;
							break;
						}
					}

					if (!f) continue;

					for (int j1 = j; j1 <= j + L; j1++) {
						unordered_set<int> now;
						for (int i1 = i; i1 <= i + L; i1++) {
							now.insert(kek[i1][j1]);
						}
						if (now.size() != L + 1) {
							f = false;
							break;
						}
					}

					if (f) {
						ans++;
					}
				}
			}
		}

		cout << ans;
	}

	return 0;
}

/*
4 4
AABBCCDD
BBAADDCC
DDCCAABB
CCDDBBAA
*/