#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include<x86intrin.h>
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ld long double
#define every(x) x.begin(), x.end()
#define pb push_back
#define ll long long
#define F first
#define S second
#define sz(x) (int)x.size()
#define For(i,x,y) for(int i=x;i<=y; ++i)
#define FOr(i,x,y) for(int i=x;i>=y; --i)
#define SpeedForce ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#define int ll
int p[3] = {};
ll mod[3] = {};
const ld PI = acos(-1);

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using pt = pair<int,int>;
//mt19937 rng(chrono::steady_clock::now.time_since_epoch().count());

inline void randomizer3000 () {
	unsigned int seed;
	asm ("rdtsc" : "=A"(seed));
	srand(seed);
}
const int N = 2020;
int s[N][N];
int uniq = 0;
	
int n, m;
       
int prv[2][N][N];

int lg[N];
int st[2][N][14][N];

int get_st (int op, int id, int l, int r) {
	int len = r - l + 1;
	len = lg[len];
	return max(st[op][id][len][l], st[op][id][len][r - (1 << len) + 1]);
}

void build () {
	for (int i = 2; i < N; ++i) lg[i] = lg[i/2] + 1;
	for (int i = 0; i < n; ++i) {
		unordered_map < int, int > lst;
		for (int j = 0; j < m; ++j) {
			if (!lst.count(s[i][j])) lst[s[i][j]] = -1;
			prv[0][i][j] = lst[s[i][j]];
//			cout << i << ' ' << j << ' ' << lst[s[i][j]] << ' ';
			lst[s[i][j]] = j; 
		}
//		cout << '\n';
	}
//	exit(0);
	

	for (int j = 0; j < m; j ++) {
		unordered_map < int, int > lst;
		
		for (int i = 0; i < n; i ++) {
			if (!lst.count(s[i][j])) lst[s[i][j]] = -1;
			prv[1][i][j] = lst[s[i][j]];
			lst[s[i][j]] = i;
		}
	}

	for (int i = 0; i < n; i ++) {
		for (int j = 0; j < m; ++j) {
			st[0][i][0][j] = prv[1][i][j]; 
		}

		for (int b = 1; b <= lg[m]; ++b) {
			for (int j = 0; j + (1 << b) <= m; ++j) {
				st[0][i][b][j] = max(st[0][i][b-1][j], st[0][i][b-1][j + (1 << (b - 1))]);
			}
		}
	}

	for (int j = 0; j < m; ++j) {
		for (int i = 0; i < n; i ++) {
			st[1][j][0][i] = prv[0][i][j];
		}
		for (int b = 1; b <= lg[n]; ++b) {
			for (int i = 0; i + (1 << b) <= n; ++i) {
				st[1][j][b][i] = max(st[1][j][b-1][i], st[1][j][b-1][i + (1 << (b - 1))]);
			}
		}
	}
}


ll h[N][N][3];
ll id[N * N][3];

void add (int x, int i, int j) {
	for (int k = 0; k < 3; ++k) {
		if (i) h[i][j][k] += h[i-1][j][k];
		if (j) h[i][j][k] += h[i][j-1][k];

		if (i && j) h[i][j][k] -= h[i-1][j-1][k];

		h[i][j][k] += id[x][k];
		if(h[i][j][k] < 0) h[i][j][k] += mod[k];
		h[i][j][k] %= mod[k];
	}
} 

ll get (int x, int y, int z) {
	if (x < 0) return 0;
	if (y < 0) return 0;
	if (z > 2) return 0;

	return h[x][y][z];
}

ll get (int op, int ax, int ay, int bx, int by) {
	ax--, ay--;
	return (get(ax, ay, op) + get(bx, by, op) - (get(ax, by, op) + get(bx, ay, op)) + 2ll * mod[op]) % mod[op];
}


bool check (int n, int m, int k) {
	//return 1;
	if (m - get_st(1, m, n - k + 1, n) < k) return 0;
	if (n - get_st(0, n, m - k + 1, m) < k) return 0;

	for (int s = 0; s < 3; ++s) {
		ll res = get(s, n-k + 1, m-k + 1, n, m) % mod[s];
		ll dd = get(s, n - k + 1, m, n, m);
	//cout << n - k << ' ' << m << ' ' << n << ' ' << m - k << '\n';
	//cout << n << ' ' << m << ' ' << res << ' ' << dd << ' ' << (dd * k) % mod << '\n';
		if ((dd * k) % mod[s] != res) return 0;
		dd = get(s, n, m - k + 1, n, m);
		if ((dd * k) % mod[s] != res) return 0;
	}
	
	return 1;
}



bool prime (int x) {
	if (x % 2 == 0) return 0;
	if (x <= 20) return 0;

	for (int i = 3; i * (ll)i <= x; i += 2) if (x % i == 0) {
		return 0;
	}

	return 1;
}

char c[N][N+N];

int32_t main () {
	randomizer3000 ();
	scanf("%d %d", &n, &m);
	unordered_map < int, int > was;

	for (int i = 0; i < n; ++i) {
		scanf("%s", c[i]);
		for (int j = 0; j < 2 * m; j += 2) {
			int kak = c[i][j] * 130 + c[i][j+1];
			if (!was.count(kak)) was[kak] = ++uniq;

			s[i][j/2] = was[kak];
		}
	}

	for (int i = 0; i < 3; ++i) {
		p[i] = rand() % 300 + 20;
		while(!prime(p[i])) p[i]++;
		mod[i] = p[i] * 2ll + rand() << 6ll + rand();
		if (mod[i] > 1e9 + 8) mod[i] = 1e9 + 8;
		while(!prime(mod[i])) mod[i]++;
	}

	for (int i = 0; i < 3; ++i) {
		id[0][i] = 1;
		for (int j = 1; j < N * N; ++j) {
			id[j][i] = (p[i] * (ll)id[j-1][i]) % mod[i];
		}
	}

	For (i, 0, n-1) {
		For(j, 0, m-1) {
			add(s[i][j], i, j);
	//		cout << h[i][j] << '\n';
		}
	}

	

	build();

	int ans = n * m;
	for (int k = 2; k <= min(n, m); ++k) {
		for (int i = k - 1; i < n; ++i) {
			for (int j = k - 1; j < m; ++j) if (check(i, j, k)) { //check(i, j, k)
									
			//	cout << i << ' ' << j << ' ' << k << '\n';
				++ans;
				
			}
		}
	} 

	printf("%d", ans);
}