#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

void run() {
    int n;
    cin >> n;
    auto a = arr<int>(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            res ^= a[i] + a[j];
        }
    }
    cout << res << endl;
}
