#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

void solve() {
	int n;
	cin >> n;
	if (n <= 1000) {
		vector <int> a(n);
		for (int& i : a) cin >> i;
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				ans ^= (a[i] + a[j]);
			}
		}
		cout << ans;
		return;
	}
	vector <int> cnt(101);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		++cnt[x];
	}
	int ans = 0;
	for (int i = 0; i <= 100; ++i) {
		for (int j = i + 1; j <= 100; ++j) {
			int now = (cnt[i] * cnt[j]) % 2;
			if (now % 2 == 1) {
				ans ^= (i + j);
			}
		}
	}
	for (int i = 0; i <= 100; ++i) {
		int now = (cnt[i] * (cnt[i] - 1) / 2) % 2;
		if (now % 2 == 1) {
			ans ^= 2 * i;
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}