#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n; cin >> n;
	vector <int> a(n); FR(i, n) cin >> a[i];

	if (n <= 1000) {
		int ans = 0;
		FR(i, n) FOR(j, i + 1, n) ans ^= (a[i] + a[j]);

		cout << ans;
	}
	else {
	
		vector <int> c(101);
		FR(i, n) c[a[i]]++;

		int ans = 0;
		FR(i, c.size()) {

			FOR(j, i + 1, c.size()) {
			
				if (c[i] * c[j] % 2 == 1) ans ^= (i + j);

			}
		}

		FR(i, c.size()) if (c[i] * (c[i] - 1) / 2 % 2 == 1) ans ^= 2 * i;

		cout << ans;
	}
	return 0;
}
