#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int LOGN = 25;
const int MAXN = 4e5 + 100;
int a[MAXN], b[MAXN];

signed main() {
	FAST_IO();
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		b[i] = a[i];
	}
	int res = 0;
	kawaii_set<pii> setik1, setik0;
	for (int bit = LOGN - 1; bit >= 0; --bit) {
		setik1.clear();
		setik0.clear();
		for (int i = 0; i < n; ++i) {
			int cnt = 0;
			if (a[i] & (1 << bit)) {
				b[i] ^= (1 << bit);
				int x = (1 << bit) - b[i];
				cnt += setik0.order_of_key({x, -1});
				cnt += setik1.size() - setik1.order_of_key({x, -1});
				setik1.insert({b[i], i});
			}
			else {
				int x = (1 << bit) - b[i];
				cnt += setik1.order_of_key({x, -1});
				cnt += setik0.size() - setik0.order_of_key({x, -1});
				setik0.insert({b[i], i});
			}
			cnt %= 2;
			if (cnt) {
				res ^= (1 << bit);
			}
		}
	}
	cout << res << '\n';
}