#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 5e5;

void stupid(int n, vector <int>& a) {
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans ^= a[i] + a[j];
		}
	}
	cout << ans << "\n";
}

void solve() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (int& i : a) {
		cin >> i;
	}
	if (n <= 1000) {
		stupid(n, a);
		return;
	}
	map <int, int> cnt;
	for (int i : a) {
		++cnt[i];
	}
	int ans = 0;
	for (auto i : cnt) {
		int cntt = i.se * (i.se - 1) / 2;
		if (cntt % 2 == 1) {
			ans += 2 * i.se;
		}
		for (auto j : cnt) {
			if (i.fi > j.fi) {
				int cntt2 = i.se * j.se;
				if (cntt2 % 2 == 1) {
					ans += i.se + j.se;
				}
			}
		}
	}
	cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 2;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}