#include <iostream>
using namespace std;

const int MAXN = 400005;

int n, a[MAXN], b[128], c[256];
bool st2 = 1;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        if (a[i] > 100) st2 = 0;
    }
}

void SolveST2()
{
    for (int i = 1; i <= n; ++ i)
    {
        b[a[i]]++;
    }

    for (int i = 1; i < 128; ++ i)
    {
        c[i * 2] += b[i] * (b[i] - 1) / 2;
        for (int j = i + 1; j < 128; ++ j)
        {
            c[i + j] += b[i] * b[j];
        }
    }

    int ans = 0;
    for (int i = 1; i < 256; ++ i)
    {
        if (c[i] % 2) ans ^= i;
    }

    cout << ans << endl;
}

int main()
{
    Init();

    if (st2)
    {
        SolveST2();
        return 0;
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            ans ^= a[i] + a[j];
        }
    }

    cout << ans << endl;
    return 0;
}

