#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    forEach(a) cin >> it;
    if (all_of(all(a), [](ll a) { return a <= 1000; })) {
        ll cnt[1001];
        memset(cnt, 0, sizeof(cnt));
        forEach(a) cnt[it]++;
        ll cntSum[2001];
        memset(cntSum, 0, sizeof(cntSum));
        ll res = 0;
        for (ll i = 0; i < 1001; i++) {
            cntSum[2 * i] += cnt[i] * (cnt[i] - 1) / 2;
            for (ll j = i + 1; j < 1001; j++) {
                cntSum[i + j] += cnt[i] * cnt[j];
            }
        }
        for (ll i = 0; i < 2001; i++) {
            if (cntSum[i] % 2) res ^= i;
        }
        cout << res << "\n";
    } else {
        ll res = 0;
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                res ^= a[i] + a[j];
            }
        }
        cout << res << "\n";
    }
}

int main() {
    FASTIO
    solve();
    return 0;
}