#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    int n;
    cin >> n;
    vi a(n);
    forn(i, n) cin >> a[i];
    int ans = 0;
    forn(i, 25){
        int N = 1 << i;
        vi cnt(2 * N);
        forn(j, n){
            cnt[a[j] & (2 * N - 1)]++;
        }
        forn1(j, 2 * N){
            cnt[j] += cnt[j - 1];
        }
        forn(j, N){
            int l = max(j, N - j), r = 2 * N - j - 1;
            int c = cnt[r];
            if (r >= j) c--;
            if (l > 0){
                c -= cnt[l - 1];
                if (l > j) c++;
            }
            //if (i == 2) cout << j << ' ' << l << ' ' << r << ' ' << cnt[l - 1] << ' ' << cnt[r] << ' ' << cnt[j] << ' ' << c << '\n';
            int C = cnt[j];
            if (j > 0) C -= cnt[j - 1];
            if (c % 2 == 1 && C % 2 == 1) ans ^= N;
        }
    }
    cout << ans << '\n';
    return 0;
}