#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int solve(vector <int> a) {
	int n = a.size();
	int ans = 0;
	vector <pair <int, int>> id(n);
	for (int i = 0; i < n; ++i) {
		id[i].first = 0;
		id[i].second = i;
	}
	for (int b = 0; b < 25; ++b) {
		int c1 = 0, c2 = 0;
		for (int i = 0; i < n; ++i) {
			if (a[i] & (1 << b)) ++c1;
			else ++c2;
		}
		int cnt = (ll)c1 * c2 % 2;
		int uk = 0;
		/*if (b == 1) {
			for (auto p : id) {
				cout << p.first << ' ' << p.second << endl;
		 	}
		 	cout << endl << endl;
		}*/
		for (int i = (int)id.size() - 1; i >= 0; --i) {
			while (uk < (int)id.size() && id[i].first + id[uk].first < (1 << b)) {
				++uk;
			}
			int cur_cnt = max(0, i - uk);
			//if (b == 1) cout << i << ' ' << cur_cnt << endl;
			cnt += cur_cnt;
			cnt %= 2;
		}
		if (cnt % 2 == 1) ans |= (1 << b);
		vector <pair <int, int>> nid;
		for (auto p : id) {
		 	if (!(a[p.second] & (1 << b))) {
		 		nid.push_back(p);
		 	}
		}
		for (auto p : id) {
			if (a[p.second] & (1 << b)) {
			 	p.first |= (1 << b);
			 	nid.push_back(p);
			}
		}
		id = nid;
	}
	return ans;
}

int stupid(vector <int> a) {
 	int res = 0;
 	int n = a.size();
 	for (int i = 0; i < n; ++i) {
 		for (int j = i + 1; j < n; ++j) {
 			res ^= (a[i] + a[j]);
 		}
 	}
 	return res;
}

void stress() {
	int cnt = 100;
	mt19937 rnd(123);
	for (int i = 1; i <= cnt; ++i) {
		int n = rnd() % 100 + 1;
		vector <int> a(n);
		for (int i = 0; i < n; ++i) a[i] = rnd() % 100 + 1;
		int sm = solve(a);
		int st = stupid(a);
		if (sm != st) {
			cout << n << '\n';
			for (int i = 0; i < n; ++i) cout << a[i] << ' ';
			cout << '\n';
			cout << sm << ' ' << st << '\n';
			exit(0);
		}
		cout << i << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	cout << solve(a) << '\n';
	//stress();
}