#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

ll cn2(ll x) {
  return x * (x - 1) / 2;
}

signed main() {
#ifdef DEBUG
  freopen("in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n;
  cin >> n;
  vector<int> a(30, 0), b(30, 0);
  while (n--) {
    int x;
    cin >> x;
    for (int j = 0; j < 30; ++j) {
      if (x & (1 << j)) {
        b[j]++;
      } else {
        a[j]++;
      }
    }
  }  
  int ans = 0;
  ll carry = 0;
  for (int j = 0; j < 30; ++j) {
    int p = ((a[j] * (ll)b[j]) & 1) ^ (carry & 1);
    if (p) {
      ans ^= (1 << j);
    }
    carry -= cn2(a[j]);
    chkmax(carry, 0);
    carry -= cn2(b[j]);
    chkmax(carry, 0);
    carry += cn2(b[j]);
  }
  cout << ans << '\n';

  return 0;
}

