#include<bits/stdc++.h>
using namespace std;
const int nmax=1e7+42;
int n,inp[nmax];

int fenwick[nmax];
void update(int pos,int val)
{
    while(pos<nmax)
    {
        fenwick[pos]+=val;
        pos=pos+(pos&(-pos));
    }
}
int query(int pos)
{
    int ret=0;
    while(pos)
    {
        ret=ret+fenwick[pos];
        pos=pos-(pos&(-pos));
    }
    return ret;
}
int ask(int num,int l,int r)
{
    l=l+2;
    r=r+2;

    //cout<<"ask "<<num<<" "<<l<<" "<<r<<endl;

    l=l-num;
    r=r-num;
    l=max(l,1);
    r=min(r,nmax-1);

    //cout<<"l= "<<l<<" r= "<<r<<endl;

    if(l>r)return 0;

    //cout<<"result= "<<query(r)-query(l-1)<<endl;
    return query(r)-query(l-1);
}
int main()
{
    scanf("%i",&n);
    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    int output=0;
    for(int bit=0;bit<25;bit++)
    {
        int md=(1<<(bit+1));
        //cout<<"bit= "<<bit<<" md= "<<md<<endl;

        for(int i=1;i<=n;i++)update(inp[i]%md+1,1);

        bool to=0;

        for(int i=1;i<=n;i++)
        {
            int num=inp[i]%md+1;

            update(num,-1);

            //cout<<"num= "<<num<<endl;

            int to_add=0;
            //[md/2, md-1]
            to_add+=ask(num,md/2,md-1);
            //[md+md/2,md+md-1]
            to_add+=ask(num,md+md/2,md+md-1);
            to_add=to_add&1;

            to=to^to_add;
            //cout<<"---"<<endl;
        }
        output=output+(md/2)*to;
        //cout<<"---"<<endl;
    }

    printf("%i\n",output);
    return 0;
}
/*
2
1 2

3
1 2 3

2
10000000
10000000

2
8388608
8388608
*/