#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = (int)4e5 + 7;
int a[MAXN], b[MAXN], n, answ = 0;
void solve() {
	cin >> n;
	for(int i = 0; i < n; ++i) cin >> a[i];
	for(int k = 0; k < 30; ++k) {
		int fmsk = (1 << (k + 1)) - 1;
		DBG(fmsk);
		int even = 0, odd = 0;
		for(int i = 0; i < n; ++i) {
			b[i] = a[i]&fmsk;
			if((a[i]>>k)&1) {
				++even;
			} else {
				++odd;
			}
		}
		sort(b, b + n);
		ll X = even * 1LL * odd;
		if(X&1) answ ^= 1 << k;
		int ptr = 0;
		ll overflowPairs = 0;
		for(int pos = n - 1; pos >= 0; --pos) {
			while(ptr < n && b[ptr] + b[pos] <= fmsk) ++ptr;
			int cnt = n - ptr;
			assert(cnt >= 0);
			overflowPairs += cnt;
		}
		for(int i = 0; i < n; ++i) {
			if(b[i] + b[i] > fmsk) --overflowPairs;
		}
		overflowPairs /= 2;
		/*for(int i = 0; i < n; ++i) for(int j = 0; j < i; ++j) {
			if(b[i] + b[j] > fmsk) ++overflowPairs;
		}*/
		if(overflowPairs&1LL) answ ^= 1 << (k + 1);
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	solve();
	return 0;
}
