#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

const int LOG = 26;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> a(n);
	for (auto& u : a)
		cin >> u;
	int ans = 0;
	for (int i = 0; i < LOG; i++) {
		vector <int> zero;
		vector <int> uno;
		for (int j = 0; j < n; j++) {
			if (a[j] & (1 << i)) {
				uno.emplace_back(a[j] & ((1 << i) - 1));
			}
			else {
				zero.emplace_back(a[j] & ((1 << i) - 1));
			}
		}
		sort(uno.begin(), uno.end());
		sort(zero.begin(), zero.end());
		int sum = 0;
		for (int j = 0; j < n; j++) {
			if ((a[j] * 2) & (1 << i))
				sum--;
			if (a[j] & (1 << i)) {
				int min_val = (1 << i) - (a[j] & ((1 << i) - 1));
				sum += uno.end() - lower_bound(uno.begin(), uno.end(), min_val);
				int max_val = min_val - 1;
				sum += upper_bound(zero.begin(), zero.end(), max_val) - zero.begin();
			}
			else {
				int min_val = (1 << i) - (a[j] & ((1 << i) - 1));
				sum += zero.end() - lower_bound(zero.begin(), zero.end(), min_val);
				int max_val = min_val - 1;
				sum += upper_bound(uno.begin(), uno.end(), max_val) - uno.begin();
			}
		}
		ans += (sum / 2 % 2) << i;
	}
	cout << ans;
}