#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr int SQ = 12;
constexpr int MSK = (1 << SQ) - 1;
int cnt1[1 << SQ], cnt2[1 << SQ][2 * SQ];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    vector<int> a(n);
    for (int &i : a) {
        i = input();
        cnt1[i & MSK] += 1;
    }
    int res = 0;
    for (int msk1 = 0; msk1 <= MSK; ++msk1) {
        for (int msk2 = msk1 + 1; msk2 <= MSK; ++msk2) {
            if (cnt1[msk1] % 2 && cnt1[msk2] % 2) {
                res ^= msk1 + msk2;
            }
        }
    }

//    for (int i : a) {
//        if ((i >> (SQ - 1)) & 1) {
//            ones.emplace_back(i);
//        } else {
//            zeros.emplace_back(i);
//        }
//    }

    cout << res << endl;
}
