#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int main() {
	int n;
	cin >> n;
	vector<int> v(n);
	cin >> v;

	int res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			res ^= (v[i] + v[j]);
		}
	}

	cout << res << '\n';
}