#include <iostream>
#include <assert.h>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;

    vll a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    bool isDebug = 0;

    if(n <= 1000 && !isDebug)
    {
        ll answ = 0;
        for(int i = 0; i < n; i++)
        {
            ll temp = 0;
            for(int j = i + 1; j < n; j++)
            {
                temp ^= (a[i] + a[j]);
            }
            answ ^= temp;
        }
        cout << answ << endl;
        return 0;
    }

    vector<vii > sufSum(n, vii(101));
    for(int i = n - 1; i >= 1; i--)
    {
        sufSum[i][a[i]]++;
        if(i != n - 1)
        {
            for(int j = 0; j < 101; j++)
                sufSum[i][j] += sufSum[i + 1][j];
        }
    }

   // cerr << "counted sufsum " << endl;

    ll answ = 0;
    for(int i = 0; i < n - 1; i++)
    {
        for(int j = 0; j < 101; j++)
        {
            if(sufSum[i + 1][j] % 2 == 1)
                answ ^= (a[i] + j);
        }
    }
    cout << answ << endl;
    return 0;
}