#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const ll N = 5e5 + 7;
const ll LOG = 29;
//const ll LOG = 3;

ll n;
ll a[N];
vector<ll> s[LOG];
ll cnt[LOG];

ll gett01(ll ind, ll cur, ll mn, ll mx) {
	ll res = 0;
	if ((cur + cur) <= mx && cur + cur >= mn) {
		res--;
	}
	ll lind = lower_bound(all(s[ind]), mn - cur) - s[ind].begin();
	ll rind = upper_bound(all(s[ind]), mx - cur) - s[ind].begin() - 1;
	res += (rind - lind + 1);
	return res;
}

ll stupid() {
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			ans = (ans ^ (a[i] + a[j]));
		}
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		for (ll j = 0; j < LOG; j++) {
			s[j].pb(a[i] & ((1ll << (j + 1)) - 1));
		}
	}
	for (ll i = 0; i < LOG; i++) {
		sort(all(s[i]));
	}
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < LOG; j++) {
			ll b = (a[i] & ((1ll << (j + 1)) - 1));
			cnt[j] += gett01(j, b, (1ll << j), ((1ll << (j + 1)) - 1));
			cnt[j] += gett01(j, b, (1ll << j) + (1ll << (j + 1)), ((1ll << (j + 2)) - 1));
		}
	}
	ll ans = 0;
	for (ll i = 0; i < LOG; i++) {
		cnt[i] /= 2;
		if (cnt[i] % 2 == 1) {
			ans += (1ll << i);
		}
	}
	cout << ans;
//#ifdef _DEBUG
//	cout << nn << stupid();
//#endif // DEBUG

}