#include <iostream>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;

#define int long long			//!!!
#define ld long double
#define eb emplace_back
#define ff first
#define ss second
#define pb pop_back
#define sz(x) (int)x.size()
#define sqr(x) (x) * (x)

const int INF = 1e9 + 7;
const ld EPS = 1e-6;
const int B = 293;
const ld PI = 3.1415926535897932384626433832795;

int t[1600010], a[400010], c[1600010];

void build(int v, int tl, int tr)
{
	if (tl == tr) {
		t[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	build(v * 2 + 1, tl, tm);
	build(v * 2 + 2, tm + 1, tr);
	t[v] = t[v * 2 + 1] ^ t[v * 2 + 2];
}

void update(int l, int r, int val, int v, int tl, int tr)
{
	if (l <= tl && tr <= r) {
		c[v] += val;
		return;
	}
	if (r < tl || tr < l)
		return;
	int tm = (tl + tr) / 2;
	update(l, r, val, v * 2 + 1, tl, tm);
	update(l, r, val, v * 2 + 2, tm + 1, tr);
}

void push(int v)
{
	c[v * 2 + 1] += c[v];
	c[v * 2 + 2] += c[v];
	c[v] = 0;
}

int get_xor(int l, int r, int v, int tl, int tr)
{
	if (l <= tl && tr <= r)
		return t[v] + c[v];
	if (r < tl || tr < l)
		return 0;
	push(v);
	int tm = (tl + tr) / 2;
	return get_xor(l, r, v * 2 + 1, tl, tm) ^ get_xor(l, r, v * 2 + 2, tm + 1, tr);
	t[v] = (t[v * 2 + 1] + c[v * 2 + 1]) ^ (t[v * 2 + 2] + c[v * 2 + 2]);
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	srand(time(0));

	int n;
 	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	build(0, 0, n - 1);
	int res = 0;
	for (int i = 0; i + 1 < n; i++)
	{
		update(i + 1, n - 1, a[i], 0, 0, n - 1);
		res ^= get_xor(i + 1, n - 1, 0, 0, n - 1);
		update(i + 1, n - 1, -a[i], 0, 0, n - 1);
	}
	cout << res << '\n';
	return 0;
}
 