#include <iostream>
#include <vector>

using namespace std;

void solve (vector <int> line) {
    int ans = 0;
    for (int i = 0; i < (int) line.size(); i++)
        for (int j = 0; j < i; j++)
            ans ^= line[i] + line[j];

    cout << ans << endl;
}


int main() {
    int n;
    cin >> n;

    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (n <= 100) {
        solve(line);
        return 0;
    }

    vector <int> cnt(101);
    for (int i : line) {
        cnt[i]++;
    }

    for (int i = 0; i < n; i++) {
        if (cnt[i] >= 4)
            cnt[i] = 0;
    }

    vector <int> new_line;
    for (int i = 0; i < n; i++)
        if (cnt[i])
            new_line.push_back(i);
    solve(new_line);
    return 0;
}
