#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 4e5 + 10;
int a[N];
int mask = 0;

bool comp(int x, int y) {
    return (x & mask) < (y & mask);
}

signed main() {
    fast();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int res = 0;
    for (int i = 0; i < 30; i++) {
        mask = (1 << (i + 1)) - 1;
        sort(a, a + n, comp);
        int l = n, r = n - 1, r3 = n;
        for (int j = 0; j < n; j++) {
            int cur = (a[j] & mask);
            while (l > 0 && (a[l - 1] & mask) + cur >= (1 << i)) l--;
            while (r >= 0 && (a[r] & mask) + cur > mask) r--;
            while (r3 > 0 && (a[r3 - 1] & mask) + cur >= mask + 1 + (1 << i)) r3--;
            int rr = min(r, j - 1);
            int len = 0;
            if (l <= rr)  len = rr - l + 1;
            if (r3 < j) len += j - r3;
            if (len & 1) res ^= (1 << i);
        }
    }
    cout << res;
    return 0;
}