#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define ll long long

vector <int> t;
vector <int> mod;
void build_tree (int v, int tl, int tr, vector <int> & a)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr)/2;
        build_tree(v*2, tl, tm, a);
        build_tree(v*2 + 1, tm + 1, tr, a);
        t[v] = t[v*2] + t[v*2 + 1];
    }
}

void push(int v, int tl, int tr)
{
    if (mod[v]!= 0 && v*2 + 1 < t.size())
    {

        mod[v*2] = mod[v*2 + 1] = mod[v];
        mod[v] = 0;
        int tm = (tl + tr)/2;
        t[v*2] = mod[v*2]*(tm - tl + 1);
        t[v*2 + 1] = mod[v*2 + 1]*(tr - tm);
    }
}

int get_sum (int l, int r, int v, int tl, int tr)
{
    if (tl >= l && tr <= r)
        return t[v];
    if (tl > r || tr < l)
        return 0;
    push(v, tl, tr);
    int tm = (tl + tr)/2;
    return get_sum(l, r, v*2, tl, tm) + get_sum(l, r, v*2 + 1, tm + 1, tr);


}

void ass (int l, int r, int v, int tl, int tr, int val)
{
    if (tl >= l && tr <= r)
    {
        mod[v] = val;
        t[v] = (tr - tl + 1)*val;

        return;
    }
    if (tl > r || tr < l)
        return;
    push(v, tl, tr);
    int tm = (tl + tr)/2;

    ass(l, r, v*2, tl, tm, val);
    ass(l, r, v*2 + 1, tm + 1, tr, val);
    t[v] = t[v*2] + t[v*2 + 1];


}

void bfs(vector <vector <int>> & g, int st, int end, vector <int> & p, vector <vector <int>> & path, vector <bool> & used, int num)
{

    used.resize(g.size(), false);
    queue <int> q;
    p[st] = -1;
    used[st] = true;
    q.push(st);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < (int) (g[v].size()); ++i)
        {
            if (used[g[v][i]])
                continue;
            q.push(g[v][i]);
            used[g[v][i]] = true;
            p[g[v][i]] = v;

        }
    }
    int u = end;
    while (1)
    {
        path[num].push_back(u);
        u = p[u];
        if (u == -1)
            break;
    }


}

void dfs(vector <vector <int>> & g,  int v, vector <int> & c)
{
    for (int i = 0; i < (int) (g[v].size()); ++i)
    {
        if (g[v][i] != 1)
            continue;
        if (c[v] >= c[i])
            c[i] = c[v] + 1;
        dfs(g, i, c);
    }


}


int main() {
   int n;
   cin >> n;
    /*
   if (n <= 1000) {
       vector<int> a(n);

       for (int i = 0; i < n; ++i)
           cin >> a[i];

       int sum = 0;
       for (int i = 0; i < n; ++i) {
           for (int j = i + 1; j < n; ++j) {
               sum = sum ^ (a[i] + a[j]);
           }
       }
       cout << sum;
       return 0;
   }
    */
    set <int> b;
    int sum = 0;
   int num;
   for (int i = 0; i < n; ++i)
   {
       cin >> num;
       if (b.find(num) == b.end())
           b.insert(num);
       else {
           b.erase(b.find(num));
           sum^=(num + num);
       }
   }
    vector <int> ch;
   for (auto it = b.begin(); it != b.end(); ++it)
        ch.push_back(*it);
    for (int i = 0; i < ch.size(); ++i) {
        for (int j = i + 1; j < ch.size(); ++j) {
            sum = sum ^ (ch[i] + ch[j]);
        }
    }
    cout << sum;



   return 0;
}
