#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 4e5 + 7;
const int LOG = 25;
//const ll LOG = 3;

int n;
int a[N];
int hr[N][LOG];
int s[LOG][N];
int cnt[LOG];
int bts[LOG];

int ind, cur, mn, mx;

int gett01() {
	int res = 0;
	if ((cur + cur) <= mx && cur + cur >= mn) {
		res--;
	}
	int lind = lower_bound(s[ind], s[ind] + n, mn - cur) - s[ind];
	int rind = upper_bound(s[ind], s[ind] + n, mx - cur) - s[ind] - 1;
	res += (rind - lind + 1);
	return res % 4;
}

ll stupid() {
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			ans = (ans ^ (a[i] + a[j]));
		}
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		for (int j = 0; j < LOG; j++) {
			hr[i][j] = (a[i] & ((1 << (j + 1)) - 1));
			s[j][bts[j]++] = hr[i][j];
		}
	}
	for (int i = 0; i < LOG; i++) {
		sort(s[i], s[i] + n);
	}
	for (int j = 0; j < LOG; j++) {
		mn = (1 << j); mx = ((1 << (j + 1)) - 1);
		ind = j;
		for (int i = 0; i < n; i++) {
			cur = hr[i][j];
			cnt[j] += gett01();
		}
		mn += (1 << (j + 1));
		mx = ((1 << (j + 2)) - 1);
		for (int i = 0; i < n; i++) {
			cur = hr[i][j];
			cnt[j] += gett01();
		}
	}
	int ans = 0;
	for (int i = 0; i < LOG; i++) {
		cnt[i] /= 2;
		if (cnt[i] % 2 == 1) {
			ans += (1 << i);
		}
	}
	cout << ans;
//#ifdef _DEBUG
//	cout << nn << stupid();
//#endif // DEBUG

}