#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 
mt19937 rng(time(NULL));

bitset<300> b, cur;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) cin>>a[i];
	
	if (n <= 1000) {
		int ans = 0;
		for (int i = 0; i < n; ++i)
			for (int j = i+ 1; j < n; ++j) ans ^= a[i] + a[j];
		cout << ans;
		return 0;
	}
	
	for (int i = 0; i < n; ++i) {
		b ^= cur << a[i];
		if (cur[a[i]]) cur[a[i]] = 0;
		else cur[a[i]] = 1;
	}
	int ans = 0;
	for (int i = 0; i < 300; ++i) {
		if (b[i]) ans ^= i;
	}
	cout << ans;


	return 0;
}