#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <string>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

bitset <20'000'050> b;
bitset <20'000'050> ans;
vector <int> v;

void Solve() {
	int n;
	cin >> n;
	map <int, int> m;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		m[a]++;
	}
	for (auto i : m)
		if (i.second & 1)
			v.push_back(i.first);
	int prev = 0;
	for (int i = 0; i < v.size(); i++) {
		b <<= (v[i] - prev);
		prev = v[i];
		ans ^= b;
		b[v[i] + prev].flip();
	}
	ll res = 0;
	for (int i = 0; i < ans.size(); i++)
		if (ans[i])
			res ^= i;
	cout << res;
}

int main() {
	IOOptimize();
	Solve();
}