#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;
typedef unsigned short ushort;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

#define int ll

inline void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int ans = -1;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (ans == -1) {
				ans = a[i] + a[j];
			}
			else {
				ans ^= a[i] + a[j];
			}
		}
	}
	cout << ans;
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}