#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

typedef long long ll;

int main()
{

	fstream cin("input.txt");
	ofstream cout("output.txt");

	int n; cin >> n;
	vector <int> val(n), solve, tab(101);

	for (int i = 0; i < n; i++)
		cin >> val[i];

	if (n <= 1000)
	{
		for (int i = 0; i < n; i++)
			for (int j = i + 1; j < n; j++)
				solve.push_back(val[i] + val[j]);

		int ans = 0;
		for (int i = 0; i < solve.size(); i++)
			ans ^= solve[i];
		cout << ans;
		return 0;
	}

	for (int i = 0; i < n; i++)
		tab[val[i]]++;

	for (int i = 0; i <= 100; i++)
		for (int j = i; j <= 100; j++){
			if (j == i && (tab[i] * (tab[i] - 1) / 2) % 2 != 0)
				solve.push_back(i + i);
			else if (i != j && tab[i] * tab[j] % 2 != 0)
				solve.push_back(i + j);
		}

	int ans = 0;
	for (int i = 0; i < solve.size(); i++)
		ans ^= solve[i];
	cout << ans;

}

