#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

/*
vector<int> t;
vector<int> tree2;

void push(int v)
{
    tree2[2 * v + 1] = tree2[v];
    tree2[2 * v + 2] = tree2[v];
    //tree[v] = tree2[v];
}

int get(int v, int tl, int tr, int l, int r)
{
    if (l >= r)
    {
        return 0;
    }
    if (l == tl && r == tr)
    {
        return t[v];
    }
    if (l >= tr)
    {
        return 0;
    }
    if (r <= tl)
    {
        return 0;
    }
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, l, min(tm, r)) + get(2 * v + 2, tm, tr, max(l, tm), r);
}

void upd(int v, int tl, int tr, int pos, int val)
{
    if (pos < tl)
    {
        return;
    }
    if (pos >= tr)
    {
        return;
    }
    if (tl == tr - 1)
    {
        t[v] = val;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v + 1, tl, tm, pos, val);
    upd(2 * v + 2, tm, tr, pos, val);
}

vector<vector<int> > graph;
vector<int> used;


void dfs(int v, int p)
{
    if (used[v])
    {
        return;
    }
    used[v] = 1;
    for (int i = 0; i < graph[v].size(); ++i)
    {
        dfs(graph[v][i], v);
    }
}

vector<int> z_func(string s)
{
    int n = s.size();
    vector<int> z;
    for (int i = 1, l = 0, r = 0; i < n; ++i)
    {
        if (i <= r)
        {
            z[i] = min(r - i + 1, z[i - l]);
        }
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
        {
            z[i]++;
        }
        if (i + z[i] > r)
        {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}


void mask()
{
    int gg = 30;
    for (int i = 0; i < ((long long)1 << gg); ++i)
    {
        vector<int> used(gg);
        int tmp = i;
        for (int h = gg - 1; h >= 0; --h)
        {
            if (tmp >= ((long long)1 << h))
            {
                tmp -= ((long long)1 << h);
                used[h] = 1;
            }
        }
    }
}
*/

vector<int> hash_func(string s)
{
    int n = s.size();
    int p = 179;
    vector<int> hf(n);
    vector<int> p_pow(n);
    p_pow[0] = 1;
    for (int i = 1; i < n; ++i)
    {
        p_pow[i] = p_pow[i - 1] * p;
        p_pow[i] %= MOD;
    }
    hf[0] = (p_pow[0] * s[0]) % MOD;
    for (int i = 1; i < n; ++i)
    {
        hf[i] = (p_pow[i] * s[i] + hf[i - 1]) % MOD;
    }
    return hf;
}





signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    int sum = 0;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        sum += a[i];
    }
    if (n > 1000)
    {
        int cnt = 0;
        vector<int> used(1000);
        for (int i = 0; i < n; ++i)
        {
            used[a[i]]++;
        }
        for (int i = 0; i < 1000; ++i)
        {
            for (int j = i; j < 1000; ++j)
            {
                if (used[i] > 0 && used[j] > 0)
                {
                    if (i == j)
                    {
                        if (used[i] * (used[i] - 1) / 2 % 2 != 0)
                        {
                            cnt ^= 2 * i;
                        }
                    }
                    else
                    {
                        if ((used[i] * used[j]) % 2 != 0)
                        {
                            cnt ^= (i + j);
                        }
                    }
                }
            }
        }
        cout << cnt;
        return 0;
    }
    int cnt = 0;
    for (int i = n - 1; i >= 0; --i)
    {
        sum ^= cnt;
        int cnt2 = 0;
        for (int j = i + 1; j < n; ++j)
        {
            cnt ^= (a[i] + a[j]);
            cnt2 ^= (a[i] + a[j]);
        }
        //cout << cnt2 << ' ';
    }
    cout << cnt;
    return 0;
}
