#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

int n;
vector<int> ar;

void solve()
{
	int res = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			res ^= (ar[i] + ar[j]);
		}
	}
	cout << res << endl;
}

void solve2()
{
	vector<int> ar4(101, 0);
	for (int i = 0; i < n; ++i)
	{
		ar4[ar[i]] += 1;
	}
	int res = 0;
	for (int i = 0; i < 101; ++i)
	{
		for (int j = i + 1; j < 101; ++j)
		{
			if (ar4[j] * ar4[i] % 2 != 0)
				res ^= i + j;
		}
	}
	cout << res << endl;
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	int maxa = 0;
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		maxa = max(a, maxa);
		ar.push_back(a);
	}
	if (maxa >= 100)
		solve();
	else
		solve2();
}