#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

int n;
vector<int> a;

void gen() {
	n = rand() % 10 + 1;
	a.resize(n);
	ior(a)
		i = rand() % 10 + 1;
}

int solve() {
	map<int, pii> m;
	for (int i = 0; i < n; ++i) {
		for (int k = 0; k < 32; ++k)
			if ((a[i] >> k) & 1)
				m[k].first++;
	}
	int ans = 0;
	ior(m) {
		if (((n - i.second.first) * i.second.first + i.second.second) & 1)
			ans += (1 << i.first);
		if ((i.second.first - 1) * (i.second.first) / 2 + min(i.second.first, i.second.second))
			m[i.first + 1].second = ((i.second.first - 1) * (i.second.first) / 2 + min(i.second.first, i.second.second));
	}
	return ans;
}

int ssolve() {
	int ans = 0;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			ans ^= (a[i] + a[j]);
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	cin >> n;
	a.resize(n);
	ior(a)
		cin >> i;
	cout << ssolve();
	return 0;
}