#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

const int N = 5e5;

int n;
int a[N];

void solve1() {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            ans ^= a[i] + a[j];
        }
    }
    cout << ans << '\n';
}

const int A = 100;

int cnt[A];

void solve2() {
    for (int i = 0; i < n; ++i) {
        ++cnt[a[i]];
    }
    int ans = 0;
    for (int i = 0; i < A; ++i) {
        for (int j = 0; j < A; ++j) {
            ans ^= (cnt[i] * 1LL * cnt[j] & 1) * (i + j);
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n <= 1000) {
        solve1();
    }
    else {
        solve2();
    }
    return 0;
}