#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)4e5;
const int A = (int)2e2 + 1;

int n, a[N];
bitset <A> res, cur, prev_;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d", &n);
    rep(n, i) {
        scanf("%d", &a[i]);
    }
    if (n >= 1000) {
        int ans = 0;
        rep(n, i) {
            for (int j = i + 1; j < n; ++j) {
                ans ^= a[i] + a[j];
            }
        }
        printf("%d", ans);
    } else {
        for (int i = 1; i < n; ++i) {
            res.flip(a[0] + a[i]);
        }
        prev_ = res;
        for (int i = 1; i < n; ++i) {
            cur = prev_;
            cur.flip(a[i - 1] + a[i]);
            int d = a[i - 1] - a[i];
            cur <<= d;
            prev_ = cur;
            res ^= cur;
        }
        int ans = 0;
        rep(A, i) {
            if (res[i]) {
                ans ^= i;
            }
        }
        printf("%d", ans);
    }
    return 0;
}