#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

const int N = 500;
const ll inf = 1e18;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n;
vector <int> a;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n;

    if (n <= 1000) {
        a.assign(n, 0);
        for (int& x: a)
            cin >> x;
        int ans = 0;
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                ans ^= (a[i] + a[j]);

        cout << ans;
        return 0;
    }
    else {
        vector <int> ci(101, 0), su(201, 0);
        for (int i = 0; i < n; i++) {
            int x;
            cin >> x;
            ci[x]++;
        }
        for (int i = 1; i <= 100; i++) {
            su[2 * i] += ci[i] * (ci[i] - 1) / 2;
            for (int j = i + 1; j <= 100; j++)
                su[i + j] += ci[i] * ci[j];
        }
        int ans = 0;
        for (int i = 1; i <= 200; i++)
            if (su[i] % 2 == 1)
                ans ^= i;
        cout << ans;
    }

    return 0;
}
