#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;
const int mod = 1e9 + 7;

bool get_bit(int mask, int pos) {
    return (mask & (1 << pos)) != 0;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    rep(i, n) {
        cin >> a[i];
    }
    vector<int> suf(n, 0);
    for (int i = n - 1; i >= 0; --i) {
        if (i == n - 1) suf[i] = a[i];
        else suf[i] = suf[i + 1] + a[i];
    }
    int ans = 0;
    rep(i, n) {
        for (int j = i + 1; j < n; ++j) {
            ans ^= (a[i] + a[j]);
        }
    }
    cout << ans;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}