#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n;
    cin >> n;

    vector <int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    if (n > 1000) {
        vector <ll> cnt(101);
        for(int i = 0; i < n; i++) {
            cnt[a[i]]++;
        }

        vector <ll> dp(201);
        for(int i = 0; i < n; i++) {
            cnt[a[i]]--;

            for(int x = 1; x <= 100; x++) {
                dp[a[i] + x] += cnt[x];
            }
        }

        int ans = 0;
        for(int bit = 0; bit < 30; bit++) {
            int st = (1 << bit);

            ll col = 0;
            for(int x = 1; x <= 200; x++) {
                if ((x & st)) {
                    col += dp[x];
                }
            }

            col %= 2;

            ans += st * col;
        }

        cout << ans << "\n";
        return 0;
    }

    /*
    brute
    */

    int rans = 0;
    for(int i = 0; i < n; i++) {
        int res = 0;
        for(int j = i + 1; j < n; j++) {
            rans ^= (a[i] + a[j]);
        }
    }

    cout << rans << "\n";
    return 0;
}
