#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 4e5 + 100;
const int maxlog = 26;

const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int foo[maxlog][maxn];
int cnt[maxn];

int main() {
    init();


    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> foo[25][i];
    }
    sort(foo[25], foo[25] + n);

    for (int j = 24; j >= 0; j--){
        int deg = (1 << (j)) - 1;
        for (int i = 0; i< n; i++){
            foo[j][i] = foo[j + 1][i];
        }
        sort(foo[j], foo[j] + n, [&](int a, int b){
            return (a & deg) < (b & deg);
        });
    }

//    for (int i = 0; i < maxlog; i++){
//        for (int j = 0; j < n; j++){
//            cout << foo[i][j] << " ";
//        }
//        cout << endl;
//    }

    int maxbit = 25;
    int ans = 0;

    for (int bit = 0; bit < maxlog ; bit++){
        int deg = (1 << bit);


        cnt[0] = 0;
        for (int i = 0; i < n; i++){
            cnt[i + 1] = cnt[i] + ((foo[bit][i] & deg) > 0);
        }

//        cout << bit << endl;
//        for (auto ev: foo)
//            cout << ev << " ";
//        cout << endl;
//        for (auto ev: cnt)
//            cout << ev << " ";
//        cout << endl;

        int res = 0;
        for (int i = 0; i <n; i++){
            int l = 0;
            int r = i;
            while(l < r){
                int m = (l + r) / 2;
                if ((foo[bit][m] % deg + foo[bit][i] % deg) < deg)
                    l = m + 1;
                else
                    r = m;
            }
            if ((foo[bit][i] & deg) > 0){
                res += r - cnt[r] + (cnt[i] - cnt[r]);
            }
            else{
                res += cnt[r] + i - r + (cnt[i] - cnt[r]);
            }
        }
        if (res & 1)
            ans |= (1 << bit);
    }

    cout << ans << endl;

    return 0;
}