#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

int n;
vector<int> a;
set<int> s;

void solve() {
    cin >> n;
    a.resize(n);

    for (int i = 0, x; i < n; ++i) {
        cin >> x;
        if (s.count(x)) {
            s.erase(x);
        } else {
            s.insert(x);
        }
    }

    for (auto &i: s) {
        a.push_back(i);
    }

    n = a.size();

    int res = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            res ^= (a[i] + a[j]);
        }
    }

    cout << res nl;
}
