#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define add push_back
#define pw(x) (1ll << (x))
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
const ll INF = (ll)1e9 + 'b' + 'l' + 'i' + 'n' + 'k' + '-' + '1' + '8' + '2';

const int N = 4e5 + 10;
const int M = 1e7 + 10;
const int L = 30;
int arr[N], f[N], cnt[L];

ll calc(int n, int p) {
	memset(cnt, 0, sizeof(cnt));
	for (int i = 0; i < n; i++) {
		f[i] = -1;
		for (int j = 0; j <= p; j++) {
			if (arr[i] & pw(j)) {
				f[i] = j;
			}
		}
	}
	ll ans = 0, rez = 0;
	for (int i = 0; i < n; i++) {
		int res = p;
		while (res > 0 && (arr[i] & pw(res - 1))) {
			res--;
		}
		if (f[i] == p) {
			for (int j = 0; j < res; j++) {
				ans += cnt[j];
			}
			ans += rez;
		} else {
			for (int j = res; j <= p; j++) {
				ans += cnt[j];
			}
		}
		if (f[i] > -1) {
			cnt[f[i]]++;
		} else {
			rez++;
		}
	}
	return ans;
}

int fast(int n) {
	int ans = 0;
	for (int i = 0; i < L; i++) {
		if (calc(n, i) & 1) {
			ans |= pw(i);
		}
	}
	return ans;
}

int slow(int n) {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ans ^= (arr[i] + arr[j]);
		}
	}
	return ans;
}

void mane() {
	/*mt19937 rnd(time(0));
	for (int it = 0; it < 1000; it++) {
		int n = rnd() % 3 + 2;
		for (int i = 0; i < n; i++) {
			arr[i] = rnd() % 3 + 1;
		}
		sort(arr, arr + n);
		int f = fast(n), s = slow(n);
		if (f != s) {
			cerr << n << endl;
			for (int i = 0; i < n; i++) {
				cerr << arr[i] << " ";
			}
			cerr << endl << f << " " << s << endl;
			return;
		}
	}*/
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	cout << fast(n);
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	mane();
#ifdef osss
	cout << endl; cerr << endl << "\t max is the best" << endl;
#endif
}