#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>

using namespace std;

typedef int ll;

int main() {
	ll n;
	cin >> n;
	if (n <= 1000) {
		vector<ll> a(n);
		for (ll i = 0; i < n; ++i) {
			cin >> a[i];
		}
		ll result = 0;
		for (ll x = 0; x < n; ++x) {
			for (ll y = x + 1; y < n; ++y) {
				result ^= (a[x] + a[y]);
			}
		}
		cout << result << endl;
		return 0;
	}
	vector<ll> a(101);
	for (ll i = 0; i < n; ++i) {
		ll x;
		cin >> x;
		++a[x];
		a[x] &= 3;
	}
	vector<ll> res(a.size() + a.size());
	for (ll x = 0; x < (ll)a.size(); ++x) {
		for (ll y = 0; y < (ll)a.size(); ++y) {
			res[x + y] += a[x] * a[y];
		}
	}
	for (ll x = 0; x < (ll)a.size(); ++x) {
		res[x + x] -= a[x];
	}
	ll result = 0;
	for (ll x = 0; x < (ll)res.size(); ++x) {
		if (res[x] & 2) {
			result ^= x;
		}
	}
	cout << result << endl;
	return 0;
}
