#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

int n;
vector<int> a;
set<int> s, t;

void solve() {
    cin >> n;

    for (int i = 0, x; i < n; ++i) {
        cin >> x;

        if (s.count(x)) {
            s.erase(x);
            if (t.count(x * 2)) {
                t.erase(x * 2);
            } else {
                t.insert(x * 2);
            }
        } else {
            s.insert(x);
        }
    }

    for (auto &i: s) {
        a.push_back(i);
    }

    /*for (auto &i: a) cout << i sq;
    cout nl;

    for (auto &i: t) cout << i sq;
    cout nl;*/

    n = a.size();

    int res = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            res ^= (a[i] + a[j]);
        }
    }

    for (auto &i: t) res ^= i;

    cout << res nl;
}
