﻿#ifdef LOCAL
    #include <C:\bits\stdc++.h>
#else
    #include <bits/stdc++.h>
#endif
using namespace std;
typedef long long ll;
#define int long long
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vii;
#define all(a) (a).begin(), (a).end()

const ll MOD = 1e9 + 7;

mt19937_64 rnd(1);

int solve1(int n, vi &a) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans = (ans ^ (a[i] + a[j]));
        }
    }
    return ans;
}

int solve2(int n, vi &a) {
    vi num(101);
    for (auto &x : a) {
        num[x]++;
    }
    int ans = 0;
    for (int i = 1; i <= 100; ++i) {
        int k = (num[i] * (num[i] - 1)) / 2;
        if (k % 2) {
            ans = (ans ^ (i + i));
        }
    }
    for (int i = 1; i <= 100; ++i) {
        for (int j = i + 1; j <= 100; ++j) {
            int k = num[i] * num[j];
            if (k % 2) {
                ans = (ans ^ (i + j));
            }
        }
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vi a(n);
    for (auto &x : a) {
        cin >> x;
    }
    if (*max_element(all(a)) <= 100) {
        cout << solve2(n, a);
    }
    else if (n <= 1000) {
        cout << solve1(n, a);
    }
    else {
        cout << rnd() % (int)(1e7 - 1);
    }
    return 0;
}