#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

int m[(int)1.1e7];

void Solve() {
	int n;
	cin >> n;
	vector <int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	bitset <(int)1.1e7> b;
	for (int i : v) {
		m[i]++;
		b[i].flip();
	}
	int ans = 0;
	for (int i = 0; i <= 1.1e7; i++) {
		int count = 0;
		for (int j = 0; 2 * j < i; j++) {
			count += b[j] & b[i - j];
		}
		if (i % 2 == 0)
			count += (m[i/2] * (m[i/2] - 1) / 2) & 1;
		if (count % 2 == 1)
			ans ^= i;
	}
	cout << ans;

}

int main() {
	IOOptimize();
	Solve();
}