#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    if (n <= 1000)
    {
        vector<int> num(n);
        for (int i = 0; i < n; i++)
            cin >> num[i];

        int ans = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < i; j++)
                ans ^= (num[i] + num[j]);

        cout << ans << endl;
        return 0;
    }

    vector<ll> counts(201, 0);
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;

        counts[a]++;
    }

    ll ans = 0;
    for (int x = 0; x <= 200; x++)
    {
        ll cnt = 0;
        for (int y = 0; y <= x / 2; y++)
        {
            if (y + y == x)
                cnt += (counts[y] * (counts[y] - 1)) / 2ll;
            else
                cnt += counts[y] * counts[x - y];
        }

        if (cnt % 2 == 1)
            ans ^= x;
    }

    cout << ans << endl;

    return 0;
}