#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>
#include <bitset>

//#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	/*int n;
	cin >> n;
	veci a(32);
	vector<bitset<32>> vec(n, bitset<32>());
	int maxx = 0;
	for (int i = 0; i < n; i++) {
		int val;
		cin >> val;
		bitset<32> bit(val);
		maxx = max(maxx, val);
		for (int j = 0; j < 32; j++)
			a[j] += 1 * int(bit[j]);
		vec[i] = bit;
	}

	int len = ceil(log(maxx) / log(2));
	veci res(32);
	for (int i = 0; i < n; i++) {
		int p = 0;
		for (int j = 0; j < len; j++) {
			if (vec[i][j]) {
				p = (a[j] - 1);

				a[j]--;
			}
			else {
				res[j] += int((a[j] + p) % 2 == 1) * 1;
				p = 0;
			}
		}
	}*/
	int n;
	cin >> n;
	vector<char> a(n);
	for (int i = 0; i < n; i++) {
		int ch;
		cin >> ch;
		a[i] = ch;
	}

	int res = a[0] ^ a[1];
	for (int i = 2; i < n; i++)
		res ^= (a[0] + a[i]);

	for (int i = 1; i < n; i++)
		for (int j = i + 1; j < n; j++)
			res ^= (a[i] + a[j]);

	cout << int(res) << "\n";

	return 0;
}
