#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int dumbSolve(int n, vector<int> a)
{
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++) ans ^= (a[i] + a[j]);
    }
    return ans;
}


int kekSolve(int n, vector<int> a)
{
    const int maxa = 300;
    int cnt[maxa];
    int dp[maxa];
    for (int i = 0; i < maxa; i++)
    {
        cnt[i] = 0;
        dp[i] = 0;
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j + a[i] < maxa; j++)
        {
            dp[j + a[i]] += cnt[j];
        }
        cnt[a[i]]++;
    }
    int ans = 0;
    for (int i = 0; i < maxa; i++)
    {
        if (dp[i] % 2 == 0) continue;
        ans ^= i;
    }
    return ans;
}


const int lg = 25;


int calc(vector<int> a, int val)
{
    int ans = 0;
    int n = a.size();
    int cur = n;
    for (int i = 0; i < n; i++)
    {
        while (cur > 0 && a[i] + a[cur - 1] >= val) cur--;
        ans += min(n - cur, n - 1 - i);
    }
    return ans;
}


int anticalc(vector<int> low, vector<int> top, int val)
{
    int n = low.size(), m = top.size();
    int cur = m - 1;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        while (cur > -1 && low[i] + top[cur] >= val) cur--;
        ans += (cur + 1);
    }
    return ans;
}


int solve(int n, vector<int> a)
{
    int ans = 0;
    for (int i = 1; i > -1; i--)
    {
        vector<int> low;
        vector<int> top;
        for (int j = 0; j < n; j++)
        {
            int cur = a[j] % (1 << (i + 1));
            if (cur < (1 << i)) low.push_back(cur);
            else top.push_back(cur - (1 << i));
        }
        sort(low.begin(), low.end());
        sort(top.begin(), top.end());
        int temp = calc(low, (1 << i)) + calc(top, (1 << i)) + anticalc(low, top, (1 << i));
        if (temp % 2) ans += (1 << i);
    }
    return ans;
}


signed main()
{
    warp();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    cout << solve(n, a) << endl;
    /*
    if (n <= 1000) {cout << dumbSolve(n, a) << endl; return 0;}
    cout << kekSolve(n, a) << endl;
    */
    return 0;
}
