#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) x.begin(),x.end()
const int MN = 1e7 + 1;
const int INF = 1e8;
const int D = 26;
vector<int> fenw[D];
vector<int> ar[D];

void add(vector<int> &f, int x) {
    for (; x < f.size(); x = (x | (x + 1))) {
        f[x] += 1;
    }
}

void del(vector<int> &f, int x) {
    for (; x < f.size(); x = (x | (x + 1))) {
        f[x] -= 1;
    }
}

int gt(int i, vector<int> &f) {
    int s = 0;
    while (i >= 0) {
        s += f[i];
        i = (i & (i + 1)) - 1;
    }
    return s;
}

int gtsum(int l, int r, vector<int> &f) {
    if (l >= f.size())
        return 0;
    r = min((int) f.size() - 1, r);
    if (r < 0)
        return 0;
    if (l <= 0)
        return gt(r, f);
    return gt(r, f) - gt(l - 1, f);
}

void build(vector<int> &f, vector<int> &ar, int k) {
    f.resize((1 << (k + 1)));
    for (auto i : ar) {
        add(f, i);
    }
}


int main() {
    fast
    int n;
    cin >> n;
    int v[n];
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        for (int j = 0; j < D; j++) {
            int pr = (1 << (j + 1)) - 1;
            pr &= v[i];
            ar[j].emplace_back(pr);
        }
    }
    for (int i = 0; i < D; i++) {
        build(fenw[i], ar[i], i);
    }

    int s[D];
    memset(s, 0, sizeof(s));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < D; j++) {
            int pr = (1 << (j + 1)) - 1;
            pr &= v[i];
            del(fenw[j], pr);
            s[j] += gtsum((1 << j) - pr, (1 << (j + 1)) - 1 - pr, fenw[j]);
        }
    }
    int ans = 0;
    for (int i = 0; i < D; i++) {
        if (s[i] & 1)
            ans += (1 << i);
    }
    cout << ans;
}