/*DavitMarg*/
#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<string>
#include<cstring>
#include<set>
#include<queue>
#include<map>
#include<unordered_map>
#include<deque>
#include<cassert>
#define mod 1000000007ll
#define LL long long
#define LD long double
#define MP make_pair
#define PB push_back
#define all(v) v.begin(),v.end()
using namespace std;

const int N = 400005;

vector<int> t;
vector<int> L, R;
void addNode(int val = 0)
{
	t.PB(val);
	L.PB(0);
	R.PB(0);
}

void add(int v, int l, int r, int pos)
{
	if (l == r)
	{
		t[v]^=1;
		return;
	}
	if (L[v] == 0)
	{
		addNode();
		L[v] = t.size() - 1;
		addNode();
		R[v] = t.size() - 1;
	}
	int m = (l + r) / 2;
	if (pos <= m)
		add(L[v], l, m, pos);
	else
		add(R[v], m + 1, r, pos);
	t[v] = t[L[v]] ^ t[R[v]];
}

int get(int v, int l, int r, int i, int j)
{
	if (i > j)
		return 0;
	if (t[v] == 0)
		return 0;
	if (l == i && r == j)
		return t[v];
	int m = (l + r) / 2;
	int res = 0;
	if (L[v])
		res ^= get(L[v], l, m, i, min(j, m));
	if (R[v])
		res ^= get(R[v], m + 1, r, max(m + 1, i), j);
	return res;
}

void build()
{
	t.clear();
	L.clear();
	R.clear();
	addNode();
}

int n, mx;
int a[N], x[N], ans;

int get(int l, int r)
{
	l = max(l, 0);
	if (l > r)
		return 0;
	r = min(r, mx);
	return get(0, 0, mx, l, r);
}

void add(int x)
{
	add(0, 0, mx, x);
}

void rd(int &num)
{
	//4857
	//32
	//10
	num = 0;
	int x = getchar();
	while(!(x >= 48 && x <= 57))
		x = getchar();
	while (x >= 48 && x <= 57)
	{
		num *= 10;
		num += x - 48;
		x = getchar();;
	}
}


int main()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		//scanf("%lld", a + i);
		rd(a[i]);
		mx = max(a[i], mx);
	}
	random_shuffle(a + 1, a + 1 + n);
	mx *= 2;
	for (int k = 0; (1 << k) <= mx; k++)
	{
		int cnt = 0;
		int d = (1 << k);
		int dd = d * 3;
		for (int i = 1; i <= n; i++)
			x[i] += (d & a[i]);
		build();
		for (int i = 1; i <= n; i++)
		{
			cnt ^= get(d - x[i], d + d - 1 - x[i]);
			cnt ^= get(dd - x[i], dd + d - 1 - x[i]);
			add(x[i]);
		}
		ans += d * cnt;
	}

	cout << ans << endl;
	return 0;
}

/*

2
1 2

3
3 3 3

3
1 2 3


*/