#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n;
const int N = 400 * 1000, BIT = 24;
int a[N], m[BIT + 1][N];
ll cnt[BIT + 1];

signed main() {
	warp();

	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];


	sort(a, a + n);

	for (int i = 0; i < n; ++i) {
		int nw = 0;
		for (int bit = 0; bit <= BIT; ++bit) {
			int X = (((int)1 << bit) & a[i]);
			if (X) {
				nw += ((int)1 << bit);
			}

			m[bit][i] = nw;
		}
	}
	for (int bit = 0; bit <= BIT; ++bit) {
		sort(m[bit], m[bit] + n);
		//reverse(m[bit], m[bit] + n);
	}
	for (int bit = 0; bit <= BIT; ++bit) {
		for (int pl = 0; pl <= 1; ++pl) {
			int R = n - 1, L = 0;
			for (int i = 0; i < n; ++i) {
				int nw = m[bit][i];

				int MN = ((int)1 << (bit)) - nw,
					MX = ((int)1 << (bit + 1)) - 1 - nw;

				if (pl) {
					int XX = ((int)1 << (bit + 1));
					MN += XX, MX += XX;
				}
				while (R >= 0 && !(m[bit][R] <= MX))
					--R;
				while (R + 1 < n && (m[bit][R + 1] <= MX))
					++R;

				while (L < n && !(MN <= m[bit][L]))
					++L;
				while (L - 1 >= 0 && (MN <= m[bit][L - 1]))
					--L;

				if (MN <= nw && nw <= MX)
					cnt[bit] += max((R - L), (int)0);
				else
					cnt[bit] += max(R - L + 1, (int)0);
			}
		}
	}
	int ans = 0;
	for (int bit = 0; bit <= BIT; ++bit) {
		cnt[bit] /= 2;
		if (cnt[bit] % 2) {
			ans += ((int)1 << bit);
		}
	}
	cout << ans;
}