#include <iostream>
#include <list>
#define endl '\n'

using namespace std;

const long long MAXN = 4e5;
const long long MAXLG = 20;
const long long MAXA = 1e7;
long long n;
long long a[MAXN+10], ft[MAXA+10];
long long bt[MAXLG+10];
long long mx = 0, lg;
long long ans;

void input()
{
    cin>>n;
    for (long long i=0; i<n; i++)
    {
        cin>>a[i];
        mx = max(a[i], mx);
    }
}

void output()
{
    cout<<ans<<endl;
}

void printArray(const long long a[], const long long n)
{
    for (long long i=0; i<n; i++)
    {
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void printList(const list<pair<long long, long long>> &l)
{
    auto id = l.begin();
    while (id != l.end())
    {
        cout<<(*id).first<<' '<<(*id).second<<endl;
        id++;
    }
    cout<<endl;
}

void update(long long curr)
{
    while (curr <= mx)
    {
        ft[curr]++;
        curr += curr&(-curr);
    }
}

long long sum(long long curr)
{
    long long sm = 0;
    while (curr > 0)
    {
        sm += ft[curr];
        curr -= curr&(-curr);
    }
    return sm;
}

void solve2()
{
    ans = 0;

    mx = 1048576; lg = 20;

    for (long long i=0; i<n; i++)
        update(a[i]);

    list<pair<long long, long long>> l;
    l.push_back({0, 524288});
    l.push_back({524288, 1048576});

    for (long long j=lg-1; j>=0; j--)
    {
        for (long long i=0; i<n; i++)
        {
            auto id = l.begin();
            while (id != l.end())
            {
                id++;
                long long f = (*id).first - a[i];
                long long s = (*id).second - a[i] - 1;

                if (s <= 0)
                {
                    id++;
                    continue;
                }

                bt[j] += sum(s) - sum(f-1);
                if (a[i] >= f && a[i] <= s) bt[j]--;
                id++;
            }
        }
        auto id = l.begin();
        auto o_id = l.begin();
        while (id != l.end())
        {
            long long f = (*id).first;
            long long s = (*id).second;
            long long mid = (f+s)/2;
            (*id).first = mid;
            l.insert(id, {f, mid});
            id++;
        }
        //prlong longList(l);
    }

    //prlong longArray(bt, 10);

    long long p_pow = 1;
    for (long long i=0; i<MAXLG; i++)
    {
        bt[i] /= 2;
        ans += (bt[i] % 2) * p_pow;
        p_pow <<= 1;
    }
}

void solve1()
{
    ans = 0;
    for (long long i=0; i<n; i++)
    {
        for (long long j=i+1; j<n; j++)
        {
            ans ^= a[i]+a[j];
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve2();
    output();
    return 0;
}



