#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<ll> a(n);
    rep(i, 0, n) cin >> a[i];
    vector<vector<int>> mask(n, vector<int>(25, 0));
    rep(i, 0, n) rep(j, 0, 25) mask[i][j] = (a[i] >> (ll)j) & 1;
    vector<ll> zero(25, 0), one(25, 0);
    ll z = 0, o = 0;
    rep(i, 0, n) {
        if (mask[i][0]) z++;
        else o++;
    }
    one[0] = (o * z) % 2;
    zero[0] = z * z + o * o;
    vector<vector<ll>> val(n, vector<ll>(25, 0));
    rep(i, 0, n) {
        val[i][0] = mask[i][0];
        rep(j, 1, 25) val[i][j] = val[i][j - 1] + (mask[i][j] << (ll)j);
    }
    rep(bit, 1, 25) {
        vector<ll> inOne, inZero;
        rep(i, 0, n) {
            if (mask[i][bit]) inOne.pb(val[i][bit - 1]);
            else inZero.pb(val[i][bit - 1]);
        }
        sort(all(inOne));
        sort(all(inZero));
        rep(i, 0, n) {
            ll need = (1LL << (ll)bit) - val[i][bit - 1];
            if (mask[i][bit]) {
                auto zi = lower_bound(all(inZero), need);
                auto oi = lower_bound(all(inOne), need);
                one[bit] += (ll)(zi - inZero.begin());
                one[bit] += (ll)(inOne.end() - oi);
                //zero[bit] += (ll)(oi - inOne.begin());
                //zero[bit] += (ll)(inZero.end() - zi);
                if (need <= val[i][bit - 1]) one[bit]--;
                //else zero[bit]--;
            } else {
                auto zi = lower_bound(all(inZero), need);
                auto oi = lower_bound(all(inOne), need);
                one[bit] += (ll)(inZero.end() - zi);
                one[bit] += (ll)(oi - inOne.begin());
                //zero[bit] += (ll)(zi - inZero.begin());
                //zero[bit] += (ll)(inOne.end() - oi);
                if (need <= val[i][bit - 1]) one[bit]--;
                //else zero[bit]--;
            }
        }
        zero[bit] /= 2, one[bit] /= 2;
    }
    ll ans = 0;
    rep(i, 0, 25) ans += ((one[i] % 2) << (ll)i);
    cout << ans << '\n';
}
