#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

int get(set<int> st, int sum, int curr, vector<int> &angry, vector<int> &pay, vector<int> &cost){
    int ans = sum - pay[curr] + cost[angry[curr]];
    int add = angry[curr];
    while (st.find(add) != st.end()){
        st.erase(add);
        add++;
        ans += cost[add];
    }
    st.insert(add);
    return ans;
}

set<int> build(set<int> st, int add){
//    cout << "build " << add << endl;
//    for (int el : st)
//        cout << el << " ";
    while (st.find(add) != st.end()){
        st.erase(add);
        add++;
    }
    st.insert(add);
//    cout << endl;
//    for (int el : st)
//        cout << el << " ";
//    cout << endl;
    return st;
}

signed main(){
    //freopen("inp", "r", stdin);
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<int> angry(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> angry[i];
    angry[0] = 1e9;
    vector<int> pay(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> pay[i];
    vector<int> cost(n + m + 1);
    for (int i = 1; i <= n + m; i++)
        cin >> cost[i];

    vector<vector<int>> bigger(n + 1);
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < i; j++)
            if (angry[j] >= angry[i])
                bigger[i].pb(j);
    }

    vector<pair<set<int>, int>> dp(n + 1);
    int pos, val, temp;
    for (int i = 1; i <= n; i++){
        pos = 0; val = 0;
        for (int el : bigger[i]){
            temp = get(dp[el].ft, dp[el].sd, i, angry, pay, cost);
            //cout << "i: " << i << " el: " << el << " " << temp << endl;
            if (temp > val){
                pos = el;
                val = temp;
            }
        }
        //cout << "i: " << i << " pos: " << pos <<endl;
        dp[i] = {build(dp[pos].ft, angry[i]), val};
//        cout << "i: " << i << " " << val << endl;
//        for (int el : dp[i].ft)
//            cout << el << " ";
//        cout << endl;
    }

    int mx = 0;
    for (auto &el : dp)
        if (el.sd > mx)
            mx = el.sd;
    cout << mx;

    return 0;
}