#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void solve1(int n, int m){
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    sort(s.begin(), s.end());
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++){
        cin >> c[i];
    }

    int ans = 0;
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum -= s[i];
        int cur = sum;
        int cnt = i + 1;
        int now = 0;
        while (cnt > 0){
            cur += (cnt * c[now]);
            now++;
            cnt /= 2;
        }
        ans = max(ans, cur);
    }
    cout << ans << "\n";
}

void solve2(int n, int m){
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++){
        cin >> c[i];
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        int mn = 1e9;
        bool good = true;
        int cur = 0;
        vector<int> cnt(n + m, 0);
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1){
                if (a[i] > mn){
                    good = false;
                    break;
                }
                mn = min(mn, a[i]);
                cur -= s[i];
                cnt[a[i]]++;
            }
        }
        if (!good){
            continue;
        }
        for (int i = 0; i < n + m; i++){
            cur += (cnt[i] * c[i]);
            if (i < n + m - 1){
                cnt[i + 1] += (cnt[i] / 2);
            }
        }
        ans = max(ans, cur);
    }
    cout << ans << endl;
}

int main()
{
    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    if (m == 1){
        solve1(n, m);
    }else{
        solve2(n, m);
    }
    return 0;
}
