#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m + 3);
    for (int &i : l)
        cin >> i;
    for (int &i : s)
        cin >> i;
    for (int i = 1; i <= n + m; ++i)
        cin >> c[i];
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int res = 0, cmin = INF;
        vector<int> cnt(n + m + 3);
        for (int j = i; j < n; ++j) {
            if (l[j] > cmin)
                continue;
            //++cnt[l[j]];
            int sum = c[l[j]] - s[j];
            for (int k = l[j]; k < n + m + 3 && cnt[k] > 0; ++k) {
                sum += c[k + 1];
            }
            if (sum >= 0) {
                res += sum;
                cmin = min(cmin, l[j]);
                ++cnt[l[j]];
                for (int k = l[j]; k < n + m + 3 && cnt[k] > 1; ++k) {
                    ++cnt[k + 1];
                    cnt[k] = 0;
                }
            }
        }
        ans = max(ans, res);
    }
    cout << ans << '\n';
}