#include <bits/stdc++.h>

using namespace std;

void solver(int n) {
    vector<int> normr(n);
    for (int i = 0; i < n; ++i) {
        cin >> normr[i];
        normr[i] = (normr[i] == 1);
    }
    vector<int> costs;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (normr[i])
           costs.push_back(i);
    }
    sort(costs.begin(), costs.end());
    vector<int> mon(n + 1);
    for (int i = 0; i < n + 1; ++i)
        cin >> mon[i];
    int ans = 0;
    for (int i = 0; i < costs.size(); ++i) {
        int cur = 0;
        for (int j = 0; j <= i; ++j)
            cur -= costs[j];
        int icop = i, tim = 0;
        while (icop > 0) {
            cur += icop * mon[tim++];
            icop /= 2;
        }
        ans = max(ans, cur);
    }
    cout << ans << '\n';
}

void solve() {
    int n, m;
    cin >> n >> m;
    if (m == 1) {
        solver(n);
        return;
    }
    vector<int> agr(n), cost(n), vals(n + m + 1);
    for (int i = 0; i < n; ++i)
        cin >> agr[i];
    for (int i = 0; i < n; ++i)
        cin >> cost[i];
    for (int i = 0; i < n + m; ++i)
        cin >> vals[i + 1];
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask)  {
        int st = m;
        bool skip = false;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask) {
                if (agr[i] > st)
                    skip = true;
                st = min(st, agr[i]);
            }
        if (skip)
            continue;
        int mins = 0;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask)
                mins += vals[agr[i]] - cost[i];
        set<int> in;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask) {
                int now = agr[i];
                while (true) {
                    if (in.find(now) == in.end()) {
                        in.insert(now);
                        break;
                    } else {
                        in.erase(now);
                        ++now;
                        mins += vals[now];
                    }
                }
            }
            ans = max(ans, mins);
    }
    cout << ans << '\n';
}
#define DEBUGs

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
