#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;
typedef unsigned short ushort;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//#define int ll

bool check(vector<int> &poses, vector<int> &agr) {
	//return 1;
	if (!poses.size()) {
		return 1;
	}
	int mi = agr[poses[0]];
	for (int i = 1; i < poses.size(); i++) {
		if (agr[poses[i]] > mi) {
			return 0;
		}
		mi = min(mi, agr[poses[i]]);
	}
	return 1;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> agr(n), cost(n), dohod(n + m);
	for (int i = 0; i < n; i++) {
		cin >> agr[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> cost[i];
	}
	for (int i = 0; i < n + m; i++) {
		cin >> dohod[i];
	}
	int max_mask = 1 << n;
	int ans = 0;
	for (int mask = 0; mask < max_mask; mask++) {
		vector<int> poses;
		int mon = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				poses.push_back(i);
				mon -= cost[i];
				mon += dohod[agr[i] - 1];
			}
		}
		if (!check(poses, agr)) {
			continue;
		}
		multiset<int> cur_agr;
		for (auto t : poses) {
			int ag = agr[t];
			while (cur_agr.find(ag) != cur_agr.end()) {
				cur_agr.erase(cur_agr.find(ag));
				ag++;
				mon += dohod[ag - 1];
			}
			cur_agr.insert(ag);
		}
		ans = max(ans, mon);
	}
	cout << ans;
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}