#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int aggr[2009];
int cost[2009];
int gain[4009];

int dp[209][209][209];
int pref[4009];

const int inf = 1e15;

inline int sumlr(int l, int r) {
    return pref[r] - pref[l - 1];
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i ++) cin >> aggr[i];
    for (int i = 0; i < n; i ++) cin >> cost[i];
    for (int i = 1; i <= n + m; i ++) cin >> gain[i];
    for (int i = 1; i <= n + m; i ++) pref[i] = pref[i - 1] + gain[i];

    for (int i = 0; i <= n; i++) {
        for (int a1 = 1; a1 <= m + 3; a1++) {
            for (int a2 = 1; a2 <= m; a2++) {
                dp[i][a1][a2] = -inf;
                dp[i][a1][m + 3] = 0;
            }
        }
    }

    for (int i = 0; i < n; i ++) {
        int b = aggr[i];
        for (int a1 = 1; a1 <= m; a1++) {
            for (int a2 = 1; a2 <= m; a2++) {
                dp[i + 1][a1][a2] = max(dp[i + 1][a1][a2], dp[i][a1][a2]);
                if (b > a1) continue;
                if (b == a1) {
                    dp[i + 1][a1][m + 3] = max(dp[i + 1][a1][m + 3], dp[i][a1][a2] + sumlr(a1 + 1, a2 + 1) - cost[i] + gain[b]);
                }

                else if (b == a1 - 1) {
                    dp[i + 1][a1 - 1][a2] = max(dp[i + 1][a1 - 1][a2], dp[i][a1][a2] - cost[i] + gain[b]);
                }

                else {
                    dp[i + 1][b][b] = max(dp[i + 1][b][b], dp[i][a1][a2] - cost[i] + gain[b]);
                }
            }
        }

        for (int a1 = 1; a1 <= m; a1++) {
            dp[i + 1][a1][m + 3] = max(dp[i + 1][a1][m + 3], dp[i][a1][m + 3]);
            if (b > a1) continue;
            dp[i + 1][b][b] = max(dp[i + 1][b][b], dp[i][a1][m + 3] - cost[i] + gain[b]);
        }
    }

    int answ = 0;
    for (int i = 0; i <= n; i ++) {
        for (int a1 = 1; a1 <= m; a1++) {
            for (int a2 = 1; a2 <= m + 3; a2++) {
                if (a2 > m && a2 != m + 3) continue;
                answ = max(answ, dp[i][a1][a2]);
                //cout <<  i << ' ' << a1 << ' ' << a2 << ' ' << dp[i][a1][a2] << endl;
            }
        }
    }

    cout << answ;

    return 0;
}



