#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);

const int N = 2000;

int n, m;

int l[4000];
int s[4000];
int c[4000];

int solve1() {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        ll res = 0;
        set<int> used;
        map<int, int> cnt;
        bool f = true;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                if (!used.empty() && l[i] > *used.begin())
                    f = false;
                used.emplace(l[i]);
                res -= s[i];
                cnt[l[i]]++;
            }
        }
        if (!f)
            continue;
        for (int i = 1; i <= 30; i++) {
            res += c[i] * cnt[i];
            while (cnt[i] > 1) {
                cnt[i] -= 2;
                //res += c[i + 1];
                cnt[i + 1]++;
            }
        }
        ans = max(ans, res);
    }
    return ans;
}

int solve2() {
    ll ans = 0;
    sort(s, s + n);
    ll cur = 0;
    vector<int> kek(20, 0);
    for (int i = 0; i < n; i++) {
        cur -= s[i];
        kek[1]++;
        cur += c[1];
        for (int j = 1; j < 20; j++) {
            if (kek[j] == 2) {
                cur += c[j + 1];
                kek[j + 1]++;
                kek[j] = 0;
            }
        }
        ans = max(ans, cur);
    }
    return ans;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
    ///--------------------------------------------------------///
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> l[i];
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int i = 1; i <= n + m; i++)
        cin >> c[i];
    if (n <= 15 && m <= 15) {
        cout << solve1();
        return 0;
    }
    if (m == 1) {
        cout << solve2();
        return 0;
    }
    ///--------------------------------------------------------///
}