#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 4e3 + 5;

int n, m;
int agr[MAXN];
int cost[MAXN];
int benefit[MAXN];

bool cmp(int i, int j) {
	return cost[i] < cost[j];
}

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

void solve() {
	int ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<int> counter(n + m + 2);
		int curcost = 0;
		int prev = 1e9;
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			if (check_bit(mask, i)) {
				if (agr[i] > prev) ok = false;
				prev = agr[i];
				counter[agr[i]]++;
				curcost -= cost[i];
			}
		}
		if (!ok) continue;
		for (int i = 1; i <= n + m; ++i) {
			if (counter[i] == 0) continue;
			curcost += benefit[i] * counter[i];
			counter[i] /= 2;
			counter[i + 1] += counter[i];
		}
		ans = max(ans, curcost);
	}
	cout << ans << endl;
}

void solve1() {
	vector<int> indices;
	for (int i = 0; i < n; ++i) indices.push_back(i);
	sort(indices.begin(), indices.end(), cmp);
	int ans = 0;
	int curcost = 0;
	for (int i = 0; i < n; ++i) {
		curcost -= cost[indices[i]];
		int adding = 0;
		int num = i + 1;
		int step = 1;
		while (num >= 2) {
			adding += num * benefit[step];
			num /= 2;
			++step;
		}
		adding += num * benefit[step];
		ans = max(ans, curcost + adding);
	}
	cout << ans << endl;
}

int main() {	
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> agr[i];
	}
	for (int i = 0; i < n; ++i) cin >> cost[i];
	for (int i = 1; i <= n + m; ++i) {
		cin >> benefit[i];
	}
	if (n > 15 || m > 15) solve1();
	else solve();
	return 0;
}