#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//comments
/*
	1) 
*/

void zp(vector<int> &v)
{
	for (int i = 1; i < v.size(); ++i)
		cin >> v[i];
}
vector<int> l, s, c, dp;
vector<set<int>> incl;

set<int> nulls;
pair<int, set<int>> include_(int pack, int add)
{
	if (incl[pack].size() && l[add] > *incl[pack].rbegin())
		return { 0, nulls };
	set<int> res = incl[pack];
	int ans = dp[pack];
	ans -= s[add];

	int agr = l[add];
	ans += c[agr];
	while (res.find(agr) != res.end())
	{
		res.erase(agr);
		++agr;
		ans += c[agr];
	}
	res.insert(agr);

	return { ans, res };
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	
	int n, m;
	cin >> n >> m;

	l.resize(n + 1); //Агрессивновсть каждого участника
	s.resize(n + 1); // Количество рублей за s[i] участника надо потратить
	c.resize(n + m + 1); // Уровень дохода за c[i] агрессивность
	zp(l); zp(s); zp(c);

	dp.resize(n + 1); //dp[i] - максимальная сумма для префикса длиной i
	dp[0] = 0;
	incl.resize(n + 1);
	for (int i = 1; i <= n; ++i)
	{
		int maxi = 0;
		set<int> maxim;
		for (int j = 0; j < i; ++j)
		{
			auto res = include_(j, i);
			if (res.first > maxi)
			{
				maxi = res.first;
				maxim = res.second;
			}
		}

		dp[i] = maxi;
		incl[i] = maxim;
	}

	cout << dp[n];
	return 0;
}