#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll Inf = 1e18;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int i = 0; i < n; ++i) cin >> l[i];
	vector <int> s(n);
	for (int i = 0; i < n; ++i) cin >> s[i];
	reverse(l.begin(), l.end());
	reverse(s.begin(), s.end());
	vector <ll> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i) cin >> c[i];	
	vector <ll> pref(n + m + 2);
	for (int i = 0; i <= n + m; ++i) pref[i + 1] = pref[i] + c[i];
	auto get = [&] (int l, int r) {
		return pref[r + 1] - pref[l];
	};
	vector <vector <ll>> dp(n + 1, vector <ll> (n + m + 2, -Inf));
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			if (i > 0 && l[i - 1] > l[j]) continue;
			for (int k = 0; k <= n + m; ++k) {
				if (dp[i][k] == -Inf) continue;
				if (k <= l[j]) {
					dp[j + 1][l[j] + 1] = max(dp[j + 1][l[j] + 1], dp[i][k] - s[j] + c[l[j]]);
				} else {
					dp[j + 1][k + 1] = max(dp[j + 1][k + 1], dp[i][k] - s[j] + get(l[j], k)); 
				}
			}
		}
	}
	ll ans = -Inf;
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n + m + 1; ++j) {
			ans = max(ans, dp[i][j]);
			//cout << dp[i][j] << ' ';
		}
		//cout << '\n';
	}
	cout << ans << '\n';
}