#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define ll long long

vector <int> t;
vector <int> mod;
void build_tree (int v, int tl, int tr, vector <int> & a)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr)/2;
        build_tree(v*2, tl, tm, a);
        build_tree(v*2 + 1, tm + 1, tr, a);
        t[v] = t[v*2] + t[v*2 + 1];
    }
}

void push(int v, int tl, int tr)
{
    if (mod[v]!= 0 && v*2 + 1 < t.size())
    {

        mod[v*2] = mod[v*2 + 1] = mod[v];
        mod[v] = 0;
        int tm = (tl + tr)/2;
        t[v*2] = mod[v*2]*(tm - tl + 1);
        t[v*2 + 1] = mod[v*2 + 1]*(tr - tm);
    }
}

int get_sum (int l, int r, int v, int tl, int tr)
{
    if (tl >= l && tr <= r)
        return t[v];
    if (tl > r || tr < l)
        return 0;
    push(v, tl, tr);
    int tm = (tl + tr)/2;
    return get_sum(l, r, v*2, tl, tm) + get_sum(l, r, v*2 + 1, tm + 1, tr);


}

void ass (int l, int r, int v, int tl, int tr, int val)
{
    if (tl >= l && tr <= r)
    {
        mod[v] = val;
        t[v] = (tr - tl + 1)*val;

        return;
    }
    if (tl > r || tr < l)
        return;
    push(v, tl, tr);
    int tm = (tl + tr)/2;

    ass(l, r, v*2, tl, tm, val);
    ass(l, r, v*2 + 1, tm + 1, tr, val);
    t[v] = t[v*2] + t[v*2 + 1];


}

void bfs(vector <vector <int>> & g, int st, int end, vector <int> & p, vector <vector <int>> & path, vector <bool> & used, int num)
{

    used.resize(g.size(), false);
    queue <int> q;
    p[st] = -1;
    used[st] = true;
    q.push(st);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < (int) (g[v].size()); ++i)
        {
            if (used[g[v][i]])
                continue;
            q.push(g[v][i]);
            used[g[v][i]] = true;
            p[g[v][i]] = v;

        }
    }
    int u = end;
    while (1)
    {
        path[num].push_back(u);
        u = p[u];
        if (u == -1)
            break;
    }


}

void dfs(vector <vector <int>> & g,  int v, vector <int> & c)
{
    for (int i = 0; i < (int) (g[v].size()); ++i)
    {
        if (g[v][i] != 1)
            continue;
        if (c[v] >= c[i])
            c[i] = c[v] + 1;
        dfs(g, i, c);
    }


}


int main() {
   int n, m;
   cin >> n >> m;
   vector <int> agr(n);
   for (int i = 0; i < n; ++i)
       cin >> agr[i];
   vector <int> c(n + m + 1);
    vector <int> s(n);
    for (int i = 0; i < n; ++i)
        cin >> s[i];

    for (int i = 1; i < n + m + 1; ++i)
        cin >> c[i];
    int SUM = 0;
    vector <int> kol(n + m + 1, 0);
    if (m == 1)
    {
        sort(s.begin(), s.end());

        for (int i = 0; i < n; ++i)
        {
            kol.assign(n + m + 1, 0);
            int itog = 0;
            for (int j = 0; j <= i; ++j) {
                kol[agr[j]]++;
                itog-=s[j];
                itog+= c[agr[j]];
            }
            int id = 1;
            while (id <= n + m)
            {
                if (kol[id] <= 1)
                {
                    id++;
                    continue;
                }
                kol[id]-=2;
                kol[id + 1]++;
                itog+=c[id + 1];
            }
            if (itog > SUM)
                SUM = itog;

        }



        cout << SUM;
        return 0;
    }
    vector <int> nom;
    int f;
    for (int num = 1; num < pow(2, n); ++num)
    {
        int id = 0;
        int x = num;
        nom.clear();
        while (x!= 0)
        {
            if (x%2 == 1)
                nom.push_back(id);
            id++;
            x/=2;
        }
        f = 0;
        for (int i = 0; i < nom.size() - 1; ++i)
        {
            if (agr[nom[i]] < agr[nom[i + 1]])
            {
                f = 1;
                break;
            }
        }
        if (f == 1)
            continue;


            kol.assign(n + m + 1, 0);
            int itog = 0;
            for (int i = 0; i < nom.size(); ++i)
            {
                itog+= c[agr[nom[i]]];
                itog-=s[nom[i]];
                kol[agr[nom[i]]]++;
            }
            id = 1;
            while (id <= n + m)
            {
                if (kol[id] <= 1)
                {
                    id++;
                    continue;
                }
                kol[id]-=2;
                kol[id + 1]++;
                itog+=c[id + 1];
            }
            if (itog > SUM)
                SUM = itog;





    }

    cout << SUM;

   return 0;
}
