#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}
#define int ll
const int MAXN = 2010;
int n, m;
int l[MAXN];
int s[MAXN];
int c[MAXN * 2];

void read() {
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		l[i]--;
	}
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n + m; i++)
		cin >> c[i];
}

bool check(int mask) {
	int now = 1e9;
	for (int i = 0; i < n; i++) {
		if (!((mask >> i) & 1)) continue;
		if (now < l[i]) return false;
		chkmin(now, l[i]);
	}
	return true;
}

int calc(int mask) {
	if (!check(mask)) return false;
	int ans = 0;
	set<int> have;
	for (int i = 0; i < n; i++) {
		if (!((mask >> i) & 1)) continue;
		ans -= s[i];
		ans += c[l[i]];
		int x = l[i];
		while (have.count(x)) {
			ans += c[x + 1];
			have.erase(x);
			x++;
		}
		have.insert(x);
	}
	return ans;
}

int ans;

void run() {
	ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		chkmax(ans, calc(mask));
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}