#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include  <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>

using namespace std;

struct pers
{
    int aggr;
    int price;
};
vector <long long int> money;
bool operator < (pers one, pers two)
{
    return(one.price < two.price);
}
int fight(int n)
{
    int sum = n;
    int k = 2;
    while (n > 1)
    {
        n = n / 2;
        sum = sum + n * k;
        k++;
    }
    return(sum);
}

int main()
{
    long long int n, m, i, j;
    cin >> n >> m;
    if (m == 1)
    {
        pers a[n];
        for (i = 0; i < n; i++)
        {
            cin >> a[i].aggr;
        }
        for (i = 0; i < n; i++)
        {
            cin >> a[i].price;
        }
        money.resize(n + m + 1);
        for (i = 1; i <= n + m; i++)
        {
            cin >> money[i];
        }
        stable_sort(a, a + n);
        int pref[n + 1];
        pref[0] = 0;
        for (i = 1; i <= n; i++)
        {
            pref[i] = pref[i - 1] + a[i - 1].price;
        }
        int ans = 0;
        for (i = 0; i < n; i++)
        {
            ans = max(ans, fight(i) - pref[i]);
        }
        cout << ans;
        return 0;
    }
    long long int aggr[n];
    for (i = 0; i < n; i++)
    {
        cin >> aggr[i];
    }
    long long int price[n];
    for (i = 0; i < n; i++)
    {
        cin >> price[i];
    }
    money.resize(n + m + 1);
    for (i = 1; i <= n + m; i++)
    {
        cin >> money[i];
    }
    long long int ans = -1e18;
    for (i = 0; i < (1 << n); i++)
    {
        long long int up = 0;
        set <long long int> onScene;
        bool checker = true;
        long long int minBef = 1e18;
        for (j = 0; j < n; j++)
        {
            if (i & (1 << j))
            {
                if (aggr[j] > minBef)
                {
                    checker = false;
                    break;
                }
                minBef = min(minBef, aggr[j]);
                up = up - price[j] + money[aggr[j]];
                int toAdd = aggr[j];
                while (onScene.find(toAdd) != onScene.end())
                {
                    onScene.erase(onScene.find(toAdd));
                    toAdd++;
                    up = up + money[toAdd];
                }
                onScene.insert(toAdd);
            }
        }
        if (checker)
            ans = max(ans, up);
    }
    cout << ans;
    return 0;
}
