#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 205, M = 805, lg = 9;
const int INF = 2000000000 + 7;

int n, m, a[N], s[N], c[M], pref[M], nxt[N], dp[N][1 << lg][M], ans = 0, l = 0;

void init() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < (1 << lg); j++) {
            for (int k = 0; k < M; k++) {
                dp[i][j][k] = -INF;
            }
        }
        nxt[i] = INF;
    }
    for (int i = 1; i <= n + m; i++)
        pref[i] = pref[i - 1] + c[i];
    for (int i = 0; i < n; i++) {
        dp[i][0][0] = 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[j] <= a[i]) {
                nxt[i] = j;
                break;
            }
        }
    }
}

signed main()
{
    fast_io;

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i++) {
        cin >> c[i + 1];
    }
    init();

    for (int i = 0; i < n; i++) {
        for (int mask = 0; mask < (1 << lg); mask++) {
            for (int col = 0; col < n; col++) {

                if (dp[i][mask][col] == -INF)
                    continue;
                ans = max(ans, dp[i][mask][col]);

                int nmask = mask, ncol = col;
                if (nxt[i] != INF) {
                    for (int j = 0; j < a[i] - a[nxt[i]]; j++) {
                        if (nmask == 0 && ncol == 0)
                            break;
                        if (nmask&(1 << (lg - 1)))
                            ncol++;
                        else
                            ncol = 0;
                        nmask <<= 1;
                        nmask &= ((1 << lg) - 1);
                    }
                    dp[nxt[i]][nmask][ncol] = max(dp[nxt[i]][nmask][ncol], dp[i][mask][col]);
                }

                nmask = mask, ncol = col;
                int gain = -s[i];

                nmask++;
                int lst = __builtin_ctz(nmask);
                if (lst == lg) {
                    lst += col;
                    ncol = 0;
                }
                gain += pref[a[i] + lst] - pref[a[i] - 1];
                nmask &= ((1 << lg) - 1);

                ans = max(ans, dp[i][mask][col] + gain);

                if (nxt[i] != INF) {
                    for (int j = 0; j < a[i] - a[nxt[i]]; j++) {
                        if (nmask == 0 && ncol == 0)
                            break;
                        if (nmask&(1 << (lg - 1)))
                            ncol++;
                        else
                            ncol = 0;
                        nmask <<= 1;
                        nmask &= ((1 << lg) - 1);
                    }
                    dp[nxt[i]][nmask][ncol] = max(dp[nxt[i]][nmask][ncol], dp[i][mask][col] + gain);
                }
            }
        }
    }
    cout << ans;

    return 0;
}

/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4
*/
