#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    l.resize(n);
    for (int &i : l) cin >> i;
    s.resize(n);
    for (int &i : s) cin >> i;
    c.resize(n + m + 1);
    for (int i = 1; i <= n + m; i++) cin >> c[i];

    int answer = -((int)1e9);
    for (int mask = 1; mask < (1 << n); mask++) {
        int givenMoney = 0;
        bool ok = true;
        int prevAgression = (int)1e9;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                givenMoney += s[i];
                if (l[i] > prevAgression) {
                    ok = false;
                    break;
                }
                prevAgression = l[i];
            }
        }

        if (!ok) {
            continue;
        }

        int receivedMoney = 0;
        map<int, int> argessives;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                argessives[l[i]]++;
            }
        }
        for (auto &i : argessives) {
            receivedMoney += i.second * c[i.first];
        }
        for (auto &i : argessives) {
            if (i.second == 1) {
                continue;
            }
            int cnt = i.second >> 1;
            receivedMoney += cnt * c[i.first + 1];
            argessives[i.first + 1] += cnt;
            argessives[i.first] &= 1;
        }

        answer = max(answer, receivedMoney - givenMoney);
    }

    cout << answer << endl;

    return EXIT_SUCCESS;
}
