#include <bits/stdc++.h>
using namespace std;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 50;
int dp[maxn][maxn][maxn][maxn];
int dp2[2001][25][25][25];

struct ps {
    int a, s;
    bool operator<(const ps &other) {
        return a > other.a;
    }
};

vector<int> s;

int sum(int x, int l) {
    int ans = 0;
    for (int i = x; i < x + l && i < s.size(); i++) ans += s[i];
    return ans;
}

int n, m;

void solve_lil() {
    vector<int> a(n + 10), p(n + 10);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> p[i];
    s.resize(n + m + 10);
    for (int i = 1; i <= n + m; i++) cin >> s[i];
    vector<ps> f(n + 1);
    for (int i = 1; i <= n; i++) f[i] = {a[i], p[i]};
    memset(dp2, 0x80, sizeof dp2);
    dp2[0][m + 2][0][m + 2] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= 23; j++) for (int k = 0; k <= 23; k++) for (int l = 0; l <= 23; l++) dp2[i][j][k][l] = dp2[i - 1][j][k][l];
        int j_ = f[i].a;
        for (int l = j_; l <= 23; l++) {
            for (int k = 1; k <= 23; k++) dp2[i][j_][k][j_] = max(dp2[i][j_][k][j_], dp2[i - 1][j_ + 1][k - 1][l] - f[i].s + s[j_]);
            for (int j = j_ + 2; j <= 23; j++) {
                for (int k = 0; k <= 23; k++) dp2[i][j_][0][j_] = max(dp2[i][j_][0][j_], dp2[i - 1][j][k][l] - f[i].s + s[j_]);
            }
            for (int k = 0; k <= 23; k++) dp2[i][j_ + k + 1][0][j_] = max(dp2[i][j_ + k + 1][0][j_], dp2[i - 1][j_][k][l] - f[i].s + sum(j_, k + 2));
        }
    }
    int bst = INT_MIN;
    for (int i = 0; i <= 23; i++) {
        for (int j = 0; j <= 23; j++) for (int l = 0; l <= 23; l++) bst = max(bst, dp2[n][i][j][l]);
    }
    assert(bst >= 0);
    cout << bst << endl;
    exit(0);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    if (m <= 5) solve_lil();
    vector<int> a(n + 10), p(n + 10);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> p[i];
    s.resize(n + m + 10);
    for (int i = 1; i <= n + m; i++) cin >> s[i];
    vector<ps> f(n + 1);
    for (int i = 1; i <= n; i++) f[i] = {a[i], p[i]};
    memset(dp, 0x80, sizeof dp);
    dp[0][m + 2][0][m + 2] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n + m + 5; j++) for (int k = 0; k <= n; k++) for (int l = 0; l < maxn; l++) dp[i][j][k][l] = dp[i - 1][j][k][l];
        int j_ = f[i].a;
        for (int l = j_; l <= n + m + 5; l++) {
            for (int k = 1; k <= n + 5; k++) dp[i][j_][k][j_] = max(dp[i][j_][k][j_], dp[i - 1][j_ + 1][k - 1][l] - f[i].s + s[j_]);
            for (int j = j_ + 2; j <= n + m + 5; j++) {
                for (int k = 0; k <= n; k++) dp[i][j_][0][j_] = max(dp[i][j_][0][j_], dp[i - 1][j][k][l] - f[i].s + s[j_]);
            }
            for (int k = 0; k <= n + 5; k++) dp[i][j_ + k + 1][0][j_] = max(dp[i][j_ + k + 1][0][j_], dp[i - 1][j_][k][l] - f[i].s + sum(j_, k + 2));
        }
    }
    int bst = INT_MIN;
    for (int i = 0; i <= n + m + 5; i++) {
        for (int j = 0; j <= n + 5; j++) for (int l = 0; l <= n + m + 5; l++) bst = max(bst, dp[n][i][j][l]);
    }
    assert(bst >= 0);
    cout << bst << endl;

}
