#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;

signed main() {
	FAST_IO();
	int n, m;
	cin >> n >> m;
	vector<int> l(n), s(n), c(n + m), pc(n + m);
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		l[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n + m; ++i) {
		cin >> c[i];
		pc[i] = c[i];
		if (i != 0) {
			pc[i] += pc[i - 1];
		}
	}
	//m <= 5 || (n <= 15 && m <= 15)
	if (false) {
		int mx = (1 << (m - 1)) * n + 1;
		int dp[2][mx][m];
		for (int i = 0; i < 2; ++i) {
			for (int j = 0; j < mx; ++j) {
				for (int k = 0; k < m; ++k) {
					dp[i][j][k] = -INF;
				}
			}
		}
		int ff = 0, ss = 1;
		dp[ff][0][m - 1] = 0;
		dp[ff][(1 << l[0])][l[0]] = c[l[0]] - s[0];
		for (int i = 1; i < n; ++i) {
			for (int cnt = 0; cnt < mx; ++cnt) {
				for (int k = 0; k < m; ++k) {
					if (dp[ff][cnt][k] == -INF) {
						continue;
					}
					dp[ss][cnt][k] = max(dp[ss][cnt][k], dp[ff][cnt][k]);
					if (l[i] > k) {
						continue;
					}
					int ncnt = cnt;
					int cur = l[i];
					int add = -s[i];
					while (true) {
						add += c[cur];
						if (ncnt & (1 << cur)) {
							ncnt ^= (1 << cur);
							cur++;
						}
						else {
							ncnt |= (1 << cur);
							break;
						}
					}
					dp[ss][ncnt][l[i]] = max(dp[ss][ncnt][l[i]], dp[ff][cnt][k] + add);
				}
			}
			swap(ff, ss);
			for (int cnt = 0; cnt < mx; ++cnt) {
				for (int k = 0; k < m; ++k) {
					dp[ss][cnt][k] = -INF;
				}
			}
		}
		int ans = 0;
		for (int j = 0; j < mx; ++j) {
			for (int k = 0; k < m; ++k) {
				ans = max(ans, dp[ff][j][k]);
			}
		}
		cout << ans << '\n';
		return 0;
	}
	int dp[n][256][n];
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 256; ++j) {
			for (int k = 0; k < n; ++k) {
				dp[i][j][k] = -INF;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		dp[i][128][0] = c[l[i]] - s[i];
		for (int i1 = i - 1; i1 >= 0; --i1) {
			if (l[i1] < l[i]) {
				continue;
			}
			for (int mask = 0; mask < 256; ++mask) {
				for (int len = 0; len < n; ++len) {
					if (dp[i1][mask][len] == -INF) {
						continue;
					}
					int nmask = (mask >> min(8, (l[i1] - l[i])));
					int nlen = 0;
					if (l[i1] - l[i] < 8) {
						for (int j = l[i1] - l[i] - 1; j >= 0; --j) {
							if (mask & (1 << j)) {
								nlen++;
							}
							else {
								break;
							}
						}
						if (nlen == l[i1] - l[i]) {
							nlen += len;
						}
					}
					bool flag = false;
					int add = -s[i];
					for (int j = 7; j >= 0; --j) {
						if (nmask & (1 << j)) {
							add += c[l[i] + 7 - j];
							nmask ^= (1 << j);
						}
						else {
							add += c[l[i] + 7 - j];
							nmask ^= (1 << j);
							flag = true;
							break;
						}
					}
					if (flag) {
						dp[i][nmask][nlen] = max(dp[i][nmask][nlen], dp[i1][mask][len] + add);
					}
					else {
						add += pc[l[i] + 8 + nlen];
						add -= pc[l[i] + 7];
						dp[i][nmask][0] = max(dp[i][nmask][0], dp[i1][mask][len] + add);
					}
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int mask = 0; mask < 256; ++mask) {
			for (int len = 0; len < n; ++len) {
				ans = max(ans, dp[i][mask][len]);
			}
		}
	}
	cout << ans << '\n';
}