#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

const int INF = (int) 1e15;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m);
    for (auto &x : l) {
        cin >> x;
    }
    for (auto &x : s) {
        cin >> x;
    }
    for (auto &x : c) {
        cin >> x;
    }
    if (n <= 15) {
        int ans = -INF;
        for (int i = 0; i < (int) pow(2, n); i++) {
            vector<int> kek;
            int mn = INF;
            bool flag = true;
            int res = 0;
            int k = i;
            for (int j = 0; j < n; j++) {
                if (k % 2) {
                    if (l[j] > mn) {
                        flag = false;
                        break;
                    }
                    mn = l[j];
                    res -= s[j];
                    res += c[l[j] - 1];
                    kek.push_back(l[j]);
                    while (kek.size() >= 2) {
                        if (kek.back() == kek[kek.size() - 2]) {
                            int val = kek.back() + 1;
                            kek.pop_back();
                            kek.pop_back();
                            kek.push_back(val);
                            res += c[val - 1];
                        } else {
                            break;
                        }
                    }
                }
                k /= 2;
            }
            if (flag) {
                ans = max(ans, res);
            }
        }
        cout << ans << endl;
        return 0;
    }
    if (m == 1) {
        sort(s.begin(), s.end());
        int best = 0;
        for (int i = 1; i <= n; i++) {
            int now = 0;
            for (int j = 0; j < i; j++) {
                now -= s[j];
            }
            int cnt = 0, k = i;
            while (k > 0) {
                now += c[cnt] * k;
                k /= 2;
                cnt++;
            }
            best = max(best, now);
        }
        cout << best << endl;
        return 0;
    }
    vector<int> a1, a2;
    for (int i = 0; i < n; i++) {
        if (l[i] == 1) {
            a1.push_back(s[i]);
        } else {
            a2.push_back(s[i]);
        }
    }
    sort(a1.begin(), a1.end());
    sort(a2.begin(), a2.end());
    for (int i = 1; i < a1.size(); i++) {
        a1[i] += a1[i - 1];
    }
    for (int i = 1; i < a2.size(); i++) {
        a2[i] += a2[i - 1];
    }
    int best = 0;
    for (int i = 1; i <= a1.size(); i++) {
        for (int j = 1; j <= a2.size(); j++) {
            int now = -a1[i - 1] - a2[j - 1] + c[0] * i;
            int cnt = 1;
            int k = i / 2 + j;
            while (k > 0) {
                now += c[cnt] * k;
                k /= 2;
                cnt++;
            }
            best = max(best, now);
        }
    }
    cout << best << endl;
}