#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

#pragma GCC optimize('Ofast,no-stack-protector,unroll-loops')

const ll INF = 1e9 + 7;

void fast() {
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve1(int n, int m) {
    vector<int> m1(n);
    for (int i = 0; i < n; i++) {
        cin >> m1[i];
    }
    vector<int> m2(n);
    for (int i = 0; i < n; i++) {
        cin >> m2[i];
    }
    vector<int> m3(n + m + 1);
    for (int i = 1; i <= n + m; i++) {
        cin >> m3[i];
    }
    int ans = -INF;
    for (int k = 1; k <= n; k++) {
        int val = 0;
        vector<pair<int, int>> dust;
        for (int i = 0; i < n; i++) {
            dust.push_back({m3[1] - m2[i], i});
        }
        sort(dust.rbegin(), dust.rend());
        vector<int> cur;
        for (int i = 0; i < k; i++) {
            cur.push_back(dust[i].second);
            val += dust[i].first;
        }
        vector<int> kol(n + m + 1, 0);
        for (auto& el : cur) {
            kol[m1[el]]++;
        }
        for (int i = 1; i <= m + n; i++) {
            if (kol[i] > 1) {
                int ch = kol[i] / 2;
                val += ch * m3[i + 1];
                kol[i + 1] += ch;
            }
        }
        ans = max(ans, val);
    }
    cout << ans;
}

signed main() {
    fast();

    int n, m;
    cin >> n >> m;
    if (m == 1) {
        solve1(n, m);
        return 0;
    }
    vector<int> m1(n);
    for (int i = 0; i < n; i++) {
        cin >> m1[i];
    }
    vector<int> m2(n);
    for (int i = 0; i < n; i++) {
        cin >> m2[i];
    }
    vector<int> m3(n + m + 1);
    for (int i = 1; i <= n + m; i++) {
        cin >> m3[i];
    }
    int ans = -INF;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> cur;
        int mn = INF;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                if (m1[i] > mn) {
                    continue;
                }
                else {
                    cur.push_back(i);
                    mn = min(mn, m1[i]);
                }
            }
        }
        int val = 0;
        for (auto& el : cur) {
            val -= m2[el];
            val += m3[m1[el]];
        }
        vector<int> kol(n + m + 1, 0);
        for (auto& el : cur) {
            kol[m1[el]]++;
        }
        for (int i = 1; i <= m + n; i++) {
            if (kol[i] > 1) {
                int ch = kol[i] / 2;
                val += ch * m3[i + 1];
                kol[i + 1] += ch;
            }
        }
        ans = max(ans, val);
    }
    cout << ans;
    return 0;
}
