#include <bits/stdc++.h>

using namespace std;

int INF = 1e9;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> l(n), c(n), price(n + m);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    for (int i = 0; i < n; i++)
        cin >> c[i];
    for (int i = 0; i < n + m; i++)
        cin >> price[i];
    if (n <= 15) {
        int answer = -INF;
        for (int mask = 0; mask < (1 << n); mask++) {
            int maxx = INF;
            bool fl = 1;
            vector<bool> visit(n + m);
            int cost = 0;
            int cash = 0;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    if (l[i] > maxx) {
                        fl = 0;
                        break;
                    }
                    cost += c[i];
                    cash += price[l[i]];
                    int start = l[i];
                    while (visit[start]) {
                        cash += price[start + 1];
                        visit[start] = 0;
                        start++;
                    }
                    visit[start] = 1;
                    if (maxx = INF)
                        maxx = l[i];
                }
            }
            if (!fl)
                continue;
            answer = max(answer, cash - cost);
        }
        cout << answer;
        return 0;
    }
    if (m == 1) {
        int answer = -INF;
        vector<int> dp(n, INF);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= i; j++) {
                if (j == 0)
                    dp[j] = min(dp[j], c[i]);
                else
                    dp[j] = min(dp[j], dp[j - 1] + c[i]);
            }
        }
        for (int cnt = 1; cnt <= n; cnt++) {
            int cost = dp[cnt - 1];
            int cash = 0;
            int help = 1;
            int ind = 0;
            while (cnt / help > 0) {
                cash += (cnt / help) * price[ind];
                help *= 2;
                ind++;
            }
            //cout << cash << " " << cost << endl;
            answer = max(answer, cash - cost);
        }
        cout << answer;
    }
}

