#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    init(l, n);
    for (auto & it : l) {
        cin >> it;
    }

    init(s, n);
    for (auto & it : s) {
        cin >> it;
    }

    init(c, n + m + 1);
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }

    vector<int> need = {0, 1, 2, 4};

    int ans = 0;
    for (int mask = 1; mask <= (1 << n) - 1; ++mask) {
        vector<int> take;
        for (int i = 0; i < n; ++i) {
            if ((int)((mask >> i) & 1) == 1) {
                take.emplace_back(i);
            }
        }

        bool flag = true;

        for (int i = 0; i < len(take) - 1; ++i) {
            if (l[take[i]] < l[take[i + 1]]) {
                flag = false;
                break;
            }
        }

        if (flag) {
            int curr_ans = 0;
            for (const auto & i : take) {
                curr_ans -= s[i];
            }

            set<int> curr;
            for (const auto & i : take) {
                curr_ans += c[l[i]];

                int now = l[i];

                while (curr.count(now)) {
                    curr.erase(now);
                    ++now;
                    curr_ans += c[now];
                }
                curr.insert(now);
            }

            chkmax(ans, curr_ans);
        }
    }

    cout << ans << '\n';
}