#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

vector<int> l, s, c;
int n, m;

vector<int> model(vector<int>& cur, int val) {
    vector<int> cnt(n + m, 0);
    rep(i, 0, cur.size()) cnt[cur[i]]++;
    while (cnt[val] >= 1) cnt[val] = 0, val++;
    cnt[val] = 1;
    vector<int> ans;
    rep(i, 0, n + m) if (cnt[i] != 0) ans.pb(i);
    return ans;
}

ll get(vector<int>& cur, ll val) {
    vector<int> cnt(n + m, 0);
    rep(i, 0, cur.size()) cnt[cur[i]]++;
    ll ans = c[val];
    while (cnt[val] >= 1) cnt[val] = 0, val++, ans += c[val];
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m);
    rep(i, 0, n) cin >> l[i], l[i]--;
    rep(i, 0, n) cin >> s[i];
    rep(i, 0, n + m) cin >> c[i];
    vector<ll> dp(n);
    vector<vector<int>> last(n);
    dp[n - 1] = c[l[n - 1]] - s[n - 1];
    last[n - 1] = { l[n - 1] };
    per(i, n - 1, 0) {
        dp[i] = c[l[i]] - s[i];
        last[i] = { l[i] };
        rep(j, i + 1, n) {
            if (l[j] > l[i]) continue;
            ll cur = get(last[j], l[i]) + dp[j] - s[i];
            if (dp[i] <= cur) {
                dp[i] = cur;
                last[i] = model(last[j], l[i]);
            }
        }
    }
    cout << *max_element(dp.begin(), dp.end()) << '\n';
}
