#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG
// #define int long long

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;
typedef pair <char, char> pt;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 5e5;

int bit(int mask, int i) {
	return ((mask >> i) & 1);
}

void spec_solve(int n, int m, vector <int> l, vector <int> s, vector <int> c) {
	sort(all(s));
	int ans = 0;
	int sum = 0;
	for (int i = 0; i < n; ++i) {
		sum += s[i];
		int k = i + 1;
		int res = -sum;
		for (; k > 0; ) {
			int log = log2(k);
			// cout << "log = " << log << "\n";
			k -= 1 << log; 
			for (int j = 0; j <= log; ++j) {
				res += c[j + 1] * (1 << (log - j));
			}
		}
		// cout << i << " " << res << "\n";
		ans = max(ans, res);
	}
	cout << ans << "\n";
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int& i : l) {
		cin >> i;
	}
	vector <int> s(n);
	for (int& i : s) {
		cin >> i;
	}
	vector <int> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	if (m == 1) {
		spec_solve(n, m, l, s, c);
		return;
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		vector <int> idx;
		for (int i = 0; i < n; ++i) {
			if (bit(mask, i)) {
				idx.push_back(i);
			}
		}
		bool flag = 0;
		for (int i = 1; i < (int)idx.size(); ++i) {
			if (l[idx[i - 1]] < l[idx[i]]) {
				flag = 1;
				break;
			}
		}
		if (flag) {
			continue;
		}
		int res = 0;
		for (int i : idx) {
			res -= s[i];
		}
		unordered_set <int> ss;
		// cout << "idx: ";
		// out(int, idx);
		for (int i : idx) {
			if (ss.count(l[i])) {
				int cur = l[i];
				res += c[cur];
				for (; ss.count(cur); ) {
					ss.erase(cur);
					++cur;
					res += c[cur];
				}
				ss.insert(cur);
			} else {
				ss.insert(l[i]);
				res += c[l[i]];
			}
		}
		// cout << "res = " << res << "\n";
		ans = max(ans, res);
	}
	cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		// cin >> t;
		t = 3;
	#else
		// cin >> t;
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}