#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 205, M = 605, lg = 3;
const int INF = 2000000000 + 7;

int n, m, a[N], s[N], c[M], pref[M], nxt[N], dp[N][1 << lg][M], ans = 0, l = 0;

void init() {
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < (1 << lg); j++) {
            for (int k = 0; k < M; k++) {
                dp[i][j][k] = -INF;
            }
        }
        nxt[i] = INF;
    }
    for (int i = 1; i <= n + m; i++)
        pref[i] = pref[i - 1] + c[i];
    for (int i = 0; i < n; i++) {
        dp[i][0][0] = 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[j] <= a[i]) {
                nxt[i] = j;
                break;
            }
        }
    }
}

void add(vector<int> &cr, int x, int &curans) {
    curans += c[x];
    if (cr.empty() || cr.back() != x) {
        cr.pb(x);
    }
    else {
        x++;
        cr.pop_back();
        add(cr, x, curans);
    }
}

signed main()
{
    fast_io;

    ifstream cin("input.txt");
    ofstream cout("output.txt");

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i++) {
        cin >> c[i + 1];
    }
    init();

    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> cur;
        for (int j = 0; j < n; j++) {
            if ((mask&(1 << j)) == 0)
                continue;
            cur.pb(j);
        }

        bool bad = false;
        for (int j = 1; j < cur.size(); j++) {
            if (a[cur[j]] > a[cur[j - 1]])
                bad = true;
        }

        if (bad)
            continue;

        int curans = 0;
        vector<int> cr;
        for (int j = 0; j < cur.size(); j++) {
            add(cr, a[cur[j]], curans);
        }
        ans = max(ans, curans);
    }

    cout << ans;

    return 0;
}

/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4

5 5
1 1 1 1 1
0 0 0 0 0
1 1 1 1 1 1 1 1 1 1
*/
