#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <bitset>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<ll> l(n);
    for (ll i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    vector<ll> s(n);
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<ll> c(n + m);
    for (ll i = 0; i < n + m; i++) {
        cin >> c[i];
    }
    ll o = (ll) -1e16;
    if (n <= 15) {
        for (ll i = 0; i < (1 << n); i++) {
            ll q = 0;
            vector<ll> v;
            ll g = (ll) 1e16;
            for (ll j = 0; j < n; j++) {
                if ((i & (1 << j)) != 0 && l[j] <= g) {
                    v.push_back(j);
                    g = min(g, l[j]);
                }
            }
            for (ll j : v) {
                q -= s[j];
            }
            vector<ll> u;
            for (ll j : v) {
                u.push_back(l[j]);
                q += c[l[j]];
                while (true) {
                    ll f = 0;
                    for (ll x = 0; f == 0 && x < (ll) u.size(); x++) {
                        for (ll y = x + 1; f == 0 && y < (ll) u.size(); y++) {
                            if (u[x] == u[y]) {
                                u[x]++;
                                q += c[u[x]];
                                u.erase(u.begin() + y);
                                f = 1;
                            }
                        }
                    }
                    if (f == 0) {
                        break;
                    }
                }
            }
            o = max(o, q);
        }
    } else {
        sort(s.begin(), s.end());
        ll q = 0;
        for (ll i = 0; i < n; i++) {
            q -= s[i];
            for (ll j = 0; j < 30; j++) {
                if (i % (1 << j) != 0) {
                    q += l[c[j - 1]];
                }
            }
        }
        o = max(o, q);
    }
    cout << o << endl;
    return 0;
}
