#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> l(n), s(n);
	for(int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	vector<int> c(n + m + 1);
	for(int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}

	vector< vector<int> > dp(n, vector<int>(n));

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			for(int prev = 0; prev < i; prev++) {
				if(l[prev] == l[i]) {
					dp[i][j] = max(dp[i][j], dp[prev][j + 1] - s[i]);
				} else if(l[prev] > l[i]) {
					int cur = 0;
					int cnt = j + 1;
					for(int curl = l[i]; curl < l[prev] && cnt > 0; curl++) {
						cur += c[curl] * cnt;
						cnt /= 2;
					}
					dp[i][j] = max(dp[i][j], dp[prev][cnt] + cur - s[i]);
				}
			}

			int cur = 0;
			int cnt = j + 1;
			for(int curl = l[i]; cnt > 0; curl++) {
				cur += c[curl] * cnt;
				cnt /= 2;
			}
			dp[i][j] = max(dp[i][j], cur - s[i]);
		}
	}

	int ans = 0;
	for(int i = 0; i < n; i++) {
		ans = max(ans, dp[i][0]);
	}
	cout << ans << endl;

#if PYHAEM_S_NOGI >= 3
	cerr << endl << endl << "Memory used: " << (double)((memory_ptr - MEMORY) * 10000 / MAX_MEMORY) / 100 << "%" << endl;
#endif

	return 0;
}