#include <iostream>
#include <vector>
#include <cstdlib>
#include <algorithm>

#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl "\n"
#endif

#define _ <<" "<<

using namespace std;
typedef long long ll;

int n,m;
vector<int> ls;
vector<int> cs;
vector<int> rew;

ll ans = 0;

void solve1(){
    vector<int> take;
    vector<int> ct(m+n+2);
    for(int mask = 0; mask < (1<<n); mask++){
        int curm = 1e5;
        take.clear();
        ct.assign(n+m+2, 0);
        ll curb = 0;
        for(int i = 0; i < n; i++){
            if((mask&(1<<i))==0) continue;
            if(ls[i] > curm) continue;
            curm = min(ls[i], curm);
            take.push_back(ls[i]);
            curb -= cs[i];
        }
        for(int v: take){
            curb += rew[v];
            ct[v]++;
            int ptr = v;
            while(ct[ptr] > 1){
                ct[ptr] = 0;
                ptr++;
                ct[ptr]++;
                curb += rew[ptr];
            }
        }
        ans = max(ans, curb);
    }
}

void solve2(){
    sort(cs.begin(), cs.end());
    for(int take = 1; take <= n; take++){
        ll pa = 0;
        for(int i = 0; i < take; i++){
            pa -= cs[i];
        }
        int left = take;
        for(int i = 1; i <= n+m; i++){
            pa += left*rew[i];
            left /= 2;
            if(left == 0) break;
        }
        ans = max(ans,pa);
    }
}

int32_t main()
{
    cin >> n >> m;
    ls.resize(n);
    for(int i = 0; i < n; i++) cin >> ls[i];
    cs.resize(n);
    for(int i = 0; i < n; i++) cin >> cs[i];
    rew.resize(n+m+5);
    for(int i = 1; i <= n+m; i++) cin >> rew[i];

    if(m==1)solve2();
    else solve1();

    cout << ans << endl;
    return 0;
}
