//#include <bits/stdc++.h>
//
//using namespace std;
//
//#define pb push_back
//#define forn(i, n) for(int i = 0; i < int(n); ++i)
//#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
//#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
//#define fst first
//#define snd second
//#define sz(X) (int)(X.size())
//#define all(X) X.begin(), X.end()
//
//typedef long long ll;
//typedef long double ld;
//typedef pair<int, int> pii;
//typedef vector<int> vi;
//
//const int MOD = 1e9 + 7;
//const int N = 15;
//
//
//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
//    int n = 5;
//    set<vi> s;
//    forn(mask, 1 << n) {
//        vi a(n, 1);
//        forn(i, n) if (mask & (1 << i)) a[i]++;
//        int cnt = 0;
//        while (true) {
//            bool ch = false;
//            vi b(a);
//            forab(i, 1, n - 1) {
//                vi x{a[i - 1], a[i], a[i + 1]};
//                sort(all(x));
//                b[i] = x[1];
//                if (b[i] != a[i]) ch = true;
//            }
//            if (!ch) break;
//            cnt++;
//            a = b;
//        }
//        if (s.count(a)) continue;
//        s.insert(a);
//        for (int x : a) cout << x << " ";
//        cout << "\n";
//    }
//    return 0;
//}
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define fornr(i, n) for(int i = int(n)-1; i>=0; --i)
#define fst first
#define snd second
#define sz(X) (int)(X.size())
#define all(X) X.begin(), X.end()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int N = 1e7 + 1;
ll sums[N], cnt[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    int ans = 0;
    forn(mask, 1 << n) {
        int cur = 0;
        vi used(n + m);
        int mn = 1e9;
        bool ok = true;
        forn(i, n) {
            if (mask & (1 << i)) {
                if (l[i] > mn) {
                    ok = false;
                    break;
                }
                mn = min(mn, l[i]);
                cur -= s[i];
            }
        }
        if (!ok) continue;
        forn(i, n) {
            if (mask & (1 << i)) {
                int x = l[i];
                while (true) {
                    cur += c[x-1];
                    if (used[x]) {
                        used[x] = false;
                        x++;
                    } else break;
                }
                used[x] = true;
            }
        }
        ans = max(cur, ans);
    }
    cout << ans << "\n";
    return 0;
}