#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;
const ll ALPH = 100;
const ll INF = 1e12;
const ll MAXN = 501;

mt19937 gen(time(NULL));

#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    ll n, m;
    vector<ll> l;
    vector<ll> s;
    vector<ll> c;
    vector<vector<vector<ll> > > dp;

    ll f(ll pos, ll val, bool flag = 0) {
        if (dp[flag][pos][val] != -INF) {
            return dp[flag][pos][val];
        }
        if (flag) {
            ll ans = c[val] + c[l[pos]] - s[pos];
            for (ll i = pos - 1; i >= 0; i--) {
                if (l[i] > l[pos] && l[i] != val) {
                    ans = max(ans, f(i, l[i]) + c[val] + c[l[pos]] - s[pos]);
                }
                if (l[i] == val) {
                    ans = max(ans, f(i, l[i] + 1, 1) + c[val] + c[l[pos]] - s[pos]);
                }
            }
            dp[flag][pos][val] = ans;
            return ans;
        } else {
            ll ans = c[l[pos]] - s[pos];
            for (ll i = pos - 1; i >= 0; i--) {
                if (l[i] > val) {
                    ans = max(ans, f(i, l[i]) + c[l[pos]] - s[pos]);
                } else if (l[i] == val) {
                    ans = max(ans, f(i, l[i] + 1, 1) + c[l[pos]] - s[pos]);
                }
            }
            dp[flag][pos][val] = ans;
            return ans;
        }
    }

    void solve() {
        cin >> n >> m;
        l.resize(n);
        s.resize(n);
        c.resize(n + m + 1);
        dp.resize(2, vector<vector<ll> > (n, vector<ll>(n + m + 1, -INF)));
        for (ll i = 0; i < n; i++) {
            cin >> l[i];
        }
        for (ll i = 0; i < n; i++) {
            cin >> s[i];
        }
        for (ll i = 1; i < n + m; i++) {
            cin >> c[i];
        }
        ll ans = -INF;
        for (ll i = n - 1; i >= 0; i--) {
            ans = max(ans, f(i, l[i]));
        }
        cout << ans;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
