#include <iostream>
#include <set>
using namespace std;

const int MAXN = 5003;

int n, m;
int l[MAXN], s[MAXN], c[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++ i)
    {
        cin >> c[i];
    }
}

int maxp = 0;

void Rec(set<int> st, int p, int i)
{
    // cout << i << endl;

    if (i == n + 1)
    {
        maxp = max(maxp, p);
        return;
    }

    Rec(st, p, i + 1);

    if (st.count(l[i]) == 1)
    {
        p -= s[i];
        p += c[l[i]];

        int t = l[i];
        while (st.count(t) == 1)
        {
            st.erase(st.find(t));
            p += c[++t];
        }
        st.insert(t);
        Rec(st, p, i + 1);
    }
    else if (st.size() == 0 or *(st.begin()) >= l[i])
    {
        p -= s[i];
        p += c[l[i]];
        st.insert(l[i]);
        Rec(st, p, i + 1);
    }
}

int main()
{
    Init();

    Rec({}, 0, 1);

    cout << maxp << endl;
    return 0;
}

