#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX_M = 100;
const int MAX_N = 100;

vector<int> s;
int c[MAX_N];

int n, m;

int getWin(vector<int> cnt) {
    int ans = 0;
    vector<int> cnt2 = cnt;
    while (true) {
        for (int i = 0; i < cnt.size(); i++) {
            ans += c[i] * cnt2[i];
        }
        vector<int> newCnt(cnt.size());
        vector<int> newCnt2(cnt.size());
        for (int i = 0; i < (int)cnt.size() - 1; i++) {
            newCnt[i + 1] += cnt[i] / 2;
            newCnt2[i + 1] += cnt[i] / 2;
            newCnt[i] += cnt[i] % 2;
        }
        if (cnt == newCnt) {
            break;
        }
        cnt = newCnt;
        cnt2 = newCnt2;
    }
    return ans;
}

vector<int> l;

void solve1() {
    sort(s.begin(), s.end());
    int ans = 0;
    int curM = 0;
    vector<int> cnt(MAX_M);
    for (int i = 0; i < n; i++) {
        curM -= s[i];
        cnt[l[i]]++;
        ans = max(ans, getWin(cnt) + curM);
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("E.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    l.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; i++) {
        cin >> c[i];
    }
    int ans = 0;
    if (m == 1) {
        solve1();
        return 0;
    }
    for (int msk = 0; msk < (1 << n); msk++) {
        vector<int> cnt(MAX_M);
        int curAns = 0;
        vector<int> lS;
        for (int j = 0; j < n; j++) {
            if ((msk >> j) & 1) {
                cnt[l[j]]++;
                lS.push_back(l[j]);
                curAns -= s[j];
            }
        }
        bool valid = true;
        for (int i = 1; i < lS.size(); i++) {
            if (lS[i] > lS[i - 1]) {
                valid = false;
            }
        }
        if (valid) {
            curAns += getWin(cnt);
            ans = max(ans, curAns);
        }
    }
    cout << ans << "\n";

    return 0;
}