#include<iostream>

using namespace std;

const int MAXN = 205;
const int inf = 1e9 + 5;

int n, m;
int l[MAXN], s[MAXN], c[MAXN*2];

int memo[MAXN][MAXN][MAXN];
int calcState(int ind, int currNum, int amount)
{
    if(amount>n)
    {
        return -inf;
    }
    if(ind==n)
    {
        if(amount==0) return 0;
        return -inf;
    }
    if(currNum==0)
    {
        if(amount==0) return 0;
        return -inf;
    }

    int answer = -inf;
    answer = max(answer, calcState(ind, currNum-1, 2*amount) + amount*c[currNum]);
    answer = max(answer, calcState(ind, currNum-1, 2*amount+1) + amount*c[currNum]);

    answer = max(answer, calcState(ind+1, currNum, amount));
    if(l[ind]==currNum && amount!=0)
    {
        answer = max(answer, calcState(ind+1, currNum, amount-1) - s[ind] + c[ l[ind] ]);
    }

    //cout << ind << " " << currNum << " " << amount << " -> " << answer << '\n';
    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        cin >> l[i];
    }
    for(int i = 0;i<n;i++)
    {
        cin >> s[i];
    }
    for(int i = 1;i<=n+m;i++)
    {
        cin >> c[i];
    }

    cout << calcState(0, m+16, 0) << '\n';
}
