#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vi a(n), s(n), c(n + m);
	fi(n) {
		cin >> a[i];
		--a[i];
	}
	fi(n) cin >> s[i];
	fi(n + m) cin >> c[i];
	if (n <= 15) {
		int ans = 0;
		for (int mask = 1; mask < (1 << n); ++mask) {
			vector<int> x;
			int cnt = 0;
			fi(n) {
				if (mask & (1 << i)) {
					x.pb(a[i]);
					cnt -= s[i];
				}
			}
			int k = x.size();
			bool flag = 1;
			fi(k - 1) {
				if (x[i] < x[i + 1]) {
					flag = 0;
					break;
				}
			}
			if (!flag)
				continue;
			vi st;
			fi(k) {
				cnt += c[x[i]];
				while (!st.empty() && x[i] == st.back()) {
					st.pop_back();
					++x[i];
					cnt += c[x[i]];
				}
				st.pb(x[i]);
			}
			ans = max(ans, cnt);
		}
		cout << ans;
	} else if (m == 1) {
		int ans = 0;
		sort(s.begin(), s.end());
		int sum = 0;
		fi(n) {
			sum += s[i];
			int k = i + 1;
			int cnt = 0, j = 0;
			while (k) {
				cnt += k * c[j];
				k /= 2;
				++j;
			}
			ans = max(ans, cnt - sum);
		}
		cout << ans;
	}
	/*vi pref(n + m + 1);
	fi(n + m)
		pref[i + 1] = pref[i] + c[i];
	vector<vector<pii>> dp(n, vii(n, { -INF, -INF }));
	vi ans(n, -INF);
	fi(n) {
		dp[i][0].first = c[a[i]] - s[i];
		fj(i) {
			if (a[j] == a[i]) {
				fvr(k, 1, j + 1)
					dp[i][k].second = max(dp[i][k].second, dp[j][k - 1].first - s[i] + pref[a[i] + k + 1] - pref[a[i]]);
			} else if (a[j] == a[i] + 1) {
				fvr(k, 1, j + 1) {
					dp[i][k].first = max(dp[i][k].first, dp[j][k - 1].first - s[i] + c[a[i]]);
				}
			} else if (a[j] > a[i] + 1)
				dp[i][0].first = max(dp[i][0].first, ans[j] - s[i] + c[a[i]]);
		}
		fv(k, i + 1)
			ans[i] = max(ans[i], max(dp[i][k].first, dp[i][k].second));
	}
	int res = 0;
	fi(n) res = max(res, ans[i]);
	cout << res;*/

	return 0;
}