#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int n, m;
vector <int> l, s, c;
int ans = 0;
set <int> scene;
int now = 0;
vector <int> adds;

void add(int agr) {
	while (scene.find(agr) != scene.end()) {
		now += c[agr];
		//now += c[agr + 1];
		++agr;
		scene.erase(agr);
	}
	now += c[agr];
	scene.insert(agr);
}

void gen(int pos) {

	if (pos == n) {
		ans = max(ans, now);
		return;
	}
	gen(pos + 1);

	if (scene.empty() || l[pos] <= *(scene.begin())) {
		int pnow = now;
		set <int> pscene = scene;

		now -= s[pos];
		add(l[pos]);
		gen(pos + 1);

		now = pnow;
		scene = pscene;
	}
}

void solve() {
	//int n, m;
	cin >> n >> m;
	l.resize(n), s.resize(n), c.resize(n + m + 1);
	//vector <int> l(n), s(n), c(n + m + 1);
	for (int& i : l) cin >> i;
	for (int& i : s) cin >> i;
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	
	if (m == 1 && 0) {
		sort(s.begin(), s.end());
		int now = 0, sum = 0, ssum = 0;
		for (int i = 0; i < n; ++i) {
			now += c[i + 1];
			sum += now;
			ssum += s[i];
			ans = max(ans, sum - ssum);
		}
		cout << ans;
		return;
	}
	
	gen(0);
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}