#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long
const int N = 2002;
const int INF = 2e18;

int cost[N * 10];

pair<set<int>, int> go(set<int> st, int x) {
    if (st.empty()) {
        return {{x}, cost[x]};
    }
    if (*st.begin() < x) {
        return {{}, -INF};
    }
    int res = cost[x];
    while (st.count(x)) {
        st.erase(x);
        ++x;
        res += cost[x];
    }
    st.insert(x);
    return {st, res};
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> start(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> start[i];
    }
    vector<int> start_c(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> start_c[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> cost[i];
    }
    map<set<int>, int> dp;
    dp[{}] = 0;
    for (int i = 1; i <= n; ++i) {
        map<set<int>, int> nw_dp;
        for (auto &j : dp) {
            nw_dp[j.first] = j.second;
        }
        for (const auto& j : dp) {
            auto [nw, get] = go(j.first, start[i]);
            if (get == -INF) continue;
            get += j.second - start_c[i];
            if (nw_dp.find(nw) != nw_dp.end()) {
                nw_dp[nw] = max(nw_dp[nw], get);
            } else {
                nw_dp[nw] = get;
            }
        }
        swap(dp, nw_dp);
    }

    int ans = -INF;
    for (auto &i : dp) {
        ans = max(ans, i.second);
    }
    cout << ans;
}