#include<iostream>
#include<cstring>
#include<vector>

using namespace std;

const int MAXN = 2005;
const int inf = 1e9 + 5;

int n, m;
int l[MAXN], s[MAXN], c[MAXN*2];

vector <int> memo[MAXN][MAXN];
int calcState(int ind, int currNum, int amount)
{
    if(amount>n)
    {
        return -inf;
    }
    if(ind==n)
    {
        if(amount==0) return 0;
        return -inf;
    }
    if(currNum==0)
    {
        if(amount==0) return 0;
        return -inf;
    }
    if(memo[ind][amount][currNum]!=-1)
    {
        return memo[ind][amount][currNum];
    }

    int answer = -inf;
    answer = max(answer, calcState(ind, currNum-1, 2*amount) + amount*c[currNum]);
    answer = max(answer, calcState(ind, currNum-1, 2*amount+1) + amount*c[currNum]);

    answer = max(answer, calcState(ind+1, currNum, amount));
    if(l[ind]==currNum && amount!=0)
    {
        answer = max(answer, calcState(ind+1, currNum, amount-1) - s[ind] + c[ l[ind] ]);
    }

    //cout << ind << " " << currNum << " " << amount << " -> " << answer << '\n';

    memo[ind][amount][currNum] = answer;
    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        cin >> l[i];
    }
    for(int i = 0;i<n;i++)
    {
        cin >> s[i];
    }
    for(int i = 1;i<=n+m;i++)
    {
        cin >> c[i];
    }

    for(int ind = 0;ind<=n;ind++)
    {
        for(int amount = 0;amount<=n;amount++)
        {
            for(int i = 0;i<m+15;i++)
            {
                memo[ind][amount].push_back(-1);
            }
        }
    }

    cout << calcState(0, m+13, 0) << '\n';
}
