#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int inf = 1e9 + 7;
const int MAXN = 2005;
int n, m;
int agr[MAXN];
int cost[MAXN];
int pay[MAXN * 2];
int dp[MAXN * 2][MAXN];
int sz[MAXN];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    rep(i, n) {
        cin >> agr[i];
        agr[i]--;
    }
    rep(i, n) {
        cin >> cost[i];
    }
    rep(i, n + m) {
        cin >> pay[i];
    }

    for (int i = 0; i + 1 < MAXN; ++i) {
        sz[i] = __builtin_popcount(i) - __builtin_popcount(i & (i + 1)) + 1;
    }

    rep(i, MAXN * 2) {
        for (int j = 1; j < MAXN; ++j) {
            dp[i][j] = -inf;
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        // agr[i]
        for (int j = n; j >= 0; --j) {
            int ad = 0;
            rep(t, sz[j]) {
                ad += pay[agr[i] + t];
            }
            dp[agr[i]][j + 1] = max(dp[agr[i]][j + 1], dp[agr[i]][j] - cost[i] + ad);

            for (int k = 1; agr[i] + k <= MAXN; ++k) {
                dp[agr[i] + k][(j + 1) >> k] = max(dp[agr[i] + k][(j + 1) >> k], dp[agr[i]][j + 1]);
            }
        }
    }

    int res = 0;
    rep(i, MAXN * 2) {
        rep(j, MAXN) {
            res = max(res, dp[i][j]);
        }
    }
    cout << res << endl;
}
