#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 2003;
int L[maxN], S[maxN];
int C[maxN + maxN];

signed main() {
#ifdef DEBUG
  freopen("in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    cin >> L[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> S[i];
  }
  for (int y = 1; y <= n + m; ++y) {
    cin >> C[y];
  }
  if (n <= 15) {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
      int lastL = 1e9;
      int sum = 0;
      vector<int> cnt(n + m + 1, 0);
      bool ok = true;
      for (int i = 0; ok && i < n; ++i) {
        if ((mask >> i) & 1) {
          ok &= lastL >= L[i];
          lastL = L[i];
          sum -= S[i];
          sum += C[L[i]];
          cnt[L[i]]++;
          for (int y = L[i]; y <= n + m && cnt[y] == 2; ++y) {
            sum += C[y + 1];
            cnt[y] = 0;
            cnt[y + 1]++;
          }
        }
      }
      if (ok) {
        chkmax(ans, sum);
      }
    }
    cout << ans << '\n';
    exit(0);
  }
  if (m == 1) {
    ll sum = 0;
    vector<int> cnt(n + m + 1, 0);
    for (int i = 0; i < n; ++i) {
      sum -= S[i];
      sum += C[L[i]];
      cnt[L[i]]++;
      for (int y = L[i]; y <= n + m && cnt[y] == 2; ++y) {
        sum += C[y + 1];
        cnt[y] = 0;
        cnt[y + 1]++;
      }
    }
    cout << sum << '\n';
    exit(0);
  }

  return 0;
}

