#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 2e3 + 10, MAX_M = 2e3 + 10, MAX_L = 2e3 + 50;
const int INF = 0x3f3f3f3f;

int l[MAX_N], s[MAX_N], c[MAX_N + MAX_M];
int dp[MAX_N][MAX_N];

pair<int, int> count(int start, int end, int cnt) {
	int cost = 0;
	for (int i = start; i < end; ++i) {
		cost += (cnt / 2) * (c[i + 1]);
		cnt /= 2;
	}
	return {cost, cnt};
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> l[i], --l[i];
	for (int i = 0; i < n; ++i)
		cin >> s[i];
	for (int i = 0; i < n + m; ++i)
		cin >> c[i];
	for (int i = 0; i < n; ++i)
		s[i] = -s[i] + c[l[i]];
	if (n <= 200) {
		fill(dp[0], dp[MAX_N], -INF);
		dp[n][0] = 0;
		l[n] = 0;
		for (int i = n; i--; ) {
			for (int j = i + 1; j <= n; ++j) {
				if (l[j] > l[i])
					continue;
				if (l[i] == l[j]) {
					for (int h = 0; h <= n - j; ++h) {
						if (dp[j][h] == -INF)
							continue;
						dp[i][h + 1] = max(dp[i][h + 1], dp[j][h] + s[i]);
					}
				} else {
					for (int h = 0; h <= n; ++h) {
						if (dp[j][h] == -INF)
							continue;
						int x, y;
						tie(x, y) = count(l[j], l[i], h);
						dp[i][y + 1] = max(dp[i][y + 1], dp[j][h] + x + s[i]);
					}
				}
			}
		}
		int best_ans = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				best_ans = max(best_ans, dp[i][j] + count(l[i], min(MAX_L - 1, n + m), j).y);
			}
		}
		cout << best_ans << "\n";
	}
	return 0;
}