#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define ll long long
#define ld long double
#pragma warning(disable : 4996)
using namespace std;


int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	speed;
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int i = 0; i < n; i++)
		cin >> l[i];
	vector <int> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	vector <int> c(n + m);
	for (int i = 0; i < n + m; i++)
		cin >> c[i];
	if (n <= 15 && m <= 15)
	{
		int ans = 0;
		for (int i = 0; i < (1 << n); i++)
		{
			vector <int> lcur;
			for (int j = 0; j < n; j++)
			{
				if ((i >> j) & 1)
					lcur.push_back(j);
			}
			bool f = true;
			for (int j = 1; j < lcur.size(); j++)
				if (l[lcur[j]] > l[lcur[j - 1]])
					f = false;
			if (f)
			{
				int sum = 0;
				for (int j = 0; j < lcur.size(); j++)
					sum -= s[lcur[j]];
				set <int> d;
				for (int j = 0; j < lcur.size(); j++)
				{
					int a = l[lcur[j]];
					sum += c[a - 1];
					while (d.find(a) != d.end())
					{
						d.erase(a);
						a++;
						sum += c[a - 1];
					}
					d.insert(a);
				}
				ans = max(ans, sum);
			}

		}
		cout << ans;
	}
	else
	{
		if (m == 1)
		{
			int ans = 0;
			sort(s.begin(), s.end());
			for (int k = 1; k <= n; k++)
			{
				int sum = 0;
				for (int st = 0; (1 << st) <= k; st++)
					sum += c[st] * (k / (1 << st));
				for (int j = 0; j < k; j++)
					sum -= s[j];
				ans = max(ans, sum);
			}
			cout << ans;
		}
	}
	return 0;
}