#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int n, m;
vector <int> l, s, c;
int ans = 0;
set <int> scene;
int now = 0;
vector <int> taken;

void add(int agr) {
	while (scene.find(agr) != scene.end()) {
		now += c[agr];
		
		scene.erase(agr);
		++agr;
	}
	now += c[agr];
	scene.insert(agr);
}

void gen(int pos, int mn = 1000000000000) {

	if (pos == n) {

		now = 0;
		scene.clear();
		for (auto& i : taken) {
			now -= s[i];
			add(l[i]);
		}
		ans = max(ans, now);
		return;
	}

	gen(pos + 1);

	if (l[pos] <= mn) {
		taken.push_back(pos);
		gen(pos + 1, l[pos]);
		taken.pop_back();
	}
}

void solve() {
	//int n, m;
	cin >> n >> m;
	l.resize(n), s.resize(n), c.resize(n + m + 1);
	//vector <int> l(n), s(n), c(n + m + 1);
	for (int& i : l) cin >> i;
	for (int& i : s) cin >> i;
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	
	if (m == 1 && 1) {
		sort(s.begin(), s.end());
		int  ssum = 0;
		for (int i = 0; i < n; ++i) {
			add(1);
			ssum += s[i];
			ans = max(ans, now - ssum);
		}
		cout << ans << "\n";
		return;
	}
	
	gen(0);
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}