#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 7;

const int MAX_N = 4e3 + 10;
struct SegTree {
    ll tree[4 * MAX_N], lazy[4 * MAX_N];
    void upd(int curr, int l, int r, int q, ll val) {
        if(l == q && r == q) {
            tree[curr] = max(tree[curr], val);
            return;
        } if(l > q || r < q) {return;}
        int m = (l + r) / 2;
        upd(curr * 2, l, m, q, val);
        upd(curr * 2 + 1, m + 1, r, q, val);
        tree[curr] = max(tree[curr * 2], tree[curr * 2 + 1]);
    }
    int ans(int curr, int l, int r, int ql, int qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {return 0;}
        int m = (l + r) / 2;
        return max(ans(curr * 2, l, m, ql, qr), ans(curr * 2 + 1, m + 1, r, ql, qr));
    }
};

SegTree st1, st2;
ll c[MAX_N], l[MAX_N], s[MAX_N];

ll dp1[MAX_N], dp2[MAX_N];

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i ++) {cin >> l[i]; l[i] ++;}
    for(int i = 0; i < n; i ++) {cin >> s[i];}
    for(int i = 0; i < n + m; i ++) {cin >> c[i + 2];}
    reverse(s, s + n);
    reverse(l, l + n);
    fill_n(dp1, MAX_N, -mod);
    fill_n(dp2, MAX_N, -mod);
    dp1[0] = 0;
    for(int i = 0; i < MAX_N; i ++) {
        ll need = c[l[i]] - s[i];
        ll mx = 0;
        for(int j = 0; j < l[i]; j ++) {
            chkmax(mx, dp1[j]);
        }
        for(int j = 0; j < l[i] - 1; j ++) {
            chkmax(mx, dp2[j]);
        }
        chkmax(dp1[l[i] + 1], dp2[l[i] - 1] + c[l[i] + 1] + need);
        chkmax(dp2[l[i]], dp1[l[i]] + c[l[i] + 1] + need);
        chkmax(dp2[l[i]], dp2[l[i] - 1] + c[l[i] + 1] + need);
        chkmax(dp1[l[i]], mx + need);
        continue;
        for(int j = 0; j <= m; j ++) {
            cout << dp1[j] << " ";
        }
        cout << endl;
        for(int j = 0; j <= m; j ++) {
            cout << dp2[j] << " ";
        }
        cout << endl << endl;
    }
    ll ans = 0;
    for(int i = 0; i <= n + m; i ++) {
        chkmax(ans, dp1[i]);
        chkmax(ans, dp2[i]);
    }
    cout << ans << endl;
    return 0;
}
