#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const int inf = 1000000000;

int d[2][21][2000000];
int l[21];
int s[21];
int c[21];
int n, m;

pair <int, int> fight(int mask, int l) {
	int sum = 0;
	while (mask & (1 << l)) {
		mask = mask - (1 << l);
		++l;
		sum += c[l];
	}
	mask += (1 << l);
	return {sum, mask};
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		--l[i];
	}
	for (int i = 0; i < n; ++i)
		cin >> s[i];
	for (int i = 0; i < n + m; ++i)
		cin >> c[i];
	for (int t = 0; t < 2; ++t)
		for (int i = 0; i <= m; ++i)
			for (int j = 0; j < (1 << (n + m)); ++j)
				d[t][i][j] = -inf;
	for (int i = 0; i < n; ++i) {
		for (int ml = 0; ml < m; ++ml) {
			for (int mask = 0; mask < (1 << (n + m)); ++mask) {
				if (d[0][ml][mask] > -inf && l[i] <= ml) {
					pair <int, int> p = fight(mask, l[i]);
					//cerr << ml << ' ' << mask << ' ' << l[i] << ' ' << p.first << ' ' << p.second << ' ' << d[ml][mask] << ";\n";
					d[1][min(ml, l[i])][p.second] = max(d[1][min(ml, l[i])][p.second], d[0][ml][mask] + p.first - s[i] + c[l[i]]);
				}
			}
		}
		d[1][l[i]][(1 << l[i])] = max(d[1][l[i]][(1 << l[i])], -s[i] + c[l[i]]);
		for (int ml = 0; ml < m; ++ml)
			for (int mask = 0; mask < (1 << (n + m)); ++mask)
				d[0][ml][mask] = d[1][ml][mask];
	}
	int sum = -inf;
	for (int i = 0; i <= m; ++i)
		for (int j = 0; j < (1 << (n + m)); ++j)
			sum = max(sum, d[0][i][j]);
	cout << sum;
	return 0;
}
 