#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)



int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> cost(n), agr(n), price(n + m);
	for (int i = 0; i < n; i++) {
		cin >> agr[i];
		agr[i]--;
	}
	for (int i = 0; i < n; i++)cin >> cost[i];
	for (int i = 0; i < n + m; i++)cin >> price[i];
	ll best = 0;
	if (m != 1) {
		for (int i = 0; i < (1 << n); i++) {
			vector<int> opa;
			bool is_good = true;
			ll cur = 0;
			for (int j = 0; j < n; j++) {
				if ((i >> j) & 1) {
					for (int k = 0; k < opa.size(); k++) {
						if (agr[j] > agr[opa[k]]) {
							is_good = false;
							break;
						}
					}
					opa.push_back(j);
					cur -= cost[j];
				}
			}
			if (!is_good)continue;
			vector<int> have_this_agr(n + m + 1, 0);
			for (int j = 0; j < opa.size(); j++) {
				int cur_agr = agr[opa[j]];
				cur += price[cur_agr];
				while (have_this_agr[cur_agr]) {
					have_this_agr[cur_agr]--;
					cur += price[cur_agr + 1];
					cur_agr++;
				}
				have_this_agr[cur_agr]++;
			}
			//cout << i << " " << cur << "\n";
			best = max(cur, best);
		}
	}
	else {
		sort(cost.begin(), cost.end());
		ll cur = 0, cur1 = 0;
		for (int i = 0; i < n; i++) {
			cur1 = 0;
			cur += cost[i];
			ll take = i + 1, up = 0;
			while (take > 0) {
				cur1 += price[up] * take;
				up++;
				take /= 2;
			}
			best = max(best, cur1 - cur);
		}
	}
	cout << best;
}