#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 2047;


void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

int dp[2][N][N];
const int NO_ANS = -1e9;

int agressive[N];
int cost[N];
int bonus[2 * N];

void Solve() {
	int n, m;
	cin >> n >> m;


	for (int i = 0; i < n; i++) {
		cin >> agressive[i];
		agressive[i]--;
	}
	for (int i = 0; i < n; i++) cin >> cost[i];
	for (int i = 0; i < n + m; ++i) cin >> bonus[i];

	for (int agr = 0; agr < m; agr++) {
		for (int pers = 0; pers <= n; pers++)
			dp[agr & 1][n][pers] = (pers == 0 ? 0 : NO_ANS);
		for (int suff = n - 1; suff >= 0; suff--) {
			for (int pers = 0; pers <= n; pers++) {
				dp[agr & 1][suff][pers] = dp[agr & 1][suff + 1][pers];
				if (pers > 0 && agressive[suff] == agr && dp[agr & 1][suff + 1][pers - 1] != NO_ANS)
					dp[agr & 1][suff][pers] = max(dp[agr & 1][suff][pers],
						dp[agr & 1][suff + 1][pers - 1] + bonus[agr] - cost[suff]);
				if (agr) {
					dp[agr & 1][suff][pers] = max(dp[agr & 1][suff][pers], max(
						2 * pers + 1 <= n && dp[!(agr & 1)][suff][2 * pers + 1] != NO_ANS ?
						dp[!(agr & 1)][suff][2 * pers + 1] + bonus[agr] * (pers) : NO_ANS,
						2 * pers <= n && dp[!(agr & 1)][suff][2 * pers] != NO_ANS ?
						dp[!(agr & 1)][suff][2 * pers] + bonus[agr] * (pers) : NO_ANS
					));
				}
			}
		}
	}
	long long ans = 0;
	for (int suff = n; suff >= 0; suff--) {
		for (int pers = 0; pers <= n; pers++) {
			int p = pers;
			int t = m;
			long long res = dp[(m - 1) & 1][suff][pers];
			if (res == NO_ANS)
				continue;
			while (p > 1) {
				res += (p / 2) * bonus[t];
				t++;
				p /= 2;
			}
			ans = max(ans, res);
		}
	}
	cout << ans;
}

int main() {
	IOOptimize();
	Solve();
}