#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 5e3 + 100;


void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int f[maxn];

int getf(int k){
    int ans = 0;
    for (int bit = 20; bit >= 0; bit--){
        if ((k & (1 << bit)) > 0){
            ans += f[bit];
        }
    }
    return ans;
}

vector<int> l, s, c;

pair<int, unordered_set<int>> battle(unordered_set<int> scene, int k){
    int ans = c[k];

    while(scene.count(k)){
        scene.erase(k);
        k++;
        ans += c[k];
    }
    scene.insert(k);
    return {ans, scene};
}

int main() {
    init();


    int n, m;
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m + 1);

    for (auto &ev: l)
        cin >> ev;
    for (auto &ev: s)
        cin >> ev;
    for (int i = 1; i < c.size(); i++){
        cin >> c[i];
    }

    if (n <= 300) {
        vector<pair<int, unordered_set<int>>> dp(n);
        for (int i = 0; i < n; i++){
            dp[i] = {c[l[i]] - s[i], {l[i]}};
        }
        for (int i = 1; i < n; i++){
            for (int j = 0; j < i; j++){
                if (l[j] < l[i])
                    continue;
                 auto res = battle(dp[j].ss, l[i]);
                if (dp[i].ff <= res.ff + dp[j].ff - s[i]){
                    dp[i].ff = res.ff + dp[j].ff - s[i];
                    dp[i].ss = res.ss;
                }
            }
        }
//        for (int i = 0; i < n; i++){
//            cout << "! " << i << endl;
//            for (auto ev: dp[i].ss)
//                cout << ev << " ";
//            cout << endl;
//        }
        int ans = 0;
        for (int i = 0; i< n; i++){
           // cout << dp[i].ff << " ";
            ans = max(ans, dp[i].ff);
        }
        //cout << endl;
        cout << ans << endl;
        return 0;
    }

    int ans = 0;
    f[0] = c[1];
    for (int i = 1; (1 << i) <= n + m; i++){
        f[i] = 2*f[i - 1] + c[i + 1];
    }

    sort(all(s));
//    for (int i = 1; i<= n; i++){
//        cout << getf(i) << " ";
//    }
//    cout << endl;

    int cursum = 0;
    for (int i = 0; i< n; i++){
        cursum += s[i];
        ans = max(ans, getf(i + 1) - cursum);
    }
    cout << ans << endl;

    return 0;

}