#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int NN = 1e5;
const int TT = 40;
int T = 40;
int dp[2][TT][NN];
int l[NN];
int s[NN];
int c[NN];
const int inf = 2e9;

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    int N = 2e3; T = 15;
    if (m > 1) {
        N = 1e5; T = 40;
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i];
    for (int i = 0; i < N; i++) {
        for (int k = 0; k < T; k++) {
            dp[0][k][i] = dp[1][k][i] = -inf;
        }
    }
        for (int k = 0; k < T; k++) {
            dp[0][k][0] = dp[1][k][0] = 0;
        }
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= mx1; j++) {
            for (int k = l[i]; k < T; k++) {
                bool fl = true;
                if (!fl) continue;
                int cur = l[i];
                int delta = -s[i];
                int nxtmask = j;
                while (true) {
                    delta += c[cur];
                    nxtmask ^= (1 << cur);
                    if (nxtmask & (1 << cur)) break;
                    cur++;
                }
                if (cur >= n + m) break;
                dp[1][l[i]][nxtmask] = max(dp[1][l[i]][nxtmask], dp[0][k][j] + delta);
                mx2 = max(mx2, nxtmask);
            }
        }
        for (int i = 0; i <= mx2; i++) {
            for (int k = 0; k < T; k++)
            dp[0][k][i] = dp[1][k][i];
        }
        mx1 = mx2;
    }
    int ans = 0;
    for (int i = 0; i <= mx1; i++) {
        for (int k = 0; k < T; k++)
        ans = max(ans, dp[0][k][i]);
    }
    cout << ans;
    return 0;
}