#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

#define int long long

const int inf = 1000000000;

int l[31];
int s[31];
int c[31];
int n, m;

pair <int, int> fight(int mask, int l) {
	int sum = 0;
	while (mask & (((long long)1) << l)) {
		mask = mask - (((long long)1) << l);
		++l;
		sum += c[l];
	}
	mask += (1 << l);
	return {sum, mask};
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		--l[i];
	}
	for (int i = 0; i < n; ++i)
		cin >> s[i];
	for (int i = 0; i < n + m; ++i)
		cin >> c[i];
	int m_sum = 0;
	for (int mask = 0; mask < (((long long)1) << n); ++mask) {
		int sum = 0;
		int ml = 100;
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			if (mask & (((long long)1) << i)) {
				if (l[i] > ml)
					ok = false;
				ml = l[i];
			}
		}
		if (!ok)
			continue;
		int mask2 = 0;
		for (int i = 0; i < n; ++i) {
			if (mask & (((long long)1) << i)) {
				sum += c[l[i]] - s[i];
				pair <int, int> p = fight(mask2, l[i]);
				mask2 = p.second;
				sum += p.first;
			}
		}
		m_sum = max(sum, m_sum);
	}
	cout << m_sum;
	return 0;
}
 