#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define ld long double
#define w while
#define con continue
#define br break
#define elif else if
#define INF 1e18
#define inf 1e9
#define EPS 1e-8
#define eps 1e-4
#define int signed
#define datahash pair <pair <vector <ll>, vector <ll>>, vector <ll>>

ll gcd(ll a, ll b) {
    return a ? gcd(b % a, a) : b;
}

const ll p1 = 359657;
const ll m1 = 1000000007;
const ll p2 = 307;
const ll m2 = 1000000009;

datahash phash(const string &s, ll p, ll m) {
    vector <ll> ps(s.size() + 1);
    vector <ll> hs(s.size() + 1);
    vector <ll> rhs(s.size() + 1);
    ps[0] = 1;
    hs[0] = 0;
    for (ll i = 0; i < s.size(); i++) {
        ps[i + 1] = (ps[i] * p) % m;
        hs[i + 1] = (hs[i] * p + s[i]) % m;
    }
    rhs[s.size()] = 0;
    for (ll i = s.size() - 1; i >= 0; i--) {
        rhs[i] = (rhs[i + 1] * p + s[i]) % m;
    }
    return { {hs, rhs}, ps};
}

ll gethash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.first[j + 1] - hasher.first.first[i] * hasher.second[j - i + 1] + m * m) % m;
}
ll getrhash(const datahash &hasher, ll i, ll j, ll p, ll m) {
    return (hasher.first.second[i] - hasher.first.second[j + 1] * hasher.second[j - i + 1] + m * m) % m;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    try {
        ll n, m;
        cin >> n >> m;
        vector<ll> c(n + m);
        vector<pair<ll, ll>> ma(n);
        for (ll i = 0; i < n; i++) {
            cin >> ma[i].first;
            ma[i].first--;
        }
        for (ll i = 0; i < n; i++) {
            cin >> ma[i].second;
        }
        for (ll i = 0; i < n + m; i++) {
            cin >> c[i];
        }
        if (n <= 15 && m <= 15) {
            ll mx = 0;
            for (ll mask = 0; mask < (1 << n); mask++) {
                ll prev = INF;
                bool fail = 0;
                ll su = 0;
                vector<bool> cs(n + m);
                for (ll v = 0; v < n; v++) {
                    if (mask & (1 << v)) {
                        if (prev < ma[v].first) {
                            fail = 1;
                            br;
                        }
                        prev = ma[v].first;
                        su -= ma[v].second;
                        su += c[ma[v].first];
                        for (ll i = ma[v].first; i < n + m; i++) {
                            if (cs[i]) {
                                su += c[i + 1];
                                cs[i] = 0;
                            } else {
                                cs[i] = 1;
                                br;
                            }
                        }
                    }
                }
                if (fail)
                    con;
                mx = max(su, mx);
            }
            cout << mx;
        } else {
            sort(ma.begin(), ma.end());
            vector<ll> ans(n);
            ll psu = 0;
            for (ll i = 0; i < n; i++) {
                ans[i] = (psu = psu - ma[i].second);
                for (ll j = 0; (1 << j) <= (i + 1); j++) {
                    ans[i] += c[j] * (i / (1 << j));
                }
            }
            ll mx = 0;
            for (ll i = 0; i < n; i++) {
                mx = max(ans[i], mx);
            }
            cout << mx;
        }
    } catch(...) {
        cout << "Oblom";
        return 0;
    }
    return 0;
}