#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    if (m <= 2) {
        int N = 1 << 13;
        vvi dp(n, vi(N, -inf));
        forn(i, n) {
            if (i > 0) dp[i] = dp[i - 1];
            dp[i][1 << l[i]] = max(dp[i][1 << l[i]], c[l[i] - 1] - s[i]);
            if (i > 0) {
                forn(j, N) {
                    if (dp[i - 1][j] != -inf && (l[i] == 1 || (l[i] == 2 && j % 4 <= 1))) {
                        int n1 = j + (1 << l[i]);
                        int add = 0;
                        forn1(z, 20){
                            if (j & (1 << z) && z != l[i]){
                                if (!(n1 & (1 << z))) add += c[z - 1];
                            }
                            if (z != l[i] && (n1 & (1 << z)) && !(j & (1 << z))) add += c[z - 1];
                        }
                        dp[i][n1] = max(dp[i][n1], dp[i - 1][j] + add - s[i] + c[l[i] - 1]);
                    }
                }
            }
        }
        cout << *max_element(all(dp[n - 1])) << '\n';
        return;
    }
    int ans = 0;
    forn(mask, 1 << n) {
        bool flag = 1;
        int sum = 0;
        vi L;
        forn(i, n) {
            if (mask & (1 << i)) {
                if (!L.empty() && l[i] > L.back()) {
                    flag = 0;
                    break;
                }
                sum -= s[i];
                sum += c[l[i] - 1];
                L.pb(l[i]);
                while (L.size() >= 2 && L[L.size() - 1] == L[L.size() - 2]) {
                    int x = L.back();
                    sum += c[x];
                    L.pop_back();
                    L.pop_back();
                    L.pb(x + 1);
                }
            }
        }
        if (flag) ans = max(ans, sum);
    }
    cout << ans << '\n';
}

bool multitest = false;

int main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}