#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 2e3 + 7;

int n, m;
int a[N];
int s[N];
int c[N * 3];

void solve15() {
	int mx = 1e9;
	int ans = 0;
	for (int i = 0; i < (1 << n); i++) {
		bool norm = true;
		int cur = 0;
		vector<int> str;
		mx = 1e9;
		for (int j = 0; j < n; j++) {
			if ((1 << j) & i) {
				if (a[j] > mx) {
					norm = false;
				}
				else {
					mx = a[j];
					str.pb(a[j]);
					cur -= s[j];
					cur += c[a[j]];
				}
			}
		}
		if (!norm) continue;
		while (str.size() >= 2) {
			int tp = str.back();
			str.pop_back();
			int sp = str.back();
			str.pop_back();
			if (tp == sp) cur += c[tp + 1];
			str.pb(tp + 1);
		}
		uax(ans, cur);
	}
	cout << ans;
	exit(0);
}

void solve1() {
	exit(0);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n >> m;
	bool S1 = true;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] != 1) S1 = false;
	}
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}
	if (S1) solve1();
	else solve15();
}