#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int n, m;
vector<int> l(2000);
vector<int> s(2000);
vector<int> c(4000);

void solve_1() {
	int ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		int nom = 100000;

		bool ok = true;

		int now = 0;

		vector<int> cnt(100);
		for (int i = 0; i < n; i++) {
			if ((mask & (1 << i)) > 0) {
				if (l[i] > nom) {
					ok = false;
				} else {
					nom = min(nom, l[i]);
				}
				now += c[l[i]];
				cnt[l[i]]++;
				now -= s[i];
			}

		}

		if (!ok) {
            continue;
		}

		for (int i = 0; i < 100; i++) {
			now += (cnt[i] / 2) * c[i + 1];
			cnt[i + 1] += cnt[i] / 2;
		}


		ans = max(ans, now);
	}

	cout << ans;
}

void solve_2() {
	vector<int> arr;
	for (int i = 0; i < n; i++) {
		arr.push_back(s[i]);
	}
	sort(arr.begin(), arr.end());

	int ans = 0;
	int nows = 0;
	for (int i = 0; i < n; i++) {
		nows -= arr[i];
		nows += c[1];

		int cnt = i + 1;
		int now = 1;

		int ans1 = nows;
		while (cnt != 0) {
			ans1 += (cnt / 2) * (c[now + 1]);
			cnt /= 2;
			now++;
		}

		//cout << ans1;

		ans = max(ans, ans1);
	}

	cout << ans;
}
signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}

	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}

	for (int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}
	if (m == 1) {
        solve_2();
        return 0;
	}
	if (n <= 15 && m <= 15) {
		solve_1();
	}
    return 0;
}
