#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(f, a.size()) cout << a[f] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x << '\n'
#define ff first
#define ss second
#define sz(a) (a).size()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef long double ld;

#define int ll

const int inf = 1e18;

bool get_bit(int mask, int i){
    return mask & (1 << i);
}

void run() {
    int n, m;
    cin >> n >> m;
    vector <int> l(n);
    vector <int> s(n);
    vector <int> c(n + m);
    cinm(l);
    cinm(s);
    cinm(c);
    int ans = -inf;
    for(int mask = 0; mask < (1 << n + 1) - 1; ++mask){
        bool able = 1;
        int prev = inf;
        int tsum = 0;
        foru(i, n){
            if(get_bit(mask, i)){
                if(l[i] > prev)
                    able = 0;
                prev = l[i];
                tsum -= s[i];
            }
        }
        if(!able)
            continue;
        set <int> temp;
        foru(i, n){
            if(get_bit(mask, i)){
                tsum += c[l[i] - 1];
                int agr = l[i];
                while(temp.count(agr)){
                    tsum += c[agr + 1 - 1];
                    agr++;
                    temp.erase(agr - 1);
                }
                temp.insert(agr);
            }
        }
        ans = max(ans, tsum);
    }
    cout << ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
    return 0;
}
