#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, m, ans = 0;
vector <ll> l, s, c;
vector <bool> u;
ll ma = 1e10;

void solve(ll i) {
    if (i == n) {
        ll otv = 0;
        vector <ll> all;
        for (ll j = 0; j < n; j++)
            if (u[j]) {
                all.push_back(l[j]);
                otv -= s[j];
                otv += c[l[j] - 1];
            }
        sort(all.begin(), all.end());
        ll q = -1;
        for (ll j = 1; j < all.size(); j++)
            if (all[j] == all[j - 1]) {
                q = j;
                break;
            }
        while (q != -1) {
            vector <ll> te;
            for (ll j = 0; j < all.size(); j++) {
                if (j == q - 1)
                    continue;
                else if (j == q) {
                    te.push_back(all[j] + 1);
                    otv += c[all[j]];
                } else te.push_back(all[j]);
            }
            all = te;
            q = -1;
            sort(all.begin(), all.end());
            for (ll j = 1; j < all.size(); j++)
                if (all[j] == all[j - 1]) {
                    q = j;
                    break;
                }
        }
        ans = max(ans, otv);
        return;
    }
    if (ma >= l[i]) {
        ll temp = ma;
        ma = l[i];
        u[i] = true;
        solve(i + 1);
        ma = temp;
    }
    u[i] = false;
    solve(i + 1);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    l.resize(n); s.resize(n); c.resize(n + m); u.resize(n);
    for (ll i = 0; i < n; i++)
        cin >> l[i];
    for (ll i = 0; i < n; i++)
        cin >> s[i];
    for (ll i = 0; i < n + m; i++)
        cin >> c[i];
    if (m == 1) {
        ans = 0;
        sort(s.begin(), s.end());
        ll su = 0, mm = -1, sc = 0;
        set <ll> all;
        for (ll i = 0; i < n; i++) {
            su += c[0];
            su -= s[i];
            ll dop = 1;
            while (all.count(dop) != 0) {
                all.erase(dop);
                dop++;
                su += c[dop - 1];
            }
            all.insert(dop);
            mm = max(mm, su);
        }
        cout << max(ans, mm);
        return 0;
    }
    solve(0);
    cout << ans;
    return 0;
}