#include <bits/stdc++.h>

using namespace std;
long long bin_pow(int a, int n)
{
    if(n == 0)
        return 1;
    long long p = bin_pow(a, n / 2);
    if(n % 2 == 0)
        return p * p;
    else
        return p * p * a;
}

bool comp(pair <int, int> a, pair <int, int> b)
{
    return a.first < b.first;
}

long long get(int x, int c[])
{
    long long n = 0;
    for(int i = 1; i <= min(x / 2 + 1, 10); i++)
    {
        n += 1ll * c[i] * (x / bin_pow(2, i - 1));
    }
    return n;
}


long long easy(int n, int m, int c[], pair <int, int> s[], int l[])
{
        long long delta = 0, ans = 0;
        sort(s, s + n, comp);
        for(int i = 0; i < n; i++)
        {
            delta += s[i].first;
            long long curr_ans = get(i + 1, c);
            ans = max(ans, curr_ans - delta);
        }
        return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    set <int> st;
    int l[n];
    for(int i = 0; i < n; i++)
    {
        cin >> l[i];
    }
    pair <int, int> s[n];
    for(int i = 0; i < n; i++)
    {
        cin >> s[i].first;
        s[i].second = i;
    }
    int c[n + m + 1];
    for(int i = 1; i <= n + m; i++)
    {
        cin >> c[i];
    }
    if(m == 1)
    {
        cout << easy(n, m, c, s, l);
        return 0;
    }
    if(n <= 15)
    {
        int ans = 0;
        for(int i = 0; i < (1<<n); i++)
        {
            int curr_ans = 0;
            vector <int> q;
            multiset <int> st;
            bool ok = true;
            for(int j = 0; j < n; j++)
            {
                if(i & (1<<j))
                {
                    curr_ans -= s[j].first;
                    curr_ans += c[l[j]];
                    q.push_back(j);
                    for(int k = 0; k < q.size(); k++)
                    {
                        if(l[q[k]] < l[j])
                        {
                            ok = false;
                            break;
                        }
                    }
                    if(!ok)
                        break;
                }
            }
            if(!ok)
                continue;
            bool is_end = false;
            for(int j = 0; j < q.size(); j++)
            {
                bool is_end = false;
                int last = l[q[j]];
                while(!is_end)
                {
                    if(st.find(last) != st.end())
                    {

                        st.erase(last);
                        if(st.find(last + 1) != st.end())
                        is_end = false;
                    else
                        is_end = true;
                        st.insert(last + 1);
                        curr_ans += c[last + 1];
                        last++;

                    }
                    else
                    {
                        st.insert(last);
                        is_end = true;
                    }

                }
            }
            ans = max(ans, curr_ans);
        }
        cout << ans;
    }
    return 0;
}
