#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 2e3 + 15;
const int M = 17;
int n, m, a[N], s[N], c[N + M];
int dp[2][M + 5][1 << M];

inline void solve() {
    memset(dp, -1, sizeof(dp));
    cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    for(int i = 0; i < n; ++i)
        cin >> s[i];
    for(int i = 0; i < n + m; ++i)
        cin >> c[i];
    dp[1][m - 1][0] = 0;
    for(int i = 0; i < n; ++i) {
        int bit = i & 1;
        memcpy(dp[bit], dp[bit ^ 1], sizeof(dp[bit]));
        for(int j = a[i]; j < m; ++j) {
            for(int mask = 0; mask < (1 << M); ++mask) {
                if(dp[bit ^ 1][j][mask] == -1)
                    continue;
                if(1 << a[i] & mask) {
                    int cur_mask = mask;
                    int val = -s[i];
                    for(int k = a[i]; k <= M; ++k) {
                        if(1 << k & mask)
                            val += c[k], cur_mask ^= 1 << k;
                        else {
                            val += c[k];
                            cur_mask |= 1 << (k - 1);
                            break;
                        }
                    }
                    Max(dp[bit][a[i]][cur_mask], dp[bit ^ 1][j][mask] + val);
                }
                else
                    Max(dp[bit][a[i]][(1 << a[i]) | mask], dp[bit ^ 1][j][mask] - s[i] + c[a[i]]);
            }
        }
    }
//    for(int i = 0; i < m; ++i)
//        for(int mask = 0; mask < (1 << m); ++mask)
//            cout << i + 1 << ' ' << bitset<M>(mask) << ' ' << dp[(n ^ 1) & 1][i][mask] << endl;
//    return;
    int ans = 0;
    for(int i = 0; i < M; ++i)
        Max(ans, *max_element(dp[(n ^ 1) & 1][i], dp[(n ^ 1) & 1][i] + (1 << M)));
    cout << ans << endl;
}

main() {
    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    int tt = 1;
    while(tt--)
        solve();
    return 0;
}
