#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;

int ans = 0;

int n;

void go(int i, vi &l, vi &s, vi &c, vi L, int r){
    if (i == n){
        ans = max(ans, r);
        return;
    }
    if (!L.empty() && l[i] > L.back()) {
        go(i + 1, l, s, c, L, r);
        return;
    }
    go(i + 1, l, s, c, L, r);
    L.pb(l[i]);
    r += c[l[i] - 1];
    r -= s[i];
    while (L.size() >= 2 && L[L.size() - 1] == L[L.size() - 2]){
        int x = L.back();
        r += c[x];
        forn(j, 2) L.pop_back();
        L.pb(x + 1);
    }
    go(i + 1, l, s, c, L, r);
}

void solve() {
    int m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    vi L;
    go(0, l, s, c, L, 0);
    cout << ans << '\n';
}

bool multitest = false;

signed main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}