#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define str string
#define ld long double
using namespace std;

const int INF = 1e18;

int dp[2007][4007];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    if (m == 1) {
        vector<int> L(n), S(n), C(1 + n + m);
        for (int i = 0; i < n; i++) {
            cin >> L[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> S[i];
        }
        for (int i = 1; i <= n + m; i++) {
            cin >> C[i];
        }
        sort(S.begin(), S.end());
        int now = 0;
        int aans = 0;
        for (int i = 0; i < n; i++) {
            now += S[i];
            int ans = -now;
            int kek = i + 1;
            int level = 1;
            while (kek) {
                ans += C[level] * kek;
                kek /= 2;
                level++;
            }
            aans = max(ans, aans);
        }
        cout << aans << '\n';
        return 0;
    } else if (n <= 17 && m <= 17) {
        vector<int> L(n), S(n), C(1 + n + m);
        for (int i = 0; i < n; i++) {
            cin >> L[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> S[i];
        }
        for (int i = 1; i <= n + m; i++) {
            cin >> C[i];
        }
        int ans = -1e9;
        for (int mask = 0; mask < pow(2, n); mask++) {
            int cost = 0;
            set<int> live;
            int last = 1e9;
            for (int h = 0; h < n; h++) {
                if (((mask >> h) & 1) && last >= L[h]) {
                    cost += C[L[h]];
                    int agr = L[h];
                    while (live.find(agr) != live.end()) {
                        live.erase(agr);
                        agr++;
                        cost += C[agr];
                    }
                    live.insert(agr);
                    cost -= S[h];
                    last = L[h];
                }
            }
            ans = max(ans, cost);
        }
        cout << ans;
        return 0;
    }
    vector<int> L(1 + n), S(1 + n), C(1 + n + m), pref(1 + n + m);
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> S[i];
    }
    for (int i = 1; i <= n + m; i++) {
        cin >> C[i];
        pref[i] = pref[i - 1] + C[i];
    }
    for (int i = 1; i <= n; i++) {
        for (int d = 1; d <= n + m; d++) {
            dp[i][d] = -INF;
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int d = 0; d <= n + m; d++) {
            if (d == 0) {
                for (int j = 1; j < i; j++) {
                    if (L[j] == L[i]) {
                        int d2 = 1;
                        while (dp[j][d2] != -INF && d2 <= n + m) {
                            dp[i][d] = max(dp[i][d], dp[j][d2] + pref[L[i] + d2] - pref[L[i]] - S[i] + C[L[i]]);
                            d2++;
                        }
                    }
                }
            } else if (d == 1) {
                dp[i][d] = max(dp[i][d], -S[i] + C[L[i]]);
                for (int j = 1; j < i; j++) {
                    if (L[j] > L[i] + 1) {
                        int d2 = 0;
                        while (dp[j][d2] != -INF && d2 <= n + m) {
                            dp[i][d] = max(dp[i][d], dp[j][d2] - S[i] + C[L[i]]);
                            d2++;
                        }
                    } else if (L[j] == L[i] + 1) {
                        dp[i][d] = max(dp[i][d], dp[j][d - 1] - S[i] + C[L[i]]);
                    }
                }
            } else {
                for (int j = 1; j < i; j++) {
                    if (L[i] == L[j] + 1) {
                        dp[i][d] = max(dp[i][d], dp[j][d - 1] - S[i] + C[L[i]]);
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int d = 0; d <= n + m; d++) {
            ans = max(ans, dp[i][d]);
        }
    }
    cout << ans;
}