#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <sstream>
#include <queue>
#include <deque>
#include <iomanip>
#include <fstream>
#include <bitset>
#include <stack>
//#include <xhash>

using namespace std;

multiset<pair<int, int> > mmm;

pair<bool, pair<pair<int, int>, pair<int, int> > > check() {
    for (auto it = mmm.begin(); it != mmm.end(); it++) {
        auto p = it;
        p++;
        if (p != mmm.end() and it->first == p->first) {
            return { true, {*it, *p} };
        }
    }
    return { false, {{}, {}} };
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n = 0, m = 0;
    cin >> n >> m;
    

        if (m == 1) {
            long long ans = 0;
            vector<int> l(n);
            for (int i = 0; i < n; i++) {
                cin >> l[i];
            }
            vector<int> s(n);
            for (int i = 0; i < n; i++) {
                cin >> s[i];
            }
            vector<int> c(n + m);
            for (int i = 0; i < n + m; i++) {
                cin >> c[i];
            }
            sort(s.begin(), s.end());
            vector<int> sum(n + 1, 0);
            vector<int> sumc(n + m + 1, 0);
            for (int i = 1; i <= n + m; i++) {
                sumc[i] = sumc[i - 1] + c[i-1];
            }
            for (int i = 1; i <= n; i++) {
                sum[i] = sum[i - 1] + s[i - 1];
            }
            vector<bool> ghui(n+1, 0);
            long long summ = 0;
            for (int i = 1; i <= n; i++) {
                summ -= s[i - 1];
                summ += c[0];
                if (ghui[1]) {
                    ghui[1] = 0;
                    for (int i = 2; i <= n; i++) {
                        summ += c[i - 1];
                        if (!ghui[i]) {
                            ghui[i] = 1;
                            break;
                        }
                        else {
                            ghui[i] = 0;
                        }
                    }
                }
                else {
                    ghui[1] = 1;
                }
                ans = max(ans, summ);
            }
            cout << ans;
        }
        else {
            if (n <= 15) {
                vector<int> l(n);
                for (int i = 0; i < n; i++) {
                    cin >> l[i];
                }
                vector<int> s(n);
                for (int i = 0; i < n; i++) {
                    cin >> s[i];
                }
                vector<int> c(n + m);
                for (int i = 0; i < n + m; i++) {
                    cin >> c[i];
                }
                bitset<15> b;
                long long ans = -5000 * 10;
                for (int hui = 0; hui < (1 << n); hui++) {
                    b = hui;
                    set<int> jk;
                    bool kek = true;
                    mmm.clear();
                    long long summ = 0;
                    for (int i = 0; i < n; i++) {
                        if (b[i]) {
                            summ -= s[i];
                            if (jk.size()) {
                                auto p = jk.lower_bound(l[i]);
                                if (p != jk.begin()) {
                                    kek = false;
                                }
                                jk.insert(l[i]);

                            }
                            else {
                                jk.insert(l[i]);
                            }
                        }
                    }
                    if (kek) {


                        for (int i = 0; i < n; i++) {
                            if (b[i]) {
                                summ += c[l[i] - 1];
                                mmm.insert({ l[i], i });
                                auto p = check();
                                while (p.first) {
                                    summ += c[p.second.first.first];
                                    mmm.erase(p.second.first);
                                    mmm.erase(p.second.second);
                                    mmm.insert({ p.second.first.first + 1, p.second.first.second });
                                    p = check();
                                }
                            }
                        }
                        ans = max(ans, summ);
                    }
                }
                cout << ans;
            }
        }
    return 0;
}