#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0
#define int ll

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

int ans = 0;
vector<int> l, s, c;

void rec(int pos, int n, vector<bool> &st) {
    if (pos >= n) {
        int last = INF1;
        for (int i = 0; i < n; ++i) {
            if (st[i]) {
                if (l[i] > last)
                    return;
                last = min(last, l[i]);
            }
        }
        int sum = 0;
        map<int, int> m;
        for (int i = 0; i < n; ++i) {
            if (st[i]) {
                sum += c[l[i]] - s[i];
                ++m[l[i]];
            }
        }
        while (!m.empty()) {
            if (m.begin()->second == 1) {
                m.erase(m.begin());
                continue;
            }
            m[m.begin()->first + 1] += m.begin()->second / 2;
            sum += c[m.begin()->first + 1] * m.begin()->second / 2;
            m.erase(m.begin());
        }
        ans = max(ans, sum);
        return;
    }
    rec(pos + 1, n, st);
    st[pos] = true;
    rec(pos + 1, n, st);
    st[pos] = false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    l.resize(n);
    for (int &i : l)
        cin >> i;
    s.resize(n);
    for (int &i : s)
        cin >> i;
    c.resize(n + m + 5);
    for (int i = 1; i <= n + m; ++i)
        cin >> c[i];
    vector<bool> st(n);
    rec(0, n, st);
    cout << ans << '\n';
}