#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> l(n);
    for (auto &i : l) {
        cin >> i;
    }
    vector<int> s(n);
    for (auto &i : s) {
        cin >> i;
    }
    vector<int> c(n + m);
    for (auto &i : c) {
        cin >> i;
    }
    c.emplace(c.begin(), 0);
    if (m != 1) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            vector<int> cur;
            int sum = 0;
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    sum += c[l[i]] - s[i];
                    cur.emplace_back(l[i]);
                }
            }
            if (!is_sorted(cur.rbegin(), cur.rend())) {
                continue;
            }
            sort(cur.begin(), cur.end());
            bool run = true;
            while (run) {
                run = false;
                for (int i = 0; i + 1 < cur.size(); i++) {
                    if (cur[i] == cur[i + 1]) {
                        sum += c[cur[i] + 1];
                        cur.emplace_back(cur[i] + 1);
                        cur.erase(cur.begin() + i, cur.begin() + i + 2);
                        sort(cur.begin(), cur.end());
                        run = true;
                        break;
                    }
                }
            }
            ans = max(ans, sum);
        }
        cout << ans;
    } else {
        int n;
        cin >> n;
        sort(s.begin(), s.end());
        long long ans = 0;
        long long profit = 0;
        vector<int> cnt(n + m + 1);
        for (int i = 0; i < n; i++) {
            profit -= s[i] - c[1];
            cnt[1]++;
            int cur = 0;
            while (cnt[cur] > 1) {
                profit += c[cur + 1];
                cnt[cur] -= 2;
                ++cnt[++cur];
            }
            ans = max(ans, profit);
        }
        cout << ans;
    }
    return 0;
}