#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-avx2")

using namespace std;
typedef long long ll;

const int inf = int(1e9) + 10;

struct osu {
    int mask, mn, upd;
};

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector <int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector <int> cost(n);
    for(int i = 0; i < n; i++) {
        cin >> cost[i];
    }

    vector <int> get(n + m + 1);
    for(int i = 1; i <= n + m; i++) {
        cin >> get[i];
    }

    if (n <= 15 && m <= 15) {
        ll ans = 0;
        for(int mask = 0; mask < (1 << n); mask++) {

            ll cur = 0;
            vector <int> cnt(100);
            int mn = int(1e9);
            for(int i = 0; i < n; i++) {
                int bit = (mask & (1 << i));

                if (bit && a[i] <= mn) {
                    cur -= cost[i];
                    cur += get[a[i]];

                    cnt[a[i]]++;
                    for(int it = 1; it < 100; it++) {
                        if (cnt[it]) {
                            mn = min(mn, it);
                        }

                        if (cnt[it] > 1) {
                            cnt[it + 1]++;
                            cnt[it] = 0;

                            cur += get[it + 1];
                        }
                    }
                }
            }

            ans = max(ans, cur);
        }

        cout << ans << "\n";
    }
    else {
        int M = 16;
        int dp[1 << M][m];
        bool can[1 << M][m];

        for(int i = 0; i < (1 << M); i++) {
            for(int j = 0; j < m; j++) {
                dp[i][j] = -inf;
                can[i][j] = 0;
            }
        }

        dp[0][m - 1] = 0;
        can[0][m - 1] = 1;

        for(int i = 0; i < n; i++) {
            vector <osu> upd;
            for(int mask = 0; mask < (1 << M); mask++) {
                for(int mn = a[i] - 1; mn < m; mn++)
                    if (can[mask][mn]) {
                        vector <int> bits(M);
                        for(int it = 0; it < M; it++) {
                            if ((mask & (1 << it))) {
                                bits[it] = 1;
                            }
                        }

                        if (true) {
                            int now = a[i];
                            int res = -cost[i] + get[now];
                            bits[now]++;
                            while(now < M && bits[now] > 1) {
                                res += get[now + 1];
                                bits[now] = 0;
                                bits[now + 1]++;
                                now++;
                            }

                            int new_mask = 0;
                            for(int it = 0; it < M; it++) {
                                new_mask += (1 << it) * bits[it];
                            }

                            upd.push_back({new_mask, a[i] - 1, dp[mask][mn] + res});
                        }
                }
            }
            for(auto it : upd) {
                    dp[it.mask][it.mn] = max(dp[it.mask][it.mn], it.upd);
                    can[it.mask][it.mn] = 1;

                }
        }

        int ans = 0;
        for(int mask = 0; mask < (1 << M); mask++) {
            for(int mn = 0; mn < m; mn++)
                ans = max(ans, dp[mask][mn]);
        }

        cout << ans << "\n";
    }

    return 0;
}
