#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma GCC optimize ("Ofast")

#define ll long long

using namespace std;

int n, m, ans;
vector <int> s, l, c;

bool check (vector <int>& num) {
    for (int i = 0; i < num.size() - 1; i ++) {
        if (l[num[i]] < l[num[i + 1]]) {
            return false;
        }
    }
    return true;
}

int solve (vector <int> num) {
    if (!check(num)) return 0;
    int counter = 0;
    for (int i = 0; i < num.size(); i ++) {
        counter -= s[num[i]];
    }
    int tmp = 0;
    vector <int> agr(n + m + 1, 0);
    for (int i = 0; i < num.size(); i ++) {
        tmp = l[num[i]];
        counter += c[tmp - 1];
        agr[tmp] ++;
        while (agr[tmp] == 2) {
            agr[tmp] = 0;
            tmp ++;
            agr[tmp] ++;
            counter += c[tmp - 1];
        }
    }
    return counter;
}

void next_v(vector <int>& v) {
    v[n - 1] ++;
    for (int i = n - 1; i >= 0; i --) {
        if (v[i] == 2) {
            v[i - 1] ++;
            v[i] = 0;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    ans = 0;
    s = vector <int>(n, 0);
    l = vector <int>(n, 0);
    c = vector <int>(n + m + 1, 0);
    for (int i = 0; i < n; i ++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i ++) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i ++) {
        cin >> c[i];
    }
    vector <int> v(n, 0);
    vector <int> num;
    for (int i = 0; i < pow(2, n) - 1; i ++) {
        next_v(v);
        for (int i = 0; i < n; i ++) {
            if (v[i] == 1) {
                num.emplace_back(i);
            }
        }
        ans = max(ans, solve(num));
        num.clear();
    }
    cout << ans;
    return 0;
}