#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

const int INF = (int) 1e15;
int rar[2001][2001];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m);
    for (auto &x : l) {
        cin >> x;
    }
    for (auto &x : s) {
        cin >> x;
    }
    for (auto &x : c) {
        cin >> x;
    }
    if (n <= 15) {
        int ans = -INF;
        for (int i = 0; i < (int) pow(2, n); i++) {
            vector<int> kek;
            int mn = INF;
            bool flag = true;
            int res = 0;
            int k = i;
            for (int j = 0; j < n; j++) {
                if (k % 2) {
                    if (l[j] > mn) {
                        flag = false;
                        break;
                    }
                    mn = l[j];
                    res -= s[j];
                    res += c[l[j] - 1];
                    kek.push_back(l[j]);
                    while (kek.size() >= 2) {
                        if (kek.back() == kek[kek.size() - 2]) {
                            int val = kek.back() + 1;
                            kek.pop_back();
                            kek.pop_back();
                            kek.push_back(val);
                            res += c[val - 1];
                        } else {
                            break;
                        }
                    }
                }
                k /= 2;
            }
            if (flag) {
                ans = max(ans, res);
            }
        }
        cout << ans << endl;
        return 0;
    }
    if (m == 1) {
        sort(s.begin(), s.end());
        int best = 0;
        for (int i = 1; i <= n; i++) {
            int now = 0;
            for (int j = 0; j < i; j++) {
                now -= s[j];
            }
            int cnt = 0, k = i;
            while (k > 0) {
                now += c[cnt] * k;
                k /= 2;
                cnt++;
            }
            best = max(best, now);
        }
        cout << best << endl;
        return 0;
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            int now = c[0] * i;
            int cnt = 1;
            int k = i / 2 + j;
            while (k > 0) {
                now += c[cnt] * k;
                k /= 2;
                cnt++;
            }
            rar[i][j] = now;
        }
    }
    int best = 0;
    for (int i = 0; i <= n; i++) {
        vector<int> a1;
        vector<int> a2;
        for (int j = 0; j < i; j++) {
            if (l[j] == 2) {
                a1.push_back(s[j]);
            }
        }
        for (int j = i; j < n; j++) {
            if (l[j] == 1) {
                a2.push_back(s[j]);
            }
        }
        sort(a1.begin(), a1.end());
        sort(a2.begin(), a2.end());
        for (int j = 1; j < a1.size(); j++) {
            a1[j] += a1[j - 1];
        }
        for (int j = 1; j < a2.size(); j++) {
            a2[j] += a2[j - 1];
        }
        for (int j = 0; j <= a1.size(); j++) {
            for (int k = 0; k <= a2.size(); k++) {
                int val1 = 0, val2 = 0;
                if (j > 0) {
                    val1 = -a1[j - 1];
                }
                if (k > 0) {
                    val2 = -a2[k - 1];
                }
                best = max(best, val1 + val2 + rar[j][k]);
            }
        }
    }
    cout << best << endl;
}