#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 100010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

int l[MX];
int s[MX];
int c[MX];
int n, m;

bool valid(int mask) {
    int mx = INF;
    fi(0, n) {
        if ((1 << i) & mask) {
            if (l[i] > mx)
                return false;
            mx = l[i];
        }
    }
    return true;
}


void one() {
    int mx = 0;
    sort(s, s + n);
    int spent = 0;
    fi(1, n + 1) {
        if (i == n)
            ++--i;
        spent += s[i - 1];
        int cur = i;
        int ans = 0;
        int st = 1;
        while (cur != 0) {
            ans += cur * c[st - 1];
            ++st;
            cur /= 2;
        }
        mx = max(ans - spent, mx);

    }
    cout << mx;
}

void two() {
    int mx = 0;
    int f = n;
    fi(0, n) {
        if (l[i] == 1) {
            f = i;
            break;
        }
    }
    fi(f, n) {
        if (l[i] == 2)
            s[i] = INF;
    }
    sort(s, s + f);
    sort(s + f, s + n);
    int spent1 = 0;
    fi(-1, f) {
        if (i >= 0)
            spent1 += s[i];
        int spent2 = 0;
        fj(f - 1, n) {
            if (j >= f)
                spent2 += s[j];
            int sum = 0;
            int left = i + 1;
            int right = j - f + 1;
            sum += right * c[0];
            left += right / 2;
            int st = 1;
            while (left != 0) {
                sum += left * c[st];
                ++st;
                left /= 2;
            }
            mx = max(mx, sum - spent1 - spent2);
        }
    }
    cout << mx;
}
int res;
set<int> cur;
void come(int x) {
    res += c[x - 1];
    if (cur.count(x)) {
        cur.erase(x);
        come(x + 1);
    } else {
        cur.insert(x);
    }
}
int32_t main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    fi(0, n) {
        cin >> l[i];
    }
    fi(0, n)
        cin >> s[i];
    fi(0, m + n)
        cin >> c[i];
    if (m == 1)
        one();
    else if (m == 2)
        two();
    else {
        int mx = 0;
        rep(mask, 0, 1 << n) {
            cur = {};
            if (mask == 22)
                ++--mask;
            int spent = 0;
            res = 0;
            if (!valid(mask))
                continue;
            fi(0, n) {
                if ((1 << i) & mask) {
                    come(l[i]);
                    spent += s[i];
                }
            }
            mx = max(mx, res - spent);
        }
        cout << mx;
    }
}