#include <bits/stdc++.h>
#define int long long
#define endl '\n'

// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC target("avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	fast();

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	while (t--) 
		solve();
}

void solve() {

	int n, m;
	cin >> n >> m;

	vector <int> ans(n);

	for (auto &d: ans)
		cin >> d;

	vector <int> g[n];

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		a--, b--;	
		g[b].push_back(a);
	}

	int gc = 0;

	vector <int> used(n);

	for (int mask = 0; mask < (1 << n); ++mask) {

		for (int i = 0; i < n; ++i) 
			used[i] = 0;

		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				for (auto &d: g[i]) 
					used[d] = 1;
			}
		}

		int sum = 0;

		for (int i = 0; i < n; ++i) 
			if (used[i]) 
				sum += ans[i];

		gc = __gcd(gc, sum);
	}

	cout << gc << endl;
}