#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <deque>
#include <cassert>
#include <cmath>


#define x first
#define y second
#define int long long


typedef long long ll;
typedef long double ld;


using namespace std;


const int maxn = 2e3 + 10;


int a[maxn];
int b[maxn];
int c[maxn * 3];
int dp[maxn][(1 << 16)];


pair<int, int> got(int n, int mask) {
	int a1 = 0;
	while (1) {
		if ((mask >> n) & 1) {
			mask = mask ^ (1 << n);
			n++;
			a1 += c[n];
		}
		else {
			mask = mask ^ (1 << n);
			break;
		}
	}
	return { a1, mask };
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	for (int i = 0; i < n + m; i++) {
		cin >> c[i];
	}
	if (n <= 15) {
		pair<int, int> ans = { 0, 0 };
		for (int mask = 0; mask < (1 << n); mask++) {
			int cur = 0;
			map<int, int> get;
			bool f = 1;
			for (int j = 0; j < n; j++) {
				if ((mask >> j) & 1) {
					if (!get.empty() && (a[j] - 1) > get.begin()->x) {
						f = 0;
						break;
					}
					get[a[j] - 1]++;
					cur -= b[j];
					cur += c[a[j] - 1];
					int cc = a[j] - 1;
					while (1) {
						if (get[cc] == 2) {
							get[cc] = 0;
							cur += c[cc + 1];
							get[cc + 1]++;
							cc++;
						}
						else
							break;
					}
				}
			}
			if (!f)
				continue;
			ans = max(ans, { cur, mask });
		}
		cout << ans.x;
		return 0;
	}
	else {
		int ans = 0;
		for (int i = 0; i < maxn; i++) {
			for (int j = 0; j < (1 << 16); j++) {
				dp[i][j] = -1e18;
			}
		}
		dp[0][0] = 0;
		for (int i = 0; i < n; i++) {
			for (int mask = 0; mask < (1 << 16); mask++) {
				if (dp[i][mask] == -1e18)
					continue;
				dp[i + 1][mask] = dp[i + 1][mask];
				int l = 1e9;
				int y = a[i] - 1;
				for (int j = 0; j < 16; j++) {
					if ((mask >> j) & 1) {
						l = j;
						break;
					}
				}
				if (l >= y) {
					auto bb = got(y, mask);
					dp[i + 1][bb.y] = max(dp[i + 1][bb.y], dp[i][mask] - b[i] + c[y] + bb.x);
					ans = max(ans, dp[i][mask] - b[i] + c[y] + bb.x);
				}
			}
		}
		cout << ans;
	}
	//system("pause");
	return 0;
}
