#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;

void solve() {
    int n, m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    vvi dp(n + 1, vi(n + m + 1, -inf));
    for (int i = n - 1; i >= 0; --i) {
        dp[i][l[i]] = max(dp[i][l[i]], c[l[i] - 1] - s[i]);
        for (int j = i + 1; j < n; ++j) {
            if (l[j] <= l[i]) {
                if (dp[j][l[i]] != -inf) {
                    dp[i][l[i] + 1] = max(dp[i][l[i] + 1], dp[j][l[i]] + c[l[i] - 1] + c[l[i]] - s[i]);
                }
                forn(z, l[i]) {
                    if (dp[j][z] == -inf) continue;
                    dp[i][l[i]] = max(dp[i][l[i]], dp[j][z] + c[l[i] - 1] - s[i]);
                }
            }
        }
    }
    int ans = 0;
    forn(i, n) ans = max(ans, *max_element(all(dp[0])));
    cout << ans << '\n';
}

bool multitest = false;

signed main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}