#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")


using namespace std;
//using namespace __gnu_pbds;

#define int long long
#define ss second
#define ff first
#define pb push_back

const int N = 2e6 + 51, INF = 1e18, MOD = 1e9 + 7;

using vi = vector <int>;
using vp = vector <pair <int, int>>;

mt19937 Flash_new_51(5151552525);

int l[N], s[N], c[N], n = 3, m = 1;
int dp[2002][2002];

int solve () {
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= n; j++) dp[i][j] = -INF;
    }
    dp[0][1] = c[1] - s[0];
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dp[i - 1][j] == -INF) continue;
            int kek = dp[i - 1][j] - s[i] + c[1];
            for (int o = 0; o < 60; o++) {
                if (((j >> o) & 1) == 0) break;
                kek += c[o + 2];
            }
            dp[i][j + 1] = max(dp[i][j + 1], kek);
            dp[i][j] = max(dp[i][j], dp[i - 1][j]);
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; i++) {
        ans = max(ans, dp[n - 1][i]);
    }
    return ans;
}

/*void stres () {
    for (int i = 0; i < n; i++) s[i] = Flash_new_51() % 10;
    for (int i = 1; i <= n + m; i++) c[i] = Flash_new_51() % 10;
}*/

signed main() {
    #ifdef Flash
        freopen("input.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 1; i <= n + m; i++) cin >> c[i];
    if (m == 1) {
        cout << solve();
        return 0;
    }
    int msk = (1ll << n), ans = 0;
    for (int mask = 0; mask < msk; mask++) {
        vi a;
        int sum = 0, mx = -1;
        bool ok = true;
        for (int j = 0; j < n; j++) {
            if ((mask >> j) & 1) {
                if (mx == -1) mx = l[j];
                else if (mx < l[j]) ok = false;
                mx = min(mx, l[j]);
                a.pb(l[j]);
                sum -= s[j];
            }
        }
        if (!ok) continue;
        int nxt[n + m + 2];
        for (int i = 0; i <= n + m; i++) nxt[i] = 0;
        for (auto to : a) {
            sum += c[to];
            nxt[to]++;
            while (nxt[to] == 2) {
                nxt[to] = 0;
                to++;
                sum += c[to];
                nxt[to]++;
            }
        }
        ans = max(ans, sum);
    }
    cout << ans;
}
