#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

int solve();
int solve1();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

signed main() {
    boot_up();

    mt19937 rnd(1);

    cin >> n >> m;
    init(l, n);
    for (auto & it : l) {
        cin >> it;
    }

    init(s, n);
    for (auto & it : s) {
        cin >> it;
    }

    init(c, n + m + 1);
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }

    cout << solve() << '\n';
    return 0;

    for (int test = 1; test <= 10; ++test) {
        n = 1 + rnd() % 10;
        m = 1 + rnd() % 10;

        init(l, n);
        for (auto & it : l) {
            it = 1 + rnd() % m;
        }

        init(s, n);
        for (auto & it : s) {
            it = rnd() % 10;
        }

        init(c, n + m + 1);
        for (int i = 1; i <= n + m; ++i) {
            c[i] = -10 + rnd() % 21;
        }

        int ans1 = solve();
        int ans2 = solve1();

        if (ans1 != ans2) {
            dbg(test);
            cout << "CHTOO!!!\n";
            cout << n << ' ' << m << '\n';
            dbg(ans1);
            dbg(ans2);
            info(l);
            info(s);
            info(c);
            exit(0);
        }
        else {
            cout << test << '\n';
        }
    }
}

int solve() {
    vector<vector<pair<set<int>, int>>> take(n);
    vector<int> dp(n, -INF_INT);

    dp[0] = c[l[0]] - s[0];
    take[0].emplace_back(pair<set<int>, int>{{l[0]}, c[l[0]] - s[0]});
    for (int i = 1; i < n; ++i) {
        take[i].emplace_back(pair<set<int>, int>{{l[i]}, c[l[i]] - s[i]});
        for (int prev = 0; prev < i; ++prev) {
            if (l[prev] >= l[i]) {
                for (const auto & it : take[prev]) {
                    int curr_ans = it.second - s[i] + c[l[i]];

                    set<int> tmp = it.first;

                    int now = l[i];

                    while (tmp.count(now)) {
                        tmp.erase(now);
                        ++now;
                        curr_ans += c[now];
                    }
                    tmp.insert(now);

                    take[i].emplace_back(tmp, curr_ans);
                    chkmax(dp[i], curr_ans);
                }
            }
        }
    }

    int ans = max(0, *max_element(all(dp)));
    for (int i = 0; i < n; ++i) {
        int now = c[l[i]] - s[i];
        chkmax(ans, now);
    }

    return ans;
}

int solve1() {
    int ans = 0;
    for (int mask = 1; mask <= (1 << n) - 1; ++mask) {
        vector<int> take;
        for (int i = 0; i < n; ++i) {
            if ((int)((mask >> i) & 1) == 1) {
                take.emplace_back(i);
            }
        }
        bool flag = true;

        for (int i = 0; i < len(take) - 1; ++i) {
            if (l[take[i]] < l[take[i + 1]]) {
                flag = false;
                break;
            }
        }

        if (flag) {
            int curr_ans = 0;
            for (const auto & i : take) {
                curr_ans -= s[i];
            }

            set<int> curr;
            for (const auto & i : take) {
                curr_ans += c[l[i]];

                int now = l[i];

                while (curr.count(now)) {
                    curr.erase(now);
                    ++now;
                    curr_ans += c[now];
                }
                curr.insert(now);
            }

            if (chkmax(ans, curr_ans) && ans == 1) {
                for (int i = 0; i < n; ++i) {
                    cout << (int)((mask >> i) & 1);
                }
                cout << '\n';
            }
        }
    }

   return ans;
}