#include <iostream>
#include <assert.h>
#include <bitset>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define vbb vector<bool>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)
#define inf (ll)(1e9 + 7)

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, m;
    cin >> n >> m;
    vll l(n);
    for(int i = 0; i < n; i++)
    {
        cin >> l[i];
    }
    vll s(n);
    for(int i = 0; i < n; i++)
        cin >> s[i];
    vll c(n + m + 1);
    for(int i = 1; i <= n + m; i++)
        cin >> c[i];

    if(m == 1) // second group
    {
        ll answ = 0;
        sort(s.begin(), s.end());
        vll cost(n + 1);
        cost[1] = s[0];
        for(int i = 2; i <= n; i++)
            cost[i] = cost[i - 1] + s[i - 1];

        vll sum(min(12ll, n + m));
        sum[1] = c[1];
        for(int i = 2; i < sum.size(); i++)
            sum[i] = 2 * sum[i - 1] + c[i];

    //    cerr << "sum ";
    //    for(int i = 0; i < sum.size(); i++)
    //        cerr << sum[i] << " ";
    //    cerr  << endl;

        for(int mask = 0; mask < (1 << 12); mask++)
        {
            ll totalPeople = mask;
            if(totalPeople > n || totalPeople == 0)
                continue;

       //     cerr << "mask " << mask << " totalPeople " << totalPeople << endl;
            ll curAnsw = -cost[totalPeople];
        //    cerr << "people cost " << curAnsw << endl;
            for(int i = 0; i < 12; i++)
            {
                if((mask & (1 << i)) != 0)
                {
                    curAnsw += sum[i + 1];
                }
            }
          //  cerr << "curAnsw " << curAnsw << endl;
            answ = max(answ, curAnsw);
        }
        cout << answ << endl;
        return 0;
    }


    ll answ = 0;
    for(int mask = 0; mask < (1 << n); mask++)
    {
        ll prev = -1;
        bool flag = 0;
        ll curAnsw = 0;
        for(int j = 0; j < n; j++)
        {
            if((mask & (1 << j)))
            {
                ll cur = l[j];
                if(prev != -1 && cur > prev)
                {
                    flag = 1;
                    break;
                }
                prev = cur;
                curAnsw -= s[j];
            }
        }
        if(flag)
            continue;

        // cerr << "looking at mask " << mask << " curAnsw " << curAnsw << endl;
        multiset<ll> curSt;
        for(int j = 0; j < n; j++)
        {
            if((mask & (1 << j)))
            {
                //     cerr << "j = " << j << endl;
                ll cur = l[j];
                curAnsw += c[cur];

                while(curSt.find(cur) != curSt.end())
                {
                    curSt.erase(curSt.find(cur));
                    cur++;
                    curAnsw += c[cur];
                }
                curSt.insert(cur);
                //  cerr << "curAnsw " << curAnsw << endl;
            }
        }
        //   cerr << "curAnsw " << curAnsw << endl;
        answ = max(answ, curAnsw);
    }
    cout << answ << endl;
    return 0;
}