#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<fstream>
///#pragma GCC optimize("Ofast")
#define int long long
#define all(a) a.begin(), a.end()
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int INF = 2100;

int n, m;
vector<int> l;
vector<int> s;
vector<int> c;
vector<int> cnt;

void init() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    cin >> n >> m;
    l.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    s.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    c.resize(n + m);
    for (int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }

    cnt.resize(n + m + 1, 0);
    ///cin.close(); cout.close();
}

void clrcnt() {
    for (int i = 0; i < n + m; ++i) {
        cnt[i] = 0;
    }
}

signed main() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    init();
    if (n <= 15 && m <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            clrcnt();
            int sum = 0;
            int lst = INF;
            int good = 1;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    if (lst < l[i]) {
                        good = 0;
                        break;
                    }
                    sum -= s[i];
                    lst = l[i];
                    cnt[l[i]]++;
                }
            }
            if (good) {
                for (int i = 0; i < n + m + 1; ++i) {
                    if (cnt[i]) {
                        sum += c[i - 1] * cnt[i];
                        cnt[i + 1] += cnt[i] / 2;
                    }
                }
            }
            ans = max(ans, sum);
        }
        cout << ans;
        return 0;
    }
    if (m == 1) {
        sort(all(s));
        int ans = 0;
        int del = 0;
        for (int i = 0; i < n; ++i) {
            del += s[i];
            int add = 0;
            int x = i + 1;
            int id = 0;
            while (x > 0) {
                add += x * c[id];
                x /= 2;
                id++;
            }
            ans = max(ans, add - del);
        }
        cout << ans;
        return 0;
    }
    ///cin.close(); cout.close();
    return 0;
}
