#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;
#define endl '\n'
const int MAXN=2e3+10;
int agr[MAXN], pr[MAXN], w[2*MAXN];
bool used[MAXN];
set <int> s;
vector <int> v;
int n;
int play() {
    int wi=0, ag;
    s.clear();
    for (int j=0;j<n;j++) {
        if (!used[j]) continue;
        wi-=pr[j];
        ag=agr[j];
        wi+=w[ag];
        v.clear();
        for (auto it=s.begin();it!=s.end();it++) {
            if ((*it)==ag) {
                ag++;
                wi+=w[ag];
                v.push_back((*it));
            }
        }
        for (auto it:v) s.erase(it);
        s.insert(ag);
    }
    return wi;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int m;
    cin >> n >> m;
    for (int i=0;i<n;i++) cin >> agr[i];
    for (int i=0;i<n;i++) cin >> pr[i];
    for (int i=1;i<=n+m;i++) cin >> w[i];
    if (n<=15) {
        int ans=0, ki, wi, ag, maxs;
        bool pos;
        for (int i=0;i<(1<<n);i++) {
            ki=i;
            for (int j=0;j<n;j++) {
                if (i%2) used[j]=true;
                else used[j]=false;
                i/=2;
            }
            i=ki;
            pos=true;
            for (int j=0;j<n;j++) {
                for (int k=j-1;k>=0;k--) {
                    if (used[k] && used[j] && agr[j]>agr[k]) pos=false;
                }
            }
            if (!pos) continue;
            wi=play();
            ans=max(ans,wi);
        }
        cout << ans << endl;
    } else {
        sort(pr,pr+n);
        int ans=0;
        for (int i=0;i<n;i++) {
            used[i]=true;
            ans=max(ans,play());
        }
        cout << ans << endl;
    }
    return 0;
}
/**
5 1
1 1 1 1 1
3 1 2 5 4
1 2 100 4 5 6
**/
