#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <random>
#include <queue>
using namespace std;

#pragma GCC optimize("inline-functions")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)
const int N = 100;
int l[N], s[N], c[N];
int taken[N];
int n, m;

int f() {
  int la = 1e9;
  for(int i = 0; i < n; i++) {
    if (taken[i]) {
      if (la < l[i]) return -1;
      la = l[i];
    }
  }
  ll res = 0;
  vector<bool> state(N);
  auto put = [&](int pos) {
    res += c[pos];
    while (state[pos]) {
      res += c[pos + 1];
      state[pos++] = 0;
    }
    state[pos] = 1;
  };
  for(int i = 0; i < n; i++) {
    if (taken[i]) {
      res -= s[i];
      put(l[i]);
    }
  }
  return res;
}

void run() {
  cin >> n >> m;
  for(int i = 0; i < n; i++) {
    cin >> l[i];
  }
  for(int i = 0; i < n; i++) {
    cin >> s[i];
  }
  for(int i = 1; i <= n + m; i++) {
    cin >> c[i];
  }
  if (n <= 15) {
    int ans = 0;
    for(int i = 0; i < (1 << n); i++) {
      for(int j = 0; j < n; j++) {
        if (i >> j & 1) taken[j] = 1;
        else taken[j] = 0;
      }
      chkmax(ans, f());
    }
    cout << ans;
  } else if (m == 1) {
    vector<pair<int, int>> p;
    for(int i = 0; i < n; i++) {
      p.emplace_back(s[i], i);
    }
    sort(all(p));
    int ans = 0;
    for(int i = 0; i < n; i++) {
      taken[p[i].y] = 1;
      chkmax(ans, f());
    }
    cout << ans;
  }
}

int main() {
#ifdef _DEBUG
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    run();
}
