#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int Inf = 1e9;

int solve(int n, int m, vector <int> l, vector <int> s, vector <int> c) {	
	reverse(l.begin(), l.end());
	reverse(s.begin(), s.end());
	vector <vector <int>> best(n + m + 1, vector <int> (n + 1, -Inf));
	for (int i = 0; i <= n + m; ++i) best[i][0] = 0;
	vector <int> dp(n + 1);
	for (int i = 0; i < n; ++i) {
		for (int cnt = 0; cnt < n; ++cnt) {
			dp[cnt + 1] = best[l[i]][cnt];
			if (dp[cnt + 1] != -Inf) {
			 	dp[cnt + 1] -= s[i];
			}
		}
		dp[0] = 0;
		int r = n;
		int ptr = l[i];
		while (ptr <= n + m) {
			for (int i = 0; i <= r; ++i) {
			 	best[ptr][i] = max(best[ptr][i], dp[i]);
		 	}
		 	for (int i = 0; i <= r; ++i) {
		 		if (i % 2 == 0) {
		 			int val = dp[i] + i * c[ptr];
		 			if (dp[i] == -Inf) val = -Inf;
		 		 	dp[i / 2] = val;
		 		} else {
		 			int val = dp[i] + i * c[ptr];
		 			if (dp[i] == -Inf) val = -Inf;
		 			dp[i / 2] = max(dp[i / 2], val);
		 		}
		 	}
		 	r /= 2;
		 	++ptr;
		}
	}
	int ans = 0;
	for (int i = 0; i <= n + m; ++i) {
		ans = max(ans, best[i][0]);
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int i = 0; i < n; ++i) cin >> l[i];
	vector <int> s(n);
	for (int i = 0; i < n; ++i) cin >> s[i];
	vector <int> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	cout << solve(n, m, l, s, c) << '\n';
}