#include <iostream>
#include <algorithm>
#define endl '\n'

using namespace std;

const int MAXN = 2000;
const int MAXM = 2000;

int n, m;
int l[MAXN+10], s[MAXN+10];
int c[MAXN+MAXM+10];
long long ans = 0;

void input()
{
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        cin>>l[i];
    }
    for (int i=0; i<n; i++)
    {
        cin>>s[i];
    }
    for (int i=0; i<n+m; i++)
    {
        cin>>c[i];
    }
}

void output()
{
    cout<<ans<<endl;
}

void zeroingArray(int arr[], int n)
{
    for (int i=0; i<n; i++)
    {
        arr[i] = 0;
    }
}

void solve()
{
    if (m == 1)
    {
        sort(s, s+n);

        int d[n+10];
        long long sum = 0;
        zeroingArray(d, n);
        for (int i=0; i<n; i++)
        {
            int p = 0;
            sum += c[0];
            sum -= s[i];
            while (d[p] == 1)
            {
                d[p] = 0;
                sum += c[++p];
            }
            d[p] = 1;
            ans = max(ans, sum);
        }
    }

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
4 1
1 1 1 1
1 2 2 3
3 -200 10 17 100 2000

1 1
1
1
2 1000
*/

