#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 2000 + 7;
const int M = 2 * N;

int n, m;
int l[N], s[N], c[M];
int dp[N][N];
int kek[M][N];

inline int f(vector<int> &cl, vector<int> &cs) {
    int res = 0;
    for (int i = 0; i < cl.size() - 1; ++i) {
        if (cl[i] < cl[i + 1]) {
            return 0;
        }
        res += cs[i] - c[cl[i]];
    }
    int cnt = 0;
    int r = cl.back();
    for (int i = cs.size() - 1; i >= 0; --i) {
        if (cl[i] == r) {
            ++cnt;
        }
        else {
            if (r == -1) {

            }
        }
    }
    return res;
}

int stupid_solve() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> cl, cs;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                cl.push_back(l[i + 1]);
                cs.push_back(s[i + 1]);
            }
        }
        ans = max(ans, f(cl, cs));
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    for (int i = M - 2; i >= 0; --i) {
        for (int j = 0; j < N - 1; ++j) {
            kek[i][j] = kek[i + 1][j / 2] + j / 2 * c[i + 1];
        }
    }
    /*cout << stupid_solve() << '\n';
    return 0;*/
    l[0] = 1e9;
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            int rt = 0;
            for (int k = 0; k < i; ++k) {
                if (l[k] > l[i] + 1) {
                    rt = max(rt, dp[k][0]);
                }
            }
            dp[i][j] = kek[l[i]][j + 1] + c[l[i]] - s[i] + rt;
            for (int k = 0; k < i; ++k) {
                if (l[i] <= l[k]) {
                    int r = 0;
                    int nj = j + 1;
                    for (int it = 0; it < l[k] - l[i]; ++it) {
                        r += nj / 2 * c[l[i] + it + 1];
                        nj /= 2;
                    }
                    dp[i][j] = max(dp[i][j], dp[k][nj] + r + c[l[i]] - s[i]);
                }
            }
        }
        ans = max(ans, dp[i][0]);
    }
    cout << ans << '\n';
    return 0;
}