#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 2000 + 7;
const int M = 2 * N;

int n, m;
int l[N], s[N], c[M];
int dp[N][N];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    l[0] = 1e9;
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int k = 0; k < i; ++k) {
                if (l[i] <= l[k]) {
                    int r = 0;
                    int nj = j + 1;
                    for (int it = 0; it < l[k] - l[i] && nj != 0; ++it) {
                        r += nj / 2 * c[l[i] + it + 1];
                        nj /= 2;
                    }
                    dp[i][j] = max(dp[i][j], dp[k][nj] + r + c[l[i]] - s[i]);
                }
            }
        }
        ans = max(ans, dp[i][0]);
    }
    cout << ans << '\n';
    return 0;
}