#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 2000 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const int bits = 15;

int n, m;
int a[MAXN], s[MAXN], c[MAXN * 2];

pii calc(int val, int mask) {
	int res = 0, new_mask = mask;
	for (int i = val; i < bits; i++) {
		res += c[i];
		if (((mask >> i) & 1) == 0) {
			new_mask += (1 << i);
			return {res, new_mask};
		}
		new_mask -= (1 << i);
	}
	return {res, new_mask};
}

void solve() {
	int dp[5][(1 << bits)];
	for (int j = 0; j < 5; j++) {
		for (int k = 0; k < (1 << bits); k++)
			dp[j][k] = -INF;
	}
	dp[m - 1][0] = 0;
	for (int i = 0; i < n; i++) {
		vector <pii>  upd;
		for (int j = a[i]; j < m; j++) {
			for (int mask = 0; mask < (1 << bits); mask++) {
				if (dp[j][mask] == -INF)
					continue;
			//	if(i == 1)
			//		cerr << j << ' ' <<  mask << endl;
				pii profit = calc(a[i], mask);
				profit.f -= s[i];
				profit.f += dp[j][mask];
				//if (i == 1 && mask == 8)
				//	cerr << profit.f << ' ' << profit.s << endl;
				upd.pb(profit);
			}
		}
		for (auto it : upd)
			dp[a[i]][it.s] = max(dp[a[i]][it.s], it.f);
		if (i == 1)
			cerr << dp[2][12] << endl;
	}
	int ans = 0;
	for (int i = 0; i < 5; i++) {
		for (int j = 0; j < (1 << bits); j++)
			ans = max(ans, dp[i][j]);
	}
	cout << ans;
}	

int main() {
	fastIO();
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < n + m; i++)
		cin >> c[i];
	if (m <= 5) {
		//cerr << "aaa";
		solve();
		//cout << endl;
		return 0;
	}
	ll ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		int last = 5000;
		bool bad = 0;
		ll res = 0;
		for (int i = 0; i < n; i++) {
			if ((mask >> i & 1)) {
				if (a[i] > last)
					bad = 1;
				last = a[i];
				res -= s[i];
			}
		}
		if (bad)
			continue;
		vi cur;
		for (int i = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				res += c[a[i]];
				//cerr << res << endl;
				cur.pb(a[i]);
				while (cur.size() > 1 && cur.back() == cur[cur.size() - 2]) {
					cur.pop_back();
					cur.back()++;
					res += c[cur.back()];
				}
			}
		}
		//if (res == 10)
		//	cerr << mask;
		ans = max(ans, res);
	}
	cout << ans;
	
	
	
	
	
	return 0;

}