#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 210, LG = 8, P = 31, mod = 1e9 + 7;
ll dp[N][1 << LG][N];
int l[N], c[N], s[N], prefSum[2 * N], inf = 1e9;
struct position
{
	int elem, mask, cnt1;
};
int getOnes(int mask) {
	int x = 0;
	for (int i = 0; ; ++i) {
		if ((mask >> i) & 1) {
			x++;
		}
		else {
			break;
		}
	}
	return x;
}
position getNewPosition(position was, int newelem) {
	int diff = was.elem - newelem;
	if (diff > LG) {
		return {newelem, 0, 0}; 
	}
	else {
		int newMask = was.mask << diff, partMoved = (was.mask >> (LG - diff));
		newMask %= (1 << LG);
		// debug(partMoved)
		int newCnt1 = was.cnt1;
		if (getOnes(partMoved) == diff) {
			newCnt1 += diff;
		}
		else {
			newCnt1 = getOnes(partMoved);
		}

		return {newelem, newMask, newCnt1};
	}
}
int getSum(int l, int r) {
	if (!l) return prefSum[r];
	return prefSum[r] - prefSum[l - 1];
}
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m;
	std::cin >> n >> m;
	FOR(i, n) {
		std::cin >> l[i];
		--l[i];
	}
	FOR(i, n) {
		std::cin >> s[i];
	}
	FOR(i, n + m) {
		std::cin >> c[i];
		if (i) prefSum[i] += prefSum[i - 1];
		prefSum[i] += c[i];
	}
	FOR(i, N) {
		FOR(j, (1 << LG)) {
			FOR(q, N) {
				dp[i][j][q] = -inf;
			}
		}
	}
	ll ans = 0;
	// debug(getNewPosition({1, 255, 1}, 1).cnt1);
	// return 0;
	FOR(i, n) {
		dp[i][1][0] = std::max(dp[i][1][0], -(ll)s[i] + c[l[i]]);
		// debug(dp[i][0][0])
		for (int last = i - 1; last >= 0; --last) {
			if (l[last] < l[i]) continue;
			for (int wasMask = 0; wasMask < (1 << LG); ++wasMask) {
				for (int wasCnt1 = 0; wasCnt1 < n; ++wasCnt1) {

					if (dp[last][wasMask][wasCnt1] == -inf) continue;

					position now = getNewPosition({l[last], wasMask, wasCnt1}, l[i]);

					ll upd = -s[i] + c[l[i]];
					int j = 0;
					for (; j < LG; ++j) {
						if ((now.mask >> j) & 1) {
							upd += c[j + l[i] + 1];
						}
						else {
							break;
						}
					}
					// if (last == 8 && wasMask == 255 && wasCnt1 == 1) {
					// 	debug(i << ' ' << now.mask << ' ' << now.cnt1)
					// }
					if (j == LG && now.cnt1 > 0) {
						upd += getSum(j + l[i] + 1, j + l[i] + now.cnt1);
						// debug(j + l[i] + 1 << ' ' << j + l[i] + now.cnt1)
						// debug(prefSum[10])
						now.cnt1 = 0;
						now.mask = 0;
					}
					else {
						now.mask++;
						if (now.mask == (1 << LG)) {
							now.cnt1 = 1;
							now.mask = 0;
						}
					}
					// if (last == 9 && wasMask == 255) 
					// 	debug(i << ' ' << now.mask << ' ' << now.cnt1 << ' ' << upd << ' ' << wasCnt1)
					dp[i][now.mask][now.cnt1] = std::max(dp[i][now.mask][now.cnt1], dp[last][wasMask][wasCnt1] + upd);
				}
			}
		}
	}
	FOR(i, n) {
		FOR(j, (1 << LG)) {
			FOR(q, n) {
				ans = std::max(ans, dp[i][j][q]);
				// if (dp[i][j][q] == 65) {
				// 	debug(i << ' ' << j << ' ' << q)
				// }
			}
		}
	}
	std::cout << ans;
}