#include<iomanip>
#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
using namespace std;
int make(int mask, vector<int> &l, vector<int> &s, vector<int> &c) {
    int ans = 0;
    vector<int> r(c.size(), 0);
    for(int i = 0; i < l.size(); ++i) {
        if(((1 << i)|mask) == mask) {
            ans -= s[i];
            for(int j = l[i];; ++j) {
                ans += c[j];
                if(r[j] == 1) {
                    r[j] = 0;
                }
                else {
                    r[j] = 1;
                    break;
                }
            }
        }
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> l(n);
    for(int
        i = 0; i < n; ++i) {
        cin >> l[i];
        --l[i];
    }
    vector<int> s(n);
    for(int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> c(n + m);
    for(int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }
    if(n <= 15 && m <= 15) {
        int ans = 0;
        for(int i = 0; i < (1 << n); ++i) {
            int pred = 1e9;
            bool is = 1;
            for(int j = 0; j < n; ++j) {
                if(((1 << j)|i) == i) {
                    if(pred < l[j]) {
                        is = 0;
                    }
                    pred = l[j];
                }
            }
            if(is == 0) {
                continue;
            }
            ans = max(ans, make(i, l, s, c));
        }
        cout << ans;
        return 0;
    }
    if(m == 1) {
        int ans = 0;
        vector<int> r(n + m + 1, 0);
        stable_sort(s.begin(), s.end());
        int p = 0;
        for(int i = 0; i < n; ++i) {
            p -= s[i];
            for(int j = 0;; ++j) {
                p += c[j];
                if(r[j] == 1) {
                    r[j] = 0;
                }
                else {
                    r[j] = 1;
                    break;
                }
            }
            ans = max(ans, p);
        }
        cout << ans;
    }
    if(m == 2) {
        long long ans = 0;
        vector<int> t2;
        vector<int> t1;
        for(int i = 0; i < n; ++i) {
            if(l[i] == 1) {
                t2.push_back(i);
            }
            else {
                t1.push_back(i);
            }
        }
        long long dop = 0;
        for(int i = 0; i <= t2.size(); ++i) {
            vector<char> r(n + m + 1, 0);
            dop = 0;
            for(int j = 0; j < i; ++j) {
                for(int k = 0; ;++k) {
                    dop += c[k];
                    if(r[k] == 1) {
                        r[k] = 0;
                    }
                    else {
                        r[k] = 1;
                        break;
                    }
                }
            }
            for(int j = 0; j <= t1.size(); ++j) {
                 for(int k = 1; ;++k) {
                    dop += c[k];
                    if(r[k] == 1) {
                        r[k] = 0;
                    }
                    else {
                        r[k] = 1;
                        break;
                    }
                }
                set<int> sp1;
                set<int> sp2;
                vector<int> dp1(t1.size(), -1e9);
                vector<int> dp2(t2.size(), -1e9);
                int hh = 0;
                for(int ii = 0; ii < t2.size(); ++ii) {
                    hh += s[t2[ii]];
                    sp2.insert(-s[t2[ii]]);
                    if(sp2.size() > i) {
                        hh += *(sp2.begin());
                        sp2.erase(sp2.begin());
                    }
                    if(sp2.size() == i) {
                        dp2[ii] = hh;
                    }
                }
                hh = 0;
                for(int ii = t1.size() - 1; ii >= 0; --ii) {
                    hh += s[t1[ii]];
                    sp1.insert(-s[t1[ii]]);
                    if(sp1.size() > j) {
                        hh += *(sp1.begin());
                        sp1.erase(sp1.begin());
                    }
                    if(sp1.size() == j) {
                        dp1[ii] = hh;
                    }
                }
                int it = 0;
                for(int k = 0; k < t2.size(); ++k) {
                    while(it < t1.size() && t2[k] >= t1[it]) {
                        ++it;
                    }
                    if(it == t1.size() || dp1[it] == -1e9 || dp2[k] == -1e9) {
                        continue;
                    }
                    ans = max(ans, dop - dp1[it] - dp2[k]);
                }
            }
        }
        cout << ans;
    }
    return 0;
}
