#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e20;

long long dp[1<<16][5];

void easy(int n, int m) {
    vector<int> agr(n), cost(n), vals(n + m + 1);
    for (int i = 0; i < n; ++i)
        cin >> agr[i];
    for (int i = 0; i < n; ++i)
        cin >> cost[i];
    for (int i = 0; i < n + m; ++i)
        cin >> vals[i + 1];
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask)  {
        int st = m;
        bool skip = false;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask) {
                if (agr[i] > st)
                    skip = true;
                st = min(st, agr[i]);
            }
        if (skip)
            continue;
        int mins = 0;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask)
                mins += vals[agr[i]] - cost[i];
        set<int> in;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask) {
                int now = agr[i];
                while (true) {
                    if (in.find(now) == in.end()) {
                        in.insert(now);
                        break;
                    } else {
                        in.erase(now);
                        ++now;
                        mins += vals[now];
                    }
                }
            }
            ans = max(ans, mins);
    }
    cout << ans << '\n';
}

long long F(int x, vector<long long>& costs) {
    long long res = 0;
    long long tmp = 0;
    for (int i = 0; i < 16; ++i) {
        tmp += tmp;
        tmp += costs[i];
        if (x & (1 << i))
            res += tmp;
    }
    return res;
}

void solve() {
    for (int i = 0; i < (1 << 16); ++i)
        for (int j = 0; j < 5; ++j)
            dp[i][j] = -INF;
    int n, m;
    cin >> n >> m;
    if (n <= 0) {
        easy(n, m);
        return;
    }
    dp[0][m - 1] = 0;
    vector<long long> l(n), c1(n), c2(n + m);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i)
        cin >> c1[i];
    for (int i = 0; i < n + m; ++i)
        cin >> c2[i];
    for (int i = 0; i < n; ++i) {
        long long k = 1;
        c1[i] = -c1[i];
        --l[i];
        for (int j = l[i] - 1; j >= 0; --j) {
            c1[i] -= (c2[j] << k++);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = (1 << 16) - 1; j >= 0; --j)
            for (int last = 5; last >= l[i]; --last)
                if (dp[j][last] != -INF)
                    dp[j + (1 << l[i])][l[i]] = max(dp[j + (1 << l[i])][l[i]],  dp[j][last] + c1[i]);

    }
    long long ans = 0;
    for (int i = 0; i < (1 << 16); ++i)
        for (int j = 0; j < 5; ++j)
            if (dp[i][j] != -INF) {
                ans = max(ans, F(i, c2) + dp[i][j]);
            }
    cout << ans << '\n';
}

int main() {
    //freopen("test1.cpp", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}
