#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 2005, M = 5055, lg = 11;
const int INF = 2000000000 + 7;

int n, m, a[N], s[N], nxt[N][13], c[M + N], bt[1 << (lg + 2)], pref[M + N], ans = 0, l = 0, t[M];

inline void update(int i, int val) {
    for (; i < M; i |= (i + 1)) {
        t[i] = max(t[i], val);
    }
}
inline int getMax(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
        res = max(res, t[r]);
    return res;
}

struct state {
    int mask, col;
    state(int mask, int col) {
        this->mask = mask;
        this->col = col;
    }
    state() {
        mask = 0;
        col = 0;
    }
    bool operator < (const state &o) const {
        return mp(mask, col) < mp(o.mask, o.col);
    }
};
map<state, int> dp[N];


void init() {
    for (int i = 0; i < (1 << (lg + 2)); i++) {
        bt[i] = __builtin_ctz(i);
    }
    for (int i = 1; i <= n + m; i++)
        pref[i] = pref[i - 1] + c[i];

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 13; j++) {
            nxt[i][j] = INF;
            for (int nx = i + 1; nx < n; nx++) {
                if (a[i] - a[nx] == j) {
                    nxt[i][j] = nx;
                    break;
                }
            }
        }
    }
}

inline void updateState(int i, int mask, int col, int val) {
    if (dp[i].find(state(mask, col)) == dp[i].end())
        dp[i][state(mask, col)] = val;
    else
        dp[i][state(mask, col)] = max(dp[i][state(mask, col)], val);
}

signed main()
{
    fast_io;

//    ifstream cin("input.txt");
//    ofstream cout("output.txt");

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i++) {
        cin >> c[i + 1];
    }
    init();

    for (int i = 0; i < n; i++) {
        dp[i][state()] = getMax(M - a[i]);
        for (auto j = dp[i].begin(); j != dp[i].end(); j++) {
            int mask = j->fs.mask, col = j->fs.col, val = j->sc;
            if (nxt[i][0] != INF)
                updateState(nxt[i][0], mask, col, val);

            int gain = -s[i];
            mask++;
            int bit = bt[mask];
            if (bit == lg) {
                bit += col;
                col = 0;
            }
            gain += pref[a[i] + bit] - pref[a[i] - 1];
            mask &= ((1 << lg) - 1);

            ans = max(ans, val + gain);

            update(M - a[i] + 12, val + gain);

            for (int j = 0; j < 13; j++) {
                if (nxt[i][j] != INF)
                    updateState(nxt[i][j], mask, col, val + gain);

                if ((mask&(1 << (lg - 1))))
                    col++;
                else
                    col = 0;
                mask <<= 1;
                mask &= ((1 << lg) - 1);
            }
        }
    }

//    for (int i = 0; i < n; i++) {
//        for (int mask = 0; mask < (1 << lg); mask++) {
//            for (int col = 0; col < n; col++) {
//
//                if (dp[i][mask][col] == -INF)
//                    continue;
//                ans = max(ans, dp[i][mask][col]);
//
//                for (int k = 0; k < nxt[i].size(); k++) {
//                    int nx = nxt[i][k];
//                    int nmask = mask, ncol = col;
//                    for (int j = 0; j < a[i] - a[nx]; j++) {
//                        if (nmask == 0 && ncol == 0)
//                            break;
//                        if (((nmask&(1 << (lg - 1))) == (1 << (lg - 1))))
//                            ncol++;
//                        else
//                            ncol = 0;
//                        nmask <<= 1;
//                        nmask &= ((1 << lg) - 1);
//                    }
//                    dp[nx][nmask][ncol] = max(dp[nx][nmask][ncol], dp[i][mask][col]);
//                }
//
//                int nmask = mask, ncol = col;
//                int gain = -s[i];
//
//                nmask++;
//                int lst = __builtin_ctz(nmask);
//                if (lst == lg) {
//                    lst += col;
//                    ncol = 0;
//                }
//                gain += pref[a[i] + lst] - pref[a[i] - 1];
//                nmask &= ((1 << lg) - 1);
//
//                ans = max(ans, dp[i][mask][col] + gain);
//
//                for (int k = 0; k < nxt[i].size(); k++) {
//                    int nx = nxt[i][k];
//                    int pmask = nmask, pcol = ncol;
//                    for (int j = 0; j < a[i] - a[nx]; j++) {
//                        if (nmask == 0 && ncol == 0)
//                            break;
//                        if (((nmask&(1 << (lg - 1))) == (1 << (lg - 1))))
//                            ncol++;
//                        else
//                            ncol = 0;
//                        nmask <<= 1;
//                        nmask &= ((1 << lg) - 1);
//                    }
//                    dp[nx][nmask][ncol] = max(dp[nx][nmask][ncol], dp[i][mask][col] + gain);
//                    nmask = pmask, ncol = pcol;
//                }
//            }
//        }
//    }
    cout << ans;

    return 0;
}

/*
8 6
2 6 2 4 5 4 5 5
7 3 1 0 7 0 2 6
5 -2 -2 -4 4 1 5 -6 1 0 0 -6 3 1

5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4

5 5
1 1 1 1 1
0 0 0 0 0
1 1 1 1 1 1 1 1 1 1
*/
