#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(c) sort(all(c))
#define reverse(c) sort(all(c))

ostream& operator <<(ostream& out, vector<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, deque<auto> d) {
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vector<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

istream& operator >>(istream& in, pair<auto, auto>& p) {
	return (cin >> p.fi >> p.se);
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n, 0);
    vector<int> s(n, 0);
    vector<int> b(n + m, 0);
    cin >> a >> s >> b;
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1<<n); ++mask) {
            int last = 1e9;
            bool flag = true;
            vector<int> people;
            int balance = 0;
            for (int i = 0; i < n; ++i) {
                if (((1<<i)|mask) == mask) {
                    if (a[i] > last) {
                        flag = false;
                        break;
                    }
                    else {
                        last = a[i];
                        balance -= s[i];
                        people.pb(a[i]);
                    }
                }
            }
            if (!flag) continue;
            set<int> now;
            for (int i = 0; i < people.size(); ++i) {
                int agr = people[i];
                while (true) {
                    balance += b[agr - 1];
                    auto ind =  now.find(agr);
                    if (ind != now.end()) {
                        now.erase(ind);
                        agr += 1;
                        continue;
                    }
                    break;
                }
                now.insert(agr);
            }
            ans = max(ans, balance);
        }
        cout << ans;
    }
    else {
        sort(s);
        vector<int> pref(n, 0);
        pref[0] = s[0];
        for (int i = 1; i < n; ++i) {
            pref[i] = pref[i - 1] + s[i];
        }
        int ans = 0;
        for (int i = 1; i <= n; ++i) {
            int j = 0;
            int big = 1;
            int balance = 0;
            balance -= pref[i - 1];
            while (i / big) {
                balance += b[j] * (i / big);
                big *= 2;
                j += 1;
            }
            ans = max(ans, balance);
        }
        cout << ans;
    }
}
