#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

#define ll long long
#define pii pair<int, int>

using namespace std;
ll n, m;

ll concat(set<ll> &a, ll l, vector<ll> c) {
    ll ans = 0;
    while (a.find(l) != a.end()) {
        a.erase(l);
        ans += c[l+1];
        l++;
    }
    a.insert(l);
    return ans;
}

ll check(ll mask, vector<ll> l, vector<ll> s, vector<ll> c) {
    set<ll> st;
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (mask & (1ll << i) == 0 || (l[i] > m &&st.size() == 0) || (st.size() > 0 && (*st.begin()) < l[i]))
            continue;
        ans -= s[i];
        if (st.empty() || st.find(l[i]) == st.end())
        {
            st.insert(l[i]);
            ans += c[l[i]];
        } else {
            ans += c[l[i]];
            ans += concat(st, l[i], c);
        }
    }
    return ans;
}

int main()
{
    cin >> n >> m;
    vector<ll> l(n), s(n);
    for (int i = 0; i < n; i++)
    {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
    }

    vector<ll> c(n + m + 1);
    
    for (int i = 1; i <= n + m; i++)
    {
        cin >> c[i];
    }
    ll ans = 0;
    for (int i = 1; i < (1 << n); i++)
    {
        ans = max(ans, check(i, l, s, c));
    }

    cout << ans;
}