#include <iostream>
#include <vector>
#include <map>
#include <set>

int combat(int c, std::vector<int>& num, std::vector<int>& prof){
    if (num[c] == 2){
        num[c] = 0;
        num[c + 1] += 1;
        return prof[c] + combat(c + 1, num, prof);
    }
    return 0;
}

int simul(std::vector<int>& m, int ms, std::vector<int>& prof){
    std::vector<int> num(ms, 0);
    int p = 0;
    for (int i = 0; i < m.size(); i++){
        p += prof[m[i] - 1];
        num[m[i]] += 1;
        p += combat(m[i], num, prof);
    }
    return p;
}

//std::vector<std::set<int>> agg_not_less(std::vector<int>& agg){
//    std::vector<std::set<int>> comp;
//    for (int i = 0; i < n; i++){
//        for (int j = i + 1; j < n; j++){
//            if (agg[j] <= agg[i]){
//                comp[i].insert(j);
//                comp[j].insert(i);
//            }
//        }
//    }
//    return comp;
//}
//
//std::vector<int> select_not_more(int l, int c, std::vector<std::set<int>>& comp, std::vector<std::set<int>>& aggs){
//    if (l == 0){
//        return {};
//    }
//    for (int i = l; i > 0; i-=2){
//
//    }
//}

std::vector<std::vector<int>> get_vars(std::vector<int>& agg, int i = 0, int min_agg = 5000){
    if (i >= agg.size()){
        return {{}};
    }
//    std::cout << i << " " << min_agg << std::endl;
    std::vector<std::vector<int>> ans;
    if (agg[i] <= min_agg){
        ans = get_vars(agg, i + 1, agg[i]);
        for (auto& a: ans){
            a.push_back(i);
        }
    }
    auto ans2 = get_vars(agg, i + 1, min_agg);
    std::copy(ans2.begin(), ans2.end(), std::back_inserter(ans));
    return ans;
}

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<int> agg (n);
    std::vector<int> price (n);
    for (int i = 0; i < n; i++){
        std::cin >> agg[i];
    }
    for (int i = 0; i < n; i++){
        std::cin >> price[i];
    }
    std::vector<int> prof (n + m);
    for (int i = 0; i < n + m; i++){
        std::cin >> prof[i];
    }
    int maxp = 0;
    for (auto & s: get_vars(agg)){
//        std::cout << "--------" << std::endl;
//        for (auto & e : s){
//            std::cout << e << std::endl;
//        }
////        std::cout << "--------" << std::endl;
        int p = 0;
        std::vector<int> sa(s.size());
        for (int i = 0; i < s.size(); i++){
            p -= price[s[i]];
            sa[i] = agg[s[i]];
        }
        p += simul(sa, n + m, prof);
//        std::cout << p << std::endl;
        maxp = std::max(p, maxp);
    }
    std::cout << maxp << std::endl;

    return 0;
}