#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

int n, m;
vector<int> l, s, c;

int solve() {
	int ans = 0;
	for (int ma = 0; ma < (1 << n); ++ma) {
		int mm = 2e9;
		int su = 0;
		map<int, int> map;
		for (int i = 0; i < n; ++i) 
			if ((ma >> i) & 1)
				if (l[i] > mm)
					break;
				else {
					mm = min(mm, l[i]);
					su -= s[i];
					su += c[l[i]];
					map[l[i]]++;
					int k = l[i];
					while (map[k] == 2) {
						map[k] = 0;
						su += c[k + 1];
						++k;
						map[k]++;
					}
				}
		ans = max(ans, su);
	}
	return ans;
}

void solve1() {
	sort(sbe(s));
	int ans = 0;
	int su = 0;
	map<int, int> map;
	for (int i = 0; i < n; ++i) {
		su -= s[i];
		su += c[l[i]];
		map[l[i]]++;
		int k = l[i];
		while (map[k] == 2) {
			map[k] = 0;
			su += c[k + 1];
			++k;
			map[k]++;
		}
		ans = max(ans, su);
	}
	cout << ans;
}

void gen() {
	n = rand() % 10 + 1;
	m = rand() % 10 + 1;
	l.resize(n);
	s.resize(n);
	c.resize(n + m);
	ior(l)
		i = rand() % m;
	ior(s)
		i = rand() % 10 + 1;
	ior(c)
		i = rand() % 20 - 5;
}

int solve2() {
	int cnt = 0;
	int p = -1;
	int i = 0;
	auto it = s.begin();
	for (; i < n; ++it, ++i) {
		if (p != l[i] && cnt != 0) {
			sort(it - cnt - 1, it);
			cnt = 0;
		}
		if (p == l[i])
			++cnt;
		p = l[i];
	}
	sort(it - cnt - 1, it);
	vector<int> d(m + 1, -2e9);
	vector<map<int, int>> d1(m + 1);
	d[m] = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= m; ++j) {
			if (l[i - 1] > j)
				continue;
			int su = d[j];
			map<int, int> map = d1[j];
			su -= s[i - 1];
			su += c[l[i - 1]];
			map[l[i - 1]]++;
			int k = l[i - 1];
			while (map[k] == 2) {
				map[k] = 0;
				su += c[k + 1];
				++k;
				map[k]++;
			}
			if (su > d[l[i - 1]]) {
				d1[l[i - 1]] = map;
				d[l[i - 1]] = su;
			}
		}
	}
	int ans = 0;
		for (int j = 0; j <= m; ++j)
			ans = max(ans, d[j]);
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	if (0) {
		while (1) {
			gen();
			int a = solve();
			int b = solve2();
			if (a != b) {
				cout << n << " " << m << '\n';
				ior(l)
					cout << i + 1 << " ";
				cout << '\n';
				ior(s)
					cout << i << " ";
				cout << '\n';
				ior(c)
					cout << i << " ";
				cout << '\n';
				cout << a << " " << b << '\n';
				fflush(stdout);
				return 0;
			}
		}
	}
	cin >> n >> m;
	l.resize(n);
	s.resize(n);
	c.resize(n + m);
	ior(l) {
		cin >> i;
		--i;
	}
	ior(s)
		cin >> i;
	ior(c)
		cin >> i;
	cout << solve2();
	return 0;
	if (n <= 15)
		solve();
	else
		solve1();
	return 0;
}