#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0
#define int ll

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

int ans = 0;
vector<int> l, s, c;

void rec(int pos, int n, vector<bool> &st) {
    if (pos >= n) {
        int last = INF1;
        for (int i = 0; i < n; ++i) {
            if (st[i]) {
                if (l[i] > last)
                    return;
                last = min(last, l[i]);
            }
        }
        int sum = 0;
        map<int, int> m;
        for (int i = 0; i < n; ++i) {
            if (st[i]) {
                sum += c[l[i]] - s[i];
                ++m[l[i]];
                int k = l[i];
                while (m[k] > 1) {
                    m[k] = 0;
                    ++m[k + 1];
                    sum += c[k + 1];
                    ++k;
                }
            }
        }
        ans = max(ans, sum);
        return;
    }
    rec(pos + 1, n, st);
    st[pos] = true;
    rec(pos + 1, n, st);
    st[pos] = false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    l.resize(n);
    for (int &i : l)
        cin >> i;
    s.resize(n);
    for (int &i : s)
        cin >> i;
    c.resize(n + m + 5);
    for (int i = 1; i <= n + m; ++i)
        cin >> c[i];
    if (m == 1) {
        int ans = 0, sum = 0;
        vector<int> cnt(n + 5);
        for (int i = 0; i < n; ++i) {
            //++cnt[1];
            sum = c[1] - s[i];
            int k = 1;
            while (cnt[k] > 0) {
                assert(k + 1 < cnt.size());
                //++cnt[k + 1];
                //cnt[k] = 0;
                sum += c[k + 1];
                ++k;
            }
            if (sum > 0) {
                ans += sum;
                ++cnt[1];
                int k = 1;
                while (cnt[k] > 1) {
                    assert(k + 1 < cnt.size());
                    ++cnt[k + 1];
                    cnt[k] = 0;
                    ++k;
                }
            }
        }
        ans = max(ans, sum);
        cout << ans << '\n';
    } else {
        vector<bool> st(n);
        rec(0, n, st);
        cout << ans << '\n';
    }
}