#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(c) sort(all(c))
#define reverse(c) sort(all(c))

ostream& operator <<(ostream& out, vector<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, deque<auto> d) {
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vector<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

istream& operator >>(istream& in, pair<auto, auto>& p) {
	return (cin >> p.fi >> p.se);
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n, 0);
    vector<int> s(n, 0);
    vector<int> b(n + m, 0);
    cin >> a >> s >> b;
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1<<n); ++mask) {
            int last = 1e9;
            bool flag = true;
            vector<int> people;
            int balance = 0;
            for (int i = 0; i < n; ++i) {
                if (((1<<i)|mask) == mask) {
                    if (a[i] > last) {
                        flag = false;
                        break;
                    }
                    else {
                        last = a[i];
                        balance -= s[i];
                        people.pb(a[i]);
                    }
                }
            }
            if (!flag) continue;
            set<int> now;
            for (int i = 0; i < people.size(); ++i) {
                int agr = people[i];
                while (true) {
                    balance += b[agr - 1];
                    auto ind =  now.find(agr);
                    if (ind != now.end()) {
                        now.erase(ind);
                        agr += 1;
                        continue;
                    }
                    break;
                }
                now.insert(agr);
            }
            ans = max(ans, balance);
        }
        cout << ans;
    }
    else if (m == 1) {
        sort(s);
        vector<int> pref(n, 0);
        pref[0] = s[0];
        for (int i = 1; i < n; ++i) {
            pref[i] = pref[i - 1] + s[i];
        }
        int ans = 0;
        for (int i = 1; i <= n; ++i) {
            int j = 0;
            int big = 1;
            int balance = 0;
            balance -= pref[i - 1];
            while (i / big) {
                balance += b[j] * (i / big);
                big *= 2;
                j += 1;
            }
            ans = max(ans, balance);
        }
        cout << ans;
    }
    else {
        vector<int> firsts;
        vector<int> seconds;
        for (int i = 0; i < n; ++i) {
            if (a[i] == 1) {
                firsts.pb(s[i]);
            }
            else {
                seconds.ps(s[i]);
            }
        }
        sort(firsts);
        sort(seconds);
        vector<int> pref1(firsts.size(), 0);
        vector<int> pref2(seconds.size(), 0);
        pref1[0] = firsts[0];
        pref2 = seconds[0];
        for (int i = 1; i < firsts.size(); ++i) {
            pref1[i] = pref1[i - 1] + firsts[i];
        }
        for (int i = 1; i < seconds.size(); ++i) {
            pref2[i] = pref2[i - 1] + seconds[i];
        }
        int ans = 0;
        for (int i = 0; i <= firsts.size(); ++i) {
            for (int j = 0; j <= seconds.size(); ++j) {
                int k = 1;
                int all = i / 2 + j;
                int big = 2;
                int balance = 0;
                if (i != 0) {
                    balance -= pref1[i - 1];
                }
                if (j != 0) {
                    balance -= pref2[j - 1];
                }
                balance += i * b[0];
                while (all / big) {
                    balance += b[k] * (all / big);
                    big *= 2;
                    k += 1;
                }
                ans = max(ans, balance);
            }
        }
        cout << ans;
    }
}
