#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;

int ans = 0;
const int N = 1 << 12;

void solve() {
    int n, m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    forn(i, n) l[i]--;
    vvi dp(m, vi(N, -inf));
    forn(i, n) {
        vvi dp1 = dp;
        int add = c[l[i]] - s[i];
        dp1[l[i]][1 << l[i]] = max(dp1[l[i]][1 << l[i]], add);
        if (i == 0) {
            dp = dp1;
            continue;
        }
        for (int j = l[i]; j < m; ++j) {
            forn(mask, N) {
                if (dp[j][mask] == -inf) continue;
                vi X;
                forn(z, 12){
                    if (mask & (1 << z)) X.pb(j + z);
                }
                while (!X.empty() && X.back() > l[i] + 11) X.pop_back();
                int mask1 = 1;
                for (int x : X) mask1 |= (1 << (x - l[i]));
                int add1 = add;
                if (j == l[i]) {
                    int z = l[i];
                    while (mask & (1 << z)) {
                        z++;
                        add1 += c[z];
                    }
                }
                dp1[l[i]][mask1] = max(dp1[l[i]][mask1], dp[j][mask] + add1);
            }
        }
        dp = dp1;
    }
    int ans = 0;
    forn(j, m) ans = max(ans, *max_element(all(dp[j])));
    cout << ans << '\n';
}

bool multitest = false;

signed main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}
