#include <bits/stdc++.h>

using namespace std;
using ll = long long;
// #define int ll
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
int n, m;
const int MAXN = 2005;
const int INF = 1e9;
int l[MAXN];
int s[MAXN];
int c[MAXN];
int dp[2 * MAXN];
int dp1[2][2 * MAXN];
int solve1(){
	for (int i = 0; i <= n; i++)
		dp[i] = INF;
	dp[0] = 0;
	for (int i = 0; i < n; i++)
		for (int j = n; j >= 1; j--)
			dp[j] = min(dp[j], dp[j - 1] + s[i]);
	int best = 0;
	int sum = 0;
	vector<int> have(n + m + 1);
	for (int i = 1; i <= n; i++){
		have[1]++;
		sum += c[1];
		for (int i = 0; i < n + m; i++){
			sum += have[i] / 2 * c[i + 1];
			have[i + 1] += have[i] / 2;
			have[i] %= 2;
		}
		best = max(best, sum - dp[i]);
	}
	cout << best << '\n';
	return 0;
}
int solve2(){
	for (int i = 0; i <= 2 * n; i++)
		dp1[0][i] = dp1[1][i] = INF;
	dp1[0][0] = dp1[1][0] = 0;
	for (int i = 0; i < n; i++)
		for (int j = 2 * n; j >= 1; j--){
			if (l[i] == 1)
				dp1[0][j] = min(dp1[0][j], min(dp1[0][j - 1], dp1[1][j - 1]) + s[i]);
			else if (j >= 2)
				dp1[1][j] = min(dp1[1][j], dp1[1][j - 2] + s[i] + 2 * c[1]);
			// cerr << dp[j] << '\n';
		}
	int best = 0;
	int sum = 0;
	vector<int> have(n + m + 1);
	for (int i = 1; i <= 2 * n; i++){
		have[1]++;
		sum += c[1];
		for (int i = 0; i < n + m; i++){
			sum += have[i] / 2 * c[i + 1];
			have[i + 1] += have[i] / 2;
			have[i] %= 2;
		}
		// cerr << i << ' ' << min(dp1[0][i], dp1[1][i]) << ' ' << sum << '\n';
		best = max(best, sum - min(dp1[0][i], dp1[1][i]));
	}
	cout << best << '\n';
	return 0;
}
int solve(){
	if (!(cin >> n >> m))
		return 1;
	for (int i = 0; i < n; i++)
		cin >> l[i];
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 1; i <= n + m; i++)
		cin >> c[i];
	if (m == 1){
		return solve1();
	}
	if (m == 2){
		return solve2();
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); mask++){
	// for (int mask = 23; mask < 24; mask++){
		vector<int> have(n + m + 1);
		int mx = m;
		int sum = 0;
		for (int i = 0; i < n; i++){
			// cerr << "\t" << i << ' ' << (mask & (1 << i)) << '\n';
			if (!(mask & (1 << i)))
				continue;
			if (l[i] > mx){
				break;
			}
			sum -= s[i];
			sum += c[l[i]];
			have[l[i]]++;
			// cerr << l[i] << ' ' << i << '\n';
			mx = min(l[i], mx);
		}
		// cerr << '\n';
		for (int i = 0; i < n + m; i++){
			// cerr << have[i] << ' ';
			sum += have[i] / 2 * c[i + 1];
			have[i + 1] += have[i] / 2;
			have[i] %= 2;
			// cerr << have[i] << ' ' << have[i + 1] << '\n';
		}
		// cerr << mask << ' ' << sum << '\n';
		ans = max(ans, sum);
	}
	cout << ans << '\n';
	return 0;
}
int main(){
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int tests = 1e9;
	for (int i = 1; i <= tests; i++){
		#ifdef LOCAL
		clock_t start = clock();
		#endif
		if (solve())
			break;
		#ifdef LOCAL
		cerr << "elapsed " << fixed << setprecision(5) << (clock() - start) * 1. / CLOCKS_PER_SEC << '\n';
		cerr << "-------------------------------------------\n";
		#endif
	}

}