
#include <iostream>
#include <algorithm>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>
#include <random>
#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<vector<int>> ch;
vector<int> cur;

void gen(int m, int cn) {
    if (m <= 0 || cn == 0) {
        ch.push_back(cur);
        if (!ch.back().empty() && ch.back().back() == 0) ch.back().pop_back();
        return;
    }
    for (int i = m; i >= 0; i--) {
        cur.push_back(i);
        gen(i, cn - 1);
        cur.pop_back();
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m + 1);
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 1; i <= n + m; i++) cin >> c[i];
    gen(m, n);
    int ans = 0;
    for (auto ve : ch) {
        vector<vector<int>> d(n + 1, vector<int>(ve.size() + 1, 1e9));
        d[0][0] = 0;
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= ve.size(); j++) {
                if (l[i - 1] == ve[j - 1]) {
                    d[i][j] = min(d[i - 1][j - 1] + s[i - 1], d[i][j]);
                }
                d[i][j] = min(d[i][j], d[i - 1][j]);
            }
        }
        int rs = 0;
        vector<int> to(n + m + 1);
        for (int i = 0; i < ve.size(); i++) {
            rs += c[ve[i]];
            to[ve[i]]++;
            for (int j = ve[i]; j <= n + m; j++) {
                if (to[j] >= 2) {
                    to[j] -= 2;
                    to[j + 1]++;
                    rs += c[j + 1];
                }
            }
        }
        //cout << rs << '\n';
        ans = max(rs - d[n][ve.size()], ans);
    }
    cout << ans;
    return 0;
}