#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18, P = 1e9 + 7, X = 2007, N = 2001, MASK = (1 << 13);
const ld EPS = 1e-9;
//int dp[N][MASK][6];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m + 1);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; i++) {
        cin >> c[i];
    }
    if (m == 1) {
        sort(all(s));
        int ans = 0;
        vector<int> used(n + m + 1);
        int cur = 0;
        for (int i = 0; i < n; i++) {
            cur -= s[i];
            for (int j = 1; j <= n + m; j++) {
                cur += c[j];
                if (used[j] == 1) {
                    used[j] = 0;
                } else {
                    used[j] = 1;
                    break;
                }
            }
            ans = max(ans, cur);
        }
        cout << ans;
        return 0;
    }
    if ((n <= 15 && m <= 15)) {
        int M = (1 << n), ans = 0;
        for (int mask = 0; mask < M; mask++) {
            int prev = INF, fl = 0, cur = 0;
            for (int i = 0; i < n; i++) {
                if ((1 << i) & mask) {
                    if (prev < l[i]) {
                        fl = 1;
                        break;
                    }
                    prev = l[i];
                    cur -= s[i];
                }
            }
            if (fl) {
                continue;
            }
            vector<int> used(n + m + 1);
            for (int i = 0; i < n; i++) {
                if (!((1 << i) & mask)) {
                    continue;
                }
                cur += c[l[i]];
                int t = l[i];
                while (used[t]) {
                    used[t] = 0;
                    t++;
                    cur += c[t];
                }
                used[t] = 1;
            }
            ans = max(ans, cur);
        }
        cout << ans;
        return 0;
    }
    if (m <= 5) {
        int M = (1 << 15);
        //cout << M <<
        vector<vector<vector<int> > > dp(n, vector<vector<int> > (M, vector<int> (m + 1)));
        for (int i = 0; i < n; i++ ) {
            for (int mask = 0; mask < M; mask++){
                for (int j = 0; j <= m; j++) {
                    dp[i][mask][j] = -INF;
                }
            }
        }
        dp[0][0][m] = 0;
        dp[0][(1 << l[0])][l[0]] = c[l[0]] - s[0];
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int mask = 0; mask < M; mask++) {
                for (int j = 0; j <= m; j++) {
                    //cout << dp[i][mask][j] << ' ';
                    if (dp[i][mask][j] == -INF) {
                        continue;
                    }
                    ans = max(ans, dp[i][mask][j]);
                    if (i != n - 1) {
                        if (dp[i + 1][mask][j] < dp[i][mask][j]) {
                            dp[i + 1][mask][j] = dp[i][mask][j];
                        }
                        if (l[i + 1] <= j) {
                            int new_mask = mask, add = -s[i + 1];
                            for (int k = l[i + 1]; k <= n + m; k++) {
                                if (k >= m + 12)  {
                                    cout << 1 / 0;
                                    return 0;
                                }
                                add += c[k];
                                if (mask & (1 << k)) {
                                    new_mask ^= (1 << k);
                                } else {
                                    new_mask ^= (1 << k);
                                    break;
                                }
                            }
                            if (dp[i + 1][new_mask][l[i + 1]] < dp[i][mask][j] + add) {
                                dp[i + 1][new_mask][l[i + 1]] = dp[i][mask][j] + add;
                            }
                        }
                    }
                }
               // cout << "\n";
            }
            //cout << "=====\n";
        }
        cout << ans;
        return 0;
    }
    return 0;
}
