#include <iostream>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdlib>
#include <cstdio>
#include <random>
#include <functional>
#include <numeric>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;
#define x first
#define y second
#define int long long
#define pb push_back
const int MAXN = 500, NONE = -1e18;
int dp[MAXN][MAXN];
int l[MAXN], s[MAXN], c[MAXN * 2];
int f(int i, int j) {
	int ans = 0;
	while (j) {
		ans += c[i] * j;
		j /= 2;
		++i;
	}
	return ans;
}
int mx(int i, int j) {
	while (j > 1)
		++i, j /= 2;
	return i;
}
void chmax(int &a, int b) {
	a = max(a, b);
}
int solve(int n, int m) {
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j < MAXN; ++j)
			dp[i][j] = NONE;
	for (int i = 0; i < MAXN; ++i)
		for (int j = 0; j <= n; ++j)
			if (mx(i, j) <= n + m)
				dp[i][j] = f(i, j);
	int *gc = c;
	for (int it = 1; it <= n; ++it) {
		int w = l[it];
		int cost = s[it];
		for (int i = n + m; i >= 1; --i)
			for (int c = 0; 2 * c <= n; ++c)
				if (dp[i][c] != NONE)
					chmax(dp[i - 1][2 * c], dp[i][c] + 2 * c * gc[i - 1]);
		for (int c = 0; c <= n; ++c)
			for (int pw = w + 1; pw <= n + m; ++pw)
				if (dp[pw][0] != NONE && mx(w, c) < pw)
					chmax(dp[w][c], dp[pw][0] + f(w, c));
		for (int c = 0; c <= n; ++c)
			if (dp[w][c + 1] != NONE)
				chmax(dp[w][c], dp[w][c + 1] - cost);
	}
	int ans = 0;
	for (int i = 0; i <= n + m; ++i)
		if (dp[i][0] != NONE)
			chmax(ans, dp[i][0]);
	return ans;
}
/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

*/
signed main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> l[i];
	for (int i = 1; i <= n; ++i)
		cin >> s[i];
	for (int i = 1; i <= n + m; ++i)
		cin >> c[i];
	cout << solve(n, m);
	return 0;
}