#include <iostream>
#define endl '\n'

using namespace std;

const int MAXN = 2000;
const int MAXM = 2000;

int n, m;
int l[MAXN+10], s[MAXN+10];
int c[MAXN+MAXM+10];
long long dp[MAXN+10];
long long ans = 0;

void input()
{
    cin>>n>>m;
    for (int i=0; i<n; i++)
    {
        cin>>l[i];
    }
    for (int i=0; i<n; i++)
    {
        cin>>s[i];
    }
    for (int i=0; i<n+m; i++)
    {
        cin>>c[i];
    }
}

void output()
{
    cout<<ans<<endl;
}

void solve()
{
    for (int i=n-1; i>=0; i--)
    {
        int currVal = c[l[i]-1] - s[i];

        for (int j=l[i]-1; j>1; j--)
        {
            if (dp[l[i]] < dp[j] + currVal)
            {
                dp[l[i]] = dp[j] + currVal;
                ans = max(ans, dp[l[i]]);
            }
        }
        if (dp[l[i]])
        {
            currVal += c[l[i]];
            if (dp[l[i]+1] < dp[l[i]] + currVal)
                dp[l[i]+1] = dp[l[i]] + currVal;
            ans = max(ans, dp[l[i]]);
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9
*/


