#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

void solve() {
    int n, m;
    cin >> n >> m;
    int c[n];
    int st[n];
    st[0] = 1;
    for (int i = 1; i < n; ++i) st[i] = (st[i - 1] * 2) % mod;
    for (int i = 0; i < n; ++i) cin >> c[i];
    vector <int> g[n];
    int cnt[n];
    for (int i = 0; i < n; ++i) cnt[i] = 0;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].push_back(u);
        cnt[u] = (cnt[u] + st[v]) % mod;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int sum = 0;
        for (int j = 0; j < g[i].size(); ++j) sum += c[g[i][j]];
        ans = __gcd(ans, sum);
    }
    vector <pair <int, int> > kek(n);
    for (int i = 0; i < n; ++i) kek[i] = {cnt[i], i};
    sort(kek.begin(), kek.end());
    for (int i = 0; i < n; ++i) {
        int j = i;
        int sum = 0;
        while (j < n && kek[j].first == kek[i].first) {
            sum += c[kek[j].second];
            ++j;
        }
        i = j - 1;
        ans = __gcd(ans, sum);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t) {
        --t;
        solve();
    }
    return 0;
}
