#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        run();
    }
}

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n + 1);
    auto c = arr<long long>(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
    }
    auto d = arr<long long>(1 << n, 0);
    auto take = arr<int>(n + 1, -1);
    for (int m = 1; m < (1 << n); m++) {
        for (int v = 1; v <= n; v++) {
            if (!(m & (1 << (v - 1))))
                continue;
            for (int u: gr[v]) {
                take[u] = m;
            }
        }
        long long sum = 0;
        for (int v = 1; v <= n; v++) {
            if (take[v] == m)
                sum += c[v];
        }
        d[m] = sum;
    }
    auto ans = d[1];
    for (int i = 2; i < (1 << n); i++) {
        ans = __gcd(ans, d[i]);
    }
    cout << ans << endl;
}
