#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<ll> v(n);
        for (ll &i : v) {
            cin >> i;
        }
        vector<vector<int>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            g[a - 1].push_back(b - 1);
        }
        ll ans = -1;
        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<bool> used(n);
            ll sum = 0;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    for (int j : g[i]) {
                        if (!used[j]) {
                            sum += v[j];
                            used[j] = true;
                        }
                    }
                }
            }
            if (ans == -1) {
                ans = sum;
            } else {
                ans = gcd(ans, sum);
            }
        }
        cout << ans << endl;
    }
}