#pragma GCC optimize("O3", "unroll-loops")
#include <bits/stdc++.h>
using namespace std;
typedef int ll;
typedef pair <ll, ll> pll;

ll solve() {
    ll n, m;
    cin >> n >> m;
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <ll> g(n, 0);
    for (ll i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v, --u;
        g[v] += a[u];
    }
    ll ans = 0;
    for (ll i = 0; i < n - 1; ++i) {
        ans = __gcd(g[i], g[i + 1]);
    }
    return ans;
}

ll solve1() {
    ll n, m;
    cin >> n >> m;
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <vector <ll>> g(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
    }
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        set <ll> t;
        for (ll k : g[i]) {
            t.insert(k);
        }
        ll sum = 0;
        for (ll k : t) {
            sum += a[k];
        }
        ans = __gcd(ans, sum);
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            set <ll> t;
            for (ll k : g[i]) {
                t.insert(k);
            }
            for (ll k : g[j]) {
                t.insert(k);
            }/*
            cout << "i, j: " << i << ' ' << j << "  ";
            for (ll k : t) {
                cout << a[k] << ' ';
            }
            cout << endl;*/
            ll sum = 0;
            for (ll k : t) {
                sum += a[k];
            }
            ans = __gcd(ans, sum);
        }
    }
    return ans;
}

inline ll solve2() {
    ll n, m;
    cin >> n >> m;
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <vector <ll>> g(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v, --u;
        g[v].push_back(u);
    }
    ll ans = 0;
    for (ll i = 1; i < (1LL << n); ++i) {
        unordered_set <ll> t;
        for (ll j = 0; j < n; ++j) {
            if (i & (1LL << j)) {
                for (ll k : g[j]) {
                    t.insert(k);
                }
            }
        }
        ll sum = 0;
        for (ll k : t) {
            sum += a[k];
        }
        if (sum) {
            ans = __gcd(ans, sum);
        }
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        cout << solve2() << '\n';
    }
    return 0;
}

/**
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

**/
