#include <algorithm>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>

#define int long long

using namespace std;
using ll = long long;
using ld = long double;

const int p = 26537;
const int mod = (int)1e9 + 7;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	cin >> t;

	while (t--)
	{
		int n = 0, m = 0;
		cin >> n >> m;

		vector<int> c(n);
		vector<set<int>> g(n);

		for (int i = 0; i < n; ++i)
			cin >> c[i];

		int u = 0, v = 0;
		for (int i = 0; i < m; ++i)
		{
			cin >> u >> v;
			g[v - 1].insert(u - 1);
		}

		map<int, int> mp;
		for (int i = 0; i < n; ++i)
		{
			int h = 0;
			for (auto x : g[i])
				h = (h * p + x) % mod;
			mp[h] += c[i];
		}

		int ans = 0;
		for (auto [h, x] : mp)
			ans = gcd(ans, x);

		cout << ans << "\n";
	}


	return 0;
}