#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll

int gcd(int a, int b) {
  while (b) {
     a %= b;
     swap(a, b);
  }
  return a;
}

const int N = 5e5 + 10;
vector<int> g[N];
int c[N], used[N], timer;

mt19937 rnd(239); 

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int T;
  cin >> T;
  while (T--) {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
      cin >> c[i];
      g[i] = {};
    }
    timer++;
    for (int i = 1; i <= m; i++) {
      int u, v;
      cin >> u >> v;
      used[v] = timer;
      g[u].pb(v);
    }
    int cur_gcd = 0;
    for (int i = 1; i <= n; i++) {
      int sum = 0;
      for (auto it : g[i]) {
        sum += c[it];
      }
      cur_gcd = gcd(cur_gcd, sum);
    }
    int cs = 0;
    for (int i = 1; i <= n; i++) {
      if (used[i] == timer) {
        cs += c[i];
      }
    }
    cur_gcd = gcd(cur_gcd, cs);
    int lim = min(n, 7ll);
    vector<int> order;
    for (int i = 1; i <= n; i++) {
      order.pb(i);
    }
    for (int iter = 0; iter < 100; iter++) {
      int subset_size = rnd() % lim + 1;
      shuffle(all(order), rnd);
      timer++;
      int sum = 0;
      for (int i = 0; i < subset_size; i++) {
        for (auto it : g[order[i]]) {
          if (used[it] < timer) {
            used[it] = timer;
            sum += c[it];
          }
        }
      }
      cur_gcd = gcd(cur_gcd, sum);
    }
    cout << cur_gcd << '\n';
  }
}