#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
uniform_real_distribution<> re(0, 1);
template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 22;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

int val[N];
vector <int> gr[N];
bitset<N> was;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        For (i, n) cin >> val[i];
        For (i, n) gr[i].clear();
        For (i, m) {
            int a, b; cin >> a >> b; a--; b--;
            gr[a].push_back(b);
        }
        int ans = 0;
        For (msk, 1<<n) {
            was = 0;
            int cur = 0;
            For (i, n)
                if((msk >> i) & 1)
                    for (int j : gr[i])
                        if (!was[j]) {
                            was[j] = 1;
                            cur += val[j];
                        }
            ans = __gcd(ans, cur);
        }
        cout << ans << '\n';
    }

}
