#include <bits/stdc++.h>

using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<int>> graph(n);
  vector<int> w(n, 0);
  for (int i = 0; i < n; i++)
    cin >> w[i];
  for (int i = 0; i < m; i++) {
    int v, u;
    cin >> v >> u;
    v--;
    u--;
    graph[v].push_back(u);
  }
  long long ans = 0;
  vector<int> used(n, -1);
  for (int mask = 0; mask < (1 << n); mask++) {
    long long sum = 0;
    for (int i = 0; i < n; i++) {
      if ((mask >> i) & 1) {
        for (auto u : graph[i]) {
          if (used[u] != mask) {
            sum += w[u];
            used[u] = mask;
          }
        }
      }
    }
    ans = gcd(ans, sum);
  }
  cout << ans << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--)
    solve();
  return 0;
}