#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

int gcd(int a, int b)
{
    while (a != 0 && b != 0)
    {
        a %= b;
        swap(a, b);
    }
    return a ^ b;
}

void solve()
{
    int n, m;
    cin >> m >> n;
    vector<pair<vector<int>, int>> t(m, make_pair(vector<int>(0), 0));
    for (int i = 0; i < m; i++) cin >> t[i].y;
    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        t[y].x.push_back(x);
    }
    for (int i = 0; i < m; i++)
    {
        sort(all(t[i].x));
    }
    vector<bool> used(m, false);
    int ans = 0;
    for (int i = 0; i < m; i++)
    {
        if (used[i]) continue;
        if (t[i].x.empty()) continue;
        int summ = 0;
        for (int j = i; j < m; j++)
        {
            if (t[j].x == t[i].x)
            {
                used[j] = true;
                summ += t[j].y;
            }
        }
        ans = gcd(ans, summ);
    }
    cout << ans << '\n';
    /*sort(all(t));
    int summ = 0;
    vector<int> last;
    last = t[0].x;
    int ans = -1;
    for (int i = 0; i < m; i++)
    {
        if (last == t[i].x)
        {
            summ += t[i].y;
            last = t[i].x;
            continue;
        }
        last = t[i].x;
        if (ans == -1)
        {
            ans = summ;
            summ = t[i].y;
            continue;
        }
        ans = gcd(ans, summ);
        summ = t[i].y;
    }
    if (ans == -1) ans = summ;
    if (summ != 0) ans = gcd(ans, summ);
    cout << ans << '\n';*/
}

int32_t main() 
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
    return 0;
}
