#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<ll> v(n);
        for (ll &i : v) {
            cin >> i;
        }
        vector<bitset<20>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            g[a - 1][b - 1] = true;
        }
        ll ans = -1;
        for (int mask = 0; mask < (1 << n); ++mask) {
            ll sum = 0;
            bitset<20> r;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    r |= g[i];
                }
            }
            for (int i = 0; i < n; ++i) {
                if (r[i]) {
                    sum += v[i];
                }
            }
            if (ans == -1) {
                ans = sum;
            } else {
                ans = gcd(ans, sum);
            }
        }
        cout << ans << endl;
    }
}