#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")
#endif
using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9, p = 37;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        vector<ll> c(n), st(n);
        forn(i, n) cin >> c[i];
        vector<pair<int, int>> r(m);
        vector<ll> hash(n), stp(n, 1ll);
        firn(i, n) {
            stp[i] = stp[i - 1] * 1ll * p % mod;
        }
        forn(i, m) {
            cin >> r[i].x >> r[i].y;
            r[i].x--; r[i].y--;
            st[r[i].y]++;
            hash[r[i].y] = (hash[r[i].y] + stp[r[i].x]) % mod;
        }
        vector<pair<pair<int, int>, ll>> q;
        forn(i, n) {
            if (!st[i]) continue;
            hash[i] = (hash[i] % mod + mod) % mod;
            q.emplace_back(pair<int, int>{st[i], hash[i]}, c[i]);
        }
        sort(all(q));
        ll ans = 0, tmp = 0;
        forn(i, q.size()) {
            if (i > 0 && q[i].x != q[i - 1].x) {
                ans = __gcd(ans, tmp);
                tmp = 0;
            }
            tmp += q[i].y;
        }
        ans = __gcd(ans, tmp);
        cout << ans << el;
    }
    return 0;
}