//#define _GLIBcxx_DEBUG

#pragma GCC optimaze("unroll-loops")
//#pragma GCC optimaze("fast-math")
//#pragma GCC optimaze("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
#define vin(v, n) for(int i = 0; i < (n); ++i) {cin >> v[i];}
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;

#define int long long

ll usgcd(ll a, ll b) {
	for (; b != 0; a %= b, swap(a, b)) {}
	return a;
}

inline void solve() {
	int n, m; cin >> n >> m;
	vector<ll> c(n); vin(c, n);
	vector<int> g(n, 0);
	for (int i = 0; i < m; ++i) {
		int u, v; cin >> u >> v;
		--u; --v;
		g[v] += (1 << u);
	}
	int ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		ll f = 0;
		for (int i = 0; i < n; ++i) {
			if (mask & g[i]) {
				f += c[i];
			}
		}
		ans = usgcd(f, ans);
	}
	cout << ans << endl;
}

signed main() {
	fastio();
	int t; cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
}