#include <iostream>
#include <cstdint>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstring>

int64_t gcd(int64_t a, int64_t b) {
    if(b == 0)
        return a;
    return  gcd(b, a % b);
}

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
        int32_t n, m;
        std::cin >> n >> m;

        int64_t* numbers = new int64_t[n];
        for(int32_t i = 0 ; i < n; i++)
            std::cin >> numbers[i];

        std::vector<int32_t>* graph = new std::vector<int32_t>[n * 2];
        for(int32_t i = 0 ; i < m; i++) {
            int32_t src, dst;
            std::cin >> src >> dst;
            src--;
            dst--;
            dst += n;
            graph[src].push_back(dst);
            graph[dst].push_back(src);
        }

        int64_t answer = 0;

        bool* incident = new bool[2 * n];
        for(int32_t i = 1; i < (1 << n); i++) {
            for(int32_t j = 0 ; j < 2 * n; j++)
                incident[j] = false;
            for(int32_t j = 0; j < n; j++) {
                if(i & (1 << j)) {
                    //selected vertex j
                    for(int32_t k = 0 ; k < graph[j].size(); k++)
                        incident[graph[j][k] - n] = true;
                }
            }
            int64_t sum = 0;
            for(int32_t j = 0 ; j < n; j++)
                if(incident[j])
                    sum += numbers[j];
            answer = gcd(answer, sum);
        }
        std::cout << answer << "\n";
    }
    return 0;
}