#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;
vector <ll> values;
vector <ll> flex;

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector <vector <ll>> g;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		cin >> n >> m;
		values.resize(n);
		for (auto& x : values) {
			cin >> x;
		}
		flex.resize(n);
		g.resize(n);
		g.assign(n, vector <ll>());
		for (int i = 0; i < m; ++i) {
			ll v, u;
			cin >> v >> u;
			--v; --u;
			g[v].push_back(u);
		}
		ll ans = 0;
		for (ll mask = 1; mask < (1 << n); ++mask) {
			ll cur = 0;
			vector <bool> used(n, false);
			for (int j = 0; j < n; ++j) {
				if (mask & (1 << j)) {
					for (auto& u : g[j]) {
						if (!used[u]) {
							cur += values[u];
							used[u] = true;
						}
					}
				}
			}
			ans = gcd(cur, ans);
		}
		cout << ans << '\n';
	}
	return 0;
}
