#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <int>> w(n);
	vector <int> c(n), f(n);
	for (int& i : c) cin >> i;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		w[u].push_back(v);
	}
	for (int u = 0; u < n; ++u) {
		for (int v : w[u]) {
			f[u] += c[v];
		}
	}
	int ans = f[0];
	for (int mask = 0; mask < (1ll << n); ++mask) {
		vector <int> u;
		int pmask = mask;
		for (int i = 0; i < n; ++i) {
			if (mask % 2 == 0) u.push_back(i);
			mask /= 2;
		}
		mask = pmask;
		set <int> v;
		for (auto& i : u) {
			for (auto& j : w[i]) {
				v.insert(j);
			}
		}
		int sum = 0;
		for (auto& i : v) sum += c[i];
		ans = gcd(ans, sum);
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}