#include <iostream>
#include <vector>
#include <algorithm>

#define gcd __gcd
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> price(n);
    for (int& i : price)
        cin >> i;

    int ans = 0;
    vector <vector <int>> common(n, vector <int> (n));
    vector <int> sm(n);

    vector <vector <int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[b].push_back(a);
        sm[a] += price[b];
    }

    for (int i = 0; i < n; i++) {
        for (int k = 0; k < (int) g[i].size(); k++) {
            for (int l = 0; l < k; l++) {
                common[l][k] += price[i];
            }
        }
    }

    for (int i : sm)
        ans = gcd(ans, i);

    for (int i = 0; i < n; i++)
        for (int j = 0; j < i; j++) {
            ans = gcd(ans, sm[j] + sm[i] - common[j][i]);
        }
    cout << ans << endl;
}

int main() {
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
