#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define vec vector
#define fi first
#define se second
#define pb push_back
#define pob pop_back
#define pf push_front
#define pof pop_front
#define all(c) c.begin(), c.end()
#define sort(c) sort(all(c))
#define reverse(c) sort(all(c))

ostream& operator <<(ostream& out, vec<auto> v) {
    for (int i = 0; i < v.size(); ++i) {
        cout << v[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, deque<auto> d) {
    for (int i = 0; i < d.size(); ++i) {
        cout << d[i] << ' ';
    }
    return (cout << '\n');
}

ostream& operator <<(ostream& out, pair<auto, auto> p) {
    return (cout << p.fi << ' ' << p.se << '\n');
}

istream& operator >>(istream& in, vec<auto>& v) {
    for (int i = 0; i < v.size(); ++i) {
        cin >> v[i];
    }
    return (cin);
}

istream& operator >>(istream& in, pair<auto, auto>& p) {
	return (cin >> p.fi >> p.se);
}

ll base = 999983;
ll mod = 1e9 + 33;
int maxn = 500001;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main() {
    int t;
    cin >> t;
    vector<ll> power(maxn, 0);
    power[0] = 1;
    for (int i = 0; i < maxn; ++i) {
        power[i] = (power[i - 1] * base) % mod;
    }
    for (int task = 0; task < t; ++task) {
        int n, m;
        cin >> n >> m;
        vector<ll> v(n, 0);
        cin >> v;
        vector<int> sizes(n, 0);
        vector<ll> hashh(n, 0);
        vector<ll> new_vertex_left(n, 0);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            ++sizes[b];
            new_vertex_left[a] += v[b];
            ll new_hash = ((a + 1) * power[sizes[b]]) % mod;
            hashh[b] = new_hash;
        }
        map<ll, ll> new_vertex;
        for (int i = 0; i < n; ++i) {
            new_vertex[hashh[i]] += v[i];
        }
        ll ans1 = 0;
        for (int i = 0; i < n; ++i) {
            ans1 = gcd(new_vertex[hashh[i]], ans1);
        }
        ll ans2 = 0;
        for (int i = 0; i < n; ++i) {
            ans2 = gcd(new_vertex_left[i], ans2);
        }
        cout << gcd(ans1, ans2) << '\n';

    }
}
