#include <bits/stdc++.h>

#define llong long long

using namespace std;

const llong HASH = 1e6 + 3;
const llong MOD = 1e9 + 7;

llong f(llong a, llong b)
{
    if (a < b)
    {
        swap(a, b);
    }
    if (b == 0)
    {
        return a;
    }
    return f(b, a % b);
}

llong h(vector<llong> &a)
{
    llong b = 0;
    for (llong i = 0; i < a.size(); i++)
    {
        b *= HASH;
        b %= MOD;
        b += a[i] + 1;
        b %= MOD;
    }
    return b;
}

void solve()
{
    llong n = 0, m = 0, x = 0, y = 0, ans = 0;
    cin >> n >> m;
    vector<llong> a(n, 0);
    vector<vector<llong> > c(n);
    vector<llong> d(n, 0);
    map<llong, llong> e;
    for (llong i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for (llong i = 0; i < m; i++)
    {
        cin >> x >> y;
        x--;
        y--;
        c[y].push_back(x);
    }
    for (llong i = 0; i < n; i++)
    {
        if (c.size() > 0)
        {
            sort(c[i].begin(), c[i].end());
            d[i] = h(c[i]);
            if (e.count(d[i]) == 0)
            {
                e[d[i]] = 0;
            }
            e[d[i]] += a[i];
        }
    }
    for (auto it : e)
    {
        if (ans == 0)
        {
            ans = it.second;
            continue;
        }
        ans = f(ans, it.second);
    }
    cout << ans << '\n';
}

int main(void)
{
    llong t = 0;
    cin >> t;
    for (llong i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
