#include<iostream>
#include<vector>
#include<algorithm>
#include<time.h>
#include<random>
#include<string>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 5e5;
const ll MOD = 1e9 + 7;
const ll base = 239;

ll gcd(ll a, ll b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);
}

vector<ll> degs(MAXN + 1);

int main() {
    degs[0] = 1;
    for (int i = 1; i < sz(degs); ++i) {
        degs[i] = (degs[i - 1] * base) % MOD;
    }
    int q; cin >> q;
    
    for (int t = 0; t < q; ++t) {
        int n, m; cin >> n >> m;
        vector<ll> val(n);
        for (int i = 0; i < n; ++i) {
            cin >> val[i];
        }
        vector<ll> hsh(n, -1);
        for (int i = 0; i < m; ++i) {
            int x, y; cin >> x >> y; x--; y--;
            hsh[y] += degs[x];
            hsh[y] %= MOD;
        }
        map<ll, ll> mp;
        for (int i = 0; i < n; ++i) {
            mp[hsh[i]] += val[i];
        }
        ll ans = 0;
        for (auto el : mp) {
            ll w = el.second;
            if (el.first != -1) {
                ans = gcd(ans, w);
            }
        }
        cout << ans << endl;
    }
    //system("pause");
    return 0;
}

