#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> pll;
typedef pair<vector<ull>, vector<ull> > pvv;
ull q = 157;
ull mod = 1e9 + 7;

void print(vector<int> &a)
{
    for (int x : a)cout << x << " ";
}
ll gcd(ll a, ll b)
{
    if (b == 0)return a;
    return gcd(b, a % b);
}
void dfs(int v, vector<vector<int> > &g, vector<int> &used, vector<ll> &c, ll &sum)
{
    if (v < c.size())sum += c[v];
    used[v] = 1;
    for (int to : g[v])
    {
        if (used[to])continue;
        dfs(to, g, used, c, sum);
    }
}
int main()
{
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector<ll>c(n + 1, 0);
        for (int i = 1; i <= n; ++i)cin >> c[i];
        vector<vector<int> >g(n + n + 5, vector<int>());
        for (int i = 0; i < m; ++i)
        {
            int a, b; cin >> b >> a;
            g[a].push_back(b + n);
            g[b + n].push_back(a);
        }
        ll ans = 0;
        for (int i = n + 1; i < g.size(); ++i)
        {
            ll sum = 0;
            for (int to : g[i])
            {
                sum += c[to];
            }
            ans = gcd(ans, sum);
        }
        vector<int>used(g.size(), 0);
        for (int i = n + 1; i < g.size(); ++i)
        {
            ll sum = 0;
            if (used[i])continue;
            dfs(i, g, used, c, sum);
            ans = gcd(ans, sum);
        }
        cerr << "!";
        cout << ans << "\n";
    }
    return 0;
}
/*
3
2 4
1 1
1 1
1 2
2 1
2 2


*/