#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <unordered_set>

#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;
const int N = 5001;
ll a[N];
ll gcd(ll a, ll b) {
	if (a == 0 && b == 0) return 0;
	while (b) {
		a = a % b;
		swap(a, b);
	}
	return a;
}
ll sm[N];
ll sh[N][N];
vi g[N];
void solve() {
	int n, m; cin >> n >> m;
	fr(i, n) cin >> a[i];
	fill(sm, sm + n, 0);
	fill(g, g + n, vi());
	fr(i, n) fill(sh[i], sh[i] + n, 0);
	ll t = 0;
	fr(i, m) {
		int u, v; cin >> u >> v;
		--u, --v;
		sm[u] += a[v];
		g[v].push_back(u);
	}
	fr(i, n) {
		for (int j = 0, sz(g[i].size()); j < sz; ++j) {
			for (int k = 0; k < j; ++k) {
				sh[g[i][j]][g[i][k]] += a[i];
			}
		}
	}
	fr(i, n) fr(j, n) {
		t = gcd(t, sm[i] + sm[j] - sh[i][j] - sh[j][i]);
		t = gcd(t, sm[i]);
		t = gcd(t, sm[j]);
	}

	cout << t << "\n";
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int tst; cin >> tst;
	while(tst--) solve();
}