#include <bits/stdc++.h>
#define int long long
#define double long double
#define l first
#define r second
#define pb push_back
#define pi pair<int, int>
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 5e5 + 1;

int c[maxn], cx[maxn];
vector<int> g[maxn], f[maxn];
int cpr[maxn], nm[maxn];

inline int gcd(int a, int b) {
    while (b != 0) {
        swap(a, b);
        b %= a;
    }
    return a;
}

int is_submask(int a, int b) {
    set<int> st;
    int hlt = 1;
    if (g[a].size() > g[b].size()) {
        hlt = -1; swap(a, b);
    }
    for (auto to : g[a])
        st.insert(to);
    for (auto to : g[b])
        if (st.find(to) == st.end())
            return 0;
    return hlt;
}

bool usd[maxn];

void dfs(int x) {
    usd[x] = 1;
    for (auto to : f[x]) {
        if (!usd[to]) dfs(to);
        cpr[x] += cpr[to];
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;
    while (t--) {
        int ans = 0;
        int n, m; cin >> n >> m;
        for (int i = 0; i < n; i++)
            f[i].clear();
        for (int i = 0; i < n; i++)
            g[i].clear();
        for (int i = 0; i < n; i++)
            cin >> c[i];
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g[v].pb(u);
        }
        map<vector<int>, int> mp;
        for (int i = 0; i < n; i++) {
            sort(all(g[i])); usd[i] = 0;
            cpr[i] = 0; mp[g[i]] = 0;
        }
        int cnt = 0;
        for (auto gg : mp)
            mp[gg.first] = cnt++;
        for (int i = 0; i < n; i++)
            nm[i] = mp[g[i]];
        for (int i = 0; i < n; i++) {
            cpr[nm[i]] += c[i];
            for (int j = i + 1; j < n; j++) {
                if (nm[j] == nm[i]) continue;
                int x = is_submask(i, j);
                if (x == 0) continue;
                if (x > 0) f[nm[j]].pb(nm[i]);
                else f[nm[i]].pb(nm[j]);
            }
        }
        for (int i = 0; i < mp.size(); i++)
            if (!usd[i]) dfs(i);
        for (int i = 0; i < mp.size(); i++)
            ans = gcd(ans, cpr[i]);
        cout << ans << '\n';
    }
    return 0;
}
/*
1
7 12
1 1 1 1 1 1 1
1 1
1 2
1 3
1 4
2 1
2 2
2 5
2 6
3 1
3
3 5
3 7
*/
