#include <bits/stdc++.h>

using namespace std;

int64_t gcd(int64_t a, int64_t b) {
    while (b) {
        int64_t tmp = b;
        b = a % b;
        a = tmp;
    }
    return a;
}

int32_t main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        int n, m;
        cin >> n >> m;
        vector<int64_t> cost(m);
        for (int i = 0; i < n; ++i)
            cin >> cost[i];
        vector<vector<int>> adj(n);
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            adj[v - 1].push_back(u - 1);
        }
        int64_t ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<char> use(n);
            for (int i = 0; i < n; ++i)
                if ((mask >> i) & 1)
                    for (int to : adj[i])
                        use[to] = 1;
            int64_t sum = 0;
            for (int i = 0; i < n; ++i)
                if (use[i])
                    sum += cost[i];
            ans = gcd(ans, sum);
        }
        cout << ans << "\n";
    }
    return 0;
}
