
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int gcd(int a, int b) {
	if (!b) {
		return a;
	}
	return gcd(b, a % b);
}

void solve() {
	int n, m;
	cin >> n >> m;

	vector<bool> used(n);

	vector<int> cost(n);

	for (int i = 0; i < n; i++) {
        cin >> cost[i];
	}
	int kek = 0;
	vector<int> arr(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		if (!used[b]) {
			kek += cost[b];
			//used[b] = true;
		}
		arr[a] += cost[b];
	}

	int ans = kek;

	for (int i = 0; i < n; i++) {
		ans = gcd(ans, arr[i]);
	}

	cout << ans << endl;

}
signed main() {
	//fast_io();

	int t;
	cin >> t;

	for (int i = 0; i < t; i++) {
		solve();
	}
    return 0;
}
