#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
long long gg = 0;
long long gcd(long long a, long long b) {
    if(b == 0) {
        return a;
    }
    return gcd(b, a%b);
}
void make(int p, vector<vector<int>> &g, vector<long long> &c, vector<int> &col, long long sum = 0) {
    if(p == g.size()) {
        gg = gcd(gg, sum);
        return;
    }
    make(p + 1, g, c, col, sum);
    for(int i = 0; i < g[p].size(); ++i) {
        ++col[g[p][i]];
        if(col[g[p][i]] == 1) {
            sum += c[g[p][i]];
        }
    }
    make(p + 1, g, c, col, sum);
    for(int i = 0; i < g[p].size(); ++i) {
        --col[g[p][i]];
        if(col[g[p][i]] == 0) {
            sum -= c[g[p][i]];
        }
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for(int _ = 0; _ < t; ++_) {
        int n;
        cin >> n;
        int m;
        cin >> m;
        vector<vector<int>> g(n);
        vector<long long> c(n);
        for(int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for(int i = 0; i < m; ++i) {
            int v1,v2;
            cin >> v1 >> v2;
            --v1, --v2;
            g[v1].push_back(v2);
        }
        gg = 0;
        vector<int> col(n, 0);
        make(0, g, c, col);
        cout << gg << "\n";
    }
}
