#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

ll n, m;
vector<vector<ll>> adj;

bool bit(ll m, ll v) {
    return (m >> v) & 1;
}

void solve() {
    cin >> n >> m;
    adj.assign(n, vector<ll>());
    vector<ll> c(n);
    forEach(c) cin >> it;
    vector<ll> bitMaskRight(n, 0);
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        adj[a].pb(b);
        bitMaskRight[b] |= (1LL << a);
    }
    vector<ll> sum((1LL << n), 0);
    for (ll ms = 0; ms < (1LL << n); ms++) {
        for (ll i = 0; i < n; i++) {
            if (bit(ms, i)) continue;
            sum[ms | (1LL << i)] = sum[ms];
            forEach(adj[i]) {
                if (!(bitMaskRight[it] & ms)) sum[ms | (1LL << i)] += c[it];
            }
        }
    }
    ll ans = 0;
    forEach(sum) ans = __gcd(ans, it);
    cout << ans << "\n";
}

int main() {
    FASTIO
    ll t;
    cin >> t;
    while (t--) solve();
    return 0;
}