#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 2005;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<int> c(n);
		for (auto &i : c) cin >> i;
		vector<int> g(n);
		for (int i = 0; i < m; ++i) {
			int x, y;
			cin >> x >> y;
			x--; y--;
			g[x] |= (1LL << y);
		}
		int gc = 0;
		for (int mask = 0; mask < (1LL << n); ++mask) {
			int to_mask = 0;
			for (int i = 0; i < n; ++i) {
				if (mask & (1LL << i)) {
					to_mask |= g[i];
				}
			}
			int sum = 0;
			for (int i = 0; i < n; ++i) {
				if (to_mask & (1LL << i)) {
					sum += (c[i]);
				}
			}
			gc = gcd(gc, sum);
		}
		cout << gc << endl;
	}
	

}