// lolkekstl.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <sstream>
#include <queue>
#include <deque>
#include <iomanip>
#include <fstream>
#include <bitset>
#include <stack>
#include <map>
//#include <xhash>

using namespace std;


map<unsigned long long, unsigned long long> find(unsigned long long a) {
    map<unsigned long long, unsigned long long> m;
    int kol = 0;
    for (unsigned long long i = 2; i * i <= a; i++) {
        if (a % i == 0) {
            kol = 0;
            while (a % i == 0) {
                kol++;
                a /= i;
            }
            m[i] = kol;
        }
    }
    if (a > 1) {
        m[a] = 1;
    }
    return m;
}

unsigned long long stepen(unsigned long long a, unsigned long long n) {
    if (n == 0) {
        return 1ull;
    }
    if (n == 1) {
        return a;
    }
    if (n & 1) {
        return a * stepen(a * a, (n >> 1));
    }
    else {
        return stepen(a * a, (n >> 1));
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long t = 0, a, b;
    cin >> t;
    bitset<21> bb;
    for (long long w = 0; w < t; w++) {
        long long n = 0, m = 0;
        cin >> n >> m;
        vector<vector<long long> > graph(n);
        vector<long long> ci(n);
        for (long long i = 0; i < n; i++) {
            cin >> ci[i];
        }
        for (long long i = 0; i < m; i++) {
            cin >> a >> b;
            a--, b--;
            graph[a].push_back(b);
        }
        map<unsigned long long, unsigned long long> m1;
        for (long long i = 0; i < n; i++) {
            long long summ = 0;
            for (auto j : graph[i]) {
                summ += ci[j];
            }
            map<unsigned long long, unsigned long long> m = find(summ);
            if (i == 0) {
                m1 = m;
            }
            else {
                map<unsigned long long, unsigned long long> kek;
                for (auto it = m1.begin(); it != m1.end(); it++) {
                    if (m.find(it->first) != m.end()) {
                        kek[it->first] = min(it->second, m[it->first]);
                    }
                }
                swap(kek, m1);
            }
        }
        unsigned long long ans = 1;
        for (auto it = m1.begin(); it != m1.end(); it++) {
            ans *= stepen(it->first, it->second);
        }
        cout << ans<<"\n";
    }
    return 0;
}