
#include <bits/stdc++.h>
#define F first
#define S second
#define PB push_back

using namespace std;
using ll = long long;
using ld = long double;

const ld PI = acos(-1);
const ll N = 5e5+5, inf = 1e9+9, mod = 1e9 + 97;

ll gcd(ll a, ll b){
    while(a != 0 && b != 0){
        if(a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

int main()
{
    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);   cin.tie(0);

    int t; cin >> t;
    while(t--){
        int n, m; cin >> n >> m;
        vector < vector < int > > g(n);
        vector < ll > c(n);
        for(int i = 0; i < n; i++) cin >> c[i];
        vector < int > left;
        for(int i = 0; i < m; i++){
            int u, v; cin >> u >> v; u--; v--;
            g[u].PB(v);
        }

        ll ans = 0;
        for(int mask = 1; mask < (1 << n); mask++){
            vector < int > us(n);
            ll sum = 0;
            for(int i = 0; i < n; i++){
                if(mask & (1 << i)){
                    for(auto to : g[i]){
                        if(!us[to]){
                            us[to] = 1;
                            sum += c[to];
                        }
                    }
                }
            }
            ans = gcd(ans, sum);

        }
        cout << ans << "\n";
    }

}
