#include <iostream>
#include <vector>
#include <cstdlib>
#include <bitset>
#include <algorithm>

#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl "\n"
#endif

#define _ <<" "<<

using namespace std;
typedef long long ll;
const int N = 21;

int T;
ll vs[N];
bitset<N> conn[N];

ll upd(ll pv, ll cur){
    if(pv == -1) return cur;
    else return __gcd(pv, cur);
}

int32_t main()
{
    cin >> T;
    while(T--){
        int n,m; cin >> n >> m;
        ll ans = -1;
        for(int i = 0; i < n; i++) cin >> vs[i];
        for(int i = 0; i < n; i++) conn[i].reset();
        for(int i = 0; i < m; i++){
            int u,v; cin >> u >> v; u--; v--;
            conn[u][v] = true;
        }
        bitset<N> incl;
        for(int mask = 1; mask < (1<<n); mask++){
            incl.reset();
            for(int i = 0; i < n; i++){
                if((mask&(1<<i))==0) continue;
                incl |= conn[i];
            }
            ll sum = 0;
            for(int i = 0; i < n; i++){
                if(!incl[i]) continue;
                sum += vs[i];
            }
            ans = upd(ans, sum);
        }
        cout << ans << endl;
    }
    return 0;
}
