#include <iostream>
#include <vector>
#include <set>
#define int long long

using namespace std;

const int MAXN = 20;

vector<int> num;
vector<int> edges[MAXN];

int ans;

int gcd(int a, int b) {
	if (!(a && b))
		return a + b;
	return gcd(b % a, a);
}

void f(string sts, set<int> used, int sum, int& n) {
	if ((int)sts.size() == n) {
		ans = gcd(ans, sum);
		return;
	}
	f(sts + "0", used, sum, n);
	int newNum = (int)sts.size();
	for (auto x: edges[newNum]) {
		if (used.find(x) == used.end()) {
			used.insert(x);
			sum += num[x];
		}
	}
	f(sts + "1", used, sum, n);
}

int32_t main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;

		// обнуление
		ans = 0;
		num.resize(0);
		for (int i = 0; i < n; i++) {
			edges[i].resize(0);
		}

		// ввод
		int temp;
		for (int i = 0; i < n; i++) {
			cin >> temp;
			num.push_back(temp);
		}

		int x1, x2;
		for (int i = 0; i < m; i++) {
			cin >> x1 >> x2;
			x1--; x2--;
			edges[x1].push_back(x2);
		}

		set<int> emp;
		f("", emp, 0, n);
		cout << ans << endl;		
	}
}