
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int gcd(int a, int b) {
	if (!b) {
		return a;
	}
	return gcd(b, a % b);
}

void solve() {
	int n, m;
	cin >> n >> m;

	vector<bool> used(n);

	vector<vector<int>> g(n);
	vector<int> cost(n);

	for (int i = 0; i < n; i++) {
        cin >> cost[i];
	}
	int kek = 0;
	vector<int> arr(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[b].push_back(a);
	}
	vector<vector<int>> good_pair(n);

	for (int i = 0; i < n; i++) {
		sort(g[i].begin(), g[i].end());
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (g[i].size() == g[j].size()) {
				bool good = true;
				for (int k = 0; k < g[i].size(); k++) {
					if (g[i][k] != g[j][k]) {
						good = false;
					}
				}

				if (good) {
					good_pair[i].push_back(j);
					good_pair[j].push_back(i);

					//cout << i << " " << j << endl;
				}
			}
		}
	}

	int ans = 0;

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			used[i] = true;
			int now = cost[i];

			for (auto u : good_pair[i]) {
				now += cost[u];
				used[u] = true;
			}
			ans = gcd(ans, now);
		}
	}

	cout << ans << endl;

}
signed main() {
	//fast_io();

	int t;
	cin >> t;

	for (int i = 0; i < t; i++) {
		solve();
	}
    return 0;
}
