#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 500000;

int arr[MAXN];
vector<int> graph[MAXN];
int sm[MAXN];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int  t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
      cin >> arr[i];
      graph[i].clear();
      sm[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
      int v, u;
      cin >> v >> u;
      v--, u--;
      sm[v] += arr[u];
      graph[v].push_back(u);
    }
    for (int i = 0; i < m; ++i) {
      sort(graph[i].begin(), graph[i].end());
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
      ans = gcd(sm[i], ans);
    }
    for (int i = 0; i < n; ++i) {
      for (int j = i + 1; j < n; ++j) {
        int pi = 0, pj = 0;
        int s = sm[i] + sm[j];
        while (pi < graph[i].size() && pj < graph[j].size()) {
          int l = graph[i][pi];
          int r = graph[j][pj];
          if (l < r)
            pi++;
          else if (l > r)
            pj++;
          else {
            s -= arr[l];
            pi++;
            pj++;
          }
        }
        ans = gcd(s, ans);
      }
    }
    cout << ans << '\n';
  }
  return 0;
}