#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

ll gcd(ll a, ll b){
    while(b){
        a %= b;
        swap(a, b);
    }
    return a;
}


void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int> >g(n);
    vector<ll>c(n);
    for(int i = 0; i < n; i++){
        cin >> c[i];
    }
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
    }
    ll big_ans = 0;
    for(int mask = 0; mask < (1 << n); mask++){
        vector<bool>used(n);
        ll ans = 0;
        for(int j = 0; j < n; j++){
            if(mask & (1 << j)){
                for(int k = 0; k < g[j].size(); k++){
                    if(!used[g[j][k]]){
                        used[g[j][k]] = 1;
                        ans += c[g[j][k]];
                    }
                }
            }
        }
        big_ans = gcd(big_ans, ans);
    }
    cout << big_ans << endl;
}

int main()
{
    QuickStart();
    int t; cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
