#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 5e5 + 1;
const int inf = 1e9 + 1;

vector<int> g[maxn];
int used[maxn];
int c[maxn];
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        int sum = 0;
        for (auto &el : g[i]) {
            sum += c[el];
        }
        ans = __gcd(ans, sum);
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = i + 1;
    }

    for (int i = 0; i < 100; i++) {
        shuffle(all(a), rnd);
        int sum = 0;
        for (int j = 0; j < (n + 1) / 2; j++) {
            //cout << a[j] << " ";
            for (auto &el : g[a[j]]) {
                if (used[el]) continue;
                used[el] = 1;
                sum += c[el];
            }
        }
        for (int j = 0; j <= n / 2; j++) {
            for (auto &el : g[a[j]]) {
                if (!used[el]) continue;
                used[el] = 0;
            }
        }
        ans = __gcd(ans, sum);
        //cout << "\n";
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++) {
        used[i] = 0;
        g[i].clear();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
