#include <bits/stdc++.h>

using namespace std;

const  int kN = 5e5 + 7;

long long c[kN];
vector<int> adj[2 * kN];

long long gcd(long long a, long long b){
    while(b != 0){
        long long c = b;
        b = a % b;
        a = c;
    }

    return a;
}

void solve(){
    int n, m;
    cin >> n >> m;

    for(int i = 1; i <= 2 * n; ++i)
        adj[i].clear();

    for(int i = 1; i <= n; ++i)
        cin >> c[i];

    for(int i = 0; i < m; ++i){
        int u, v;

        cin >> u >> v;
        adj[u + n].push_back(v);
        //adj[v].push_back(u + n);
    }

    for(int i = n + 1; i <= 2 * n; ++i)
        sort(adj[i].begin(), adj[i].end());

    long long ans = 0;
    for(int i = n + 1; i <= 2 * n; ++i){
        for(int j = i + 1; j <= 2 * n; ++j){
            int l = 0, r = 0;
            long long same = 0, a = 0, b = 0;
            while(l != adj[i].size() && r != adj[j].size()){
                if(adj[i][l] == adj[j][r]){
                    same += c[adj[i][l]];
                    ++l;
                    ++r;
                    continue;
                }

                if(adj[i][l] < adj[j][r]){
                    a += c[adj[i][l]];
                    ++l;
                }
                else{
                    b += c[adj[j][r]];
                    ++r;
                }
            }

            while(l != adj[i].size()){
                a += c[adj[i][l]];
                ++l;
            }
            while(r != adj[j].size()){
                b += c[adj[j][r]];
                ++r;
            }

            ans = gcd(ans, a);
            ans = gcd(ans, b);
            ans = gcd(ans, same);
        }
    }

    cout << ans << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    cin >> t;

    while(t--)
        solve();
}
