#include <iostream>
#include <set>
#include <vector>

using namespace std;

vector <long long> c;
vector <vector <int>> graph;

long long gcd(long long a, long long b)
{
    while (b != 0)
    {
        long long r = a % b;

        a = b;
        b = r;
    }

    return a;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long t, n, m;

    cin >> t;

    for (long long i = 0; i < t; i++)
    {
        c.clear();
        graph.clear();

        cin >> n >> m;

        for (long long j = 0; j < n; j++)
        {
            long long x;
            cin >> x;
            c.push_back(x);
        }

        graph.resize(n);

        for (long long j = 0; j < m; j++)
        {
            long long x, y;
            cin >> x >> y;
            graph[x - 1].push_back(y - 1);
            //graph[y - 1].push_back(x - 1);
        }

        long long mask = 1;

        mask = (1 << n);

        long long sum = 0;

        for (int j = 1; j < mask; j++)
        {
            int x = j;
            int r = n - 1;
            long long summ = 0;
            set <int> visited;
            while (x != 0)
            {
                int h = x % 2;
                if (h == 1)
                {
                    for (auto k : graph[r])
                    {
                        visited.insert(k);
                    }
                }
                r--;
                x /= 2;
            }
            //cout << "SUMM! " << summ << " " << j << endl;
            for (auto hh : visited)
            {
                summ += c[hh];
            }
            sum = gcd(sum, summ);
        }

        cout << max(1LL, sum) << endl;
    }
    return 0;
}
