#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

int_fast64_t gcd(int_fast64_t a, int_fast64_t b){
    if(a<b)
        swap(a, b);
    if(b==0)
        return a;
    return gcd(b, a%b);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for(int qwe = 0; qwe<t; qwe++){
        int n, m;
        cin >> n >> m;
        vector<long long> c(n);
        vector<vector<int> > g(n);
        for(int i = 0; i<n; i++)
            cin >> c[i];
        for(int i = 0; i<m; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            g[a].push_back(b);
        }
        vector<set<int> > rt(1);
        for(int i = 0; i<n; i++)
            rt[0].insert(i);
        for(int i = 0; i<n; i++){
            set<int> jm;
            for(int j = 0; j<g[i].size(); j++)
                jm.insert(g[i][j]);
            //cout << i << endl;
            int sz = rt.size();
            for(int j = 0; j<sz; j++){
                if(rt[j].empty())
                    continue;
                set<int> rt1;
                auto it1 = jm.begin();
                for(auto it = rt[j].begin(); it!=rt[j].end();){
                    while(it1!=jm.end()&&(*it1)<(*it))
                        it1++;
                    if(it1==jm.end())
                        break;
                    if((*it)==(*it1)){
                        rt1.insert(*it);
                        auto it2 = it;
                        it++;
                        rt[j].erase(it2);
                    }
                    else
                        it++;
                }
                if(!rt1.empty())
                    rt.push_back(rt1);
            }
        }
        long long ans = 0;
        for(int i = 0; i<rt.size(); i++){
            long long sm = 0;
            for(auto it = rt[i].begin(); it!=rt[i].end(); it++)
                sm += c[*it];
            ans = gcd(ans, sm);
        }
        cout << ans << '\n';
    }

    return 0;
}
