#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 5e3 + 5;
int n, m;
ll c[MAXN];
vector<int> g[MAXN];
vector<int> gr[MAXN];
ll s1[MAXN];
ll s[MAXN][MAXN];

void solve() {
    cin >> n >> m;
    rep(i, n) {
        cin >> c[i];
    }
    rep(i, n) {
        g[i].clear();
        gr[i].clear();
        s1[i] = 0;
    }
    rep(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        gr[v].push_back(u);
    }

    rep(i, n) {
        for (auto it : g[i]) {
            s1[i] += c[it];
        }
    }

    // rep(i, n) {
    //     cout << s1[i] << ' ';
    // }
    // cout << endl;

    rep(i, n) {
        rep(j, n) {
            s[i][j] = s1[i] + s1[j];
        }
    }

    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j < n; ++j) {
    //         cout << s[i][j] << ' ';
    //     }
    //     cout << endl;
    // }

    rep(i, n) {
        for (auto it1 : gr[i]) {
            for (auto it2 : gr[i]) {
                s[it1][it2] -= c[i];
            }
        }
    }

    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            res = gcd(res, s[i][j]);
        }
    }

    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    rep(tt, t) {
        solve();
    }
}
