#include <iostream>
#include <numeric>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    ll c[n];
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    int lToRMsk[n];
    fill(lToRMsk, lToRMsk + n, 0);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        lToRMsk[a] |= 1 << b;
    }
    ll ans = 0;
    for (int leftMsk = 0; leftMsk < (1 << n); leftMsk++) {
        int rightMsk = 0;
        for (int l = 0; l < n; l++) {
            if (((leftMsk >> l) & 1) == 1) {
                rightMsk |= lToRMsk[l];
            }
        }
        ll sum = 0;
        for (int j = 0; j < n; j++) {
            if (((rightMsk >> j) & 1) == 1) {
                sum += c[j];
            }
        }
        ans = gcd(ans, sum);
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("G.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }

    return 0;
}