#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 500005;

struct Right
{
    long long c;
    vector<int> o;
};

int n, m;
vector<int> g[MAXN];
Right a[MAXN];
bool b[MAXN];

bool cmp(Right a, Right b)
{
    return a.o < b.o;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;
    while (t--)
    {
        cin >> n >> m;
        for (int i = 1; i <= n; ++ i)
        {
            cin >> a[i].c;
        }
        for (int i = 1; i <= m; ++ i)
        {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            a[v].o.push_back(u);
        }

        for (int i = 1; i <= n; ++ i)
        {
            sort(a[i].o.begin(), a[i].o.end());
        }

        sort(a + 1, a + n + 1, cmp);

        // cout << "sorted "<< endl;

        long long gcd = 0;
        /*for (int i = 0; i < (1 << n); ++ i)
        {
            for (int j = 1; j <= n; ++ j) b[j] = 0;
            for (int j = 1; j <= n; ++ j)
            {
                if (i & (1 << (j - 1)))
                {
                    for (int adj : g[j])
                    {
                        b[adj] = 1;
                    }
                }
            }

            long long sum = 0;
            for (int j = 1; j <= n; ++ j)
            {
                if (b[j]) sum += a[j].c;
            }

            if (i == 0) gcd = sum;
            else gcd = __gcd(gcd, sum);
        }*/

        vector<long long> nums;
        nums.push_back(a[1].c);
        for (int i = 2; i <= n; ++ i)
        {
            if (a[i].o == a[i - 1].o) nums[nums.size() - 1] += a[i].c;
            else nums.push_back(a[i].c);
        }

        for (long long num : nums)
        {
            if (gcd == 0) gcd = num;
            else gcd = __gcd(gcd, num);
        }

        for (int i = 1; i <= n; ++ i)
        {
            g[i].clear();
            a[i].o.clear();
        }

        cout << gcd << endl;
    }
}

