#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 5e5 + 5;
const int MAX_TRIES = 1000;

mt19937 mt(313);
int rng(int l, int r)
{
    return mt() % (r - l + 1) + l;
}

ll gcd(ll x, ll y)
{
    if(x > y)
        swap(x, y);
    return ((x == 0) ? y : gcd(x, y % x));
}


int n, m;
vector <int> nb[N];
ll c[N];

bool taken[N];
ll add_to_set(int u)
{
    ll res = 0;
    for(int v: nb[u])
        if(!taken[v])
        {
            taken[v] = 1;
            res += c[v];
        }

    return res;
}

void rmv_from_set(int u)
{
    for(int v: nb[u])
        taken[v] = false;
}

ll ans;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int tests;
    cin >> tests;
    while(tests--)
    {
        cin >> n >> m;
        for(int i = 1; i <= n; i++)
        {
            nb[i].clear();
            cin >> c[i];
        }

        int u, v;
        for(int i = 1; i <= m; i++)
        {
            cin >> u >> v;
            nb[u].pb(v);
        }

        ans = 0;
        for(int i = 1; i <= n; i++)
        {
            ans = gcd(ans, add_to_set(i));
            rmv_from_set(i);

        }

        for(int i = 2; i <= n; i++)
        {
            ll sm = add_to_set(1);
            sm += add_to_set(i);
            ans = gcd(ans, sm);

            rmv_from_set(i);
            rmv_from_set(1);
        }

        cout << ans << endl;
    }

    return 0;
}
