#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <deque>


using namespace std;

#define all(c) c.begin(), c.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;


template<typename T>
istream &operator>>(istream &is, vector<T> &vector_input) {
    for (int i = 0; i < vector_input.size(); ++i)
        is >> vector_input[i];
    return is;
}

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

vector<vi> g;

vll c;
set<int> r;

ll check() {
    ll cur = 0;
    for (int i:r)
        cur += c[i];
    return cur;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int ii = 0; ii < t; ++ii) {
        int n, m;
        cin >> n >> m;
        g.resize(2 * n);
        c.resize(n);
        cin >> c;
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
        }
        ll ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int i = 0; i < n; ++i)
                if ((mask >> i) & 1)
                    for (int v:g[i])
                        r.insert(v);
            ans = gcd(ans, check());
            r.clear();
        }
        g.clear();
        c.clear();
        cout << ans << "\n";
    }
}