#include <bits/stdc++.h>

using namespace std;

const int kN = 5e5 + 7;
const int kMask = (1 << 20);

long long c[kN];
vector<int> adj[2 * kN];
int mask[kN];
long long sum_mask[kN];

long long gcd(long long a, long long b){
    while(b != 0){
        long long c = b;
        b = a % b;
        a = c;
    }

    return a;
}

void solve(){
    int n, m;
    cin >> n >> m;

    for(int i = 1; i <= 2 * n; ++i)
        adj[i].clear();

    for(int i = 1; i <= n; ++i)
        cin >> c[i];

    for(int i = 0; i < m; ++i){
        int u, v;

        cin >> u >> v;
        adj[u + n].push_back(v);
        //adj[v].push_back(u + n);
    }

    for(int i = 1; i <= n; ++i)
        mask[i] = 0;
    for(int i = 0; i < (1 << n); ++i)
        sum_mask[i] = 0;

    for(int i = n + 1; i <= 2 * n; ++i)
        for(int x: adj[i])
            mask[x] += (1 << (i - n - 1));

    for(int i = 1; i <= n; ++i)
        sum_mask[mask[i]] += c[i];

    long long ans = 0;
    for(int i = 0; i < (1 << n); ++i)
        ans = gcd(ans, sum_mask[i]);

    cout << ans << "\n";
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t;
    cin >> t;

    while(t--)
        solve();
}
