#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e3 + 10;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

#define CHECK(pred) ++version;\
			ll lres = 0;\
			for (int i = 0; i < n; ++i) {\
				if (pred)\
					for (int v : edges[i])\
						used[v] = version;\
			}\
			for (int i = 0; i < n; ++i)\
				if (used[i] == version)\
					lres += c[i];\
			gres = gcd(gres, lres);

mt19937 rnd(time(0));

vector<int> edges[MAX_N];
ll c[MAX_N];
int used[MAX_N];
int version = 1;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tests;
	cin >> tests;
	while (tests--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i)
			cin >> c[i];
		for (int i = 0; i < n; ++i)
			edges[i].clear();
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			edges[--u].push_back(--v);
		}
		ll gres = 0;
		for (int q = 0; q < n; ++q) {
			CHECK(i == q);
		}
		for (int iter = 0; iter < 1e5; ++iter) {
			CHECK(rnd() % 2);
		}
		cout << gres << "\n";
	}
	return 0;
}