#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n;
vector<int> a;

signed main() {
    boot_up();

    while (cin >> n) {
        solve();
    }
}

void solve() {
    init(a, n);

    bool flag = true;

    for (auto & it : a) {
        cin >> it;

        if (it > 100) {
            flag = false;
        }
    }

    if (flag) {
        int res = 0;
        vector<int> cnt(101);

        for (int i = n - 1; i >= 0; --i) {
            for (int nxt = 1; nxt <= 100; ++nxt) {
                if (cnt[nxt] % 2 == 1) {
                    res ^= (a[i] + nxt);
                }
            }

            ++cnt[a[i]];
        }

        cout << res << '\n';
        return;
    }

    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            res ^= (a[i] + a[j]);
        }
    }

    cout << res << '\n';
}
