#include <bits/stdc++.h>

using namespace std;
#define int long long
int allrandom = 400000000;
mt19937 rng;
int __rndlast, __rnddg = 1;
inline bool randbit()
{
    __rndlast >>= 1;
    if (__rnddg < 0)
    {
        __rnddg = 32;
        __rndlast = rng();
    }
    __rnddg--;
    return (__rndlast & 1);
}
void solve(int randlim)
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int buka = a[0];
    for (int i = 0; i < n; i++)
        buka = __gcd(a[i], buka);

    vector<vector<int>> g(n), ig(n);
    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        ig[v - 1].push_back(u - 1);
    }

    int biaka = -1;
    {
        vector<bool> used(n, false);
        for (int i = 0; i < n; i++)
        {
            int bds = 0;
            for (int to : g[i])
                bds += a[to], used[to] = true;
            if (i == 0)
                biaka = bds;
            else
                biaka = __gcd(biaka, bds);
        }
        int tsum = 0;
        for (int i = 0; i < n; i++)
            if (used[i])
                tsum += a[i];
        biaka = __gcd(biaka, tsum);
    }
    int decr = max(n + m, 20LL);
    while (randlim > 0 && biaka != buka)
    {
        randlim -= decr;
        allrandom -= decr;
        int tsum = -1;
        vector<bool> used(n, false);
        if (randbit())
        {
            for (int i = 0; i < n; i++)
            {
                if (randbit())
                {
                    for (int to : g[i])
                        if (!used[to])
                    {
                        used[to] = true;
                    }
                }
            }
        }
        else
        {
            vector<bool> usedfrom(n, false);
            for (int i = 0; i < n; i++)
            {
                if (randbit())
                {
                    used[i] = true;
                    for (int from : ig[i])
                        if (!usedfrom[from])
                        {
                            usedfrom[from] = true;
                            for (int to : g[from])
                                if (!used[to])
                                {
                                    used[to] = true;
                                }
                        }
                }
            }
        }
        for (int i = 0; i < n; i++)
            if (used[i])
                tsum += a[i];
        if (tsum < 0)
            continue;
        tsum++;
        biaka = __gcd(biaka, tsum);
    }
    cout << biaka << "\n";
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    rng.seed(198356627);
    int t;
    cin >> t;
    while (t-->0)
        solve(allrandom / (t + 1));
    return 0;
}
