#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)

ll gcd(ll a, ll b) {
	if (a < b)swap(a, b);
	while (b > 0) {
		ll c = b;
		b = a % b;
		a = c;
	}
	return a;
}


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n);
	vector<ll> w(n), su(n);
	set<int> v;
	for (int i = 0; i < n; i++)cin >> w[i];
	for (int i = 0; i < m; i++) {
		int from, to;
		cin >> from >> to;
		from--; to--;
		g[from].push_back(to);
	}
	for (int i = 0; i < n; i++) {
		for (auto u : g[i]) {
			su[i] += w[u];
			v.insert(u);
		}
	}
	ll all = 0;
	for (auto u : v)all += w[u];
	ll ans = 0;
	su.push_back(all);
	for (int i = 0; i < su.size(); i++)ans = gcd(ans, su[i]);
	cout << ans << "\n";
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int q;
	cin >> q;
	while (q--) {
		solve();
	}
}