#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long
const int MAXN = 5000;
#define ll int
signed arr[MAXN];
vector<signed> graph[MAXN];
vector<signed> graph2[MAXN][MAXN];
ll sm[MAXN];
ll sm2[MAXN][MAXN];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int  t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    vector<int> arr(n);
    for (int &el : arr)
      cin >> el;
    vector<vector<int>> graph(n);
    for (int i = 0; i < m; ++i) {
      int v, u;
      cin >> v >> u;
      v--, u--;
      graph[v].push_back(u);
    }
    int finmask = (1<<n);
    int ans = 0;
    for (int mask = 0; mask < finmask; mask++) {
      int sm = 0;
      vector<char> used(n, 0);
      for (int i = 0; i < n; ++i) {
        if (!((mask>>i)&1))
          continue;
        for (int u : graph[i]) {
          if (used[u])
            continue;
          used[u] = 1;
          sm += arr[u];
        }
      }
      ans = gcd(sm, ans);
    }
    cout << ans << '\n';
  }
  return 0;
}