#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

const int INF = 1e9;

bool cmp (const pair<vector<int>, ll> &a, const pair<vector<int>, ll> &b) {
	if (a.first.size() != b.first.size())
		return false;
	for (int i = 0; i < a.first.size(); ++i)
		if (a.first[i] != b.first[i])
			return false;
	return true;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<int> c(n);
		for (int &i : c)
			cin >> i;

		vector<pair<vector<int>, ll>> g(n);
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			g[u].first.push_back(v);
		}
		ll ans = 0;
		for (int i = 0; i < (1 << n); ++i) {
			vector<bool> good(n);
			for (int j = 0; j < n; ++j)
				if (i & (1 << j))
					for (auto k : g[j].first)
						good[k] = true;
			ll sum = 0;
			for (int j = 0; j < n; ++j)
				if (good[j])
					sum += c[j];
			ans = std::__gcd(ans, sum);
		}
		cout << ans << '\n';
	}
	return 0;
}