#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937 rnd(time(0));

long long get(vector<long long> &w, vector<vector<int> > &g, vector<int> &req) {
    long long ans = 0;
    int n = w.size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < req.size(); j++) {
            if (lower_bound(all(g[i]), req[j]) != g[i].end()) {
                ans += w[i];
                break;
            }
        }
    }
    return ans;
}

int main() {
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        vector<long long> w(n);
        for (int i = 0; i < n; i++) {
            cin >> w[i];
        }
        vector<vector<int> > g(n);
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            g[b - 1].push_back(a - 1);
        }
        for (int i = 0; i < n; i++) {
            sort(all(g[i]));
        }
        long long ans = 0;
        for (int i = 0; i < n; i++) {
            vector<int> q = {i};
            ans = __gcd(ans, get(w, g, q));
        }
        for (int i = 0; i < 10; i++) {
            vector<int> q;
            q.reserve(10);
            for (int j = 0; j < (rnd() % 10) % n + 1; j++) {
                q.push_back(rnd() % n);
            }
            ans = __gcd(ans, get(w, g, q));
        }
        cout << ans << '\n';
    }
    return 0;
}

/*
8 2 0
1 2
1 3
3 4
3 5
1 6
6 7
6 8
5 2
8 7
 */