#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>

using namespace std;

long long int gcd(long long int a, long long int b)
{
    while (a != 0 && b != 0)
    {
        if (a > b)
            a = a % b;
        else
            b = b % a;
    }
    return(a + b);
}

int main()
{
    long long int t;
    cin >> t;
    for (long long int tmp = 0; tmp < t; tmp++)
    {
        long long int n, m, a, b, i, j, x;
        cin >> n >> m;
        long long int A[n];
        for (i = 0; i < n; i++)
        {
            cin >> A[i];
        }
        vector <long long int> edges[n];
        for (i = 0; i < m; i++)
        {
            cin >> a >> b;
            edges[a - 1].push_back(b - 1);
        }
        long long int g = 0;
        for (i = 0; i < (1 << n); i++)
        {
            long long int sum = 0;
            unordered_map <long long int, bool> used;
            for (j = 0; j < n; j++)
            {
                if (i & (1 << j))
                {
                    for (x = 0; x < edges[j].size(); x++)
                    {
                        if (!used[edges[j][x]])
                        {
                            sum = sum + A[edges[j][x]];
                            used[edges[j][x]] = true;
                        }
                    }
                }
            }
            g = gcd(g, sum);
        }
        cout << g << endl;
    }
    return 0;
}
