#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

struct node {
    map<int, int> to;
    ll sum;
};

const int MAXN = 5e5 + 5;
int n, m;
ll c[MAXN];
vector<int> gr[MAXN];

int last;
node t[MAXN];

void init() {
    last = 1;
    t[0].to.clear();
    t[0].sum = 0;
}

void trie_add(const vector<int> &a, ll x) {
    // cout << "trie_add {";
    // rep(i, a.size()) {
    //     if (i) cout << ' ';
    //     cout << a[i];
    // }
    // cout << "}" << endl;
    int v = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (!t[v].to.count(a[i])) {
            t[v].to[a[i]] = last;
            t[last].to.clear();
            t[last].sum = 0;
            last++;
        }
        v = t[v].to[a[i]];
    }
    t[v].sum += x;
}

void dfs(int v, ll &res) {
    // cout << "dfs " << v << endl;
    res = gcd(res, t[v].sum);
    for (auto it : t[v].to) {
        dfs(it.s, res);
    }
}

void solve() {
    cin >> n >> m;
    rep(i, n) {
        cin >> c[i];
    }
    rep(i, n) {
        gr[i].clear();
    }
    rep(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        gr[v].push_back(u);
    }
    rep(i, n) {
        sort(all(gr[i]));
    }

    init();
    rep(i, n) {
        if (!gr[i].empty()) {
            trie_add(gr[i], c[i]);
            // cout << "last: " << last << endl;
            // rep(i, last) {
            //     cout << " " << i << " : { ";
            //     for (auto it : t[i].to) {
            //         cout << it.f << ":" << it.s << ' ';
            //     }
            //     cout << "} sum = " << t[i].sum << endl;
            // }
        }
    }

    ll res = 0;
    dfs(0, res);
    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    rep(tt, t) {
        solve();
    }
}
