#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

const int INF = 1e9;

bool cmp (const pair<vector<int>, ll> &a, const pair<vector<int>, ll> &b) {
	if (a.first.size() != b.first.size())
		return false;
	for (int i = 0; i < a.first.size(); ++i)
		if (a.first[i] != b.first[i])
			return false;
	return true;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<int> c(n);
		for (int &i : c)
			cin >> i;

		vector<pair<vector<int>, ll>> g(n);
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			--u, --v;
			g[v].first.push_back(u);
		}
		for (int i = 0; i < n; ++i) {
			g[i].second = c[i];
			std::sort(g[i].first.begin(), g[i].first.end());
		}

		std::sort(g.begin(), g.end(), [](const auto& a, const auto& b){
			if (a.first.size() != b.first.size())
				return a.first.size() < b.first.size();
			for (int i = 0; i < a.first.size(); ++i)
				if (a.first[i] != b.first[i])
					return a.first[i] < b.first[i];
			return false;
		});

		ll ans = 0;
		ll cur = g[0].second;
		for (int i = 1; i < n; ++i) {
			if (g[i - 1].first.size() == 0) {
				cur = g[i].second;
				continue;
			}
			if (cmp(g[i], g[i - 1]))
				cur += g[i].second;
			else {
				ans = std::__gcd(ans , cur);
				cur = g[i].second;
			}
		}
		if (cur != 0)
			ans = std::__gcd(ans, cur);
		
		cout << ans << '\n';
	}
	return 0;
}