#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    for (int test = 0; test < t; test++)
    {
        int n, m;
        cin >> n >> m;

        vector<ll> num(n);
        for (int i = 0; i < n; i++)
            cin >> num[i];

        vector<vector<int>> g(n);
        for (int i = 0; i < m; i++)
        {
            int a, b;
            cin >> a >> b;
            a--;
            b--;

            g[a].push_back(b);
        }

        ll ans = 0;
        for (int mask = 1; mask < (1 << n); mask++)
        {
            vector<bool> taken(n, false);
            for (int i = 0; i < n; i++)
                if (mask & (1 << i))
                    for (int v : g[i])
                        taken[v] = true;

            ll total = 0;
            for (int i = 0; i < n; i++)
                if (taken[i])
                    total += num[i];

            ans = __gcd(ans, total);
        }

        cout << ans << endl;
    }

    return 0;
}