#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
using namespace std;
const int max_n = 5e5 + 1;
int n, m;
int f[max_n];

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

struct w {
    int id;
    vector<int> a;

    w(vector<int> b, int id1) {
        id = id1;
        for(int i : b) a.emplace_back(i);
    }

    w() {}

    bool operator<(const w a1)const {
        if (a1.a.size() != a.size()) return a.size() < a1.a.size();
        for(int i = 0;i < a.size();i++) if (a1.a[i] != a[i]) return a[i] < a1.a[i];
        return true;
    }
};
bool eq(vector<int> a, vector<int> b) {
    if (a.size() != b.size()) return false;
    for(int i = 0;i < a.size();i++) if (a[i] != b[i]) return false;
    return true;
}


void solve() {
    cin >> n >> m;

    for(int i = 0;i < n;i++) cin >> f[i];

    vector<vector<int>> temp(n);
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        temp[v2].emplace_back(v1);
    }

    vector<w> temp1;
    for(int i = 0;i < n;i++) {
        sort(temp[i].begin(), temp[i].end());
        if (!temp[i].empty()) {
            temp1.emplace_back(temp[i], i);
        }
    }

    sort(temp1.begin(), temp1.end());

    int ans = 0;
    vector<int> prev;
    int sum = 0;
    for(int i = 0;i < temp1.size();i++) {
        if (!eq(prev, temp1[i].a)) {
            ans = gcd(ans, sum);
            prev = temp1[i].a;
            sum = 0;
        }
        sum += f[temp1[i].id];
    }
    ans = gcd(ans, sum);

    cout << ans << '\n';
}


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}