#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <deque>


using namespace std;

#define all(c) c.begin(), c.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;


template<typename T>
istream &operator>>(istream &is, vector<T> &vector_input) {
    for (int i = 0; i < vector_input.size(); ++i)
        is >> vector_input[i];
    return is;
}

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    for (int ii = 0; ii < t; ++ii) {
        int n, m;
        cin >> n >> m;
        vector<vi> g(n);
        vll c;
        c.resize(n);
        vector<vector<bool>> gg(n, vector<bool>(n, false));
        cin >> c;
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
            gg[u][v] = true;
        }
        ll ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            ll cur = 0;
            set<int> r;
            for (int i = 0; i < n; ++i)
                if ((mask >> i) & 1)
                    for (int j = 0; j < n; ++j)
                        if (gg[i][j])
                            r.insert(j);
            for (int i:r)
                cur += c[i];
            ans = gcd(ans, cur);
        }
        cout << ans << "\n";
    }
}