#include <bits/stdc++.h>

#define loop(i, n) for(int i  = 0; i < n; ++i)
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define vec vector
#define paii pair<int, int>
#define fr first
#define sc second
#define all(x) x.begin(), x.end()
#define Unique(x) x.erase(unique(all(x)), x.end())
#define SZ(x) (int) x.size()
#define pb push_back

#define int long long

using namespace std;

mt19937 rnd(time(0));

const int MAXN = 5e5 + 47;

int n, m;
vec<int> c;
vec<vec<int> > graf(MAXN);

int gcd(int a, int b) {
    while(b > 0) {
        swap(a, b);
        b %= a;
    }
    return a;
}

void solve1() {
    vec<int> sum((1 << n), 0);
    loop(msk, (1 << n)) {
        int t = msk;
        loop(i, n) {
            if(t % 2 == 1) sum[msk] += c[i];
            t /= 2;
        }
    }
    vec<int> prec(n);
    loop(i, n) {
        for(int p1 : graf[i]) prec[i] += (1 << (p1));
    }/*
    loop(i, n) {
        bitset<4> m(prec[i]);
        cout << m << " " << sum[prec[i]] <<  endl;
    }
    cout << endl;*/

    int ans = 0;
    loop(msk, (1 << n)) {
        int t = msk, f = 0, hav = 0;
        loop(i, n) {
            if(t % 2 == 1) {
                hav |= prec[i];
            }
            t /= 2;
        }
        f = sum[hav];
        //cout << f << " ";
        ans = gcd(ans, f);
    }
    //cout << endl;
    cout << ans << endl;
    return ;
}

void solve2() {
    int ans = 0;
    vec<vec<int> > dp(n, vec<int>(n, 0)), hav(n);
    loop(p1, n) {
        int sum = 0;
        for(int p2 : graf[p1]) {
            //hav[p2].pb(p1);
            sum += c[p2];
        }
        ans = gcd(sum, ans);
    }
    loop(p1, n) {
        vec<int> us;
        for(int k : graf[p1]) us.pb(k);
        FOR(p2, p1 + 1, n) {
            vec<int> t = us;
            for(int k: graf[p2]) t.pb(k);
            sort(all(t)), Unique(t);
            int sum = 0;
            for(int k : t) sum += c[k];
            ans = gcd(ans, sum);
        }
    }
    cout << ans << endl;
   /* loop(p1, n) {
        loop(a, SZ(hav[p1])) {
            int p2 = hav[p1][a];
            FOR(b, a + 1, SZ(hav[p1])) {
                int p3 = hav[p1][b];
                dp[p2][p3] += c[p1];
                dp[p3][p2] += c[p1];
            }
        }
    }
    loop(a, n) {
        loop(b, n) {
            ans = gcd(dp[a][b], ans);
        }
    }
    cout << ans << endl;*/
}

void solve() {
    cin >> n >> m;
    graf.resize(0), graf.resize(n);
    c.resize(0), c.resize(n);
    loop(i, n) cin >> c[i];
    loop(i, m) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graf[a].pb(b);
    }/*
    if(n <= 20) {
        solve1();
        return ;
    }*/
    solve2();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef COFFEE_MACHINE
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif // COFFEE_MACHINE

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}
