#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll n, m, a[1000000];
vector <ll> nx[1000000];
ll mark[1000000];

ll gcd(ll a, ll b) {
    while (a > 0 && b > 0) {
        if (a > b) a %= b;
			else b %= a;
    }
    return (a == 0 ? b : a);
}

ll ans = 0;

void rec(ll v) {
	if (v == n+1) {
		ll s = 0;
        for (ll i = 1; i <= n; i++) {
            if (mark[i] > 0) s += a[i];
        }
        ans = gcd(ans, s);
        return ;
	}
	rec(v+1);
    for (auto u : nx[v]) mark[u]++;
    rec(v+1);
    for (auto u : nx[v]) mark[u]--;
}

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(100024);

	ll q;
	cin >> q;
    ll time = 100000000 / q;

    for (; q > 0; q--) {
        cin >> n >> m;
        ll g = 0;
        for (ll i = 1; i <= n; i++) cin >> a[i];
        for (ll i = 1; i <= n; i++) g = gcd(g, a[i]);
        for (ll i = 1; i <= n; i++) a[i] /= g;
        for (ll i = 1; i <= n; i++) nx[i].clear();
        for (ll i = 0; i < m; i++) {
			ll x, y;
			cin >> x >> y;
            nx[x].push_back(y);
        }
        ans = 0;
        for (ll i = 1; i <= n; i++) mark[i] = 0;
        rec(1);
        cout << g * ans << endl;
    }

	return 0;
}
