#include <bits/stdc++.h>

//#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

ll gcd(ll a, ll b)
{
    while (a && b)
    {
        a %= b;
        swap(a, b);
    }
    return a + b;
}

signed main()
{
    hello();

    int t;
    cin >> t;
    srand(time(0));
    for (int v = 0; v < t; ++v)
    {
        int n, m;
        cin >> n >> m;
        vector <ll> seq(n);
        for (int i = 0; i < n; ++i)
            cin >> seq[i];

        vector <vector <int>> graph(n);
        for (int i = 0; i < m; ++i)
        {
            int x, y;
            cin >> x >> y;
            graph[x - 1].push_back(y - 1);
        }


        ll res = 0;
        for (int i = 0; i < n; ++i)
        {
            ll cnt = 0;
            for (auto to : graph[i])
                cnt += seq[to];
            res = gcd(res, cnt);
        }
        vector <int> order(n);
        iota(order.B(), order.E(), 0);
        vector <int> used(n, -1);
        for (int u = 0; u < 5500; ++u)
        {
            random_shuffle(order.B(), order.E());
            int maxn = rand() % n;
            ll cnt = 0;

            for (int i = 0; i <= maxn; ++i)
            {
                for (auto to : graph[order[i]])
                    if (used[to] != u)
                    {
                        cnt += seq[to];
                        used[to] = u;
                    }
                res = gcd(res, cnt);
            }
        }

        cout << res << endl;
    }
}
