#include <bits/stdc++.h>
using namespace std;
const int N = 500005;
mt19937 rnd(1431);
long long gcd(long long x, long long y)
{
    if (x == 0)
        return y;
    return gcd(y % x, x);
}

int n, m;
long long u[N];
vector<int> a[N];

int xx[N];
void solv1()
{
    long long ans = 0;
    for (int i = 0; i < n; ++i)
    {
        xx[i] = 0;
        for (int j = 0; j < a[i].size(); ++j)
        {
            int x = a[i][j];
            xx[i] |= (1 << x);
        }
    }
    for (int x = 1; x < (1 << n); ++x)
    {
        int y = 0;
        for (int i = 0; i < n; ++i)
        {
            if ((x & (1 << i)))
                y |= xx[i];
        }
        long long sum = 0;
        for (int i = 0; i < n; ++i)
        {
            if ((y & (1 << i)))
                sum += u[i];
        }
        ans = gcd(ans, sum);
    }
    if (ans == 0)
        printf("1\n");
    else
        printf("%lld\n", ans);
}

bool c[N];
void solv2()
{
    long long ans = 0;
    for (int ii = 0; ii < n; ++ii)
    {
        for (int i = 0; i < n; ++i)
            c[i] = false;
        for (int i = 0; i < n; ++i)
        {
            if ((rnd() % 2 == 0))
            {
                for (int j = 0; j < a[i].size(); ++j)
                    c[a[i][j]] = true;
            }
        }
        long long sum = 0;
        for (int i = 0; i < n; ++i)
        {
            if (c[i])
                sum += u[i];
        }
        ans = gcd(ans, sum);
    }
    if (ans == 0)
        printf("1\n");
    else
        printf("%lld\n", ans);
}

void solv()
{
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; ++i)
        scanf("%lld", &u[i]);
    for (int i = 0; i < n; ++i)
        a[i].clear();
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;
        --y;
        a[x].push_back(y);
    }
    if (n <= 20 && m <= 400)
        solv1();
    else
        solv2();
}

int main()
{
    freopen("input.txt", "r", stdin);
    int tt;
    scanf("%d", &tt);
    while (tt--)
    {
        solv();
    }
    return 0;
}
