#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
using namespace std;
const int max_n = 5e5 + 1;
int n, m;
int f[max_n];

/*
struct sort2 {
    bool operator()(vector<int> &a1, vector<int> &a2) {
        if (a1.size() != a2.size()) return a1.size() < a2.size();
        for(int i = 0;i < a1.size();i++) {
            if (a1[i] != a2[i]) return a1[i] < a2[i];
        }
        return true;
    }
};
*/

map<vector<int>, vector<int>> S;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}






void solve() {
    S.clear();
    cin >> n >> m;

    for(int i = 0;i < n;i++) cin >> f[i];

    vector<vector<int>> temp(n);
    for(int i = 0;i < m;i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        temp[v2].emplace_back(v1);
    }
    for(int i = 0;i < n;i++) {
        sort(temp[i].begin(), temp[i].end());


        if (!temp[i].empty()) {
            temp[i].emplace(temp[i].begin(), temp[i].size());
            S[temp[i]].emplace_back(i);
        }
    }

    int ans = 0;
    for(auto &i : S) {
        int sum = 0;
        for(int j : i.second) {
            sum += f[j];
        }
        ans = gcd(ans, sum);
    }
    cout << ans << '\n';
}


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}