#include<iostream>
#include<vector>
#include<algorithm>
#include<time.h>
#include<random>
#include<string>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 5e5;
vector<ll> MOD = { (ll)1e9 + 7, (ll)1e9 + 9 };
vector<ll> base = { 239, 179 };

ll gcd(ll a, ll b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);
}

vector<vector<ll>> degs(2, vector<ll>(MAXN + 1));

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    degs[0][0] = 1;
    degs[1][0] = 1;
    for (int i = 1; i < sz(degs[0]); ++i) {
        degs[0][i] = (degs[0][i - 1] * base[0]) % MOD[0];
        degs[1][i] = (degs[1][i - 1] * base[1]) % MOD[1];
    }
    int q; cin >> q;

    for (int t = 0; t < q; ++t) {
        int n, m; cin >> n >> m;
        vector<ll> val(n);
        for (int i = 0; i < n; ++i) {
            cin >> val[i];
        }
        vector<vector<ll>> hsh(2, vector<ll>(n, -1));
        for (int i = 0; i < m; ++i) {
            int x, y; cin >> x >> y; x--; y--;
            hsh[0][y] += degs[0][x];
            hsh[0][y] %= MOD[0];
            hsh[1][y] += degs[1][x];
            hsh[1][y] %= MOD[1];
        }
        map<pair<ll, ll>, ll> mp;
        vector<ll> vt;
        set<pair<ll, ll>> st;
        for (int i = 0; i < n; ++i) {
            st.insert({ hsh[0][i], hsh[1][i] });
        }
        vt.resize(st.size(), 0);
        int ind = 0;
        pair<ll, ll> minus = make_pair(-1, -1);
        for (auto pr : st) {
            if (pr == minus) {
                continue;
            }
            mp[pr] = ind;
            ind++;
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            pair<ll, ll> pr = { hsh[0][i], hsh[1][i] };
            if (pr == minus) {
                continue;
            }
            vt[mp[pr]] += val[i];
        }
        for (auto el : vt) {
            ans = gcd(ans, el);
        }
        cout << ans << endl;
    }
    //system("pause");
    return 0;
}