#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector <vector <int>> g;
vector <ll> c;
vector <ll> sums;

void rec(int ind, vector <bool> used, ll cur_sum)
{
    if (ind == g.size())
    {
        sums.push_back(cur_sum);
    }
    else
    {
        rec(ind + 1, used, cur_sum);
        for (int v : g[ind])
            if (!used[v])
            {
                cur_sum += c[v];
                used[v] = true;
            }
        rec(ind + 1, used, cur_sum);
    }
}

ll gcd(ll a, ll b)
{
    while (b != 0)
    {
        ll r = a % b;
        a = b;
        b = r;
    }

    return a;
}

int main()
{
    int t = 0;
    cin >> t;

    while (t--)
    {
        int m = 0, n = 0;
        cin >> n >> m;
        c.resize(n);
        for (int i = 0; i < n; ++i)
            cin >> c[i];

        g.resize(n);
        for (int i = 0; i < m; ++i)
        {
            int u = 0, v = 0;
            cin >> u >> v;
            g[u - 1].push_back(v - 1);
        }

        sums.resize(0);
        rec(0, vector<bool>(n, false), 0);
        ll ans = sums[0];
        for (int i = 1; i < sums.size(); ++i)
            ans = gcd(ans, sums[i]);

        cout << ans << '\n';
    }

    return 0;
}