#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;
const int mod = 1e9 + 7;

int get_bit(int mask, int pos) {
    return (mask & (1 << pos)) != 0;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> c(n);
    rep(i, n) {
        cin >> c[i];
    }
    vector<int> nei(n, 0);
    rep(i, m) {
        int v, to;
        cin >> v >> to;
        v--;
        to--;
        nei[v] |= (1LL << to);
    }
    int ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        int mask_nei = 0;
        rep(i, n){
            if (!get_bit(mask, i)) {
                mask_nei |= nei[i];
            }
        }
        int sum = 0;
        rep(i, n) {
            if (get_bit(mask_nei, i)) sum += c[i];
        }
        if (sum == 0) continue;
        if (ans == 0) {
            ans = sum;
            continue;
        }
        ans = gcd(ans, sum);
    }
    cout << ans << endl;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}