#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 5e3 + 234;
const int M = 1e9 + 7;

pair < int, int > u[N];

vector < int > g[N];

lll c[N];

int e[N][N];

int it = 0;

void solve() {
    ++it;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
        g[i].clear();
    }
    int x, y;
    lll ans = 0;
    lll cur;
    for (int i = 0; i < m; ++i) {
        cin >> x >> y;
        --x;
        --y;
        e[x][y] = it;
        g[x].pb(y);
    }
    for (int i = 0; i < n; ++i) {
        cur = 0;
        for (auto to : g[i]) {
            cur += c[to];
        }
        ans = __gcd(ans, cur);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            cur = 0;
            for (auto to : g[i]) {
                cur += c[to];
            }
            for (auto to : g[j]) {
                if (e[i][to] != it) {
                    cur += c[to];
                }
            }
        }
        ans = __gcd(ans, cur);
    }
    pair < int, int > kek;
    if (n > 20) {
        for (int lol = 0; lol < 20000; ++lol) {
            cur = 0;
            for (int i = 0; i < n; ++i) {
                if (gen() % 2) {
                     for (auto to : g[i]) {
                        kek = {it, lol};
                        if (u[to] != kek) {
                            u[to] = {it, lol};
                            cur += c[to];
                        }
                    }
                }
            }
            ans = __gcd(ans, cur);
        }
    } else {
        for (int mask = 1; mask < (1 << n); ++mask) {
            cur = 0;
            for (int i = 0; i < n; ++i) {
                if ((1 << i) & mask) {
                    for (auto to : g[i]) {
                        kek = {it, mask};
                        if (u[to] != kek) {
                            u[to] = {it, mask};
                            cur += c[to];
                        }
                    }
                }
            }
            ans = __gcd(ans, cur);
        }
    }
    cout << ans << '\n';

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
