#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)

ll gcd(ll a, ll b) {
	if (a < b)swap(a, b);
	while (b > 0) {
		ll c = b;
		b = a % b;
		a = c;
	}
	return a;
}


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n), gr(n);
	vector<ll> w(n), su(n);
	for (int i = 0; i < n; i++)cin >> w[i];
	for (int i = 0; i < m; i++) {
		int from, to;
		cin >> from >> to;
		from--; to--;
		g[from].push_back(to);
		gr[to].push_back(from);
	}
	vector<ll> kk;
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		vector<int> adj;
		vector<int> pw(n);
		int sz = gr[i].size();
		if (sz == 0)continue;
		for (auto u : gr[i])adj.push_back(u);
		for (auto u : adj) {
			for (auto v : g[u])pw[v]++;
		}
		ll cur = 0;
		for (int j = 0; j < n; j++)if (pw[j] == sz)cur += w[j];
		kk.push_back(cur);
	}
	for (int i = 0; i < kk.size(); i++)ans = gcd(ans, kk[i]);
	cout << ans << "\n";
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int q;
	cin >> q;
	while (q--) {
		solve();
	}
}