#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define ll long long

vector <int> t;
vector <int> mod;
void build_tree (int v, int tl, int tr, vector <int> & a)
{
    if (tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr)/2;
        build_tree(v*2, tl, tm, a);
        build_tree(v*2 + 1, tm + 1, tr, a);
        t[v] = t[v*2] + t[v*2 + 1];
    }
}

void push(int v, int tl, int tr)
{
    if (mod[v]!= 0 && v*2 + 1 < t.size())
    {

        mod[v*2] = mod[v*2 + 1] = mod[v];
        mod[v] = 0;
        int tm = (tl + tr)/2;
        t[v*2] = mod[v*2]*(tm - tl + 1);
        t[v*2 + 1] = mod[v*2 + 1]*(tr - tm);
    }
}

int get_sum (int l, int r, int v, int tl, int tr)
{
    if (tl >= l && tr <= r)
        return t[v];
    if (tl > r || tr < l)
        return 0;
    push(v, tl, tr);
    int tm = (tl + tr)/2;
    return get_sum(l, r, v*2, tl, tm) + get_sum(l, r, v*2 + 1, tm + 1, tr);


}

void ass (int l, int r, int v, int tl, int tr, int val)
{
    if (tl >= l && tr <= r)
    {
        mod[v] = val;
        t[v] = (tr - tl + 1)*val;

        return;
    }
    if (tl > r || tr < l)
        return;
    push(v, tl, tr);
    int tm = (tl + tr)/2;

    ass(l, r, v*2, tl, tm, val);
    ass(l, r, v*2 + 1, tm + 1, tr, val);
    t[v] = t[v*2] + t[v*2 + 1];


}

void bfs(vector <vector <int>> & g, int st, int end, vector <int> & p, vector <vector <int>> & path, vector <bool> & used, int num)
{

    used.resize(g.size(), false);
    queue <int> q;
    p[st] = -1;
    used[st] = true;
    q.push(st);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < (int) (g[v].size()); ++i)
        {
            if (used[g[v][i]])
                continue;
            q.push(g[v][i]);
            used[g[v][i]] = true;
            p[g[v][i]] = v;

        }
    }
    int u = end;
    while (1)
    {
        path[num].push_back(u);
        u = p[u];
        if (u == -1)
            break;
    }


}

void dfs(vector <vector <int>> & g,  int v, vector <int> & c)
{
    for (int i = 0; i < (int) (g[v].size()); ++i)
    {
        if (g[v][i] != 1)
            continue;
        if (c[v] >= c[i])
            c[i] = c[v] + 1;
        dfs(g, i, c);
    }


}

ll gcd( ll a, ll b)
{
    if (b == 0)
        return a;
    return gcd(b, a%b);


}

int main() {
   ll trrr;

    cin >> trrr;
    ll n, m;
    vector <ll> st(25, 1);
    for (ll i = 1; i < 25; ++i)
        st[i] = st[i - 1]*2;
    vector <ll> bin;
    vector <ll> c;
    ll u, v;
    while (trrr != 0)
    {
        trrr--;
        cin >> n >> m;
        bin.resize(n, 0);
        c.resize(n);
        for (ll i = 0; i < n; ++i)
            cin >> c[i];
        for (ll i = 0; i < m; ++i)
        {
            cin >> u >> v;
            u--;
            v--;
            bin[u] += st[v];
        }

        ll ans = 0;
        for (ll num = 1; num < (ll) (pow(2, n)); num++)
        {
            ll zap = 0;
            ll id = 0;
            ll ch = num;
            while (ch!= 0)
            {
                if (ch%2== 1)
                {

                    zap = zap | bin[id];

                }
                ch/=2;
                id++;
            }
            if (zap == 0)
                continue;
            id = 0;
            ll it = 0;
            while (zap != 0)
            {
                if (zap%2== 1)
                {
                    it+=c[id];

                }
                zap/=2;
                id++;
            }
            if (it == 0)
                continue;
            if (ans == 0)
                ans = it;
            else
                ans = gcd(ans, it);

        }



        cout << ans << endl;
    }




   return 0;
}
