#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>

#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<ull> vecll;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

int gcd(int a, int b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vecll a(n);
		for (int i = 0; i < n; i++)
			cin >> a[i];
		vector<list<int>> g(n);
		for (int i = 0; i < m; i++) {
			int fr, to;
			cin >> fr >> to;
			g[--fr].eb(--to);
		}
		ull res = 0;
		for (int i = 1; i < (1 << n); i++) {
			ull sum = 0;
			vecb used(n);
			for (int j = 0; j < n; j++)
				if ((i >> j) & 1) {
					for (int k : g[j])
						if (!used[k]) {
							sum += a[k];
							used[k] = true;
						}
				}
			res = gcd(res, sum);
		}
		cout << res << "\n";
	}

	return 0;
}
