#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
//    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 10;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
//    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

const int MAXN = 25;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int n, m; // вершины левой доли - 0 ... n - 1, правой - n ... 2n - 1
vector<vector<int>> g;
int c[MAXN];
int used[MAXN];

int count(int mask) {
    for (int i = 0; i < n; i++) {
        if ((mask >> i) & 1) {
            for (auto u : g[i]) {
                used[u - n] = 1;
            }
        }
    }
    int sum = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) sum += c[i];
        used[i] = 0;
    }
    return sum;
}

void tryhard() {
    int ans = count(1);
    for (int mask = 2; mask < (1 << n); mask++) {
        ans = gcd(ans, count(mask));
    }
    cout << ans << "\n";
}

void solve() {
    cin >> n >> m;
    g.resize(n + n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    int u, v;
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        u--, v--;
        g[u].pb(n + v);
        g[n + v].pb(u);
    }
    tryhard();
    g.clear();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) solve();
}
/*
сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
