#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <deque>
#include <cassert>
#include <cmath>


#define x first
#define y second
#define int long long


typedef long long ll;
typedef long double ld;

using namespace std;



#pragma GCC target("sse", "sse2", "sse3", "avx")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n, m, u, v;
        cin >> n >> m;
        vector<vector<int>> g(n);
        vector<long long> w(n);
        for (int i = 0; i < n; i++)
            cin >> w[i];
        for (int i = 0; i < m; i++) {
            cin >> u >> v;
            u--;
            v--;
            g[u].push_back(v);
        }
        sort(g.begin(), g.end());
        g.resize(unique(g.begin(), g.end()) - g.begin());
        long long cur = 0;
        for (int mask = 0; mask < (1 << (g.size())); ++mask) {
            vector<bool> used(g.size());
            for (int j = 0; j < g.size(); j++) {
                if ((mask >> j) & 1)
                    for (int u : g[j])
                        used[u] = 1;
            }
            long long cc = 0;
            for (int i = 0; i < n; i++) {
                if (used[i])
                    cc += w[i];
            }
            cur = __gcd(cur, cc);
            if (cur == 1)
                break;
        }
        cout << cur << '\n';
    }
	return 0;
}
