#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define int long long

using namespace std;

const int N = 5e5 + 7, B1 = N, B2 = N + 3, M1 = 1e12 + 3, M2 = 1e11 + 7;
vector <int> g[N];
map <pair <int, int>, int> summ;
int c[N];

void solve() {
    int n, m;
    cin >> n >> m;
    summ.clear();
    int res = -1;
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        g[u].push_back(v);
    }
    for (int i = 1; i <= n; i++) {
        sort(g[i].begin(), g[i].end());
        if (!g[i].empty()) {
            int h1 = 0, h2 = 0;
            for (int elem : g[i]) {
                h1 *= B1;
                h2 *= B2;
                h1 += elem;
                h2 += elem;
                h1 %= M1;
                h2 %= M2;
            }
            summ[make_pair(h1, h2)] += c[i];
        }
    }
    for (auto elem : summ) {
        if (res == -1) res = elem.second;
        res = __gcd(res, elem.second);
    }
    cout << res << endl;
}

signed main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
