#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 
mt19937 rng(time(NULL));

vector<int> g[maxn], gr[maxn];
bool u[maxn];
ll c[maxn];

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) cin >> c[i];
		for (int i = 0; i < n; ++i) {
			g[i].clear();
			gr[i].clear();
		}
		for (int i = 0; i < m; ++i) {
			int a, b;
			cin >> a >> b;
			a--; b--;
			g[a].push_back(b);
			gr[b].push_back(a);
		}
		vector<ll> d(n);
		for (int i = 0; i < n; ++i) {
			for (int j : g[i]) d[i] += c[j];
		}
		ll ans = 0;
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < n; ++j) u[j] = 0;
			ll cur = 0;
			for (int j : gr[i]) {
				for (int h : g[j]) {
					if (!u[h]) {
						u[h] = 1;
						cur += c[h];
					}
				}
			}
			ans = gcd(ans, cur);
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				set<int> js;
				for (int h : g[i]) js.insert(h);
				for (int h : g[j]) js.insert(h);
				ll sm = 0;
				for (int h : js) sm += c[h];
				ans = gcd(ans, sm);
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				for (int j2 = j + 1; j2 < n; ++j2) {
					set<int> js;
					for (int h : g[i]) js.insert(h);
					for (int h : g[j]) js.insert(h);
					for (int h : g[j2]) js.insert(h);
					ll sm = 0;
					for (int h : js) sm += c[h];
					ans = gcd(ans, sm);
				}
			}
		}
		for (int i = 0; i < n; ++i) ans = gcd(ans, d[i]);
		cout << ans << "\n";
	}


	return 0;
}