#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

int n, m;

void solve() {
    cin >> n >> m;
    vector<set<ll> > S(n + 1);
    vector<ll> c(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        S[u].insert(v);
    }
    ll ans = 0;
    for (int i = 0; i < (1LL << (n + 1)); ++i) {
        ll s = 0;
        set<ll> ss;
        for (int j = 0; j < 20; ++j) {
            if ((i >> j) & 1) {
                for (ll num : S[j]) {
                    ss.insert(num);
                }
            }
        }
        for (ll num : ss) {
            s += c[num];
        }

        ans = gcd(ans, s);
    }
    cout << ans << '\n';
}

int main() {
//    freopen("input.in", "r", stdin);
//    freopen("output.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
}