#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5003;

bitset <maxn> bs[maxn];
ll c[maxn];

vector <vector <int> > cur;
vector <vector <int> > nw;

void source() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        bs[i].reset();
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        bs[v][u] = true;
    }
    cur.clear();
    cur.push_back(vector <int> ());
    for (int i = 0; i < n; i++) {
        cur.back().push_back(i);
    }
    ll res = 0;
    for (int i = 0; i < n; i++) {
        nw.clear();
        for (int j = 0; j < cur.size(); j++) {
            if (cur[j].empty())
                continue;
            nw.push_back(vector <int> ());
            ll csum = 0;
            for (int t : cur[j]) {
                if (bs[i][t]) {
                    csum += c[t];
                    nw.back().push_back(t);
                }
            }
            res = __gcd(res, csum);
            nw.push_back(vector <int> ());
            for (int t : cur[j]) {
                if (!bs[i][t]) {
                    nw.back().push_back(t);
                }
            }
        }
        cur = nw;
    }
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int T;
    cin >> T;
    for (int i = 0; i < T; i++) {
        source();
    }
    return 0;
}
