#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18, P = 1e9 + 7, X = 2007;
const ld EPS = 1e-9;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> c(n);
        vector<vector<int> > g(n);
        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g[v].pb(u);
        }
        int G = 0;
        vector<int> used_r(n);
        for (int i = 0; i < n; i++) {
            int sum = 0;
            for (int u : g[i]) {
                sum += c[u];
                used_r[u] = 1;
            }
            G = gcd(G, sum);
        }
        int sum_all = 0;
        for (int i = 0; i < n; i++) {
            if (used_r[i]) {
                sum_all += c[i];
            }
        }
        G = gcd(sum_all, G);
        //continue;
       // cout << CLOCKS_PER_SEC << "\n";
        int M = (1 << n), st = time(0);
        for (int mask = 0; mask < M; mask++) {
            if ((ld)clock() / CLOCKS_PER_SEC > 1.99) {
                break;
            }
            if (G == 1) {
                break;
            }
            int sum = 0;
            vector<int> used(n);
            for (int i = 0; i < n; i++) {
                if ((1 << i) & mask) {
                    for (int u : g[i]) {
                        used[u] = 1;
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                if (used[i]) {
                    sum += c[i];
                }
            }
            if (G == -1) {
                G = sum;
            } else {
                G = gcd(G, sum);
            }
        }
        //cout << clock() << "\n";
        cout << G << "\n";
    }
    return 0;
}
