#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<deque>
#include<set>
#include<map>
#include<random>
#include<tuple>
#include<cassert>
#include<bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

mt19937 gen(313);
uniform_int_distribution <int> rand_int(1, 1000000000);

const int N = 5007;

int c[N];
set <int> g[N];
map <set <int>, vector<int> > ask;
vector <pair <bitset<N>, int> > sz[N];

int gcd(int a, int b) {
	while (b > 0) {
		a %= b; swap(a, b);
	}
	return a;
}

void clean(int n) {
	loop1(i, n) {
		g[i].clear();
		sz[i].clear();
		c[i] = 0;
	}
	ask.clear();
}

void solve() {
	int n, m; cin >> n >> m;
	loop1(i, n) cin >> c[i];
	loop(i, m) {
		int u, v; cin >> u >> v;
		g[v].insert(u);
	}
	int sum = 0, ans;
	loop1(v, n)
		if (g[v].size() > 0) {
			sum += c[v];
			ask[g[v]].pb(v);
		}
	ans = sum;
	/*for (auto it : ask) {
	cout << "{";
	for (int c : it.F) cout << c << ",";
	cout << "} : {";
	for (int c : it.S) cout << c << ",";
	cout << "}\n";
    }*/
	for (auto it : ask) {
		bitset<N> b(0);
		int d = 0;
		for (int x : it.F) b[x] = 1;
		for (int x : it.S) d += c[x];
		sz[it.F.size()].pb({b, d});
	}
	loop1(len, n - 1)
		for (auto px : sz[len]) {
			//cout << ans << " " << sum - px.second << "\n";
			//cout << len << " " << px.F[1] << px.F[2] << px.F[3] << px.F[4] << " " << px.S << "\n";
			ans = gcd(ans, sum - px.S);
			for (int nlen = len + 1; nlen < n; ++nlen)
				loop(i, sz[nlen].size())
				    if ((sz[nlen][i].F & px.F) == px.F)
					    sz[nlen][i].S += px.S;
		}
	cout << ans << "\n";
	clean(n);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t; cin >> t; loop(i, t)
	solve();
	return 0;
}
