#pragma GCC optimize("Ofast")

#include <algorithm>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long

const int p = 26537;
const int mod = (int)1e9 + 7;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	cin >> t;
	/*
	vector<ll> c;
	while (t--)
	{
		int g[20] = {};
		ll c[20] = {};

		int n = 0, m = 0;
		cin >> n >> m;

		for (int i = 0; i < n; ++i)
			cin >> c[i];

		int u = 0, v = 0;
		for (int i = 0; i < m; ++i)
		{
			cin >> u >> v;
			g[u - 1] |= (1 << (v - 1));
		}

		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask)
		{
			int used = 0;
			for (int i = 0; i < n; ++i)
				if (mask & (1 << i))
					used |= g[i];
			
			ll sum = 0;
			for (int i = 0; i < n; ++i)
				if (used & (1 << i))
					sum += c[i];

			ans = gcd(ans, sum);
		}

		cout << ans << "\n";
	}*/

	while (t--)
	{
		int n = 0, m = 0;
		cin >> n >> m;

		vector<int> c(n);
		vector<set<int>> g(n);

		for (int i = 0; i < n; ++i)
			cin >> c[i];

		int u = 0, v = 0;
		for (int i = 0; i < m; ++i)
		{
			cin >> u >> v;
			g[v - 1].insert(u - 1);
		}

		map<int, int> mp;
		for (int i = 0; i < n; ++i)
		{
			int h = 0;
			for (auto x : g[i])
				h = (h * p + x + 1) % mod;
			mp[h] += c[i];
		}

		int ans = 0;
		for (auto [h, x] : mp)
			if (h) ans = gcd(ans, x);

		cout << ans << "\n";
	}

	return 0;
}