// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define ld long double
#define left left228
#define right right228

const int N = 500 * 1000 + 228;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int adj[30], c[N];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		adj[i] = 0;
	}
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		adj[u] |= (1 << v);
	}
	int ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {	
		int sos = (1 << n) - 1;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				sos &= adj[i];
			}
		}
		int sum = 0;
		for (int i = 0; i < n; ++i) {
			if ((sos >> i) & 1) {
				sum += c[i];
			}
		}
		ans = gcd(ans, sum);
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while(t--) {
		solve();
	}
	return 0;
}

/*

3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

*/