#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <math.h>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<ll> c(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    ll G = 0;
    vector<vector<int> > graph(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        graph[u - 1].push_back(v - 1);
    }
    for (int i = 0; i < n; i++) {
        sort(graph[i].begin(), graph[i].end());
        
    }
    for (int i = 0; i < n; i++) {
        vector<bool> good(n);
        for (int v : graph[i])
            good[v] = 1;
        for (int j = 0; j < n; j++) {
            ll S = 0;
            for (int v : graph[j]) {
                if (good[v])
                    S += c[v];
            }
            G = gcd(G, S);
        }
    }
    cout << G << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int ij = 0; ij < t; ij++) {
        solve();
    }
}
//*/