#include<bits/stdc++.h>
using namespace std;
const int nmax=1e6+42,SZ=4;
/*
const int mod_1=1000003,mod_2=30000001,mod_3=500000003,mod_4=1100000009;
const int base_1=31,base_2=47,base_3=101,base_4=257;
*/
const int mod[4]={1000003,30000001,500000003,1100000009};
const int base[4]={31,47,101,257};

int n,m;
long long costs[nmax];

long long total[nmax];

vector<int> adj[nmax];



struct arr
{
    int hsh[SZ];
    int id;
};
arr work[nmax];

void create(int i)
{
    work[i].id=i;
    for(int h=0;h<SZ;h++)
    {
        long long help=0;
        for(auto k:adj[i])
            help=(help*base[h]+k)%mod[h];

        //cout<<i<<" "<<h<<" -> "<<help<<endl;
        work[i].hsh[h]=help;
    }
}

bool cmp(arr s,arr t)
{
    for(int i=0;i<SZ;i++)
        if(s.hsh[i]!=t.hsh[i])return s.hsh[i]<t.hsh[i];
    return s.id<t.id;
}
bool eq(int i,int j)
{
    for(int p=0;p<SZ;p++)
        if(work[i].hsh[p]!=work[j].hsh[p])return 0;
    return 1;
}
long long query()
{

    scanf("%i%i",&n,&m);
    for(int i=1;i<=n;i++)
    {
        scanf("%lld",&costs[i]);
        adj[i]={};
        total[i]=0;
    }
    int u,v;
    for(int i=1;i<=m;i++)
    {
        scanf("%i%i",&u,&v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=n;i++)
        sort(adj[i].begin(),adj[i].end());

    for(int i=1;i<=n;i++)
        create(i);

    sort(work+1,work+n+1,cmp);

    for(int i=1;i<=n;i++)
    {
        int j=i;

        int mini=n;
        long long sum=0;

        while(j<=n&&eq(i,j))
        {
            mini=min(mini,work[j].id);
            sum=sum+costs[work[j].id];
            j++;
        }

        total[mini]+=sum;

        i=j-1;
    }

    long long g=0;
    for(int i=1;i<=n;i++)
        if(adj[i].size())g=__gcd(g,total[i]);
    return g;
}

int main()
{
    int t;
    scanf("%i",&t);

    for(int i=1;i<=t;i++)
        printf("%lld\n",query());
    return 0;
}
/*
3
2 4
1 1
1 1
1 2
2 1
2 2
3 4
1 1 1
1 1
1 2
2 2
2 3
4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

100
2 1
1000 17
1 1
4 4
5 7 9 11
1 1
1 2
3 3
3 4
1 1
1000000000000
1 1

1000
3 3
10 20 30
1 1
1 2
1 3
*/