#include<iostream>
#include<algorithm>
#include<vector>
#include<cmath>
#include<set>
#include<map>
#include<ctime>
#include<assert.h>
#include <chrono>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#define speed ios_base::sync_with_stdio(false); cout.tie(nullptr); cout.tie(nullptr);
#define ll long long

using namespace std;

long long gcd(long long a, long long b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

int dfs(int v, int n, const vector<vector<int>> &g, const vector<long long> &c, vector<int> &used) {
	used[v] = 1;
	int ans = 0;
	if (v <= n) {
		ans += c[v];
	}
	for (auto u : g[v]) {
		if (!used[u]) {
			ans += dfs(u, n, g, c, used);
		}
	}
	return ans;
}

int main() {
	//auto start = std::chrono::system_clock::now();
	speed;
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		int n, m;
		cin >> n >> m;
		vector<long long> c(n + 1);
		long long sum = 0;
		for (int i = 1; i <= n; ++i) {
			cin >> c[i];
		}
		vector<int> used(2 * n + 2, 0);
		vector<vector<int>> g(n + n + 2, vector<int>());
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			if (used[v] == 0) {
				sum += c[v];
				used[v] = 1;
			}
			g[n + u].push_back(v);
			g[v].push_back(n + u);
		}
		used.assign(2 * n + 2, 0);
		//char t;
		//cin >> t;
		vector<long long> comp;
		vector<long long> comp1;
		bool flag = false;
		for (int i = 1; i <= n; ++i) {
			int temp = 0;
			if (!used[i]) {
				comp1.push_back(dfs(i, n, g, c, used));
			}
			for (auto u : g[n + i]) {
				temp += c[u];
			}
			if (temp != 0) {
				comp.push_back(temp);
			}
		}
		if (flag) {
			cout << 1 << endl;
		}
		else {
			ll gg = comp[0];
			for (int i = 1; i < comp.size() && gg != 1; ++i) {
				gg = gcd(gg, comp[i]);
			}
			gg = gcd(gg, sum);
			for (int i = 1; i < (1 << comp1.size()) && gg != 1; ++i) {
				int temp = 0;
				for (int j = comp1.size() - 1; j >= 0; --j) {
					if (((i >> j) & 1) == 1) {
						temp += comp1[comp1.size() - j - 1];
					}
				}
				//cout << temp << " ";
				gg = gcd(gg, temp);
			}
			cout << gg << endl;
		}
	}
	return 0;
}