#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
#include <bitset>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

//mt19937_64 rng(228);

ll ggcd(ll x, ll y) {
    if (x == 0) return y;
    if (y == 0) return x;
    return ggcd(y, x % y);
}

using BS = bitset<5000>;

void _tmain([[maybe_unused]] int test_id) {
    int test_case_cnt;
    cin >> test_case_cnt;
    while (test_case_cnt--) {
        int n, m;
        cin >> n >> m;
        vector<ll> cost(n);
        for (ll &x : cost) { cin >> x; }
        // vector<BS> g(n);
        vector<BS> gr(n);
        for (int _i = 0; _i < m; ++_i) {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            //g[u][v] = true;
            gr[v][u] = true;
        }
        ll ans = 0;
        /* for (int i = 0; i < n; ++i) {
             BS x = g[i];
             int k = masks.size();
             for (int j = 0; j < k; ++j) {
                 BS per = masks[j] & x;
                 if (per == 0) {
                     continue;
                 }
                 masks[j] ^= per;
                 x ^= per;
                 masks.push_back(per);
             }
             if (x.any()) {
                 masks.push_back(x);
             }
         }*/

        unordered_map<BS, vector<int>> mp;
        for (int j = 0; j < n; ++j) {
            mp[gr[j]].push_back(j);
        }

        int cntr = 0;
        for (auto[_, mask] :mp) {
            ll res = 0;
            for (int j: mask) {
             //   if (mask[j]) {
                    //assert(cls[j] == -1);
                    // cls[j] = cntr;
                    res += cost[j];
               // }
            }
            ans = ggcd(ans, res);
            ++cntr;
        }
        /*for (int j1 = 0; j1 < n; ++j1) {
            for (int j2 = 0; j2 < n; ++j2) {
                if (cls[j1] == cls[j2]) {
                    assert(gr[j1] == gr[j2]);
                } else {
                    assert(gr[j1] != gr[j2]);
                }
            }
        }*/
        cout << ans << "\n";
    }
}