//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

int n, m;
vector<ll> c;
vector<vector<int>> g, reg;

void run() {
	c.clear();
	g.clear();
	cin >> n >> m; c.resize(n); cin >> c;	
	g.resize(n); reg.resize(n);
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--; b--;
		reg[b].pb(a);
		g[a].pb(b);
	}
	ll rez = 0;
	for (int i = 0; i < n; i++) {
		vector<int> un;
		for (int j : reg[i]) {
			un.insert(un.end(), g[j].begin(), g[j].end());
		}
		sort(un.begin(), un.end());
		un.resize(unique(un.begin(), un.end()) - un.begin());
		ll S = 0;
		for (int id : un) {
			S += c[id];
		}
		rez = __gcd(rez, S);
	}
	cout << rez << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	int tests; cin >> tests;
	for (int test = 0; test < tests; test++)
		run();
}