#include <bits/stdc++.h>

using namespace std;

long long gcd(long long a, long long b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> rebs(n);
    vector<long long> costs(n);
    for (int i = 0; i < n; ++i)
        cin >> costs[i];
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        rebs[a] += (1 << b);
    }
    long long ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        int res = 0;
        for (int i = 0; i < n; ++i)
            if (mask & (1 << i))
                res |= rebs[i];
        long long sum = 0;
        for (int i = 0; i < n; ++i)
            if (res & (1 << i))
                sum += costs[i];
        ans = gcd(ans, sum);
    }
    cout << ans << '\n';
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
