#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 5e2 + 2;
const lll M = 1e18 + 7;

int a[2100][2100];

const int SZ = 95 * 95;

unordered_set < int > now;

int calc1[N][N], calc2[N][N];

lll cnt[N * N];

lll pref1[N][N];

lll pref2[N][N];

lll get1(int l, int r, int i) {
    lll ans = pref1[r][i];
    if (l) {
        ans -= pref1[l - 1][i];
        ans += M;
        ans %= M;
    }
    return ans;
}

lll get2(int l, int r, int i) {
    lll ans = pref2[i][r];
    if (l) {
        ans -= pref2[i][l - 1];
        ans += M;
        ans %= M;
    }
    return ans;
}

int main() {
    for (int i = 0; i < N * N; ++i) {
        cnt[i] = gen();
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    string s;
    int c;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (int j = 0; j < m; ++j) {
            c = int(s[j * 2]) - 33;
            c *= 100;
            c += int(s[j * 2 + 1]) - 33;
            a[i][j] = c;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pref1[i][j] = cnt[a[i][j]];
            if (i) {
                pref1[i][j] = (pref1[i][j] + pref1[i - 1][j]) % M;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pref2[i][j] = cnt[a[i][j]];
            if (j) {
                pref2[i][j] = (pref2[i][j] + pref2[i][j - 1]) % M;
            }
        }
    }
    int ans = 0;
    for (int sz = 1; sz < min(min(n, m), SZ); ++sz) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                calc1[i][j] = 1;
                calc2[i][j] = 1;
                if (i >= sz - 1 && j) {
                    if (get1(i - sz + 1, i, j) == get1(i - sz + 1, i, j - 1)) {
                        calc1[i][j] = calc1[i][j - 1] + 1;
                    }
                }
                if (j >= sz - 1 && i) {
                    if (get2(j - sz + 1, j, i) == get2(j - sz + 1, j, i - 1)) {
                        calc2[i][j] = calc2[i - 1][j] + 1;
                    }
                }
            }
        }
        for (int i = sz - 1; i < n; ++i) {
            for (int j = sz - 1; j < m; ++j) {
                if (calc1[i][j] >= sz && calc2[i][j] >= sz) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
