#include <iostream>
#include <vector>
using namespace std;

int t;

long long int NOD(long long int a, long long int b) {
    if (a < b) {
        swap(a, b);
    }

    if (b == 0) {
        return a;
    }

    while (a % b != 0) {
        long long int y = b;
        b = a % b;
        a = y;
    }

    return b;
}

int main()
{
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n, m;
        cin >> n >> m;
        vector <long long int> mas(n + 1), sums(n + 1), gg(n + 1);
        for (int j = 1; j <= n; j++) {
            long long int c;
            cin >> c;

            mas[j] = c;
        }
        
        for (int j = 1; j <= m; j++) {
            long long int a, b;
            cin >> a >> b;

            sums[a] += mas[b];
            gg[b] = 1;
        }

        for (int j = 1; j <= n; j++) {
            if (gg[j] == 1) {
                sums[0] += mas[j];
            }      
        }

        long long int del = sums[0];
        for (int i = 1; i <= n; i++) {
            del = NOD(del, sums[i]);
        }

        cout << del << endl;
    }
}