#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <ctime>

#define int long long
#define gcd __gcd

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector <int> price(n);
    for (int& i : price)
        cin >> i;

    vector <vector <int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
    }

    int ans = 0;
    for (int mask = 0; mask < (1 << n) && clock() / CLOCKS_PER_SEC < 1.99; mask++) {
        set <int> take;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                for (int j : g[i])
                    take.insert(j);
            }
        }
        int sm = 0;
        for (int i : take) {
            sm += price[i];
        }
        ans = gcd(ans, sm);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
