#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

#define int ll
const int N = 510'000;
vector<int> f[N], q[N];
bool operator <(const vector<int> &a, const vector<int> &b) {
    forn(i, (int)a.size() - 1) {
        if (a[i] != b[i]) return a[i] < b[i];
    }
    return false;
}
inline bool diff(const vector<int> &a, const vector<int> &b) {
    forn(i, (int)a.size() - 1) {
        if (a[i] != b[i]) return false;
    }
    return true;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        forn(i, n) {
            f[i].clear();
            q[i].clear();
            q[i].push_back(0);
        }
        vector<ll> c(n);
        forn(i, n) cin >> c[i];
        forn(i, m) {
            int v, u;
            cin >> v >> u;
            v--; u--;
            q[u][0]++;
            f[v].push_back(u);
        }
        forn(i, n)
            for (auto to : f[i])
                q[to].push_back(i);
        forn(i, n) q[i].push_back(c[i]);
        int ans = 0;
        sort(q, q + n);
        int tmp = 0;
        forn(i, n) {
            if (i > 0 && !diff(q[i - 1], q[i])) {
                if (q[i - 1][0] > 0)
                    ans = __gcd(ans, tmp);
                tmp = 0;
            }
            tmp += q[i].back();
        }
        if (q[n - 1][0] > 0)
            ans = __gcd(ans, tmp);
        cout << ans << el;
    }
    return 0;
}
#endif