#include<bits/stdc++.h>
using namespace std;

#define int long long
const int M1 = 1e9 + 7, M2 = 1e9 + 9, P = 533131;

#define x first
#define y second

#define all(a) (a).begin(), (a).end()


pair<int, int> get(vector<int> a) {
    pair<int, int> res = {0, 0};
    for (auto el : a) {
        res.x = (res.x * P + el) % M1;
        res.y = (res.y * P + el) % M2;
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> c(n);
    for (int i = 0; i < n; i++) cin >> c[i];
    vector<vector<int>> g(m);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[u].push_back(v);
    }
    map<pair<int, int>, int> ma;
    for (int i = 0; i < n; i++) {
        sort(all(g[i]));
        ma[get(g[i])] += c[i];
    }
    int ans = 0;
    for (auto el : ma) ans = __gcd(ans, el.y);
    cout << ans << '\n';
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests;
    cin >> tests;
    while (tests--) solve();
    return 0;
}
