
#include<bits/stdc++.h>

#define int long long
#define all(x) begin(x), end(x)
#define x first
#define y second

using namespace std;

void fast() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

const int MAXN = 5e5 + 10;
const int MAXLOG = 20;

vector<int> c;
vector<vector<int>> g;

void solve() {
    int n, m;
    cin >> n >> m;
    c.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> c[i];
    }
    g.resize(n, vector<int>());
    for(int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
    }
    int ans = -1;
    for(int mask = 0; mask < (1 << n); mask++) {
        vector<bool> used(n);
        for(int i = 0; i < n; i++) {
            if(((mask >> i) & 1)) {
                for(int j = 0; j < g[i].size(); j++) {
                    used[g[i][j]] = 1;
                }
            }
        }
        int sum = 0;
        for(int i = 0; i < n; i++) {
            if(used[i]) {
                sum += c[i];
            }
        }
        if(ans == -1) {
            ans = sum;
        }
        else {
            ans = __gcd(ans, sum);
        }
    }
    cout << ans << '\n';
}

signed main() {
    fast();
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
