#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 5010;

vector<int> graph[2 * N];
int c[2 * N];
int col[2 * N];
bool con[2 * N][2 * N];

long long gcd(long long x, long long y)
{
    if (x == 0) return y;
    if (y == 0) return x;
    return __gcd(x, y);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        cin >> c[i + n];
    }
    for (int i = 0; i < m; i++)
    {
        int v, u;
        cin >> v >> u;
        v--, u = u - 1 + n;
        graph[v].push_back(u);
        graph[u].push_back(v);
        con[v][u] = 1;
        con[u][v] = 1;
    }
    long long g = 0;
    for (int i = 0; i < n; i++)
    {
        for (auto u : graph[i]) c[i] += c[u];
    }
    for (int i = 0; i < n; i++)
    {
        g = gcd(g, c[i]);
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = i; j < n; j++)
        {
            c[j] += c[j - 1];
            for (auto v : graph[j])
            {
                if (con[v][j - i]) c[j] -= c[v];
            }
            g = gcd(g, c[j]);
        }
    }
    cout << g << "\n";
    for (int i = 0; i < 2 * n; i++) for (int j = 0; j < 2 * n; j++) con[i][j] = 0;
    for (int i = 0; i < 2 * n; i++)
    {
        c[i] = 0;
        col[i] = 0;
        while (graph[i].size()) graph[i].pop_back();
    }
}


signed main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}

/*
3
1 93 45
*/
