#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
//comments
/*
	1) 
*/

int gcd(int a, int b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

int globalgcd = 0;

void sol()
{
	int n, m;
	cin >> n >> m;
	globalgcd = 0;
	vector<vector<int>> g(n + 1, vector<int>(n + 1));
	vector<int> cost(n + 1);
	for (long long i = 1; i <= n; ++i)
		cin >> cost[i];

	for (long long i = 0; i < m; ++i)	
	{
		int x, y;
		cin >> x >> y;
		g[x][y] = 1;
	}

	for (long long mask = 0; mask < (1 << n); ++mask)
	{
		int temp = 0;
		vector<int> ver;
		for (long long submask = 0; submask <= n; ++submask)
		{
			if ((1 << submask) & mask)
				ver.push_back(submask + 1);
		}

		if (ver.size())
		{
			set<int> s;
			for (long long i = 0; i < ver.size(); ++i)
			{
				int u = ver[i];
				for (long long j = 1; j <= n; ++j)
					if (g[u][j] == 1)
						s.insert(j);
			}

			for (auto &u : s)
				temp += cost[u];
			globalgcd = gcd(globalgcd, temp);
		}
	}
	cout << globalgcd << nl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	freopen("input.txt", "r", stdin);
	
	
	int t;
	cin >> t;

	string s;
	while (t--) { sol(); getline(cin, s); getline(cin, s); };

	return 0;
}