#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG
#define int long long

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 5e5;

unordered_set <int> gr[MAXN];

int bit(int mask, int i) {
	return ((mask >> i) & 1);
}

bool is_in(int mask, int submask) {
	return ((mask & submask) == submask);
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> c(n);
	for (int& i : c) {
		cin >> i;
	}
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		gr[a].insert(b);
	}

	vector <int> sum(n);
	for (int i = 0; i < n; ++i) {
		for (int to : gr[i]) {
			sum[i] += c[to];
		}
	}
	int ans = sum[0];
	for (int i = 0; i < n; ++i) {
		ans = __gcd(ans, sum[i]);
		for (int j = i + 1; j < n; ++j) {
			unordered_set <int> cur = gr[i];
			for (int k : gr[j]) {
				cur.insert(k);
			}
			int ssss = 0;
			for (int k : cur) {
				ssss += c[k];
			}
			// cout << ssss << "\n";
			ans = __gcd(ans, ssss);
		}
	}
	cout << ans << "\n";
	return;

	vector <int> mask_on(n); // for left
	for (int i = 0; i < n; ++i) {
		int mask = 0;
		for (int j : gr[i]) {
			mask |= 1 << j;
		}
		mask_on[i] = mask;
	}	

	int g = -1;
	for (int mask = 1; mask < (1 << n); ++mask) { // for right
		int maskk = 0;
		for (int i = 0; i < n; ++i) {
			if (is_in(mask, mask_on[i])) {
				maskk |= mask_on[i];
			}
		}
		if (maskk == mask) {
			int s = 0;
			for (int i = 0; i < n; ++i) {
				if (bit(mask, i)) {
					s += c[i];
				}
			}
			if (g == -1) {
				g = s;
			} else {
				g = __gcd(g, s);
			}
		}
	}
	cout << g << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		cin >> t;
		// t = 2;
	#else
		cin >> t;
		// t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}