#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <string>
#include <set>

typedef long long ll;

using namespace std;

ll gcd(ll a, ll b){
    if(b == 0) return a;
    return gcd(b, a%b);
}

int main() {
    int t;
    cin >> t;
    while(t--) {
        int n = 0, m = 0;
        cin >> n >> m;
        vector<int> g(21);
        vector<ll> c(21);
        for(int i = 0; i < n; i++){
            cin >> c[i];
        }
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[a] |= (1 << b);
        }
        ll gc = 0;
        vector<bool> used(21);
        int a = (1 << n);
        for(int i = 0; i < a; i++){
            for(int j = 0; j < n; j++){
                used[j] = false;
            }
            ll sum = 0;
            ll cur = 0;
            for(int j = 0; j < n; j++){
                if(i & (1 << j)){
                    cur |= g[j];
                }
            }
            for(int j = 0; j < n; j++){
                if(cur & (1 << j)){
                    sum += c[j];
                }
            }
            gc = gcd(max(gc, sum), min(gc, sum));
        }
        cout << gc << endl;
    }
    return 0;
}