#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int K = 20;
const int N = (1 << K);
ll c[K];
int sosed[K];
bool dp[N];

signed main() {
	FAST_IO();
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		fill(sosed, sosed + n, 0);
		for (int i = 0; i < m; ++i) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			sosed[u] |= (1 << v);
		}
		fill(dp, dp + (1 << n), false);
		dp[0] = true;
		ll g = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			for (int i = 0; i < n; ++i) {
				dp[mask | sosed[i]] |= dp[mask];
			}
			if (dp[mask]) {
				ll s = 0;
				for (int i = 0; i < n; ++i) {
					if (mask & (1 << i)) {
						s += c[i];
					}
				}
				g = __gcd(g, s);
			}
		}
		cout << g << '\n';
	}
}