#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

ll gcd(ll a, ll b) {
	if (min(a, b) == 0) return (max(a, b));
	if (a % b == 0) return b;
	return gcd(b, a % b);
}

int main() {
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector <vector <ll>> g(n);
		vector <ll> a(n);
		for (ll i = 0; i < n; i++)
			cin >> a[i];
		for (ll i = 0; i < m; i++) {
			ll u, v;
			cin >> u >> v;
			u--;
			v--;
			g[u].push_back(v);
		}
		ll x = 0;
		for (ll mask = 1; mask < (1 << n); mask++) {
			vector <bool> tf(n);
			ll copy_mask = mask;
			for (ll i = 0; i < n; i++) {
				tf[i] = copy_mask % 2;
				copy_mask /= 2;
			}
			vector <bool> used(n);
			for (ll i = 0; i < n; i++)
				if (tf[i])
					for (ll v : g[i])
						used[v] = true;
			ll sum = 0;
			for (ll i = 0; i < n; i++)
				sum += (a[i] * used[i]);
			x = gcd(x, sum);
		}
		cout << x << endl;
	}
	return 0;
}

/*
3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

*/