#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second
#define pb emplace_back
#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, ve<ll> &a) {
	for (auto &i : a) in >> i;
	return in;
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vvi g(n);
		ve<ll> cost(n);
		cin >> cost;
		int u, v;
		for (int i = 0; i < m; ++i) {
			cin >> u >> v;
			g[u - 1].pb(v - 1);
		}
		ll curgcd = 0;
		for (int u = 0; u < n; ++u) {
			ve<bool> used(n);
			ll sum = 0;
			for (auto v : g[u]) used[v] = true, sum += cost[v];
			curgcd = __gcd(curgcd, sum);
			for (int v = u + 1; v < n; ++v) {
				ll sum1 = sum;
				ll sum2 = 0;
				ll sum12 = 0;
				for (auto p : g[v]) {
					if (used[p] == true) sum1 -= cost[p], sum12 += cost[p];
					else sum2 += cost[p];
				}
				curgcd = __gcd(curgcd, sum1);
				curgcd = __gcd(curgcd, sum2);
				curgcd = __gcd(curgcd, sum12);
			}
		}
		cout << curgcd << endl;
	}
	return 0;
}
