#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")
#endif
using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define debug(x) cout << #x << ": " << x << el

const int inf = 1e9, p1 = 37, p2 = 47;
const ll mod = 1000'000'007ll, llinf = 1e18;
const ld pi = 3.1415926;
const char el = '\n';

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return true; } return false; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return true; } return false; }

mt19937 rnd(time(nullptr));

struct item {
    int u, v, w;
    ll c;
    item(int _u, int _v, int _w, ll _c) {
        u = _u;
        v = _v;
        w = _w;
        c = _c;
    }
};
bool operator <(const item &a, const item &b) {
    return (a.u != b.u ? a.u < b.u : (a.v != b.v ? a.v < b.v : (a.w != b.w ? a.w < b.w : false)));
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        vector<ll> c(n), st(n);
        forn(i, n) cin >> c[i];
        vector<pair<int, int>> r(m);
        vector<ll> hash1(n), hash2(n), stp1(n, 1ll), stp2(n, 1ll);
        firn(i, n) {
            stp1[i] = stp1[i - 1] * 1ll * p1 % mod;
            stp2[i] = stp2[i - 1] * 1ll * p2 % mod;
        }
        forn(i, m) {
            cin >> r[i].x >> r[i].y;
            r[i].x--; r[i].y--;
            st[r[i].y]++;
            hash1[r[i].y] = (hash1[r[i].y] + stp1[r[i].x]) % mod;
            hash2[r[i].y] = (hash2[r[i].y] + stp2[r[i].x]) % mod;
        }
        vector<item> q;
        forn(i, n) {
            if (!st[i]) continue;
            hash1[i] = (hash1[i] % mod + mod) % mod;
            hash2[i] = (hash2[i] % mod + mod) % mod;
            q.emplace_back(st[i], hash1[i], hash2[i], c[i]);
        }
        sort(all(q));
        ll ans = 0, tmp = 0;
        forn(i, q.size()) {
            if (i > 0 && (q[i].v != q[i - 1].v || q[i].u != q[i - 1].u || q[i].w != q[i - 1].w)) {
                ans = __gcd(ans, tmp);
                tmp = 0;
            }
            tmp += q[i].c;
        }
        ans = __gcd(ans, tmp);
        cout << ans << el;
    }
    return 0;
}