#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}

int n, m;
vector<vector<int>> g;
vector<int> u;
vector<ll> c;

void solve() {
    g.clear();
    u.clear();
    c.clear();

    cin >> n >> m;
    g.resize(n);
    u.resize(n);
    c.resize(n);

    for (auto &i: c) cin >> i;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
    }

    vector<ll> d(n);
    ll ans = 0;

    for (int i = 0; i < n; ++i) {
        for (auto &j: g[i]) {
            d[i] += c[j];
        }

        ans = __gcd(ans, d[i]);
    }

    vector<int> u(n);
    int t = 1;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            t += 1;
            ll d = 0;

            for (auto &v: g[i]) {
                if (u[v] != t) {
                    u[v] = t;
                    d += c[v];
                }
            }

            for (auto &v: g[j]) {
                if (u[v] != t) {
                    u[v] = t;
                    d += c[v];
                }
            }

            ans = __gcd(ans, d);
        }
    }

    cout << ans nl;
}
