#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
long long gg = 0;
long long gcd(long long a, long long b) {
    if(b == 0) {
        return a;
    }
    return gcd(b, a%b);
}
void make(int p, vector<vector<int>> &g, vector<long long> &c, vector<int> &col, long long sum = 0) {
    if(p == g.size()) {
        gg = gcd(gg, sum);
        return;
    }
    make(p + 1, g, c, col, sum);
    for(int i = 0; i < g[p].size(); ++i) {
        ++col[g[p][i]];
        if(col[g[p][i]] == 1) {
            sum += c[g[p][i]];
        }
    }
    make(p + 1, g, c, col, sum);
    for(int i = 0; i < g[p].size(); ++i) {
        --col[g[p][i]];
        if(col[g[p][i]] == 0) {
            sum -= c[g[p][i]];
        }
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for(int _ = 0; _ < t; ++_) {
        gg = 0;
        int n, m;
        cin >> n >> m;
        vector<long long> c(n);
        for(int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        vector<vector<int>> g(n);
        for(int i = 0; i < m; ++i) {
            int v1,v2;
            cin >> v1 >> v2;
            --v1,--v2;
            g[v1].push_back(v2);
        }
        vector<char> us(n, 0);
        for(int i = 0; i < n; ++i) {
            long long s = 0;
            for(auto v : g[i]) {
                us[v] = 1;
                s += c[v];
            }
            for(int j = i + 1; j < n; ++j) {
                long long d = 0;
                for(auto t : g[j]) {
                    if(us[t] == 0) {
                        d += c[t];
                    }
                }
                gg = gcd(gg, d + s);
            }
            for(auto v : g[i]) {
                us[v] = 0;
            }
        }
    cout << gg << "\n";
    }
}
