#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;
typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int gcd(int a, int b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int LOCAL = 0;
std::mt19937 gen;
int rnd() {
    gen.seed(LOCAL++);
    return gen();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector < vector <int> > g(n);
    vector <int> cnt(n);
    vector <int> c(n);
    for(int i = 0; i < n; ++i) cin >> c[i];
    for(int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        cnt[b]++;
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        int local = 0;
        for(auto u : g[i]) {
            local += c[u];
        }
        ans = gcd(ans, local);
    }
    for(int tst = 0; tst < 5000; ++tst) {
        int local = 0;
        set <int> nums;
        for(int i = 0; i < n; ++i) {
            if(rnd() % 2 == 0) {
                for(auto u : g[i]) {
                    //local += c[u];
                    nums.insert(u);
                }
            }
        }
        for(auto i : nums) {
            local += c[i];
        }
        ans = gcd(ans, local);
    }
    cout << ans << '\n';
}

signed main() {
    srand(time(nullptr));
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}