#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long


int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> f(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    vector<set<int>> g(n);
    vector<set<int>> gg(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        f[a] += c[b];
        gg[a].insert(b);
        g[b].insert(a);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = gcd(ans, f[i]);
    }
    for (int i = 0; i < n; ++i) {
        int cur = 0;
        vector<int> used(n);
        for (auto v : g[i]) {
            for (auto x : gg[v]) {
                if (!used[x]) {
                    cur += c[x];
                    used[x] = 1;
                }
            }
        }
        ans = gcd(ans, cur);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            int cur = f[i] + f[j];
            for (auto v : gg[i]) {
                if (gg[j].count(v)) {
                    cur -= c[v];
                }
            }
        }
    }
    cout << ans << endl;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}