#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <bitset>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    for (ll q = 0; q < t; q++) {
        ll n, m;
        cin >> n >> m;
        vector<ll> c(n);
        for (ll i = 0; i < n; i++) {
            cin >> c[i];
        }
        vector<vector<ll>> adj(n);
        vector<vector<ll>> rev_adj(n);
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            adj[u].push_back(v);
            rev_adj[v].push_back(u);
        }
        ll o = 0;
        for (ll i = 0; i < (1 << n); i++) {
            set<ll> r;
            for (ll j = 0; j < n; j++) {
                if ((i & (1 << j)) != 0) {
                    for (ll k : adj[j]) {
                        r.insert(k);
                    }
                }
            }
            ll s = 0;
            for (ll j : r) {
                s += c[j];
            }
            o = gcd(o, s);
        }
        cout << o << "\n";
    }
    return 0;
}
