#include <bits/stdc++.h>
using namespace std;
const int N = 500005;
mt19937 rnd(1431);
long long gcd(long long x, long long y)
{
    if (x == 0)
        return y;
    return gcd(y % x, x);
}

int n, m;
long long u[N];
vector<int> a[N], b[N];

int xx[N];
void solv1()
{
    long long ans = 0;
    for (int i = 0; i < n; ++i)
    {
        xx[i] = 0;
        for (int j = 0; j < a[i].size(); ++j)
        {
            int x = a[i][j];
            xx[i] |= (1 << x);
        }
    }
    for (int x = 1; x < (1 << n); ++x)
    {
        int y = 0;
        for (int i = 0; i < n; ++i)
        {
            if ((x & (1 << i)))
                y |= xx[i];
        }
        long long sum = 0;
        for (int i = 0; i < n; ++i)
        {
            if ((y & (1 << i)))
                sum += u[i];
        }
        ans = gcd(ans, sum);
    }
    if (ans == 0)
        printf("1\n");
    else
        printf("%lld\n", ans);
}

bool c[N];
void solv2()
{
    long long ans = 0;
    for (int i = 0; i < n; ++i)
    {
        long long sum = 0;
        for (int j = 0; j < a[i].size(); ++j)
        {
            sum += u[a[i][j]];
        }
        ans = gcd(ans, sum);
    }
    for (int j = 0; j < n; ++j)
    {
        set<int> s;
        for (int k = 0; k < b[j].size(); ++k)
        {
            int i = b[j][k];
            for (int j = 0; j < a[i].size(); ++j)
                s.insert(a[i][j]);
        }
        long long sum = 0;
        for (set<int>::iterator it = s.begin(); it != s.end(); ++it)
            sum += u[(*it)];
        ans = gcd(ans, sum);
    }
    if (ans == 0)
        printf("1\n");
    else
        printf("%lld\n", ans);
}

void solv()
{
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; ++i)
        scanf("%lld", &u[i]);
    for (int i = 0; i < n; ++i)
    {
        a[i].clear();
        b[i].clear();
    }
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;
        --y;
        a[x].push_back(y);
        b[y].push_back(x);
    }
    if (n <= 20 && m <= 400)
        solv1();
    else
        solv2();
}

int main()
{
    freopen("input.txt", "r", stdin);
    int tt;
    scanf("%d", &tt);
    while (tt--)
    {
        solv();
    }
    return 0;
}
