#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define ve vector
#define vi vector<int>
#define vvi ve<ve<int>>
#define fi first
#define se second
#define pb emplace_back
#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9;

ostream &operator<< (ostream &out, pii &a) {
	out << '(' << a.fi << ' ' << a.se << ')';
	return out;
}

istream &operator>> (istream &in, pii &a) {
	in >> a.fi >> a.se;
	return in;
}

ostream &operator<< (ostream &out, vi &a) {
	out << "(";
	for (auto &i : a) out << i << ", ";
	out << ") ";
	return out;
}

istream &operator>> (istream &in, ve<ll> &a) {
	for (auto &i : a) in >> i;
	return in;
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	int tt = t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vvi g(n);
		ve<ll> cost(n);
		cin >> cost;
		int u, v;
		for (int i = 0; i < m; ++i) {
			cin >> u >> v;
			g[u - 1].pb(v - 1);
		}
		ll curgcd = 0;
		mt19937 rnd;
		unordered_map<int, bool> opt;
		int k = 100000000 / n / tt;
		for (int i = 0; i < k; ++i) {
			int mask = rnd() % (1 << n);
			int cnt = 0;
			bool flag = false;
			while (opt[mask]) {
				mask = rnd() % (1 << n);
				if (cnt++ == 10) {
					flag = true;
					break;
				}
			}
			if (flag) break;
			opt[mask] = true;
			ve<bool> taken(n);
			ll sum = 0;
			for (int u = 0; u < n; ++u) {
				if ((mask | (1 << u)) == mask) {
					for (auto v : g[u]) {
						if (!taken[v]) taken[v] = true, sum += cost[v];
					}
				}
			}
			curgcd = __gcd(curgcd, sum);
			if (curgcd == 1) break;
		}
		cout << curgcd << endl;
	}
	return 0;
}