#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <random>
#include <queue>
using namespace std;

#pragma GCC optimize("inline-functions")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)

void run() {
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m;
    cin >> n >> m;
    vector<ll> c(n);
    for(ll &x : c) cin >> x;
    vector<int> g(n);
    for(int i = 0; i < m; i++) {
      int a, b;
      cin >> a >> b;
      --a; --b;
      g[a] |= (1 << b);
    }
    ll ge = 0;
    for(int i = 1; i < (1 << n); i++) {
      int tu = 0;
      for(int j = 0; j < n; j++) {
        if (i >> j & 1) {
          tu |= g[j];
        }
      }
      ll sum = 0;
      for(int j = 0; j < n; j++) {
        if (tu >> j & 1) {
          sum += c[j];
        }
      }
      ge = __gcd(ge, sum);
    }
    cout << ge << '\n';
  }
}

int main() {
#ifdef _DEBUG
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    run();
}
