#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long


int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> f(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    vector<set<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        f[a] += c[b];
        g[a].insert(b);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = gcd(ans, f[i]);
    }
    for (int lol = 0; lol < 10000; ++lol) {
        int i = rand() % n, j = rand() % n, x = rand() % n;
        vector<int> used(n);
        int cur = 0;
        for (auto v : g[i]) {
            if (!used[v]) {
                cur += c[v];
                used[v] = true;
            }
        }
        for (auto v : g[j]) {
            if (!used[v]) {
                cur += c[v];
                used[v] = true;
            }
        }
        for (auto v : g[x]) {
            if (!used[v]) {
                cur += c[v];
                used[v] = true;
            }
        }
        ans = gcd(ans, cur);
    }
    cout << ans << endl;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}