#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<string>

using namespace std;

#define int long long

int gcd(int a, int b)
{
	if (min(a, b) == 0)
	{
		return max(a, b);
	}
	return gcd(min(a, b), max(a, b) % min(a, b));
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n, m;
		cin >> n >> m;
		if (n <= 20)
		{
			vector<int> a(n);
			for (int i = 0; i < n; i++)
			{
				cin >> a[i];
			}
			vector<vector<int>> g(n, vector<int>(n + 1));
			for (int i = 0; i < m; i++)
			{
				int a, b;
				cin >> a >> b;
				g[a - 1][b - 1] = 1;
			}
			int ans = 0;
			for (int mask = 0; mask < (1 << n); mask++)
			{
				vector<int> nums;
				for (int i = 0; i < n; i++)	
				{
					if (1 & (mask >> i))
					{
						nums.push_back(i);
					}
				}
				int sum = 0;
				for (int i = 0; i < n; i++)
				{
					int t = 0;
					for (auto u : nums) {
						if (g[u][i]) {
							t = 1;
							break;
						}
					}
					sum += t * a[i];
				}
				ans = gcd(ans, sum);
			}
			cout << ans << "\n";
		}
	}
} 