#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;
vector<ll> g[500005];
vector<int> g1[500005];
ll v[500005];
ll mod = 1e9 + 11;
ll pr = 540373;

ll gcd(ll a, ll b) {
    while (b > 0) {
        ll c = b;
        b = a % b;
        a = c;
    }
    return a;
}

struct el {
    ll h;
    int sz;
    int num;
};

bool operator < (el a, el b) {
    if (a.h == b.h) return a.sz < b.sz;
    return a.h < b.h;
}



int main() {
    int t;
    cin >> t;
    for (int o = 0; o < t; ++o) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            v[i] = 0;
            g[i].clear();
            g1[i].clear();
        }
        for (int i = 0; i < n; ++i) {
            cin >> v[i];
        }
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            g[b].pb(a);
            g1[a].pb(b);
        }
        vector<el> p;
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 0) continue;
            sort(g[i].begin(), g[i].end());
            ll h = 0;
            for (int j = 0; j < g[i].size(); ++j) {
                h = (h * pr) % mod + (g[i][j] + 1);
            }
            p.pb({h, g[i].size(), i});
        }
        sort(p.begin(), p.end());
        ll curr = 0;
        ll gc = 0;
        for (int i = 0; i < p.size(); ++i) {
            if (i == 0 || (p[i].h == p[i - 1].h && p[i].sz == p[i - 1].sz)) {
                curr += v[p[i].num];
            } else {
                gc = gcd(gc, curr);
                curr = v[p[i].num];
            }
        }
        if (curr > 0) gc = gcd(gc, curr);

        /*ll gc = 0;
        for (pair<vector<int>, ll> el : mp) {
            if (el.ft.size() == 0) continue;
            gc = gcd(gc, el.sd);
        }*/
        cout << gc << "\n";
        /*ll gc1 = 0;
        for (int ms = 0; ms < (1 << n); ++ms) {
            vector<int> u(n);
            for (int i = 0; i < n; ++i) {
                if (1 & (ms >> i)) {
                    for (int j : g1[i]) {
                        u[j] = 1;
                    }
                }
            }
            ll s = 0;
            for (int i = 0; i < n; ++i) {
                if (u[i] == 1) s += v[i];
            }
            gc1 = gcd(gc1, s);
        }
        cout << "!! " << gc << " " << gc1 << "\n";*/

    }
    return 0;
}

