#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b) {
	return (b == 0 ? a : gcd(b, a % b));	
}

void solve() {
 	int n, m;
 	cin >> n >> m;
 	vector <ll> x(n);
 	for (int i = 0; i < n; ++i) cin >> x[i];
 	vector <vector <int>> g(n);
 	vector <int> have(n);
 	for (int i = 0; i < m; ++i) {
 		int u, v;
 		cin >> u >> v;
 		--u, --v;
 		g[u].push_back(v);
 		have[v] = true;
 	}
 	vector <int> c(n);
 	for (int i = 0; i < n; ++i) c[i] = 0;
 	int uk = 1;
 	for (int i = 0; i < n; ++i) {
		vector <int> have;
		for (auto v : g[i]) {
			have.push_back(c[v]);
		}
		sort(have.begin(), have.end());
		have.resize(unique(have.begin(), have.end()) - have.begin());
		for (auto v : g[i]) {
			int id = lower_bound(have.begin(), have.end(), c[v]) - have.begin();
			c[v] = uk + id;
		}
		uk += have.size();
 	}
 	vector <ll> sm(uk);
 	for (int i = 0; i < n; ++i) {
 		if (have[i]) sm[c[i]] += x[i];
 	}
 	ll gc = 0;
 	for (int i = 0; i < uk; ++i) {
 		if (sm[i] > 0) {
 			gc = gcd(gc, sm[i]);
 		}
 	}
 	cout << gc << '\n';
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}