#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 5001;
const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    init();

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<bitset<maxn>> g(n);
        vector<ll> a(n);
        for (auto &ev: a)
            cin >> ev;

        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u][v] = 1;
        }
        ll ans = -1;
       for (int i = 0; i < n; i++){
           ll sum = 0;
           for (int j = 0; j < n; j++){
               if (g[i][j])
                   sum += a[j];
           }
           if (ans == -1)
               ans = sum;
           else
               ans = gcd(ans, sum);
       }
       for (int i = 0; i< n; i++){
           for (int j = i + 1; j < n; j ++){
               bitset<maxn> cur = g[i] | g[j];
               ll sum = 0;
               for (int k = 0; k < n; k++){
                   if (cur[k])
                       sum += a[k];
               }
               ans = gcd(ans, sum);
           }
       }
       cout << ans << endl;
    }
    return 0;
}