#include <bits/stdc++.h>
#define x first
#define y second
#define int long long
using namespace std;
vector<int>* el;
int gcd(int a, int b){
    if(b==0)
        return a;
    return gcd(b, a%b);
}
int cnt[5000][5000];
int* h;
int* p;
int* sum;

int get(int v){
    if(p[v]==v)
        return v;
    return p[v] = get(p[v]);
}

void unite(int v, int u){
    v = get(v);
    u = get(u);
    if(h[u]>h[v]){
        p[v] = u;
        sum[u] += sum[v];
        sum[v] = 0;
    } else if(h[v]>h[u]){
        p[u] = v;
        sum[v] += sum[u];
        sum[u] = 0;
    } else {
        p[v] = u;
        sum[u] += sum[v];
        sum[v] = 0;
        h[u]++;
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for(int tt = 0; tt<t; tt++){
        int n, m;
        cin >> n >> m;
        int c[n];
        int sz[n];
        p = new int[n];
        h = new int[n];
        sum = new int[n];
        el = new vector<int>[n];
        for(int i = 0; i<n; i++){
            cin >> c[i];
            sz[i] = 0;
            p[i] = i;
            h[i] = 1;
            sum[i] = c[i];
            for(int j = 0; j<n; j++)
                cnt[i][j] = 0;
        }
        for(int i = 0; i<m; i++){
            int v1, v2;
            cin >> v1 >> v2;
            v1--;
            v2--;
            for(auto z:el[v1]){
                cnt[(signed)z][(signed)v2]++;
                cnt[(signed)v2][(signed)z]++;
            }
            sz[v2]++;
            el[v1].push_back(v2);
        }
        int ans = 0;
        for(int i = 0; i<n; i++){
            for(int j = 0; j<i; j++){
                if(cnt[i][j]==sz[i] && cnt[i][j]==sz[j])
                    unite(i, j);
            }
        }
        for(int i = 0; i<n; i++){
            if(i==get(i) && sz[i]>0)
                ans = gcd(ans, sum[i]);
        }
        cout << ans << "\n";
    }
    return 0;
}
