#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e3 + 3;

int t;
void read()
{
    cin >> t;
}

int n, m;
long long c[maxn];
vector <int> adj[maxn];
bool is[maxn][maxn];
void solve()
{
    while (t--)
    {
        cin >> n >> m;
        for (int i = 1; i <= n; i++)
            cin >> c[i];

        for (int i = 1; i <= n; i++)
            adj[i].clear();

            for (int i = 1; i <= n; i++)
                for (int j = 1; j <= n; j++)
                is[i][j] = false;

        for (int i = 1; i <= m; i++)
        {
            int a, b;
            cin >> a >> b;

            is[a][b] = true;
            adj[a].push_back(b);
        }

        long long ans = 0;
        for (int i = 1; i <= n; i++)
        {
            long long sum = 0;
            for (auto j: adj[i])
            sum += c[j];

            ans = __gcd(ans, sum);
        }

        for (int i = 1; i <= n; i++)
            for (int j = i+1; j <= n; j++)
        {
            long long sum = 0;
            for (int k = 1; k <= n; k++)
                if (is[i][k] || is[j][k])
                sum += c[k];

            ans = __gcd(ans, sum);
        }

        long long big_sum = 0;
        for (int i = 1; i <= n; i++)
        {
            bool can = false;
            for (int j = 1; j <= n; j++)
                if (is[i][j])
            {
                can = true;
                break;
            }

            if (can)
                big_sum += c[i];
        }

        ans = __gcd(ans, big_sum);

        cout << ans << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
