#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <iomanip>
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define ll long long
#define ld long double
#pragma warning(disable : 4996)
using namespace std;

ll gcd(ll a, ll b) {
	if (b)
		return gcd(b, a % b);
	else
		return a;		
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	speed;
	int t;
	cin >> t;
	for (int q = 0; q < t; q++)
	{
		int n, m;
		cin >> n >> m;
		vector <ll> a(n);
		for (int i = 0; i < n; i++)
			cin >> a[i];
		vector <vector <ll>> g(n);
		for (int i = 0; i < m; i++)
		{
			int from, to;
			cin >> from >> to;
			g[from - 1].push_back(to - 1);
		}
		ll ans = 0;
		for (int i = 0; i < (1 << n); i++)
		{
			vector <int> u(n);
			for (int j = 0; j < n; j++)
				if ((i >> j) & 1)
					for (int k = 0; k < g[j].size(); k++)
						u[g[j][k]] = 1;
			ll sum = 0;
			for (int j = 0; j < u.size(); j++)
				if (u[j])
					sum += a[j];
			ans = gcd(ans, sum);
		}
		cout << ans << '\n';

	}
	return 0;
}