// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define ld long double
#define left left228
#define right right228

const int N = 500001;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

bitset<N> adj[N];
int c[N];
vector<int> g[N], in[N];
bitset<N> kek;

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		adj[i] = 0;
		g[i].clear();
		in[i].clear();
	}
	kek = 0;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		in[v].push_back(u);
		adj[u][v] = 1;
		kek[v] = 1;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int sum = 0;
		for (int to : g[i]) {
			sum += c[to];
		}
		ans = gcd(ans, sum);
	}
	int sm = 0;
	for (int i = 0; i < n; ++i) {
		if (kek[i]) sm += c[i];
	}
	ans = gcd(ans, sm);
	for (int i = 0; i < n; ++i) {
		if (!in[i].empty()) {
			kek = adj[in[i][0]];
			for (int j = 1; j < (int)in[i].size(); ++j) {
				kek &= adj[in[i][j]];
			}
			int sum = 0;
			for (int j = 0; j < n; ++j) {
				if (kek[j]) sum += c[j];
			}
			ans = gcd(ans, sum);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while(t--) {
		solve();
	}
	return 0;
}

/*

3
2 4
1 1
1 1
1 2
2 1
2 2

3 4
1 1 1
1 1
1 2
2 2
2 3

4 7
36 31 96 29
1 2
1 3
1 4
2 2
2 4
3 1
4 3

*/