#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/


#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 100010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);


ll gcd(ll a, ll b) {
    if (!b)
        return a;
    if (!a)
        return b;
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int c[MX];
vi g[MX];
void solve() {
    int n, m;
    cin >> n >> m;
    fi(0, n)
        cin >> c[i];
    fi(0, m) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
    }
    int gc = 0;
    rep(mask, 1, 1 << n) {
        vch used(n, 0);
        fi(0, n) {
            if ((1 << i) & mask) {
                fx(to, g[i]) {
                    used[to] = 1;
                }
            }
        }
        int sum = 0;
        fi(0, n) {
            if (used[i])
                sum += c[i];
        }
        cout << sum << '\n';
        if (sum != 0)
            gc = gcd(gc, sum);
    }


    cout << max(1ll, gc) << '\n';

}

int32_t main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    fi(0, t)
        solve();

}