#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e3 + 3;

int t;
void read()
{
    cin >> t;
}

int n, m;
long long c[maxn];
vector <int> adj[maxn];
bool is[maxn][maxn];

long long sum(vector <int> &v)
{
    long long ans = 0;
    for (int i = 1; i <= n; i++)
    {
        bool can = false;
        for (auto j: v)
            if (is[j][i])
        {
            can = true;
            break;
        }

        if (can)
            ans += c[i];
    }

    return ans;
}

void solve()
{
    while (t--)
    {
        cin >> n >> m;
        for (int i = 1; i <= n; i++)
            cin >> c[i];

        for (int i = 1; i <= n; i++)
            adj[i].clear();

            for (int i = 1; i <= n; i++)
                for (int j = 1; j <= n; j++)
                is[i][j] = false;

        for (int i = 1; i <= m; i++)
        {
            int a, b;
            cin >> a >> b;

            is[a][b] = true;
            adj[a].push_back(b);
        }

        long long ans = 0;
        for (int i = 1; i <= n; i++)
        {
            long long sum = 0;
            for (auto j: adj[i])
            sum += c[j];

            ans = __gcd(ans, sum);
        }

        for (int i = 1; i <= 500; i++)
        {
            vector <int> v;
            int how_many = rand() % n + 1;
            int curr_cnt = 0;
            for (int j = 1; j <= n; j++)
            {
                if (curr_cnt == how_many)
                    continue;

                if (rand() & 1)
                {
                    curr_cnt++;
                    v.push_back(j);
                }
            }

            ans = __gcd(ans, sum(v));
        }

        cout << ans << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
