#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 5e5 + 7;

int n, m;
ll s[N];
ll c[N];
vector<int> g[N];
bool used[N];

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		for (int i = 0; i < n; i++) {
			s[i] = 0;
			used[i] = false;
			g[i].clear();
		}
		for (int i = 0; i < n; i++) {
			cin >> c[i];
		}
		int x, y;
		for (int i = 0; i < m; i++) {
			cin >> x >> y;
			x--; y--;
			g[x].pb(y);
			s[x] += c[y];
		}
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			if (s[i] == 0) continue;
			if (ans == 0) ans = s[i];
			else ans = gcd(ans, s[i]);
			if (ans == 1) break;
		}
		ll ts;
		for (int i = 0; i < n; i++) {
			ts = 0;
			for (int j = 0; j < g[i].size(); j++) {
				int to = g[i][j];
				if (!used[to]) {
					used[to] = true;
					ts += c[to];
				}
			}
			if (ts == 0) continue;
			if (ans == 0) ans = ts;
			else ans = gcd(ans, ts);
			if (ans == 1) break;
		}
		cout << ans << nn;
	}
}