#pragma GCC optimize("Ofast")

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

const ll p = 26537;
const ll mod = (ll)1e17 + 7;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	cin >> t;

	while (t--)
	{
		int n = 0, m = 0;
		cin >> n >> m;

		vector<ll> c(n);
		vector<set<ll>> g(n);

		for (int i = 0; i < n; ++i)
			cin >> c[i];

		int u = 0, v = 0;
		for (int i = 0; i < m; ++i)
		{
			cin >> u >> v;
			g[v - 1].insert(u);
		}

		unordered_map<ll, ll> mp;
		for (int i = 0; i < n; ++i)
		{
			ll h = 0;
			for (auto x : g[i])
				h = (h * p + x) % mod;
			mp[h] += c[i];
		}

		ll ans = 0;
		for (auto [h, x] : mp)
			if (h) ans = gcd(ans, x);

		cout << ans << "\n";
	}

	return 0;
}                                                                                                                                                                                  