/*
 *   cCreated by Kazalika   for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
const int N = 2e3 + 5, LOG = 13;
const ll INF = 1e15;
const ldb EPS = 1e-8;

ll gcd(ll a, ll b) {
    if (a < b) swap(a, b);
    if (b == 0) return a;
    if (a % b == 0) return b;
    return gcd(a % b, a);
}

const ll base = 228228227, MOD = 1e9 + 7;

ll hashH(vector <ll> & s) {
    vector <ll> h(sz(s));
    if (sz(s) == 0) return 0;
    h[0] = s[0] % MOD;
    forn(1, i, sz(s))
        h[i] = (h[i - 1] * base + s[i]) % MOD;
    return h.back();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <ll> c(n), s(n);
    vector <int> g[n];
    vector <ll> gr[n];
    forn(0, i, n) cin >> c[i];
    forn(0, i, m) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        gr[u].push_back(v);
    }
    ll res = 0;
    forn(0, i, n){
        ll ss = 0;
        for (int j : g[i])
            ss += c[j];
        s[i] = ss;
    }
    forn(0, i, n) {
        forn(0, j, n) {
            res = gcd(res, gcd(s[i], s[j]));
        }
    }
    cout << res << '\n';

}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

}