#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
bool used[MAXN + 5];
long long c[MAXN + 5];
vector<int> G1[MAXN + 5], G2[MAXN + 5];

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        cin >> n >> m;
        for (int i = 1; i <= n; ++ i)
            cin >> c[i];
        for (int i = 1; i <= n; ++ i)
        {
            G1[i].clear();
            G2[i].clear();
        }
        for (int i = 0; i < m; ++ i)
        {
            int u, v;
            cin >> u >> v;
            G1[u].push_back(v);
            G2[v].push_back(u);
        }
        long long ans = 0;
        for (int i = 0; i < (1ll << n); ++ i)
        {
            memset(used, false, sizeof(used));
            long long sum = 0;
            for (int j = 0; j < n; ++ j)
            {
                if (i & (1ll << j))
                {
                    for (int k = 0; k < G1[j + 1].size(); ++ k)
                    {
                        if (!used[G1[j + 1][k]])
                        {
                            used[G1[j + 1][k]] = true;
                            sum += c[G1[j + 1][k]];
                        }
                    }
                }
            }
            ans = __gcd(ans, sum);
            if (ans == 1) break;
        }

        cout << ans << endl;
    }


    return 0;
}
