#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <random>
#include <queue>
using namespace std;

#pragma GCC optimize("inline-functions")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)

mt19937 gen;
const int N = 5001;
vector<int> g[N];
ll c[N];
int used[N];
int t = 1;

auto d = clock();

void run() {
  gen.seed(228);
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++) {
      cin >> c[i];
      g[i].clear();
    }
    for(int i = 0; i < m; i++) {
      int a, b;
      cin >> a >> b;
      --a; --b;
      g[a].push_back(b);
    }
    vector<int> ord(n);
    iota(all(ord), 0);
    ll ge = 0;

    for(int i = 0; i < n; i++) {
      ll kek = 0;
      for(int x : g[i]) {
        kek += c[x];
      }
      ge = __gcd(kek, ge);
    }
    int temp = 4500;
    if (!t) {
      temp = 1e9;
    }
    for(int i = 0; i < temp && ge != 1; i++) {
      if ((clock() - d) / double(CLOCKS_PER_SEC) >= 1.97) break;
      shuffle(all(ord), gen);
      ll sum = 0;
      t++;
      for(int x : ord) {
        ll add = 0;
        for(int to : g[x]) {
          if (used[to] != t) {
            sum += c[to];
          }
        }
        if (ge > __gcd(add + sum, ge)) {
          ge = __gcd(add + sum, ge);
          sum += add;
          for(int to : g[x]) {
            used[to] = t;
          }
        } else if (gen() % 4) {
          sum += add;
          for(int to : g[x]) {
            used[to] = t;
          }
        }
      }
    }

    cout << ge << '\n';
  }
}

int main() {
#ifdef _DEBUG
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    run();
}
