#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;

mt19937 gen(time(NULL));

#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    void solve() {
        ll n, m;
        cin >> n >> m;
        vector<ll> g(n);
        vector<vector<ll> > nxt(n);
        for (ll i = 0; i < n; i++) {
            cin >> g[i];
        }
        vector<ll> sum(n);
        ll ans = 0;
        for (ll i = 0; i < m; i++) {
            ll u, v;
            cin >> u >> v;
            --u, --v;
            nxt[u].push_back(v);
            sum[u] += g[v];
        }
        for (ll i = 0; i < n; i++) {
            ans = __gcd(ans, sum[i]);
        }
        vector<ll> used(n);
        ll T = 0;
        vector<ll> ord(n);
        iota(all(ord), 0);
        for (ll tmp = 0; tmp < 1e8 / (n + m); tmp++) {
            T++;
            ll now = 0;
            shuffle(all(ord), gen);
            for (auto v : ord) {
                for (auto to : nxt[v]) {
                    if (!used[to]) {
                        now += g[to];
                    }
                    used[to]++;
                }
                ans = __gcd(ans, now);
            }
            shuffle(all(ord), gen);
            for (auto v : ord) {
                for (auto to : nxt[v]) {
                    used[to]--;
                    if (!used[to]) {
                        now -= g[to];
                    }
                }
                ans = __gcd(ans, now);
            }
        }
        cout << ans << "\n";
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    ll TEST_COUNT = 1;
    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
