#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;
typedef unsigned short ushort;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//#define int ll

inline void solve() {
	int n, m;
	cin >> n >> m;
	vector<string> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<vector<ushort>> v(n, vector<ushort>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			v[i][j] = (int)a[i][2 * j] * 256 + (int)a[i][2 * j + 1];
		}
	}
	int ans = n * m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<ushort> comm;
			comm.insert(v[i][j]);
			int q = min(n - i, m - j);
			vector<set<ushort>> strok(q), stolb(q);
			strok[0].insert(v[i][j]);
			stolb[0].insert(v[i][j]);
			for (int k = 1; k < q; k++) {
				for (int w = i; w < i + k; w++) {
					strok[w - i].insert(v[w][j + k]);
					stolb[k].insert(v[w][j + k]);
					comm.insert(v[w][j + k]);
				}
				for (int w = j; w < j + k; w++) {
					stolb[w - j].insert(v[i + k][w]);
					strok[k].insert(v[i + k][w]);
					comm.insert(v[i + k][w]);
				}
				strok[k].insert(v[i + k][j + k]);
				stolb[k].insert(v[i + k][j + k]);
				comm.insert(v[i + k][j + k]);
				bool flag = 1;
				for (int w = 0; w <= k; w++) {
					if (stolb[w].size() != k + 1 || strok[w].size() != k + 1) {
						flag = 0;
						break;
					}
				}
				if (flag && comm.size() == k + 1) {
					ans++;
				}
			}
		}
	}
	cout << ans;
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}