#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
int const maxn = 2005, maxc = 10000;
int a[maxn][maxn], n, m, cnt[maxc], nxtx[maxn][maxn], nxty[maxn][maxn], oks[maxc], cur;

inline void solve1(int i) {
    for (int j = 0; j < maxc; ++j) cnt[j] = 0;
    int R = 1, j = 1;
    while (j <= m) {
        while (R <= m && cnt[a[i][R]] == 0) {
            cnt[a[i][R++]]++;
        }
        cnt[a[i][j]]--;
        nxtx[i][j++] = R - 1;
    }
}

inline void solve2(int i) {
    for (int j = 0; j < maxc; ++j) cnt[j] = 0;
    int R = 1, j = 1;
    while (j <= n) {
        while (R <= n && cnt[a[R][i]] == 0) {
            cnt[a[R++][i]]++;
        }
        cnt[a[j][i]]--;
        nxty[j++][i] = R - 1;
    }
}

inline int check(int lx, int ly, int rx, int ry) {
    cur++;
    for (int j = ly; j <= ry; ++j) {
        oks[a[lx][j]] = cur;
    }
    for (int i = lx + 1; i <= rx; ++i) {
        for (int j = ly; j <= ry; ++j) {
            if (oks[a[i][j]] != cur) return 0;
        }
    }
    return 1;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    char x, y;
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            cin >> x >> y;
            if (x > y) swap(x, y);
            a[i][j] = ((int)x - 32) * 100 + (int)y - 32;
        }
    }
    for (int i = 1; i <= n; ++i) {
        solve1(i);
    }
    for (int j = 1; j <= m; ++j) {
        solve2(j);
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            int rx = nxty[i][j], ry = nxtx[i][j];
            for (int k = 1; k <= min(n - i + 1, m - j + 1); ++k) {
                rx = min(rx, nxty[i + k - 1][j]), ry = min(ry, nxtx[i][j + k - 1]);
                if (rx - i + 1 < k || ry - j + 1 < k) break;
                ans += check(i, j, i + k - 1, j + k - 1);
            }
        }
    }
    cout << ans << '\n';
    return 0;
}

