#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

void Solve() {
	int n, m;
	cin >> n >> m;
	vector <string> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set <pair <char, char>> s;
			vector <set <pair <char, char>>> col(m);
			vector <set <pair <char, char>>> str(n);
			for (int k = 0; k + i < n && k + j < m; k++) {
				for (int l = 0; l <= k; l++) {
					s.insert({ v[i + k][2 * (j + l)], v[i + k][2 * (j + l) + 1] });
					col[j + l].insert({ v[i + k][2 * (j + l)], v[i + k][2 * (j + l) + 1] });
					str[i + k].insert({ v[i + k][2 * (j + l)], v[i + k][2 * (j + l) + 1] });
				}
				for (int l = 0; l <= k; l++) {
					s.insert({ v[i + l][2 * (j + k)], v[i + l][2 * (j + k) + 1] });
					col[j + k].insert({ v[i + l][2 * (j + k)], v[i + l][2 * (j + k) + 1] });
					str[i + l].insert({ v[i + l][2 * (j + k)], v[i + l][2 * (j + k) + 1] });
				}
				bool flag = true;
				for (int i = 0; i < m; i++) {
					if (col[i].size() != k + 1 && col[i].size() != 0)
						flag = false;
				}
				for (int i = 0; i < n; i++) {
					if (str[i].size() != k + 1 && str[i].size() != 0)
						flag = false;
				}
				if (s.size() != k + 1)
					flag = false;
				if (flag)
					ans++;
			}
			
		}
	}
	cout << ans;
}

int main() {
	IOOptimize();
	Solve();
}