#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include  <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>

using namespace std;

bool checker(vector <vector <string> > A, int len)
{
    set <string> counter;
    int i, j;
    for (i = 0; i < len; i++)
    {
        set <string> Q;
        for (j = 0; j < len; j++)
        {
            counter.insert(A[i][j]);
            Q.insert(A[i][j]);
        }
        if (Q.size() != len)
        {
            return(false);
        }
    }
    if (counter.size() != len)
    {
        return(false);
    }
    for (j = 0; j < len; j++)
    {
        set <string> Q;
        for (i = 0; i < len; i++)
        {
            Q.insert(A[i][j]);
        }
        if (Q.size() != len)
        {
            return(false);
        }
    }
    return(true);
}

int main()
{
    int n, m, i, j;
    cin >> n >> m;
    string A[n][m];
    char a, b;
    for (i = 0; i < n; i++)
    {
        for (j = 0; j < m; j++)
        {
            cin >> a >> b;
            string s = "  ";
            if (a < b)
            {
                s[0] = a;
                s[1] = b;
            }
            else
            {
                s[0] = b;
                s[1] = a;
            }
            A[i][j] = s;
        }
    }
    int cou = 0;
    for (i = 0; i < n; i++)
    {
        for (j = 0; j < m; j++)
        {
            for (int len = 1; len <= min(n - i, m - j); len++)
            {
                vector <vector <string> > B(len, vector <string> (len, ""));
                for (int i1 = i; i1 < i + len; i1++)
                {
                    for (int j1 = j; j1 < j + len; j1++)
                    {
                        B[i1 - i][j1 - j] = A[i1][j1];
                    }
                }
                if (checker(B, len))
                {
                    cou++;
                }
            }
        }
    }
    cout << cou;
    return 0;
}
