#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int C = 256;
const int mx = 2010;
int n, m, a[mx][mx];

int check(int x1, int y1, int x2, int y2) {
	for (int i = x1; i <= x2; ++i) {
		for (int j1 = y1; j1 <= y2; ++j1) {
			for (int j2 = j1 + 1; j2 <= y2; ++j2) {
				if (a[i][j1] == a[i][j2]) {
					return 0;
				}
			}
		}
	}
	for (int i = y1; i <= y2; ++i) {
		for (int j1 = x1; j1 <= x2; ++j1) {
			for (int j2 = j1 + 1; j2 <= x2; ++j2) {
				if (a[j1][i] == a[j2][i]) {
					return 0;
				}
			}
		}
	}
	set<int> vals;
	for (int i = x1; i <= x2; ++i) {
		for (int j = y1; j <= y2; ++j) {
			vals.insert(a[i][j]);
			if (vals.size() > x2 - x1 + 1) {
				return 0;
			}
		}
	}
	return 1;
}

signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j ++) {
			a[i][j] = (int)s[2 * j] * C + (int)s[2 * j + 1];
		}
	}
	int ans = 0;
	for (int x1 = 0; x1 < n; ++x1) {
		for (int y1 = 0; y1 < m; ++y1) {
			for (int d = 1; d <= min(n, m); ++d) {
				int x2 = x1 + d - 1;
				int y2 = y1 + d - 1;
				if (x2 < n && y2 < m) {
					ans += check(x1, y1, x2, y2);
				}
			}
		}
	}
	cout << ans << endl;
}
