#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            char c1, c2;
            cin >> c1 >> c2;
            a[i][j] = c1 * 127 + c2;
        }
    }
    int ans = 0;
    for (int x1 = 0; x1 < n; x1++){
        for (int y1 = 0; y1 < m; y1++){
            for (int len = 1; len + x1 <= n && len + y1 <= m; len++){
                int x2 = x1 + len;
                int y2 = y1 + len;
                int cnt = 0;
                set<int> c;
                for (int i = x1; i < x2; i++){
                    for (int j = y1; j < y2; j++){
                        if (c.find(a[i][j]) == c.end()){
                            cnt++;
                        }
                        c.insert(a[i][j]);
                    }
                }
                if (cnt != len){
                    continue;
                }
                c = set<int>();
                bool good = 1;
                for (int i = x1; i < x2; i++){
                    c = set<int>();
                    for (int j = y1; j < y2; j++){
                        if (c.find(a[i][j]) != c.end()){
                            good = 0;
                            break;
                        }
                        c.insert(a[i][j]);
                    }
                }
                for (int j = y1; j < y2; j++){
                    c = set<int>();
                    for (int i = x1; i < x2; i++){
                        if (c.find(a[i][j]) != c.end()){
                            good = 0;
                            break;
                        }
                        c.insert(a[i][j]);
                    }
                }
                ans += good;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
