#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//#define TIME ((clock() - start_time) / CLOCKS_PER_SEC)

//using namespace __gnu_pbds;
using namespace std;


const int maxn = 101;
const int maxc = 101 * 101;

int c[maxn][maxn][maxc];

void upd(int i, int j, int t)
{
    if (i)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] += c[i - 1][j][k];
    }
    if (j)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] += c[i][j - 1][k];
    }
    if (i && j)
    {
        for (int k = 0; k < maxc; ++k)
            c[i][j][k] -= c[i - 1][j - 1][k];
    }
    c[i][j][t]++;
}

int get(int x1, int y1, int x2, int y2)
{
    int cnt = 0;
    for (int i = 0; i < maxc; ++i)
    {
        int res = c[x2][y2][i];
        if (x1) res -= c[x1 - 1][y2][i];
        if (y1) res -= c[x2][y1 - 1][i];
        if (x1 && y1) res += c[x1 - 1][y1 - 1][i];
        if (res) ++cnt;
    }
    return cnt;
}

vector<int> co;
int idx(int x)
{
    return lower_bound(all(co), x) - co.begin();
}

int tab[maxn][maxn];

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char inx1, inx2;
            cin >> inx1 >> inx2;
            tab[i][j] = (inx1 - '!') * 1000 + (inx2 - '!');
            co.pb(tab[i][j]);
        }
    }
    sort(all(co));
    co.erase(unique(all(co)), co.end());
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            upd(i, j, idx(tab[i][j]));
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            ++ans;
            for (int k = 1; i + k < n && j + k < m; ++k)
            {
                bool flg = false;
                for (int p = 0; p < k; ++p)
                {
                    if (get(i, j + p, i + k, j + p) != k + 1)
                    {
                        flg = true;
                        break;
                    }
                    if (get(i + p, j, i + p, j + k) != k + 1)
                    {
                        flg = true;
                        break;
                    }
                }
                if (flg) break;
                if (get(i, j, i + k, j + k) == k + 1)
                {
                    ++ans;
                    break;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
