#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

void my_file_in_out() {
	freopen("inp.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

void stop() {cerr << "FINISHED\n";exit(0);}
ld timer() {return (clock() / (ld)CLOCKS_PER_SEC);}
void OK() {cerr << "OK\n";}

namespace VECTOR_MAGIC {
	#define UNIT template <typename T>
	UNIT istream &operator>>(istream &inp, vector <T> &a) {
		for (auto &el : a)
			inp >> el;
		return inp;
	}
	UNIT ostream &operator<<(ostream &out, vector <T> &a) {
		for (auto &el : a)
			out << el << ' ';
		out << '\n';
		return out;
	}
	UNIT void operator --(vector <T> &a) {
		for (auto &el : a)
			--el;
	}
	UNIT void operator ++(vector <T> &a) {
		for (auto &el : a)
			++el;
	}
}

using namespace VECTOR_MAGIC;

mt19937 rnd(time(0));

vector <vector <vector <int>>> dif_col, dif_row;

void upd(vector <int> &fen, int p, int x) {
	for (; p < len(fen); p |= (p + 1))
		fen[p] += x;
}

int get(vector <int> &fen, int p) {
	int r = 0;
	for (; p >= 0; p = (p & (p + 1)) - 1)
		r += fen[p];
	return r;
}

void fill_dif(vector <vector <int>> &targ, vector <int> &a) {
	int n = len(a);
	targ.resize(n, vector <int> (n, 0));
	vector <int> was;
	vector <int> cnt(10000, 0);
	for (int i = 0; i < n; i++) {
		int diff = 0;
		for (int j = i; j < n; j++) {
			cnt[a[j]]++;
			if (cnt[a[j]] == 1) {
				was.push_back(a[j]);
				diff++;
			}
			targ[i][j] = diff;
		}
		for (auto &el : was)
			cnt[el] = 0;
		was.clear();
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	//my_file_in_out();

	int n, m;
	cin >> n >> m;

	vector <vector <int>> a(n);
	vector <pair <char, char>> comp;
	vector <string> b(n);
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		for (int j = 0; j < 2 * m; j += 2)
			comp.push_back(make_pair(b[i][j], b[i][j + 1]));
 	}

 	sort(all(comp));
 	comp.erase(unique(all(comp)), comp.end());

 	for (int i = 0; i < n; i++) 
 		for (int j = 0; j < 2 * m; j += 2)
 			a[i].push_back(lower_bound(all(comp), make_pair(b[i][j], b[i][j + 1])) - comp.begin());

 	dif_col.resize(m);
 	dif_row.resize(n);

 	for (int i = 0; i < n; i++) {
 		vector <int> row = a[i];
 		fill_dif(dif_row[i], row);
 	}

 	for (int i = 0; i < m; i++) {
 		vector <int> col;
 		for (int j = 0; j < n; j++)
 			col.push_back(a[j][i]);
 		fill_dif(dif_col[i], col);
 	}

 	int ans = 0;
 	vector <int> kol(10000, 0);
 	vector <int> was;
 	for (int i = 0; i < n; i++) {
 		for (int j = 0; j < m; j++) {
 			int razn = 0;
 			int ii = i;
 			int jj = j;
 			while (ii < n && jj < m) {
 				for (int k = i; k <= ii; k++) {
 					kol[a[k][jj]]++;
 					if (kol[a[k][jj]] == 1) {
 						razn++;
 						was.push_back(a[k][jj]);
 					}
 				}
 				for (int k = j; k < jj; k++) {
 					kol[a[ii][k]]++;
 					if (kol[a[ii][k]] == 1) {
 						razn++;
 						was.push_back(a[ii][k]);
 					}
 				}
 				int d = ii - i + 1;
 				if (razn != d) {
 					ii++; jj++;
 					if (razn < d)
 						break;
 					continue;
 				}
 				bool fl = 1;
 				for (int p = i; p <= ii && fl; p++)
 					fl &= (dif_row[p][j][jj] == d);
 				for (int p = j; p <= jj && fl; p++)
 					fl &= (dif_col[p][i][ii] == d);
 				ans += fl;
 				if (!fl) break;
 				ii++; jj++;
 			}
 			for (auto &el : was)
				kol[el] = 0;
			was.clear();
 		}
 	}

 	cout << ans;

	return 0;
}