#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> arr(n, vector<int> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			char c2;
			cin >> c >> c2;
			arr[i][j] = c * 256 + c2;
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = 1; i + k <= n && j + k <= m; k++) {
				unordered_set<int> s1;
				bool bad = 0;
				for (int r = i; r < i + k; r++) {
					unordered_set<int> s2;
					for (int jj = j; jj < j + k; jj++) {
						s2.insert(arr[r][jj]);
						s1.insert(arr[r][jj]);
					}
					if (s2.size() != k) {
						bad = 1;
						break;
					}
				}
				if (s1.size() != k)
					continue;
				if (bad)
					continue;
				for (int c = j; c < j + k; c++) {
					unordered_set<int> s2;
					for (int r = i; r < i + k; r++) {
						s2.insert(arr[r][c]);
					}
					if (s2.size() != k) {
						bad = 1;
						break;
					}
				}
				if (bad)
					continue;
				ans++;
			}
		}
	}
	cout << ans << endl;
}
