#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <stack>
#include <cassert>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

struct izm 
{
	int x, row;
	char c;//r, c
	izm() {}
	izm(int _x, int _row, char _c) 
	{
		x = _x;
		row = _row;
		c = _c;
	}
};

int n, m, a[2000][2000], NOW = 0, NROW[2000], NCOL[2000];
bool used[10000], row[2000][10000], col[2000][10000];
stack <izm> changes;

void otkat()
{
	while (!changes.empty())
	{
		used[changes.top().x] = false;
		if (changes.top().c == 'r') {
			row[changes.top().row][changes.top().x] = false;
			NROW[changes.top().row] = 0;
		}
		else {
			col[changes.top().row][changes.top().x] = false;
			NCOL[changes.top().row] = 0;
		}
		changes.pop();
	}
	NOW = 0;
}

void update(char c, int row, int x)
{
	if (x >= 10000)
		x = x;
	if (c == 'c') 
	{
		if (col[row][x] == false) 
		{
			changes.push(izm(x, row, 'c'));
			col[row][x] = true;
			NCOL[row]++;
			if (!used[x]) 
			{
				used[x] = true;
				NOW++;
			}
		}
	}
	else
	{
		if (::row[row][x] == false) 
		{
			changes.push(izm(x, row, 'r'));
			::row[row][x] = true;
			NROW[row]++;
			if (!used[x])
			{
				used[x] = true;
				NOW++;
			}
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	/*cout << int('’');
	char c1, c2;
	cin >> c1 >> c2;
	cout << int((c1 - 33) * 100 + (c2 - 33));
	return 0;*/
	cin >> n >> m;
	for (int i = 0; i < n; i++) 
	{
		for (int j = 0; j < m; j++) 
		{
			char c1, c2;
			cin >> c1 >> c2;
			if (c1 == '’')
				c1 = 39;
			if (c2 == '’')
				c2 = 39;
			if (c1 == -111)
				c1 = 96;
			if (c2 == -111)
				c2 = 96;
			c1 -= 33;
			c2 -= 33;
			a[i][j] = c1 * 100 + c2;
		}
	}
	//return 0;
	ll ans = 0;
	for(int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			ans++;
			otkat();
			update('r', i, a[i][j]);
			update('c', j, a[i][j]);
			for(int add = 1; i + add < n && j + add < m; add++)
			{
				bool ch_col = true, ch_row = true;
				for (int jj = j; jj < j + add; jj++)
				{
					update('c', jj, a[i + add][jj]);
					ch_col &= (NCOL[jj] == add + 1);
				}
				for (int ii = i; ii < i + add; ii++) 
				{
					update('r', ii, a[ii][j + add]);
					ch_row &= (NROW[ii] == add + 1);
				}
				for (int jj = j; jj <= j + add; jj++)
					update('r', i + add, a[i + add][jj]);
				for (int ii = i; ii <= i + add; ii++)
					update('c', j + add, a[ii][j + add]);
				if (ch_row && ch_col && NOW == add + 1 && NROW[i + add] == add + 1 && NCOL[j + add] == add + 1)
					ans++;
			}
		}
	cout << ans;
	return 0;
}
