#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template <typename T>
struct Test {
    T data;
    bool is_ans_unique = false;
    int expected_ans = -1;
    Test(T d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = false;

typedef int TEST_TYPE;
typedef int RESULT_TYPE;

int n, m;
vector<vector<int>> field;

RESULT_TYPE solve() {
    return 0;
}

vector<vector<pair<int, int>>> up, down;

bool is_square(int x, int y, int k) {
    set<int> all;
    vector<set<int>> suck(k);
    for (int i = x; i < x + k; ++i) {
        set<int> now;
        for (int j = y; j < y + k; ++j) {
            now.insert(field[i][j]);
            all.insert(field[i][j]);
            suck[j - y].insert(field[i][j]);
        }
        if (now.size() != k) return false;
    }
    if (all.size() != k) return false;
    for (auto e : suck) {
        if (e.size() != k) return false;
    }
    return true;
}

void fill_prev_next() {

}

RESULT_TYPE stupid() {

    int answer = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 1; k <= min(n - i, m - j); ++k) {
                answer += is_square(i, j, k);
            }
        }
    }
    return answer;
}

void gen_test() {

}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> m;
    field.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char t;
            cin >> t;
            int now = (t - 33) * (127 - 33);
            cin >> t;
            now += (t - 33);
            field[i].emplace_back(now);
        }
    }
}

bool check(RESULT_TYPE stupid_ans, RESULT_TYPE smart_ans) {
    return true;
}

bool load_test(TEST_TYPE t) {
    return true;
}

void clean_data() {

}

vector<Test<TEST_TYPE>> pretests = {};

bool check_pretests(bool is_smart) {
    for (Test<TEST_TYPE> test : pretests) {
        if (!is_smart && !test.is_ans_unique) {
            continue;
        }
        clean_data();
        load_test(test.data);
        RESULT_TYPE stupid_ans = stupid();
        if (is_smart) {
            clean_data();
            load_test(test.data);
            RESULT_TYPE smart_ans = solve();

        } else {

        }
    }
    return true;
}

void precalc() {

}

int main() {
    precalc();
    if (IS_TESTING) {
        check_pretests(false);
    } else {
        read();
        cout << stupid() << '\n';
    }

}