#include <bits/stdc++.h>

#define len(v) (int)v.size()
#define ft first
#define sc second
#define pb push_back
// #define int ll

using namespace std;
typedef long long ll;
typedef long double ld;


signed main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, m;
	cin >> n >> m;
	vector<vector<int>> mat(n, vector<int> (m, 0));
	vector<int> fs;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c1, c2;
			cin >> c1 >> c2;
			int c11 = c1, c22 = c2;
			// cout << i << " " << j << " " << c11 << " " << c22 << " " << c11 * 1000 + c22 << endl;
			mat[i][j] = c11 * 1000 + c22;
			fs.pb(mat[i][j]);
		}
	}
	vector<int> num(1e6 + 100, -1);
	int cnt = 0;
	sort(fs.begin(), fs.end());
	// cout << 1 << " " << len(fs) << " " << fs[0] << endl;
	for (int i = 0; i < len(fs); i++) {
		if(num[fs[i]] == -1) 
			num[fs[i]] = cnt++;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			mat[i][j] = num[mat[i][j]];
		}
	}
	vector<vector<int>> up(n, vector<int> (m, 0));
	vector<vector<int>> left(n, vector<int> (m, 0));
	map<pair<int, int>, int> old;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if(old.count({mat[i][j], j})) 
				up[i][j] = old[{mat[i][j], j}] + 1;
			if(i > 0) 
				up[i][j] = max(up[i][j], up[i - 1][j]);
			old[{mat[i][j], j}] = i;
			// cout << i << " " << j << " " << up[i][j] << endl;
		}
	}
	old.clear();
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if(old.count({mat[i][j], i}))
				left[i][j] = old[{mat[i][j], i}] + 1;
			if(j > 0) 
				left[i][j] = max(left[i][j], left[i][j - 1]);
			old[{mat[i][j], i}] = j;
		}
	}
	vector<vector<int>> pos(cnt + 1, vector<int> (m));
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int maxup = 0;
			int maxlft = 0;
			vector<int> count(cnt + 1, 0);
			int cntn = 0;
			for (int k = 1; k <= min(n, m); k++) {
				int in = i - k + 1, jn = j - k + 1;
				if(in < 0 || jn < 0) 
					break;
				for (int j1 = jn; j1 <= j; j1++) {
					if(!count[mat[in][j1]]) 
						cntn++;
					count[mat[in][j1]] = 1;
				}
				for (int i1 = in; i1 <= i; i1++) {
					if(!count[mat[i1][jn]])
						cntn++;
					count[mat[i1][jn]] = 1;
				}
				maxup = max(maxup, up[i][jn]);
				maxlft = max(maxlft, left[in][j]);
				if(maxup > in || maxlft > jn) 
					break;
				if(cntn == k) {
					ans++;
				}
			}
		}
	}
	cout << ans << endl;
}

