#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

#define x1 x228
#define y1 y228

const int A = 94;
const int A2 = A * A;
ll num[A2];
const int maxN = 2003;
int grid[maxN][maxN];
ll sum[maxN][maxN];

ll gt(int x, int y) {
  if (x < 0 || y < 0) {
    return 0;
  } else {
    return sum[x][y];
  }
}
ll gt(int x1, int y1, int x2, int y2) {
  x1--;
  y1--;
  return gt(x2, y2) - gt(x1, y2) - gt(x2, y1) + gt(x1, y1);
}

int cnt[A2];

signed main() {
#ifdef DEBUG
  freopen("in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  mt19937_64 rng64(time(0));
  for (int c = 0; c < A2; ++c) {
    num[c] = rng64() % ((ll)1e12);
  }

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    string t;
    cin >> t;
    for (int j = 0; j < 2 * m; j += 2) {
      grid[i][j / 2] = ((int)t[j] - 33) * A + ((int)t[j + 1] - 33);
    }
  }
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      sum[i][j] = num[grid[i][j]] + gt(i - 1, j) + gt(i, j - 1) - gt(i - 1, j - 1);
    }
  }
  ll ans = 0;
  for (int i = 0; i < n; ++i) {
    for (int k = 1; k <= n - i; ++k) {
      int one = 0;
      ll up_sum = 0;
      auto add = [&](int x) {
        cnt[x]++;
        up_sum += num[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 2) {
          --one;
        }
      };
      auto rem = [&](int x) {
        cnt[x]--;
        up_sum -= num[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 0) {
          --one;
        }
      };
      for (int j = 0; j < k; ++j) {
        add(grid[i][j]);
      }
      for (int l = 0, r = l + k - 1; r < m; ++l, ++r) {
        if (one == k && k * up_sum == gt(i, l, i + k - 1, r)) {
          ++ans;
        }
        if (r + 1 < m) {
          rem(grid[i][l]);
          add(grid[i][r + 1]);
        }
      }
      for (int j = m - k; j < m; ++j) {
        rem(grid[i][j]);
      }
    }
  }
  cout << ans << '\n';

  return 0;
}

