#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

const int let = 8876;
//int in[let];
vector <vector <int>> a;

int check(int i1, int j1, int i2, int j2, int k) {
	set <int> in;
	for (int i = i1; i < i2; ++i) {
		for (int j = j1; j < j2; ++j) {
			in.insert(a[i][j]);
		}
	}
	return in.size() == k;
}


void solve() {
	int n, m;
	cin >> n >> m;
	a.assign(n, vector <int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			a[i][j] = (s[2 * j]) * 1000 + (s[2 * j + 1] - '!');
		}
	}
	int ans = 0;
	int let = 'z' - 'a' + 1;
	for (int i1 = 0; i1 < n; ++i1) {
		for (int j1 = 0; j1 < m; ++j1) {
			for (int k = 1; i1 + k - 1 < n && j1 + k - 1 < m && k <= 2000; ++k) {
				if (!check(i1, j1, i1 + k, j1 + k, k)) continue;
				int fl = 1;
				for (int i = i1; i < i1 + k; ++i) {
					if (!check(i, j1, i + 1, j1 + k, k)) fl = 0;
				}
				for (int j = j1; j < j1 + k; ++j) {
					if (!check(i1, j, i1 + k, j + 1, k)) fl = 0;
				}
				if (fl) {
					++ans;
					//cout << i1 << " " << j1 << " " << k << "\n";
				}
				//else break;
			}
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}