#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 2001
#define INF
using namespace std;

int n, m;
int tab[MAXN][MAXN];

void input()
{
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            char c1, c2;
            cin >> c1 >> c2;
            tab[i][j] = (int(c1) - 32) * 100 + (int(c2) - 32);
        }
}

bool check(int x, int y, int k)
{
    set <int> last;
    set <int> all;

    //cout << endl << "x: " << x << ", y: " << y << ", k: " << k << endl;

    for (int i = x; i < x + k; ++i)
    {
        set <int> tmp;
        for (int j = y; j < y + k; ++j)
        {
            tmp.insert(tab[i][j]);
            all.insert(tab[i][j]);
        }
        if (tmp.size() != k)
        {
            //cout << "WR 1 (X): " << i << endl;
            return 0;
        }
        if (i != x && tmp != last)
        {
            //cout << "WR 2 (X): " << i << endl;
            return 0;
        }
        last = tmp;
    }

    if (all.size() != k)
    {
        //cout << "WR 3" << endl;
        return 0;
    }

    for (int j = y; j < y + k; ++j)
    {
        set <int> tmp;
        for (int i = x; i < x + k; ++i)
            tmp.insert(tab[i][j]);
        if (tmp.size() != k)
        {
            //cout << "WR 1 (Y): " << j << endl;
            return 0;
        }
        if (j != y && tmp != last)
        {
            //cout << "WR 2 (Y): " << j << endl;
            return 0;
        }
        last = tmp;
    }

    //cout << "RR" << endl;
    return 1;
}

void solve()
{
    int cnt = n * m;

    for (int k = 2; k <= min(n, m); ++k)
    {
        for (int i = 0; i <= n - k; ++i)
        {
            for (int j = 0; j <= m - k; ++j)
                if (check(i, j, k))
                {
                    ++cnt;
                    //cout << "(" << i << "; " << j << ")" << endl;
                }
        }
    }

    cout << cnt << endl;
}

/**

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

5 10
!"#$%&’()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_‘abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&


*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
