/*#pragma optimize("Ofast")
#pragma optimize("fast-math")
#pragma optimize("unroll-loops")
#pragma optimize("unswitch-loops")
#pragma target("avx,avx2,sse,sse2,ssse3,sse4,popcnt")*/
#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

#define right aksdjfslafj

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e3) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, m;
char fld[2][MAX][MAX];
int down[MAX][MAX];
int right[MAX][MAX];

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> fld[0][i][j] >> fld[1][i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        map<pair<char, char>, int> cnt;
        for (int j = m - 1; j >= 0; --j) {
            if (cnt.find({fld[0][i][j], fld[1][i][j]}) == cnt.end()) {
                right[i][j] = INF_INT;
            }
            else {
                right[i][j] = cnt.at({fld[0][i][j], fld[1][i][j]});
            }

            cnt[{fld[0][i][j], fld[1][i][j]}] = j;
        }
    }

    for (int i = 0; i < m; ++i) {
        map<pair<char, char>, int> cnt;
        for (int j = n - 1; j >= 0; --j) {
            if (cnt.find({fld[0][j][i], fld[1][j][i]}) == cnt.end()) {
                down[j][i] = INF_INT;
            }
            else {
                down[j][i] = cnt.at({fld[0][j][i], fld[1][j][i]});
            }

            cnt[{fld[0][j][i], fld[1][j][i]}] = j;
        }
    }


    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool kill = true;
            int right_min = INF_INT;
            int down_min = INF_INT;
            set<pair<char, char>> diff;
            for (int k = 1; kill && i + k - 1 < n && j + k - 1 < m; ++k) {
                // (i, j) (i + k - 1) (j + k - 1)
                for (int jj = j; jj <= j + k - 1; ++jj) {
                    chkmin(right_min, right[i + k - 1][jj]);
                    chkmin(down_min, down[i + k - 1][jj]);
                }

                for (int ii = i; ii <= i + k - 1; ++ii) {
                    chkmin(right_min, right[ii][j + k - 1]);
                    chkmin(down_min, down[ii][j + k - 1]);
                }

                if (right_min <= j + k - 1 || down_min <= i + k - 1) {
                    kill = false;
                }

                if (!kill) {
                    break;
                }

                for (int jj = j; jj <= j + k - 1; ++jj) {
                    diff.insert({fld[0][i + k - 1][jj], fld[1][i + k - 1][jj]});
                }

                for (int ii = i; ii <= i + k - 1; ++ii) {
                    diff.insert({fld[0][ii][j + k - 1], fld[1][ii][j + k - 1]});
                }

                if (len(diff) == k) {
                    ++ans;
                }
            }
        }
    }


    cout << ans << '\n';
}