#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll P = 31;
const ll MOD = 1e9 + 7;
const int ALPH = 100;
const int MAXN = 501;

mt19937 gen(time(NULL));

#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    int n, m;
    vector<vector<int> > g;

    void solve() {
        cin >> n >> m;
        g.resize(n, vector<int>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char a, b;
                cin >> a >> b;
                g[i][j] = (a - 33) * ALPH + (b - 33);
            }
        }
        int cnt[ALPH * ALPH];
        int nowK = 0;
        int noNullLine[ALPH * ALPH][MAXN];
        int noNullRow[ALPH * ALPH][MAXN];
        int ans = n * m;
        int T = 0;
        for (int len = 2; len <= min(n, m); len++) {
            fill(cnt, cnt + ALPH, 0);
            for (int i = 0; i + len <= n; i++) {
                for (int j = 0; j + len <= m; j++) {
                    T++;
                    fill(cnt, cnt + ALPH * ALPH, 0);
                    nowK = 0;
                    bool f = 1;
                    for (int i1 = i; i1 < i + len; i1++) {
                        for (int j1 = j; j1 < j + len; j1++) {
                            if (noNullLine[g[i1][j1]][i1] == T) {
                                f = 0;
                                break;
                            }
                            if (noNullRow[g[i1][j1]][j1] == T) {
                                f = 0;
                                break;
                            }
                            if (cnt[g[i1][j1]] == len) {
                                nowK--;
                            }
                            cnt[g[i1][j1]]++;
                            if (cnt[g[i1][j1]] == len) {
                                nowK++;
                            }
                            noNullLine[g[i1][j1]][i1] = T;
                            noNullRow[g[i1][j1]][j1] = T;
                        }
                        if (!f) {
                            break;
                        }
                    }
                    ans += (f && nowK == len);
                }
            }
        }
        cout << ans;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
