#include <iostream>
#include <set>
#include <vector>

using namespace std;

const int N = 501;
int matrix[N][N];

signed main() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            matrix[i][j] = (a - 33) * 100 + (b - 33);
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            set<int> all = {matrix[i][j]};
            vector<set<int>> lines = {{matrix[i][j]}};
            vector<set<int>> cols = {{matrix[i][j]}};
            ans++;

            for (int len = 1; i + len < n && j + len < m; len++) {
                bool ok = true;
                lines.emplace_back();
                cols.emplace_back();

                for (int k = 0; k <= len; k++) {
                    if (cols[k].count(matrix[i + len][j + k])) {
                        ok = false;
                        break;
                    }
                    if (lines[k].count(matrix[i + k][j + len])) {
                        ok = false;
                        break;
                    }
                    cols[k].insert(matrix[i + len][j + k]);
                    lines[len].insert(matrix[i + len][j + k]);

                    lines[k].insert(matrix[i + k][j + len]);
                    cols[len].insert(matrix[i + k][j + len]);
                    all.insert(matrix[i + len][j + k]);
                    all.insert(matrix[i + k][j + len]);
                }


                if (cols[len].size() != len + 1 || lines[len].size() != len + 1) {
                    ok = false;
                    break;
                }

                if (ok && all.size() == len + 1)
                    ans++;
                if (!ok)
                    break;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
