#include<iostream>
#include<ctime>
#include<random>

using namespace std;

#define int long long

mt19937_64 rnd(time(NULL));

int a[2000+5][2000+5];

unsigned long long Zobrist[20000+5];

int c1[2000+5][2000+5];

int c2[2000+5][2000+5];

int c[20000+5];

unsigned long long h[100+5][100+5][100+5];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for (int i=1; i<=n; i++)
    {
        string s;
        cin>>s;
        for (int j=0; j<m*2; j+=2)
        {
            //if (s[j]>s[j+1]) swap(s[j],s[j+1]);
            a[i][j/2+1]=(s[j]-33)*100+(s[j+1]-33)+1;
        }
    }
    for (int i=1; i<=20000; i++)
    {
        Zobrist[i]=rnd();
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=20000; j++)
        {
            c[j]=0;
        }
        int l=1, r=1;
        c[a[i][1]]++;
        while (l<=m)
        {
            if (c[a[i][r]]>1)
            {
                c1[i][l]=max(c1[i][l],c1[i][l-1]);
                c[a[i][l]]--;
                l++;
                continue;
            }
            c1[i][l]=max(c1[i][l],r);
            for (int j=l; j<=m; j++)
            {
                c1[i][j]=max(c1[i][j],r);
            }
            if (r==m)
            {
                break;
            }
            if (r<m)
            {
                r++;
                c[a[i][r]]++;
            }
        }
    }
    for (int i=1; i<=m; i++)
    {
        for (int j=1; j<=20000; j++)
        {
            c[j]=0;
        }
        int l=1, r=1;
        c[a[1][i]]++;
        while (l<=n)
        {
            if (c[a[r][i]]>1)
            {
                c2[l][i]=max(c2[l][i],c2[l-1][i]);
                c[a[l][i]]--;
                l++;
                continue;
            }
            c2[l][i]=max(c2[l][i],r);
            for (int j=l; j<=n; j++)
            {
                c2[j][i]=r;
            }
            if (r==n)
            {
                break;
            }
            if (r<n)
            {
                r++;
                c[a[r][i]]++;
            }
        }
    }
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            unsigned long long H=0;
            for (int k=j; k<=m; k++)
            {
                H^=Zobrist[a[i][k]];
                h[i][j][k]=H;
            }
        }
    }
    int ans=n*m;
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++)
        {
            int l=j;
            int r=c1[i][j];
            int k=1e9;
            for (int j1=l; j1<=r; j1++)
            {
                k=min(k,c2[i][j1]);
            }
            //cout<<i<<" "<<j<<" "<<l<<" "<<r<<" "<<k<<endl;
            if (l==r||k==i) continue;
            bool can=true;
            if (c1[i][j]-j==k-i)
            {
                for (int y=i+1; y<=k; y++)
                {
                    if (h[y][l][r]!=h[y-1][l][r])
                    {
                        can=false;
                        break;
                    }
                }
                if (can)
                {
                    ans++;
                }
            }
        }
    }
    cout<<ans;
}
