#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

#define ll long long
#define pii pair<int, int>

using namespace std;

bool check(int x, int y, int k, vector<vector<int>> &a) {
    set<int> st;
    for (int i = x; i < x + k; i++)
    {
        set<int> row;
        for (int j = y; j < y + k; j++)
        {
            st.insert(a[i][j]);
            row.insert(a[i][j]);
        }
        if (row.size() != k)
            return false;
    }
    for (int j = y; j < y + k; j++)
    {
        set<int> col;
        for (int i = x; i < x + k; i++)
        {
            st.insert(a[i][j]);
            col.insert(a[i][j]);
        }
        if (col.size() != k)
            return false;
    }
    if (st.size() != k)
        return false;
    return true;
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++)
        {
            a[i][j] = (s[2 * j] - 33) * 100 + s[2 * j + 1] - 33;
        }
    }

    int ans = 0;
    for (int k = 1; k <= min(n, m); k++)
    {
        for (int i = 0; i + k - 1 < n; i++)
        {
            for (int j = 0; j + k - 1 < m; j++)
            {
                ans += check(i, j, k, a);
            }
        }
    }
    cout << ans;
}