#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &a, const T2 &b) {if (a > b) a = b;}
template<class T1, class T2> inline void chkmax(T1 &a, const T2 &b) {if (a < b) a = b;}
#define files(FILENAME) read(FILENAME); write(FILENAME)
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define left left228
#define right right228
#define y1 y1228
#define mp make_pair
#define pb push_back
#define y2 y2228
using ll = long long;
using ld = long double;
const string FILENAME = "input";
const int MAXN = 2005;



char readchar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int n, m;
char s[MAXN][MAXN];
int a[MAXN][MAXN];
int up[MAXN][MAXN];
int right[MAXN][MAXN];
int last[10000];
ll megahash[10000];
mt19937 as;
ll sum[MAXN][MAXN];

int  main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//read(FILENAME);
	as.seed(228);
	scanf("%d %d\n", &n, &m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j++) {
			s[i][j] = readchar();
		}
	}	
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			a[i][j] = ((int)s[i - 1][(j - 1) * 2] - 33) * 94 + (int)s[i - 1][(j - 1) * 2 + 1] - 33;
		}
	}
	//calc how long all unique horizontally
	for (int i = 1; i <= n; i++) {
		for (int j = m; j >= 1; j--) {
			last[a[i][j]] = m + 1;
		}
		int cur = m;
		for (int j = m; j >= 1; j--) {
			chkmin(cur, last[a[i][j]] - 1);
			right[i][j] = cur;
			last[a[i][j]] = j;
		}
	}
	for (int i = 1; i <= m; i++) {
		for (int j = n; j >= 1; j--) {
			last[a[j][i]] = n + 1;
		}
		int cur = n;
		for (int j = n; j >= 1; j--) {
			chkmin(cur, last[a[j][i]] - 1);
			up[j][i] = cur;
			last[a[j][i]] = j;
		}
	}
	for (int i = 0; i <= 10000; i++) {
		megahash[i] = ((ll)as() << 31) + as();
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			sum[i][j] = megahash[a[i][j]] + sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1];
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			int k = min(n - i + 1, m - j + 1);
			int curmup = 1e9, curmright = 1e9;
			ll cur = 0;
			int ti = i;
			int tj = j;
			for (int s = 1; s <= k; s++) {
				cur += megahash[a[ti][j]];
				chkmin(curmup, up[i][tj]);
				chkmin(curmright, right[ti][j]);
				if (curmup < ti || curmright < tj) {
					break;
				}
				if (sum[ti][tj] - sum[ti][j - 1] - sum[i - 1][tj] + sum[i - 1][j - 1] == cur * s) {
					ans++;
				}
				ti++;
				tj++;
			}
		}
	}
	cout << ans << '\n';
	return 0;
}
