#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;

const int N = 30000;
int main() {
    int n, m;
    cin >> n >> m;
    vvi a(n, vi(m));
    forn(i, n){
        string s;
        cin >> s;
        forn(j, m){
            int x = s[j * 2], y = s[j * 2 + 1];
            a[i][j] = x * 200 + y;
        }
    }
    int ans = 0;
    vvi up(n, vi(m, -1)), left(n, vi(m, -1));
    forn(i, n){
        vi last(N, -1);
        forn(j, m){
            left[i][j] = last[a[i][j]];
            last[a[i][j]] = j;
        }
    }
    forn(j, m){
        vi last(N, -1);
        forn(i, n){
            up[i][j] = last[a[i][j]];
            last[a[i][j]] = i;
        }
    }
    vb used(N);
    forn(i, n){
        forn(j, m){
            int maxx = min(n - i, m - j);
            vi I;
            int cnt = 0;
            bool flag = 1;
            for (int sz = 1; sz <= maxx; ++sz){
                forn(z, sz){
                    int x = a[i + sz - 1][j + z], y = a[i + z][j + sz - 1];
                    if (left[i + sz - 1][j + z] >= j || up[i + sz - 1][j + z] >= i) flag = 0;
                    if (left[i + z][j + sz - 1] >= j || up[i + z][j + sz - 1] >= i) flag = 0;
                    if (!used[x]){
                        used[x] = 1;
                        I.pb(x);
                        cnt++;
                    }
                    if (!used[y]){
                        used[y] = 1;
                        I.pb(y);
                        cnt++;
                    }
                }
                if (!flag) break;
                if (cnt == sz) ans++;
                if (cnt > maxx) break;
            }
            for (int z : I) used[z] = 0;
        }
    }
    cout << ans << '\n';
    return 0;
}