#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<string>

using namespace std;

long long gcd(long long a, long long b) {
	if (a < b) {
		swap(a, b);
	}
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> p(n,vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;
			p[i][j] = (a - 33) * 10 + b - 33;
		}
	}
	vector<vector<int>> lx(n, vector<int>(m));
	vector<vector<int>> ly(n, vector<int>(m));
	map<int, int> mp;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			lx[i][j] = mp[p[i][j]];
			mp[p[i][j]] = j + 1;
		}
		for (int j = 0; j < m; j++) {
			mp[p[i][j]] = 0;
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			ly[j][i] = mp[p[j][i]];
			mp[p[j][i]] = j + 1;
		}
		for (int j = 0; j < n; j++) {
			mp[p[j][i]] = 0;
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int sz = 1; sz < 1e9; sz+=0) {
				if (i - sz + 1 < 0 || j - sz + 1 < 0) {
					break;
				}
				bool t = true;
				set<int> se;
				for (int i1 = i - sz + 1; i1 <= i; i1++) {
					for (int j1 = j - sz + 1; j1 <= j; j1++) {
						if (lx[i1][j1] > j - sz + 1 || ly[i1][j1] > i - sz + 1) {
							t = false;
							break;
						}
						se.insert(p[i1][j1]);
					}
				}
				if (t && se.size() == sz) {
					ans++;
					sz *= 2;
				}
				else {
					sz++;
				}
			}
		}
	}
	cout << ans;
}