#include<bits/stdc++.h>

using namespace std;

const int K = 1e4;
const int N = 501;

int a[N][N];

int nrl[N][N];
int nrd[N][N];

int ps[N][N][N];

int wr[K];
int cnt[K];
vector<pair<int, int>> who[K];

int n, m;

void init() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> s;
			for (int tj = j; tj < m; tj++) {
            	if (s.count(a[i][tj])) break;
            	else s.insert(a[i][tj]);	
            }
            nrl[i][j] = (int)s.size();
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> s;
			for (int ti = i; ti < n; ti++) {
            	if (s.count(a[ti][j])) break;
            	else s.insert(a[ti][j]);	
            }
            nrd[i][j] = (int)s.size();
		}                
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cnt[a[i][j]]++;
			who[a[i][j]].push_back({i, j});
		}
	}
	int pnt = 0;
	for (int k = 0; k < K; k++) {
		if (cnt[k] < N) continue;
		wr[k] = pnt;
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				ps[pnt][i][j] = ps[pnt][i - 1][j] + ps[pnt][i][j - 1] - ps[pnt][i - 1][j - 1] + (a[i - 1][j - 1] == k);
			}
		}
		pnt++;
	}
}

int ch(int i, int j, int len, int x) {
	if (cnt[x] < N) {
		int c = 0;
	 	for (auto t : who[x]) {
	 		c += ((i <= t.first && t.first < i + len) && (j <= t.second && t.second < j + len));
	 	}
	 	return c == len;
	}
	x = wr[x];
	int v = ps[x][i + len][j + len] - ps[x][i + len][j] - ps[x][i][j + len] + ps[x][i][j];
	return v == len;
}

int read() {
	char a, b;
	cin >> a >> b;
	assert(a >= 33);
	assert(b >= 33);
	int res = 100 * (a - 33) + (b - 33);
	assert(res < K); 
	return res;
}

int solve(int i, int j) {
	int ans = 0;
	for (int len = 1; i + len <= n && j + len <= m; len++) {
		int ti = i + len - 1;
		int tj = j + len - 1;
		int ok = 1;
		for (int fi = i; fi <= ti; fi++) ok &= (nrl[fi][j] >= len);
		for (int fj = j; fj <= tj; fj++) ok &= (nrd[i][fj] >= len);
		for (int fi = i; fi <= ti; fi++) ok &= (ch(i, j, len, a[fi][j]));
		if (ok) ans++;
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
   	
   	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			a[i][j] = read();
		}
	}
	init();
	int ans = 0;
	for (int i = 0; i < n; i++) {
	 	for (int j = 0; j < m; j++) {
	 		ans += solve(i, j);
	 	}
	}
	cout << ans << endl;
}                      