#include <iostream>
#include <map>

using namespace std;

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m;
	cin >> n >> m;
	char b[n][2 * m];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j++) {
			cin >> b[i][j];
		}
	}
	string a[n][m];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j += 2) {
			string s1 = "";
			s1 += b[i][j];
			s1 += b[i][j + 1];
			a[i][j / 2] = s1;
		}
	}

	int ans = 0;
	for (int x1 = 0; x1 < n; x1++) {
		for (int y1 = 0; y1 < m; y1++) {
			for (int x2 = x1; x2 < n; x2++) {
				for (int y2 = y1; y2 < m; y2++) {
					// проверка на квадрат
					if (y2 - y1 + 1 != x2 - x1 + 1) {
						continue;
					}

					// (x1, y1) - координаты верхнего левого угла
					// (x2, y2) - координаты нижнего правого угла

					// проверка на содерждание ровно k различных элементов
					map<string, int> stg;
					for (int i = x1; i <= x2; i++) {
						for (int j = y1; j <= y2; j++) {
							stg[a[i][j]]++;
						}
					}
					if (stg.size() != (x2 - x1 + 1)) {
						continue;
					}

					bool flag = false;

					// проверка на различие в строках
					for (int i = x1; i <= x2; i++) {
						map<string, int> stg;
						for (int j = y1; j <= y2; j++) {
							stg[a[i][j]]++;
						}
						if (stg.size() != x2 - x1 + 1) {
							flag = true;
							break;
						}
					}
					if (flag)
						continue;

					// проверка на различие в столбцах
					for (int i = y1; i <= y2; i++) {
						map<string, int> stg;
						for (int j = x1; j <= x2; j++) {
							stg[a[j][i]]++;
						}
						if (stg.size() != x2 - x1 + 1) {
							flag = true;
							break;
						}
					}

					if (flag)
						continue;

					ans++;
				}
			}
		}
	}
	cout << ans;
} 