#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(f, a.size()) cout << a[f] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x << '\n'
#define ff first
#define ss second
#define sz(a) (a).size()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef long double ld;

#define int ll

bool check(int x1, int y1, int x2, int y2, vector <vi> &pref){
    int sum = pref[y2][x1] - (y1? pref[y1 - 1][x1] : 0) - (x1?pref[y2][x1 - 1]:0) + (x1 && y1? pref[y1 - 1][x1 - 1] : 0);
    set <int> sums;
    sums.insert(sum);
    fori(i, x1 + 1, x2 + 1){
        int tsum = pref[y2][i] - (y1? pref[y1 - 1][i] : 0) - (i?pref[y2][i - 1]:0) + (i && y1? pref[y1 - 1][i - 1]:0);
        sums.insert(tsum);
        if(sums.size() != 1)
            return 0;
    }
    fori(i, y1 + 1, y2 + 1){
        int tsum = pref[i][x2] - (x1? pref[i][x1 - 1] : 0) - (i?pref[i - 1][x2]:0) + (i && x1? pref[i - 1][x1 - 1]:0);
        sums.insert(tsum);
        if(sums.size() != 1)
            return 0;
    }
    return 1;
}

void run() {
    int n, m;
    cin >> n >> m;
    vector <string> inp(n);
    vector <vector <int>> a(n, vector <int>(m));
    set <string> co;
    foru(i, n){
        string s;
        cin >> s;
        inp[i] = s;
        foru(j, m){
            co.insert(string(s.begin() + j * 2, s.begin() + j * 2 + 2));
        }
    }
    int temp = 0;
    map <string, int> code;
    for(auto i : co){
        code[i] = temp;
        temp+=170;
    }
    foru(i, n){
        foru(j, m){
            a[i][j] = code[string(inp[i].begin() + j * 2, inp[i].begin() + j * 2 + 2)];
        }
    }
    vector <vector <int>> pref(n, vector <int>(m));
    int ans = 0;
    foru(i, n){
        foru(j, m){
            pref[i][j] = (i?pref[i - 1][j] : 0)+ (j?pref[i][j - 1] : 0) - (i&&j?pref[i-1][j-1] : 0) + a[i][j];
        }
    }
    cout.flush();
    foru(i, n){
        foru(j, m){
            for(int k = 1; k <= min(i, j) + 1; ++k){
                ans += check(j - k + 1, i - k + 1, j, i, pref);
            }
        }
    }
    cout << ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
    return 0;
}
