#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> pole(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char a, b;
            cin >> a >> b;
            pole[i][j] = (int(a) - 33) * 94 + int(b) - 33;
        }
    }
    int ans = (n * m);
    for (int k = 2; k <= min(n, m); ++k) {
        for (int l = 0; l + k <= n; ++l) {
            for (int r = 0; r + k <= m; ++r) {
                bool kruto = true;
                vector<set<int>> tmp(k + k);
                for (int x = 0; x < k && kruto; ++x) {
                    for (int y = 0; y < k && kruto; ++y) {
                        tmp[x].insert(pole[l + x][r + y]);
                    }
                    if (tmp[x].size() != k)
                        kruto = false;
                    if (x != 0)
                        if (tmp[x] != tmp[x - 1])
                        kruto = false;
                }
                for (int x = 0; x < k && kruto; ++x) {
                    for (int y = 0; y < k && kruto; ++y) {
                        tmp[x + k].insert(pole[l + y][r + x]);
                    }
                    if (tmp[x + k].size() != k)
                        kruto = false;
                    if (tmp[x + k] != tmp[x + k - 1])
                        kruto = false;
                }
                if (kruto) {
                    ++ans;
                }
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
