#include <bits/stdc++.h>
#define endl '\n'
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
using namespace std;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}
mt19937 rnd(2007);
const int mod = (int) 1e9 + 7;

const int maxn = 2007;
const int CNT = 10000;
int a[maxn][maxn];
int h[maxn][maxn];
int lgst[maxn];
int hshvals[CNT];
int n, m;

void read_square(){
    forn (i, n){
        string s; cin >> s;
        forn (j, m){
            a[i][j] = (s[i * 2 + 1] - 33) * 95 + (s[i * 2] - 33);
        }
    }
}

void solve(){
    cin >> n >> m;
    forn (i, CNT) hshvals[i] = rnd() % mod;
    read_square();

    forn (i, n){
        forn (j, m){
            a[i][j] = hshvals[a[i][j]];
        }
    }
    
    long long ans = 0;
    for (int k = 1; k <= n && k <= m; ++k){
        for (int i = 0; i < n; ++i){
            h[i][m - k] = 0;
            for (int v = k; v >= 1; --v){
                h[i][m - k] += a[i][m - v];
                if (h[i][m - k] >= mod)
                    h[i][m - k] -= mod;
            }
            for (int v = m - k - 1; v >= 0; --v){
                h[i][v] = h[i][v  + 1] + a[i][v];
                if (h[i][v] >= mod) h[i][v] -= mod;
                h[i][v] -= a[i][v + k];
                if (h[i][v] < 0) h[i][v] += mod;
            }
        }
        for (int j = 0; j + k <= m; ++j) {
            for (int i = 0; i + k <= n; ++i) {
                if (i == 0 || h[i][j] != h[i - 1][j]) lgst[i] = 0;
                lgst[i]++;
                if (lgst[i] >= k)
                    ++ans;
            }
        }
    }
    cout << ans << endl;
}
