#include <iostream>
#include <assert.h>
#include <bitset>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define vbb vector<bool>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

vector<vector<string> > a;

int convert(string& st)
{

    return ((int)st[0] - 33) * 127 + ((int)st[1] - 33);
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, m;
    cin >> n >> m;

    a.resize(n, vector<string> (m));
    for(int i = 0; i < n; i++)
    {
        string cur;
        cin >> cur;
        for(int j = 0; j < m; j++)
        {
            string temp = "";
            temp += cur[j * 2];
            temp += cur[j * 2 + 1];
            a[i][j] = temp;

         //   cerr << "temp " << temp << endl;
         //   cerr << ((int)(temp[0])) << " " << ((int)(temp[1])) << endl;
        }
    }

    ll answ = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            answ++;
            vector<bitset<15877> > usedHor(1);
            usedHor[0][convert(a[i][j])] = 1;

            vector<bitset<15877> > usedVer(1);
            usedVer[0][convert(a[i][j])] = 1;

            bitset<15877> totalUsed;
            totalUsed[convert(a[i][j])] = 1;
            ll cnt = 1;

       //     cerr << "start " << i << " " << j << endl;
            for(int k = 1; k < min(n - i, m - j); k++)
            {
            //    cerr << "k " << k << endl;
                bool flag = 0;
                bitset<15877> temp;
                usedHor.pb(temp);
                usedVer.pb(temp);

                for(int t = 0; t <= k; t++)
                {
                    string newEl = a[i + k][j + t];
                    if(totalUsed[convert(newEl)] == 0)
                    {
                        totalUsed[convert(newEl)] = 1;
                        cnt++;
                    }
                    if(usedVer[t][convert(newEl)] || usedHor.back()[convert(newEl)])
                    {
                        flag = 1;
                        break;
                    }
                    usedVer[t][convert(newEl)] = 1;
                    usedHor.back()[convert(newEl)] = 1;
                }
                for(int t = 0; t < k; t++)
                {
                    string newEl = a[i + t][j + k];
                    if(totalUsed[convert(newEl)] == 0)
                    {
                        totalUsed[convert(newEl)] = 1;
                        cnt++;
                    }
                    if(usedHor[t][convert(newEl)] || usedVer.back()[convert(newEl)])
                    {
                        flag = 1;
                        break;
                    }
                    usedHor[t][convert(newEl)] = 1;
                    usedVer.back()[convert(newEl)] = 1;
                }
                if(flag)
                    break;
                if(cnt == k + 1)
                    answ++;
            }
        }
    }
    cout << answ << endl;
    return 0;
}