#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

#define x1 x228
#define y1 y228

const int A = 126 - 33 + 1;
const int A2 = A * A;
const int maxN = 2003;
int grid[maxN][maxN];

/*struct Hash
{
    static const int MA = 998244353, MB = 100992299;

    int a, b;

    Hash(): a(0), b(0)
    {
    }
    Hash(int _a): a(_a), b(_a)
    {
    }
    Hash(int _a, int _b): a(_a), b(_b)
    {
    }

    Hash operator + (const Hash &x) const
    {
        return Hash((a + x.a) % MA, (b + x.b) % MB);
    }
    Hash operator + (int x) const
    {
        return Hash((a + x) % MA, (b + x) % MB);
    }
    Hash operator - (const Hash &x) const
    {
        return Hash((a - x.a + MA) % MA, (b - x.b + MB) % MB);
    }
    Hash operator - (int x) const
    {
        return Hash((a - x + MA) % MA, (b - x + MB) % MB);
    }
    Hash operator * (const Hash &x) const
    {
        return Hash(a * (ll)x.a % MA, b * (ll)x.b % MB);
    }
    Hash operator * (int x) const
    {
        return Hash(a * (ll)x % MA, b * (ll)x % MB);
    }
    bool operator == (const Hash &x) const
    {
        return a == x.a && b == x.b;
    }
};
const Hash B(2);*/
using Hash = ll;
Hash pw[1000005];

int cnt[1000005];

bool valid_row[maxN][maxN];
Hash H_row[maxN][maxN];
int dp_row[maxN][maxN];
bool valid_col[maxN][maxN];
Hash H_col[maxN][maxN];
int dp_col[maxN][maxN];

signed main() {
#ifdef DEBUG
  freopen("in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  /*pw[0] = Hash(1);
  for (int i = 1; i < A2; ++i) {
    pw[i] = pw[i - 1] * B;
  }*/
  mt19937_64 rng(time(0));
  for (int c = 0; c < A2; ++c) {
    pw[c] = rng() % ((ll)1e12);
  }

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    string t;
    cin >> t;
    for (int j = 0; j < 2 * m; j += 2) {
      grid[i][j / 2] = ((int)t[j] - 33) * A + ((int)t[j + 1] - 33);
    }
  }
  ll ans = 0;
  for (int k = 1; k <= n; ++k) {
    for (int i = 0; i < n; ++i) {
      int one = 0;
      Hash sum = 0;
      auto add = [&](int x) {
        cnt[x]++;
        sum = sum + pw[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 2) {
          --one;
        }
      };
      auto rem = [&](int x) {
        cnt[x]--;
        sum = sum - pw[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 0) {
          --one;
        }
      };
      for (int j = 0; j < k; ++j) {
        add(grid[i][j]);
      }
      for (int l = 0, r = l + k - 1; r < m; ++l, ++r) {
        valid_row[i][l] = (one == k);
        H_row[i][l] = sum;
        if (r + 1 < m) {
          rem(grid[i][l]);
          add(grid[i][r + 1]);
        }
      }
      for (int j = m - k; j < m; ++j) {
        rem(grid[i][j]);
      }
    }
    for (int l = 0; l + k - 1 < m; ++l) {
      for (int i = 0; i < n; ++i) {
        if (!valid_row[i][l]) {
          dp_row[i][l] = 0;
        } else {
          dp_row[i][l] = 1;
          if (i > 0 && valid_row[i - 1][l] && H_row[i - 1][l] == H_row[i][l]) {
            dp_row[i][l] += dp_row[i - 1][l];
          }
        }
      }
    }
    // col
    for (int j = 0; j < m; ++j) {
      int one = 0;
      Hash sum = 0;
      auto add = [&](int x) {
        cnt[x]++;
        sum = sum + pw[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 2) {
          --one;
        }
      };
      auto rem = [&](int x) {
        cnt[x]--;
        sum = sum - pw[x];
        if (cnt[x] == 1) {
          ++one;
        } else if (cnt[x] == 0) {
          --one;
        }
      };
      for (int i = 0; i < k; ++i) {
        add(grid[i][j]);
      }
      for (int l = 0, r = l + k - 1; r < n; ++l, ++r) {
        valid_col[l][j] = (one == k);
        H_col[l][j] = sum;
        if (r + 1 < n) {
          rem(grid[l][j]);
          add(grid[r + 1][j]);
        }
      }
      for (int i = n - k; i < n; ++i) {
        rem(grid[i][j]);
      }
    }
    for (int l = 0; l + k - 1 < n; ++l) {
      for (int j = 0; j < m; ++j) {
        if (!valid_col[l][j]) {
          dp_col[l][j] = 0;
        } else {
          dp_col[l][j] = 1;
          if (j > 0 && valid_col[l][j - 1] && H_col[l][j - 1] == H_col[l][j]) {
            dp_col[l][j] += dp_col[l][j - 1];
          }
        }
      }
    }
    // combine
    for (int i = 0; i + k - 1 < n; ++i) {
      for (int j = 0; j + k - 1 < m; ++j) {
        if (dp_row[i + k - 1][j] >= k && dp_col[i][j + k - 1] >= k && H_row[i][j] == H_col[i][j]) {
          ++ans;
        }
      }
    }
  }
  cout << ans << '\n';

  return 0;
}

