#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

const int N = 500;

int n, m;
int a[N][N];
int dp[2][N][N];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c, d;
            cin >> c >> d;
            a[i][j] = (c - 33) * (126 - 33 + 1) + d - 33;
        }
    }
    for (int i = 0; i < n; ++i) {
        queue<int> q;
        set<int> s;
        for (int j = 0; j < m; ++j) {
            q.push(a[i][j]);
            while (s.find(a[i][j]) != s.end()) {
                s.erase(q.front());
                q.pop();
            }
            s.insert(a[i][j]);
            dp[0][i][j] = q.size();
        }
    }
    for (int j = 0; j < m; ++j) {
        queue<int> q;
        set<int> s;
        for (int i = 0; i < n; ++i) {
            q.push(a[i][j]);
            while (s.find(a[i][j]) != s.end()) {
                s.erase(q.front());
                q.pop();
            }
            s.insert(a[i][j]);
            dp[1][i][j] = q.size();
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            set<int> s;
            bool flag = false;
            for (int d = 0; i - d >= 0 && j - d >= 0; ++d) {
                for (int x = i - d; x <= i; ++x) {
                    s.insert(a[x][j - d]);
                    flag |= (dp[0][x][j] <= d);
                }
                for (int y = j - d; y <= j; ++y) {
                    s.insert(a[i - d][y]);
                    flag |= (dp[1][i][y] <= d);
                }
                if (flag) {
                    break;
                }
                /*if (s.size() == d + 1 && d != 0) {
                    cout << "kek\n";
                }*/
                ans += (s.size() == d + 1);
            }
        }
    }
    cout << ans << '\n';
    return 0;
}