#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 5e2 + 2;
const int M = 1e9 + 7;

int a[N][N];

const int SZ = 10000;

vector < vector < vector < int > > > dp;

int cnt(int x1, int y1, int x2, int y2, int c) {
    int ans = dp[x2][y2][c];
    if (x1) {
        ans -= dp[x1 - 1][y2][c];
    }
    if (y1) {
        ans -= dp[x2][y1 - 1][c];
    }
    if (x1 && y1) {
        ans += dp[x1 - 1][y1 - 1][c];
    }
    return ans;
}

int get(int x1, int y1, int x2, int y2) {
    int res = 0;
    for (int c = 0; c < SZ; ++c) {
        res += (cnt(x1, y1, x2, y2, c) > 0);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    dp.resize(n, vector < vector < int > > (m, vector < int > (SZ)));
    string s;
    int c;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        for (int j = 0; j < m; ++j) {
            c = int(s[j * 2]) - 33;
            c *= 100;
            c += int(s[j * 2 + 1]) - 33;
            dp[i][j][c] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int c = 0; c < SZ; ++c) {
                if (i) {
                    dp[i][j][c] += dp[i - 1][j][c];
                }
                if (j) {
                    dp[i][j][c] += dp[i][j - 1][c];
                }
                if (i && j) {
                    dp[i][j][c] -= dp[i - 1][j - 1][c];
                }
            }
        }
    }
    int ans = 0;
    bool f;
    for (int sz = 1; sz < SZ; ++sz) {
        for (int i = sz - 1; i < n; ++i) {
            for (int j = sz - 1; j < m; ++j) {
                if (get(i - sz + 1, j - sz + 1, i, j) != sz) {
                    continue;
                }
                f = 1;
                for (int I = i - sz + 1; I <= i; ++I) {
                    if (get(I, j - sz + 1, I, j) != sz) {
                        f = 0;
                        break;
                    }
                }
                for (int J = j - sz + 1; J <= j; ++J) {
                    if (get(i - sz + 1, J, i, J) != sz) {
                        f = 0;
                        break;
                    }
                }
                if (f) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
