#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "\n";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll n, m;
vector<vector<int> > A;

bool check(int i, int j, int k)
{
    for (int i1 = i; i1 <= i + k; i1++)
    {
        map<int, int> z;
        for (int j1 = j; j1 <= j + k; j1++)
        {
            int x = A[i1][j1];
            if (z[x] == 1)
                return false;
            z[x]++;
        }
    }
    for (int j1 = j; j1 <= j + k; j1++)
    {
        map<int, int> z;
        for (int i1 = i; i1 <= i + k; i1++)
        {
            ll x = A[i1][j1];
            if (z[x] == 1)
                return false;
            z[x]++;
        }
    }
    return true;
}

int main()
{
    fast();
    cin >> n >> m;
    A.resize(n, vector<int> (m));
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m * 2; j += 2)
        {
            char c = s[j];
            char c1 = s[j + 1];
            A[i][j / 2] = (int(c) - 30) * 1000 + int(c1) - 33;
        }
    }
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            set<int> r;
            for (int k = 0; k + i < n && k + j < m && k < 10000; k++)
            {
                for (ll t = i; t <= i + k; t++)
                {
                    r.insert(A[t][j + k]);
                }
                for (ll t = j; t <= j + k; t++)
                {
                    r.insert(A[i + k][t]);
                }
                if (r.size() != k + 1)
                    continue;
                if (check(i, j, k))
                {
                    ans++;
                }
            }
        }
    }
    cout << ans;
}
