#pragma GCC optimize("Ofast")

#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	cin >> n >> m;

	vector<vector<int>> a(n, vector<int>(m));

	char ch1, ch2;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			cin >> ch1 >> ch2;
			a[i][j] = ch1 * 128 + ch2;
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			vector<set<int>> col, raw;
			set<int> elem;
			for (int len = 1; i + len <= n && j + len <= m; ++len)
			{
				col.push_back(set<int>()), raw.push_back(set<int>());

				bool ok = true;

				for (int x = i; x < i + len; ++x)
				{
					if (raw[len - 1].count(a[x][j + len - 1]))
						ok = false;
					else
						raw[len - 1].insert(a[x][j + len - 1]);

					if (col[x - i].count(a[x][j + len - 1]))
						ok = false;
					else
						col[x - i].insert(a[x][j + len - 1]);
				}

				for (int y = j; y < j + len - 1; ++y)
				{
					if (col[len - 1].count(a[i + len - 1][y]))
						ok = false;
					else
						col[len - 1].insert(a[i + len - 1][y]);

					if (raw[y - j].count(a[i + len - 1][y]))
						ok = false;
					else
						raw[y - j].insert(a[i + len - 1][y]);
				}

				if (ok)
				{
					for (auto x : col.back())
						elem.insert(x);
					for (auto x : raw.back())
						elem.insert(x);

					if (elem.size() == len)
						++cnt;
				}
				else
					break;
			}
		}
	}

	cout << cnt << endl;


	return 0;
}