#pragma GCC target("avx2")
#pragma GCC optimization("O3,unroll-loops,fast-math")

#include <ext/pb_ds/assoc_container.hpp>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace __gnu_pbds;
using namespace std;

typedef long long ll;
typedef gp_hash_table<int, bool> heh_map;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

const int p = 127;
const int MAXN = 100;

int n, m;
//vector<vector<int>> a;
int a[MAXN][MAXN];

inline void insert(heh_map &m, int val) {
    m[val] = true;
}

void solve() {
    cin >> n >> m;
    //a.resize(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (x - 33 + 1) * p + (y - 33 + 1);
        }
    }

    int ans = n * m;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int k = 1;

            //cout << "i,j" sp i+1 sp j+1 nl;

            //set<int> gl;
            //vector<set<int>> x, y;

            heh_map gl;
            //vector<heh_map> x, y;
            vector<heh_map> x(n - i + 1), y(m - j + 1);

            //x.push_back({a[i][j]});
            //y.push_back({a[i][j]});
            //gl.insert(a[i][j]);

            //x.push_back({});
            //y.push_back({});
            insert(x[0], a[i][j]);
            insert(y[0], a[i][j]);
            insert(gl, a[i][j]);

            while (i + k < n && j + k < m) {
                for (int f = 0; f < k; ++f) {
                    //x[f].insert(a[i + f][j + k]);
                    //gl.insert(a[i + f][j + k]);
                    //insert(gl, a[i + f][j + k]);
                    gl[a[i + f][j + k]] = 1;
                    //insert(x[f], a[i + f][j + k]);
                    x[f][a[i + f][j + k]] = 1;
                }

                for (int f = 0; f < k; ++f) {
                    //y[f].insert(a[i + k][j + f]);
                    //gl.insert(a[i + k][j + f]);
                    //insert(gl, a[i + k][j + f]);
                    //insert(y[f], a[i + k][j + f]);
                    gl[a[i + k][j + f]] = 1;
                    y[f][a[i + k][j + f]] = 1;
                }

                //x.push_back(set<int>());
                //y.push_back(set<int>());
                //x.push_back({});
                //y.push_back({});

                for (int f = 0; f <= k; ++f) {
                    //x[k].insert(a[i + k][j + f]);
                    //gl.insert(a[i + k][j + f]);
                    //insert(gl, a[i + k][j + f]);
                    //insert(x[k], a[i + k][j + f]);
                    x[k][a[i + k][j + f]] = 1;
                    gl[a[i + k][j + f]] = 1;
                }

                for (int f = 0; f <= k; ++f) {
                    //y[k].insert(a[i + f][j + k]);
                    //gl.insert(a[i + f][j + k]);
                    //insert(gl, a[i + f][j + k]);
                    //insert(y[k], a[i + f][j + k]);
                    gl[a[i + f][j + k]] = 1;
                    y[k][a[i + f][j + k]] = 1;
                }

                bool flag = true;

                for (int f = 0; f <= k; ++f) {
                    flag &= x[f].size() == k + 1;
                    flag &= y[f].size() == k + 1;
                }

                if (gl.size() == k + 1 && flag) {
                    //cout << "k" sp k nl;
                    ans += 1;
                }

                k += 1;
            }
        }
    }

    cout << ans nl;
}

/**

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

**/
