#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long

vector<vector<vector<char>>> used;

bool check(vector<vector<short>> &a, int x1, int y1, int x2, int y2) {
    set<short> solver;
    int k = x2 - x1 + 1;
    for (int i = x1; i <= x2; ++i) {
        for (int j = y1; j <= y2; ++j) {
            solver.emplace(a[i][j]);
        }
    }
    if (solver.size() != k)
        return 0;

    for (int i = x1; i <= x2; ++i) {
        set<short> s;
        for (int j = y1; j <= y2; ++j) {
            s.emplace(a[i][j]);
        }
        if (s.size() != k)
            return 0;
    }

    for (int j = y1; j <= y2; ++j) {
        set<short> s;
        for (int i = x1; i <= x2; ++i) {
            s.emplace(a[i][j]);
        }
        if (s.size() != k)
            return 0;
    }
    return 1;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    int n, m;
    cin >> n >> m;
    vector<string> s(n);
    for (auto &i : s)
        cin >> i;

    vector<vector<short>> a(n, vector<short> (m));
    used.resize(n, vector<vector<char>> (m, vector<char> (max(n, m) + 1)));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m * 2; j += 2) {
            a[i][j / 2] = s[i][j] * 127 + s[i][j + 1];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k + i < n && k + j < m; ++k) {
                if (!used[i][j][k]) {
                    bool res = check(a, i, j, i + k, j + k);
                    ans += res;
                    for (int cur = k; cur < 2 * k && cur <= max(n, m); ++cur) {
                        used[i][j][k] = 1;
                    }
                }
            }
        }
    }
    cout << ans;
    return 0;
}
