#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2005, P = 127;

int mat[N][N], a[N][N], mx_col[N], mx_row[N][N], mn[N][N];

int solve(int n, int m, int s) {
    for (int j = 1; j <= m; ++j) {
        mx_col[j] = 0;
        unordered_map<int, int> cnt;
        for (int i = 1; i <= n; ++i) {
            if (cnt[a[i][j]]) {
                break;
            }
            cnt[a[i][j]]++;
            ++mx_col[j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (i == 1) {
                mn[i][j] = mx_row[s + i][j];
            } else {
                mn[i][j] = min(mn[i - 1][j], mx_row[s + i][j]);
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        int last_bad = 0;
        unordered_map<int, int> cnt;
        for (int j = 1; j <= m; ++j) {
            for (int i1 = 1; i1 <= i; ++i1) {
                cnt[a[i1][j]]++;
                if (j > i) {
                    cnt[a[i1][j - i]]--;
                }
            }
            bool ok = true;
            for (int i1 = 1; i1 <= i; ++i1) {
                if (cnt[a[i][j]] != i) {
                    ok = false;
                }
            }
            if (mx_col[j] < i) {
                last_bad = j;
                continue;
            }
            if (mn[i][j] < i) {
                continue;
            }
            if (j - last_bad < i) {
                continue;
            }
            if (!ok) {
                continue;
            }
            ans++;
        }
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            mat[i][j] = s[j * 2 - 2] + s[j * 2 - 1] * P;
        }
    }
    for (int i = 1; i <= n; ++i) {
        unordered_map<int, int> last;
        for (int j = 1; j <= m; ++j) {
            mx_row[i][j] = min(mx_row[i][j - 1] + 1, j - last[mat[i][j]]);
            last[mat[i][j]] = j;
        }
    }
    int ans = 0;
    for (int i1 = 1; i1 <= n; ++i1) {
        for (int i = i1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                a[i - i1 + 1][j] = mat[i][j];
            }
        }
        ans += solve(n - i1 + 1, m, i1 - 1);
    }
    cout << ans << "\n";

    return 0;
}
