#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ll long long
#define ull unsigned long long
#define pii pair <int, int>
#define pll pair <long long, long long>
#define cntbit(x) __builtin_popcount(x)
#define pb push_back
#define pf push_front
#define ppb pop_back
#define mp make_pair
#define f first
#define se second

const int inf = 2e9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
uniform_int_distribution <int> range(0, inf);

template <typename T> void Max(T &a, T b) {
    a = max(a, b);
}

template <typename T> void Min(T &a, T b) {
    a = min(a, b);
}

ostream &operator << (ostream &cout, vector <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

ostream &operator << (ostream &cout, set <int> s) {
    cout << "{";
    for(auto &it : s)
        cout << it << ", ";
    cout << "}";
    return cout;
}

const int mod = 1e9 + 7;
const int N = 2e3 + 15;
const int M = 1e4 + 123;
int n, m, a[N][N];
ll ans;

int used[M], row[N][M], col[N][M];
int cntused;

inline void solve() {
    scanf("%d %d\n", &n, &m);
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            char c = getchar();
            char d = getchar();
            a[i][j] = (c - 32) * 100 + (d - 32);
        }
        getchar();
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            ++cntused;
            int cnt = 0;
            for(int k = 1; i - k >= 0 && j - k >= 0; ++k) {
                if(used[a[i - k + 1][j - k + 1]] != cntused)
                    ++cnt;
                bool flag = true;
                used[a[i - k + 1][j - k + 1]] = cntused;
                col[j - k + 1][a[i - k + 1][j - k + 1]] = cntused;
                row[i - k + 1][a[i - k + 1][j - k + 1]] = cntused;
                for(int d = j; d > j - k + 1; --d) {
                    if(col[d][a[i - k + 1][d]] == cntused || row[i - k + 1][a[i - k + 1][d]] == cntused) {
                        flag = false;
                        break;
                    }
                    if(used[a[i - k + 1][d]] != cntused)
                        ++cnt;
                    used[a[i - k + 1][d]] = cntused;
                    col[d][a[i - k + 1][d]] = cntused;
                    row[i - k + 1][a[i - k + 1][d]] = cntused;
                }
                for(int d = i; d > i - k + 1; --d) {
                    if(row[d][a[d][j - k + 1]] == cntused || col[j - k + 1][a[d][j - k + 1]] == cntused) {
                        flag = false;
                        break;
                    }
                    if(used[a[d][j - k + 1]] != cntused)
                        ++cnt;
                    used[a[d][j - k + 1]] = cntused;
                    row[d][a[d][j - k + 1]] = cntused;
                    col[j - k + 1][a[d][j - k + 1]] = cntused;
                }
                if(cnt == k && flag) {
                    ans++;
                    assert(k <= 15);
                }
            }
        }
    }
    cout << ans << endl;
}

main() {
//    ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
    int tt = 1;
    while(tt--)
        solve();
    return 0;
}
