#include <iostream>
#include <vector>
#include <cstring>
#define int long long

using namespace std;

const int N = 2007, M = 1e4 + 7, B = 10007, M1 = 988244353, B2 = 1e9 + 7, M2 = 1e9 + 9;
int f[N][N], maxi[N][N];
long long h[N][N];
long long poww[M];
long long cur[N];
int diff[M];
int last[M];
bool has[M], ok[M];

signed main() {
    //freopen("input.txt", "r", stdin);
    poww[0] = 1;
    for (int i = 1; i < M; i++) {
        poww[i] = (poww[i - 1] * B) % M1;
    }
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < M; i++) ok[i] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            int x = a, y = b;
            f[i][j] = (x - 32) * 100 + (y - 32);
            maxi[i][j] = N;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < M; j++) last[j] = m;
        int cur = m;
        for (int j = m - 1; j >= 0; j--) {
            cur = min(cur, last[f[i][j]]);
            maxi[i][j] = min(maxi[i][j], cur - j);
            last[f[i][j]] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < M; i++) last[i] = n;
        int cur = n;
        for (int i = n - 1; i >= 0; i--) {
            cur = min(cur, last[f[i][j]]);
            maxi[i][j] = min(maxi[i][j], cur - i);
            last[f[i][j]] = i;
        }
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            memset(has, 0, sizeof(has));
            int cur = 0;
            for (int len = 1; len <= maxi[i][j]; len++) {
                if (i + len > n || j + len > m) break;
                for (int t = 0; t < len; t++) {
                    if (!has[f[i + len - 1][j + t]]) {
                        has[f[i + len - 1][j + t]] = 1;
                        cur++;
                    }
                    if (!has[f[i + t][j + len - 1]]) {
                        has[f[i + t][j + len - 1]] = 1;
                        cur++;
                    }
                }
                if (cur == len) ans++;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
