#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <math.h>
#include <iomanip>
#include <set>
#define ll long long
#define ld long double

using namespace std;

const int A = 10000;
vector<int> coun1(A);
vector<int> coun2(A);
set<int> bad;

void del() {
    for (auto elem : bad) {
        coun1[elem] = 0;
        coun2[elem] = 0;
    }
    bad.clear();
}

bool check(int x1, int y1, int len, vector<vector<int> > &mat) {
    del();
    for (int i = 0; i < len; i++) {
        for (int j = 0; j < len; j++) {
            int c = mat[x1 + i][y1 + j];
            if (coun1[c] != i)
                return 0;
            bad.insert(c);
            coun1[c]++;
        }
    }

    for (int j = 0; j < len; j++) {
        for (int i = 0; i < len; i++) {
            int c = mat[x1 + i][y1 + j];
            if (coun2[c] != j)
                return 0;
            coun2[c]++;
        }
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<string> mat(n);
    for (int i = 0; i < n; i++) {
        cin >> mat[i];
    }
    vector<vector<int> > val(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int a = mat[i][2 * j] - ' ';
            int b = mat[i][2 * j + 1] - ' ';
            val[i].push_back(a * 100 + b);
        }
    }
    int ans = 0;
    int c1 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int len = 0; len < n; len++) {
                int x1 = i, x2 = i + len;
                int y1 = j, y2 = j + len;
                if (x2 >= n || y2 >= m)
                    break;
                if (check(x1, y1, len + 1, val)) {
                    ans++;
                    if (len == 0)
                        c1++;
                }
            }
        }
    }
    cout << ans << endl;
    //cout << c1 << endl;
}
//*/