#include <iostream>
#include <vector>
#include <string>


using namespace std;


bool check(vector<vector<string>> &a, int k, int i, int j) {
    vector<string> all;
    for (int i1 = i; i1 < i + k; ++i1) {
        for (int j1 = j; j1 < j + k; ++j1) {
            bool is = false;
            for (int l = 0; l < all.size(); ++l) {
                if (all[l] == a[i1][j1]) {
                    is = true;
                    break;
                }
            }
            if (!is)
                all.push_back(a[i1][j1]);
        }
    }

    if (all.size() != k)
        return false;

    for (int i1 = i; i1 < i + k; ++i1) {
        vector<string> curL;
        for (int j1 = j; j1 < j + k; ++j1) {
            for (int l = 0; l < curL.size(); ++l) {
                if (curL[l] == a[i1][j1])
                    return false;
            }
            curL.push_back(a[i1][j1]);
        }
    }


    for (int j1 = j; j1 < j + k; ++j1) {
        vector<string> curL;
        for (int i1 = i; i1 < i + k; ++i1) {
            for (int l = 0; l < curL.size(); ++l) {
                if (curL[l] == a[i1][j1])
                    return false;
            }
            curL.push_back(a[i1][j1]);
        }
    }

    return true;
}



int main() {
    int n, m;
    cin >> n >> m;
    vector<string> b(n);
    vector<vector<string>> a(n, vector<string> (m));
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        for (int j = 0; j < m; ++j) {
            a[i][j] = {b[i][j * 2], b[i][j * 2 + 1]};
        }
    }
    int ans = n * m;
    for (int k = 2; k <= min(n, m); ++k) {
        for (int i = 0; i <= n - k; ++i) {
            for (int j = 0; j <= m - k; ++j) {
                if (check(a, k, i, j)) {
                    ++ans;
                }
            }
        }
    }

    cout << ans;
}
