#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 4e3 + 10;
const int inf = 1e18;

int n, m;
pair<char, char> a[N][N];
int down[N][N];
int rght[N][N];

pii calc(int x, int y)
{
    int mndown = inf;
    int res = 0;
    int lastj = 0;
    bool was = false;

    for (int j = y; j < m; ++j)
    {
        mndown = min(mndown, down[x][j]);
        lastj = j;

        int mxi = -1;

        for (int i = x; i < n; ++i)
            if (abs(i - x) + 1 > mndown || rght[i][y] < abs(j - y) + 1)
                break;
            else
                mxi = i;

        if (mxi == -1)
        {
            was = true;
            break;
        }

        res += abs(mxi - x) + 1;
    }

    if (!was)
        ++lastj;

    return make_pair(res, lastj);
}

bool check(int x1, int y1, int x2, int y2)
{
    int k = 0;
    set<pair<char, char>> allst;

    for (int i = x1; i <= x2; ++i)
    {
        set<pair<char, char>> cur;

        for (int j = y1; j <= y2; ++j)
            if (cur.find(a[i][j]) == cur.end())
            {
                cur.insert(a[i][j]);
                allst.insert(a[i][j]);
            }
            else
                return false;

        cur.clear();
    }

    if (allst.size() != abs(x1 - x2) + 1)
        return false;

    for (int j = y1; j <= y2; ++j)
    {
        set<pair<char, char>> cur;

        for (int i = x1; i <= x2; ++i)
            if (cur.find(a[i][j]) == cur.end())
                cur.insert(a[i][j]);
            else
                return false;

        cur.clear();
    }

    return true;
}

int32_t main()
{

    cin >> n >> m;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            cin >> a[i][j].x >> a[i][j].y;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            set<pair<char, char>> cur;
            int len = 0;

            for (int z = j; z < m; ++z)
                if (cur.find(a[i][z]) != cur.end())
                    break;
                else
                {
                    cur.insert(a[i][z]);
                    ++len;
                }

            rght[i][j] = len;

            cur.clear();
            len = 0;

            for (int z = i; z < n; ++z)
                if (cur.find(a[z][j]) != cur.end())
                    break;
                else
                {
                    cur.insert(a[z][j]);
                    ++len;
                }

            down[i][j] = len;
        }

    int ans = 0;

    for (int x1 = 0; x1 < n; ++x1)
        for (int y1 = 0; y1 < m; ++y1)
            for (int x2 = x1; x2 < n; ++x2)
                for (int y2 = y1; y2 < m; ++y2)
                    if(abs(x1 - x2) == abs(y1 - y2))
                        if (check(x1, y1, x2, y2))
                            ++ans;

    cout << ans << endl;
}