#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<fstream>
///#pragma GCC optimize("Ofast")
#define int short
#define all(a) a.begin(), a.end()
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e9;
const int A = 33;
const int ALP = 126 - 33 + 3;

const int MAXN, MAXM;

int n, m;
vector<vector<pair<int, int>>> a;
vector<vector<vector<vector<int>>>> sf;
vector<vector<vector<vector<int>>>> dw;
vector<vector<vector<vector<int>>>> rt;
vector<vector<int>> ld;
vector<vector<int>> lr;

void init() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            a[i][j] = {s[j * 2] - A, s[j * 2 + 1] - A};
        }
    }
    ///cin.close(); cout.close();
}

void initsf() {
    sf.resize(n + 1);
    for (int i = 0; i <= n; ++i) {
        sf[i].resize(m + 1);
        for (int j = 0; j <= m; ++j) {
            sf[i][j].resize(ALP);
            for (int id = 0; id < ALP; ++id) {
                sf[i][j][id].resize(ALP, 0);
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            for (int i1 = 0; i1 < ALP; ++i1) {
                for (int j1 = 0; j1 < ALP; ++j1) {
                    sf[i][j][i1][j1] = sf[i + 1][j][i1][j1] + sf[i][j + 1][i1][j1] - sf[i + 1][j + 1][i1][j1];
                }
            }
            //cout << i << " " << j << endl;
            //cout << a[i][j].ft << " " << a[i][j].sd << endl;
            //cout << "----\n";
            sf[i][j][a[i][j].ft][a[i][j].sd]++;
            //cout << "||||\n";
        }
    }
}

void initdw() {
    dw.resize(n + 1);
    for (int i = 0; i <= n; ++i) {
        dw[i].resize(m);
        for (int j = 0; j < m; ++j) {
            dw[i][j].resize(ALP);
            for (int id = 0; id < ALP; ++id) {
                dw[i][j][id].resize(ALP, n);
            }
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < m; ++j) {
            for (int i1 = 0; i1 < ALP; ++i1) {
                for (int j1 = 0; j1 < ALP; ++j1) {
                    dw[i][j][i1][j1] = dw[i + 1][j][i1][j1];
                }
            }
            if (i < n - 1) {
                dw[i][j][a[i + 1][j].ft][a[i + 1][j].sd] = i + 1;
            }
        }
    }
}

void initrt() {
    rt.resize(n);
    for (int i = 0; i < n; ++i) {
        rt[i].resize(m + 1);
        for (int j = 0; j <= m; ++j) {
            rt[i][j].resize(ALP);
            for (int id = 0; id < ALP; ++id) {
                rt[i][j][id].resize(ALP, m);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = m - 1; j >= 0; --j) {
            for (int i1 = 0; i1 < ALP; ++i1) {
                for (int j1 = 0; j1 < ALP; ++j1) {
                    rt[i][j][i1][j1] = rt[i][j + 1][i1][j1];
                }
            }
            if (j < m - 1) {
                rt[i][j][a[i][j + 1].ft][a[i][j + 1].sd] = j + 1;
            }
        }
    }
}

void initld() {
    ld.resize(n);
    for (int i = n - 1; i >= 0; --i) {
        ld[i].resize(m);
        for (int j = 0; j < m; ++j) {
            if (i == n - 1) {
                ld[i][j] = 1;
            }
            else {
                ld[i][j] = min(ld[i + 1][j] + 1, dw[i][j][a[i][j].ft][a[i][j].sd] - i);
            }
        }
    }
}

void initlr() {
    lr.resize(n);
    for (int i = 0; i < n; ++i) {
        lr[i].resize(m);
        for (int j = m - 1; j >= 0; --j) {
            if (j == m - 1) {
                lr[i][j] = 1;
            }
            else {
                lr[i][j] = min(lr[i][j + 1] + 1, rt[i][j][a[i][j].ft][a[i][j].sd] - j);
            }
        }
    }
}

int cunt(int i, int j, int k) {
    k++;
    int res = 0;
    for (int i1 = 0; i1 < ALP; ++i1) {
        for (int j1 = 0; j1 < ALP; ++j1) {
            if (sf[i][j][i1][j1] - sf[i][j + k][i1][j1] - sf[i + k][j][i1][j1] + sf[i + k][j + k][i1][j1] > 0) {
                res++;
            }
        }
    }
    return res;
}

signed main() {
    ///ifstream cin(""); ofstream cin("");
    ///fast_IO();
    init();
    initsf();
    initdw();
    initrt();
    initld();
    initlr();

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int mk = INF;
            for (int k = 0; k < min(n - i, m - j); k++) {
                mk = min(mk, ld[i][j + k]);
                mk = min(mk, lr[i + k][j]);
                if (mk < k + 1) {
                    break;
                }
                if (cunt(i, j, k) == k + 1) {
                    ///cout << i + 1 << " " << j + 1 << " " << i + k + 1 << " " << j + k + 1 << endl;
                    ans++;
                }
            }
        }
    }
    cout << ans;
    ///cin.close(); cout.close();
    return 0;
}
