#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <queue>
#include <stack>
#include <deque>
#include <list>
#include <vector>
#include <string>


using namespace std;

typedef long long ll;
mt19937 ran(time(0));

const ll mod = 1000012121;
const ll inf = 2e18;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    char c1, c2;
    vector<vector<int>>g(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> c1 >> c2;
            g[i][j] = (c1 - 30) * 200 + (c2 - 30);
        }
    }
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            vector<set<int>>s1, s2;
            int ii = i, jj = j;
            while (ii >= 0 && jj >= 0) {
                int szma1 = 0, szmi1 = 2e9, szma2 = 0, szmi2 = 2e9;
                for (int k = j; k > jj; k--) {
                    s2[j - k].insert(g[ii][k]);
                }
                s2.push_back(set<int>());
                bool ch = true;
                for (int k = ii; k <= i; k++) {
                    s2[j - jj].insert(g[k][jj]);
                }
                for (auto x : s2) {
                    szma2 = max(szma2, (int)(x.size()));
                    szmi2 = min(szmi2, (int)(x.size()));
                }
                for (int k = 1; k < s2.size(); k++) {
                    if (s2[k] != s2[k - 1]) {
                        ch = false;
                        break;
                    }
                }
                for (int k = i; k > ii; k--) {
                    s1[i - k].insert(g[k][jj]);
                }
                s1.push_back(set<int>());
                for (int k = jj; k <= j; k++) {
                    s1[i - ii].insert(g[ii][k]);
                }
                for (auto x : s1) {
                    szma1 = max(szma1, (int)(x.size()));
                    szmi1 = min(szmi1, (int)(x.size()));
                }
                for (int k = 1; k < s1.size(); k++) {
                    if (s1[k] != s1[k - 1]) {
                        ch = false;
                        break;
                    }
                }
                if (s1[0] != s2[0])ch = false;
                if (szma1 == szmi1 && szmi1 == szmi2 && szmi2 == szma2 && szma2 == abs(ii - i) + 1 && ch) {
                    sum++;
                }
                ii--;
                jj--;
            }
        }
    }
    cout << sum;
    return 0;
}