#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) x.begin(),x.end()
const int MN = 1e7 + 1;
const int INF = 1e8;

int main() {
    int n, m;
    cin >> n >> m;
    pair<char, char> tb[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> tb[i][j].first >> tb[i][j].second;
        }
    }
    int goodRow[n][m][m];
    int goodCol[m][n][n];
    memset(goodRow, 0, sizeof(goodRow));
    memset(goodCol, 0, sizeof(goodCol));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            set<pair<char, char>> s;
            for (int jj = j; jj < m; jj++) {
                s.insert(tb[i][jj]);
                if (s.size() == jj - j + 1) {
                    goodRow[i][j][jj - j] = true;
                }
            }
            s.clear();
            for (int ii = i; ii < n; ii++) {
                s.insert(tb[ii][j]);
                if (s.size() == ii - i + 1) {
                    goodCol[j][i][ii - i] = true;
                }
            }
        }
    }
    bool good[n][m][min(n, m)];
    memset(good, 0, sizeof(good));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            set<pair<char, char>> s;
            for (int k = 0; k <= min(n - 1 - i, m - 1 - j); k++) {
                for (int d = 0; d <= k; d++) {
                    s.insert(tb[i + k][j + d]);
                    s.insert(tb[i + d][j + k]);
                }
                if (s.size() == k + 1) {
                    good[i][j][k] = true;
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 0; k <= min(n - 1 - i, m - 1 - j); k++) {
                bool can = true;
                for (int d = 0; d <= k; d++) {
                    if (!goodRow[i + d][j][k])
                        can = false;
                    if (!goodCol[j + d][i][k])
                        can = false;
                }
                if (can && good[i][j][k])
                    ans++;
            }
        }
    }
    cout << ans;
}