#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2005, P = 127;

int n, m, a[N][N];
unordered_map<int, int> cnt_row[N], cnt_col[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for (int j = 1; j <= m; ++j) {
            a[i][j] = s[j * 2 - 2] + s[j * 2 - 1] * P;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            for (int x = i; x <= n; ++x) {
                cnt_row[x].clear();
            }
            for (int y = j; y <= m; ++y) {
                cnt_col[y].clear();
            }
            unordered_map<int, int> cnt;
            for (int k = 1; k <= min(n - i + 1, m - j + 1); ++k) {
                bool ok = true;
                for (int y = j; y <= j + k - 1; ++y) {
                    cnt_col[y][a[i + k - 1][y]]++;
                    if (cnt_col[y][a[i + k - 1][y]] != 1) {
                        ok = false;
                        break;
                    }
                    cnt[a[i + k - 1][y]]++;
                }
                if (!ok) {
                    break;
                }
                for (int x = i; x <= i + k - 1; ++x) {
                    cnt_row[x][a[x][j + k - 1]]++;
                    if (cnt_row[x][a[x][j + k - 1]] != 1) {
                        ok = false;
                        break;
                    }
                    if (x != i + k - 1) {
                        cnt[a[x][j + k - 1]]++;
                    }
                }
                if (!ok) {
                    break;
                }
                for (int x = i; x <= i + k - 1; ++x) {
                    for (int y = j; y <= j + k - 1; ++y) {
                        if (cnt[a[x][y]] != k) {
                            ok = false;
                            break;
                        }
                    }
                    if (!ok) {
                        break;
                    }
                }
                ans += ok;
            }
        }
    }
    cout << ans << "\n";

    return 0;
}
