#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

constexpr int P = 53;
constexpr int M = 1e9 + 7;

using prc = pair<char, char>;
mt19937 rnd;

constexpr int MAXN = 510;

signed col[MAXN][MAXN][MAXN], row[MAXN][MAXN][MAXN];
short cntc[MAXN][MAXN][MAXN], cntr[MAXN][MAXN][MAXN];

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<prc>> f(n, vector<prc>(m));
    map<prc, signed> to;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j].ff >> f[i][j].ss;
            to[f[i][j]] = (signed)(rnd());
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            signed cr = to[f[i][j]];
            col[i][j][i] = cr;
            row[i][j][j] = cr;
            for (int k = i + 1; k < n; k++) {
                col[i][j][k] = col[i][j][k - 1] + to[f[k][j]];
                if (j > 0 && col[i][j][k] == col[i][j - 1][k])  cntc[i][j][k] = cntc[i][j - 1][k] + 1;
            }
            for (int k = j + 1; k < m; k++) {
                row[i][j][k] = row[i][j][k - 1] + to[f[i][k]];
                if (i > 0 && row[i][j][k] == row[i - 1][j][k]) cntr[i][j][k] = cntr[i - 1][j][k] + 1;
            }
        }
    }
    int ans = 0LL;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int mdi = i;
            int mdj = j;
            set<prc> usd;
            for (int k = i; k < n; k++) {
                if (usd.count(f[k][j])) break;
                mdi = k;
                usd.insert(f[k][j]);
            }
            usd.clear();
            for (int k = j; k < m; k++) {
                if (usd.count(f[i][k])) break;
                mdj = k;
                usd.insert(f[i][k]);
            }
            int tt = 0;
            while (i + tt <= mdi && j + tt <= mdj) {
                ans += (cntc[i][j + tt][i + tt] >= tt && cntr[i + tt][j][j + tt] >= tt);
                tt++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}