#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define pb push_back
#define eb emplace_back
#define xmax(x,y) x = max(x, y)
#define xmin(x,y) x = min(x, y)
#define mp make_pair
#define output(a) cout << #a << ' '; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) sort(all(a)); a.resize(unique(all(a)) - a.begin());

using namespace std;

const int S = (126 - 33 + 1) * (126 - 33 + 1);
const int N = 500;

int a[N][N];

int id = 0;
map<string, int> to;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            string t = s.substr(j * 2, 2);
            if (to.find(t) == to.end()) {
                to[t] = id;
                ++id;
            }
            a[i][j] = to[t];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<unordered_set<int>> row, col;
            unordered_set<int> tot;
            for (int k = 0; k <= min(i, j); ++k) {
                row.eb(unordered_set<int>());
                col.eb(unordered_set<int>());
                bool ok = 1;
                for (int ci = 0; ci < k - 1; ++ci) {
                    int x = a[i - ci][j - k];
                    if (row[ci].count(x)) {
                        ok = 0;
                        break;
                    }
                    row[ci].emplace(x);
                    tot.emplace(x);
                }
                for (int cj = 0; cj < k - 1 && ok; ++cj) {
                    int x = a[i - k][j - cj];
                    if (col[cj].count(x)) {
                        ok = 0;
                        break;
                    }
                    col[cj].emplace(x);
                    tot.emplace(x);
                }
                for (int t = 0; t <= k && ok; ++t) {
                    int x = a[i - k][j - t];
                    if (row.back().count(x)) {
                        ok = 0;
                        break;
                    }
                    row.back().emplace(x);
                    tot.emplace(x);

                    x = a[i - t][j - k];
                    if (col.back().count(x)) {
                        ok = 0;
                        break;
                    }
                    col.back().emplace(x);
                    tot.emplace(x);
                }
                if (!ok) {
                    break;
                }
                if (sz(tot) == k + 1) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
