#include<bits/stdc++.h>
using namespace std;

#define x first
#define y second

const int M = 1e9 + 7, M2 = 1e9 + 9, P = 131331;

int p[50007], p2[50007];

inline void add(pair<int, int> &h, int x) {
    h.x += p[x];
    if (h.x >= M) h.x -= M;
    h.y += p2[x];
    if (h.y >= M2) h.y -= M2;
}

int a[2007][2007];
pair<int, int> row[2007][2007], col[2007][2007];
int len[
2007][2007], len2[2007][2007];
int go[2007][2007], go2[2007][2007];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    p[0] = 1;
    p2[0] = 1;
    for (int i = 1; i < 50007; i++) {
        p[i] = (long long) p[i - 1] * P % M;
        p2[i] = (long long) p2[i - 1] * P % M2;
    }
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (x - 33) * 94 + y - 33;
            row[i][j] = {0, 0};
            col[i][j] = {0, 0};
        }
    }
    for (int i = 0; i < n; i++) {
        vector<pair<int, int>> sorted;
        for (int j = 0; j < m; j++) sorted.emplace_back(a[i][j], j);
        sort(sorted.begin(), sorted.end());
        for (int j = 0; j < m; j++) {
            if (j == 0 || sorted[j - 1].x != sorted[j].x) go[i][sorted[j].y] = 0; else go[i][sorted[j].y] = sorted[j - 1].y + 1;
        }
        for (int j = 1; j < m; j++) {
             go[i][j] = max(go[i][j], go[i][j - 1]);
        }
    }
    for (int j = 0; j < m; j++) {
        vector<pair<int, int>> sorted;
        for (int i = 0; i < n; i++) sorted.emplace_back(a[i][j], i);
        sort(sorted.begin(), sorted.end());
        for (int i = 0; i < n; i++) {
            if (i == 0 || sorted[i - 1].x != sorted[i].x) go2[sorted[i].y][j] = 0; else go2[sorted[i].y][j] = sorted[i - 1].y + 1;
        }
        for (int i = 1; i < n; i++) {
            go2[i][j] = max(go2[i][j], go2[i - 1][j]);
        }
    }
    int ans = 0;
    for (int k = 0; k < min(n, m); k++) {
        for (int i = 0; i < n; i++) {
            for (int j = k; j < m; j++) add(row[i][j], a[i][j - k]);
        }
        for (int j = 0; j < m; j++) {
            for (int i = k; i < n; i++) add(col[i][j], a[i - k][j]);
        }
        for (int i = 0; i < n; i++) {
            for (int j = k; j < m; j++) {
                len[i][j] = 1;
                if (go[i][j] > j - k) len[i][j] = 0;
                if (i != 0 && row[i][j] == row[i - 1][j] && len[i][j] == 1) len[i][j] += len[i - 1][j];
            }
        }
        for (int j = 0; j < m; j++) {
            for (int i = k; i < n; i++) {
                len2[i][j] = 1;
                if (go2[i][j] > i - k) len2[i][j] = 0;
                if (j != 0 && col[i][j] == col[i][j - 1] && len2[i][j] == 1) len2[i][j] += len2[i][j - 1];
            }
        }
        for (int i = k; i < n; i++) {
            for (int j = k; j < m; j++) {
                if (len[i][j] >= k + 1 && len2[i][j] >= k + 1) ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
