#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>
#include <unordered_set>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
//#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)5e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vvi a(n, vi(m));
	fi(n) {
		string s;
		cin >> s;
		fj(m)
			a[i][j] = (s[2 * j] - '!') * 94 + (s[2 * j + 1] - '!');
	}
	int cnt = 0;
	fvr(k, 1, min(n, m)) {
		fi(n - k + 1) {
			fj(m - k + 1) {
				unordered_set<int> s;
				fvr(x, i, i + k - 1) {
					fvr(y, j, j + k - 1) {
						s.insert(a[x][y]);
					}
				}
				if (s.size() != k)
					continue;
				s.clear();
				bool flag = 1;
				fvr(x, i, i + k - 1) {
					fvr(y, j, j + k - 1) {
						s.insert(a[x][y]);
					}
					if (s.size() != k) {
						flag = 0;
						break;
					}
					s.clear();
				}
				if (!flag)
					continue;
				fvr(y, j, j + k - 1) {
					fvr(x, i, i + k - 1) {
						s.insert(a[x][y]);
					}
					if (s.size() != k) {
						flag = 0;
						break;
					}
					s.clear();
				}
				if (flag)
					++cnt;
			}
		}
	}
	cout << cnt;

	return 0;
}