#include <bits/stdc++.h>

using namespace std;

vector<vector<unsigned long long> > h1, h2;
vector<vector<int> > t;


bool good2(int a, int b, int k)
{
    unsigned long long ans = h1[a][b + k] - h1[a][b];
    for (int d = 0; d < k; ++d)
    {
        if (ans != h1[a + d][b + k] - h1[a + d][b])
        {

            return false;
        }
        if (ans != h2[a + k][b + d] - h2[a][b + d])
        {
            return false;
        }
    }
    return true;
}

bool good4(int a, int b, int k)
{
    set<int> all;
    for (int i = 0; i < k; ++i)
    for (int j = 0; j < k; ++j)
    {
        all.insert(t[a + i][b + j]);
    }
    if (all.size() != k) return false;
    for (int i = 0; i < k; ++i)
    {
        all.clear();
        for (int j = 0; j < k; ++j)
            all.insert(t[a + i][b + j]);
        if (all.size() != k) return false;
    }
    for (int j = 0; j < k; ++j)
    {
        all.clear();
        for (int i = 0; i < k; ++i)
            all.insert(t[a + i][b + j]);
        if (all.size() != k) return false;
    }
    return true;
}

int main()
{
    srand(time(NULL));
    int n, m;
    cin >> n >> m;
    t.resize(n, vector<int> (m));
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
        {
            t[i][j] = (s[j * 2] - 33) * 94 + (s[j * 2 + 1] - 33);
        }
    }
    vector<unsigned long long> value(94 * 94);
    for (int i = 0; i < value.size(); ++i)
    {
        value[i] = rand();
        value[i] <<= 32;
        value[i] += rand();
    }
    h1.resize(n, vector<unsigned long long> (m + 1));
    h2.resize(n + 1, vector<unsigned long long> (m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            h1[i][j + 1] = h1[i][j] + value[t[i][j]];
        }
    }
    for (int j = 0; j < m; ++j)
    {
        for (int i = 0; i < n; ++i)
        {
            h2[i + 1][j] = h2[i][j] + value[t[i][j]];
        }
    }
    int res = n * m;
    for (int a = 0; a < n; ++a)
    for (int b = 0; b < m; ++b)
    for (int k = 2; k <= n; ++k)
    {
        if (a + k > n || b + k > m) continue;
        if (good2(a, b, k))
        {
            ++res;
        }
    }
    cout << res << endl;
}
