#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int MAXN = 2020;
string s[MAXN];
int mm[MAXN * 5];
int lf[MAXN][MAXN], up[MAXN][MAXN];

int get(int i, int j) {
	return (int)(s[i][2 * j] - 33) * 100 + (int)s[i][2 * j + 1] - 33;
}

signed main() {
	FAST_IO();
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n; ++i) {
		map<int, int> last;
		for (int j = 0; j < m; ++j) {
			if (last.count(get(i, j))) {
				lf[i][j] = last[get(i, j)];
			}
			else {
				lf[i][j] = -1;
			}
			last[get(i, j)] = j;
			if (j != 0) lf[i][j] = max(lf[i][j - 1], lf[i][j]);
		}
	}
	for (int j = 0; j < m; ++j) {
		map<int, int> last;
		for (int i = 0; i < n; ++i) {
			if (last.count(get(i, j))) {
				up[i][j] = last[get(i, j)];
			}
			else {
				up[i][j] = -1;
			}
			last[get(i, j)] = i;
			if (i != 0) up[i][j] = max(up[i - 1][j], up[i][j]);
		}
	}
	int x = n - 1, y = 0, ans = 0;
	while (true) {
		if (x == 0 && y == m) {
			break;
		}
		fill(mm, mm + MAXN * 5, INF);
		int added = 0;
		kawaii_set<pii> setik;
		int tx = x, ty = y;
		while (x < n && y < m) {
			added++;
			for (int j = y; j >= 0; --j) {
				if (y - j - added < mm[get(x, j)]) {
					setik.erase({mm[get(x, j)], get(x, j)});
					mm[get(x, j)] = y - j - added;
					setik.insert({mm[get(x, j)], get(x, j)});
				}
			}
			for (int i = x; i >= 0; --i) {
				if (x - i - added < mm[get(i, y)]) {
					setik.erase({mm[get(i, y)], get(i, y)});
					mm[get(i, y)] = x - i - added;
					setik.insert({mm[get(i, y)], get(i, y)});
				}
			}
			for (int k = 0; k <= min(x, y); ++k) {
				bool flag = true;
				for (int j = y; j >= y - k; --j) {
					if (up[x][j] == x - k) {
						flag = false;
						break;
					}
				}
				for (int i = x; i >= x - k; --i) {
					if (lf[i][y] == y - k) {
						flag = false;
						break;
					}
				}
				if (!flag) {
					break;
				}
				int cnt = setik.order_of_key({k + 1 - added, -1});
				ans += (cnt == k + 1);
			}
			x++;
			y++;
		}
		x = tx;
		y = ty;
		if (x != 0) {
			x--;
		}
		else {
			y++;
		}
	}
	cout << ans << '\n';
}