#include <bits/stdc++.h>

using namespace std;

long long gcd(long long a, long long b){
    if(b == 0)
        return a;
    else
        return gcd(b, a % b);
}

void solve(){
    int n, m; cin >> n >> m;
    vector<vector<int> > g(n);
    vector<long long> c(n);
    for(int i = 0; i < n; ++i)
        cin >> c[i];
    for(int i = 0; i < m; ++i){
        int a, b; cin >> a >> b; --a, --b;
        g[a].push_back(b);
    }
    long long ans = -1;
    for(int mask = 0; mask < (1 << n); ++mask){
        vector<bool> used(n);
        long long cnt = 0;
        for(int i = 0; i < n; ++i){
            if(!(mask & (1 << i)))
                continue;
            for(int j = 0; j < g[i].size(); ++j){
                if(!used[g[i][j]]){
                    cnt += c[g[i][j]], used[g[i][j]] = 1;
                }
            }
        }
        if(ans == -1)
            ans = cnt;
        else
            ans = gcd(ans, cnt);
    }
    cout << ans << '\n';
 }

int main()
{
    int t; cin >> t;
    for(int i = 0; i < t; ++i)
        solve();
    return 0;
}
