#pragma optimization_level 3
#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define F first
#define S second
#define vec vector
#define pb push_back
#define pll pair<ll, ll>
#define uset unordered_set
#define umap unordered_map
#define pii pair<int, int>
#define pnn pair<Node*, Node*>
#define uid uniform_int_distribution
#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
using namespace std;
typedef string str;
typedef long long ll;
typedef long double ld;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void prM(vec<vec<int>> &m){
    for(auto i : m){
        for(int u : i) cout<<u<<" ";
        cout<<"\n";
    }
    cout<<endl;
}

const int G = 94*94, I = 2000;
ll o = 0;
int a,b, m[I][I], rg[I][I], dw[I][I];
ll n[I][I], pnr[I][I], pnd[I][I], cng[G];
vec<pii> num1[G], num2[G];

int nxt_in_row(int num, pii p){
    int l = -1, r = num1[num].size();
    for(; l+1<r;){
        int md = (l+r)/2;
        if(num1[num][md] <= p) l = md;
        else r = md;
    }
    return r==num1[num].size() || num1[num][r].F!=p.F ? -1 : num1[num][r].S-p.S;
}

int nxt_in_col(int num, pii p){
    int l = -1, r = num2[num].size();
    for(; l+1<r;){
        int md = (l+r)/2;
        if(num2[num][md] <= p) l = md;
        else r = md;
    }
    return r==num2[num].size() || num2[num][r].F!=p.F ? -1 : num2[num][r].S-p.S;
}

void calc(){
    for(int q=0; q<a; q++){
        rg[q][b-1] = 1;
        for(int w=b-2; w>=0; w--){
            int X = nxt_in_row(m[q][w], {q,w});
            if(X==-1) rg[q][w] = rg[q][w+1]+1;
            else rg[q][w] = min(rg[q][w+1]+1, X);
        }
    }
    for(int w=0; w<b; w++){
        dw[a-1][w] = 1;
        for(int q=a-2; q>=0; q--){
            int X = nxt_in_col(m[q][w], {w,q});
            if(X==-1) dw[q][w] = dw[q+1][w]+1;
            else dw[q][w] = min(dw[q+1][w]+1, X);
        }
    }
}

inline ll hsh_row(int x, int l, int r){
    return pnr[x][r]^(l ? pnr[x][l-1] : 0);
}

inline ll hsh_col(int y, int l, int r){
    return pnd[r][y]^(l ? pnd[l-1][y] : 0);
}

int main() {
    fast;
    uid<ll> gen(0, LONG_LONG_MAX);
    for(int q=0; q<G; q++) cng[q] = gen(rnd);
    cin>>a>>b;
    for(int q=0; q<a; q++){
        str t; cin>>t;
        for(int w=0; w<b; w++){
            m[q][w] = 94*(t[w*2]-33) + (t[w*2+1]-33);
            //if(m[q][w] >= G) for(int q=0; q<LONG_LONG_MAX; q++) a+=rnd();
            n[q][w] = pnr[q][w] = pnd[q][w] = cng[m[q][w]];
            if(w) pnr[q][w] ^= pnr[q][w-1];
            if(q) pnd[q][w] ^= pnd[q-1][w];
            num1[m[q][w]].pb({q,w});
        }
    }
    for(int w=0; w<b; w++){
        for(int q=0; q<a; q++){
            num2[m[q][w]].pb({w,q});
        }
    }
    calc();
   // prM(rg);
   // prM(dw);
    o = a*b;
    ll HS;
    for(int q=0; q<a; q++){
        for(int w=0; w<b; w++){
            int mx = min(rg[q][w], dw[q][w]);
            for(int e=2; e<=mx; e++){
                mx = min({mx, rg[q+e-1][w], dw[q][w+e-1]});
                if(e>mx) break;
                int fl = 1;
                HS = hsh_row(q, w, w+e-1);
                for(int i=0; i<e && fl; i++){
                    fl &= HS==hsh_row(q+i, w, w+e-1);
                    fl &= HS==hsh_col(w+i, q, q+e-1);
                }
                //if(fl) e = e*2-1;
                o += fl;
            }
        }
    }
    cout<<o;
}