#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

constexpr int P = 53;
constexpr int M = 1e9 + 7;

using prc = pair<char, char>;
mt19937 rnd;

constexpr int MAXN = 500;

short col[MAXN][MAXN][MAXN], row[MAXN][MAXN][MAXN];
short cntc[MAXN][MAXN][MAXN], cntr[MAXN][MAXN][MAXN];
char f1[MAXN][MAXN], f2[MAXN][MAXN];
short tto[MAXN][MAXN];
signed usd[MAXN][MAXN];

void run() {
    int n, m;
    cin >> n >> m;
    map<prc, signed> to;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f1[i][j] >> f2[i][j];
            to[{f1[i][j], f2[i][j]}] = (signed)(rnd());
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            tto[i][j] = to[{f1[i][j], f2[i][j]}];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            signed cr = tto[i][j];
            col[i][j][i] = cr;
            row[i][j][j] = cr;
            for (int k = i + 1; k < n; k++) {
                col[i][j][k] = col[i][j][k - 1] + tto[k][j];
                if (j > 0 && col[i][j][k] == col[i][j - 1][k])  cntc[i][j][k] = cntc[i][j - 1][k] + 1;
            }
            for (int k = j + 1; k < m; k++) {
                row[i][j][k] = row[i][j][k - 1] + tto[i][k];
                if (i > 0 && row[i][j][k] == row[i - 1][j][k]) cntr[i][j][k] = cntr[i - 1][j][k] + 1;
            }
        }
    }
    int ans = 0LL;
    int cci = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int mdi = i;
            int mdj = j;
            for (int k = i; k < n; k++) {
                if (usd[f1[k][j]][f2[k][j]] == cci) break;
                mdi = k;
                usd[f1[k][j]][f2[k][j]] = cci;
            }
            cci ++;
            for (int k = j; k < m; k++) {
                if (usd[f1[i][k]][f2[i][k]] == cci) break;
                mdj = k;
                usd[f1[i][k]][f2[i][k]] = cci;
            }
            cci ++;
            int tt = 0;
            while (i + tt <= mdi && j + tt <= mdj) {
                ans += (cntc[i][j + tt][i + tt] >= tt && cntr[i + tt][j][j + tt] >= tt);
                tt++;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}