#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct HESH {
	ll a, b;
	//HESH(ll A, ll B) { a = A; b = B; }
	friend HESH operator ^ (HESH a, HESH b) {
		a.a ^= b.a;
		a.b ^= b.b;
        return a;
	}
	friend bool operator == (HESH a, HESH b) {
		return (a.a == b.a && a.b == b.b);
	}
} b[2100][2100];

int rand64() {
	return (rand() << 48) + (rand() << 32) + (rand() << 16) + rand();
}

int n, m;
map <int, HESH> renum;
map <int, int> renum_c;
int a[2100][2100];
int L[2100][2100];
int R[2100][2100];
int U[2100][2100];
int D[2100][2100];
HESH xL[2100][2100];
map <int, int> Lc[2100];
map <int, int> Uc[2100];

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(100024);

    cin >> n >> m;
    int o = 0;
    for (int i = 0; i < n; i++) {
		string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            int x = s[j*2] * 127 + s[j*2+1];
            if (renum.find(x) == renum.end()) {
                renum[x] = {rand64(), rand64()};
                renum_c[x] = ++o;
            }
            a[i+1][j+1] = renum_c[x];
            b[i+1][j+1] = renum[x];
        }
    }
    for (int i = 1; i <= max(n, m); i++) {
        for (int j = 1; j <= o; j++) {
            Lc[i][j] = 0;
            Uc[i][j] = 0;
        }
    }
    for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
            L[i][j] = 0;
            R[i][j] = n+1;
            U[i][j] = 0;
            D[i][j] = m+1;
		}
    }
    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= m; j++) {
            if (Lc[i][a[i][j]] != -1) {
                R[i][Lc[i][a[i][j]]] = j;
            }
			L[i][j] = Lc[i][a[i][j]];
			Lc[i][a[i][j]] = j;

            if (Uc[j][a[i][j]] != -1) {
                D[i][Uc[j][a[i][j]]] = i;
            }
            U[i][j] = Uc[j][a[i][j]];
			Uc[j][a[i][j]] = i;
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
			xL[i][j] = xL[i][j-1] ^ b[i][j];
		  }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            for (int len = 1; len <= min(i, j); len++) {
                HESH c;
                bool bad = false;
				for (int x = i-len+1; x <= i; x++) {
					if (x == i-len+1) {
						c = xL[x][j] ^ xL[x][j-len];
					} else {
						if (c == (xL[x][j] ^ xL[x][j-len])) continue;
						bad = true;
						break;
					}
                }
                if (!bad) ans++;
            }
        }
    }
    cout << ans << endl;


	return 0;
}
