#include <bits/stdc++.h>

using namespace std;

const int kN = 2007;
const int kMinAscii = 33;
const int kMaxAscii = 126;
const int kCntAscii = kMaxAscii - kMinAscii + 1;
const int kMaxNum = kCntAscii * kCntAscii;

short a[kN][kN];
int cnt[kMaxNum];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m;
    cin >> n >> m;

    for(int i = 0; i < n; ++i){
        string s;
        cin >> s;
        for(int j = 0; j < 2 * m; j += 2)
            a[i][j / 2] = (s[j] - kMinAscii) * kCntAscii + (s[j + 1] - kMinAscii);
    }

    int ans = 0;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            for(int d = 0; i + d < n && j + d < m; ++d){
                int x = i + d, y = j + d, cnt_d = 0;

                bool ok = true;
                for(int i2 = i; i2 <= x; ++i2){
                    for(int j2 = j; j2 <= y; ++j2){
                        ++cnt[a[i2][j2]];
                        if(cnt[a[i2][j2]] > 1)
                            ok = false;
                    }

                    for(int j2 = j; j2 <= y; ++j2)
                        --cnt[a[i2][j2]];
                }

                for(int j2 = j; j2 <= y; ++j2){
                    for(int i2 = i; i2 <= x; ++i2){
                        ++cnt[a[i2][j2]];
                        if(cnt[a[i2][j2]] > 1)
                            ok = false;
                    }

                    for(int i2 = i; i2 <= x; ++i2)
                        --cnt[a[i2][j2]];
                }

                if(!ok)
                    break;

                for(int i2 = i; i2 <= x; ++i2){
                    for(int j2 = j; j2 <= y; ++j2){
                        ++cnt[a[i2][j2]];
                        if(cnt[a[i2][j2]] == d + 1)
                            ++cnt_d;
                    }
                }
                for(int i2 = i; i2 <= x; ++i2)
                    for(int j2 = j; j2 <= y; ++j2)
                        --cnt[a[i2][j2]];

                if(cnt_d != d + 1)
                    continue;

                ++ans;
            }
        }
    }

    cout << ans << "\n";
}
