#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

bool operator==(set<int> &a, set<int> &b){
    if(a.size()!=b.size())
        return false;
    auto it = a.begin(), it1 = b.begin();
    while(it!=a.end()){
        if((*it)!=(*it1))
            return false;
        it++;
        it1++;
    }
    return true;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(n, vector<int>(m));
    for(int i = 0; i<n; i++){
        for(int j = 0; j<m; j++){
            char c, d;
            cin >> c >> d;
            int c1 = c-33, d1 = d-33;
            a[i][j] = (c*(126-33+1))+d;
            //cout << i << ':' << j << ' ' << a[i][j] << endl;
        }
    }
    vector<vector<vector<int> > > u(n, vector<vector<int> >(m, vector<int>(m, 0)));
    vector<vector<vector<bool> > > u1(n, vector<vector<bool> >(m, vector<bool>(m, false)));
    for(int x = 0; x<n; x++){
        for(int y1 = 0; y1<m; y1++){
            set<int> rt, rt1;
            long long hs = 0, hs1 = 0;
            for(int y2 = y1; y2<m; y2++){
                rt.insert(a[x][y2]);
                hs += a[x][y2];
                if(rt.size()==y2-y1+1)
                    u1[x][y1][y2] = true;
                else
                    break;
                if(x){
                    rt1.insert(a[x-1][y2]);
                    hs1 += a[x-1][y2];
                    if(hs==hs1)
                        u[x][y1][y2] = u[x-1][y1][y2]+1;
                }
            }
        }
    }
    vector<vector<vector<int> > > u2(m, vector<vector<int> >(n, vector<int>(n, 0)));
    vector<vector<vector<bool> > > u3(m, vector<vector<bool> >(n, vector<bool>(n, false)));
    for(int x = 0; x<m; x++){
        for(int y1 = 0; y1<n; y1++){
            set<int> rt, rt1;
            long long hs = 0, hs1 = 0;
            for(int y2 = y1; y2<n; y2++){
                rt.insert(a[y2][x]);
                hs += a[y2][x];
                if(rt.size()==y2-y1+1)
                    u3[x][y1][y2] = true;
                else
                    break;
                if(x){
                    rt1.insert(a[y2][x-1]);
                    hs1 += a[y2][x-1];
                    if(hs==hs1)
                        u2[x][y1][y2] = u2[x-1][y1][y2]+1;
                }
            }
        }
    }
    int ans = 0;
    for(int x = 0; x<n; x++){
        for(int y = 0; y<m; y++){
            for(int ln = 0; ln<=min(x, y); ln++){
                bool kek = true;
                if(!u1[x][y-ln][y])
                    continue;
                if(u[x][y-ln][y]<ln)
                    continue;
                if(!u3[y][x-ln][x])
                    continue;
                if(u2[y][x-ln][x]<ln)
                    continue;
                ans += kek;
            }
        }
    }
    cout << ans;

    return 0;
}
