#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 10;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

int n, m;
vector<string> a;

int get_h(char a, char b) {
    return a * 1000 + b;
}

bool check(int s, int x, int y) {
    if (x + s > n || y + s > m) return 0;
    set<int> h;
    for (int i = 0; i < s; i++) {
        int cur = get_h(a[x][2 * (y + i)], a[x][2 * (y + i) + 1]);
        if (h.count(cur)) return 0;
        h.insert(cur);
    }
    for (int i = x + 1; i < x + s; i++) {
        set<int> h1 = h;
        for (int j = 0; j < s; j++) {
            int cur = get_h(a[i][2 * (j + y)], a[i][2 * (j + y) + 1]);
            if (!h1.count(cur)) return 0;
            h1.erase(cur);
        }
        if (!h1.empty()) return 0;
    }
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int ans = n * m;
//    dbg(check(2, 0, 0))
    for (int s = 2; s <= min(n, m); s++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (check(s, i, j)) ans++;
            }
        }
    }
    cout << ans;
}
/*
5 10
!"#$%&’()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_‘abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
