#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 
mt19937 rng(time(NULL));

int a[2002][2002];
int n, m;

struct table2d {
	int t[2002][2002];


} rw, cl;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			a[i][j] = ((int)s[j * 2]) << 8 + (int)s[j * 2 + 1];
		}
	}

	for (int i = 0; i < n; ++i) {
		int fst = 0;
		set<int> ss;
		for (int j = 0; j < m; ++j) {
			while (fst < m && ss.find(a[i][j]) != ss.end()) {
				rw.t[i][fst] = j - 1;
				ss.erase(a[i][fst]);
				fst++;
			}
			ss.insert(a[i][j]);
		}
		while (fst < m)
			rw.t[i][fst++] = m - 1;
	}

	for (int j = 0; j < m; ++j) {
		int fst = 0;
		set<int> ss;
		for (int i = 0; i < n; ++i) {
			while (fst < n && ss.find(a[i][j]) != ss.end()) {
				cl.t[fst][j] = i - 1;
				ss.erase(a[fst][j]);
				fst++;
			}
			ss.insert(a[i][j]);
		}
		while (fst < n)
			cl.t[fst++][j] = n - 1;
	}



	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			ans++;
			int mnrw = rw.t[i][j];
			int mncl = cl.t[i][j];
			set<int> ss = { a[i][j] };
			for (int k = 2; i + k - 1 < n && j + k - 1 < m; ++k) {
				for (int yk = i; yk < i + k; ++yk) {
					ss.insert(a[yk][j + k - 1]);
					mnrw = min(mnrw, rw.t[yk][j + k - 1]);
					mncl = min(mncl, cl.t[yk][j + k - 1]);
				}
				for (int xk = j; xk < j + k - 1; ++xk) {
					ss.insert(a[i + k - 1][xk]);
					mnrw = min(mnrw, rw.t[i+k-1][xk]);
					mncl = min(mncl, cl.t[i+k-1][xk]);
				}

				if (mnrw < j + k - 1 || mncl < i + k - 1) break;
				if (ss.size() == k) ans++;
			}

		}
	}
	cout << ans;

	return 0;
}