#include<iostream>
#include<vector>
#include<algorithm>
#include<time.h>
#include<random>
#include<string>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (ll)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#include<iostream>
#include<vector>
#include<algorithm>
#include<time.h>
#include<random>
#include<string>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (ll)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()



ll n, m;
vector<vector<pair<char, char>>> g;

const ll MOD = 1e9 + 9;
const ll base = 279;

vector<ll> degs(100000);

vector<vector<ll>> ver, hor;

ll solve(ll x0, ll y0, ll l) {
    set<pair<char, char>> st1;
    for (ll y = y0; y < y0 + l; ++y) {
        st1.insert(g[x0][y]);
    }
    if (sz(st1) != l) {
        return 0;
    }
    set<pair<char, char>> st2;
    for (ll x = x0; x < x0 + l; ++x) {
        st2.insert(g[x][y0]);
    }
    if (sz(st2) != l) {
        return 0;
    }
    set<ll> st;
    for (ll y = y0; y < y0 + l; ++y) {
        st.insert((ver[y][x0 + l] - ver[y][x0] + MOD) % MOD);
    }
    for (ll x = x0; x < x0 + l; ++x) {
        st.insert((hor[x][y0 + l] - hor[x][y0] + MOD) % MOD);
    }
    if (sz(st) != 1) {
        return 0;
    }
    return 1;
}

int main() {
    cin >> n >> m;
    g.resize(n, vector<pair<char, char>>(m));
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < m; ++j) {
            char c1, c2;
            cin >> c1 >> c2;
            g[i][j] = { c1, c2 };
        }
    }
    degs[0] = 1;
    for (ll i = 1; i < 100000; ++i) {
        degs[i] = degs[i - 1] * base;
        degs[i] %= MOD;
    }
    hor.resize(n, vector<ll>(m + 1, 0));
    ver.resize(m, vector<ll>(n + 1, 0));
    for (ll x = 0; x < n; ++x) {
        for (ll y = 0; y < m; ++y) {
            ll cnt = (ll)((ll)g[x][y].first - 32) * 101 + (ll)((ll)g[x][y].second - 32) + 14;
            hor[x][y + 1] = (hor[x][y] + degs[cnt]) % MOD;
        }
    }
    for (ll y = 0; y < m; ++y) {
        for (ll x = 0; x < n; ++x) {
            ll cnt = (ll)((ll)g[x][y].first - 32) * 101 + (ll)((ll)g[x][y].second - 32) + 14;
            ver[y][x+1] = (ver[y][x] + degs[cnt]) % MOD;
        }
    }
    ll ans = 0;
    for (ll l = 1; l < min(n, m); ++l) {
        for (ll x = 0; (x + l - 1) < n; ++x) {
            for (ll y = 0; (y + l - 1) < m; ++y) {
                ans += solve(x, y, l);
            }
        }
    }
    cout << ans;
    system("pause");
    return 0;
}

