#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct HESH {
	ll a = 0, b = 0;
	//HESH(ll A, ll B) { a = A; b = B; }
	friend HESH operator ^ (HESH a, HESH b) {
		a.a ^= b.a;
		a.b ^= b.b;
        return a;
	}
	friend bool operator == (HESH a, HESH b) {
		return (a.a == b.a && a.b == b.b);
	}
} b[3000][3000];

ll rand64() {
	return (rand() << 48) + (rand() << 32) + (rand() << 16) + rand();
}

ll n, m;
map <ll, HESH> renum;
map <ll, ll> renum_c;
ll a[3000][3000];
ll L[3000][3000];
ll R[3000][3000];
ll U[3000][3000];
ll D[3000][3000];
HESH xL[3000][3000];
map <ll, ll> Lc[3000];
map <ll, ll> Uc[3000];

int main()
{
	ios_base :: sync_with_stdio(0);
	cin.tie();
	cout.tie();

	srand(100024);

    cin >> n >> m;
    ll o = 0;
    for (ll i = 0; i < n; i++) {
		string s;
        cin >> s;
        for (ll j = 0; j < m; j++) {
            ll x = s[j*2] * 127 + s[j*2+1];
            if (renum.find(x) == renum.end()) {
                renum[x] = {rand64(), rand64()};
                renum_c[x] = ++o;
            }
            a[i+1][j+1] = renum_c[x];
            b[i+1][j+1] = renum[x];
        }
    }
    for (ll i = 1; i <= max(n, m); i++) {
        for (ll j = 1; j <= o; j++) {
            Lc[i][j] = 0;
            Uc[i][j] = 0;
        }
    }
    for (ll i = 1; i <= n; i++) {
		for (ll j = 1; j <= m; j++) {
            L[i][j] = 0;
            R[i][j] = n+1;
            U[i][j] = 0;
            D[i][j] = m+1;
		}
    }
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= m; j++) {
            if (Lc[i][a[i][j]] != 0) {
                R[i][Lc[i][a[i][j]]] = j;
            }
			L[i][j] = Lc[i][a[i][j]];
			Lc[i][a[i][j]] = j;

            if (Uc[j][a[i][j]] != 0) {
                D[i][Uc[j][a[i][j]]] = i;
            }
            U[i][j] = Uc[j][a[i][j]];
			Uc[j][a[i][j]] = i;
        }
    }

    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= m; j++) {
			xL[i][j] = xL[i][j-1] ^ b[i][j];
		  }
    }
    ll ans = 0;
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= m; j++) {
            for (ll len = 1; len <= min(i, j); len++) {
                HESH c;
                bool bad = false;
				for (ll x = i-len+1; x <= i; x++) {
					if (x == i-len+1) {
						c = xL[x][j] ^ xL[x][j-len];
					} else {
						if (c == (xL[x][j] ^ xL[x][j-len])) continue;
						bad = true;
						break;
					}
                }
                if (bad) continue;
                for (ll x = i; x > i-len; x--) {
					for (ll y = j; y > j-len; y--) {
                        if (L[x][y] > j-len) { bad = true; break; }
                        if (U[x][y] > i-len) { bad = true; break; }
					}
					if (bad) break;
                }
                if (bad) continue;
                ans++;
            }
        }
    }
    cout << ans << endl;


	return 0;
}
