#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

const int N = 505, M = 94 * 94;
string s[N];
ll a[N][N], tmp[N][N], mx_up[N][N], mx_lt[N][N], 
	used[M], last[M], nearest[N], up[N][N], w[M];
ll sum[N][N];
int nearest_dif_hash[N][N][N];
int fl = 0;

mt19937 rnd(time(0));

void solve(int n, int m, ll b[N][N], ll res[N][N]) {
	memset(up, -1, sizeof(up));

	for (int i = 0; i < m; i++) {
		fl++;

		for (int j = 0; j < n; j++) {
			if (j > 0) {
				up[j][i] = up[j - 1][i];
			}
			if (used[b[j][i]] == fl) {
				up[j][i] = max(up[j][i], last[b[j][i]]);
			}
			used[b[j][i]] = fl;
			last[b[j][i]] = j;
		}
	}

	fill(nearest, nearest + m, -1);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			nearest[j] = max(nearest[j], up[i][j]);
		}

		for (int k = 0, j = 0; j < m; j++) {
			while (true) {
				bool ok = true;
				for (int h = k; h <= j; h++) {
					if (i - nearest[h] < j - k + 1) {
						ok = false;
						break;
					}
				}
				if (ok)
					break;
				k++;
			}
			res[i][j] = j - k + 1;
		}
	}
}

void trans(int n, int m, ll a[N][N]) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			tmp[j][i] = a[i][j];
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			a[i][j] = tmp[i][j];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);


	for (int i = 0; i < M; i++) {
		w[i] = rnd();
	}

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2 * m; j += 2) {
			a[i][j / 2] = (int)(s[i][j] - 33) * 94 + s[i][j + 1] - 33;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			sum[i][j + 1] = sum[i][j] + w[a[i][j]];
		}
	}

	// cout << sum[2][5] - sum[2][2] << "\n";
	// cout << sum[3][5] - sum[3][2] << "\n";
	// cout << sum[1][5] - sum[1][2] << "\n";
 
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << a[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	// cout << "\n";

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = j; k < m; k++) {
				nearest_dif_hash[i][j][k] = -1;
				if (i > 0) {
					if (sum[i][k + 1] - sum[i][j] !=
						sum[i - 1][k + 1] - sum[i - 1][j]) {
						nearest_dif_hash[i][j][k] = i - 1;
					}
					else {
						nearest_dif_hash[i][j][k] = nearest_dif_hash[i - 1][j][k];
					}
				}
			}
		}
	}

	solve(n, m, a, mx_up);
	trans(n, m, a);
	solve(m, n, a, mx_lt);
	trans(m, n, mx_lt);

	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << mx_up[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }
	// cout << "\n";
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		cout << mx_lt[i][j] << " ";
	// 	}
	// 	cout << "\n";
	// }


	ll ans = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int x = mx_up[i][j];
			for (int k = 0; k < x; k++) {
				if (i - nearest_dif_hash[i][j - k][j] > k) {
					ans++;
				}
			}
		}
	}

	cout << ans;

	return 0;
}