#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include<bits/stdc++.h>

using namespace std;

const int N = 501;

int n, m;

int a[N][N];

int nrl[N][N];
int nrd[N][N];
bitset<N> cn[N][N];



void init() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> s;
			for (int tj = j; tj < m; tj++) {
            	if (s.count(a[i][tj])) break;
            	else s.insert(a[i][tj]);	
            }
            nrl[i][j] = (int)s.size();
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> s;
			for (int ti = i; ti < n; ti++) {
            	if (s.count(a[ti][j])) break;
            	else s.insert(a[ti][j]);	
            }
            nrd[i][j] = (int)s.size();
		}                
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j + 1 < m; j++) {
			set<int> s1;
			set<int> s2;
			cn[i][j][0] = 1;
			for (int ti = i; ti < i + nrd[i][j]; ti++) {
				s1.insert(a[ti][j]);
				s2.insert(a[ti][j + 1]);
				cn[i][j][ti - i + 1] = (s1 == s2);
			}
		}
	}
}

int read() {
	char a, b;
	cin >> a >> b;
	int res = 100 * (a - 33) + (b - 33);
	return res;
}

int solve(int i, int j) {
	int ans = 0;
	int mn = N;
	bitset<N> pot;
	for (int i = 0; i < N; i++) pot[i] = i;
	for (int len = 1; i + len <= n && j + len <= m; len++) {
		int ti = i + len - 1;
		int tj = j + len - 1;
		int ok = 1;
		mn = min(mn, nrl[ti][j]);
		mn = min(mn, nrd[i][tj]);
		if (mn < len) break;
		if (len > 1) pot &= cn[i][tj - 1];
		if (ok && pot[len]) ans++;
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
   	
   	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			a[i][j] = read();
		}
	}
	init();
	//cout << cn[2][0][0] << endl;
	int ans = 0;
	for (int i = 0; i < n; i++) {
	 	for (int j = 0; j < m; j++) {
	 		ans += solve(i, j);
	 	}
	}
	cout << ans << endl;
}                                                           