#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define fr(i, n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<ll> vll;
typedef vector<pii> vii;

const int N = 2001;
int mt[N][N];
int n, m;
int maxl[N][N];
int maxd[N][N];
void calcstr() {
	fr(i, n) {
		vi cnt(127 * 127, 0);
		fr(j, m) {
			int k;
			if (j == 0) k = 0;
			else {
				cnt[mt[i][j - 1]]--;
				k = maxl[i][j - 1];
			}
			for (; k < m; ++k) {
				if (cnt[mt[i][k]] == 0) {
					cnt[mt[i][k]]++;
				} else break;
			}
			maxl[i][j] = k;
		}

	}
}
void calcceil() {
	fr(j, m) {
		vi cnt(127 * 127, 0);
		fr(i, n) {
			int k;
			if (i == 0) k = 0;
			else {
				cnt[mt[i - 1][j]]--;
				k = maxd[i - 1][j];
			}
			for (; k < n; ++k) {
			if (cnt[mt[k][j]] == 0) {
					cnt[mt[k][j]]++;
				} else break;
			}
			maxd[i][j] = k;
		}
	}
}

bool check(int a, int b, int c, int d) {

	vi cnt(127 * 127, 0);
	int x = 0;
	for (int i = a; i <= c; ++i) {
		for (int j = b; j <= d; ++j) {
			cnt[mt[i][j]]++;
			if (cnt[mt[i][j]] == 1) {
				++x;
			}
		}
	}
	return x == c - a + 1;
}
int cc = 0;
void f(int i, int j) {
	int row = m;
	int ceil = n;
	for (int x = 1; i + x <= n && j + x <= m; ++x) {
		ceil = min(ceil, maxd[i][j + x - 1]);
		row = min(row, maxl[i + x - 1][j]);
		if (ceil <= i + x - 1) break;
		if (row <= j + x - 1) break;

		if (check(i, j, i + x - 1, j + x - 1)) {
			++cc;
			x *= 2; --x;
		}
	}
}
void solve() {
	cin >> n >> m;
	fr(j, n) {
		string str; cin >> str;
		for (int i = 1, sz(str.size()); i < sz; i += 2) {
			mt[j][i >> 1] = (str[i - 1] - 32) * 127 + str[i] - 32;
		}
	}
	calcstr();
	calcceil();
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			f(i, j);
		}
	}
	cout << cc;
}
int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	solve();
}