#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

vector <vector <int>> a;
int n, m;

bool check(int x, int y, int m) {
	map <int, int> cnt;
	for (int i = x; i < x + m; i++)
		for (int j = y; j < y + m; j++)
			cnt[a[i][j]]++;

	if (cnt.size() != m)
		return 0;
	for (auto & i : cnt)
		if (i.s != m)
			return 0;

	for (int i = x; i < x + m; i++) {
		set <int> pep;
		for (int j = y; j < y + m; j++)
			pep.insert(a[i][j]);
		if (pep.size() != m)
			return 0;
	}

	for (int j = y; j < y + m; j++) {
		set <int> pep;
		for (int i = x; i < x + m; i++)
			pep.insert(a[i][j]);
		if (pep.size() != m)
			return 0;
	}

	return 1;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	cin >> n >> m;

	a.resize(n, vector <int>(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			char x, y;
			cin >> x >> y;
			a[i][j] = (int)x * 1000 + (int)y;
		}

	//for (auto & i : a)
		//cerr << i << endl;

	ll ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			for (int l = 1; l < min(n - i, m - j) + 1; l++)
				if (check(i, j, l)) {
					//cerr << i << " " << j << " " << l << endl;
					ans++;
				}
		}
	cout << ans << endl;
	return 0;
}