#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long

vector<vector<vector<char>>> used;
int n, m;

bool check(vector<vector<short>> &a, int x1, int y1, int x2, int y2) {
    set<short> solver;
    int k = x2 - x1 + 1;
    for (int i = x1; i <= x2; ++i) {
        for (int j = y1; j <= y2; ++j) {
            solver.emplace(a[i][j]);
        }
    }
    if (solver.size() != k) {
        if (solver.size() < k) {
            for (int cur = k; cur <= max(n, m); ++cur) {
                used[x1][y1][cur] = 1;
            }
        }
        return 0;
    }

    for (int i = x1; i <= x2; ++i) {
        set<short> s;
        for (int j = y1; j <= y2; ++j) {
            s.emplace(a[i][j]);
        }
        if (s.size() != k) {
            if (s.size() < k) {
                for (int cur = k; cur <= max(n, m); ++cur) {
                    used[x1][y1][cur] = 1;
                }
            }
            return 0;
        }
    }

    for (int j = y1; j <= y2; ++j) {
        set<short> s;
        for (int i = x1; i <= x2; ++i) {
            s.emplace(a[i][j]);
        }
        if (s.size() != k) {
            if (s.size() < k) {
                for (int cur = k; cur <= max(n, m); ++cur) {
                    used[x1][y1][cur] = 1;
                }
            }
            return 0;
        }
    }
    return 1;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    cin >> n >> m;
    vector<string> s(n);
    for (auto &i : s)
        cin >> i;

    vector<vector<short>> a(n, vector<short> (m));
    used.resize(n, vector<vector<char>> (m, vector<char> (max(n, m) + 1)));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m * 2; j += 2) {
            a[i][j / 2] = s[i][j] * 127 + s[i][j + 1];
        }
    }

    int ans = 0;
    for (int k = 1; k <= max(n, m); ++k) {
        for (int i = 0; i + k <= n; ++i) {
            for (int j = 0; j + k <= m; ++j) {
                if (!used[i][j][k]) {
                    bool res = check(a, i, j, i + k - 1, j + k - 1);
                    ans += res;
                    if (res) {
                        for (int cur = k; cur < 2 * k && cur <= max(n, m); ++cur) {
                            used[i][j][cur] = 1;
                            if (min(i, j) - cur + k >= 0)
                                used[i - cur + k][j - cur + k][cur] = 1;
                            if (i - cur + k >= 0)
                                used[i - cur + k][j][cur] = 1;
                            if (j - cur + k >= 0)
                                used[i][j - cur + k][cur] = 1;
                            //cout << i << ' ' << j << ' ' << cur << ' '  << k << endl;
                        }
                    }
                }
            }
        }
    }
    cout << ans;
    return 0;
}
