#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <time.h>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)2e3;
const int A = (int)1e4;

int n, m, a[N][N], first_down[N][N], first_right[N][N], nxt_down[N][N], nxt_right[N][N], last_ind[A], ans;
int t, used[A];

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    fastio;
    cin >> n >> m;
    rep(n, i) {
        rep(m, j) {
            char c1, c2;
            cin >> c1 >> c2;
            c1 -= 33, c2 -= 33;
            a[i][j] = c1 * 100 + c2;
        }
    }
    fill(allar(last_ind, A), n);
    rep(m, j) {
        per(n, i) {
            nxt_down[i][j] = last_ind[a[i][j]];
            last_ind[a[i][j]] = i;
        }
        rep(n, i) {
            last_ind[a[i][j]] = n;
        }
    }
    fill(allar(last_ind, A), m);
    rep(n, i) {
        per(m, j) {
            nxt_right[i][j] = last_ind[a[i][j]];
            last_ind[a[i][j]] = j;
        }
        rep(m, j) {
            last_ind[a[i][j]] = m;
        }
    }
    per(n, i) {
        rep(m, j) {
            if (i == n - 1) {
                first_down[i][j] = i;
            } else {
                first_down[i][j] = min(first_down[i + 1][j], nxt_down[i][j] - 1);
            }
        }
    }
    per(m, j) {
        rep(n, i) {
            if (j == m - 1) {
                first_right[i][j] = j;
            } else {
                first_right[i][j] = min(first_right[i][j + 1], nxt_right[i][j] - 1);
            }
        }
    }
    rep(n, i) {
        rep(m, j) {
            ++ans;
            ++t;
            used[a[i][j]] = t;
            int max_k = min(first_right[i][j] - j + 1, first_down[i][j] - i + 1);
            int cnt_us = 1;
            int i1 = i + 1;
            int j1 = j + 1;
            for (int k = 2; k <= max_k; ++k) {
                max_k = min(max_k, min(first_down[i][j1] - i + 1, first_right[i1][j] - j + 1));
                if (max_k < k) {
                    break;
                }
                rep(k, it) {
                    if (used[a[i1][j + it]] != t) {
                        used[a[i1][j + it]] = t;
                        ++cnt_us;
                    }
                }
                rep(k, it) {
                    if (used[a[i + it][j1]] != t) {
                        used[a[i + it][j1]] = t;
                        ++cnt_us;
                    }
                }
                if (cnt_us == k) {
                    ++ans;
                }
                ++i1, ++j1;
            }
        }
    }
    cout << ans;
    return 0;
} 