#include <bits/stdc++.h>

using namespace std;
const int MAXN = (1 << 11);

int n, m;
pair < int, int > a[MAXN][MAXN];
map < pair < int, int >, int > mp[MAXN][MAXN];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            char c1, c2;
            cin >> c1 >> c2;
            a[i][j].first = (int)(c1);
            a[i][j].second = (int)(c2);
        }
}

void fill_dp()
{
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)

            for (int k1 = 36; k1 <= 126; k1 ++)
                for (int k2 = 36; k2 <= 126; k2 ++)
                {
                    pair < int, int > p;
                    p.first = k1;
                    p.second = k2;
                    mp[i][j][p] += mp[i - 1][j][p] +
                                   mp[i][j - 1][p] -
                                   mp[i - 1][j - 1][p];
                }

}

bool test(int x1, int y1, int &k)
{
    int x2 = x1 + k - 1, y2 = y1 + k - 1;
    x1 --;
    y1 --;

    map < pair < int, int >, int > dd;
    int cnt = 0;
    for (int i = 36; i <= 126; i ++)
        for (int j = 36; j <= 126; j ++)
        {
            pair < int, int > p;
            p.first = i;
            p.second = j;

            dd[p] = mp[x2][y2][p] -
                    mp[x2][y1][p] -
                    mp[x1][y2][p] +
                    mp[x1][y1][p];
            if (dd[p] != 0)
                cnt ++;
        }

    return cnt == k;
}
void solve()
{
    fill_dp();
    int ans = 0;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            for (int k = 1; k <= min(n - i, m - j); k ++)
                if (test(i, j, k))
                    ans ++;
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();
    solve();
    return 0;
}
