#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;

mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

const int N = 5e2 + 7;
const int C = 100;

pair<int, int> f[N][N];

int up[N][N];
int r[N][N];

pair<int, int> upp[C][C][N];
pair<int, int> righ[C][C][N];

void solve(){
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < C; i++) {
		for (int j = 0; j < C; j++) {
			for(int k = 0; k  < N; k++)
				upp[i][j][k] = righ[i][j][k] = { -1, -1 };
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char f1, f2; cin >> f1 >> f2;
			int a = (int)f1 - 33;
			int b = (int)f2 - 33;
			up[i][j] = N;
			r[i][j] = N;
			if (upp[a][b][j].first != -1) {
				up[upp[a][b][j].first][upp[a][b][j].second] = i;
			}
			upp[a][b][j] = { i, j };
			f[i][j] = { a, b };
		}
	}
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			int a = f[i][j].first;
			int b = f[i][j].second;
			if (righ[a][b][i].first != -1)
				r[righ[a][b][i].first][righ[a][b][i].second] = j;
			righ[a][b][i] = { i, j };
		}
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << up[i][j] << " ";
		}
		cout << endl;
	}*/
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<pair<int, int>> omg;
			int d = N;
			for (int k = 0; k < d && i + k < n && j + k < m; k++) {
				for (int t = 0; t <= k; t++) {
					omg.insert(f[i + t][j + k]);
					omg.insert(f[i + k][j + t]);
					d = min(d, up[i + t][j + k] - i);
					d = min(d, r[i + t][j + k] - j);
					d = min(d, up[i + k][j + t] - i);
					d = min(d, r[i + k][j + t] - j);
				}
				if (omg.size() == (k + 1)) {
					//cout << i << " " << j << " " << k + 1 << " " << omg.size() << endl;
					//if (k != 0) cout << i << " " << j << " " << k + 1 << endl;
					ans++;
				}
			}
		}
	}
	cout << ans << endl;
}