#include <bits/stdc++.h>

using namespace std;
const int MAXN = 510;

int n, m;
pair < char, char > c[MAXN][MAXN];

void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
            cin >> c[i][j].first >> c[i][j].second;
}

int s[130][130];
bool latin(int &x, int &y, int &k)
{
    int cnt = 0;
    for (int i = x; i < x + k; i ++)
        for (int j = y; j < y + k; j ++)
        {
            if (s[(int)(c[i][j].first)][(int)(c[i][j].second)] == 0)
                cnt ++;
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 1;
        }

    bool ans = true;

    if (cnt != k)
        ans = false;

    for (int i = x; i < x + k; i ++)
        for (int j = y; j < y + k; j ++)
        {
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 0;
        }

    for (int i = x; i < x + k; i ++)
    {
        for (int j = y; j < y + k; j ++)
        {
            if (s[(int)(c[i][j].first)][(int)(c[i][j].second)] == 1)
                ans = false;
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 1;
        }

        for (int j = y; j < y + k; j ++)
        {
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 0;
        }
    }

    for (int j = y; j < y + k; j ++)
    {
        for (int i = x; i < x + k; i ++)
        {
            if (s[(int)(c[i][j].first)][(int)(c[i][j].second)] == 1)
                ans = false;
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 1;
        }

        for (int i = x; i < x + k; i ++)
        {
            s[(int)(c[i][j].first)][(int)(c[i][j].second)] = 0;
        }
    }

    return ans;
}
int test(int &k)
{
    int cnt = 0;
    for (int i = 1; i <= n - k + 1; i ++)
        for (int j = 1; j <= m - k + 1; j ++)
        {
            if (latin(i, j, k))
                cnt ++;
        }
    return cnt;
}

void solve()
{
    int ans = 0;
    for (int k = 1; k <= min(n, m); k ++)
        ans += test(k);
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
/**
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
