#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

const int alph = 96;
int k = (1 << 9);

struct DO {

	int mn[alph * alph];
	int mx[alph * alph];
	int cnt[alph * alph];

};

vector <DO> d(2 * k);

void push(int x, int a, int symb) {

	x += k;
	d[x].mn[symb] = d[x].mx[symb] = a;
	d[x].cnt[symb] = 1;

	x /= 2;
	while (x > 0) {

		d[x].mn[symb] = min(d[2 * x].mn[symb], d[2 * x + 1].mn[symb]);
		d[x].mx[symb] = max(d[2 * x].mx[symb], d[2 * x + 1].mx[symb]);
		d[x].cnt[symb] = d[2 * x].cnt[symb] + d[2 * x + 1].cnt[symb];

		x /= 2;
	}

}

pair <int, pii> check(int L, int R, int symb) {

	L += k, R += k;
	pair <int, pii> ans = { 0, {1e9, 0} };

	while (L <= R) {

		if (L % 2 == 1) ans.second.first = min(ans.second.first, d[L].mn[symb]), ans.second.second = max(ans.second.second, d[L].mx[symb]), ans.first += d[L].cnt[symb], L++;
		if (L % R == 0) ans.second.first = min(ans.second.first, d[R].mn[symb]), ans.second.second = max(ans.second.second, d[R].mx[symb]), ans.first += d[R].cnt[symb], R--;

		L /= 2, R /= 2;

	}

	return ans;

}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	FR(i, d.size()) FR(j, alph * alph) d[i].mn[j] = 1e9;

	int n, m; cin >> n >> m;
	//vector <vector <string>> a(n, vector <string>(m));
	vector <vector <int>> a(n, vector <int>(m));

	char v1, v2;
	FR(i, n) FR(j, m) cin >> v1 >> v2, a[i][j] = (v1 - '!' + 1) * (alph - 1) + (v2 - '!' + 1);

	int ans = 0;

	FR(i, n) FR(j, m) push(i, j, a[i][j]);

	vector < pair <int, pii> > LR(m);

	FR(dlt, n) {

		FR(i, n - dlt) {

			FR(j, m) LR[j] = check(i, i + dlt, a[i][j]);
			sort(all(LR));

			int ch = 0;// , lastL = LR[0].second.first;
			FR(j, LR.size()) {
			
				if (ch == dlt + 1) ans++;

				if (j > 0 && ch > 0) {

					if (LR[j] == LR[j - 1]) ch++;
					else ch = 0;
				}

				if (LR[j].first == dlt + 1 && LR[j].second.second - LR[j].second.first == dlt && ch == 0) ch = 1;
				//else ch = 0;
				if (!(LR[j].first == dlt + 1 && LR[j].second.second - LR[j].second.first == dlt)) ch = 0;

			}
			if (ch == dlt + 1) ans++;
		}
	}

	cout << ans;

	return 0;
}