#include <bits/stdc++.h>

//#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;
const int Q = 101;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXC = 1e5;

vector <int> st(MAXC);

int subhash(int hl, int hr, int len)
{
    return (hr - hl + P) % P;
}


signed main()
{
    hello();

    int n, m;
    cin >> n >> m;
    vector <vector <int>> matr(n, vector <int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char c1, c2;
            cin >> c1 >> c2;
            matr[i][j] = (c1 - 32) * 100 - (c2 - 32);
        }
    }

    //show(matr);
    st[0] = 1;
    for (int i = 1; i < MAXC; ++i)
        st[i] = (ll)st[i - 1] * Q % P;

    vector <vector <int>> left(n, vector <int>(m + 1));
    vector <vector <int>> up(n + 1, vector <int>(m));

    for (int i = 0; i < n; ++i)
        for (int j = 1; j <= m; ++j)
            left[i][j] = (left[i][j - 1] + st[matr[i][j - 1]]) % P;

    for (int j = 0; j < m; ++j)
        for (int i = 1; i <= n; ++i)
        {
            up[i][j] = (up[i - 1][j] + st[matr[i - 1][j]]) % P;
        }

    int res = 0;

    vector <int> cnt(MAXC);
    vector <int> used(MAXC);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {

            for (int len = 0; len + j < m && len + i < n; ++len)
            {
                if (used[matr[i][j + len]] != (i * m) + j)
                {
                    cnt[matr[i][j + len]] = 0;
                    used[matr[i][j + len]] = i * m + j;
                }
                ++cnt[matr[i][j + len]];
                if (cnt[matr[i][j + len]] == 2)
                    break;
                bool flag = 0;
                int ch = subhash(left[i][j], left[i][j + len + 1], len + 1);
                for (int i1 = i; i1 <= i + len; ++i1)
                    if (subhash(left[i1][j], left[i1][j + len + 1], len + 1) != ch)
                        flag = 1;
                for (int j1 = j; j1 <= j + len; ++j1)
                    if (subhash(up[i][j1], up[i + len + 1][j1], len + 1) != ch)
                        flag = 1;
                if (!flag)
                    ++res;
            }
        }

    cout << res << endl;

}
