#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<deque>
#include<set>
#include<map>
#include<random>
#include<tuple>
#include<cassert>
#include<bitset>

#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ld;

#define int short
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

//mt19937 gen(313);
//uniform_int_distribution <int> rand_int(1, 1000000000);

const int N = 103;

int f[N][N];
map <pair <char, char>, int> ask;

void solve() {
	int n, m, cnt = 0; cin >> n >> m;
	loop1(i, n)
		loop1(j, m) {
		char c1, c2; cin >> c1 >> c2;
		if (ask.find({ c1, c2 }) != ask.end())
			f[i][j] = ask[{c1, c2}];
		else
			ask[{c1, c2}] = f[i][j] = ++cnt;
	}
	int ans = n * m, minnm = min(n, m);
	for (int sz = 2; sz <= min(n, m); ++sz) 
		for (int up = 1; up <= n - sz + 1; ++up) {
			multiset <int> strd[N], rowd[N];
			set <int> str[N], row[N];
			for (int s = up; s < up + sz; ++s)
				loop1(x, sz) {
				    strd[s].insert(f[s][x]); str[s].insert(f[s][x]);
					rowd[x].insert(f[s][x]); row[x].insert(f[s][x]);
			    }
			int lst;
			for (int i = sz; i > 0; --i) {
				if (rowd[i].size() != row[i].size()) {
					lst = i; break;
				}
				if (row[i] != row[i - 1]) {
					lst = i - 1; break;
				}
			}
			for (int r = sz; r <= m; ++r) {
				if (r == sz) goto mark;
				for (int x = up; x < up + sz; ++x) {
					strd[x].erase(strd[x].find(f[x][r - sz]));
					if (strd[x].find(f[x][r - sz]) == strd[x].end())
						str[x].erase(f[x][r - sz]);
				}
				for (int x = up; x < up + sz; ++x) {
					strd[x].insert(f[x][r]); str[x].insert(f[x][r]);
					row[r].insert(f[x][r]); rowd[r].insert(f[x][r]);
				}
				if (row[r] != row[r - 1]) lst = r - 1;
				if (row[r].size() != rowd[r].size()) lst = r;
			    mark:;
				//cout << sz << " " << up << " " << r << " " << lst << "\n";
				if (r - lst >= sz) {
					bool ok = 1;
					for (int i = up; i < up + sz; ++i)
						if (strd[i].size() != str[i].size()) {
							ok = 0; break;
						}
					ans += ok;
				}
			}
		}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
    solve();
	return 0;
}
