//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <ctime>

#define ll long long
#define S second
#define F first

using namespace std;

ll a, b, c, d, e;
vector <ll> ar, agr, price;
vector <ll> pp, prost;
vector <vector <ll> > arr;
vector <vector <ll> > hash1, hash2, maxlen;

bool is_prime(ll a)
{
    for (ll i = 2; i <= round(sqrt(a)); ++i)
        if (a % i == 0)
            return false;
    return true;
}

ll p = (126 - 33 + 1) * (126 - 33 + 1);
ll ot;

void solve1(ll dl)
{
    ll del = 2;
    while (true)
    {
        dl *= del;
        if (dl > min(a, b))
            break;
        for (ll i = 0; i + dl <= a; ++i)
            for (ll j = 0; j + dl <= b; ++j)
            {
                if (hash1[i][j] == hash1[i + dl / 2][j + dl / 2] && hash1[i][j + dl / 2] == hash1[i + dl / 2][j] && hash1[i][j] != -1 && hash1[i][j + dl / 2] != -1)
                {
                    ++ot;
                    maxlen[i][j] = dl;
                }
            }
    }
    return;
}



int main()
{
    srand(time(0));
    cin >> a >> b;
    ot = a * b;
    arr.resize(a);
    hash1.resize(a);
    maxlen.resize(a);
    pp.resize(p * p);
    for (ll i = 0; i < p * p; ++i)
        pp[i] = (rand() % (ll)1e15 + 7);
    for (ll i = 2; i <= min(a, b); ++i)
        if (is_prime(i))
            prost.push_back(i);
    for (ll i = 0; i < a; ++i)
    {
        string s;
        cin >> s;
        arr[i].resize(b);
        hash1[i].resize(b);
        maxlen[i].resize(b);
        for (ll j = 0; j < b * 2; j += 2)
        {
            arr[i][j / 2] = (s[j] - char(33)) * p + s[j + 1] - char(33);
            hash1[i][j / 2] = pp[(s[j] - char(33)) * p + s[j + 1] - char(33)];
        }
    }
    for (ll n = 0; n < prost.size(); ++n)
    {
        for (ll i = 0; i < a; ++i)
        {
            for (ll j = 0; j < b; ++j)
            {
                ll dl = prost[n];
                map <ll, ll> map1, map2;
                ll fl = 0;
                maxlen[i][j] = -1;
                //cout << i << " " << j << endl;
                while (i + dl <= a && j + dl <= b)
                {
                    //cout << dl + i << " " << dl + j << " w" << endl;
                    for (ll k = i; k < i + dl; ++k)
                    {
                        for (ll k1 = j; k1 < j + dl; ++k1)
                        {
                            ++map1[arr[k][k1]];
                            ++map2[arr[k][k1]];
                        }
                        if (map2.size() != dl)
                            fl = 1;
                        map2.clear();
                    }
                    if (map1.size() != dl)
                    {
                        break;
                    }
                    for (ll k = j; k < j + dl; ++k)
                    {
                        for (ll k1 = i; k1 < i + dl; ++k1)
                        {
                            ++map2[arr[k1][k]];
                        }
                        if (map2.size() != dl)
                            fl = 1;
                        map2.clear();
                    }
                    if (fl == 1)
                        break;
                    ++ot;
                    maxlen[i][j] = dl;
                    break;
                }
            }
        }
        solve1(prost[n]);
    }
    cout << ot;
}
