/*#pragma GCC optimize("Ofast, no-stack-protector")
 #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx,mmx,avx,tune-native")
 #pragma GCC optimize("unroll-loops")
 #pragma GCC optimize("fast-math") */

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()

typedef long long ll;
typedef long double lld;

int a[40][40];

bool check(int k) {
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            for (int h = 0; h < k; h++) {
                if (h != j && a[i][h] == a[i][j])
                    return false;
                if (h != i && a[h][j] == a[i][j])
                    return false;
            }
            int cnt = 0;
            for (int x = 0; x < k; x++) {
                for (int y = 0; y < k; y++) {
                    if (a[x][y] == a[i][j])
                        cnt++;
                }
            }
            if (cnt != k)
                return false;
        }
    }
    return true;

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // комменти файлы, умоляю
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    int arr[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            arr[i][j] = (int)x * 100 + (int)y;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 1; i + k <= n && j + k <= m; k++) {
                for (int x = i; x < i + k; x++) {
                    for (int y = j; y < j + k; y++) {
                        a[x - i][y - j] = arr[x][y];
                    }
                }
                if (check(k)) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}