#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 2e3 + 10, MAX_C = 8900, BASE = 9001, MOD = 1e9 + 7;

ll powers[MAX_C];

short a[MAX_N][MAX_N];

char isGoodHor[MAX_N][MAX_N]; 
ll hh[MAX_N][MAX_N];

short len_eq1[MAX_N][MAX_N], len_eq2[MAX_N][MAX_N], len_eq3[MAX_N][MAX_N]; 

int used[MAX_C];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char x, y;
			cin >> x >> y;
			a[i][j] = (x - 33) * 94 + (y - 33);
		}
	}
	powers[0] = 1;
	for (int i = 1; i < MAX_C; ++i)
		powers[i] = powers[i - 1] * BASE % MOD;
	int ans = 0;
	for (int len = 2; len <= min(n, m); ++len) {
		// for (int i = 0; i < m; ++i) {
		// 	int diff = 0;
		// 	for (int j = 0; j < n; ++j) {
		// 		if (!used[a[j][i]])
		// 			++diff;
		// 		++used[a[j][i]];
		// 		if (j >= len) {
		// 			--used[a[j - len][i]];
		// 			if (!used[a[j - len][i]])
		// 				--diff;
		// 		}
		// 		if (diff == len)
		// 			len_eq1[j][i] = (i == 0 ? 0 : len_eq1[j][i - 1]) + 1;
		// 		else
		// 			len_eq1[j][i] = 0;
		// 	}
		// 	for (int j = 0; j < n; ++j)
		// 		used[a[j][i]] = 0;
		// }
		for (int i = 0; i < n; ++i) {
			int diff = 0;
			ll curr_hash = 0;
			for (int j = 0; j < m; ++j) {
				if (!used[a[i][j]]) {
					curr_hash += powers[a[i][j]];
					if (curr_hash >= MOD)
						curr_hash -= MOD;
					++diff;
				}
				++used[a[i][j]];
				if (j >= len) {
					--used[a[i][j - len]];
					if (!used[a[i][j - len]]) {
						curr_hash -= powers[a[i][j - len]];
						if (curr_hash < 0)
							curr_hash += MOD;
						--diff;
					}
				}
				// if (diff == len) {
				// 	len_eq2[i][j] = (i == 0 ? 0 : len_eq2[i - 1][j]) + 1;
				// } else {
				// 	len_eq2[i][j] = 0;
				// }
				hh[i][j] = curr_hash;
				if (i == 0 || hh[i - 1][j] != hh[i][j])
					len_eq3[i][j] = 1;
				else
					len_eq3[i][j] = len_eq3[i - 1][j] + 1;
			}
			for (int j = 0; j < m; ++j)
				used[a[i][j]] = 0;
		}
		for (int i = 0; i <= n - len; ++i) {
			for (int j = 0; j <= m - len; ++j) {
				bool isgood = 1;
				isgood &= len_eq3[i + len - 1][j + len - 1] >= len;
				// isgood &= len_eq2[i + len - 1][j + len - 1] >= len;
				// isgood &= len_eq1[i + len - 1][j + len - 1] >= len;
				ans += isgood;
			}
		}
		// for (int i = 0; i < n; ++i) {
		// 	for (int j = 0; j < m; ++j)
		// 		cout << len_eq1[i][j] << " ";
		// 	cout << "\n";
		// }
		// cout << "\n";
	}
	cout << ans + n * m << "\n";
	return 0;
}