#include <bits/stdc++.h>
using namespace std;

//#define int long long

typedef long long ll;
typedef pair < int, int > pii;
#define sz(x) int(x.size())
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 2;
const int MOD = 1e9 + 7;
const int N = 5e2 + 1;
const int K = 1e5;

unsigned short a[N][N], r[N][N][N], c[N][N][N];
char vr[N][N][N], vc[N][N][N];
ll p[K];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    p[0] = 1;
    for (int i = 1; i < K; i++) {
        p[i] = p[i - 1] * 227;
    }

    short n, m;
    cin >> n >> m;

    for (short i = 1; i <= n; i++) {
        for (short j = 1; j <= m; j++) {
            char x, y;
            cin >> x >> y;

            a[i][j] = (x - char(33) + 240) + (y - char(33) + 240) * 227;
            //cout << a[i][j] << endl;
            //cout << (x - char(33) + 1) << " " << (y - char(33) + 1) << endl;
            //cout << int(x) << endl;
        }
    }

    

    for (short i = 1; i <= n; i++) {
        for (short j = 1; j <= m; j++) {
            unordered_set < unsigned short > s;
            for (short k = j; k <= m; k++) {
                s.insert(a[i][k]);
                vr[i][j][k] = (k - j + 1) == (sz(s));
                r[i][j][k] = r[i][j][k - 1] + p[a[i][k]];
            }
        }
    }

    

    for (short j = 1; j <= m; j++) {
        for (short i = 1; i <= n; i++) {
            unordered_set < unsigned short > s;
            for (short k = i; k <= n; k++) {
                s.insert(a[k][j]);
                vc[i][j][k] = (k - i + 1) == sz(s);
                c[i][j][k] = c[i][j][k - 1] + p[a[k][j]];
            }
        }
    }

    

    int ans = 1LL * n * m;
    for (short k = 2; k <= min(n, m); k++) {
        for (short i = 1; i <= n; i++) {
            for (short j = 1; j <= m; j++) {
                //cout << k << " " << i << " " << j << endl;
                if (i + k - 1 > n || j + k - 1 > m) {
                    break;
                }

                unsigned short h = r[i][j][j + k - 1];
                char flag = 1;
                for (short cr = i; cr < i + k; cr++) {
                    if (!vr[cr][j][j + k - 1] || r[cr][j][j + k - 1] != h) {
                        flag = 0;
                        break;
                    }
                }

                if (!flag) {
                    continue;
                }

                h = c[i][j][i + k - 1];
                for (short cc = j; cc < j + k; cc++) {
                    if (!vc[i][cc][i + k - 1] || c[i][cc][i + k - 1] != h) {
                        flag = 0;
                        break;
                    }    
                }

                ans += (flag);
            }
        }
    }

    cout << ans << endl;

    return 0;
}