#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

ll n, m;
vector<vector<ll>> mx;

void solve() {
    /// troubles de la tete
    cin >> n >> m;
    mx.assign(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            mx[i][j] = (ll(a) << 32) + ll(b);
        }
    }
#ifdef Debug
    forEach(mx) {
        forEach(it) cout << it << " ";
        cout << "\n";
    }
#endif
    ll ans = n * m;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            for (ll d = 2; i + d <= n && j + d <= m; d++) {
                unordered_set<ll> all;
                vector<unordered_set<ll>> hor(d);
                vector<unordered_set<ll>> ver(d);
                for (ll I = i; I < i + d; I++) {
                    for (ll J = j; J < j + d; J++) {
                        all.insert(mx[I][J]);
                        hor[I - i].insert(mx[I][J]);
                        ver[J - j].insert(mx[I][J]);
                    }
                }
                if (all_of(all(hor), [=](unordered_set<ll> &v) { return v.size() == d; }) &&
                    all_of(all(ver), [=](unordered_set<ll> &v) { return v.size() == d; }) &&
                    all.size() == d) ans++;
            }
        }
    }
    cout << ans << "\n";
}

int main() {
#ifndef Debug
    FASTIO
#endif
    solve();
    return 0;
}