#include <bits/stdc++.h>

using namespace std;

//#define ll long long
typedef long long ll;

const ll maxn = 1002;
const ll inf = 1e18;
const ll maxns = 70000;

ll dop[maxns];
ll mdown[maxn][maxn];
ll mleft[maxn][maxn];
ll pref[maxn][maxn];
ll pref2[maxn][maxn];
ll dd_2[maxn][maxn];
ll dd[maxn][maxn];
ll dd2_2[maxn][maxn];
ll dd2[maxn][maxn];
ll mmax[maxn][maxn];
ll v[maxn][maxn];


struct node {
    ll l, r, mmin;
    node *left, *right;
};

node *root_down[maxn];
node *root_left[maxn];

node *build2(ll l, ll r, ll i){
    node *res = new node;
    res->l = l;
    res->r = r;
    if(l == r){
        res->mmin = mleft[l][i];
        res->right = res->left = nullptr;
    }
    else {
        ll mid = (l+r) / 2;
        res->left = build2(l, mid, i);
        res->right = build2(mid+1, r, i);
        res->mmin = min(res->left->mmin, res->right->mmin);
    }
    return res;
}

node *build(ll l, ll r, ll i){
    node *res = new node;
    res->l = l;
    res->r = r;
    if(l == r){
        res->mmin = mdown[i][l];
        res->right = res->left = nullptr;
    }
    else {
        ll mid = (l+r) / 2;
        res->left = build(l, mid, i);
        res->right = build(mid+1, r, i);
        res->mmin = min(res->left->mmin, res->right->mmin);
    }
    return res;
}

ll query(node *root, ll l, ll r){
    if(root->l > r || root->r < l)return inf;
    if(root->l >= l  && root->r <= r)return root->mmin;
    return min(query(root->left, l, r), query(root->right, l, r));
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    srand(time(0));
/*
    vector<int> dop.resize(maxns);
    vector<vector<int> > mdown[maxn][maxn];
    ll mleft[maxn][maxn];
    ll pref[maxn][maxn];
    ll pref2[maxn][maxn];
    ll dd_2[maxn][maxn];
    ll dd[maxn][maxn];
    ll dd2_2[maxn][maxn];
    ll dd2[maxn][maxn];
    ll mmax[maxn][maxn];
    ll v[maxn][maxn];
*/
    ll n, m;
    cin >> n >> m;
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++){
            char ch;
            char ch2;
            cin >> ch >> ch2;
            v[c][i] = ll(ch) * 257 + ll(ch2);
        }
    }

    for(ll c=0; c<m; c++){
        for(ll i=0; i<maxns; i++)
            dop[i] = n;
        for(ll i=n-1; i>=0; i--){
            mdown[i][c] = dop[v[i][c]] - i;
            dop[v[i][c]] = i;
        }
    }
    for(ll c=0; c<n; c++){
        for(ll i=0; i<maxns; i++)
            dop[i] = m;
        for(ll i=m-1; i>=0; i--){
            mleft[c][i] = dop[v[c][i]] - i;
            dop[v[c][i]] = i;
        }
    }/*
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++)
            cout << mleft[c][i] << " ";
        cout  << endl;
    }*/
    for(ll c=0; c<n; c++){
        root_down[c] = build(0, m-1, c);
    }
    for(ll c=0; c<m; c++){
        root_left[c] = build2(0, n-1, c);
    }
    ll ans = 0;
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++){
            ll l = 0, r = min(n, m)+1;
            while(l + 1 < r){
                ll mid = (l+r) / 2;
                ll res1 = query(root_down[c], i, i+mid-1);
                ll res2 = query(root_left[i], c, c+mid-1);
                if(min(res1, res2) >= mid)l = mid;
                else r = mid;
            }
            mmax[c][i] = l;
            //ans += l;
        }
    }
    int ma[maxns], ma2[maxns];
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++){
            //if(ma.find(v[c][i]) == ma.end()){
                //ma[v[c][i]] = (((rand()<<15) + rand())<<15) + rand();
               // ma[v[c][i]] = (((((rand()<<15) + rand())<<15) + rand())<<15)+rand();
                ma[v[c][i]] = ((rand()<<14) + rand());
                ma2[v[c][i]] = ((rand()<<14) + rand());
            //}
        }
    }

    for(ll c=0; c<m; c++){
        for(ll i=0; i<n; i++){
            if(i == 0){
                pref[i][c] = ma[v[i][c]];
            }
            else pref[i][c] = pref[i-1][c] ^ ma[v[i][c]];
        }
    }
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++){
            if(i == 0){
                pref2[c][i] = ma2[v[c][i]];
            }
            else pref2[c][i] = pref2[c][i-1] ^ ma2[v[c][i]];
        }
    }
/*
    for(ll c=0; c<n; c++){
        for(ll i=0; i<m; i++)
            cout << mmax[c][i] << " ";
        cout  << endl;
    }
*/
    for(ll k=1; k<=min(n, m); k++){
        for(ll c=0; c<=n-k; c++){
            for(ll i=0; i<m; i++){
                if(c)dd[c][i] = pref[c+k-1][i] ^ pref[c-1][i];
                else dd[c][i] = pref[c+k-1][i];
            }
        }
        for(ll c=0; c<=n-k; c++){
            dd2[c][m-1] = 1;
            for(ll i=m-2; i>=0; i--){
                if(dd[c][i] == dd[c][i+1]){
                    dd2[c][i] = dd2[c][i+1] + 1;
                }
                else dd2[c][i] = 1;
            }
        }
/*
        for(ll c=0; c<n; c++){
            for(ll i=0; i<m; i++)
                cout << dd2[c][i] << " ";
            cout  << endl;
        }*/

        for(ll c=0; c<=m-k; c++){
            for(ll i=0; i<n; i++){
                if(c)dd_2[i][c] = pref2[i][c+k-1] ^ pref2[i][c-1];
                else dd_2[i][c] = pref2[i][c+k-1];
            }
        }
        for(ll c=0; c<=m-k; c++){
            dd2_2[n-1][c] = 1;
            for(ll i=n-2; i>=0; i--){
                if(dd_2[i][c] == dd_2[i+1][c]){
                    dd2_2[i][c] = dd2_2[i+1][c] + 1;
                }
                else dd2_2[i][c] = 1;
            }
        }


        for(ll c=0; c<n; c++){
            for(ll i=0; i<m; i++){
                if(dd2[c][i] >= k && mmax[c][i] >= k && dd2_2[c][i] >= k)ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

2 3
AABBAA
BBAAAA

3 3
AABBCC
BBCCAA
CCAABB

2 3
AABBAA
BBAAAA

3 2
AABB
BBAA
AAAA

1 2
AABB
*/
