#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define left left228
#define short unsigned short
#define char unsigned char
#pragma GCC optmimize("O3")
const int MAXN = 2e3;

short matrix[MAXN][MAXN];
int up[MAXN][MAXN], left[MAXN][MAXN];


inline short to_short(pair<char, char> p) {
    return ((short)(p.first) << 8) + (short)(p.second);
}

int cnt[65536];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c, t;
            cin >> c >> t;
            matrix[i][j] = to_short({c, t});
        }
    }
    for (int i = 0; i < n; i++) {
        map<short, int> prev;
        for (int j = 0; j < m; j++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                left[i][j] = -1;
            } else {
                left[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        map<short, int> prev;
        for (int i = 0; i < n; i++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                up[i][j] = -1;
            } else {
                up[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = i;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int k = 0;
            int left_max = -1, up_max = -1, d = 0;
            while (i + k < n && j + k < m) {
                for (int t = 0; t <= k; t++) {
                    if (!cnt[matrix[i + t][j + k]]) {
                        d++;
                    }
                    cnt[matrix[i + t][j + k]]++;
                    up_max = max(up_max, up[i + t][j + k]);
                    left_max = max(left_max, left[i + t][j + k]);
                    if (!cnt[matrix[i + k][j + t]]) {
                        d++;
                    }
                    cnt[matrix[i + k][j + t]]++;
                    up_max = max(up_max, up[i + k][j + t]);
                    left_max = max(left_max, left[i + k][j + t]);
                }
                k++;
                if (left_max >= j || up_max >= i) {
                    break;
                }
                if (d == k) {
                    ans++;
                }
            }
            for (int c = 0; c < k; c++) {
                cnt[matrix[i + c][j + c]]--;
                for (int t = 0; t < k; t++) {
                    cnt[matrix[i + c][j + t]]--;
                }
            }
        }
    }
    cout << ans;
    return 0;
}