#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include <climits>
#include <math.h>
#include <list>
#include <algorithm>
#include <bitset>

//#pragma GCC optimize("O3, unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define eb emplace_back
#define x first
#define y second
#define sz(a) (int)a.size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> veci;
typedef vector<bool> vecb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

void z_fun(string str) {
	int n = sz(str);
	veci z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i]);
		while (i + z[i] < n && str[z[i]] == str[i + z[i]])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
}

const int MOD = 1e9 + 7;
const int P = 107;

vvi vec;

bool check(pi st, int a) {
	unordered_set<int> s;
	for (int i = st.x; i < st.x + a; i++)
		for (int j = st.y; j < st.y + a; j++)
			s.emplace(vec[i][j]);
	if (s.size() != a)
		return false;
	for (int i = st.x; i < st.x + a; i++) {
		unordered_set<int> set;
		for (int j = st.y; j < st.y + a; j++) {
			if (set.find(vec[i][j]) != set.end())
				return false;
			set.emplace(vec[i][j]);
		}
	}
	for (int i = st.y; i < st.y + a; i++) {
		unordered_set<int> set;
		for (int j = st.x; j < st.x + a; j++) {
			if (set.find(vec[j][i]) != set.end())
				return false;
			set.emplace(vec[j][i]);
		}
	}
	return true;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vec.assign(n, veci(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;
			vec[i][j] = a - 33 + P * (b - 33);
		}

	/*vector<vector<bitset<11000>>> c(m, vector<bitset<11000>>(n));
	for (int i = 0; i < m; i++)
		c[i][0][vec[0][i]] = 1;
	for (int i = 1; i < n; i++)
		for (int j = 0; j < m; j++) {
			c[j][i] = c[j][i - 1];
			c[j][i][vec[i][j]] = 1;
		}

	vector<vector<bitset<11000>>> r(n, vector<bitset<11000>>(m));
	for (int i = 0; i < n; i++)
		r[i][0][vec[i][0]] = 1;
	for (int i = 1; i < m; i++)
		for (int j = 0; j < n; j++) {
			r[j][i] = r[j][i - 1];
			r[j][i][vec[j][i]] = 1;
		}

	ull res = (ull)n * m;
	for (int i = 2; i < n; i++) {
		bitset<11000> bit;
		for (int j = 0; j < i; j++)
			for (int k = 0; k < i; k++)
				bit[vec[j][k]] = 1;
		if (bit.count() == i)
			res++;
		for (int j = 0; j < n; j++)
			for (int k = 0; k < m; k++) {

			}
	}*/
	ull res = ull(n) * m;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			for (int len = 2; len <= min(n - i, m - j); len++)
				res += 1 * check(mp(i, j), len);

	cout << res << endl;

	return 0;
}
