#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using namespace std;
using namespace __gnu_pbds;

const int N = 2002, M = 10000, L = 11;
ul B = 100001;
ul hr[N][N], pb[N];
char s[N * 2];
int a[N][N], mv[N][N], mh[N][N], lp[M], mp[N], h[M];
ul hv[N][N], hh[N][N];
random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ul> dis(1, 2e18);

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n, m, p1, p2, pos, t1, t2, t3, d1, d2, d3, cc, dd, ans = 0;
	cin >> n >> m;
	rep(i, n) {
		cin >> s;
		rep(j, m)
			a[i][j] = (s[j * 2] - 33) * 94 + s[j * 2 + 1] - 33;
	}
	rep(j, M)
		lp[j] = -1;
	rep(i, n) {
		rep(j, m) {
			mh[i][j] = min((j == 0 ? 0 : mh[i][j - 1]) + 1, j - lp[a[i][j]]);
			lp[a[i][j]] = j;
		}
		rep(j, m)
			lp[a[i][j]] = -1;
	}
	rep(i, m) {
		rep(j, n) {
			mv[j][i] = min((j == 0 ? 0 : mv[j - 1][i]) + 1, j - lp[a[j][i]]);
			lp[a[j][i]] = j;
		}
		rep(j, n)
			lp[a[j][i]] = -1;
	}
	rep(i, M)
		h[i] = dis(gen);
	rep(i, n)
		rep(j, m) {
			hv[i + 1][j] = hv[i][j] ^ h[a[i][j]];
			hh[i][j + 1] = hh[i][j] ^ h[a[i][j]];
		}
	if (n > 500 || m > 500) {
		pb[0] = 1;
		rep(i, m)
			pb[i + 1] = pb[i] * B;
		rep(i, n + 1)
			rep(j, m)
				hr[i][j + 1] = hr[i][j] * B + (hv[i][j] ^ hv[i][j + 1]);
		rep(i, n)
			rep(j, m) {
				int mx = min(i, j) + 1;
				rep(k, mx) {
					if (hr[i + 1][j] - hr[i + 1][j - k] * pb[k] == hr[i - k][j] - hr[i - k][j - k] * pb[k])
						ans++;
				}
			}
		cout << ans;
		return 0;
	}
	ans = n * m;
	rep(i, n)
		rep(j, m) {
			int d = 2;
			for (int k = 2; k <= i + 1 && k <= j + 1; k++) {
				//cout << i << ' ' << j << ' ' << k << ' ' << d << '\n';
				if (d > i + 1 || d > j + 1 || mh[i + 1 - d][j] < d || mv[i][j + 1 - d] < d)
					break;
				if ((hh[i][j + 1] ^ hh[i][j + 1 - d]) != (hh[i - k + 1][j + 1] ^ hh[i - k + 1][j + 1 - d])) {
					d += k - 1;
					k = 1;
					continue;
				}
				if (k == d) {
					int fl = 1;
					for (int l = 1; l < d; l++)
						if ((hv[i + 1][j] ^ hv[i + 1 - d][j]) != (hv[i + 1][j - l] ^ hv[i + 1 - d][j - l])) {
							fl = 0;
							break;
						}
					ans += fl;
					d *= 2;
					k = 1;
					continue;
				}
			}
		}
	cout << ans;
}

