#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;

// #define int long long
#define endl "\n"
#define x first
#define y second 
#define vec vector
#define pii pair<int, int>
#define pb push_back

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	srand(time(0));
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(10);
	solve();
	return 0;
}


void solve() {
	int n, m;
	cin >> n >> m;
	vec<vec<char>> s(n + 1, vec<char>(2 * m + 1));
	for (int i = 1; i <= n; ++i) {
		string str;
		cin >> str;
		for (int j = 1; j <= 2 * m; ++j) {
			s[i][j] = str[j - 1];
		}
	}

	vec<vec<int>> a(n + 1, vector<int>(m + 1));
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			char c1 = s[i][2 * j - 1], c2 = s[i][2 * j];
			a[i][j] = (int)c1 * 127 + (int)c2;
		}
	}

	vec<vec<int>> dp1(n + 1, vec<int>(m + 1)), dp2(n + 1, vec<int>(m + 1));
	vec<vec<int>> id1(n + 1, vec<int>(m + 1)), id2(n + 1, vec<int>(m + 1));
	for (int j = 1; j <= m; ++j) {
		map<int, int> mp;
		for (int i = 1; i <= n; ++i) {
			id1[i][j] = mp[a[i][j]];
			mp[a[i][j]] = i;
		}
	}
	for (int i = 1; i <= n; ++i) {
		map<int, int> mp;
		for (int j = 1; j <= m; ++j) {
			id2[i][j] = mp[a[i][j]];
			mp[a[i][j]] = j;
		}
	}

	for (int i = 1; i <= m; ++i) {
		dp1[1][i] = 1;
	}
	for (int i = 2; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			if (id1[i][j] == 0) {
				dp1[i][j] = dp1[i - 1][j] + 1;
			}
			else {
				int tmp = i - id1[i][j];
				dp1[i][j] = min(tmp, dp1[i - 1][j] + 1);
			}
		}
	}

	for (int i = 1; i <= n; ++i) {
		dp2[i][1] = 1;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 2; j <= m; ++j) {
			if (id2[i][j] == 0) {
				dp2[i][j] = dp2[i][j - 1] + 1;
			}
			else {
				int tmp = j - id2[i][j];
				dp2[i][j] = min(tmp, dp2[i][j - 1] + 1);
			}	
		}
	}

	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			int k = 1;
			while (k <= min(i, j)) {
				bool ok = true;
				for (int ptr = i; ptr > i - k; --ptr) {
					if (dp2[ptr][j] < k) {
						ok = false;
						break;
					}
				}
				if (!ok) break;
				for (int ptr = j; ptr > j - k; --ptr) {
					if (dp1[i][ptr] < k) {
						ok = false;
						break;
					}
				}
				if (!ok) break;

				set<int> se;
				for (int pi = i; pi > i - k; --pi) {
					if (!ok) break;
					for (int pj = j; pj > j - k; --pj) {
						se.insert(a[pi][pj]);
						if (se.size() > k) {
							ok = false;
							break;
						}
					}
				}

				if (se.size() != k) ok = false;

				if (ok) {
					ans++;
					k *= 2;
				}
				else k++;
			}
		}
	}

	cout << ans << endl;
}