#include <iostream>
#include <vector>
#include <set>
using namespace std;

const int MAXN = 2003;
const int BASE = 9997;
const int MOD = 1000000009;

int n, m;
int a[MAXN][MAXN];

long long bpow[MAXN];
long long rh[MAXN][MAXN], ch[MAXN][MAXN];

long long rt[MAXN * 4][MAXN];
long long ct[MAXN * 4][MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char x, y;
            cin >> x >> y;
            x -= 33; y -= 33;
            a[i][j] = x * 94 + y;
        }
    }

    /*bpow[0] = 1;
    for (int i = 1; i < MAXN; ++ i)
    {
        bpow[i] = (bpow[i - 1] * BASE) % MOD;
    }*/
}
/*
void Hashing()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            rh[i][j] = (rh[i][j - 1] + a[i][j] * bpow[j]) % MOD;
        }
    }

    for (int j = 1; j <= m; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            ch[i][j] = (ch[i - 1][j] + a[i][j] * bpow[i]) % MOD;
        }
    }
}

int getHash(int rc, int i, int l, int r)
{
    if (rc == 1)
    {
        long long h = rh[i][r] - rh[i][l - 1];
        if (h < 0) h += MOD;
        h *= max(n, m) - l;
        h %= MOD;
        return h;
    }
    if (rc == 2)
    {
        long long h = ch[r][i] - ch[l - 1][i];
        if (h < 0) h += MOD;
        h *= max(n, m) - l;
        h %= MOD;
        return h;
    }
}

void build_row(int idx, int v = 1, int l = 1, int r = m)
{
    if (l == r)
    {
        tr[v][idx] = getHash(1, idx, l, l);
        return;
    }

    int mid = (l + r) / 2
    build_row(idx, v << 1 | 0, l, mid + 0);
    build_row(idx, v << 1 | 1, mid + 1, r);

    tr[v][idx] = tr[v << 1 | 0][idx] + tr[v << 1 | 1][idx] * (r - mid);
    tr[v][idx] %= MOD;
}

void build_col(int idx, int v = 1, int l = 1, int r = n)
{
    if (l == r)
    {
        tc[v][idx] = getHash(2, idx, l, l);
        return;
    }

    int mid = (l + r) / 2
    build_col(idx, v << 1 | 0, l, mid + 0);
    build_col(idx, v << 1 | 1, mid + 1, r);

    tc[v][idx] = tc[v << 1 | 0][idx] + tc[v << 1 | 1][idx] * (r - mid);
    tc[v][idx] %= MOD;
}

int query_row(int idx, int le, int ri, int v = 1, int l = 1, int r = m)
{
    if (ri < l or le > r) return 0;
    if (le <= l and r <= ri) return tr[v][idx];

    int mid = (l + r) / 2;
    long long ans = query_row
}

int query_col()
{

}*/

int main()
{
    Init();
    //Hashing();

    // cout << "init sone" << endl;

    long long cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            for (int k = 1; k <= min(n - i + 1, m - j + 1); ++ k)
            {
                bool fl = 1;

                set<int> pat;
                for (int ii = i; ii < i + k; ++ ii)
                {
                    set<int> cur;
                    for (int jj = j; jj < j + k; ++ jj)
                    {
                        if (i == ii) pat.insert(a[ii][jj]);
                        else cur.insert(a[ii][jj]);
                    }
                    if (ii != i and cur != pat)
                    {
                        fl = 0;
                        break;
                    }
                    if (ii == i and pat.size() != k)
                    {
                        fl = 0;
                        break;
                    }
                }

                if (fl) for (int jj = j; jj < j + k; ++ jj)
                {
                    set<int> cur;
                    for (int ii = i; ii < i + k; ++ ii)
                    {
                        cur.insert(a[ii][jj]);
                    }
                    if (cur != pat)
                    {
                        fl = 0;
                        break;
                    }
                }

                if (fl)
                {
                    cnt++;
                }
            }
        }
    }

    cout << cnt << endl;
    return 0;
}
