#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC target("popcnt")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
//#define TIME ((clock() - start_time) / CLOCKS_PER_SEC)

//using namespace __gnu_pbds;
using namespace std;


const int maxn = 2001;
const int inf = 1e9;

vector<pair<char, char>> co;
int idx(pair<char, char> x)
{
    return lower_bound(all(co), x) - co.begin();
}

pair<char, char> ftab[maxn][maxn];
int tab[maxn][maxn], nd[maxn][maxn], nr[maxn][maxn];

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char inx1, inx2;
            cin >> inx1 >> inx2;
            ftab[i][j] = {inx1, inx2};
            co.pb(ftab[i][j]);
        }
    }
    sort(all(co));
    co.erase(unique(all(co)), co.end());
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            tab[i][j] = idx(ftab[i][j]);
        }
    }
    for (int i = 0; i < n; ++i)
    {
        unordered_map<int, int> pos;
        for (int j = m - 1; j >= 0; --j)
        {
            int val = pos[tab[i][j]];
            if (val) nr[i][j] = val - 1;
            else nr[i][j] = inf;
            pos[tab[i][j]] = j + 1;
        }
    }
    for (int j = 0; j < m; ++j)
    {
        unordered_map<int, int> pos;
        for (int i = n - 1; i >= 0; --i)
        {
            int val = pos[tab[i][j]];
            if (val) nd[i][j] = val - 1;
            else nd[i][j] = inf;
            pos[tab[i][j]] = i + 1;
        }
    }
    int ans = 0;
    int c[sz(co)], used[sz(co)];
    memset(c, 0, sizeof(c));
    memset(used, 0, sizeof(used));
    int tim = 1;
    for (int x1 = 0; x1 < n; ++x1)
    {
        for (int y1 = 0; y1 < m; ++y1)
        {
            ++tim;
            ++ans;
            int cnt = 0;
            int vr = nr[x1][y1], vd = nd[x1][y1];
            if (used[tab[x1][y1]] != tim)
            {
                used[tab[x1][y1]] = tim;
                ++cnt;
            }
            for (int k = 1; x1 + k < n && y1 + k < m; ++k)
            {
                for (int i = x1; i < x1 + k; ++i)
                {
                    if (used[tab[i][y1 + k]] != tim)
                    {
                        used[tab[i][y1 + k]] = tim;
                        ++cnt;
                    }
                    vr = min(vr, nr[i][y1 + k]);
                    vd = min(vd, nd[i][y1 + k]);
                }
                for (int j = y1; j < y1 + k; ++j)
                {
                    if (used[tab[x1 + k][j]] != tim)
                    {
                        used[tab[x1 + k][j]] = tim;
                        ++cnt;
                    }
                    vd = min(vd, nd[x1 + k][j]);
                    vr = min(vr, nr[x1 + k][j]);
                }
                if (used[tab[x1 + k][y1 + k]] != tim)
                {
                    used[tab[x1 + k][y1 + k]] = tim;
                    ++cnt;
                }
                c[tab[x1 + k][y1 + k]]++;
                vd = min(vd, nd[x1 + k][y1 + k]);
                vr = min(vr, nr[x1 + k][y1 + k]);
                if (vr <= y1 + k) break;
                if (vd <= x1 + k) break;
                if (cnt == k + 1) ++ans;
            }
        }
    }
    cout << ans;
    return 0;
}