#include <bits/stdc++.h>

#define y1 kek

#pragma GCC optimize("Ofast")
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("-avx2")

using namespace std;
typedef long long ll;

int ans;
string a[2000][2000];
int stn;

int n, m;
int nxt[2000][2000], nxt1[2000][2000];
void solve(int l, int r, int k) {
    multiset <int> row, col;
    unordered_map <string, int> uniq;

    int diff = 0;
    for(int i = 0; i < k - 1; i++) {
        for(int j = l; j <= r; j++) {
            row.insert(nxt[i][j]);
            col.insert(nxt1[i][j]);

            if (!uniq[a[i][j]]) {
                diff++;
            }

            uniq[a[i][j]]++;
        }
    }

    for(int i = k - 1; i < n; i++) {
        for(int j = l; j <= r; j++) {
            if (!uniq[a[i][j]]) {
                diff++;
            }
            uniq[a[i][j]]++;

            row.insert(nxt[i][j]);
            col.insert(nxt1[i][j]);
        }

        auto it = row.lower_bound(r + 1);
        auto it1 = col.lower_bound(i + 1);
        int flag = (diff != k);
        if (!flag && it != row.begin() && *--it >= l) {
            flag = 1;
        }

        if (!flag && it1 != col.begin() && *--it1 >= i - k + 1) {
            flag = 1;
        }

        if (!flag) {
            ans++;
        }

        for(int j = l; j <= r; j++) {
            uniq[a[i - k + 1][j]]--;
            if (uniq[a[i - k + 1][j]] == 0) {
                diff--;
            }

            row.erase(row.find(nxt[i - k + 1][j]));
            col.erase(col.find(nxt1[i - k + 1][j]));
        }
    }
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    cin >> n >> m;

    char c, c1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> c >> c1;

            a[i][j].push_back(c);
            a[i][j].push_back(c1);
        }
    }

    n = 100, m = 100;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            int r = j + 1;
            while(r < m && a[i][j] != a[i][r]) {
                r++;
            }

            if (r == m) {
                nxt[i][j] = -1;
            }
            else {
                nxt[i][j] = r;
            }

            r = i + 1;
            while(r < n && a[i][j] != a[r][j]) {
                r++;
            }

            if (r == n) {
                nxt1[i][j] = -1;
            }
            else {
                nxt1[i][j] = r;
            }
        }
    }

    for(int j = 0; j < m; j++) {
        for(int j1 = j; j1 < m; j1++) {
            if (j1 - j + 1 <= n) {
                solve(j, j1, j1 - j + 1);
            }
        }
    }

    cout << ans << "\n";
    return 0;
}
