#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    map<pair<char, char>, int> mapi;
    int c = 1;
    vector<vector<int>> field(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 2 * m; j += 2) {
            pair<char, char> now = {s[j], s[j + 1]};
            if (mapi[now] == 0) {
                //cout << now.first << " " << now.second << " - " << c << "\n";
                mapi[now] = c;
                field[i][j / 2] = c;
                c++;
            } else {
                field[i][j / 2] = mapi[now];
            }
        }
    }

    vector<vector<int>> left(n, vector<int>(m));
    vector<vector<int>> up(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        map<int, int> mapi2;
        int last = 0;
        for (int j = 0; j < m; j++) {
            if (mapi2[field[i][j]] != 0) {
                last = max(last, mapi2[field[i][j]]);
            }
            left[i][j] = j - last + 1;
            mapi2[field[i][j]] = j + 1;
        }
    }

    for (int i = 0; i < m; i++) {
        map<int, int> mapi2;
        int last = 0;
        for (int j = 0; j < n; j++) {
            if (mapi2[field[j][i]] != 0) {
                last = max(last, mapi2[field[j][i]]);
            }
            up[j][i] = j - last + 1;
            mapi2[field[j][i]] = j + 1;
        }
    }

    ll ans = 0;
    /*

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << left[i][j] << " ";
        }
        cout << "\n";
    }
    */

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            //int gr = min(up[i][j], left[i][j]);
            int gr = min(i, j) + 1;
            for (int k = 1; k <= gr; k++) {
                bool f = true;
                for (int y = i; y > i - k; y--) {
                    int kol = 0;
                    for (int x = i; x > i - k; x--) {
                        for (int z = j; z > j - k; z--) {
                            if (field[x][z] == field[y][j]) {
                                kol++;
                            }
                        }
                    }

                    if (kol != k) {
                        f = false;
                        break;
                    }
                }

                for (int y = i; y > i - k; y--) {
                    if (left[y][j] < k) {
                            //cout << up[y][j] << "\n";
                        f = false;
                    }
                }

                for (int z = j; z > j - k; z--) {
                    if (up[i][z] < k) {
                        //cout << i << " " << j << "\n";
                        f = false;
                    }
                }

                if (f) {
                    ans++;
                }
            }
        }
    }
    cout << ans;


    return 0;
}

/*
2 2
ABBA
BAAB

*/
