#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

vector<vector<int> > bar;
vector<vector<int> > bar2;

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int> > ar(n, vector<int>());
	char c = 33;
	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j)
		{
			ar[i].push_back((s[2 * j] - ' ') * 97 + (s[2 * j + 1] - ' '));
		}
	}
	vector<vector<int> > hashh(n, vector<int>(m + 1, 0));
	bar = vector<vector<int> >(n, vector<int>(m, 1e9));
	bar2 = vector<vector<int> >(m, vector<int>(n, 1e9));
	vector<vector<int> > hashh2(m, vector<int>(n + 1, 0));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			hashh[i][j] = hashh[i][j - 1] + int((ar[i][j - 1]));
		}
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			int q = i + 1;
			while (q < n && ar[q][j] != ar[i][j])
			{
				++q;
			}
			if (q != n)
			{
				bar2[j][i] = q;
			}
		}
	}
	for (int j = 0; j < m; ++j)
	{
		for (int i = 0; i < n; ++i)
		{
			int z = j + 1;
			while (z < m && ar[i][z] != ar[i][j])
			{
				++z;
			}
			if (z != m)
				bar[i][j] = z;
		}
	}
	for (int j = 0; j < m; ++j)
	{
		for (int i = 1; i <= n; ++i)
		{
			hashh2[j][i] = hashh2[j][i - 1] + (ar[i - 1][j]);
		}
	}
	vector<vector<vector<int> > > sparsestr = vector<vector<vector<int>>>(max(n, m) + 1, vector<vector<int>>(max(n, m) + 1, vector<int>(30, 1e9)));
	vector<vector<vector<int> > > sparsest = vector<vector<vector<int>>>(max(n, m) + 1, vector<vector<int>>(max(n, m) + 1, vector<int>(30, 1e9)));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			sparsestr[i][j][0] = bar[i][j];
			sparsest[j][i][0] = bar2[j][i];
		}
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			for (int k = 1; k < 30; ++k)
			{
				sparsestr[i][j][k] = min(sparsestr[i][j][k - 1], sparsestr[i][min(m - 1, j + (1 << (k - 1)))][k - 1]);
			}
		}
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			for (int k = 1; k < 30; ++k)
			{
				sparsest[j][i][k] = min(sparsest[j][i][k - 1], sparsest[j][min(n - 1, i + (1 << (k - 1)))][k - 1]);
			}
		}
	}
	int ans = 0;
	vector<int> werty = vector<int>(5000, 0);
	int cnt = 0;
	int p = 1;
	for (int i = 0; i < 5000; ++i)
	{
		werty[i] = cnt;
		if (i > p)
		{
			p *= 2;
			cnt += 1;
		}
	}
	cout << p << endl;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			for (int k = 1; k <= min(n - i, m - j); ++k)
			{
				int normhash = hashh2[j][i + k] - hashh2[j][i];
				int per = 0;
				for (int q = i; q < i + k; ++q)
				{
					if (hashh[q][j + k] - hashh[q][j] != normhash || j + k > min(sparsestr[q][j][werty[k]], sparsestr[q][max(0, j + k - (1 << werty[k]))][werty[k]])){
						per = 1;
						break;
					}
				}
				if (per == 1)
					continue;
				for (int q = j; q < j + k; ++q)
				{
					if (hashh2[q][i + k] - hashh2[q][i] != normhash || i + k > min(sparsest[q][i][werty[k]], sparsest[q][max(0, i + k - (1 << werty[k]))][werty[k]])){
						per = 1;
						break;
					}
				}
				if (per == 0){
					ans++;
				}
			}
		}
	}
	cout << ans << endl;
}
