#include <bits/stdc++.h>

//#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;
const int Q = 503;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXC = 1e5;

vector <int> st(MAXC);

int subhash(int hl, int hr, int len)
{
    return (hr - hl + P) % P;
}


signed main()
{
    hello();

    int n, m;
    cin >> n >> m;
    vector <vector <int>> matr(n, vector <int>(m));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char c1, c2;
            cin >> c1 >> c2;
            matr[i][j] = (c1 - 32) * 100 - (c2 - 32);
        }
    }

    //show(matr);
    st[0] = 1;
    for (int i = 1; i < MAXC; ++i)
        st[i] = (ll)st[i - 1] * Q % P;

    vector <vector <int>> left(n, vector <int>(m + 1));
    vector <vector <int>> up(n + 1, vector <int>(m));

    for (int i = 0; i < n; ++i)
        for (int j = 1; j <= m; ++j)
            left[i][j] = (left[i][j - 1] + st[matr[i][j - 1]]) % P;

    for (int j = 0; j < m; ++j)
        for (int i = 1; i <= n; ++i)
            up[i][j] = (up[i - 1][j] + st[matr[i - 1][j]]) % P;

    int res = 0;

    vector <int> cnt(MAXC);
    vector <int> used(MAXC);
    map <pii, vector <pii>> lefth, uph;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            for (int len = 0; len + j < m; ++len)
            {
                if (used[matr[i][j + len]] != (i * m) + j)
                {
                    cnt[matr[i][j + len]] = 0;
                    used[matr[i][j + len]] = i * m + j;
                }
                ++cnt[matr[i][j + len]];
                if (cnt[matr[i][j + len]] == 2)
                    break;
                int ch = subhash(left[i][j], left[i][j + len + 1], len + 1);
                lefth[{ch, len}].push_back({j, i});
            }
        }

    fill(used.B(), used.E(), 0);
    fill(cnt.B(), cnt.E(), 0);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
        {
            for (int len = 0; len + i < n; ++len)
            {
                if (used[matr[i + len][j]] != (i * m) + j)
                {
                    cnt[matr[i + len][j]] = 0;
                    used[matr[i + len][j]] = i * m + j;
                }
                ++cnt[matr[i + len][j]];
                if (cnt[matr[i + len][j]] == 2)
                    break;
                int ch = subhash(up[i][j], up[i + len + 1][j], len + 1);
                //cout << i << " " << j << " " << len << " " << ch << endl;
                uph[{ch, len}].push_back({i, j});
            }
        }

    fill(used.B(), used.E(), 0);
    fill(cnt.B(), cnt.E(), 0);

    for (auto& val : lefth)
        sort(val.S.B(), val.S.E());
    for (auto& val : uph)
        sort(val.S.B(), val.S.E());

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            for (int len = 0; len + j < m && len + i < n; ++len)
            {
                if (used[matr[i][j + len]] != (i * m) + j)
                {
                    cnt[matr[i][j + len]] = 0;
                    used[matr[i][j + len]] = i * m + j;
                }
                ++cnt[matr[i][j + len]];
                if (cnt[matr[i][j + len]] == 2)
                    break;
                int ch = subhash(left[i][j], left[i][j + len + 1], len + 1);
                int v1 = upper_bound(lefth[{ch, len}].B(), lefth[{ch, len}].E(), (pii){j, i + len}) - lower_bound(lefth[{ch, len}].B(), lefth[{ch, len}].E(), (pii){j, i});
                int v2 = upper_bound(uph[{ch, len}].B(), uph[{ch, len}].E(), (pii){i, j + len}) - lower_bound(uph[{ch, len}].B(), uph[{ch, len}].E(), (pii){i, j});
                //cout << v1 << " " << v2 << " " << i << " " << j << " " << len << endl;

                if (v1 >= len + 1 && v2 >= len + 1)
                {
                    ++res;
                    //cout << i << " " << j << " " << len << endl;
                }
            }

    cout << res << endl;

}
