#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, m;
vector<vector<int>> a;

vector<int> v(94*100, 0);
int cnt = 0;

inline void add(int x) {
	v[x]++;
	if ( v[x] == 1 ) cnt++;
}

inline void del(int x) {
	v[x]--;
	if ( v[x] == 0 ) cnt--;
}

inline void init() {
	for ( int i = 0; i < 94*100; ++i ) v[i] = 0;
	cnt = 0;
}

int main() {
	cin >> n >> m;
	a = vector<vector<int>>(n, vector<int>(m, 0));
	char c, c1;
	int x, y;
	for ( int i = 0; i < n; ++i ) for ( int j = 0; j < m; ++j ) {
		cin >> c >> c1;
		c -= 33;
		c1 -= 33;
		x = c; y = c1;
		a[i][j] = 94 * x + y;
	}
	ll ans = 0;
	for ( int k = 1; k <= min(n, m); ++k ) {
		vector<vector<bool>> down(n - k + 1, vector<bool>(m, 0));
		vector<vector<bool>> right(n, vector<bool>(m - k + 1, 0));

		init();
		for ( int j = 0; j < m; ++j ) {
			init();
			for ( int i = 0; i < k; ++i ) add(a[i][j]);
			down[0][j] = cnt == k;
			for ( int i = k; i < n; ++i ) {
				add(a[i][j]); del(a[i-k][j]);
				down[i-k+1][j] = cnt == k;
			}
		}
		init();
		for ( int i = 0; i < n; ++i ) {
			init();
			for ( int j = 0; j < k; ++j ) add(a[i][j]);
			right[i][0] = cnt == k;
			for ( int j = k; j < m; ++j ) {
				add(a[i][j]); del(a[i][j-k]);
				right[i][j-k+1] = cnt == k;
			}
		}
		init();
		for ( int i = 0; i < n - k + 1; ++i ) {
			init();
			for ( int i1 = i; i1 < i + k; ++i1 ) {
				for ( int j1 = 0; j1 < k; ++j1 ) {
					add(a[i1][j1]);
				}
			}

			for ( int j = 0; j < m - k + 1; ++j ) {
				bool flag = true;
				for ( int i1 = i; i1 < i + k; ++i1 ) flag = flag && ( right[i1][j] );
				for ( int j1 = j; j1 < j + k; ++j1 ) flag = flag && ( down[i][j1] );
				if ( j != 0 ) {
					for ( int i1 = i; i1 < i + k; ++i1 ) del(a[i1][j-1]);
					for ( int i1 = i; i1 < i + k; ++i1 ) add(a[i1][j+k-1]);
				}
				flag = flag && (cnt == k);

				if ( flag ) { ans++;}
			}
		}
	}

	cout << ans << endl;
	return 0;
}