#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void push(unordered_set<int> &us, ll &ans, int x, vector<int> &c) {
    ans += c[x - 1];
    while (us.count(x)) {
        us.erase(x);
        x++;
        ans += c[x - 1];
    }
    us.insert(x);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> l(n);
    for (int &i : l) {
        cin >> i;
    }
    vector<int> s(n);
    for (int &i : s) {
        cin >> i;
    }
    vector<int> c(n + m);
    for (int &i : c) {
        cin >> i;
    }
    if (n <= 15 && m <= 15) {
        ll ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            int last = 1e4;
            bool f = true;
            ll res = 0;
            unordered_set<int> us;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    res -= s[i];
                    if (l[i] > last) {
                        f = false;
                        break;
                    }
                    last = l[i];
                    push(us, res, l[i], c);
                }
            }
            if (!f) {
                continue;
            }
            ans = max(ans, res);
        }
        cout << ans << endl;
    } else {
        vector<vector<ll>> dp(n + 1, vector<ll>(m + n + 1, -1e18));
        for (int i = 0; i < n; ++i) {
            ll sum = 0;
            dp[i + 1][l[i]] = c[l[i]] - s[i];
            for (int j = l[i]; j < n + m; ++j) {
                sum += c[j];
                for (int y = 0; y <= i; ++y) {
                    dp[i + 1][j] = max(dp[i + 1][j], sum + dp[y][j + 1] + s[i]);
                }
            }
        }
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, dp[i][l[i]]);
        }
        
        cout << ans << endl;
    }

}