#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 4e5 + 228;
const int B = 25;
int n, a[mx], suf[mx], rev_suf[mx];

int solve(int bit) {
	int res = 0;
	for (int i = 0; i < n; ++i) {
		suf[i] = (a[i] & ((1 << (bit + 1)) - 1));
	}
	sort(suf, suf + n);
	copy(suf, suf + n, rev_suf);
	reverse(rev_suf, rev_suf + n);
	// cerr << "suf" << endl;
	// output(suf, suf + n);
	int L1 = (1 << bit), L2 = 2 * (1 << bit), L3 = 3 * (1 << bit);
	vector<int> L = {L1, L2, L3};
	vector<int> ptr(3);
	ll all = 0;
	for (int i = 0; i < n; ++i) {
		for (int it = 0; it < 3; ++it) {
			while (ptr[it] < n && suf[i] + rev_suf[ptr[it]] >= L[it]) {
				ptr[it]++;
			}
		}
		int cnt = ptr[0] - ptr[1] + ptr[2];
		// cerr << "cnt = " << cnt << endl;
		all += cnt;
		if (suf[i] + suf[i] >= L1 && suf[i] + suf[i] < L2) {
			all--;
		}
		if (suf[i] + suf[i] >= L3) {
			all--;
		}
	}
	all /= 2;
	return (all % 2);
}

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	int ans = 0;
	for (int i = 0; i < B; ++i) {
		ans ^= (solve(i) << i);
	}
	cout << ans << endl;
}
