#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

//#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;
	
mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

const int L = 101;

int cnt[L];

void solve() {
	fill(cnt, cnt + L, 0);
	int n; cin >> n;
	vector<int> a(n);
	bool fl = true;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] >= L) fl = false;
		if (fl) {
			cnt[a[i]]++;
		}
	}
	if (n <= 1e3) {
		int ans = 0;
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				ans = ans ^ (a[i] + a[j]);
			}
		}
		cout << ans << endl;
	} else {
		int ans = 0;
		for (int i = 0; i < L; i++) {
			if (!cnt[i]) continue;
			if ((cnt[i] * 1ll & (cnt[i] - 1) / 2) & 1) ans = ans ^ (2 * i);
			for (int j = i + 1; j < L; j++) {
				if (!cnt[j]) continue;
				if ((cnt[i] * 1ll * cnt[j]) & 1) ans = ans ^ (i + j);
			}
		}
		cout << ans << endl;
	}
}