#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

int n;

void solve1() {
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    int S = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            S ^= (a[i] + a[j]);
        }
    }
    cout << S;
}

void solve2() {
    vector<ll> a(101);
    for (int i = 0; i < n; ++i) {
        int num;
        cin >> num;
        a[num]++;
    }
    vector<ll> sums(201);
    for (int i = 0; i < 101; ++i) {
        for (int j = i + 1; j < 101; ++j) {
            sums[i + j] = a[i] * a[j];
        }
    }
    ll S = 0;
    for (int i = 0; i < 201; ++i) {
        if (sums[i] & 1) {
            S ^= i;
        }
    }
    cout << S;
}

void solve() {
    cin >> n;
    if (n <= 1000) {
        solve1();
    } else {
        solve2();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}