#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

void _tmain([[maybe_unused]] int test_id) {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) {cin >> x;}
    int ans = 0;
    for (int h = 0; h < 28; ++h) {
        vector<int> b_with, b_without;
        ll k = 0;
        for (int i = 0; i < n; ++i) {
            bool has_cur = (a[i] & (1 << h));
            int low = (a[i] & ((1 << h) - 1));
            int lim =  (1 << h);
            if (has_cur) {
                for (int x : b_with) {
                    if (low + x >= lim) {
                        ++k;
                    }
                }
                for (int x : b_without) {
                    if (low + x < lim) {
                        ++k;
                    }
                }
            } else {
                for (int x : b_with) {
                    if (low +x < lim) {
                        ++k;
                    }
                }
                for (int x : b_without){
                    if (low +x >= lim) {
                        ++k;
                    }
                }
            }

            if (has_cur) {
                b_with.push_back(low);
            } else {
                b_without.push_back(low);
            }
        }
        ans += int(k%2ll) * (1 << h);
    }
    cout << ans << "\n";
}
