#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	if (n <= 0)
	{
		vector<int> arr(n);
		for (int i = 0; i < n; ++i)
			cin >> arr[i];

		int ans = 0;
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
				ans ^= (arr[i] + arr[j]);

		cout << ans << endl;
	}
	else
	{
		vector<int> cnt(101);
		int x = 0;
		for (int i = 0; i < n; ++i)
		{
			cin >> x;
			++cnt[x];
		}

		int ans = 0;
		for (int i = 0; i <= 100; ++i)
			for (int j = i + 1; j <= 100; ++j)
				if ((cnt[i] & 1) && (cnt[j] & 1))
					ans ^= (i + j);

		for (int i = 0; i <= 100; ++i)
			if ((cnt[i] & 3) && ((cnt[i] - 1) & 3))
				ans ^= (i + i);

		cout << ans << endl;
	}

	

	return 0;
}