#include <iostream>
#include<vector>
#include<algorithm>
#include<set>
using namespace std;
struct Node {
	Node* left;
	Node* right;
	int cnt;
	int priority;
	int a;
	int sum;
	Node(int a) :
		left(0),
		right(0),
		cnt(1),
		priority(rand()),
		a(a),
		sum(1){}
};
void update(Node* v)
{
	v->sum = v->cnt;
	if(!v ->left)
	{ 
	}
	else
	{
		v->sum += v->left->sum;
	}
	if (!v->right)
	{

	}
	else
	{
		v->sum += v->right->sum;
	}
}
void split(Node* root, Node* &l, Node* &r, int a)
{
	if (!root)
	{
		l = r = NULL;
		return;
	}
	if (root->a < a)
	{
		split(root->right, root->right, r, a);
		l = root;
		update(l);
	}
	else
	{
		split(root->left, l, root->left, a);
		r = root;
		update(r);
	}
}
void merge(Node* l, Node* r, Node*&v)
{
	if (!l)
	{
		v = r;
		return;
	}
	else
	{
		v = l;
		return;
	}
	if (l->priority > r->priority)
	{
		merge(l->right, r, l->right);
		v = l;
		update(v);
	}
	else
	{
		merge(l, r->left, r->left);
		v = r;
		update(v);
	}
}
bool find(Node* root, int a)
{
	if (!root)
	{
		return false;
	}
	bool flag;
	if (root->a == a)
	{
		root->cnt++;
		root->sum++;
		return true;
	}
	if (root->a > a)
	{
		flag =  find(root->right, a);
	}
	else
	{
		flag = find(root->left, a);
	}
	update(root);
	return flag;
}
void add(Node*&root, int a)
{
	if (find(root, a))
	{
		return;
	}
	Node* L;
	Node* R;
	split(root, L, R, a);
	Node*v = new Node(a);
	merge(L, v, L);
	merge(L, R, root);
}
int anstree(Node* root, int a)
{
	if (!root)
	{
		return 0;
	}
	int cnt = 1;
	if(!root ->right)
	{

	}
	else
	{
		cnt += root->right->sum;
	}
	if (root->a < a)
	{
		return anstree(Node->right, a);
	}
	else
	{
		return cnt + anstree(Node->left, a);
	}
}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector <int> A(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
	}
	int ans = 0;
	vector <int> cnt(21);
	vector <Node*> root(21);
	for (int i = 0; i < n; i++)
	{
		for (int j = 1; j <= 20; j++)
		{
			int k = pow(2, j);
			int ost = A[i] % j;
			int cnt = anstree(root[j], k / 2 - ost);
			if (cnt % 2 == 1)
			{
				ans = (ans ^ (k / 2));
			}
		}
		for (int j = 1; j <= 20; j++)
		{
			int k = pow(2, j);
			int ost = A[i] % j;
			if (!root[j])
			{
				root[j] = new Node(ost);
			}
			else
			{
				add(root[j], ost);
			}
		}
	}
	cout << ans;
	//system("pause");
	return 0;
}