#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int LOGN = 25;
const int MAXN = 4e5 + 100;
int a[MAXN], b[MAXN];

signed main() {
	FAST_IO();
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		b[i] = a[i];
	}
	int res = 0;
	for (int bit = LOGN - 1; bit >= 0; --bit) {
		vector<int> v0, v1;
		for (int i = 0; i < n; ++i) {
			if (a[i] & (1 << bit)) {
				b[i] ^= (1 << bit);
				v1.push_back(b[i]);
			}
			else {
				v0.push_back(b[i]);
			}
		}
		sort(all(v0));
		sort(all(v1));
		ll sum = 0;
		for (int i = 0; i < n; ++i) {
			int cnt = 0;
			if (a[i] & (1 << bit)) {
				int x = (1 << bit) - b[i];
				cnt += lower_bound(all(v0), x) - v0.begin();
				cnt += v1.size() - (lower_bound(all(v1), x) - v1.begin());
				if (b[i] >= x) {
					cnt--;
				}
			}
			else {
				int x = (1 << bit) - b[i];
				cnt += lower_bound(all(v1), x) - v1.begin();
				cnt += v0.size() - (lower_bound(all(v0), x) - v0.begin());
				if (b[i] >= x) {
					cnt--;
				}
			}
			sum += cnt;
		}
		sum /= 2;
		sum %= 2;
		if (sum) {
			res ^= (1 << bit);
		}
	}
	cout << res << '\n';
}