#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

#pragma GCC optimize ("Ofast")

#define ll long long

using namespace std;

int XOR (int a, int b) {
    return (a | b) - (a & b);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n, 0);
    for (int i = 0; i < n; i ++) {
        cin >> a[i];
    }
    int res = 0;
    for (int i = 0; i < n; i ++) {
        for (int j = i + 1; j < n; j ++) {
            res = XOR(res, a[i] + a[j]);
        }
    }
    cout << res;
    return 0;
}