//#define _GLIBcxx_DEBUG

#pragma GCC optimaze("unroll-loops")
//#pragma GCC optimaze("fast-math")
//#pragma GCC optimaze("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
#define vin(v, n) for(int i = 0; i < (n); ++i) {cin >> v[i];}
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;

signed main() {
	fastio();
	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (n <= 2000) {
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				ans = ans ^ (a[i] + a[j]);
			}
		}
		cout << ans << endl;
	}
	else {
		int maxa = 100;
		vector<int> cnt(maxa + 1, 0);
		for (int i = 0; i < n; ++i) {
			++cnt[a[i]];
		}
		vector<int> sum(2 * maxa + 1, 0);
		for (int i = 1; i <= maxa; ++i) {
			for (int j = i + 1; j <= maxa; ++j) {
				sum[i + j] += cnt[i] * cnt[j];
			}
		}
		for (int i = 2; i <= 2 * maxa; ++i) {
			sum[i] = sum[i] % 2;
		}
		int ans = 0;
		for (int i = 2; i <= 2 * maxa; ++i) {
			ans ^= sum[i] * i;
		}
		cout << ans << endl;
	}
}