#include <iostream>
#include <vector>
#include <bitset>


#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl "\n"
#endif

#define _ <<" "<<

using namespace std;
typedef long long ll;
const int N = 2e7+100;

int n;
vector<int> vs;

void solve1(){
    int ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < i; j++){
            ans ^= (vs[i]+vs[j]);
        }
    }
    cout << ans << endl;
}
void solve2(){
    int ct[305] = {0};
    int ansct[305] = {0};
    for(int i = 0; i < n; i++){
        int v = vs[i];
        for(int i = 0; i < 301-v; i++){
            ansct[i+v] += ct[i];
        }
        ct[v]++;
    }
    int ans = 0;
    for(int i = 0; i < 300; i++){
        if(ansct[i]%2) ans ^= i;
    }
    cout << ans << endl;
}

int32_t main()
{
    cin >> n; vs.resize(n);
    for(int& i: vs) cin >> i;
    if(n <= 1005) solve1();
    else solve2();
    return 0;
}
