#include <iostream>
#include <cstring>

using namespace std;

const int K = 24, N = (1 << (K + 1)) + 7, NN = 4e5 + 7;
int f[N], a[NN];

void upd(int pos) {
    pos++;
    for (int i = pos; i < N; i += i & (-i)) f[i]++;
}

int get_pref(int pos) {
    //cout << pos << endl;
    pos++;
    int res = 0;
    for (int i = pos; i > 0; i -= i & (-i)) res += f[i];
    return res;
}

int get(int l, int r) {
    if (l > r) return 0;
    return get_pref(r) - get_pref(l - 1);
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    int res = 0;
    int mask = 0;
    for (int i = 0; i <= K; i++) {
        int mem = mask;
        mask |= (1 << i);
        int cnt = 0;
        memset(f, 0, sizeof(f));
        for (int j = n - 1; j >= 0; j--) {
            if (a[j] & (1 << i)) cnt += (n - 1 - j) - get(((~a[j]) & mem) + 1, ((~a[j]) & mask) + (1 << i));
            else cnt += get(((~a[j]) & mem) + 1, (~a[j]) & mask); 
            upd(a[j] & mask);
        }
        //cout << "!! " << cnt << endl;
        if (cnt % 2) res |= (1 << i);
    }
    cout << res << endl;
    return 0;
}
