#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int dumbSolve(int n, vector<int> a)
{
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++) ans ^= (a[i] + a[j]);
    }
    return ans;
}


int kekSolve(int n, vector<int> a)
{
    const int maxa = 300;
    int cnt[maxa];
    int dp[maxa];
    for (int i = 0; i < maxa; i++)
    {
        cnt[i] = 0;
        dp[i] = 0;
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j + a[i] < maxa; j++)
        {
            dp[j + a[i]] += cnt[j];
        }
        cnt[a[i]]++;
    }
    int ans = 0;
    for (int i = 0; i < maxa; i++)
    {
        if (dp[i] % 2 == 0) continue;
        ans ^= i;
    }
    return ans;
}


signed main()
{
    warp();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (n <= 1000) {cout << dumbSolve(n, a) << endl; return 0;}
    cout << kekSolve(n, a) << endl;
    return 0;
}
