#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 4e5 + 7;
//const int LOG = 29;
const int LOG = 3;

int n;
int a[N];
vector<int> s[LOG];
int cnt[LOG];

int gett01(int ind, int cur, int mn, int mx) {
	int res = 0;
	if ((cur + cur) <= mx && cur + cur >= mn) {
		res--;
	}
	int lind = lower_bound(all(s[ind]), mn - cur) - s[ind].begin();
	int rind = upper_bound(all(s[ind]), mx - cur) - s[ind].begin() - 1;
	res += (rind - lind + 1);
	return res;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		for (int j = 0; j < LOG; j++) {
			s[j].pb(a[i] & ((1 << (j + 1)) - 1));
		}
	}
	for (int i = 0; i < LOG; i++) {
		sort(all(s[i]));
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < LOG; j++) {
			int b = a[i] & ((1 << (j + 1)) - 1);
			cnt[j] += gett01(j, b, (1 << j), ((1 << (j + 1)) - 1));
			cnt[j] += gett01(j, b, (1 << j) + (1 << (j + 1)), ((1 << (j + 2)) - 1));
		}
	}
	int ans = 0;
	for (int i = 0; i < LOG; i++) {
		cnt[i] /= 2;
		if (cnt[i] % 2 == 1) {
			ans += (1 << i);
		}
	}
	cout << ans;
}