﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int lg = 25;
const int maxw = (1 << (lg + 1));

int all[maxw + 1];

int main()
{
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	int ans = 0;
	for (int bit = 0; bit < lg; bit++) {
		for (int i = 0; i < n; i++) {
			b[i] = a[i] & ((1 << (bit + 1)) - 1);
		}
		memset(all, 0, sizeof all);
		for (int i = 0; i < n; i++) {
			all[b[i] + 1]++;
		}
		for (int i = 0; i < maxw; i++) {
			all[i + 1] += all[i];
		}
		ll cnt = 0;
		int ll1 = (1 << bit), rr1 = (1 << (bit + 1));
		int ll2 = (1 << (bit + 1)) + (1 << bit), rr2 = (1 << (bit + 2));
		for (int i = 0; i < n; i++) {
			int x = b[i];
			int l1 = ll1 - x, r1 = rr1 - x;
			int l2 = ll2 - x, r2 = rr2 - x;
			l1 = max(l1, 0), r1 = min(r1, maxw);
			l2 = max(l2, 0), r2 = min(r2, maxw);
			cnt += all[r1] - all[l1];
			cnt += all[r2] - all[l2];
			if (x >= l1 && x < r1 || x >= l2 && x < r2) cnt--;
		}
		//cout << cnt << endl;
		cnt /= 2;
		if (cnt % 2 == 1) ans |= (1 << bit);
	}
	cout << ans << endl;
}
