#include <iostream>
#include<vector>
#include<algorithm>
#include<set>
using namespace std;
struct Node {
	Node* left;
	Node* right;
	int cnt;
	int priority;
	int a;
	int sum;
	Node(int a) :
		left(0),
		right(0),
		cnt(1),
		priority(rand()),
		a(a),
		sum(1){}
};
void update(Node* v)
{
	v->sum = v->cnt;
	if(!v ->left)
	{ 
	}
	else
	{
		v->sum += v->left->sum;
	}
	if (!v->right)
	{

	}
	else
	{
		v->sum += v->right->sum;
	}
}
void split(Node* root, Node* &l, Node* &r, int a)
{
	if (!root)
	{
		l = r = NULL;
		return;
	}
	if (root->a < a)
	{
		split(root->right, root->right, r, a);
		l = root;
		update(l);
	}
	else
	{
		split(root->left, l, root->left, a);
		r = root;
		update(r);
	}
}
void merge(Node* l, Node* r, Node*&v)
{
	if (!l)
	{
		v = r;
		return;
	}
	else
	{
		v = l;
		return;
	}
	if (l->priority > r->priority)
	{
		merge(l->right, r, l->right);
		v = l;
		update(v);
	}
	else
	{
		merge(l, r->left, r->left);
		v = r;
		update(v);
	}
}
bool find(Node* root, int a)
{
	if (!root)
	{
		return false;
	}
	bool flag;
	if (root->a == a)
	{
		root->cnt++;
		root->sum++;
		return true;
	}
	if (root->a > a)
	{
		flag =  find(root->right, a);
	}
	else
	{
		flag = find(root->left, a);
	}
	update(root);
	return flag;
}
void add(Node*&root, int a)
{
	if (find(root, a))
	{
		return;
	}
	Node* L;
	Node* R;
	split(root, L, R, a);
	Node*v = new Node(a);
	merge(L, v, L);
	merge(L, R, root);
}
int anstree(Node* root, int a)
{
	if (!root)
	{
		return 0;
	}
	int cnt = 1;
	if(!root ->right)
	{

	}
	else
	{
		cnt += root->right->sum;
	}
	if (root->a < a)
	{
		return anstree(root->right, a);
	}
	else
	{
		return cnt + anstree(root->left, a);
	}
}
int anstree(Node* root, int l, int r)
{
	Node* L;
	Node* R;
	Node* L1;
	Node* R1;
	split(root, L, R, r + 1);
	split(L, L1, R1, l);
	if (!R1)
	{
		return 0;
	}
	else
	{
		return R1->sum;
	}
}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector <int> A(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
	}
	int ans = 0;
	vector <int> cnt(21);
	vector <pair <Node*, Node*> > root(21);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= 20; j++)
		{
			int k = pow(2, j + 1);
			int cnt = 0;
			if (A[i] % k >= k / 2)
			{
				cnt = anstree(root[j]->first, 0, k / 2 - (A[i] % k - k / 2) - 1) + anstree(root[j]->second, k / 2 - (A[i] % k - k / 2), k);
			}
			else
			{
				cnt = anstree(root[j]->second, 0, k / 2 - (A[i] % k - k / 2) - 1) + anstree(root[j]->first, k / 2 - (A[i] % k - k / 2), k);
			}
			if (cnt % 2 == 1)
			{
				ans = (ans ^ (1 << j));
			}
		}
		for (int j = 0; j <= 20; j++)
		{
			int k = pow(2, j + 1);
			if (A[i] % k >= k / 2)
			{
				add(root[j], A[i] % k - k / 2);
			}
			else
			{
				add(root[j], A[i] % k);
			}
		}
	}
	cout << ans;
	//system("pause");
	return 0;
}