#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "\n";

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

ll mal(vector<ll> A)
{
    ll n = A.size();
    ll maxs = A[n - 1] + A[n - 2];
    vector<ll> cnt(maxs + 1, 0);
    for (int i = 0; i < n; i++)
    {
        cnt[A[i]]++;
    }
    ll ans = 0;
    for (ll s = 1; s <= maxs; s++)
    {
        for (ll sl = 1; sl * 2 <= s; sl++)
        {
            if (sl * 2 != s)
            {
                ll k1 = cnt[sl];
                ll k2 = cnt[s - sl];
                if ((k1 * k2) % 2 != 0)
                    ans ^= s;
            }
            else
            {
                ll k = cnt[sl];
                if ((k * (k - 1) / 2) % 2 != 0)
                    ans ^= s;
            }
        }
    }
    return ans;
}

ll slow(vector<ll> A)
{
    ll ans = 0;
    ll n = A.size();
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            ans ^= (A[i] + A[j]);
        }
    }
    return ans;
}

int main()
{
    fast();
    ll n;
    cin >> n;
    vector<ll> A(n);
    ll mx = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
        mx = max(mx, A[i]);
    }
    sort(A.begin(), A.end());
    if (mx <= 100)
    {
       cout << mal(A);
       return 0;
    }
    cout << slow(A);
}
