#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


const int B = 25;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int answ = 0;
    for (int b = 0; b < B; ++b) {
        int bit = (1 << b);
        int dbit = (1 << (b + 1));

        vector<int> rems(n);
        for (int i = 0; i < n; ++i) {
            rems[i] = a[i] % dbit;
        }

        vector<int> rcnt(dbit);
        for (int i = 0; i < n; ++i) {
            ++rcnt[rems[i]];
        }

        vector<int> psum(dbit + 1);
        for (int i = 0; i < dbit; ++i) {
            psum[i + 1] = psum[i] + rcnt[i];
        }

        int tprt = 0;
        for (int i = 0; i < dbit; ++i) {
            if (rcnt[i] % 2 == 0) {
                continue;
            }

            int low = bit - i;
            if (low < 0) {
                low += dbit;
            }

            int high = dbit - i;

            int prt;
            if (low < high) {
                prt = psum[high] - psum[low];

                if (i >= low) {
                    prt -= psum[i + 1] - psum[low];
                }

                if (i >= high) {
                    prt = 0;
                }
            } else {
                prt = psum[dbit] - psum[low] + psum[high];

                if (i < high) {
                    prt -= psum[i + 1];
                } else {
                    prt -= psum[high];
                }

                if (i >= low) {
                    prt -= psum[i + 1] - psum[low];
                }
            }

            tprt ^= prt % 2;
        }

        for (int i = 0; i < dbit; ++i) {
            int cs = i + i;
            if (cs >= dbit) {
                cs -= dbit;
            }

            if (cs < bit) {
                continue;
            }

            long long c = rcnt[i];
            tprt ^= c * (c - 1) / 2 % 2;
        }

        if (tprt) {
            answ ^= bit;
        }
    }

    cout << answ;

    return 0;
}
