#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

#ifdef _DEBUG
const int M = 10010;
#else
const int M = 10000010;
#endif

const int INF = (int)1e9 + 10;

int pref[M];
int a[N];

int ans = 0;

int mx = -1;

int sum(int l, int r) {
	l = max(l, 0);
	r = min(r, mx * 2 - 1);
	if (l > r)
		return 0;
	return pref[r + 1] - pref[l];
}

#ifdef _DEBUG
const int bits = 5;
#else
const int bits = 24;
#endif

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
	}
	for (int j = bits; j >= 0; --j) {
		mx = 1 << j;
		for (int i = 1; i <= n; ++i) {
			pref[a[i] + 1]++;
		}
		for (int i = 1; i <= mx * 2; ++i) {
			pref[i] += pref[i - 1];
		}
		for (int i = 0; i < mx; ++i) {
			int cnt = pref[i + 1] - pref[i];
			if (i * 2 >= mx && i * 2 < mx * 2) {
				if (((ll)cnt * (cnt - 1ll) / 2ll) & 1ll)
					ans ^= mx;
			}
			if (sum(max(i + 1, mx - i), mx * 2 - i - 1) & 1) {
				ans ^= ((pref[i + 1] - pref[i]) & 1) * mx;
			}
		}
		for (int i = 1; i <= n; ++i) {
			a[i] &= mx - 1;
		}
		for (int i = 1; i <= mx; ++i) {
			pref[i] = 0;
		}
	}
	cout << ans;
}