/*
 *   cCreated by Kazalika   for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
const int N = 5e5 + 5, LOG = 22;
const ll INF = 1e15;
const ldb EPS = 1e-8;

int n;

void slow() {
    int res = 0;
    vint v(n);
    forn(0, i, n) {
        cin >> v[i];
        forn(0, j, i)
            res ^= v[i] + v[j];
    }
    cout << res;
    exit(0);
}

void faster() {
    vint v(n);
    vector <int> cnt(202);
    forn(0, i, n) {
        cin >> v[i];
        cnt[v[i]]++;
    }
    sort(all(v));
    vector <int> res(202);
    for (int i = 0; i < n; ++i) {
        cnt[v[i]]--;
        vector <int> newcnt(202);
        for (int j = 0; j < 202; ++j)
            if (cnt[j])
                newcnt[j + v[i]]++;
        for (int j = 0; j < 202; ++j)
            res[j] += newcnt[j];
    }
    int out = 0;
    for (int i = 0; i < 202; ++i)
        if (res[i] & 1) out ^= i;
    cout << out;
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n;
    if (n <= 1000) slow();
    faster();

}