#include <iostream>

using namespace std;

const int MAX_N = (int) 4e5 + 10;
const int MAX_A = 200;
const int MAX_S = 2 * MAX_A;

int cnt[MAX_A];

int a[MAX_N];

int n;

void solveSlow() {
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ans ^= a[i] + a[j];
        }
    }
    cout << ans << "\n";
}

void solve2() {
    for (int i = 0; i < n; i++) {
        cnt[a[i]]++;
    }
    int sumCnt[MAX_S];
    fill(sumCnt, sumCnt + MAX_S, 0);
    for (int sum = 0; sum < MAX_S; sum++) {
        for (int i = 0; i < n; i++) {
            int need = sum - a[i];
            cnt[a[i]]--;
            if (need > 0 && need < MAX_A) {
                sumCnt[sum] += cnt[need];
            }
            cnt[a[i]]++;
        }
    }
    int ans = 0;
    for (int s = 0; s < MAX_S; s++) {
        sumCnt[s] /= 2;
        if (sumCnt[s] % 2 == 1) {
            ans ^= s;
        }
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("F.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    bool g2 = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 100) {
            g2 = false;
        }
    }
    if (g2) {
        solve2();
        return 0;
    } else {
        solveSlow();
    }


    return 0;
}