#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <deque>


using namespace std;

#define all(c) c.begin(), c.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;


template<typename T>
istream &operator>>(istream &is, vector<T> &vector_input) {
    for (int i = 0; i < vector_input.size(); ++i)
        is >> vector_input[i];
    return is;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vi a(n);
    cin >> a;
    int ans = 0;
    if (n <= 1000) {
        for (int i = 0; i < n; ++i)
            for (int j = i + 1; j < n; ++j)
                ans ^= (a[i] + a[j]);
    } else {
        map<int, ll> m;
        for (int i:a)
            ++m[i];
        for (int i = 1; i <= 100; ++i)
            for (int j = i; j <= 100; ++j) {
                if (i != j) {
                    ll k1 = m[i], k2 = m[j];
                    if ((k1 * k2) % 2 != 0)
                        ans ^= (i + j);
                } else {
                    ll k1 = m[i];
                    if ((k1 * (k1 - 1) / 2) % 2 != 0)
                        ans ^= (i + j);
                }
            }
    }
    cout << ans;
}