#include <iostream>
#include <vector>

using namespace std;

void solve (vector <int> line) {
    int ans = 0;
    for (int i = 0; i < (int) line.size(); i++)
        for (int j = 0; j < i; j++)
            ans ^= line[i] + line[j];

    cout << ans << endl;
}


int main() {
    int n;
    cin >> n;

    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (n <= 1000) {
        solve(line);
        return 0;
    }

    vector <int> cnt(101);
    for (int i : line) {
        cnt[i]++;
    }

    for (int i = 0; i < 101; i++) {
        cnt[i] %= 4;
    }

    vector <int> new_line;
    for (int i = 0; i < 101; i++)
        while (cnt[i]) {
            new_line.push_back(i);
            cnt[i]--;
        }
    solve(new_line);
    return 0;
}
