#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T> 
bool uin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 24;
const LL LINF = 1e18;
const int N = (int)4e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

int n, a[N];
int sz, so;
pair <int, int> zero[N], one[N];

bool bit(int x, int pos) {
	return (x & (1 << pos)) > 0;
}

int same(int n, int b, pair <int, int> *arr) {
	int ind = 0, res = 0;
	for (int i = n - 1; i > ind; i--) {
		while (i > ind && !bit(arr[i].first + arr[ind].first, b))
			ind++;
		res ^= bit(i - ind, 0);
	}
	return res;
}

int diff(int b) {
	int ind = sz - 1, res = 0;
	for (int i = 0; i < so && ind >= 0; i++) {
		while (ind >= 0 && bit(one[i].first + zero[ind].first, b + 1))
			ind--;
		res ^= bit(ind + 1, 0);
	}
	return res;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n;
	for (int i = 0; i < n; i++) 
		cin >> a[i];
	int ans = 0;
	for (int i = 0; i < LOG; i++) {
		int mask = (1 << (i + 1)) - 1;
		sz = 0, so = 0;
		for (int j = 0; j < n; j++) {
			int val = a[j] & mask;
			if (val < (1 << i))
				zero[sz++] = mp(val, j);
			else
				one[so++] = mp(val, j);
		}
		sort(zero, zero + sz);
		sort(one, one + so);
		int b = diff(i);
		b ^= same(sz, i, zero);
		b ^= same(so, i, one);
		ans |= (b << i);
	}
	cout << ans;
}