#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, M = 25, INF = 1e9;

int64_t n, a[N], cnt1[M], cnt0[M], ans;
vector<int64_t> nts;
mt19937 rnd(time(0));



inline void read(){
    cin >> n;
    for(int i = 1; i <= n; ++i){
        cin >> a[i];
    }
}

int64_t C2n(const int64_t& n){
    return n*(n-1)/2;
}

inline void nullnull(int step){
    int64_t mask = (1LL<<step)-1, dva = 1LL<<step;
    nts.clear();
    for(int i = 1; i <= n; ++i){
        if(~(a[i]>>step)&1) nts.pb(a[i]&mask);
    }
    sort(ALL(nts));
    for(int i = 0; i < nts.size(); ++i){
        cnt1[step]+=nts.end()-lower_bound(ALL(nts),dva-nts[i]);
        if(nts[i]>=dva/2) --cnt1[step];
    }
}
inline void nullone(int step){
    int64_t mask = (1LL<<step)-1, dva = 1LL<<step;
    for(int i = 1; i <= n; ++i){
        if((a[i]>>step)&1){
            cnt1[step]+=lower_bound(ALL(nts),dva-(a[i]&mask))-nts.begin();
        }
    }
}
inline void solve(){
    for(int i = 0; i < 1; ++i){
        for(int j = 1; j <= n; ++j){
            cnt1[i] += a[j]&1;
            cnt0[i] += ~a[j]&1;
        }
    }
    ans = (cnt1[0]*cnt0[0])&1;
    for(int step = 1; step < M; ++step){
        nullnull(step);
        nullone(step);
        cnt0[step] = C2n(n)-cnt1[step];
        ans+=((cnt1[step])&1)<<(step);
    }
}

inline void print(){
    cout << ans;
}

inline void test(){
    cout << log2(1e7);
    exit(0);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    solve();
    print();

    return 0;
}
