#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
uniform_real_distribution<> re(0, 1);
template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 2000;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

vector <int> pref[101];

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vector <int> ar(n);
    for (int &i : ar)
        cin >> i;

    if (n <= 1000) {
        int ans = 0;
        For (i, n)
            for (int j = i+1; j < n; j++)
                ans ^= (ar[i] + ar[j]);
        cout << ans << '\n';
    } else {
        For (i, 101) {
            pref[i].resize(n+1);
            for (int j = n-1; j >= 0; j--)
                pref[i][j] = pref[i][j+1] ^ (i + ar[j]);
        }
        int ans = 0;
        For (i, n)
            ans ^= pref[ar[i]][i+1];
        cout << ans << '\n';
    }
}
