#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const int bits = 8;

int n, a[MAXN];

void solve_tup() {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++)
			ans ^= (a[i] + a[j]);
 	}
 	cout << ans;
}

//int b[bits][2][MAXN * 10];
int sum[bits][2][110];

void upd(int num, int bit, int pos) {
	while (pos < 110) {
		sum[num][bit][pos]++;
		pos |= (pos + 1);
	}
}

int calc(int num, int bit, int pos) {
	int res = 0;
	while (pos >= 0) {
		res += sum[num][bit][pos];
		pos = (pos & (pos + 1)) - 1;
	}
	return res;
}

int get(int num, int bit, int l, int r) {
	return calc(num, bit, r) - calc(num, bit, l - 1);
}


int main() {
	fastIO();
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	if (n <= 1000) {
		solve_tup();
		return 0;		
	}
	/*for (int i = 0; i < bits; i++) {
		for (int j = 0; j < n; j++) {
			b[bits][0][j] = -1;
			b[bits][1][j] = -1;
		}
 	}
	for (int i = 0; i < n; i++) {
		int pref_sum = 0;
		for (int j = 0; j < bits; j++) {
			int bit = ((a[i] >> j) & 1); 
			b[j][bit][i] = pref_sum;
			if (bit)
				pref_sum += (1 << j);
		}
	}*/
	int ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		int pref_sum = 0, cur_res = 0;
		for (int j = 0; j < bits; j++) {
			int cnt1 = 0;
			if ((a[i] >> j) & 1) {
				cnt1 += get(j, 0, 0, (1 << j) - pref_sum - 1); 
				cnt1 += get(j, 1, (1 << j) - pref_sum, 110 - 1);
			}
			else {
				cnt1 += get(j, 1, 0, (1 << j) - pref_sum - 1);
				cnt1 += get(j, 0, (1 << j) - pref_sum, 110 - 1); 
			}
			//if (i == 0)
			//	cerr << cnt1 << endl;
			if (cnt1 % 2)
				cur_res += (1 << j);
			upd(j, ((a[i] >> j) & 1), pref_sum);
			if ((a[i] >> j) & 1)
				pref_sum += (1 << j);
		}
		ans ^= cur_res;
		//cerr << get(0, 0, 0, MAXN) <<  ' ' << get(0, 1, 0, MAXN) << endl;
	}
	cout << ans;
	
	
	
	
	
	return 0;

}