/*DavitMarg*/
#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<string>
#include<cstring>
#include<set>
#include<queue>
#include<map>
#include<unordered_map>
#include<deque>
#include<cassert>
#define mod 1000000007ll
#define LL long long
#define LD long double
#define MP make_pair
#define PB push_back
#define all(v) v.begin(),v.end()
using namespace std;

const int N = 400005;

vector<LL> t;
vector<int> L, R;
void addNode(LL val = 0)
{
	t.PB(val);
	L.PB(0);
	R.PB(0);
}

void add(int v, LL l, LL r, LL pos)
{
	if (l == r)
	{
		t[v]++;
		return;
	}
	if (L[v] == 0)
	{
		addNode();
		L[v] = t.size() - 1;
		addNode();
		R[v] = t.size() - 1;
	}
	LL m = (l + r) / 2ll;
	if (pos <= m)
		add(L[v], l, m, pos);
	else
		add(R[v], m + 1, r, pos);
	t[v] = t[L[v]] + t[R[v]];
}

LL get(int v, LL l, LL r, LL i, LL j)
{
	if (i > j)
		return 0;
	if (l == i && r == j)
		return t[v];
	LL m = (l + r) / 2ll;
	LL res = 0;
	if (L[v])
		res += get(L[v], l, m, i, min(j, m));
	if (R[v])
		res += get(R[v], m + 1, r, max(m + 1, i), j);
	return res;
}

void build()
{
	t.clear();
	L.clear();
	R.clear();
	addNode();
}

LL n;
LL a[N], x[N], ans;

LL get(LL l, LL r)
{
	l = max(l,0ll);
	if (l > r)
		return 0ll;
	return get(0, 0, mod, l, r);
}

void add(LL x)
{
	add(0, 0, mod, x);
}



int main()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
		scanf("%lld", a + i);
	for (int k = 0; k <= 30; k++)
	{
		LL cnt = 0;
		LL d = (1ll << k);
		LL dd = (1ll << (k + 1)) + d;
		for (int i = 1; i <= n; i++)
			x[i] += ((1ll << k) & a[i]);
		build();
		for (int i = 1; i <= n; i++)
		{
			cnt += get(d-x[i], d + d - 1ll-x[i]);
			cnt %= 2;
			cnt += get(dd-x[i], dd + d - 1ll-x[i]);
			cnt %= 2;
			add(x[i]);
		}
		if (cnt)
			ans += d;
	}

	cout << ans << endl;
	return 0;
}

/*

2
1 2

3
3 3 3

3
1 2 3


*/