#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;

struct Stupid {
    vector<int> a;
    int n;

    Stupid(vector<int> a): a(a) {
        n = a.size();
    }

    int solve() {
        int res = 0;
        for(int i = 0; i < n; ++i)
            for(int j = i+1; j < n; ++j)
                res ^= a[i]+a[j];

        return res;
    }
};

struct Solver {
    vector<int> a;
    int n;
    static const int m = 30;

    Solver(vector<int> a): a(a) {
        n = a.size();
    }

    int solve() {
        int res = 0;

        vector<int> p0(m, 0);
        for(int i = 0; i < n; ++i) {
            vector<int> p = p0;

            vector<int> cur(m, 0);
            for(int j = 0; j < m; ++j) {
                cur[j] = a[i] % 2;
                p0[j] += cur[j];
                a[i] /= 2;
            }

            int cur_n = 0;
            for(int j = 0; j < m; ++j) {
                cout << "MDA: " << j << " " << cur[j] << " " << i << " " << p[j] << "\n";
                if(cur[j]) {
                    cur_n ^= (1<<j)*(abs(i-p[j]) % 2);
                    if(j+1 < m) p[j+1] += p[j];
                } else {
                    cur_n ^= (1<<j)*((p[j]) % 2);
                }
            }

            cout << cur_n << "\n";
            res ^= cur_n;
        }

        return res;
    }
};

vector<int> get_a(int n, int m) {
    vector<int> a(n, 0);
    for(int i = 0; i < n; ++i)
        a[i] = 1 + (rand() % m);

    return a;
}

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n;
            cin >> n;

            vector<int> a(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> a[i];

            Stupid solver(a);
            int res = solver.solve();

            cout << res << "\n";

        } else {
            int n = 3;
            vector<int> a = get_a(n, 5);

            Solver solver(a);
            int res = solver.solve();

            Stupid stupid(a);
            int tres = stupid.solve();

            if(res !=  tres) {
                cout << "MDA: ";
                for(int i : a) cout << i << " ";
                cout << "\n";
                cout << res << " " << tres << "\n\n";
            }
        }
    }

    return 0;
}
