#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)
#define x first
#define y second

const int BITS = 27;

map<int, int> cnt[BITS];

void run() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    for(int &x : a) x *= 2;
    int res = 0;
    int tot = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            tot ^= (a[i] + a[j]);
        }
    }
    for (int i = BITS - 1; i >= 0; i--) {
        for (int j = 0; j < BITS; j++) {
            cnt[j].clear();
        }
        ll cur = 0;
        for (int j = 0; j < n; j++) {
            if (a[j] >> i & 1) {
                int mask = 0;
                for (int v = i; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        continue;
                    } else {
                        cur += cnt[i - v][mask];
                        mask ^= (1 << v);
                    }
                }
                mask = (1 << i);
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        cur += cnt[i - v][mask ^ (1 << v)];
                    } else {
                        mask ^= (1 << v);
                    }
                }
            } else {
                int mask = (1 << i);
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        continue;
                    } else {
                        cur += cnt[i - v][mask];
                        mask ^= (1 << v);
                    }
                }
                mask = 0;
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        cur += cnt[i - v][mask ^ (1 << v)];
                    } else {
                        mask ^= (1 << v);
                    }
                }
            }
            int mask = 0;
            for (int v = i; v >= 0; v--) {
                if (a[j] >> v & 1) mask ^= (1 << v);
                cnt[i - v][mask]++;
            }
        }
        if (cur & 1) {
            res ^= (1 << i);
        }
    }
    cout << (res >> 1);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    // gene();

    run();
}
