import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.util.TreeSet;

import static java.lang.Math.max;

public class B {
    static BufferedReader in;
    static StringTokenizer st;
    static int ms[];
    static int n;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        n = nextInt();
        ms = new int[n];
        fn();
        for (int i = 0; i < n; i++) {
            ms[i] = nextInt();
        }
        int ans = 0;
        for (int i = 0; i < 30; i++) {
            ans += fk(i);
        }
        System.out.println(ans);
    }

    private static int fk(int k) {
        k++;
        int tk[] = new int[n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < k; j++) {
                tk[i] += (ms[i] & (1 << j));
            }
        }
        int cnt = 0;
        int one[] = new int[n];
        int two[] = new int[n];
        for (int i = 0; i < n; i++) {
            one[i] = (1 << k) - tk[i];
            two[i] = (1 << k) + (1 << (k - 1)) - tk[i];
        }
        Arrays.sort(one);
        Arrays.sort(two);
        for (int i = 0; i < n; i++) {
            if ((1 << k) - tk[i] > tk[i] && tk[i] >= (1 << (k - 1)) - tk[i]) cnt--;
            if ((1 << k) + (1 << (k - 1)) - tk[i] <= tk[i]) cnt--;
            int l = -1;
            int r = n;
            while (l + 1 < r) {
                int m = (l + r) >> 1;
                if (one[m] > tk[i]) r = m;
                else l = m;
            }
            int l1 = -1;
            int r1 = n;
            int x = tk[i] + (1 << (k - 1));
            while (l1 + 1 < r1) {
                int m = (l1 + r1) >> 1;
                if (one[m] > x) r1 = m;
                else l1 = m;
            }
            cnt += max(r1 - r, 0);
            l = -1;
            r = n;
            while (l + 1 < r) {
                int m = (l + r) >> 1;
                if (two[m] <= tk[i]) l = m;
                else r = m;
            }
            cnt += r;
        }
        cnt /= 2;
        cnt %= 2;
        return cnt << (k - 1);
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
