#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>
#define int long long

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n;
const int N = 400 * 1000, BIT = 30;
int a[N], m[BIT + 1][N], cnt[BIT + 1];

signed main() {
	warp();

	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];


	sort(a, a + n);

	for (int i = 0; i < n; ++i) {
		int nw = 0;
		for (int bit = 0; bit <= BIT; ++bit) {
			int X = (((int)1 << bit) & a[i]);
			if (X) {
				nw += ((int)1 << bit);
			}

			m[bit][i] = nw;
		}
	}
	for (int bit = 0; bit <= BIT; ++bit) {
		sort(m[bit], m[bit] + n);
	}
	for (int i = 0; i < n; ++i) {
		int nw = 0;
		for (int bit = 0; bit <= BIT; ++bit) {
			int X = (((int)1 << bit) & a[i]);
			if (X) {
				nw += ((int)1 << bit);
			}
			int MN = ((int)1 << bit) - nw,
				MX = ((int)1 << (bit + 1)) - 1 - nw;

			int L = lower_bound(m[bit], m[bit] + n, MN) - m[bit],
				R = upper_bound(m[bit], m[bit] + n, MX) - m[bit] - 1;
			
			
			if (MN <= nw && nw <= MX)
				++L;

			cnt[bit] += max((R - L + 1), (int)0);
		}
	}
	int ans = 0;
	for (int bit = 0; bit <= BIT; ++bit) {
		cnt[bit] /= 2;
		if (cnt[bit] % 2) {
			ans += ((int)1 << bit);
		}
	}
	cout << ans;
}