#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>
#include <math.h>
#include <iomanip>
#define ll long long
#define ld long double

using namespace std;

const int maxlog = 25;

int coun[maxlog];

ll all[maxlog];
vector<ll> arr[maxlog];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<ll> a(n);
    
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        ll val = 0;
        for (int j = 0; j < maxlog; j++) {
            if (a[i] & (1 << j)) {
                coun[j]++;
                val += (1 << j);
            }
            arr[j].push_back(val);
        }
    }
    ll x = 0;
    for (int j = 0; j < maxlog; j++) {
        ll A = coun[j];
        ll B = n - coun[j];
        //cout << j << ": " << A << " " << B << " " << x << endl;
        all[j] = (A * B + x) % 2;
        //cout << all[j] << "!" << endl;
        sort(arr[j].begin(), arr[j].end());
        x = 0;
        int pt = n;
        for (int i = 0; i < n; i++) {
            while (pt > i && (arr[j][i] + arr[j][pt - 1] >= (1 << (j + 1))))
                pt--;
            int R = max(pt, i + 1);
            x += (n - R);
        }
    }
    ll ans = 0;
    for (int j = 0; j < maxlog; j++) {
        if (all[j] == 1)
            ans += (1 << j);
    }
    cout << ans << endl;
}