#include <iostream>
#include <vector>

#define int long long

using namespace std;

void solve1(int n, vector<int> & a){
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            ans = (ans ^ (a[i] + a[j]));
        }
    }
    cout << ans << endl;
}

void solve2(int n, vector<int> & a){
    int ans = 0;
    vector<int> cnt(101);
    for (auto i : a){
        cnt[i]++;
    }
    for (int i = 0; i < 101; i++){
        for (int j = i + 1; j < 101; j++){
            ans = (ans ^ ((i + j) * (cnt[i] * cnt[j] % 2)));
        }
    }
    for (int i = 0; i < 101; i++){
        ans = (ans ^ (i * (cnt[i] - 1) * cnt[i] / 2 % 2));
    }
    cout << ans << endl;

}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    if (n <= 1000){
        solve1(n, a);
    }else{
        solve2(n, a);
    }
    return 0;
}
