//#define _GLIBCXX_DEBUG 1
#pragma GCC("tune=native")

#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    if (n <= 1000) {
        int arr[400001];
        for (int i = 0; i < n; ++i) cin >> arr[i];
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                sum ^= arr[i] + arr[j];
            }
        }
        cout << sum;
    } else {
        int16_t arr[400001];
        int now2;
        for (int i = 0; i < n; ++i) {
            cin >> now2;
            arr[i] = now2;
        }
        sort(&arr[0], (&arr[0]) + n);
        int16_t mx = arr[n - 1] + arr[n - 2];
//        vector<char> use(max1 + max2 + 1);
        int16_t sum = 0;
        int16_t now;
        for (int16_t i = 1; i <= mx; ++i) {
            int l = 0, r = n - 1, cnt = 0;
            for (; r > l; r--) {
                now = arr[r];
                for (; l < r && arr[l] + now < i; l++);
                if (l >= r) break;
                if (arr[l] + now == i)
                    cnt++;
            }
            if (cnt & 1) sum ^= i;
        }
        cout << sum;
    }
}