#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	ll n;
	cin >> n;
	vector <ll> a(n);
	cin >> a;

	vector <ll> cnt1(a[a.size() - 1] + 1), cnt2(a[a.size() - 1] + a[a.size() - 2] + 1);
	for (auto & i : a)
		cnt1[i]++;
	
	sort(all(a));
	a.erase(unique(all(a)), a.end());
	
	for (ll i = 0; i < a.size(); i++)
		for (ll j = 0; j < i; j++)
			cnt2[a[i] + a[j]] += cnt1[a[i]] * cnt1[a[j]];

	ll ans = 0;
	for (ll i = 0; i < cnt2.size(); i++)
		if (cnt2[i] % 2)
			ans ^= i;
	cout << ans;
	return 0;
}