#include <iostream>
#include <vector>

#define int long long

using namespace std;

void solve1(int n, vector<int> & a){
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            ans = (ans ^ (a[i] + a[j]));
        }
    }
    cout << ans << endl;
}

void solve2(int n, vector<int> & a){
    int ans = 0;
    vector<int> cnt(101);
    for (auto i : a){
        cnt[i]++;
    }
    vector<int> cnt2(201);
    for (int i = 0; i < 101; i++){
        for (int j = i + 1; j < 101; j++){
            cnt2[i + j] += cnt[i] * cnt[j];
        }
    }
    for (int i = 0; i < 101; i++){
        if (cnt[i]){

            //cout << i << ' ' << cnt[i] << "    ";
        }
        cnt2[i + i] += (cnt[i] * (cnt[i] - 1) / 2);
    }
    //cout << endl;

    for (int i = 0; i < 201; i++){
        if (cnt2[i]){
            int sup = cnt2[i];
            //cout << i << ' ' << sup << "   ";
            ans = (ans ^ (i * (sup % 2)));
        }
    }
    //cout << endl;

    cout << ans << endl;

}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    //solve1(n, a);
    //solve2(n, a);
    if (n <= 1000){
        solve1(n, a);
    }else{
        solve2(n, a);
    }
    return 0;
}
