#define _GLIBCXX_DEBUG 1

#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> arr(n);
    for (auto &i : arr) cin >> i;
    if (n <= 1000) {
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                sum ^= arr[i] + arr[j];
            }
        }
        cout << sum;
    } else {
        sort(arr.begin(), arr.end());
        int max1 = *arr.rend();
        int max2 = *next(arr.rend());
//        vector<char> use(max1 + max2 + 1);
        int sum = 0;
        for (int i = 2; i <= max1 + max2; ++i) {
            int l = 0, r = n - 1, cnt = 0;
            for (; r > l; r--) {
                for (; l < r && arr[l] + arr[r] < i; l++);
                if (l >= r) break;
                if (arr[l] + arr[r] == i) cnt++;
            }
            if (cnt & 1) sum ^= i;
        }
        cout << sum;
    }
}