#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

int n;
vector<int> a;

void gen() {
	n = rand() % 3 + 1;
	a.resize(n);
	ior(a)
		i = rand() % 5 + 1;
}

int solve() {
	vector<int> m(101);
	for (int i = 0; i < n; ++i) {
		m[a[i]]++;
	}
	int ans = 0;
	for (int i = 1; i < 101; ++i)
		for (int j = i; j < 101; ++j) {
			if (i == j) {
				if (((m[i] * (m[i] - 1)) / 2) & 1)
					ans ^= (i + j);
				continue;
			}
			if ((m[i] * m[j]) & 1)
				ans ^= (i + j);
		}
	return ans;
}

int ssolve() {
	int ans = 0;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			ans ^= (a[i] + a[j]);
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	if (0) {
		do {
			gen();
			int s1 = solve();
			int s2 = ssolve();
			if (s1 != s2) {
				cout << n << '\n';
				ior(a)
					cout << i << " ";
				cout << '\n' << s1 << " " << s2;
				return 0;
			}
		} while (1);
	}
	cin >> n;
	a.resize(n);
	ior(a)
		cin >> i;
	if (n <= 1000)
		cout << ssolve();
	else
		cout << solve();
	return 0;
}