#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
#define int long long

int solve(vector<int> &a) {
    int n = a.size();
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans ^= (a[i] + a[j]);
        }
    }
    return ans;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> hist(101);
    for (int &i : a) {
        cin >> i;
        hist[i]++;
    }

    vector<int> b;
    vector<int> fix;

    for (int i = 0; i < 101; ++i) {
        if (hist[i] == 0)
            continue;
        if (hist[i] % 2)
            b.emplace_back(i);
        if ((hist[i] * (hist[i] - 1) / 2) % 2)
            fix.emplace_back(i * 2);
    }

    int ans = solve(b);
    for (int i : fix)
        ans ^= i;
    cout << ans;
    return 0;
}
