#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
#include <unordered_map>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)
#define x first
#define y second

const int BITS = 26;
ll INF = 1e9 + 17;
unordered_map<ll, int> cnt;
mt19937 gen;

inline int read() {
  int ret = 0;
  char c;
  while (1) {
    c = getchar();
    if ('0' <= c && c <= '9') {
      ret = ret * 10 + (c - '0');
    } else if (ret) break;
  }
  return ret;
}

const int N = 4e5 + 1;
int a[N];

void run() {
    int n = read();
    for (int i = 0; i < n; i++) a[i] = read() * 2;
    shuffle(a, a + n, gen);
    int res = 0;
    for (int i = BITS - 1; i >= 0; i--) {
        cnt.clear();
        cur.reserve(n * i + 1);
        ll cur = 0;
        for (int j = 0; j < n; j++) {
            if (a[j] >> i & 1) {
                int mask = 0;
                for (int v = i; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        continue;
                    } else {
                        if (cnt.find((i - v) * INF + mask) != cnt.end())
                          cur += cnt[(i - v) * INF + mask];
                        mask ^= (1 << v);
                    }
                }
                mask = (1 << i);
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        if (cnt.find((i - v) * INF + (mask ^ (1 << v))) != cnt.end())
                          cur += cnt[(i - v) * INF + (mask ^ (1 << v))];
                    } else {
                        mask ^= (1 << v);
                    }
                }
            } else {
                int mask = (1 << i);
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        continue;
                    } else {
                        if (cnt.find((i - v) * INF + mask) != cnt.end())
                          cur += cnt[(i - v) * INF + mask];
                        mask ^= (1 << v);
                    }
                }
                mask = 0;
                for (int v = i - 1; v >= 0; v--) {
                    if (a[j] >> v & 1) {
                        if (cnt.find((i - v) * INF + (mask ^ (1 << v))) != cnt.end())
                        cur += cnt[(i - v) * INF + (mask ^ (1 << v))];
                    } else {
                        mask ^= (1 << v);
                    }
                }
            }
            int mask = 0;
            for (int v = i; v >= 0; v--) {
                if (a[j] >> v & 1) mask ^= (1 << v);
                cnt[(i - v) * INF + mask]++;
            }
        }
        if (cur & 1) {
            res ^= (1 << i);
        }
    }
    cout << (res >> 1);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    // gene();

    run();
}
