#define _GLIBCXX_DEBUG 1

#include <algorithm>
#include <cmath>
#include <tuple>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <deque>
#include <unordered_set>
#include <bitset>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;
using ordset = tree<
        int,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;


int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> arr(n);
    int mx = -1;
    for (auto &i : arr) {cin >> i; mx = max(mx, i);}
    if (mx > 100) {
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                sum ^= arr[i] + arr[j];
            }
        }
        cout << sum;
    } else {
        vector<int> el(mx + 1);
        for (auto i : arr) el[i]++;
        ll sum = 0;
        for (int i = 1; i <= mx * 2; ++i) {
            int cnt = 0;
            for (int l = 1; l < i and l < i - l; ++l) {
                if (l > mx or i - l > mx) continue;
                cnt += el[l] * el[i - l];
            }
            if (cnt & 1) sum ^= i;
        }
        cout << sum;
    }
}