// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define mp make_pair
#define ll long long
#define ld long double
#define pll pair<long long, long long>
#define pld pair<long double, long double>
#define pii pair<int, int>
#define pb emplace_back

int main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
		srand(time(0));
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(0);
		cout.tie(0);
		cout << fixed << setprecision(15);
	#endif
	int n;
	cin >> n;
	vector<int> a(n);
	map<pair<int, int>, long long> q;
	unordered_map<int, long long> ones, zeros;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		bitset<32> b = a[i];
		if (b[0]) ++ones[0];
		else ++zeros[0];
		for (int j = 1; j < 32; ++j) {
			++q[{j, b[j] * 2 + b[j - 1]}];
			if (b[j]) ++ones[j];
			else ++zeros[j];
		}
		// cout << b << '\n';
	}
	// cout << '\n';
	// for (int i = 0; i < 5; ++i) {
	// 	cout << "for " << i << '\n';
	// 	cout << "00 : " << q[{i, 0}] << '\n';
	// 	cout << "01 : " << q[{i, 1}] << '\n';
	// 	cout << "10 : " << q[{i, 2}] << '\n';
	// 	cout << "11 : " << q[{i, 3}] << '\n';
	// }
	bitset<32> ans;
	ans[0] = (ones[0] * zeros[0]) % 2;
	for (int i = 1; i < 32; ++i) {
		ans[i] = (ones[i] * zeros[i] - q[{i, 1 * 2 + 1}] * q[{i, 0 * 2 + 1}] + q[{i, 0 * 2 + 1}] * (q[{i, 0 * 2 + 1}] - 1) / 2) % 2;
		// cout << i << " : " << (ones[i] * zeros[i] - q[{i, 1 * 2 + 1}] * q[{i, 0 * 2 + 1}] + q[{i, 0 * 2 + 1}] * (q[{i, 0 * 2 + 1}] - 1)) << '\n';
	}
	cout << ans.to_ullong();
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s   ";
	#endif
	return 0;
}