#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)
#define x first
#define y second

const int BITS = 27;

const int BB = 1e7;
int go[2][BB];
int sz[BB];
int head = 0;

inline void nw() {
  assert(head < BB);
  go[0][head] = go[1][head] = -1;
  sz[head] = 0;
  head++;
}

inline int nxt(int v, int p) {
  if (go[p][v] == -1) {
    go[p][v] = head;
    nw();
  }
  return go[p][v];
}

ll cur = 0;

void dfs10(int a, int i) {
  int v = 0;
  while (i >= 0) {
    if (a >> i & 1) {
      v = nxt(v, 0);
    } else {
      cur += sz[nxt(v, 0)];
      v = nxt(v, 1);
    }
    --i;
  }
}

void dfs11(int a, int i) {
  int v = nxt(0, 1);
  --i;
  while (i >= 0) {
    if (a >> i & 1) {
      cur += sz[nxt(v, 1)];
      v = nxt(v, 0);
    } else {
      v = nxt(v, 1);
    }
    --i;
  }
}

void dfs01(int a, int i) {
    int v = nxt(0, 1);
    --i;
    while (i >= 0) {
      if (a >> i & 1) {
        v = nxt(v, 0);
      } else {
        cur += sz[nxt(v, 0)];
        v = nxt(v, 1);
      }
      --i;
    }
}

void dfs00(int a, int i) {
   int v = nxt(0, 0);
   --i;
   while (i >= 0){
    if (a >> i & 1) {
      cur += sz[nxt(v, 1)];
      v = nxt(v, 0);
    } else {
      v = nxt(v, 1);
    }
    --i;
   }
}

void add(int x, int p) {
  int v = 0;
  while (p >= 0) {
    sz[v]++;
    v = nxt(v, x >> p & 1);
    --p;
  }
  sz[v]++;
}

void run() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    for(int &x : a) x *= 2;
    int res = 0;
    for (int i = BITS - 1; i >= 0; i--) {
        cur = 0;
        head = 0;
        nw();
        for (int j = 0; j < n; j++) {
            if (a[j] >> i & 1) {
              dfs10(a[j], i);
              dfs11(a[j], i);
            } else {
              dfs00(a[j], i);
              dfs01(a[j], i);
            }
            add(a[j], i);
        }
        if (cur & 1) {
            res ^= (1 << i);
        }
    }
    cout << (res >> 1);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    // gene();

    run();
}
