#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

#pragma GCC optimize("inline-functions")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)
#define x first
#define y second

const int BITS = 27;

const int BB = 1e7;
int go[2][BB];
int sz[BB];
int head = 0;

inline int nxt(int v, int p) {
  if (go[p][v] == -1) {
    go[p][v] = head;
    go[0][head] = go[1][head] = -1;
    sz[head] = 0;
    head++;
  }
  return go[p][v];
}

ll cur = 0;

inline void dfs10(int a, int i) {
  int v = 0;
  while (i >= 0) {
    if (a >> i & 1) {
      v = nxt(v, 0);
    } else {
      if (go[0][v] != -1)
        cur += sz[go[0][v]];
      v = nxt(v, 1);
    }
    --i;
  }
}

inline void dfs11(int a, int i) {
  int v = nxt(0, 1);
  --i;
  while (i >= 0) {
    if (a >> i & 1) {
      if (go[1][v] != -1)
        cur += sz[go[1][v]];
      v = nxt(v, 0);
    } else {
      v = nxt(v, 1);
    }
    --i;
  }
}

inline void dfs01(int a, int i) {
    int v = nxt(0, 1);
    --i;
    while (i >= 0) {
      if (a >> i & 1) {
        v = nxt(v, 0);
      } else {
        if (go[0][v] != -1)
          cur += sz[go[0][v]];
        v = nxt(v, 1);
      }
      --i;
    }
}

inline void dfs00(int a, int i) {
   int v = nxt(0, 0);
   --i;
   while (i >= 0){
    if (a >> i & 1) {
      if (go[1][v] != -1)
        cur += sz[go[1][v]];
      v = nxt(v, 0);
    } else {
      v = nxt(v, 1);
    }
    --i;
   }
}

inline void add(int x, int p) {
  int v = 0;
  while (p >= 0) {
    sz[v]++;
    v = nxt(v, x >> p & 1);
    --p;
  }
  sz[v]++;
}

const int N = 4e5 + 1;

inline int read() {
  int ret = 0;
  char c;
  while (1) {
    c = getchar();
    if ('0' <= c && c <= '9') {
      ret = ret * 10 + (c - '0');
    } else if (ret) break;
  }
  return ret;
}

int a[N];

void run() {
    assert((1 << BITS) / 2 > 4e7);
    int n = read();
    for (int i = 0; i < n; i++) a[i] = read() * 2;
    int res = 0;
    for (int i = BITS - 1; i >= 0; i--) {
        cur = 0;
        head = 0;
        go[0][head] = go[1][head] = -1;
        sz[head] = 0;
        head++;
        for (int j = 0; j < n; j++) {
            if (a[j] >> i & 1) {
              dfs10(a[j], i);
              dfs11(a[j], i);
            } else {
              dfs00(a[j], i);
              dfs01(a[j], i);
            }
            add(a[j], i);
        }
        if (cur & 1) {
            res ^= (1 << i);
        }
    }
    cout << (res >> 1);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    run();
}
