#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

signed main()
{
    Start();
    int n;
    cin >> n;
    vector <int> a(n);
    cin >> a;
    int x = 0;
    for (int bit = 0; bit < 25; ++bit)
    {
        vector <int> b(n);
        for (int i = 0; i < n; ++i)
        {
            b[i] = a[i] & ((1 << bit) - 1);
        }
        vector <int> p(n);
        iota(all(p), 0);
        sort(all(p), [&] (int i, int j) {return b[i] < b[j];});
        sort(all(b));
        vector <int> from(n);
        for (int i = 0; i < n; ++i)
        {
            from[i] = lower_bound(all(b), (1 << bit) - b[i]) - b.begin();
            from[i] = max(from[i], i + 1);
        }
        vector <int> cnt1(n + 1);
        for (int i = n - 1; i >= 0; --i)
            cnt1[i] = cnt1[i + 1] + (a[p[i]] >> bit & 1);
        auto count1 = [&] (int l, int r) {return cnt1[l] - cnt1[r + 1];};
        auto count0 = [&] (int l, int r) {return r - l + 1 - (cnt1[l] - cnt1[r + 1]);};
        int cur = 0;
        for (int i = 0; i < n; ++i)
        {
            cur += count0(from[i], n - 1);
            cur += count1(i, from[i] - 1);
        }
        x ^= (cur & 1) << bit;
    }
    cout << x;
    return 0;
}

