#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

const int PW = 25;

#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 400010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

int cnt[PW];
int arr[MX];
int bits[PW][MX];
int bitcnt[PW];
int main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    fi(0, n) {
        cin >> arr[i];
        int mask = 0;
        fj(0, PW) {
            mask += 1 << j;
            if ((1 << j) & arr[i])
                bitcnt[j]++;
            bits[j][i] = arr[i] & mask;
        }
    }
    fj(0, PW)
        sort(bits[j], bits[j] + n);
    fi(0, n) {
        int x = arr[i];
        int sm = 0;
        fj(0, PW) {
            sm += (1 << j) & x;
            int need = (1 << (j + 1)) - sm;
            cnt[j + 1] += bits[j] + n - lower_bound(bits[j], bits[j] + n, need);
            int bit = (1 << j) & x;
            if (!bit)
                cnt[j] += bitcnt[j];
            else {
                cnt[j] += n - bitcnt[j];
                --cnt[j + 1];
            }
        }
    }
    int ans = 0;
    fi(0, PW)
        if ((cnt[i] / 2) % 2) ans += (1 << i);
    cout << ans;
}