#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr int SQ = 14;
constexpr int RS = 24 - SQ;
constexpr int MSK1 = (1 << SQ) - 1;
constexpr int MSK2 = (1 << RS) - 1;
ll cnt1[1 << SQ], cnt2[1 << RS][SQ + 1], cnt3[1 << RS][SQ + 1];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    vector<int> a(n);
    for (int &i : a) {
        i = input();
        cnt1[i & MSK1] += 1;
    }

    int res = 0;
    for (int msk1 = 0; msk1 <= MSK1; ++msk1) {
        if ((cnt1[msk1] * (cnt1[msk1] - 1) / 2) % 2) {
            res ^= msk1 + msk1;
        }
    }
    for (int msk1 = 0; msk1 <= MSK1; ++msk1) {
        for (int msk2 = msk1 + 1; msk2 <= MSK1; ++msk2) {
            if (cnt1[msk1] % 2 && cnt1[msk2] % 2) {
                res ^= msk1 + msk2;
            }
        }
    }

    for (int i : a) {
        int b = SQ - 1, c = SQ - 1;
        for (; b >= 0; --b) {
            if ((i >> b) & 1) {
                break;
            }
        }
        for (; c >= 0; --c) {
            if (!((i >> c) & 1)) {
                break;
            }
        }
        ++c;
        cnt2[i >> SQ][b + 1] += 1;
        if (c + 1 <= SQ) {
            cnt3[i >> SQ][c + 1] += 1;
        }
    }

    int ans = res;
    res = 0;
    for (int msk1 = 0; msk1 <= MSK2; ++msk1) {
        if ((cnt2[msk1][SQ] * (cnt2[msk1][SQ] - 1) / 2) % 2) {
            res ^= (msk1 + msk1 + 1);
        }

        for (int b1 = SQ - 1; b1 >= 0; --b1) {
            if ((cnt2[msk1][b1] * (cnt2[msk1][b1] - 1) / 2) % 2) {
                res ^= (msk1 + msk1);
            }
        }

        for (int b1 = SQ - 1; b1 >= 0; --b1) {
            for (int b2 = b1 - 1; b2 >= 0; --b2) {
                if (cnt2[msk1][b1] % 2 && cnt2[msk1][b2] % 2) {
                    res ^= (msk1 + msk1);
                }
            }
        }

        for (int b1 = SQ - 1; b1 >= 0; --b1) {
            for (int c2 = SQ; c2 >= 0; --c2) {
                if (cnt2[msk1][b1] % 2 && cnt3[msk1][c2] % 2) {
                    res ^= (msk1 + msk1 + (c2 <= b1));
                }
            }
        }
    }

    for (int msk1 = 0; msk1 <= MSK2; ++msk1) {
        for (int msk2 = msk1 + 1; msk2 <= MSK2; ++msk2) {
            if (cnt2[msk1][SQ] % 2 && cnt2[msk2][SQ] % 2) {
                res ^= (msk1 + msk2 + 1);
            }

            for (int b1 = SQ - 1; b1 >= 0; --b1) {
                for (int b2 = SQ - 1; b2 >= 0; --b2) {
                    if (cnt2[msk1][b1] % 2 && cnt2[msk2][b2] % 2) {
                        res ^= (msk1 + msk2);
                    }
                }
            }

            for (int b1 = SQ - 1; b1 >= 0; --b1) {
                for (int c2 = SQ; c2 >= 0; --c2) {
                    if (cnt2[msk1][b1] % 2 && cnt3[msk2][c2] % 2) {
                        res ^= (msk1 + msk2 + (c2 <= b1));
                    }
                }
            }

            for (int c1 = SQ; c1 >= 0; --c1) {
                for (int b2 = SQ - 1; b2 >= 0; --b2) {
                    if (cnt3[msk1][c1] % 2 && cnt2[msk2][b2] % 2) {
                        res ^= (msk1 + msk2 + (c1 <= b2));
                    }
                }
            }
        }
    }

    cout << ans + (res << SQ) << endl;
}
