#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 4e5 + 5;
const int LOG = 25;

int a[MAXN];
int n;

void solve() {
	int res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			res ^= (a[i] + a[j]);
		}
	}
	cout << res << endl;
}

void solve1() {
	vector<ll> counter(105);
	int res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= 100; ++j) {
			int col = counter[j];
			if (col % 2) res ^= (j + a[i]);
		}
		counter[a[i]]++;
	}
	cout << res << endl;
}

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

void solve2() {
	int res = 0;
	for (int bit = 0; bit < LOG; ++bit) {
		vector<int> zeros;
		vector<int> ones;
		for (int j = 0; j < n; ++j) {
			sort(zeros.begin(), zeros.end());
			sort(ones.begin(), ones.end());
			if (check_bit(a[j], bit)) {
				//zero
				int l = -1, r = int(zeros.size());
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = zeros[mid] + a[j];
					if (check_bit(sum, bit)) l = mid;
					else r = mid;
				}
				int cur = l + 1;
				if (cur % 2) res ^= (1 << bit);
				// one
				 l = -1; r = int(ones.size());
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = ones[mid] + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				cur = int(ones.size()) - r;
				if (cur % 2) res ^= (1 << bit);
				ones.push_back(a[j]);
			} else {
				// zeros
				int l = -1, r = int(zeros.size());
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = zeros[mid] + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				int cur = int(zeros.size()) - r;
				if (cur % 2) res ^= (1 << bit);
				// ones
				l = -1; r = int(ones.size());
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = ones[mid] + a[j];
					if (check_bit(sum, bit)) l = mid;  
					else r = mid;
				}
				cur = l + 1;
				if (cur % 2) res ^= (1 << bit);
				zeros.push_back(a[j]);
			}
		}
	}
	cout << res << endl;
}

int main() {
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> a[i];
	solve2();
	//if (n <= 1000) solve();
	//else solve1();
	return 0;
}