#include <iostream>
#include <algorithm>
#define int long long
using namespace std;

const int MAXN = 400005;

int n, m, a[MAXN], b[128], c[256];
bool st2 = 1;

int t[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        if (a[i] > 100) st2 = 0;
        m = max(a[i], m);
    }
}

void SolveST2()
{
    for (int i = 1; i <= n; ++ i)
    {
        b[a[i]]++;
    }

    for (int i = 1; i < 128; ++ i)
    {
        c[i * 2] += b[i] * (b[i] - 1) / 2;
        for (int j = i + 1; j < 128; ++ j)
        {
            c[i + j] += b[i] * b[j];
        }
    }

    int ans = 0;
    for (int i = 1; i < 256; ++ i)
    {
        if (c[i] % 2) ans ^= i;
    }

    cout << ans << endl;
}

void Solve()
{
    int res = 0;
    int odd = 0, even = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (a[i] % 2) odd++;
        else even++;
    }
    if ((1ll * odd * even) % 2 == 1) res = 1;

    for (int b = 2; b < 30; ++ b)
    {
        for (int i = 1; i <= n; ++ i)
        {
            t[i] = a[i] & ((1 << b) - 1);
        }

        sort(t + 1, t + n + 1);

        /*for (int i = 1; i <= n; ++ i)
        {
            cout << t[i] << ' ';
        }*/
        // cout << endl;

        int lim = 1 << b;
        // cout << lim << endl;
        long long bg = 0;
        for (int i = 1; i <= n; ++ i)
        {
            int l, r, b1 = 0, b2 = 0, b3 = 0;

            l = 1; r = n;
            while (l <= r)
            {
                int mid = (l + r) / 2;
                if (t[i] + t[mid] >= lim / 2) {b1 = mid; r = mid - 1;}
                else l = mid + 1;
            }

            l = 1; r = n;
            while (l <= r)
            {
                int mid = (l + r) / 2;
                if (t[i] + t[mid] < lim) {b2 = mid; l = mid + 1;}
                else r = mid - 1;
            }

            l = 1; r = n;
            while (l <= r)
            {
                int mid = (l + r) / 2;
                if (t[i] + t[mid] >= 3 * lim / 2) {b3 = mid; r = mid - 1;}
                else l = mid + 1;
            }

            if (b1 != 0 and b2 != 0 and b2 > i) bg += b2 - max(i, b1 - 1);
            if (b3 != 0) bg += n - max(b3 - 1, i);
        }

        if (bg % 2 == 1) res ^= lim / 2;
    }

    cout << res << endl;
}

signed main()
{
    Init();

    Solve();
    return 0;

    if (st2)
    {
        SolveST2();
        return 0;
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            ans ^= a[i] + a[j];
        }
    }

    cout << ans << endl;
    return 0;
}

