#include <iostream>
#include <vector>
#include <bitset>


#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl "\n"
#endif

#define _ <<" "<<

using namespace std;
typedef long long ll;
const int N = 1<<25;

int n;
vector<int> vs;

void solve1(){
    int ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < i; j++){
            ans ^= (vs[i]+vs[j]);
        }
    }
    cout << ans << endl;
}
void solve2(){
    int ct[305] = {0};
    int ansct[305] = {0};
    for(int i = 0; i < n; i++){
        int v = vs[i];
        for(int i = 0; i < 301-v; i++){
            ansct[i+v] += ct[i];
        }
        ct[v]++;
    }
    int ans = 0;
    for(int i = 0; i < 300; i++){
        if(ansct[i]%2) ans ^= i;
    }
    cout << ans << endl;
}
int ct[N+10];
int prefct[N+10];

int get(int l, int r){
    r = min(r, N-1);
    if(l > r) return 0;
    if(l == 0) return prefct[r];
    else return prefct[r] - prefct[l-1];
}

void solve3(){
    for(int t: vs) ct[t++];
    int ans = 0;
    int mask = 0;
    for(int bit = 0; bit < 25; bit++){
        mask |= (1<<bit);

        int bd = (1<<(bit+1));
        for(int i = 0; i <= bd; i++) ct[i] = 0;
        for(int t: vs) ct[t&mask]++;

        prefct[0] = ct[0];
        for(int i = 1; i < bd; i++) prefct[i] = prefct[i-1] + ct[i];

        ll pct = 0;
        for(int t: vs){
            int l = 0;
            int r = 0;
            int tm = (t&mask);

            if((t&(1<<bit))){
                l = 0;
                r = (bd-1) - tm;
            }else{
                l = (1<<bit)-(t&mask);
                r = (bd-1) - tm;
            }
            int ct = get(l,r);
            if(l <= tm && tm <= r) ct--;

            pct += ct;
        }
        pct /= 2;
        if(pct%2) ans |= (1<<bit);
    }
    cout << ans << endl;
}

int32_t main()
{
    int maxa  = 0;
    cin >> n; vs.resize(n);
    for(int& i: vs) {
        cin >> i;
        maxa = max(i,maxa);
    }
    /*if(n <= 1005) solve1();
    else if(maxa <= 105) solve2();
    else solve3();*/
    solve3();
    return 0;
}
