#include <iostream>
#include <vector>
#include <bitset>


#define header ios_base::sync_with_stdio(0); cin.tie(nullptr); cout.tie(nullptr);

#ifndef LOCALDEV
#define endl "\n"
#endif

#define _ <<" "<<

using namespace std;
typedef long long ll;
const int N = 1<<24;

int n;
vector<int> vs;

int ct[N+10];
int prefct[N+10];

int get(int l, int r){
    r = min(r, N-1);
    if(l > r) return 0;
    if(l == 0) return prefct[r];
    else return prefct[r] - prefct[l-1];
}

void solve(){
    int ans = 0;
    int mask = 0;
    for(int bit = 0; bit < 24; bit++){
        int bv = (1<<bit);
        int bd = (1<<(bit+1));
        mask |= bv;

        for(int i = 0; i <= bd; i++) ct[i] = 0;
        for(int t: vs) ct[t&mask]++;
        prefct[0] = ct[0];
        for(int i = 1; i <= bd; i++) prefct[i] = prefct[i-1]+ct[i];

        ll pairs = 0;
        for(int t: vs){
            int tm = (t&mask);
            int l = max(bv-tm, 0);
            int r = (bd-1) - tm;
            ll c = get(l,r);
            if(tm >= l && tm <= r) c--;
            c = max(c, 0LL);
            pairs += c;
        }
        pairs /= 2;
        if(pairs%2) ans |= bv;
    }
    cout << ans << endl;
}

int32_t main()
{
    cin >> n; vs.resize(n);
    for(int& i: vs) {
        cin >> i;
    }
    solve();
    return 0;
}
