#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
#pragma gcc optimize ("O3")
#pragma gcc target ("sse4")
using namespace std;
const int MAXA = 1e6 + 1;

inline int rev(int &x, int &log_n)
{
    int res = 0;
    for(int i = 0; i < log_n; i++)
        if(x & (1 << i))
            res |= (1 << (log_n - 1 - i));

    return res;
}
//
//typedef complex <double> base;
const double PI = acos(-1);

struct base{

    double x, y;
    base() {x = 0; y = 0;}
    base(double _x, double _y)
    {
        x = _x;
        y = _y;
    }


};

base mult(base a, base b)
{
   return base(a.x * b.x - a.y * b.y, a.x * b.y + a.y * b.x);
}

base add(base a, base b)
{
    return base(a.x + b.x, a.y + b.y);
}

base sub(base a, base b)
{
    return base(a.x - b.x, a.y - b.y);
}

base di(base a, double x)
{
    return base(a.x / x, a.y / x);
}

void FFT(vector <base> &a, bool invert)
{
    int n = (int)a.size(), log_n = 0;
    while((1 << log_n) < n)
        log_n++;

    for(int i = 0; i < n; i++)
        if(i < rev(i, log_n))
            swap(a[i], a[rev(i, log_n)]);

    for(int len = 2; len <= n; len *= 2)
    {
        double ang = ( 2 * PI / len) * (invert ? -1 : 1);
        base wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len)
        {
            base w(1, 0);
            for(int j = 0; j < len / 2; j++)
            {
                base u = a[i + j], v = mult(a[i + j + len / 2], w);
                a[i + j] = add(u, v);
                a[i + j + len / 2] = sub(u, v);
                w = mult(w, wlen);
            }
        }
    }

    if(invert)
        for(int i = 0; i < n; i++)
            a[i] = di(a[i], n);
}

void mult(vector <base> &fa)
{
    int n = 1;
    while(n < fa.size())
        n *= 2;
    fa.resize(n);

    FFT(fa, 0);
    for(int i = 0; i < n; i++)
        fa[i] = mult(fa[i], fa[i]);
    FFT(fa, 1);
}


int n;
int inp[400005];

void dumb_sol()
{
    for(int i = 1; i <= n; i++)
        cin >> inp[i];
    int ans = 0;
    for(int i = 1; i <= n; i++)
        for(int j = i + 1; j <= n; j++)
            ans ^= (inp[i] + inp[j]);

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    vector <base> cnt(MAXA);
    int x;

    cin >> n;
//    if(n <= 1000)
//    {
//        dumb_sol();
//        return 0;
//    }
    for(int i = 1; i <= n; i++)
    {
        cin >> inp[i];
        cnt[inp[i]].x++;
    }

    mult(cnt);
    for(int i = 1; i <= n; i++)
            cnt[2 * inp[i]].x--;

    int ans = 0;
    for(int i = 0; i < (int)cnt.size(); i++)
        if(((int)(cnt[i].x + 0.5) / 2) & 1)
            ans ^= i;

    cout << ans << endl;

    return 0;
}

/*

3
1 2 3

*/
