#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n;
    cin >> n;
    if (n > 1000) {
        ll res = 0;
        vector <int> all(120000000);
        for (ll i = 0; i < n; i++) {
            ll a;
            cin >> a;
            all[a]++;
        }
        for (ll i = 0; i < 1001; i++)
            if (all[i] > 0)
                for (ll j = i; j < 1001; j++) {
                    if (all[j] <= 0)
                        continue;
                    if (i == j && (all[i] * (all[i] - 1)) % 4 != 0)
                        res = res xor (i + j);
                    else if (i != j && (all[i] * all[j]) % 2 != 0)
                        res = res xor (i + j);
                }
        cout << res;
        return 0;
    }
    vector <ll> a(n);
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    ll res = 0;
    for (ll i = 0; i < n; i++)
        for (ll j = i + 1; j < n; j++)
            res = res xor (a[i] + a[j]);
    cout << res;
    return 0;
}