#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

unordered_map<ll, ll> cnt;

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        ll a;
        cin >> a;
        cnt[a]++;
    }
    vector<ll> b;
    b.reserve(n);
    forEach(cnt) if (it.S % 2) b.pb(it.F);
    ll ans = 0;
    forEach(cnt) if (it.S * (it.S - 1) / 2 % 2) ans ^= 2 * it.F;
    for (ll i = 0; i < b.size(); i++) {
        for (ll j = i + 1; j < b.size(); j++) {
            ans ^= b[i] + b[j];
        }
    }
    cout << ans << "\n";
}

int main() {
    FASTIO
    solve();
    return 0;
}