#include<bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;

const int MAXN = 4e5 + 5;
const int LOG = 25;
const int MAXC = 1e7 + 5;

int a[MAXN];
int n;

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

vector<int> renum;
int tree0[MAXC];
int tree1[MAXC];

void update(int i, int tree[]) {
	++i;
	for (int ind = i; ind < MAXC - 1; ind += ind & (-ind)) {
		tree[ind]++;
	}
}

int get_sum(int r, int tree[]) {
	++r;
	int res = 0;
	for (int i = r; i > 0; i -= i & (-i)) {
		res += tree[i];
	}
	return res;
}

void solve2() {
	int res = 0;
	for (int bit = 0; bit < 25; ++bit) {
		memset(tree0, 0, sizeof tree0);
		memset(tree1, 0, sizeof tree1);
		int maxnum = min((1 << (bit + 1)), MAXC - 1);
		//cout << "bit: " << bit << endl;
		for (int j = 0; j < n; ++j) {
			//cout << "j: " << j << endl;
			if (check_bit(a[j], bit)) {
				//zero
				int l = 0, r = maxnum;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = mid + a[j];
					if (check_bit(sum, bit)) l = mid;
					else r = mid;
				}
				int cur = get_sum(l, tree0);
				if (cur % 2) res ^= (1 << bit);
				// one
				 l = 0; r = maxnum;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = mid + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				cur = get_sum(maxnum - 1, tree1) - get_sum(r - 1, tree1);
				if (cur % 2) res ^= (1 << bit);
				int val = (a[j] & ((1 << (bit + 1)) - 1));
				update(val, tree1);
				//cout << "upd: " << val << endl;
				//ones.push_back(a[j] & ((1 << (bit + 1)) - 1));
			} else {
				// zeros
				int l = 0, r = maxnum;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = mid + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				int cur = get_sum(maxnum - 1, tree0) - get_sum(r - 1, tree0);
				if (cur % 2) res ^= (1 << bit);
				// ones
				l = 0; r = maxnum;
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = mid + a[j];
					if (check_bit(sum, bit)) l = mid;  
					else r = mid;
				}
				//cout << "R: " << l << endl;
				cur = get_sum(l, tree1);
				//cout << "sum: " << cur << endl;
				if (cur % 2) res ^= (1 << bit);
				int val = (a[j] & ((1 << (bit + 1)) - 1));
				update(val, tree0);
				//cout << "upd: " << val << endl;
				//zeros.push_back(a[j] & ((1 << (bit + 1)) - 1));
			}
			//cout << "res: " << res << endl;
		}
		//cout << "res: " << res << endl;
	}
	cout << res << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		renum.push_back(a[i]);
	}
	/*sort(renum.begin(), renum.end());
	renum.resize(int(unique(renum.begin(), renum.end()) - renum.begin()));
	for (int i = 0; i < n; ++i) {
		int ind = int(lower_bound(renum.begin(), renum.end(), a[i]) - renum.begin());
		a[i] = ind;
	}*/
	solve2();
	//if (n <= 1000) solve();
	//else solve1();
	return 0;
}