#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(i, a.size()) cout << a[i] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x
#define ff first
#define ss second
#define sz(a) (a).size()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef long double ld;

#define int ll

int stupsol(vi &a){
    int n = sz(a);
    int ans = 0;
    for(int i = 0; i < n; ++i){
        int tans = 0;
        for(int j = i + 1; j < n; ++j){
            tans ^= a[i] + a[j];
        }
        ans ^= tans;
    }
    return ans;
}

bool get_bit(int a, int i){
    return (a & (1 << i));
}

void run() {
    int n;
    cin >> n;
    vi a(n);
    cinm(a);
   // cout << stupsol(a) << '\n';
    int cnt_next = 0;
    bitset <26> t;
    int sum = 0;
    int prev1 = 0;
    for(int bitnum = 1; bitnum <= 25; ++bitnum){
        int cnt00 = 0;
        int cnt01 = 0;
        int cnt10 = 0;
        int cnt11 = 0;
        for(int i = 0; i < n; ++i){
            cnt00 += !get_bit(a[i], bitnum) && !get_bit(a[i], bitnum - 1);
            cnt01 += !get_bit(a[i], bitnum) && get_bit(a[i], bitnum - 1);
            cnt10 += get_bit(a[i], bitnum) && !get_bit(a[i], bitnum - 1);
            cnt11 += get_bit(a[i], bitnum) && get_bit(a[i], bitnum - 1);
        }
        int cnt = (cnt01) * (cnt01 - 1) / 2;
        cnt += (cnt10) * (cnt01);
        cnt += (cnt10) * (cnt00);
        cnt += (cnt11) * (cnt00);
        cnt += cnt11 * (cnt11 - 1) / 2;
        cnt += cnt_next;
        cnt_next = (cnt01 * cnt11 + cnt10 * (cnt10 - 1) / 2 +cnt10 * cnt11);
        t.set(bitnum, cnt % 2);
    }
    int cnt1 = 0;
    for(int i = 0; i < n; ++i){
        cnt1 += get_bit(a[i], 0);
    }
    t.set(0, cnt1 % 2);
    cout << t.to_ulong() << '\n';
   // cout << t;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
}