#include <iostream>
#include <vector>
#include <map>

using namespace std;

void solve (vector <int> line) {
    int ans = 0;
    for (int i = 0; i < (int) line.size(); i++)
        for (int j = 0; j < i; j++)
            ans ^= line[i] + line[j];

    cout << ans << endl;
}


int main() {
    int n;
    cin >> n;

    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (n <= 1000) {
        solve(line);
        return 0;
    }

    map <int, int> cnt;
    for (int i : line) {
        cnt[i]++;
    }

    for (auto& i : cnt) {
        i.second %= 4;
    }

    vector <int> new_line;
    for (auto& i : cnt)
        while (i.second) {
            new_line.push_back(i.first);
            i.second--;
        }
    solve(new_line);
    return 0;
}
