#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int log_n = 23;
const int MAXA = (1 << log_n);

int rev(int &x)
{
    int res = 0;
    for(int i = 0; i < log_n; i++)
        if(x & (1 << i))
            res |= (1 << (log_n - 1 - i));

    return res;
}

const double PI = acos(-1);

struct base{

    double x, y;
    base() {x = 0; y = 0;}
    base(double _x, double _y)
    {
        x = _x;
        y = _y;
    }
};

base mult(base a, base b)
{
   return base(a.x * b.x - a.y * b.y, a.x * b.y + a.y * b.x);
}

base add(base a, base b)
{
    return base(a.x + b.x, a.y + b.y);
}

base sub(base a, base b)
{
    return base(a.x - b.x, a.y - b.y);
}

void di(base &a, double x)
{
    a.x = a.x / x;
    a.y = a.y / x;
}

base a[MAXA];
void FFT(bool invert)
{
    int n = MAXA, log_n = 24;

    int x;
    for(int i = 0; i < n; i++)
    {
        int x = rev(i);
        if(i < x)
            swap(a[i], a[x]);
    }

    for(int len = 2; len <= n; len *= 2)
    {
        double ang = ( 2 * PI / len) * (invert ? -1 : 1);
        base wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len)
        {
            base w(1, 0);
            for(int j = 0; j < len / 2; j++)
            {
                base u = a[i + j], v = mult(a[i + j + len / 2], w);
                a[i + j] = add(u, v);
                a[i + j + len / 2] = sub(u, v);
                w = mult(w, wlen);
            }
        }
    }

    if(invert)
        for(int i = 0; i < n; i++)
            di(a[i], n);
}

void mult()
{
    FFT(0);
    for(int i = 0; i < MAXA; i++)
        a[i] = mult(a[i], a[i]);
    FFT(1);
}


int n;
int inp[400005];

void dumb_sol()
{
    for(int i = 1; i <= n; i++)
        cin >> inp[i];
    int ans = 0;
    for(int i = 1; i <= n; i++)
        for(int j = i + 1; j <= n; j++)
            ans ^= (inp[i] + inp[j]);

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int x;

    cin >> n;
//    if(n <= 1000)
//    {
//        dumb_sol();
//        return 0;
//    }
    for(int i = 1; i <= n; i++)
    {
        cin >> inp[i];
        a[inp[i]].x++;
    }

    mult();
    for(int i = 1; i <= n; i++)
        a[2 * inp[i]].x--;

    int ans = 0;
    for(int i = 0; i < MAXA; i++)
        if(((int)(a[i].x + 0.5) / 2) & 1)
            ans ^= i;

    cout << ans << endl;

    return 0;
}

/*

3
1 2 3

*/
