#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

void Solve() {
	int n, m;
	cin >> n >> m;
	vector <int> agressive(n);
	vector <int> cost(n);
	for (int i = 0; i < n; i++) {
		cin >> agressive[i];
		agressive[i]--;
	}
	for (int i = 0; i < n; i++) cin >> cost[i];
	vector <int> bonus(n + m);
	for (int i = 0; i < n + m; ++i) cin >> bonus[i];
	long long ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		long long res = 0;
		vector <int> now(n + m + 10);
		int prev = 1e9;
		for (int j = 0; j < n; j++) {
			if (mask & (1 << j)) {
				if (agressive[j] > prev)
					res -= 2e9;
				prev = agressive[j];
				res -= cost[j];
				res += bonus[agressive[j]];
				now[agressive[j]]++;
			}
			for (int i = 0; i < now.size(); i++) {
				if (now[i] > 1) {
					now[i] -= 2;
					now[i + 1]++;
					res += bonus[i + 1];
				}
			}
		}
		ans = max(ans, res);
	}
	cout << ans;
}

int main() {
	IOOptimize();
	Solve();
}