#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif // DEBUG
#include <bits/stdc++.h>
using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
typedef unsigned long long ull;
//#define int long long

void solve1(int n, int m) {
    vector<int> c(n + m);
    vector<pair<int, int>> a(n);
    for (auto &i : a)
        cin >> i.second;
    for (auto &i : a)
        cin >> i.first;

    for (int &i : c)
        cin >> i;

    sort(all(a));
    int cost = 0, ans = 0;

    for (int i = 0; i < n; ++i) {
        cost += a[i].first;
        int res = 0;
        for (int j = 0; (i + 1) / (1 << j) > 0; ++j) {
            res += c[j] * ((i + 1) / (1 << j));
        }
        ans = max(ans, res - cost);
    }
    cout << ans;
}

bool find(int mask, int x) {
    return ((mask & (1 << x)) != 0);
}

int calc(vector<int> &a, vector<int> &cost) {
    int res = 0;
    set<int> now;

    for (int i : a) {
        res += cost[i - 1];
        while (now.find(i) != now.end()) {
            now.erase(i);
            i++;
            res += cost[i - 1];
        }
        now.emplace(i);
    }

    return res;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);cin.tie(0);
#endif // DEBUG

    int n, m;
    cin >> n >> m;
    if (m == 1) {
        solve1(n, m);
        return 0;
    }
    vector<int> a(n), cost(n), profit(n + m);
    for (int &i : a)
        cin >> i;
    for (int &i : cost)
        cin >> i;
    for (int &i : profit)
        cin >> i;

    int ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        int cur_cost = 0;
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            if (find(mask, i)) {
                cur_cost += cost[i];
                st.emplace_back(a[i]);
            }
        }

        bool fl = 0;
        for (int i = 1; i < st.size(); ++i) {
            if (st[i - 1] < st[i]) {
                fl = 1;
                break;
            }
        }
        if (fl)
            continue;
/*
        for (int i : st)
            cout << i << ' ';
        cout << endl << calc(st, profit) << ' ' << cur_cost << endl << endl;
*/
        ans = max(calc(st, profit) - cur_cost, ans);
    }
    cout << ans;
    return 0;
}
