#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> agr(n), cost(n), vals(n + m + 1);
    for (int i = 0; i < n; ++i)
        cin >> agr[i];
    for (int i = 0; i < n; ++i)
        cin >> cost[i];
    for (int i = 0; i < n + m; ++i)
        cin >> vals[i + 1];
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask)  {
        int st = m;
        bool skip = false;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask) {
                if (agr[i] > st)
                    skip = true;
                st = min(st, agr[i]);
            }
        if (skip)
            continue;
        int mins = 0;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask)
                mins += vals[agr[i]] - cost[i];
        vector<int> in;
        for (int i = 0; i < n; ++i)
            if ((1 << i) & mask)
                in.push_back(agr[i]);
        sort(in.rbegin(), in.rend());
        while (!in.empty()) {
            int it = in.back();
            in.pop_back();
            if (in.size() == 0)
                continue;
            int n1 = in.back();
            in.pop_back();
            if (n1 != it)
                in.push_back(n1);
            else {
                in.push_back(n1 + 1);
                mins += vals[n1 + 1];
            }
        }
        ans = max(ans, mins);
    }
    cout << ans << '\n';
}
#define DEBUGs

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
