#include <bits/stdc++.h>

using namespace std;

void solve1(int n, int m, vector<int>& hit, vector<int>& up, vector<int>& cost) {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int res = 0;
        bool can = true;
        vector<int> stack;
        int prev = m;
        for (int i = 0; i < n; ++i)
            if ((mask >> i) & 1) {
                res += cost[hit[i] - 1] - up[i];
                int fight = hit[i];
                can &= prev >= hit[i];
                prev = hit[i];
                while (!stack.empty() && stack.back() == fight) {
                    stack.pop_back();
                    ++fight;
                    res += cost[fight - 1];
                }
                stack.push_back(fight);
            }
        if (can)
            ans = max(ans, res);
    }
    cout << ans;
    exit(0);
}

void solve2(int n, int m, vector<int>& hit, vector<int>& up, vector<int>& cost) {
    sort(up.begin(), up.end());
    int in = 0, ans = 0;
    for (int i = 0; i < n; ++i) {
        in += up[i];
        int res = -in, cnt = i + 1, j = 0;
        while (cnt) {
            res += cnt * cost[j];
            cnt /= 2;
            ++j;
        }
        ans = max(ans, res);
    }
    cout << ans;
    exit(0);
}

int32_t main() {
    int n, m;
    cin >> n >> m;
    vector<int> hit(n), up(n), cost(n + m);
    for (int i = 0; i < n; ++i)
        cin >> hit[i];
    for (int i = 0; i < n; ++i)
        cin >> up[i];
    for (int i = 0; i < n + m; ++i)
        cin >> cost[i];
    if (n <= 15 && m <= 15)
        solve1(n, m, hit, up, cost);
    if (m == 1)
        solve2(n, m, hit, up, cost);
    return 0;
}
