#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;


int n, m;
vector <int> l, s, c;
vector <vector <int> > dp;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    l.assign(n, 0);
    s.assign(n, 0);
    c.assign(n + m, 0);

    for (int& x: l)
        cin >> x;
    for (int& x: s)
        cin >> x;
    for (int& x: c)
        cin >> x;
    c.insert(c.begin(), 0);

    dp.assign(n + m + 1, vector <int>(n + m + 1, -2e9));
    dp[n + m][n + m] = 0;

    for (int i = 0; i < n; i++) {
        auto ndp = dp;

        for (int prev = l[i] + 1; prev <= n + m; prev++)
            ndp[l[i]][l[i]] = max(ndp[l[i]][l[i]], dp[prev][prev] + c[l[i]] - s[i]);

        for (int prev = l[i] + 1; prev <= n + m; prev++)
            ndp[prev][prev] = max(ndp[prev][prev], dp[l[i]][prev] + c[l[i]] - s[i]);

        for (int prev = l[i] + 2; prev <= n + m; prev++)
            ndp[l[i]][l[i] + 1] = max(ndp[l[i]][l[i] + 1], dp[prev][prev] + c[l[i] + 1]
                                        + c[l[i]] - s[i]);

        for (int prev = l[i] + 2; prev <= n + m; prev++)
            ndp[l[i]][prev] = max(ndp[l[i]][prev], dp[l[i] + 1][prev] + c[l[i] + 1]
                                  + c[l[i]] - s[i]);

        dp = ndp;
    }

    int ans = -2e9;
    for (int i = 1; i <= n + m; i++)
        ans = max(ans, dp[i][i]);

    cout << ans;
    return 0;
}
