#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;

signed main() {
	FAST_IO();
	int n, m;
	cin >> n >> m;
	vector<int> l(n), s(n), c(n + m);
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		l[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n + m; ++i) {
		cin >> c[i];
	}
	int mx = (1 << (m - 1)) * n + 1;
	int dp[2][mx][m];
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < mx; ++j) {
			for (int k = 0; k < m; ++k) {
				dp[i][j][k] = -INF;
			}
		}
	}
	int ff = 0, ss = 1;
	dp[ff][0][m - 1] = 0;
	dp[ff][(1 << l[0])][l[0]] = c[l[0]] - s[0];
	for (int i = 1; i < n; ++i) {
		for (int cnt = 0; cnt < mx; ++cnt) {
			for (int k = 0; k < m; ++k) {
				if (dp[ff][cnt][k] == -INF) {
					continue;
				}
				dp[ss][cnt][k] = max(dp[ss][cnt][k], dp[ff][cnt][k]);
				if (l[i] > k) {
					continue;
				}
				int ncnt = cnt;
				int cur = l[i];
				int add = -s[i];
				while (true) {
					add += c[cur];
					if (ncnt & (1 << cur)) {
						ncnt ^= (1 << cur);
						cur++;
					}
					else {
						ncnt |= (1 << cur);
						break;
					}
				}
				dp[ss][ncnt][l[i]] = max(dp[ss][ncnt][l[i]], dp[ff][cnt][k] + add);
			}
		}
		swap(ff, ss);
		for (int cnt = 0; cnt < mx; ++cnt) {
			for (int k = 0; k < m; ++k) {
				dp[ss][cnt][k] = -INF;
			}
		}
	}
	int ans = 0;
	for (int j = 0; j < mx; ++j) {
		for (int k = 0; k < m; ++k) {
			ans = max(ans, dp[ff][j][k]);
		}
	}
	cout << ans << '\n';
}