#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back
#define int long long

pair<set<int>, int> get(set<int> st, int sum, int curr, vector<int> &angry, vector<int> &pay, vector<int> &cost){
    int ans = sum - pay[curr] + cost[angry[curr]];
    int add = angry[curr];
    while (st.find(add) != st.end()){
        st.erase(add);
        add++;
        ans += cost[add];
    }
    st.insert(add);
    return {st, ans};
}

signed main(){
    //freopen("inp", "r", stdin);
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<int> angry(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> angry[i];
    angry[0] = 1e9;
    vector<int> pay(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> pay[i];
    vector<int> cost(n + m + 1);
    for (int i = 1; i <= n + m; i++)
        cin >> cost[i];

    vector<vector<int>> bigger(n + 1);
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < i; j++)
            if (angry[j] >= angry[i])
                bigger[i].pb(j);
    }

//    for (auto v : bigger){
//        for (int el : v)
//            cout << el << " ";
//        cout << endl;
//    }

    vector<vector<pair<set<int>, int>>> dp(n + 1);
    dp[0] = {{{}, 0}};
    int pos, val, ans = 0;
    for (int i = 1; i <= n; i++){
        for (int el : bigger[i]){
            for (auto &opt : dp[el]){
                dp[i].eb(get(opt.ft, opt.sd, i, angry, pay, cost));
                if (dp[i].back().sd > ans)
                    ans = dp[i].back().sd;
            }
        }
    }

    cout << ans;

    return 0;
}