#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)4e3 + 1;

int n, m, l[N], s[N], c[N];

void solve0() {
    int ans = 0;
    rep(1 << n, mask) {
        int cur = 0, prev_ = m;
        bool f = true;
        rep(n, i) {
            if (mask >> i & 1) {
                if (prev_ < l[i]) {
                    f = false;
                    break;
                }
                prev_ = l[i];
                cur -= s[i];
            }
        }
        if (!f) {
            continue;
        }
        vector <bool> used(n + m + 1, false);
        rep(n, i) {
            if (mask >> i & 1) {
                cur += c[l[i]];
                int ind = l[i];
                while (used[ind]) {
                    used[ind] = false;
                    ++ind;
                    cur += c[ind];
                }
                used[ind] = true;
            }
        }
        ans = max(ans, cur);
    }
    printf("%d", ans);
}

bool cmp(int a, int b) {
    return s[a] < s[b];
}

void solve1() {
    vector <int> inds(n, 0), sequence_plus(n, 0);
    if (n > 1) {
        sequence_plus[1] = c[2];
        int i = 2, ind_c = 3;
        while (i < n) {
            rep(i - 1, j) {
                if (i + j >= n) {
                    break;
                }
                sequence_plus[i + j] = sequence_plus[j];
            }
            i += i - 1;
            if (i < n) {
                sequence_plus[i] = sequence_plus[(i + 1) / 2 - 1] + c[ind_c];
                ++i;
                ++ind_c;
            }
        }
    }
    rep(n, i) {
        inds[i] = i;
    }
    sort(allv(inds), cmp);
    int ans = 0, cur = 0;
    rep(n, i) {
        cur -= s[i];
        cur += c[l[i]];
        cur += sequence_plus[i];
        ans = max(ans, cur);
    }
    printf("%d", ans);
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d", &n, &m);
    rep(n, i) {
        scanf("%d", &l[i]);
    }
    rep(n, i) {
        scanf("%d", &s[i]);
    }
    rep(n + m, i) {
        scanf("%d", &c[i + 1]);
    }
    if (n <= 15 && m <= 15) {
        solve0();
    } else if (m == 1) {
        solve1();
    }
    return 0;
}