#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

#define int int64_t

int n, m;
vector<int> agre;
vector<int> cost;
vector<int> prib;

void solve1()
{
	vector<int> ar4(n, 0);
	vector<int> ar5(n + m, 0);
	int ans = 0;
	for (int i = 0; i < (1 << n); ++i)
	{
		int agr = 1e9;
		int a = i;
		int lokans = 0;
		ar4 = vector<int>(n, 0);
		ar5 = vector<int>(n + m, 0);
		int cnt = 0;
		int per = 0;
		while (a > 0)
		{
			ar4[cnt] = (a % 2);
			cnt++;
			a /= 2;
		}
		for (int j = 0; j < n; ++j)
		{
			if (ar4[j] == 1 && agre[j] > agr)
			{
				per = 1;
				break;
			}
			if (ar4[j] == 1)
			{
				lokans -= cost[j];
				agr = min(agr, agre[j]);
			}
		}
		if (per == 1)
			continue;
		for (int j = 0; j < n; ++j)
		{
			if (ar4[j] == 1)
			{
				ar5[agre[j]] += 1;
				lokans += prib[agre[j]];
			}
		}
		for (int j = 0; j < n + m - 1; ++j)
		{
			lokans += prib[j + 1] * (ar5[j] / 2);
			ar5[j + 1] += (ar5[j] / 2);
		}
		ans = max(ans, lokans);
	}
	cout << ans << endl;
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		a--;
		agre.push_back(a);
	}
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		cost.push_back(a);
	}
	for (int i = 0; i < n + m; ++i)
	{
		int a;
		cin >> a;
		prib.push_back(a);
	}
	if (n <= 15 && m <= 15)
		solve1();

}