#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 2000;

int n, m, ans;
int l[MAXN + 5], s[MAXN + 5], c[2 * MAXN + 5];

void rec(int i, int Min, int sum, vector<int> people)
{
    if (i == n)
    {
        ans = max(ans, sum);
        return;
    }

    rec(i + 1, Min, sum, people);

    if (l[i] <= Min)
    {
        int a = l[i];
        Min = min(Min, a);
        people[a]++;
        sum += c[a] - s[i];
        while (people[a] > 1)
        {
            people[a] = 0;
            a++;
            people[a]++;
            sum += c[a];
        }
        rec(i + 1, Min, sum, people);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 0; i < n; ++ i)
        cin >> l[i];

    for (int i = 0; i < n; ++ i)
        cin >> s[i];

    for (int i = 1; i <= n + m; ++ i)
        cin >> c[i];

    if (m == 1)
    {
        sort(s, s + n);
        vector<int> people(4096, 0);
        int anss = 0;
        int sum = 0, sum1 = 0, i = 0;
        while (i < n)
        {
            sum += c[1] - s[i];
            int a = 1;
            people[a]++;
            while (people[a] > 1)
            {
                people[a] = 0;
                a++;
                people[a]++;
                sum += c[a];
            }
            anss = max(anss, sum);
            i++;
        }
        cout << anss << endl;
        return 0;
    }

    vector<int> v(4096, 0);
    rec(0, 5000, 0, v);

    cout << ans << endl;

    return 0;
}
