#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 2010;
const int INF = 1e9 + 228;
int n, m, l[mx], s[mx], c[mx];

void add(set<int> &S, int val, int &res) {
	if (S.find(val) != S.end()) {
		S.erase(val);
		res += c[val + 1];
		add(S, val + 1, res);
	} else {
		S.insert(val);
	}
}

signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	int ans = 0;
	for (int sub = 0; sub < (1 << n); ++sub) {
		set<int> S;
		int res = 0, last_l = m;
		for (int i = 0; i < n; ++i) {
			if ((sub >> i) & 1) {
				if (last_l < l[i]) {
					res = -INF;
					break;
				}
				res -= s[i];
				res += c[l[i]];
				add(S, l[i], res);
				last_l = l[i];
			}
		}
		// cerr << sub << " " << res << endl;
		chkmax(ans, res);
	}
	cout << ans << endl;
}
