#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <random>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long


int32_t main() 
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
   
    int n, m;
    cin >> n >> m;
    vector<int> l(n);
    vector<int> s(n);
    vector<int> c(n + m + 1);
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i + 1];

    if (n <= 15 && m <= 15)
    {
        int ans = 0;
        for (int i = 0; i < (1ll << n); i++)
        {
            vector<int> all;
            for (int j = 0; j < n; j++)
            {
                if (i & (1ll << j)) all.push_back(j);
            }
            bool flag = false;
            for (int i = 1; i < all.size(); i++)
            {
                if (l[all[i]] > l[all[i - 1]])
                {
                    flag = true;
                    break;
                }
            }
            if (flag) continue;
            int curr = 0;
            vector<int> temp;
            for (auto i : all)
            {
                curr += c[l[i]] - s[i];
                temp.push_back(l[i]);
            }
            sort(all(temp));
            int l = 0, r = temp.size();
            while (r - l > 1)
            {
                if (temp[l] != temp[l + 1])
                {
                    l++;
                    continue;
                }
                curr += c[temp[l] + 1];
                l++;
                temp[l]++;
            }
            ans = max(ans, curr);
        }
        cout << ans;
        return 0;
    }

    if (m == 1)
    {
        sort(all(s));
        int ans = 0, curr, pref = 0;
        for (int i = 0; i < n; i++)
        {
            pref += s[i];
            curr = -pref + (i + 1) * c[1];
            int now = i + 1, ind = 2;
            while (now > 1)
            {
                now /= 2;
                curr += now * c[ind++];
            }
            ans = max(ans, curr);
        }
        cout << ans;
        return 0;
    }
    return 0;
}
