#include <bits/stdc++.h>

const int64_t MAX_N = 2000;
const int64_t MAX_M = 20;

int64_t n, m, l[MAX_N + 5], s[MAX_N + 5], c[MAX_N + MAX_M + 5];
std::unordered_map< int64_t, int64_t > dp[MAX_N + 5];

int64_t calc_dp(int64_t ind, int64_t mask) {
	if(ind == n) {
		return 0;
	}
	else if(dp[ind].count(mask) != 0) {
		return dp[ind][mask];
	}

	int64_t curr = 0;
	while((1 << curr) <= mask) {
		if((mask & (1 << curr)) != 0) {
			break;
		}
		curr++;
	}

	curr++;
	
	dp[ind][mask] = calc_dp(ind + 1, mask);
	if(l[ind] > curr && mask != 0) {
		return dp[ind][mask];
	}

	curr = l[ind] - 1;
	int64_t oldMask = mask;
	int64_t currAns = -s[ind] + c[l[ind]];
	while((mask & (1 << curr)) != 0) {
		mask ^= (1 << curr);
		curr++;
		currAns += c[curr + 1];
	}

	mask += (1 << curr);

	currAns += calc_dp(ind + 1, mask);

	dp[ind][oldMask] = std::max(dp[ind][oldMask], currAns);

	return dp[ind][oldMask];
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m;

	for(int64_t i = 0; i < n; i++) {
		std::cin >> l[i];
	}

	for(int64_t i = 0; i < n; i++) {
		std::cin >> s[i];
	}

	for(int64_t i = 1; i <= n + m; i++) {
		std::cin >> c[i];
	}	

	std::cout << calc_dp(0, 0) << '\n';
}