#include <bits/stdc++.h>

const int32_t MAX_N = 2000;
const int32_t MAX_M = 20;

int32_t n, m, l[MAX_N + 5], s[MAX_N + 5], c[MAX_N + MAX_M + 5];
std::unordered_map< int32_t, int64_t > dp[MAX_N + 5][MAX_M + 5];

int64_t calc_dp(int32_t ind, int32_t minAccepted, int32_t mask) {
	if(ind == n) {
		return 0;
	}
	else if(dp[ind][minAccepted].count(mask) != 0) {
		return dp[ind][minAccepted][mask];
	}
	
	dp[ind][minAccepted][mask] = calc_dp(ind + 1, minAccepted, mask);
	if(l[ind] > minAccepted) {
		return dp[ind][minAccepted][mask];
	}

	int32_t curr = l[ind] - 1;
	int32_t oldMask = mask;
	int64_t currAns = -s[ind] + c[l[ind]];
	while((mask & (1 << curr)) != 0) {
		mask ^= (1 << curr);
		curr++;
		currAns += c[curr + 1];
	}

	mask += (1 << curr);

	currAns += calc_dp(ind + 1, std::min(minAccepted, l[ind]), mask);

	dp[ind][minAccepted][oldMask] = std::max(dp[ind][minAccepted][oldMask], currAns);

	return dp[ind][minAccepted][oldMask];
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m;

	for(int32_t i = 0; i < n; i++) {
		std::cin >> l[i];
	}

	for(int32_t i = 0; i < n; i++) {
		std::cin >> s[i];
	}

	for(int32_t i = 1; i <= n + m; i++) {
		std::cin >> c[i];
	}	

	std::cout << calc_dp(0, m + 1, 0) << '\n';
}