#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 2000;
const int MAXC = 5000;

const int INF = 1000000000;

int n, m;
int l[MAXN], s[MAXC], c[2 * MAXN + 7];

int tr(int mask) {
    vector<int> part;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            if (!part.empty() && part.back() < l[i]) {
                return -INF;
            }
            part.push_back(l[i]);
            ans -= s[i];
            ans += c[l[i]];
        }
    }
    while (!part.empty()) {
        int k = part.back();
        int cnt_k = 1;
        part.pop_back();
        while (!part.empty() && part.back() == k) {
            ++cnt_k;
            part.pop_back();
        }
        ans += c[k + 1] * (cnt_k / 2);
        for (int i = 0; i < cnt_k / 2; ++i) {
            part.push_back(k + 1);
        }
    }
    return ans;
}

void solve1() {
    int ans = -INF;
    for (int mask = 0; mask < 1 << n; ++mask) {
        ans = max(ans, tr(mask));
    }
    cout << ans << '\n';
}

int e5[207][2007][2007];

void solve() {

}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    if (n <= 15) {
        solve1();
        return 0;
    }
    return 0;
}