#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <math.h>
#include <map>
#include <set>

using namespace std;

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;

vector <int> L;
vector <int> s;
vector <int> c;
int n, m; 

vector <bool> use;
vector <int> cnt;

int check() {

	int D = 0, M1 = 0, M2 = 0;
	FR(i, n) if (use[i]) D += s[i], M1 += c[L[i]];

	FR(i, n + m + 1) cnt[i] = 0;
	FR(i, n) if (use[i]) cnt[L[i]]++;

	FR(i, n + m + 1) {
		
		cnt[i + 1] += cnt[i] / 2;
		if (cnt[i] > 1) M2 += c[i + 1] * (cnt[i] / 2);

	}


	return M1 + M2 - D;
}

int rec(int step, int mn) {

	if (step == n) return check();
	//else if (step == n) return -1e9;

	if (L[step] > mn) return rec(step + 1, mn);
	
	int ans = rec(step + 1, mn);
	
	use[step] = 1;
	mn = min(mn, L[step]);
	//if (mx == 1e9) mx = L[step];
	ans = max(ans, rec(step + 1, mn));

	use[step] = 0;

	return ans;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> n >> m;

	use.resize(n, 0);
	cnt.resize(n + m + 2);
	L.resize(n); FR(i, n) cin >> L[i];
	s.resize(n); FR(i, n) cin >> s[i];
	c.resize(n + m + 1); FOR(i, 1, n + m) cin >> c[i];
	
	if (n <= 15) {
		

		cout << rec(0, 1e9);
	}
	else {
	
		vector <int> dlt(n + m + 2);
		sort(all(s));

		int ans = 0; int sm = 0;
		FR(i, n) {
		
			sm += s[i];
		
			int pans = 0;
			int x = i + 1;
			pans += c[1] * x;

			int j = 1;
			while (x > 0) {
			
				pans += c[j + 1] * (x / 2);
				x /= 2;
				j++;

			}

			pans -= sm;
			ans = max(ans, pans);

		}

		cout << ans;

	}

	return 0;

}