#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e18;

int n, m;
int agr[N];
int c[N];
int add[N];

bool check(vector<int>& v)
{
    int p = inf;

    for (auto i : v)
        if (agr[i] > p)
            return false;
        else
            p = min(p, agr[i]);

    return true;
}

int calc(vector<int>& v)
{
    if (!check(v))
        return false;

    set<int> agrs;

    int res = 0;

    vector<int> agr(n + m + 1);

    for (int i = 0; i < n; ++i)
        agr[i] = ::agr[i];

    for (auto i : v)
    {
        res += add[agr[i]];
        res -= c[i];

        if (agrs.find(agr[i]) == agrs.end())
            agrs.insert(agr[i]);
        else
        {
            while (true)
            {
                agrs.erase(agr[i]);
                ++agr[i];
                res += add[agr[i]];

                if (agrs.find(agr[i]) == agrs.end())
                {
                    agrs.insert(agr[i]);
                    break;
                }
            }
        }
    }

    return res;
}

int32_t main()
{
    cin >> n >> m;

    for (int i = 0; i < n; ++i)
        cin >> agr[i];

    for (int i = 0; i < n; ++i)
        cin >> c[i];

    for (int i = 1; i <= n + m; ++i)
        cin >> add[i];

    int ans = 0;

    for (int msk = 0; msk < (1ll << n); ++msk)
    {
        vector<int> tmp;

        for (int b = 0; b < n; ++b)
            if ((1ll << b) & msk)
                tmp.push_back(b);

        ans = max(ans, calc(tmp));
    }

    cout << ans << endl;
}
