#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <random>
#include <algorithm>
#include <math.h>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

#define int long long


#define mp(a, b) make_pair(a, b)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define endl '\n'

typedef long long ll;
using namespace std;

mt19937 mrand(random_device{}());

const double PI = acos(double(-1));
const double eps = 1e-7;
const ll inf0 = 1023 * 1024 * 1024;
const ll inf = inf0 * inf0;

void solve();
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	cout.precision(15); cout << fixed;
	solve();
	return 0;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> l(n);
	vector<int> s(n);
	for (int &i : l) cin >> i;
	for (int &i : s) cin >> i;
	vector<int> c(n + m);
	for (int &i : c) cin >> i;
	reverse(all(c)); c.push_back(0); reverse(all(c));
	if (n <= 15) {
		int ans = 0;
		for (int mask = 0; mask < (1 << n); mask++) {
			int cur = 0;
			vector<int> f;
			int last = -1;
			for (int i = 0; i < n; i++) {
				if ((1 << i) & mask) {
					if (last != -1 && l[i] > l[last]) {
						cur = 0;
						break;
					} else {
						last = i;
						cur += c[l[i]] - s[i];
						f.push_back(l[i]);
						while (f.size() >= 2) {
							int v = f.back();
							f.pop_back();
							if (v == f.back()) {
								f.back()++;
								cur += c[f.back()];
							} else {
								f.push_back(v);
								break;
							}
						}
					}
				}
			}
			ans = max(ans, cur);
		}
		cout << ans << endl;
	} 
}