#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


const int MAXM = 16;
const int MAXN = 2000;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> a(n), s(n), c(n + m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];

        --a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    for (int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }

    reverse(a.begin(), a.end());
    reverse(s.begin(), s.end());

    if (n <= 15) {
        int answ = 0;

        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<int> take(n);
            int cm = mask;
            for (int i = 0; i < n; ++i) {
                take[i] = cm % 2;

                cm /= 2;
            }

            vector<int> tcnt(n + m + 1);
            int last = 0;
            int cur = 0;

            bool can = true;
            for (int i = 0; i < n; ++i) {
                if (!take[i]) {
                    continue;
                }

                if (a[i] < last) {
                    can = false;

                    break;
                }

                last = a[i];

                ++tcnt[a[i]];
                cur -= s[i];
            }

            if (!can) {
                continue;
            }

            for (int i = 0; i < n + m; ++i) {
                cur += tcnt[i] * c[i];

                tcnt[i + 1] += tcnt[i] / 2;
            }

            if (cur > answ) {
                answ = cur;
            }
        }

        cout << answ;
    }

    return 0;
}
