#include "bits/stdc++.h"

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>
#define mx(a, b) a = max(a, b)
const ll MAXN = 201;
const ll inf = (ll)1e18;

using namespace std;

template<class T>
void read(vector<T> &a) {
    for (auto &i : a) cin >> i;
}

template<class T>
void write(vector<T> &a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

ll dp[MAXN][MAXN][2];

void solve() {
    int n, m; cin >> n >> m;
    vi a(n); read(a);
    for (int i = 0; i < n; ++i) a[i]--;
    vi s(n); read(s);
    vi b(n + m); read(b);
    vi pref(n + m); pref[0] = b[0];
    for (int i = 1; i < n + m; ++i) {
        pref[i] = pref[i - 1] + b[i];
    }
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            dp[i][j][0] = -inf;
            dp[i][j][1] = -inf;
        }
    }
    dp[0][0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int k = 0; k < i; ++k) {
            for (int j = 0; j <= n; ++j) {
                if (k > 0 && a[k - 1] == a[i - 1] && dp[k][j][0] != -inf) {
                    dp[i][0][1] = mx(dp[i][0][1], dp[k][j][0] + pref[a[k - 1] + j + 1] - pref[a[k - 1]] + b[a[i - 1]] - s[i - 1]);
                } else if ((!k || a[i - 1] < a[k - 1] - 1) && dp[k][j][0] != -inf) {
                    dp[i][0][0] = mx(dp[i][0][0], dp[k][j][0] + b[a[i - 1]] - s[i - 1]);
                } else if ((!k || a[i - 1] < a[k - 1]) && dp[k][j][1] != -inf) {
                    dp[i][0][0] = mx(dp[i][0][0], dp[k][j][1] + b[a[i - 1]] - s[i - 1]);
                }
            }
        }
        for (int j = 1; j <= n; ++j) {
            for (int k = 0; k < i; ++k) {
                if (k > 0 && a[k - 1] - 1 == a[i - 1] && dp[k][j - 1][0] > -inf) mx(dp[i][j][0], dp[k][j - 1][0] - s[i - 1] + b[a[i - 1]]);
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            mx(ans, max(dp[i][j][0], dp[i][j][1]));
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();

    return 0;
}