#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int inf = int(1e9) + 10;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector <int> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector <int> cost(n);
    for(int i = 0; i < n; i++) {
        cin >> cost[i];
    }

    vector <int> get(n + m + 1);
    for(int i = 1; i <= n + m; i++) {
        cin >> get[i];
    }

    if (n <= 15 && m <= 15) {
        int ans = 0;
        for(int mask = 0; mask < (1 << n); mask++) {

            int cur = 0;
            vector <int> cnt(100);
            int mn = int(1e9);
            for(int i = 0; i < n; i++) {
                int bit = (mask & (1 << i));

                if (bit && a[i] <= mn) {
                    cur -= cost[i];
                    cur += get[a[i]];

                    cnt[a[i]]++;
                    for(int it = 1; it < 100; it++) {
                        if (cnt[it]) {
                            mn = min(mn, it);
                        }

                        if (cnt[it] > 1) {
                            cnt[it + 1]++;
                            cnt[it] = 0;

                            cur += get[it + 1];
                        }
                    }
                }
            }

            ans = max(ans, cur);
        }

        cout << ans << "\n";
    }
    else {
        int M = 15;
        int dp[n][1 << M];
        bool can[n][1 << M];
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < (1 << M); j++) {
                dp[i][j] = -inf;
                can[i][j] = 0;
            }
        }

        dp[0][0] = 0;
        for(int i = 0; i < n; i++) {
            if (!i) {
                dp[i][1 << (a[i] - 1)] = 0;
                dp[i][1 << (a[i] - 1)] -= cost[i];
                dp[i][1 << (a[i] - 1)] += get[a[i]];

                can[i][1 << (a[i] - 1)] = 1;
            }
            else {
                for(int mask = 0; mask < (1 << M); mask++) {
                    if (can[i - 1][mask]) {
                        can[i][mask] = 1;
                        dp[i][mask] = max(dp[i][mask], dp[i - 1][mask]);

                        vector <int> bits(M);
                        for(int it = 0; it < M; it++) {
                            if ((mask & (1 << it))) {
                                bits[it] = 1;
                            }
                        }

                        int mn = 0;
                        for(int it = 0; it < M; it++) {
                            if (bits[it]) {
                                mn = it;
                                break;
                            }
                        }

                        if (a[i] - 1 <= mn || !mask) {
                            int now = a[i] - 1;
                            int res = -cost[i] + get[a[i]];
                            while(bits[now]) {
                                res += get[now + 2];
                                bits[now] = 0;
                                now++;
                            }

                            bits[now] = 1;
                            int new_mask = 0;
                            for(int it = 0; it < M; it++) {
                                new_mask += (1 << it) * bits[it];
                            }

                            dp[i][new_mask] = max(dp[i][new_mask], dp[i - 1][mask] + res);
                            can[i][new_mask] = 1;
                        }
                    }
                }
            }
        }

        int ans = 0;
        for(int mask = 0; mask < (1 << M); mask++) {
            ans = max(ans, dp[n - 1][mask]);
        }

        cout << ans << "\n";
    }

    return 0;
}
