#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int int64_t
#define pii pair<int, int>
#define double long double
#define S second
#define F first
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> orset;
// RRR() < exp((small_energy - big_energy) / t)

const int N = 2020;

int cnt;

struct person{
    int agr, cash, fpos;
    int start_agr;
    int idx;
    bool made;
};

//map<int, int> made[N]; // true if i-th person was made from j
//bool banned[N][N] // if some vertixes were made from one then they are banned to each other
int c[N+N], par[N*N], sz[N*N];
vector<person> p[N];

int root(int v){
    if(par[v] == v) return v;
    return par[v] = root(par[v]);
}

bool merge(int a, int b){
    a = root(a);
    b = root(b);
    if(a == b) return false;
    if(sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    par[b] = a;
    return true;
}

bool comp(person a, person b){
    return a.fpos < b.fpos;
}


bool debugger(person a, person b){
    return a.idx < b.idx;
}

vector<person> all;
int ans = INT_MIN;
int n, m;

void dfs(int v, int cash, int mx, int stroot){
    cash += all[v].cash;
    ans = max(ans, cash);
    for(int i = v + 1; i < n; i ++){
        if(all[i].start_agr <= mx && root(all[i].idx) != stroot)
            dfs(i, cash, mx, stroot);
    }
}


int32_t main(){
    for(int i = 0; i < N*N; i ++)
        sz[i] = 1, par[i] = i;
//    ios_base :: sync_with_stdio(0);
//    cin.tie(0); cout.tie(0);
    cin >> n >> m;
    vector<person> ar(n);
    for(int i = 0; i < n; i ++)
        cin >> ar[i].agr, ar[i].agr --, ar[i].idx = cnt ++, ar[i].fpos = i, ar[i].start_agr = ar[i].agr;
    for(int i = 0; i < n; i ++)
        cin >> ar[i].cash;
    for(int i = 0; i < n + m; i ++)
        cin >> c[i];
    for(int i = 0; i < n; i ++)
        ar[i].cash = (ar[i].cash * -1) + c[ar[i].agr];
    for(int i = 0; i < n; i ++)
        p[ar[i].agr].pb(ar[i]);
    for(int i = 0; i < n + m; i ++){
        for(int j = 0; j < p[i].size(); j ++){
            for(int u = 0; u < p[i].size(); u ++){
                if(p[i][j].fpos >= p[i][u].fpos || p[i][j].start_agr < p[i][u].start_agr) continue;
                if(!merge(p[i][j].idx, p[i][u].idx)) continue;
//                cout << "merging  " << p[i][j].idx << " " << p[i][u].idx << endl;
                person nw;
                nw.idx = cnt ++;
                merge(nw.idx, p[i][j].idx);
                nw.agr = i + 1;
                nw.start_agr = max(p[i][j].start_agr, p[i][u].start_agr);
                nw.made = true;
                nw.fpos = min(p[i][j].fpos, p[i][u].fpos);
                nw.cash = p[i][j].cash + p[i][u].cash + c[nw.agr];
                p[nw.agr].pb(nw);
            }
        }
    }
    for(int i = 0; i < n + m; i ++){
        for(auto x: p[i])
            all.pb(x);
    }
    sort(all.begin(), all.end(), comp);
    for(int i = 0; i < all.size(); i ++){
//        cout << all[i].idx << " " << all[i].agr << " " << all[i].cash << endl;
        dfs(i, 0, all[i].start_agr, root(all[i].idx));
    }
    cout << ans;

}


//5 4
//4 3 1 2 1
//1 2 1 2 1
//1 2 3 4 5 6 7 8 9

//2 2
//1 2
//0 0
//2 1 -100 -100

//5 4
//4 3 2 1 1
//0 2 6 7 4
//12 12 12 6 -3 -5 3 10 -4
