#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 5005;
const int INF = 1e18;
int c[N];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen("input.txt", "r", stdin);
	
	int n, m;
	cin >> n >> m;
	vector<pii> a(n);
	for (auto &i : a) cin >> i.first;
	for (auto &i : a) cin >> i.second;
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	int ans = 0;
	for (int mask = 0; mask < (1LL << n); ++mask) {
		int res = 0;
		map<int, int> cnt;
		int mn = INF;
		bool ok = 1;
		for (int i = 0; i < n; ++i) {
			if (mask & (1LL << i)) {
				res -= a[i].second;
				if (a[i].first > mn) ok = 0;
				mn = min(mn, a[i].first);
				cnt[a[i].first]++;
			}
		}
		if (!ok) continue;
		for (int i = 1; i <= n + m; ++i) {
			if (cnt[i]) {
				res += c[i] * (cnt[i]);
				cnt[i + 1] += cnt[i] / 2;
			}
		}
		ans = max(ans, res);
	}
	cout << ans << endl;
}