#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

int n, m;
vector <int> l, s, c;

int check(vector <int> msk)
{
    vector <int> tk;
    int mn = 1e9;
    for (int i = 0; i < n; ++i)
    {
        if (mn < l[i] || !msk[i])
            continue;
        mn = l[i];
        tk.pb(i);
    }
    vector <int> cur;
    int ans = 0;
    for (int i : tk)
    {
        int lt = l[i];
        ans += c[lt - 1] - s[i];
        while (!cur.empty() && cur.back() == lt)
        {
            cur.pop_back();
            ++lt;
            ans += c[lt - 1];
        }
        cur.push_back(lt);
    }
    return ans;
}

signed main()
{
    Start();
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m);
    cin >> l >> s >> c;
    int ans = 0;
    for (int mask = 0; mask < 1 << n; ++mask)
    {
        vector <int> msk;
        for (int i = 0; i < n; ++i)
            msk.pb(mask >> i & 1);
        ans = max(ans, check(msk));
    }
    cout << ans;
    return 0;
}

