#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 5000 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;

int n, m;
int a[MAXN], s[MAXN], c[MAXN];



void solve() {
	ll ans = 0;
	sort(s, s + n);
	for (int cnt = 1; cnt <= n; cnt++) {
		ll res = 0;
		for (int i = 0; i < cnt; i++)
			res -= s[i];
		int cnt1 = cnt, val = 1;
		while (cnt1 > 0) {
			res += (ll)cnt1 * (ll)c[val];
			val++;
			cnt1 /= 2;
		}
		ans = max(ans, res);
	}
	cout << ans;
}	

int main() {
	fastIO();
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; i++)
		cin >> c[i];
	if (m == 1) {
		//cerr << "aaa";
		solve();
		return 0;
	}
	ll ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		int last = 5000;
		bool bad = 0;
		ll res = 0;
		for (int i = 0; i < n; i++) {
			if ((mask >> i & 1)) {
				if (a[i] > last)
					bad = 1;
				last = a[i];
				res -= s[i];
			}
		}
		if (bad)
			continue;
		vi cur;
		for (int i = 0; i < n; i++) {
			if ((mask >> i) & 1) {
				res += c[a[i]];
				//cerr << res << endl;
				cur.pb(a[i]);
				while (cur.size() > 1 && cur.back() == cur[cur.size() - 2]) {
					cur.pop_back();
					cur.back()++;
					res += c[cur.back()];
				}
			}
		}
		//if (res == 10)
		//	cerr << mask;
		ans = max(ans, res);
	}
	cout << ans;
	
	
	
	
	
	return 0;

}