#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>
#include <queue>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;
const int MOD = 1e9 + 7;

using namespace std;

void go1(int n, int m, vector<int> &l, vector<int> &s, vector<int> &c) {
    sort(all(s));
    int ans = 0;
    int minus = 0;
   
    for (int i = 0; i < n; i++) {
        minus += s[i];
        int x = i + 1;
        int res = -minus;
        for (int j = 1; x; j++) {
            res += c[j] * x;
            x /= 2;
        }
        ans = max(ans, res);
    }
    cout << ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<int> c(n + m + 1);
    for (int i = 1; i <= n + m; i++) {
        cin >> c[i];
    }

    if (m == 1) {
        go1(n, m, l, s, c);
        return;
    }

    int ans = 0;
    for (int mask = 0; mask < (1LL << n); mask++) {
        int mn = INF;
        bool good = true;
        vector<int> used(n + m + 1);
        int res = 0;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                if (mn < l[i]) {
                    good = false;
                }
                res -= s[i];
                mn = min(l[i], mn);
                used[l[i]]++;
                int x = l[i];
                res += c[x];
                while (used[x] > 1) {
                    used[x] -= 2;
                    x++;
                    used[x]++;
                    res += c[x];
                }
            }
        }
        if (good) ans = max(ans, res);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/