#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n = 0, m = 0;
    cin >> n >> m;

    vector <int> l(n), s(n), c(n + m + 1);
    for (int i = 0; i < n; ++i)
        cin >> l[i];
    for (int i = 0; i < n; ++i)
        cin >> s[i];
    for (int i = 1; i <= n + m; ++i)
        cin >> c[i];

    vector <int> pref_c = { 0 };
    for (int i = 1; i <= n + m; ++i)
        pref_c.push_back(pref_c.back() + c[i]);

    vector <int> dp(n);
    vector <vector <int>> el(n), row(n);

    for (int i = 0; i < n; ++i)
    {
        dp[i] = c[l[i]] - s[i];
        el[i].push_back(l[i]);
        row[i].push_back(1);

        bool equal = false;
        int ind = -1;
        for (int j = 0; j < i; ++j)
        {
            if (el[j].back() < l[i])
                continue;

            if (el[j].back() == l[i])
            {
                int fare = pref_c[el[j].back() + row[j].back()] - pref_c[el[j].back()];
                if (dp[j] + fare - s[i] + c[l[i]] > dp[i])
                {
                    dp[i] = dp[j] + fare - s[i] + c[l[i]];
                    equal = true;
                    ind = j;
                }
            }
            else
            {
                if (dp[j] + c[l[i]] - s[i] > dp[i])
                {
                    dp[i] = dp[j] - s[i] + c[l[i]];
                    equal = false;
                    ind = j;
                }
            }
        }

        if (ind == -1)
            continue;

        if (equal)
        {
            el[i].assign(el[ind].begin(), el[ind].end() - row[ind].back());
            row[i].assign(row[ind].begin(), row[ind].end() - row[ind].back());
            if (el[i].empty())
            {
                el[i].push_back(l[i] + row[ind].back());
                row[i].push_back(1);
            }
            else
            {
                if (el[i].back() - 1 == l[i] + row[ind].back())
                    row[i].push_back(row[i].back() + 1);
                else
                    row[i].push_back(1);

                el[i].push_back(l[i] + row[ind].back());
            }
        }
        else
        {
            el[i].assign(el[ind].begin(), el[ind].end());
            row[i].assign(row[ind].begin(), row[ind].end());

            if (el[i].back() - 1 == l[i])
                row[i].push_back(row[i].back() + 1);
            else
                row[i].push_back(1);

            el[i].push_back(l[i]);
        }
    }

    cout << max(*max_element(dp.begin(), dp.end()), 0);

    return 0;
}