#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
const int maxc = 5002;
const int inf = 1e15;

int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

void relax(int &a, int b) {
    a = max(a, b);
}

void solve() {
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (m + n, vector<int>(n + 2, -inf)));
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < n + m; j++) {
            dp[i][j][0] = 0;
        }
    }
    // cout << "here\n";
    for (int i = n - 1; i >= 0; i--) {
        // here
        for (int mn = 0; mn < l[i]; mn++) {
            for (int up = 0; up <= n; up++) {
                int up1 = up;
                int pr1 = dp[i + 1][mn][up];
                for (int j = mn; j < l[i]; j++) {
                    pr1 += up1 * c[j];
                    up1 /= 2;
                    if (up1 == 0) break;
                }
                relax(dp[i][l[i]][up1 + 1], pr1 - s[i]);
            }
        }
        // mn == l[i];
        for (int up = 0; up <= n; up++) {
            relax(dp[i][l[i]][up + 1], dp[i + 1][l[i]][up] - s[i]); 
        }
        // no
        for (int mn = 0; mn < n + m; mn++) {
            for (int up = 0; up <= n; up++) {
                relax(dp[i][mn][up], dp[i + 1][mn][up]);
            }
        }
    }

    int ans = 0;

    for (int mn = 0; mn < m + n; mn++) {
        for (int up = 0; up <= n; up++) {
            int up1 = up;
            int pr1 = dp[0][mn][up];
            for (int j = mn; j < n + m; j++) {
                pr1 += up1 * c[j];
                up1 /= 2;
                if (up1 == 0) {
                    break;
                }
            }
            relax(ans, pr1);
        }
    }
    cout << ans;

}

signed main() {
    // ios::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(maxc);

    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i++) {
        cin >> c[i];
    }
    solve();
}

/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4


*/