#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int Inf = 1e9;

int solve(int n, int m, vector <int> l, vector <int> s, vector <int> c) {	
	reverse(l.begin(), l.end());
	reverse(s.begin(), s.end());
	vector <int> pref(n + m + 2);
	vector <vector <int>> dp(n + 1, vector <int> (n + 1, -Inf));
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int cnt = 0; cnt <= n; ++cnt) {
			if (dp[i][cnt] == -Inf) continue;
			for (int j = i; j < n; ++j) {
				if (i > 0 && l[j] < l[i - 1]) continue;
				if (i > 0 && l[j] == l[i - 1]) {
					dp[j + 1][cnt + 1] = max(dp[j + 1][cnt + 1], dp[i][cnt] - s[j]);
				} else {
					int add = 0;
					int ptr = (i == 0 ? 0 : l[i - 1]);
					int cur_cnt = cnt;
					while (cur_cnt > 0 && ptr < l[j]) {
						add += c[ptr] * cur_cnt;
						++ptr;
						cur_cnt /= 2;
					}
					dp[j + 1][cur_cnt + 1] = max(dp[j + 1][cur_cnt + 1], dp[i][cnt] - s[j] + add);
			 	}
			}
		}
	}
	/*for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j) {
			cout << dp[i][j] << ' ';
		}
		cout << endl;
	}*/
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int cnt = 0; cnt <= n; ++cnt) {
			int res = dp[i][cnt];
			int ptr = l[i - 1];
			int cur_cnt = cnt;
			while (cur_cnt > 0) {
				res += c[ptr] * cur_cnt;
				++ptr;
				cur_cnt /= 2;
			}
			ans = max(ans, res);
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int i = 0; i < n; ++i) cin >> l[i];
	vector <int> s(n);
	for (int i = 0; i < n; ++i) cin >> s[i];
	vector <int> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	cout << solve(n, m, l, s, c) << '\n';
}
