#include <bits/stdc++.h>
#define int long long

using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 5005;
int mas[maxn];
int cost[maxn];
int wei[maxn];
int n, m;

vector <int> cur;
int inf = (int)(2e18);
map <int, int> ma;

void solve_1() {
    int i ,j, a, b;
    int ans = 0;
    for (i = 0; i < (1 << n); i++) {
        cur.clear();
        ma.clear();
        int sum = 0;
        for (j = 0; j < n; j++) {
            if (((i >> j) & 1) == 1) {
                cur.push_back(mas[j]);
                ma[mas[j]]++;
                sum += wei[mas[j]] - cost[j];
            }
        }
        int f = 1;
        for (j = 0; j + 1 < cur.size(); j++) {
            if (cur[j] < cur[j + 1]) {
                f = 0;
                break;
            }
        }
        if (!f) continue;
        while (true) {
            f = 0;
            for (auto x : ma) {
                if (x.second > 1) {
                    f = 1;
                    a = x.first;
                    break;
                }
            }
            if (!f) {
                break;
            }
            ma[a] -= 2;
            ma[a + 1]++;
            sum += wei[a + 1];
        }
        ans = max(ans, sum);
    }
    cout << ans;
}

void solve_2() {
    int i, j, a, b;
    int ans = -inf;
    sort(cost, cost + n);
    int cur = 0;
    for (i = 1; i <= n; i++) {
        cur += 1 - cost[i - 1];
        ma.clear();
        ma[1] = i;
        int sum = 0;
        while (true) {
            int f = 0;
            for (auto x : ma) {
                if (x.second > 1) {
                    f = 1;
                    a = x.first;
                    break;
                }
            }
            if (!f) {
                break;
            }
            ma[a] -= 2;
            ma[a + 1]++;
            sum += wei[a + 1];
        }
        ans = max(ans, sum + cur);
    }
    cout << ans;
}

signed main() {
    fast();
    int a, b, i, j;
    cin >> n >> m;
    for (i = 0; i < n; i++) {
        cin >> mas[i];
    }
    for (i = 0; i < n; i++) {
        cin >> cost[i];
    }
    for (i = 1; i <= n + m; i++) {
        cin >> wei[i];
    }
    if (n <= 15 && m <= 15) {
        solve_1();
        return 0;
    }
    if (m == 1) {
        solve_2();
        return 0;
    }
}
