#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;
typedef long double db;

const int N = 2e3 + 5;
const int inf = 1e18 + 7;
int agr[N];
int cost[N];
int cnt[N];

int f(vector < int > ind) {
    int prv = inf;
    int res = 0;
    int n = sz(ind);
    stack < int > q;
    for (int j = 0; j < n; j++) {
        int i = ind[j];
        if (agr[i] > prv) {
            return -inf;
        }
        res -= cost[i];
        res += cnt[agr[i]];
        int p = 0;
        while (sz(q) && q.top() == agr[i] + p) {
            q.pop();
            p++;
            res += cnt[agr[i] + p];
        }
        q.push(agr[i] + p);
        prv = agr[i];
    }
    return res;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> agr[i];
        agr[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> cost[i];
    }
    for (int i = 0; i < n + m; i++) {
        cin >> cnt[i];
    }
    if (n <= 15) {
        int ans = -inf;
        for (int i = 0; i < (1 << n); i++) {
//            if (i == 31) {
//                cout << "!";
//            }
            vector < int > lst;
            for (int j = 0; j < n; j++) {
                if (i & (1 << j)) {
                    lst.pb(j);
                }
            }
            ans = max(ans, f(lst));
        }
        cout << ans << endl;
        return 0;
    }
    return 0;
}
