#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

const ll INF = 1e9;

int main() {
	ll n, m;
	cin >> n >> m;
	vector <ll> l(n), s(n), c(n + m);
	for (ll i = 0; i < n; i++) {
		cin >> l[i];
		l[i]--;
	}
	for (ll i = 0; i < n; i++)
		cin >> s[i];
	for (ll i = 0; i < n + m; i++)
		cin >> c[i];
	ll ans = 0;
	if (n <= 15) {
		for (ll x = 0; x < (1 << n); x++) {
			ll cur_ans = 0;
			ll mi = INF;
			ll copy_x = x;
			vector <bool> tf(n);
			for (ll i = 0; i < n; i++) {
				tf[i] = copy_x % 2;
				copy_x /= 2;
			}
			vector <bool> used(n + m);
			for (ll i = 0; i < n; i++) {
				if (!tf[i])
					continue;
				if (mi < l[i]) {
					continue;
				}
				mi = l[i];
				cur_ans += c[l[i]] - s[i];
				ll agg = l[i];
				while (used[agg]) {
					used[agg] = false;
					agg++;
					cur_ans += c[agg];
				}
				used[agg] = true;
			}
			ans = max(ans, cur_ans);
			if (cur_ans == 21) {
				for (int i = 0; i < n; i++)
					cout << tf[i] << " ";
				cout << endl;
			}
		}
		cout << ans;
		return 0;
	}
	if (m == 1) {
		vector <bool> used(n + m);
		sort(s.begin(), s.end());
		ll cur_ans = 0;
		for (ll i = 0; i < n; i++) {
			cur_ans += c[l[i]] - s[i];
			ll agg = l[i];
			while (used[agg]) {
				used[agg] = false;
				agg++;
				cur_ans += c[agg];
			}
			used[agg] = true;
			ans = max(ans, cur_ans);
		}
		cout << ans;
		return 0;
	}
	vector <pair <ll, ll>> x, y;
	for (ll i = 0; i < n; i++) {
		if (l[i] == 0) x.push_back({ s[i], i });
		else y.push_back({ s[i], i });
	}
	sort(x.begin(), x.end());
	sort(y.begin(), y.end());
	for (ll t = -1; t < n; t++) {
		vector <bool> used(n + m);
		ll kek = 0;
		ll cur_ans = 0;
		for (ll i = 0; i < x.size(); i++)
			if (x[i].second > t) {
				cur_ans += c[0] - x[i].first;
				ll agg = 0;
				while (used[agg]) {
					used[agg] = false;
					agg++;
					cur_ans += c[agg];
				}
				used[agg] = true;
				ans = max(ans, cur_ans);
				kek = max(ans, cur_ans);
			}
		for (ll i = 0; i < y.size(); i++) 
			if (y[i].second <= t) {
				cur_ans += c[1] - y[i].first;
				ll agg = 1;
				while (used[agg]) {
					used[agg] = false;
					agg++;
					cur_ans += c[agg];
				}
				used[agg] = true;
				ans = max(ans, cur_ans);
				kek = max(ans, cur_ans);
			}
	}
	cout << ans;
	return 0;
}
/*
11 2
2 1 2 1 2 2 2 1 2 2 1
7 6 3 4 2 5 2 11 4 7 1
5 6 -2 7 5 -3 7 -2 9 -4 11 12 13
0 0 1 0 1 1 1 0 1 0 1
*/