#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define ve vector
#define y1 stanislavpolyn

#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/rope>
using namespace __gnu_cxx;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;

const ll oo = 1e18;
const ll mod = 1e9 + 7;
const ll maxn = 5e5 + 47;

ll n, m, l[maxn], s[maxn], c[maxn];
bool subtask = 1;

ll calc(ll n) {
    ll step = 2;
    ll ans = 0;
    while(n > 0) {
        ans += (n / 2) * c[step];
        n /= 2;
        step++;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    ll n, m;
    cin >> n >> m;
    subtask &= (m == 1);
    fr(i, 0, n - 1) {
        cin >> l[i];
    }
    fr(i, 0, n - 1) {
        cin >> s[i];
    }
    fr(i, 1, n + m) {
        cin >> c[i];
    }
    if(subtask) {
        sort(s, s + n);
        ll sum = 0;
        ll best = 0;
        fr(i, 0, n - 1) {
            sum -= s[i];
            sum += c[1];
            umx(best, calc(i + 1) + sum);
        }
        cout << best << "\n";
        return 0;
    }
    ll best = 0;
    fr(mask, 0, pw(n) - 1) {
        ve<ll> a;
        ll sum = 0;
        fr(i, 0, n - 1) {
            if(mask & pw(i)) {
                a.pb(l[i]);
                sum -= s[i];
                sum += c[l[i]];
            }
        }
        bool bad = 0;
        fr(i, 1, sz(a) - 1) {
            if(a[i] > a[i - 1]) {
                bad = 1;
                break;
            }
        }
        if(bad) {
            continue;
        }
        bool changed = 1;
//        cout << sum << ": ";
//        fr(i, 0, sz(a) - 1) {
//            cout << a[i] << " ";
//        }
//        cout << "\n";
        while(changed) {
            changed = 0;
            fr(i, 0, sz(a) - 1) {
                fr(j, i + 1, sz(a) - 1) {
                    if(a[i] == a[j]) {
                        changed = 1;
                        sum += c[a[j] + 1];
                        a[j]++;
                        swap(a[i], a.back());
                        a.pop_back();
                    }
                }
            }
//            cout << sum << ": ";
//            fr(i, 0, sz(a) - 1) {
//                cout << a[i] << " ";
//            }
//            cout << "\n";
        }
//        system("pause");
        umx(best, sum);
    }
    cout << best << "\n";
    return 0;
}

/*
5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4

5 1
1 1 1 1 1
1 2 3 4 5
2 4 7 1 6 8
*/

