#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <queue>
#include <cmath>
#include <algorithm>
#include <tuple>
#include <stdio.h>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <stdlib.h>
#include <time.h>
#include <random>
#include <istream>
#include <ostream>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,sse4")
//#pragma GCC oprimize("unroll-loops")
//#pragma GCC optimize("fast-math")

using namespace std;

//#define int long long
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ld long double

// if (clock() * 1.0 / CLOCKS_PER_SEC > 1.45)

//struct int_comp {
//    bool operator() (const int a, const int b) const {
//        return a > b;
//    }
//};

ostream& operator<< (ostream& a, vector<int>& b) {
    for (auto k : b) cout << k << " ";
    return a;
}

#ifdef LOCAL
//    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 10;
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
//    int INF = 1e18;
//    int mod = 2600000069;
//    int p = 179;
    #define dbg(x)
#endif

mt19937 my_rand(2724912234);

int n, m;
vector<int> a, s, c;

void tryhard() {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
//        for (int i = 0; i < n; i++) {
//            if ((mask >> i) & 1) {
//                cout << 1;
//            } else cout << 0;
//        }
//        cout << "\n";
        vector<int> ind;
        bool ok = 1;
        int cost = 0;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                if (!ind.empty() && a[ind.back()] < a[i]) {
                    ok = 0;
                    break;
                }
                ind.pb(i);
                cost -= s[i];
            }
        }
//        if (mask == 23) dbg(cost)
        vector<int> have(40, 0);
        for (auto k : ind) {
            int cur = a[k];
            cost += c[cur];
            have[cur]++;
            while (have[cur] > 1) {
                have[cur] = 0;
                cur++;
                cost += c[cur];
                have[cur]++;
            }
//            if (mask == 23) dbg(cost)
//            for (int i = 0; i < 10; i++) cout << have[i] << " ";
//            cout << "\n";
        }
//        dbg(cost);
        if (ok) ans = max(ans, cost);
    }
    cout << ans << "\n";
}

const int MAXN = 2010;
const int MAXM = 5;
const int MASK = (int)(1LL << 15);

int dp[MAXN][MAXM][MASK];

void stupid() {
    for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXM; j++) {
            for (int k = 0; k < MASK; k++) {
                dp[i][j][k] = -2000000000;
            }
        }
    }
    dp[0][MAXM - 1][0] = 0;
    dp[0][a[0]][(1 << a[0])] = c[a[0]] - s[0];
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < MAXM; j++) {
            for (int mask = 0; mask < MASK; mask++) {
                if (dp[i][j][mask] == -2000000000) continue;
//                cout << "from:\n";
//                cout << i << " " << j << " " << mask << " " << dp[i][j][mask] << "\n";
                dp[i + 1][j][mask] = max(dp[i + 1][j][mask], dp[i][j][mask]);
                if (j < a[i + 1]) continue;
//                cout << "HERE\n";
                int nw_mask = mask + (1 << a[i + 1]);
                int add = 0, ind = a[i + 1];
                for (ind = a[i + 1]; ind < 40 && ((mask >> ind) & 1); ind++) {
                    add += c[ind];
                }
                add += c[ind];
                dp[i + 1][a[i + 1]][nw_mask] = max(dp[i + 1][a[i + 1]][nw_mask], dp[i][j][mask] + add - s[i + 1]);
//                cout << "updated:\n";
//                cout << i + 1 << " " << a[i + 1] << " " << nw_mask << " " << dp[i][j][mask] + add - s[i + 1] << "\n";
//                cout << "new : " << dp[i][j][mask] + add - s[i] << "\n";
            }
        }
    }
//    dbg(dp[1][0][1])
   /*
5 1
1 1 1 1 1
3 1 1 0 3
0 1 1 -3 -3 4
   */
    int ans = 0;
    for (int j = 0; j < MAXM; j++) {
        for (int mask = 0; mask < MASK; mask++) {
            ans = max(ans, dp[n - 1][j][mask]);
//            if (dp[n - 1][j][mask] == 1) {
//                cout << n - 1 << " " << j << " " << mask << "\n";
//            }
//            if (dp[n - 1][j][mask] = 5) {
//                cout << n - 1 << " " << j << " " << mask << "\n";
//            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    dbg((1<<16) * 5 * 2001)
//    dbg(512 * 1024 * 1024 / 4)
    cin >> n >> m;
    a.resize(n);
    s.resize(n);
    c.resize(n + m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i];
    if (m > 5) tryhard();
    else stupid();
}
/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100


сначала пиши тупняк если не уверен в решении
не зацикливайся на задаче если не получается
не думай о результате
следи за временем
*/
