/*
 *   cCreated by Kazalika   for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
const int N = 2e3 + 5, LOG = 13;
const int INF = 1e9;
const ldb EPS = 1e-8;

int n, m;
vector <int> l, s, c;

void slow() {

    int res = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int minv = INF;
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                if (l[i] > minv)
                    ok = false;
                minv = min(minv, l[i]);
            }
        }
        if (!ok) continue;
        vector <int> agr;
        int resn = 0;
        for (int i = 0; i < n; ++i) {
            if (!(mask >> i & 1)) continue;
            resn -= s[i];
            resn += c[l[i]];
            int nagr = l[i];
            while (!agr.empty() && agr.back() == nagr) {
                agr.pop_back();
                nagr++;
                resn += c[nagr];
            }
            agr.push_back(nagr);
        }
        res = max(res, resn);
    }
    cout << res;

    exit(0);
}


void faster() {
    vector <vector <ll> > dp(n, vector <ll> (n + m + 1, -INF));
    for (int i = n - 1; i >= 0; --i) {
        dp[i][l[i]] = c[l[i]] - s[i];
        for (int j = i + 1; j < n; ++j) {
            if (l[j] > l[i]) continue;
            for (int agr = 1; agr <= n + m; ++agr) {
                if (agr == l[i] && dp[j][agr] != -INF)
                    dp[i][agr + 1] = max(dp[i][agr + 1], dp[j][agr] + c[agr + 1] - s[i] + c[l[i]]);
                else
                    dp[i][agr] = max(dp[i][agr], dp[j][agr] + c[l[i]] - s[i]);
            }
        }
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= n + m; ++j)
            res = max(res, dp[i][j]);
    }
    cout << res;
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    l.resize(n); s.resize(n); c.resize(n + m + 1);
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> s[i];
    for (int i = 1; i <= n + m; ++i) cin >> c[i];
    //if (n <= 15 && m <= 15) slow();
    faster();

}