#include <iostream>
#include <cstdint>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <vector>
#include <cstring>

int main() {
    int32_t num_candidates, max_aggressivity;
    std::cin >> num_candidates >> max_aggressivity;

    int32_t* aggressivity = new int32_t[num_candidates];
    int32_t* cost = new int32_t[num_candidates];
    int32_t* cost_per_agressivity = new int32_t[num_candidates + max_aggressivity + 1];
    for(int32_t i = 0 ; i < num_candidates; i++) {
        std::cin >> aggressivity[i];
    }
    for(int32_t i = 0 ; i < num_candidates; i++) {
        std::cin >> cost[i];
    }
    for(int32_t i = 0 ; i < num_candidates + max_aggressivity; i++) {
        std::cin >> cost_per_agressivity[i + 1];
    }

    int32_t answer = INT32_MIN;
    for(int32_t i = 0 ; i < (1 << num_candidates); i++) {
        int32_t already_taken = INT32_MAX;
        bool valid = true;
        for(int32_t j = 0 ; j < num_candidates; j++) {
            if(i & (1 << j)) {
                if (aggressivity[j] > already_taken) {
                    valid = false;
                    break;
                }
                already_taken = aggressivity[j];
            }
        }
        if(!valid)
            continue;

        std::set<int32_t> current;
        int32_t money = 0;
        for(int32_t j = 0 ; j < num_candidates; j++) {
            if(i & (1 << j)) {
                money -= cost[j];
                money += cost_per_agressivity[aggressivity[j]];
                int32_t cur_agressivity = aggressivity[j];
                while(current.find(cur_agressivity) != current.end()) {
                    current.erase(cur_agressivity);
                    cur_agressivity++;
                    money += cost_per_agressivity[cur_agressivity];
                }
                current.insert(cur_agressivity);
            }
        }
        answer = std::max(answer, money);
    }
    std::cout << answer;
    return 0;
}