#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 
mt19937 rng(time(NULL));

int a[2002][2002];
int n, m;

struct table2d {
	int t[2002][2002];

	void build() {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) cout << t[i][j] << " "; cout << endl;
		}
		cout << endl;
	}

	int mn(int y1, int x1, int y2, int x2) {
		int ans = 1e9;
		for (int y = y1; y <= y2; ++y) {
			for (int x = x1; x <= x2; ++x) {
				ans = min(ans, t[y][x]);
			}
		}
		return ans;
	}

} rw, cl;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	vector<int> l(n), s(n), c(n + m + 1);
	for (int i = 0; i < n; ++i) cin >> l[i];
	for (int i = 0; i < n; ++i) cin >> s[i];
	for (int i = 0; i < n + m; ++i) cin >> c[i+1];
	if (m == 1) {
		sort(s.begin(), s.end());
		ll best = 0, cur = 0;
		set<int> cs;
		for (int i = 0; i < n; ++i) {
			cur += c[1] - s[i];
			int cl = 1;
			while (cs.find(cl) != cs.end()) {
				cs.erase(cl);
				cur += c[++cl];
			}
			cs.insert(cl);
			best = max(best, cur);
		}
		cout << best << endl;
		return 0;
	}
	ll best = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int mn = 1e9;
		bool fail = 0;
		ll cur = 0;
		set<int> cs;
		for (int i = 0; i < n; ++i) {
			if (mask & (1 << i)) {
				if (l[i] > mn) {
					fail = 1;
					break;
				}
				mn = min(mn, l[i]);
				cur += c[l[i]] - s[i];
				int cl = l[i];
				while (cs.find(cl) != cs.end()) {
					cs.erase(cl);
					cur += c[++cl];
				}
				cs.insert(cl);
			}
		}
		if (!fail) best = max(best, cur);
	}

	cout << best;

	return 0;
}