#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 25;
const LL LINF = 1e18;
const int N = (int)2e3 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

int n, m, l[N], s[N], c[2 * N];

int bit(int x, int pos) {
	return (x & (1 << pos)) > 0;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> l[i];
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 1; i <= n + m; i++)
		cin >> c[i];
	if (n <= 15 && m <= 15) {
		int ans = 0;
		for (int i = 0; i < (1 << n); i++) {
			int lst = -1;
			bool fl = true;
			int cnt[32] = {}, res = 0;
			for (int j = 0; j < n; j++) {
				if (!bit(i, j))
					continue;
				if (lst != -1 && l[lst] < l[j]) {
					fl = false;
					break;
				}
				lst = j;
				res -= s[j];
				cnt[l[j]]++;
			}
			for (int j = 0; j < 31; j++) {
				res += c[j] * cnt[j];
				cnt[j + 1] += cnt[j] / 2;
			}
			uax(ans, res);
		}
		cout << ans;
		exit(0);
	}
	if (m == 1) {
		int ans = 0;
		sort(s, s + n);
		int cnt[32] = {}, res = 0;
		for (int i = 0; i < n; i++) {
			res -= s[i] - l[1];
			cnt[1]++;
			for (int j = 1; j < 31; j++) {
				if (cnt[j] == 2) {
					res += l[j + 1];
					cnt[j] = 0;
					cnt[j + 1]++;
				}
			}
			uax(ans, res);
		}
		cout << ans;
	}
}