#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 16, MAX_M = 16, MAX_L = 23;

int l[MAX_N], s[MAX_N], c[MAX_N + MAX_M];
int cnts[MAX_L];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> l[i], --l[i];
	for (int i = 0; i < n; ++i)
		cin >> s[i];
	for (int i = 0; i < n + m; ++i)
		cin >> c[i];
	for (int i = 0; i < n; ++i)
		s[i] = -s[i] + c[l[i]];
	if (n <= 15) {
		int best_ans = 0;
		int max_mask = 1 << n;
		for (int mask = 0; mask < max_mask; ++mask) {
			int cost = 0;
			int last = MAX_N;
			bool bad = 0;
			fill(cnts, cnts + MAX_L, 0);
			for (int i = 0; i < n && !bad; ++i) {
				if ((mask >> i & 1)) {
					if (last < l[i])
						bad = 1;
					last = l[i];
					++cnts[l[i]];
					cost += s[i];
					// int curr = l[i];
					// while (cnts[curr] == 2) {
					// 	cnts[curr] = 0;
					// 	++curr;
					// 	cost += c[curr];
					// 	++cnts[curr];
					// }
				}
			}
			if (bad)
				continue;
			// cout << bitset<5>(mask) << ": \n";
			// for (int i = 0; i < MAX_L; ++i)
			// 	cout << cnts[i] << " ";
			// cout << "\n";
			for (int i = 0; i < MAX_L - 1; ++i) {
				if (cnts[i] > 1) {
					cost += (cnts[i] / 2) * c[i + 1];
					cnts[i + 1] += cnts[i] / 2;
					cnts[i] %= 2;
				}
			}
			assert(cnts[MAX_L - 1] <= 1);
			// cout << cost << "\n";
			best_ans = max(best_ans, cost);
		}
		cout << best_ans << "\n";
	}
	return 0;
}