#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 2e3;
int dp[2][N][N];
int l[N];
int s[N];
int c[N];
const int inf = 1e9;

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i];
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            dp[0][i][j] = dp[1][i][j] = -inf;
        }
    }
    dp[0][100][0] = 0;
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= mx1; j++) {
            for (int z = l[i]; z < N; z++) {
                bool fl = true;
                for (int z = 0; z < l[i]; z++) {
                    if (j & (1 << z)) {
                        fl = false;
                        break;
                    }
                }
                if (!fl) continue;
                int cur = l[i];
                int delta = -s[i];
                int nxtmask = j;
                while (true) {
                    delta += c[cur];
                    nxtmask ^= (1 << cur);
                    if (nxtmask & (1 << cur)) break;
                    cur++;
                }
                dp[1][l[i]][nxtmask] = max(dp[1][l[i]][nxtmask], dp[0][z][j] + delta);
                mx2 = max(mx2, nxtmask);
            }
        }
        for (int i = 0; i <= mx2; i++) {
            for (int j = 0; j < N; j++) {
                dp[0][j][i] = dp[1][j][i];
            }
        }
        mx1 = mx2;
    }
    int ans = 0;
    for (int i = 0; i <= mx1; i++) {
        for (int j = 0; j < N; j++) {
            ans = max(ans, dp[0][j][i]);
        }
    }
    cout << ans;
    return 0;
}