#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int Inf = 1e9;

int solve(int n, int m, vector <int> l, vector <int> s, vector <int> c) {	
	reverse(l.begin(), l.end());
	reverse(s.begin(), s.end());
	vector <int> pref(n + m + 2);
	vector <vector <int>> best(n + m + 1, vector <int> (n + 1, -Inf));
	for (int i = 0; i <= n + m; ++i) best[i][0] = 0;
	for (int i = 0; i < n; ++i) {
		/*for (int i = 0; i <= n + m; ++i) {
			for (int j = 0; j <= n; ++j) {
				cout << best[i][j] << ' ';
			}
			cout << endl;
		}
		cout << endl << endl;*/
		vector <pair <pair <int, int>, int>> vals;
		for (int cnt = 0; cnt <= n; ++cnt) {
			int ptr = l[i];
			if (best[ptr][cnt] == -Inf) continue;
			int cur_cnt = cnt + 1;
			int add = best[ptr][cnt] - s[i];
			while (ptr <= n + m) {
				//best[ptr][cur_cnt] = max(best[ptr][cur_cnt], add);
				vals.push_back({{ptr, cur_cnt}, add});
				add += c[ptr] * cur_cnt;
				cur_cnt /= 2; 
				++ptr;
			}
		}
		for (auto p : vals) {
			best[p.first.first][p.first.second] = max(best[p.first.first][p.first.second], p.second);
		}
	}
	int ans = 0;
	for (int i = 0; i <= n + m; ++i) {
		ans = max(ans, best[i][0]);
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m;
	cin >> n >> m;
	vector <int> l(n);
	for (int i = 0; i < n; ++i) cin >> l[i];
	vector <int> s(n);
	for (int i = 0; i < n; ++i) cin >> s[i];
	vector <int> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	cout << solve(n, m, l, s, c) << '\n';
}
