//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}
int n, m;
vector<int> agg;
vector<int> cost;
vector<int> prof;
const int N = 2010;
int mem[N][N];
int dp(int i, int men) {
	if (mem[i][men] != -1) return mem[i][men];
	int rez = 0;
	{
		// suppose we take nothing
		int nmen = men;
		for (int t = agg[i];; t++) {
			nmen /= 2;
			if (!nmen) break;
			rez += prof[t + 1] * nmen;
		}
	}
	for (int j = i - 1; ~j; j--) {
		if (agg[j] >= agg[i]) {
			// suppose we take j
			int cur = cost[j] + prof[agg[j]];
			int nmen = men;
			// simulation
			for (int t = agg[i]; t < agg[j]; t++) {
				nmen /= 2;
				if (!nmen) break;
				cur += prof[t + 1] * nmen;
			}
			cur += dp(j, nmen + 1);
			rez = max(rez, cur);
		}
	}
	return mem[i][men] = rez;
}

void run() {
	memset(mem, -1, sizeof mem);
	cin >> n >> m;	
	prof.resize(n + m + 1);
	agg.resize(n); cost.resize(n);
	cin >> agg >> cost;
	for (int &x : cost) x = -x;
	for (int i = 1; i <= n + m; i++) cin >> prof[i];
	vector<vector<int>> best(n + m + 1,
		vector<int>(n + 1, -1e9));
	int rez = 0;
	for (int i = 0; i < n; i++) {
		for (int men = 0; men <= n; men++) {
			int lc = prof[agg[i]] + cost[i];	
			{
				// suppose we take nothing
				int nmen = men + 1;
				for (int t = agg[i];; t++) {
					nmen /= 2;
					if (!nmen) break;
					lc += prof[t + 1] * nmen;
				}
			}
			{
				// suppose we take j
				int cur = prof[agg[i]] + cost[i];
				int nmen = men + 1;
				// simulation
				int t = agg[i];
				for (; t <= n + m; t++) {
					// if (!nmen) break;
					lc = max(lc, cur + best[t][nmen]);
					nmen /= 2;
					if (t + 1 > n + m) break;
					cur += prof[t + 1] * nmen;
				}
				if (men == 0) {
					rez = max(rez, lc);
				}
				best[agg[i]][men] = max(best[agg[i]][men], lc);
			}
		}
	}
	cout << rez << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}