#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(228);
#define rall(x) (x).begin(), (x).end()
#define all(x) (x).begin(), (x).end()
#define pNN pair <Node *, Node *>
#define SZ(x) (int)(x).size()
#define pii pair <int, int>
#define pb push_back
#define ins insert
#define ers erase
#define S second
#define F first
const int N = 15, M = 40;

int cnt[M], c[M];
int l[N], s[N];
int n, m;
int lg2[(1 << N) + 10];

int get_sum(vector <int> & vec) {
	vector <int> vec1;
	int res = 0;
	for (auto x : vec) {
		int level = l[x];
		res += c[level];
		while (SZ(vec1) > 0 && vec1.back() == level) {
			++level;
			res += c[level];
			vec1.pop_back();
		}
		vec1.pb(level);
	}
	return res;
}

int get(int mask) {
	vector <int> vec;
	while (mask) {
		int ind = lg2[mask ^ (mask & (mask - 1))];
		vec.pb(ind);
		mask &= mask - 1;
	}
	for (int i = 1; i < SZ(vec); ++i) {
		if (l[vec[i]] > l[vec[i - 1]]) {
			return -1;
		}
	}
	int sum = 0;
	for (auto x : vec) {
		sum += s[x];
	}
	return get_sum(vec) -sum;
}

void small_solve() {
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	int ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		ans = max(ans, get(mask));
	}
	cout << ans;
}	

void big_solve() {
	vector <int> l(n), s(n), c(n + m + 1), cnt(n + m + 10, 0);
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	sort(all(s));
	int ans = 0, sum = 0, res = 0;
	for (int i = 0; i < n; ++i) {
		sum += s[i];
		int level = 1;
		res += c[level];
		while (cnt[level] > 0) {
			--cnt[level];
			++level;
			res += c[level];
		}
		++cnt[level];
		ans = max(ans, res - sum);
	}
	cout << ans;
}

signed main() {
	lg2[1] = 0;
	for (int i = 2; i < (1 << N) + 10; ++i) {
		lg2[i] = lg2[i >> 1] + 1;
	}
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef Solenoid555
		freopen("input.txt", "r", stdin);
	#endif
	cin >> n >> m;
	if (m == 1) {
		big_solve();
	} else {
		small_solve();
	}
	return 0;
}