#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> l(n), s(n);
	for(int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	vector<int> c(n + m + 1);
	for(int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}

	vector< vector<int> > dp(n, vector<int>(n + 1));
	vector< vector<int> > ltobest(m + 1, vector<int>(n + 1, -1000000000000000LL));

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			for(int curl = l[i]; cnt > 0; curl++) {
				cur += c[curl] * cnt;
				cnt /= 2;
			}
			dp[i][j] = cur;
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] = max(dp[i][j], ltobest[l[i]][j + 1]);
		}

		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			int curl;
			for(curl = l[i]; cnt > 0; curl++) {
				for(int prev = 0; prev < i; prev++) {
					if(l[prev] > l[i] && curl == l[prev]) {
						dp[i][j] = max(dp[i][j], dp[prev][cnt] + cur);
					}
				}
				cur += c[curl] * cnt;
				cnt /= 2;
			}
			for(int prev = 0; prev < i; prev++) {
				if(curl >= l[prev] && l[prev] > l[i]) {
					dp[i][j] = max(dp[i][j], dp[prev][cnt] + cur);
				}
			}
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] -= s[i];
		}

		for(int j = 0; j < n; j++) {
			ltobest[l[i]][j] = max(ltobest[l[i]][j], dp[i][j]);
		}
	}

	int ans = 0;
	for(int i = 0; i < n; i++) {
		ans = max(ans, dp[i][0]);
	}
	cout << ans << endl;

	return 0;
}