#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using namespace std;
using namespace __gnu_pbds;

const int N = 2001, M = 4001;
ll inf = 1e12;
ll l[N], s[N], c[M], dp[M][N], pm[M], cd[N], mc[M][N];

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n, m;
	cin >> n >> m;
	rep(i, n)
		cin >> l[i];
	rep(i, n)
		cin >> s[i];
	rep(i, n + m)
		cin >> c[i + 1];
	rep(i, m + 1)
		for (int j = 1; j <= n; j++)
			dp[i][j] = -inf;
	for (int i = n + m - 1; i > 0; i--)
		for (int j = 1; j <= n; j++)
			mc[i][j] = mc[i + 1][j / 2] + j / 2 * c[i + 1];
	int d, bm;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = 1; j <= n; j++)
			cd[j] = -inf;
		for (int j = max(1ll, l[i] - 11); j <= l[i]; j++) {
			for (int k = 0; k < n - i; k++) {
				d = 1 << (l[i] - j);
				bm = k / d;
				cd[bm + 1] = max(cd[bm + 1], dp[j][k] + mc[j][d] * bm + mc[j][k % d]);
			}
		}
		rep(j, l[i] - 11)
			cd[1] = max(cd[1], pm[j]);
		for (int j = 1; j <= n; j++) {
			dp[l[i]][j] = max(dp[l[i]][j], cd[j] - s[i] + c[l[i]]);
			pm[l[i]] = max(pm[l[i]], cd[j] - s[i] + c[l[i]] + mc[l[i]][j]);
		}
	}
	ll ans = 0;
	rep(i, m + 1)
		ans = max(ans, pm[i]);
	cout << ans;
}

