#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int aggr[2009];
int cost[2009];
int gain[4009];

int dp[2009][(1 << 14) + 1];

const int inf = 1e15;

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i ++) cin >> aggr[i];
    for (int i = 0; i < n; i ++) cin >> cost[i];
    for (int i = 1; i <= n + m; i ++) cin >> gain[i];

    if (n <= 15) {
        int answ = 0;

        for (int mask = 1; mask < (1 << n); mask++) {
            vector<int> in;
            unordered_set<int> ao;
            for (int i = 0; i < n; i ++) {
                if ((mask >> i) & 1) in.push_back(i);
            }

            int sum = 0;
            for (int i = 0; i < in.size(); i ++) {
                if (i > 0 && aggr[in[i - 1]] < aggr[in[i]]) sum = -inf;
                int x = aggr[in[i]];
                sum -= cost[in[i]];
                sum += gain[x];
                while (ao.find(x) != ao.end()) {
                    ao.erase(x);
                    x++;
                    sum += gain[x];
                }

                ao.insert(x);
            }

            answ = max(answ, sum);
        }

        cout << answ;
        return 0;
    }

    for (int j = 0; j <= n; j ++) {
        for (int i = 1; i < (1 << 14); i ++) {
            dp[j][i] = -inf;
        }
    }

    for (int i = 0; i < n; i ++) {
        for (int mask = 0; mask < (1 << 14); mask ++) {
            dp[i + 1][mask] = max(dp[i + 1][mask], dp[i][mask]);
            int sum = 0;
            int subm = mask;
            int b = aggr[i];
            while ((subm >> b) & 1) {
                subm ^= (1 << b);
                sum += gain[b + 1];
                b++;
            }

            subm ^= (1 << b);
            dp[i + 1][subm] = max(dp[i + 1][subm], dp[i][mask] - cost[i] + gain[aggr[i]] + sum);
        }
    }

    int answ = 0;
    for (int j = 0; j <= n; j ++) {
        for (int i = 1; i < (1 << 14); i ++) {
            answ = max(answ, dp[j][i]);
        }
    }

    cout << answ;

    return 0;
}



