#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long
const int N = 2002;
const int INF = 2e18;

int cost[N * 10];

pair<set<int>, int> go(set<int> st, int x) {
    if (st.empty()) {
        return {{x}, cost[x]};
    }
    if (*st.begin() < x) {
        assert(false);
        return {{}, -INF};
    }
    int res = cost[x];
    while (st.count(x)) {
        st.erase(x);
        ++x;
        res += cost[x];
    }
    st.insert(x);
    return {st, res};
}

map<set<int>, int> dp[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> start(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> start[i];
    }
    vector<int> start_c(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> start_c[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> cost[i];
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        dp[i][{start[i]}] = cost[start[i]] - start_c[i];
        for (int j = i - 1; j >= 1; --j) {
            if (start[i] <= start[j]) {
                for (auto &x : dp[j]) {
                    auto [nw, get] = go(x.first, start[i]);
                    get += x.second - start_c[i];
                    if (dp[i].find(nw) != dp[i].end()) {
                        dp[i][nw] = max(dp[i][nw], get);
                    } else {
                        dp[i][nw] = get;
                    }
                    ans = max(ans, get);
                }
            }
        }
    }
    cout << ans;
}