#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 1e6;
int dp[2][N];
int l[N];
int s[N];
int c[N];
const int inf = 1e15;

signed main() {
    fast();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i]--;
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i];
    for (int i = 0; i < N; i++) {
        dp[0][i] = dp[1][i] = -inf;
    }
    dp[0][0] = dp[1][0] = 0;
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= mx1; j++) {
            bool fl = true;
            for (int z = 0; z < l[i]; z++) {
                if (j & (1 << z)) {
                    fl = false;
                    break;
                }
            }
            if (!fl) continue;
            int cur = l[i];
            int delta = -s[i];
            int nxtmask = j;
            while (true) {
                delta += c[cur];
                nxtmask ^= (1 << cur);
                if (nxtmask & (1 << cur)) break;
                cur++;
            }
            if (cur >= n + m) break;
            dp[1][nxtmask] = max(dp[1][nxtmask], dp[0][j] + delta);
            mx2 = max(mx2, nxtmask);
        }
        for (int i = 0; i <= mx2; i++) {
            dp[0][i] = dp[1][i];
        }
        mx1 = mx2;
    }
    int ans = 0;
    for (int i = 0; i <= mx1; i++) {
        ans = max(ans, dp[0][i]);
    }
    cout << ans;
    return 0;
}