#include <iostream>
#include <algorithm>
#include <set>
using namespace std;

const int MAXN = 5003;

int n, m;
int l[MAXN], s[MAXN], c[MAXN];

bool st2 = 1;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> l[i];
        if (l[i] != 1) st2 = 0;
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++ i)
    {
        cin >> c[i];
    }
}

int maxp = 0;

void Rec(set<int> st, int p, int i, int mina = 1 << 20)
{
    // cout << i << endl;

    if (i == n + 1)
    {
        maxp = max(maxp, p);
        return;
    }

    Rec(st, p, i + 1, mina);

    if (mina < l[i]) return;

    if (st.count(l[i]) == 1)
    {
        p -= s[i];
        p += c[l[i]];

        int t = l[i];
        while (st.count(t) == 1)
        {
            st.erase(st.find(t));
            p += c[++t];
        }
        st.insert(t);
        Rec(st, p, i + 1, mina);
    }
    else
    {
        p -= s[i];
        p += c[l[i]];
        st.insert(l[i]);
        Rec(st, p, i + 1, min(mina, l[i]));
    }
}

void SolveST2()
{
    sort(s + 1, s + n + 1);
    set<int> st;

    int ans = 0, p = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (st.count(l[i]) == 1)
        {
            p -= s[i];
            p += c[l[i]];

            int t = l[i];
            while (st.count(t) == 1)
            {
                st.erase(st.find(t));
                p += c[++t];
            }
            st.insert(t);
        }
        else
        {
            p -= s[i];
            p += c[l[i]];
            st.insert(l[i]);
        }

        ans = max(ans, p);
    }

    cout << ans << endl;
}

int main()
{
    Init();

    if (st2)
    {
        SolveST2();
        return 0;
    }

    Rec({}, 0, 1);

    cout << maxp << endl;
    return 0;
}

