#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

namespace my_in_out {
	template <typename T>
	istream & operator>> (istream & in, vector <T> & a) {
		for (auto & i : a)
			in >> i;
		return in;
	}

	template <typename T>
	ostream & operator<< (ostream & out, vector <T> & a) {
		for (auto & i : a)
			out << i << " ";
		//out << endl;
		return out;
	}

	template <typename T1, typename T2>
	istream & operator>> (istream & in, pair <T1, T2> & a) {
		in >> a.f >> a.s;
		return in;
	}

	template <typename T1, typename T2>
	ostream & operator<< (ostream & out, pair <T1, T2> & a) {
		out << a.f << " " << a.s;
		return out;
	}
};

const ll INF = 1e9 + 7, MAXN = 2e5 + 5, pp = 32;
const ld EPS = 1e-9, PI = acos(-1);

void my_inp() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
}

using namespace my_in_out;

ll n, m;
vector <ll> a, s, c;

ll solve1(ll mask) {
	ll mx = INF, ans = 0;
	//cerr << bitset<5>(mask) << endl;
	for (ll i = 0; i < n; i++) {
		if ((mask & (1 << i)) && a[i] > mx)
			return -INF;
		else if ((mask & (1 << i))) {
			ans -= s[i];
			mx = a[i];
		}
	}

	vector <ll> pep;
	for (ll i = 0; i < n; i++) {
		if (mask & (1 << i))
			pep.pb(a[i]);
	}

	//cerr << bitset<5>(mask) << endl;
	//cerr << pep << endl;

	set <ll> st = {pep[0]};
	ans += c[pep[0] - 1];
	//cerr << ans << endl;

	for (ll i = 1; i < pep.size(); i++) {
		ll tk = pep[i];
		ans += c[tk - 1];
		//cerr << "tans : " << ans << endl;
		while (st.find(tk) != st.end()) {
			st.erase(tk);
			tk++; 
			ans += c[tk - 1];
		}

		st.insert(tk);
	}

	//cerr << "ans : " << ans << endl;
	return ans;
}

void solve2() {
	sort(all(s));
	ll sum = 0;
	ll tans = 0;
	
	vector <ll> dp(n + m);
	dp[0] = c[0];
	for (ll i = 1; i < n + m; i++)
		dp[i] = 2 * dp[i - 1] + c[i];
	//cerr << dp << endl;
	for (ll i = 0; i < n; i++) {
		sum += s[i];

		ll pep = 0;
		for (ll j = 0; j < min(n + m, 60LL); j++)
			if ((i + 1) & (1 << j)) {
				//cerr << i + 1 << " " << j << endl;  
				pep += dp[j];
			}
		tans = max(tans, pep - sum); 
	}	

	cout << tans << endl;
	exit(0);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//my_inp();

	cin >> n >> m;
	
	a.resize(n);
	s.resize(n);
	c.resize(n + m);
	
	cin >> a >> s >> c;

	if (m == 1)
		solve2();
	if (n <= 15) {
		ll ans = 0;
		for (ll i = 1; i < (1 << n); i++)
			ans = max(ans, solve1(i));
		cout << ans << endl;
		return 0;
	}

	return 0;
}