#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 15;
const int MAXM = 15;
const int INF = 1e9;

vector<int> l(MAXN);
vector<int> s(MAXN);
vector<int> c(MAXN + MAXM);

int ans = -INF;

void f(string sts, vector<int> people, int& n) {
	if ((int)sts.size() == n) {
		// проверка на невозрастание агрессивности
		bool flag = false;
		//cout << sts << endl; 
		for (int i = 1; i < (int)people.size(); i++) {
			if (l[people[i - 1]] < l[people[i]]) 
				flag = true;
		}
		if (flag)
			return;

		// симуляция шоу и получения значения прибыли
		int spent = 0;
		for (auto x: people) {
			spent += s[x];
		}

		int earned = 0;
		set<int> now; // хранит значения агрессивности людей, которые сейчас на сцене
		for (auto p: people) {
			earned += c[l[p] - 1];
			int agro = l[p] - 1;
			while (now.find(agro) != now.end()) {
				now.erase(agro);
				earned += c[agro + 1];
				agro++;
			}
			now.insert(agro); 
		}
		//cout << earned << ' ' << spent << endl;
		// /cout << endl;
		ans = max(ans, earned - spent);
		return;
	}
	f(sts + "0", people, n);
	people.push_back((int)sts.size());
	f(sts + "1", people, n);
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	// ввод
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> l[i];
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n + m; i++)
		cin >> c[i];

	vector<int> emp;
	f("", emp, n);
	cout << ans;
}