#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
#include <set>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int main() {
	int n, m;
	cin >> n >> m;

	vector<int> l(n), s(n), c(n + m);
	cin >> l >> s >> c;
	long long ans = 0;
	for (int i = 0; i < (1 << n); i++) {
		multiset<int> agr;
		bool flag = true;
		long long cur_ans = 0;
		int g_mn = INF;
		for (int j = 0; j < n; j++) {
			if ((i >> j) & 1) {
				if (!agr.empty() && l[j] > g_mn) {
					flag = false;
					break;
				} else {
					g_mn = l[j];
					cur_ans += c[l[j] - 1] - s[j];
					int cur_l = l[j];
					while (!agr.empty() && *agr.begin() == cur_l) {
						cur_ans += c[cur_l++];
						agr.erase(agr.begin());
					}
					agr.insert(cur_l);
				}
			}
		}

		if (flag) {
			ans = max(ans, cur_ans);
		}
	}

	cout << ans << '\n';
}