#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(1e6) + 8;
const ll mod = ll(1e9) + 7;
const ll p = 31;

ll n, m;
vector<ll> l;
vector<ll> s;
vector<ll> c;

void solve() {
    cin >> n >> m;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        l.pb(cur);
    }
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        s.pb(cur);
    }
    for(ll i = 0; i < n + m; i++) {
        ll cur;
        cin >> cur;
        c.pb(cur);
    }

    if(m == 1) {
        sort(s.begin(), s.end());

        vector<ll> tps;
        ll ans = 0;
        ll cur = 0;
        for(ll i = 0; i < n; i++) {
            cur += c[l[i] - 1] - s[i];
            tps.pb(l[i]);
            while(tps.size() > 1 && tps[tps.size() - 1] == tps[tps.size() - 2]) {
                tps.pop_back();
                ll nw = tps.back() + 1;
                tps.pop_back();
                cur += c[nw - 1];
                tps.pb(nw);
            }
            ans = max(ans, cur);
        }

        cout << ans << endl;
    } else {
        ll ans = 0;
        for(ll msk = 1; msk < (1 << n); msk++) {
            ll res = 0;
            vector<ll> cur;
            for(ll i = 0; i < n; i++) {
                if(msk & (1 << i)) {
                    cur.pb(i);
                }
            }

            vector<ll> tps;
            bool ok = true;
            for(auto i : cur) {
                res += c[l[i] - 1] - s[i];
                if(tps.size() > 0) {
                    if(l[i] > tps.back()) {
                        ok = false;
                        break;
                    }
                }
                tps.pb(l[i]);
                while(tps.size() > 1 && tps[tps.size() - 1] == tps[tps.size() - 2]) {
                    tps.pop_back();
                    ll nw = tps.back() + 1;
                    tps.pop_back();
                    res += c[nw - 1];
                    tps.pb(nw);
                }
            }
            if(ok) ans = max(ans, res);
        }
        cout << ans << endl;
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
