#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>

using namespace std;
constexpr int inf = 2e9;
vector <int> l, s, c;
vector <bool> used;

int ans = 0;

int get_fare()
{
    int ret = 0, cur_min = 0;
    stack <int> cur;
    for (int i = 0; i < used.size(); ++i)
    {
        if (!used[i])
            continue;

        int current = l[i];
        ret -= s[i];
        while (!cur.empty() && cur.top() == current)
        {
            ret += c[current++];
            cur.pop();
        }

        cur.push(current);
        ret += c[current];
    }

    return ret;
}

void rec(int ind, int cur_min)
{
    if (ind == used.size())
    {
        ans = max(ans, get_fare());
    }
    else
    {
        rec(ind + 1, cur_min);
        if (l[ind] <= cur_min)
        {
            used[ind] = true;
            rec(ind + 1, l[ind]);
            used[ind] = false;
        }
    }
}

int main()
{
    int n = 0, m = 0;
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m + 1);
    used.resize(n);

    for (int i = 0; i < n; ++i)
        cin >> l[i];
    for (int i = 0; i < n; ++i)
        cin >> s[i];
    for (int i = 1; i <= n + m; ++i)
        cin >> c[i];

    rec(0, inf);

    cout << ans;
    return 0;
}