#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 15;
const int MAXM = 15;

int lrr[MAXN];
int srr[MAXN];
int crr[MAXN + MAXM + 1];

int calc(int x) {
  int ans = 0;
  int i = 0;
  while (x > 0) {
    ans += crr[i] * x;
    x >>= 1;
    i++;
  }
  return ans;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n,  m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i)
    cin >> lrr[i];
  for (int i = 0; i < n; ++i)
    cin >> srr[i];
  for (int i = 0; i < n + m; ++i)
    cin >> crr[i + 1];
  if (n <= 15) {
    int finmask = (1<<n);
    int ans = -INT_MAX;
    for (int mask = 0; mask < finmask; ++mask) {
      int cans = 0;
      int lst = m + 1;
      bool isok = true;
      vector<int> sc;
      for (int i = 0; i < n; ++i) {
        if (!((mask>>i)&1))
          continue;
        if (lrr[i] > lst) {
          isok = false;
          break;
        }
        lst = lrr[i];
        cans += crr[lrr[i]] - srr[i];
        sc.push_back(lrr[i]);
      }
      if (!isok)
        continue;
      while (!sc.empty()) {
        int cnt = 0;
        int l = sc.back();
        while (!sc.empty() && l == sc.back()) {
          cnt++;
          sc.pop_back();
        }
        int ncnt = cnt / 2;
        int nl = l + 1;
        cans += crr[nl] * ncnt;
        for (int i = 0; i < ncnt; ++i)
          sc.push_back(nl);
      }
      if (cans > ans)
        ans = cans;
    }
    cout << ans;
  } else if (m == 1) {
    int ans = 0;
    int mxx = 0;
    for (int x = 0; x <= n; ++x) {
      int nans = calc(x);
      if (nans > ans)
        ans = nans, mxx = x;
    }
    sort(srr, srr + n);
    for (int i = 0; i < mxx; ++i)
      ans -= srr[i];
    cout << ans;
  }
  return 0;
}