#include<bits/stdc++.h>

using namespace std;

const int N = 2001;
const int M = 22;
const int INF = 1e9 + 239;

int c[N + M];
int dp[M][1 << M];
int ndp[M][1 << M];

int lm;

void proceed(int mask, int add, int &rmask, int &er) {
	if ((mask >> add) & 1) {
	  	proceed(mask ^ (1 << add), add + 1, rmask, er);
	  	er += c[add];
	} else {
		er = c[add];
		rmask = mask | (1 << add);
	}
}

void relax(pair<int, int> cd) {
	{	
		for (int wa = cd.first; wa < lm; wa++) {
			for (int mask = 0; mask < (1 << lm); mask++) {
				if (dp[wa][mask] == -INF) continue;
				int nmask;
				int nc;
				proceed(mask, cd.first, nmask, nc);
				nc -= cd.second;
				ndp[cd.first][nmask] = max(ndp[cd.first][nmask], dp[wa][mask] + nc);
			}
		}
		for (int wa = 0; wa < lm; wa++) {
			for (int mask = 0; mask < (1 << lm); mask++) {
				if (dp[wa][mask] == -INF) continue;
				ndp[wa][mask] = max(ndp[wa][mask], dp[wa][mask]);
			}
		}
	}
	for (int i = 0; i < lm; i++) {
		for (int j = 0; j < (1 << lm); j++) {
			dp[i][j] = ndp[i][j];
			ndp[i][j] = -INF;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif

	int n, kek;
	cin >> n >> kek;   
	vector<pair<int, int>> cd(n);
	for (auto &t : cd) cin >> t.first;
	for (auto &t : cd) cin >> t.second;
	for (int i = 1; i <= n + kek; i++) {
		cin >> c[i]; 	
	}
	lm = kek;
	{
		int tn = n;
		while (tn > 0) {
			lm++;
			tn /= 2;
		}
		lm++;	
	}
	//lm = M;
	//cerr << lm << endl;
	for (int i = 0; i < lm; i++) {
		for (int j = 0; j < (1 << lm); j++) {
			dp[i][j] = -INF;
			ndp[i][j] = -INF;
		}
	}
	dp[lm - 1][0] = 0;
	for (int i = 0; i < n; i++) {
		relax(cd[i]);
	}
	int ans = -INF;
	for (int i = 0; i < lm; i++) {
		for (int j = 0; j < (1 << lm); j++) {
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans << endl;	
}                                  