#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

const int inf = 1e9, logn = 15;
int n, m, ans = 0;
vector<int> a, s, c;

void relax(int &x, int y) {
	x = max(x, y);
}

int calc(int cnt1 = 0, int cnt2 = 0) {
	int b = 0, sas = 0;
	for (int i = 1; i <= n + m; i++) {
		b /= 2;
		if (i == 1) b += cnt1;
		if (i == 2) b += cnt2;
		sas += b * c[i];
	}
	return sas;
}

int solve1() {
	auto ss = s;
	sort(ss.begin(), ss.end());
	int ans = 0, curs = 0;
	for (int i = 0; i < n; i++) {
		curs -= ss[i];
		ans = max(ans, curs + calc(i + 1));
	}
	return ans;
}

signed main() {
	kekek;
	cin >> n >> m;
	a.resize(n);
	c.resize(n + m + 100, 0);
	s.resize(n);
	for (auto &i : a) {
		cin >> i;
	}
	for (auto &i : s) {
		cin >> i;
	}
	for (int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}

	if (m == 1) {
		cout << solve1();
		return 0;
	}
	reverse(a.begin(), a.end());
	reverse(s.begin(), s.end());

	vector<vector<int>> olddp(logn + m + 2, vector<int>(n + 2, -inf));
	olddp[1][0] = 0;
	for (int i = 0; i <= n; i++) {
		vector<vector<int>> dp(logn + m + 2, vector<int>(n + 2, -inf));
		for (int mx = 1; mx <= logn + m; mx++) {
			for (int cnt = 0; cnt <= n; cnt++) {
				if (olddp[mx][cnt] <= -inf) continue;

				//cout << "i = " << i << " mx = " << mx << " cnt = " << cnt << " dp = " << dp[i][mx][cnt] << '\n';

				relax(olddp[mx + 1][cnt / 2], olddp[mx][cnt] + (cnt / 2) * c[mx + 1]);

				if (i != n && a[i] == mx) {
					relax(dp[mx][cnt + 1], olddp[mx][cnt] - s[i] + c[mx]);
				}

				relax(dp[mx][cnt], olddp[mx][cnt]);
			}
		}
		if (i == n) {
			cout << max(0ll, olddp[logn + m + 1][0]);
			return 0;
		}

		dp.swap(olddp);
	}


	return 0;
}