#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;

typedef long long ll;

struct Elem
{
	ll cost, agr;
};

vector <ll> val, cost, tab;


bool cmp(const Elem &p1, const Elem &p2)
{
	return p1.cost < p2.cost;
}

ll kek(int level, int cnt){
	ll ans = 0;
	while (cnt){
		ans += tab[level + 1] * (cnt / 2);
		cnt /= 2;
		level++;
	}
	return ans;
}

int main()
{

	fstream cin("input.txt");
	ofstream cout("output.txt");

	ll n, m; cin >> n >> m;
	val.resize(n); cost.resize(n); tab.resize(n + m + 1);

	for (int i = 0; i < n; i++)
		cin >> val[i];
	for (int i = 0; i < n; i++)
		cin >> cost[i];
	for (int i = 1; i <= n + m; i++)
		cin >> tab[i];

	if (n <= 15)
	{
		ll ans = 0;
		for (int c = 1; c < (1 << n); c++)
		{
			vector <ll> cur, rofl;
			ll asd = 0;
			for (int j = 0; j < n; j++)
				if ((1 << j) & c) cur.push_back(j);

			rofl.push_back(cur[0]);
			for (int j = 1; j < cur.size(); j++)
				if (val[cur[j]] <= val[rofl.back()])
					rofl.push_back(cur[j]);

			for (int i = 0; i < rofl.size(); i++)
				asd -= cost[rofl[i]], asd += tab[val[rofl[i]]];

			vector <int> agr;
			for (int i = 0; i < rofl.size(); i++)
				agr.push_back(val[rofl[i]]);

			sort(agr.rbegin(), agr.rend());

			for (int i = agr.size() - 1; i > 0; i--)
			{
				if (agr[i] != agr[i - 1])
				{
					agr.pop_back();
					continue;
				}
				ll gh = agr[i] + 1;
				agr.pop_back(); agr.pop_back();
				agr.push_back(gh); asd += tab[gh];
				sort(agr.rbegin(), agr.rend());
			}

			ans = max(ans, asd);
		}
		cout << ans;
		return 0;
	}

	bool key = true;

	vector <Elem> List(n);

	for (int i = 0; i < n; i++)
		List[i] = { cost[i], val[i] };

	sort(List.begin(), List.end(), cmp);

	for (int i = 0; i < n; i++)
		if (List[i].agr != 1) key = false;

	if (key)
	{
		ll ans = 0, sum = 0, asd = 0, solve = 0;
		for (int i = 0; i < n; i++)
		{
			solve = 0;
			sum += List[i].cost, asd += tab[List[i].agr];
			int cnt = i + 1, level = 1;
			while (cnt)
			{
				solve += tab[level + 1] * (cnt / 2);
				cnt /= 2;
				level++;
			}
			ans = max(ans, solve - sum + asd);
		}

		cout << ans;
		return 0;
	}

	vector <Elem> less, more;
	for (int i = 0; i < n; i++)
		if (List[i].agr == 1) less.push_back(List[i]);
		else more.push_back(List[i]);

	sort(less.begin(), less.end(), cmp);
	sort(more.begin(), more.end(), cmp);

	ll sumless = 0, asdless = 0, ans = 0;
	for (int i = 0; i < less.size(); i++){
		sumless += less[i].cost, asdless += tab[less[i].agr];
		ans = max(ans, kek(1, i + 1) - sumless + asdless);
		ll summore = 0, asdmore = 0;
		for (int j = 0; j < more.size(); j++){
			summore += more[j].cost, asdmore += tab[more[j].agr];
			ans = max(ans, kek(2, j + 1) - summore + asdmore);
			ans = max(ans, kek(2, (i + 1) / 2 + j + 1) - summore - sumless + asdmore + asdless + tab[2] * (i + 1) / 2);
		}
	}

	cout << ans;

}