#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;
const int mod = 1e9 + 7;

int get_bit(int mask, int pos) {
    return (mask & (1LL << pos)) != 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(2 * n + m);
    rep(i, n) {
        cin >> l[i];
    }
    rep(i, n) {
        cin >> s[i];
    }
    rep(i, n + m) {
        cin >> c[i + 1];
    }
    int ans = 0;
    rep(mask, (1 << n)) {
        if (mask == 0) continue;
        int last = 1e10;
        bool flag = true;
        int res = 0;
        rep(i, n) {
            if (!get_bit(mask, i)) continue;
            if (l[i] > last) {
                flag = false;
                break;
            }
            last = l[i];
            res -= s[i];
        }
        if (!flag) continue;
        vector<int> agr = l;
        int podmask = mask;
        rep (i, n) {
            if (!get_bit(podmask, i)) continue;
            res += c[agr[i]];
            for (int j = i - 1; j >= 0; --j) {
                if (!get_bit(podmask, j)) continue;
                if (agr[i] == agr[j]) {
                    agr[i]++;
                    podmask ^= (1 << j);
                    res += c[agr[i]];
                }
            }
        }
        ans = max(ans, res);
    }
    cout << ans;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}