#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 5e3 + 100;


void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int f[maxn];

int getf(int k){
    int ans = 0;
    for (int bit = 20; bit >= 0; bit--){
        if ((k & (1 << bit)) > 0){
            ans += f[bit];
        }
    }
    return ans;
}

int main() {
    init();


    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m + 1);
    for (auto &ev: l)
        cin >> ev;
    for (auto &ev: s)
        cin >> ev;
    for (int i = 1; i < c.size(); i++){
        cin >> c[i];
    }

    if (n <= 16) {
        int ans = 0;
        for (int mask = 1; mask < (1 << n); mask++) {
            vector<int> cur;
            for (int i = 0; i < n; i++) {
                if ((mask & (1 << i)) > 0)
                    cur.pb(i);
            }
            bool usp = true;
            for (int i = 0; i < cur.size() - 1; i++) {
                if (l[cur[i + 1]] > l[cur[i]]) {
                    usp = false;
                    break;
                }
            }
            if (!usp)
                continue;
            int res = 0;
            for (auto ev: cur)
                res -= s[ev];

            unordered_set<int> scene;
            for (auto ev: cur) {
                res += c[l[ev]];
                int curl = l[ev];
                while (scene.count(curl)) {
                    scene.erase(curl);
                    curl++;
                    res += c[curl];
                }
                scene.insert(curl);
            }
            ans = max(ans, res);
        }
        cout << ans << endl;
        return 0;
    }

    int ans = 0;
    f[0] = c[1];
    for (int i = 1; (1 << i) <= n + m; i++){
        f[i] = 2*f[i - 1] + c[i + 1];
    }

    sort(all(s));
//    for (int i = 1; i<= n; i++){
//        cout << getf(i) << " ";
//    }
//    cout << endl;

    int cursum = 0;
    for (int i = 0; i< n; i++){
        cursum += s[i];
        ans = max(ans, getf(i + 1) - cursum);
    }
    cout << ans << endl;

    return 0;

}