#include <bits/stdc++.h>
#define int long long
#define endl '\n'

// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("unswitch-loops")
// #pragma GCC target("avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	fast();

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();
}

bool check(int mask, vector <int> angry) {
	int mn = 100000;
	for (int i = 0; i < angry.size(); ++i) {
		if (mn < angry[i] && ((mask >> i) & 1))
			return false;
		mn = min(mn, angry[i]);
	}

	return true;
}

void solve() {

	int n, m;
	cin >> n >> m;

	vector <int> angry(n);

	for (auto &d: angry)
		cin >> d;

	vector <int> cost(n);

	for (auto &d: cost)
		cin >> d;

	vector <int> doh(n + m);

	for (auto &d: doh)
		cin >> d;

	int mx = -1000000;

	for (int mask = 1; mask < (1 << n); ++mask) {
		// if (mask != 31)
		// 	continue;
		if (check(mask, angry)) {
			int sum = 0;
			for (int i = 0; i < n; ++i) 
				if ((mask >> i) & 1)
					sum -= cost[i];

			vector <int> ans1;
			
			for (int i = 0; i < n; ++i) 
				if ((mask >> i) & 1) 
					ans1.push_back(angry[i]);

			for (int i = 0; i < ans1.size(); ++i) 
				sum += doh[ans1[i] - 1];

			// cout << sum << endl;

			bool flag = true;
			while (flag) {

				flag = false;

				for (int i = 0; i < ans1.size(); ++i) {
					for (int j = i + 1; j < ans1.size(); ++j) {
						if (ans1[i] == ans1[j] && ans1[j] != -1) {
							flag = true;
							ans1[j] = -1;
							sum += doh[ans1[i]];
							ans1[i]++;
						}
					}
				}
			}

			// cout << mask << " " << sum << endl;

			mx = max(mx, sum);
		}
	}

	cout << mx;
}