#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


const int INF = (int)1e9;


const int MAXN = 2001;


int loss[MAXN];
int c[2 * MAXN];
int psum[2 * MAXN + 1];
vector<int> a, s;


int ones(int i) {
    int res = 0;
    int cur = i;
    int pow = 0;
    while (cur) {
        res += c[pow] * cur;

        cur /= 2;
        ++pow;
    }

    return res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    a.resize(n);
    s.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];

        --a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    for (int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }

    for (int i = 0; i < 2 * MAXN; ++i) {
        psum[i + 1] = psum[i] + c[i];
    }

    reverse(a.begin(), a.end());
    reverse(s.begin(), s.end());

    for (int i = 1; i < MAXN; ++i) {
        for (int j = 1; j <= i; ++j) {
            loss[i] += (1 << j) * c[i - j];
        }
    }

    for (int i = 0; i < n; ++i) {
        s[i] += loss[a[i]];
    }

    if (n <= 15) {
        int answ = 0;

        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<int> take(n);
            int cm = mask;
            for (int i = 0; i < n; ++i) {
                take[i] = cm % 2;

                cm /= 2;
            }

            int ppc = 0;
            int last = 0;
            int cur = 0;

            bool can = true;
            for (int i = 0; i < n; ++i) {
                if (!take[i]) {
                    continue;
                }

                if (a[i] < last) {
                    can = false;

                    break;
                }

                last = a[i];

                ppc += (1 << a[i]);
                cur -= s[i];
            }

            if (!can) {
                continue;
            }

            cur += ones(ppc);

            if (cur > answ) {
                answ = cur;
            }
        }

        cout << answ;

        return 0;
    }

    return 0;
}

/*

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -100 -5 3 10 -4

*/