#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define str string
#define ld long double
using namespace std;

const int INF = 1e17;

int dp[2001][2001];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> L(1 + n), S(1 + n), C(1 + n + m), pref(1 + n + m);
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> S[i];
    }
    for (int i = 1; i <= n + m; i++) {
        cin >> C[i];
        pref[i] = pref[i - 1] + C[i];
    }
    for (int i = 1; i <= n; i++) {
        for (int d = 1; d <= m; d++) {
            dp[i][d] = -INF;
        }
    }
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int d = 0; d <= m; d++) {
            if (d == 0) {
                for (int j = 1; j < i; j++) {
                    if (L[j] == L[i]) {
                        int d2 = 1;
                        while (dp[j][d2] != -INF && d2 <= m) {
                            dp[i][d] = max(dp[i][d], dp[j][d2] + pref[L[i] + d2] - pref[L[i]] - S[i] + C[L[i]]);
                            d2++;
                        }
                    }
                }
            } else if (d == 1) {
                dp[i][d] = max(dp[i][d], -S[i] + C[L[i]]);
                for (int j = 1; j < i; j++) {
                    if (L[j] > L[i] + 1) {
                        int d2 = 0;
                        while (dp[j][d2] != -INF && d2 <= m) {
                            dp[i][d] = max(dp[i][d], dp[j][d2] - S[i] + C[L[i]]);
                            d2++;
                        }
                    } else if (L[j] == L[i] + 1) {
                        dp[i][d] = max(dp[i][d], dp[j][d - 1] - S[i] + C[L[i]]);
                    }
                }
            } else {
                for (int j = 1; j < i; j++) {
                    if (L[j] == L[i] + 1) {
                        dp[i][d] = max(dp[i][d], dp[j][d - 1] - S[i] + C[L[i]]);
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int d = 0; d <= m; d++) {
            ans = max(ans, dp[i][d]);
        }
    }
    cout << ans;
}