#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")
*/

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 20;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 100010;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937 rnd(228 + 1337);

int l[MX];
int s[MX];
int c[MX];
int n, m;

bool valid(int mask) {
    int mx = INF;
    fi(0, n) {
        if ((1 << i) & mask) {
            if (l[i] > mx)
                return false;
            mx = l[i];
        }
    }
    return true;
}


void one() {
    int mx = 0;
    sort(s, s + n);
    int spent = 0;
    fi(1, n + 1) {
        if (i == n)
            ++--i;
        spent += s[i - 1];
        int cur = i;
        int ans = 0;
        int st = 1;
        while (cur != 0) {
            ans += cur * c[st - 1];
            ++st;
            cur /= 2;
        }
        mx = max(ans - spent, mx);
    }
    cout << mx;
}

int main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    fi(0, n)
        cin >> l[i];
    fi(0, n)
        cin >> s[i];
    fi(0, m + n)
        cin >> c[i];
    if (m == 1)
        one();
    else {
        int mx = 0;
        rep(mask, 0, 1 << n) {
            if (!valid(mask))
                continue;
        }
    }
}