#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <ctime>

using namespace std;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <int> l(n), s(n);
	for (auto& u : l)
		cin >> u, u--;
	for (auto& u : s)
		cin >> u;
	vector <int> c(n + m);
	for (auto &u : c)
		cin >> u;
	long long ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		long long cost = 0;
		int prev = 20'001;
		bool cor = 1;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (l[i] > prev)
					cor = 0;
				prev = l[i];
			}
		}
		if (!cor) continue;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i))
				cost -= s[i];
		}
		vector <int> st;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				cost += c[l[i]];
				int val = l[i];
				while (st.size() && st.back() == val) {
					st.pop_back();
					cost += c[++val];
				}
				st.push_back(val);
			}
		}
		ans = max(ans, cost);
	}
	cout << ans;
}