#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct State {
    int profit;
    int given;
    int taken;
    int prev;
};

int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    l.resize(n);
    for (int &i : l) cin >> i;
    s.resize(n);
    for (int &i : s) cin >> i;
    c.resize(n + m + 1);
    for (int i = 1; i <= n + m; i++) cin >> c[i];

    vector<State> dp(n);
    for (int i = 0; i < n; i++) {
        if (c[l[i]] - s[i] > 0) {
            dp[i].profit = c[l[i]] - s[i];
            dp[i].taken = c[l[i]];
            dp[i].given = s[i];
        } else {
            dp[i].profit = 0;
            dp[i].taken = 0;
            dp[i].given = 0;
        }
        dp[i].prev = -1;
        for (int j = i - 1; j >= 0; j--) {
            if (l[i] <= l[j]) {
                int givenMoney = dp[j].given + s[i];
                int takenMoney = 0;
                map<int, int> agresses;
                agresses[l[i]]++;
                int person = j;
                while (person != -1) {
                    agresses[l[person]]++;
                    person = dp[person].prev;
                }
                for (auto &k : agresses) {
                    takenMoney += k.first * k.second;
                }
                for (auto &k : agresses) {
                    if (k.second == 1) continue;
                    int cnt = k.second >> 1;
                    takenMoney += cnt * (k.first + 1);
                    agresses[k.first] &= 1;
                    agresses[k.first + 1] += cnt;
                }

                if (takenMoney - givenMoney > dp[i].profit) {
                    dp[i].profit = takenMoney - givenMoney;
                    dp[i].given = givenMoney;
                    dp[i].taken = takenMoney;
                    dp[i].prev = j;
                }
            }
        }
    }

    int answer = 0;
    for (int i = 0; i < n; i++) {
        answer = max(answer, dp[i].profit);
    }

    cout << answer << endl;

    return EXIT_SUCCESS;
}
