#include <bits/stdc++.h>
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define pb push_back
#define fst first
#define snd second
#define all(c) c.begin(), c.end()
using namespace std;
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
typedef long long ll;
typedef long double ld;
const int INF32 = 1e9 + 228;
const ll INF64 = 2e18 + 228;
mt19937 rng(time(0));
uniform_int_distribution<int> rnd(1, 2);
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<ll> l(n), s(n), c(n + m);
    vector<pair<int, int> > ch(n);
    for(int i = 0; i < n; i++)
    {
        cin >> l[i];
        l[i]--;
        ch[i].fst = l[i];
    }
    for(int i = 0; i < n; i++)
    {
        cin >> s[i];
        ch[i].snd = s[i];
    }
    for(int j = 0; j < n + m; j++)
        cin >> c[j];
    if(m == 1)
    {
        sort(all(ch), [](const pair<int, int> &a, const pair<int, int> &b)
             {
                return a.snd == b.snd ? a.fst < b.fst : a.snd < b.snd;
             });
        ll startprice = 0;
        ll best = 0;
        for(int cnt = 0; cnt < n; cnt++)
        {
            startprice -= ch[cnt].snd;
            ll ans = (cnt + 1) * c[0];
            ll last = cnt + 1;
            for(int j = 1; j <= cnt; j++)
            {
//                cout << (last) / 2  << " " << c[j] << "\n";
                ans += (last) / 2 * c[j];
                last = last / 2;
            }
            best = max(best, ans + startprice);
        }
        cout << best << "\n";
        return 0;
    }
    int mask = 0;
    int lim = (1 << n);
    ll best = 0;
    while(mask != lim)
    {
        vector<int> pos;
        ll ans = 0;
        for(int i = 0; i < n; i++)
            if((mask >> i) & 1)
            {
                pos.pb(i);
                ans -= s[i];
            }
        int take = pos.size();
        bool bad = 0;
        for(int j = 1; j < take; j++)
        {
            if(l[pos[j - 1]] < l[pos[j]])
            {
                bad = 1;
                break;
            }
        }
        if(bad)
        {
            mask++;
            continue;
        }
        multiset<int> curagr;
        for(int j = 0; j < take; j++)
        {
            ll ouragr = l[pos[j]];
            ans += c[ouragr];
//            cout << c[ouragr] << " ";
            curagr.insert(ouragr);
        }
        bool smth = 1;
        while(smth)
        {
            smth = 0;
            for(auto& it : curagr)
            {
                if(curagr.count(it) > 1)
                {
                    curagr.erase(curagr.lower_bound(it));
                    curagr.erase(curagr.lower_bound(it));
                    ans += c[it + 1];
                    curagr.insert(it + 1);
                    smth = 1;
                    break;
                }
            }
        }
//        cout << "\n";
//        for(int j = 0; j < take; j++)
//        {
//            cout << l[pos[j]] << " ";
//        }
//        cout << "\n";
//        cout << ans << "\n";
//        cout << "\n";
        best = max(best, ans);
        mask++;
    }
    cout << best;
    return 0;
}
