#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second
typedef vector<bool> vb;

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int inf = 1e9;
#define int long long

void solve() {
    int n, m;
    cin >> n >> m;
    vi l(n), s(n), c(n + m);
    forn(i, n) cin >> l[i];
    forn(i, n) cin >> s[i];
    forn(i, n + m) cin >> c[i];
    int ans = 0;
    forn(mask, 1 << n) {
        bool flag = 1;
        int sum = 0;
        vi L;
        forn(i, n) {
            if (mask & (1 << i)) {
                if (!L.empty() && l[i] > L.back()) {
                    flag = 0;
                    break;
                }
                sum -= s[i];
                sum += c[l[i] - 1];
                L.pb(l[i]);
                while (L.size() >= 2 && L[L.size() - 1] == L[L.size() - 2]) {
                    int x = L.back();
                    sum += c[x];
                    L.pop_back();
                    L.pop_back();
                    L.pb(x + 1);
                }
            }
        }
        if (flag) ans = max(ans, sum);
    }
    cout << ans << '\n';
}

bool multitest = false;

signed main() {
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}