#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n, m;
vector<int> l;
vector<int> s;
vector<int> c;

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    init(l, n);
    for (auto & it : l) {
        cin >> it;
    }

    init(s, n);
    for (auto & it : s) {
        cin >> it;
    }

    init(c, n + m + 1);
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }

    //vector<vector<set<int>>> take(n);
    vector<set<int>> take(n);
    vector<int> dp(n, -INF_INT);

    dp[0] = c[l[0]] - s[0];
    take[0].insert(l[0]);
    for (int i = 1; i < n; ++i) {
        for (int prev = 0; prev < i; ++prev) {
            if (l[prev] >= l[i]) {
                int curr_ans = dp[prev] - s[i] + c[l[i]];

                set<int> tmp = take[prev];

                int now = l[i];

                while (tmp.count(now)) {
                    tmp.erase(now);
                    ++now;
                    curr_ans += c[now];
                }
                tmp.insert(now);

                if (chkmax(dp[i], curr_ans)) {
                    take[i] = tmp;
                }
            }
        }
    }

    cout << *max_element(all(dp)) << '\n';
    return;

    int ans = max(0, *max_element(all(dp)));

    cout << ans << '\n';
}