#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

constexpr int INF = 1e9 + 8;

void solve15(int n, int m) {
    vector<int> L(n), s(n), c(m + n + 2);
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= m + n; i++) cin >> c[i];
    int ans = 0;
    for (int msk = 0; msk < (1 << n); msk++) {
        vector<int> cnt(n + m + 2);
        int cans = 0;
        int mn = INF;
        for (int i = 0; i < n; i++) {
            if ((msk & (1 << i)) && (L[i] <= mn)) {
                cnt[L[i]]++;
                cans -= s[i];
                mn = min(L[i], mn);
            }
        }
        for (int i = 0; i <= n + m; i++) {
            cans += cnt[i] * c[i];
            cnt[i + 1] += cnt[i] / 2;
        }
        ans = max(cans, ans);
    }
    cout << ans << '\n';
}

void solve1(int n, int m) {
    vector<int> L(n), s(n), c(m + n + 2);
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= m + n; i++) cin >> c[i];
    vector<int> pr(n + 1);
    for (int cn = 1; cn <= n; cn++) {
        int ccnt = cn;
        int j = 0;
        int cans = 0;
        while (ccnt > 0) {
            cans += ccnt * c[j + 1];
            j++;
            ccnt /= 2;
        }
        pr[cn] = cans;
    }
    sort(all(s));
    int ans = 0;
    int cd = 0;
    for (int i = 0; i < n; i++) {
        cd -= s[i];
        int cans = cd + pr[i + 1];
        ans = max(ans, cans);
    }
    cout << ans << '\n';
}

void run() {
    int n, m;
    cin >> n >> m;
    if (n <= 15) {
        solve15(n, m);
    } else {
        solve1(n, m);
    }
}

signed main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}