#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}
#define int ll
const int MAXN = 2010;
int n, m;
int l[MAXN];
int s[MAXN];
int c[MAXN * 2];
int ans;

void read() {
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		l[i]--;
	}
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n + m; i++)
		cin >> c[i];
}

pair<int, int> calc(int k, int last, int now) {
	pair<int, int> ans = {0, 0};
	while (k > 0 && last != now) {
		k /= 2;
		last++;
		ans.first += c[last] * k;
	}
	if (last == now)
		ans.second += k;
	return ans;
}

const int INF = -1e18;

void run() {
	ans = 0;
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (m, vector<int> (n + 1, INF)));
	for (int j = 0; j < m; j++) {
		dp[n][j][0] = 0;
	}

	for (int i = n - 1; i >= 0; i--) {
		for (int j = 0; j < m; j++) {
			for (int k = 0; k <= n; k++) {
				chkmax(dp[i][j][k], dp[i + 1][j][k]);
				if (j <= l[i] && dp[i + 1][j][k] != INF) {
					int fans = dp[i + 1][j][k];
					fans -= s[i];
					fans += c[l[i]];
					auto help = calc(k, j, l[i]);
					fans += help.first;
					chkmax(dp[i][l[i]][1 + help.second], fans);
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = 0; k <= n; k++) {
				if (dp[i][j][k] != INF) {
					int fans = dp[i][j][k] + calc(k, j, -INF).first;
					chkmax(ans, fans);
				}
			}
		}
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

/*

3 3
1 1 1
0 0 0
1 1 1 1 1 1


5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100


*/