#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;
using namespace __gnu_pbds;

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(time(0));

const int N = 2e2 + 234;
const int M = 1e9 + 7;

int dp[N][N][N];

int l[N], c[N], s[N];

bool u[N][N][N];

int n, m;

void solve() {
    sort(s, s + n);
    lll ans = 0;
    lll now = 0;
    lll cur;
    int cnt;
    for (int i = 0; i < n; ++i) {
        now -= s[i];
        now += c[1];
        cur = now;
        cnt = i + 1;
        for (int j = 2; j <= min(30, n + m); ++j) {
            cur += c[j] * cnt;
            cnt /= 2;
        }
        ans = max(ans, cur);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    if (m == 1) {
        solve();
        return 0;
    }
    reverse(l, l + n);
    reverse(s, s + n);
    u[0][0][0] = 1;
    for (int i = 0; i <= n; ++i) {
        for (int last = 0; last <= n + m; ++last) {
            for (int j = 0; j <= n; ++j) {
                if (!u[i][last][j]) {
                    continue;
                }
                if (i < n && !u[i + 1][last][j] || dp[i + 1][last][j] < dp[i][last][j]) {
                    dp[i + 1][last][j] = dp[i][last][j];
                    u[i + 1][last][j] = 1;
                }
                if (i < n && last == l[i]) {
                    if (!u[i + 1][last][j + 1] || dp[i + 1][last][j + 1] < dp[i][last][j] + c[l[i]] - s[i]) {
                        dp[i + 1][last][j + 1] = dp[i][last][j] + c[l[i]] - s[i];
                        u[i + 1][last][j + 1] = 1;
                    }
                }
                if (!u[i][last + 1][j / 2] || dp[i][last + 1][j / 2] < dp[i][last][j] + c[last + 1] * (j / 2)) {
                    dp[i][last + 1][j / 2] = dp[i][last][j] + c[last + 1] * (j / 2);
                    u[i][last + 1][j / 2] = 1;
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n + m; ++j) {
            for (int k = 0; k <= 1; ++k) {
//                if (dp[i][j][k]) {
//                    cout << i << ' ' << j << ' ' << k << ' ' << dp[i][j][k] << endl;
//                }
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans;
    return 0;
}
