#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

//#define int long long

const int N = 4000 + 7;
const int M = 2 * N;

int n, m;
int l[N], s[N], c[M];
int dp[N][N];
int kek[M][N];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    for (int i = M - 2; i >= 0; --i) {
        for (int j = 0; j < N - 1; ++j) {
            kek[i][j] = kek[i + 1][j / 2] + j / 2 * c[i + 1];
        }
    }
    l[0] = 1e9;
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            int rt = 0;
            for (int k = 0; k < i; ++k) {
                if (l[k] > l[i] + 1) {
                    rt = max(rt, dp[k][0]);
                }
            }
            dp[i][j] = kek[l[i]][j + 1] + c[l[i]] - s[i] + rt;
            for (int k = 0; k < i; ++k) {
                if (l[i] == l[k]) {
                    dp[i][j] = max(dp[i][j], dp[k][j + 1] + c[l[i]] - s[i]);
                }
                if (l[i] + 1 == l[k]) {
                    dp[i][j] = max(dp[i][j], dp[k][(j + 1) / 2] + (j + 1) / 2 * c[l[i] + 1] + c[l[i]] - s[i]);
                }
            }
        }
        ans = max(ans, dp[i][0]);
    }
    cout << ans << '\n';
    return 0;
}