#include "bits/stdc++.h"

#define ll long long
#define vi vector<ll>
#define ld long double
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>
#define mx(a, b) a = max(a, b)
const ll MAXN = 201;
const ll inf = (ll)1e18;
const ld PI = acos(-1);

using namespace std;

template<class T>
void read(vector<T> &a) {
    for (auto &i : a) cin >> i;
}

template<class T>
void write(vector<T> &a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

void solve() {
    ll n, m; cin >> n >> m;
    vi c(n); read(c);
    vvi graph(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u; cin >> v >> u;
        v--, u--;
        graph[u].pb(v);
    }
    map<set<ll>, ll> cnt;
    for (ll i = 0; i < n; ++i) {
        set<ll> k;
        for (ll u : graph[i]) k.insert(u);
        if (cnt.find(k) == cnt.end()) cnt[k] = 0;
        cnt[k] += c[i];
    }
    ll ans = 0;
    for (auto i : cnt) ans = __gcd(ans, i.second);
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    ll t; cin >> t;
    while(t--)
    solve();

    return 0;
}