import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

import static java.lang.Math.max;

public class A1 {
    static BufferedReader in;
    static StringTokenizer st;
    static int l[], s[], c[];
    static int n, m;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        n = nextInt();
        m = nextInt();
        l = new int[n];
        s = new int[n];
        c = new int[n + m];
        fn();
        for (int i = 0; i < n; i++) {
            l[i] = nextInt() - 1;
        }
        fn();
        for (int i = 0; i < n; i++) {
            s[i] = nextInt();
        }
        fn();
        for (int i = 0; i < n + m; i++) {
            c[i] = nextInt();
        }
        int ans = 0;
        if (m != 1) {
            for (int i = 1; i < (1 << n); i++) {
                ans = max(ans, fk(i));
            }
        } else {
            Arrays.sort(s);
            for (int i = 1; i <= n; i++) {
                ans = max(ans, fr(i));
            }
        }
        System.out.println(ans);
    }

    private static int fr(int x) {
        int sum = 0;
        for (int i = 0; i < x; i++) {
            sum -= s[i];
        }
        int ms[] = new int[n + m];
        ms[0] = x;
        for (int i = 0; i < n + m; i++) {
            if (ms[i] == 0) break;
            sum += ms[i] * c[i];
            if (i != n + m - 1) ms[i + 1] += ms[i] / 2;
        }
        return sum;
    }

    private static int fk(int msk) {
        int pr = 1000000;
        int sum = 0;
        int ms[] = new int[n + m];
        for (int i = 0; i < n; i++) {
            if ((msk & (1 << i)) > 0) {
                if (pr < l[i]) return 0;
                pr = l[i];
                sum -= s[i];
                ms[l[i]]++;
            }
        }
        for (int i = 0; i < n + m; i++) {
            sum += ms[i] * c[i];
            if (i != n + m - 1) ms[i + 1] += ms[i] / 2;
        }
        return sum;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
