#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

const int N = 500;
const ll inf = 1e18;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

int n, m;
vector <int> l, s, c;

void solve1() {
    int sans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {

        vector <int> agr;
        int ans = 0, mi = 1e9;
        for (int i = 0; i < n; i++) {
            if (!(mask & (1 << i)) || l[i] > mi)
                continue;

            mi = min(mi, l[i]);

            ans += c[l[i]];
            ans -= s[i];
            agr.push_back(l[i]);
            while (agr.size() > 1u && agr.back() == agr[agr.size() - 2]) {
                int nl = agr.back() + 1;
                ans += c[nl];
                agr.pop_back();
                agr.pop_back();
                agr.push_back(nl);
            }
            sans = max(sans, ans);
        }
    }
    cout << sans;
}

void solve2() {
    solve1();
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    l.assign(n, 0);
    s.assign(n, 0);
    c.assign(n + m + 1, 0);
    for (int& x: l)
        cin >> x;
    for (int& x: s)
        cin >> x;
    for (int i = 1; i <= n + m; i++)
        cin >> c[i];

    if (n <= 15 && m <= 15)
        solve1();
    else
        solve2();

    return 0;
}
