//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2")


#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (X).rend()
ll mx(ll &a, ll &b) { return (a < b ? a = b : a); }
ll mn(ll &a, ll &b) { return (a > b ? a = b : a); }

pair<char, char> elem[100][100];
map<pair<char, char>, int> pref[100][100];

map<pair<char, char>, int> operator-(const map<pair<char, char>, int> &a, const map<pair<char, char>, int> &b) {
    map<pair<char, char>, int> ans = a;
    for(auto &i : b) ans[i.first] -= i.second;
    return ans;
}

map<pair<char, char>, int> operator+(const map<pair<char, char>, int> &a, const map<pair<char, char>, int> &b) {
    map<pair<char, char>, int> ans = a;
    for(auto &i : b) ans[i.first] += i.second;
    return ans;
}

int get_elements(int lx, int ly, int rx, int ry) {
    map<pair<char, char>, int> now = pref[rx][ry];
    if(ly != 0) now = now - pref[rx][ly - 1];
    if(lx != 0) now = now - pref[lx - 1][ry];
    if(ly != 0 && lx != 0) now = now + pref[lx - 1][ly - 1];
    ll ans = 0;
    for(auto &i : now) ans += i.second != 0;
    return ans;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//freopen("input.txt", "r", stdin);
//freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;
    vector<ll>a(n);
    for(auto &i : a) cin >> i;
    vector<ll>cost(n);
    for(auto &i : cost) cin >> i;
    vector<ll>get(n + m);
    for(auto &i : get) cin >> i;
    if(m == 1) {
        vector<pll> members;
        for (int i = 0; i < n; i++) members.emplace_back(a[i], cost[i]);
        vector<ll>pref(n + m);
        pref[0] = get[0];
        for(int i = 1; i < n + m; i++) pref[i] = pref[i - 1] + get[i];
        sort(all(members), [&](pll a, pll b) { return a.second < b.second; });
        ll ans = 0;
        ll now = 0;
        ll cnt_members = 0;
        auto find_first_zero = [](ll number) {
            for(int i = 0; i < 13; i++)
                if((number & (1 << i)) == 0)
                    return i;
        };
        for(auto &[l, price] : members) {
            now -= price, now += get[l - 1];
            ll zero = find_first_zero(cnt_members);
            cnt_members++;
            if(zero > 0) now += pref[zero - 1];
            mx(ans, now);
        }
        cout << ans;
        return 0;
    }
    if(n <= 15 && m <= 15) {
        ll ans = 0;
        for(ll mask = 0; mask < (1 << n); mask++) {
            ll now = 0;
            vector<ll> a1;
            map<ll, ll> persons;
            for (int i = 0; i < n; i++) if ((1 << i) & mask) a1.push_back(a[i]), persons[a[i]]++, now -= cost[i], now += get[a[i] - 1];
            for(int i = 0; i < a1.size(); i++) {
                if(a1[i] > a1[i - 1]) a1.clear();
            }
            if(a1.empty()) continue;
            while(persons.size() != a1.size()) {
                for(int i = 0; i < a1.size() - 1; i++) {
                    if(persons[a1[i]] > 1) {
                        a1[i]++;
                        now += get[a1[i] - 1];
                        a1.erase(find(all(a1), a1[i] - 1));
                        persons[a1[i] - 1] -= 2;
                        if(persons[a1[i] - 1] == 0) persons.erase(a1[i] - 1);
                        persons[a1[i]]++;
                        break;
                    }
                }
            }
            mx(ans, now);
        }
        cout << ans;
        return 0;
    }

    return 0;
}