#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include  <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>

using namespace std;

struct pers
{
    int aggr;
    int price;
};
vector <long long int> money;
bool operator < (pers one, pers two)
{
    if (one.aggr == two.aggr)
        return(one.price < two.price);
    return(one.aggr < two.aggr);
}
struct par
{
    multiset <pers> ed;
    multiset <pers> dv;
};
int getAns(int n, int m, int ind2, int ind1, vector <par> sorted)
{
    int bestAns = 0;
    for (int i = ind2 + 1; i < ind1; i++)
    {
        // dv - sorted[i].dv; ed - sorted[i].ed;
        multiset <pers> :: iterator now;
        now = sorted[i].dv.begin();
        int ans = 0;
        for (int w = 0; w < m; w++)
        {
            ans = ans + money[(*now).aggr] - (*now).price;
            now++;
        }
        now = sorted[i].ed.begin();
        for (int w = 0; w < n; w++)
        {
            ans = ans + money[(*now).aggr] - (*now).price;
            now++;
        }
        int m1 = m;
        ans = ans + (n / 2) * money[2];
        m1 = m1 + n / 2;
        int k = 2;
        while (m1 > 1)
        {
            m1 = m1 / 2;
            k++;
            ans = ans + m * k;
        }
        bestAns = max(ans, bestAns);
    }
    return(bestAns);
}
int fight(int n)
{
    int sum = n * money[1];
    int k = 2;
    while (n > 1)
    {
        n = n / 2;
        sum = sum + n * money[k];
        k++;
    }
    return(sum);
}

int main()
{
    long long int n, m, i, j;
    cin >> n >> m;if (m == 1)
    {
        pers a[n];
        for (i = 0; i < n; i++)
        {
            cin >> a[i].aggr;
        }
        for (i = 0; i < n; i++)
        {
            cin >> a[i].price;
        }
        money.resize(n + m + 1);
        for (i = 1; i <= n + m; i++)
        {
            cin >> money[i];
        }
        stable_sort(a, a + n);
        int pref[n + 1];
        pref[0] = 0;
        for (i = 1; i <= n; i++)
        {
            pref[i] = pref[i - 1] + a[i - 1].price;
        }
        int ans = 0;
        for (i = 0; i <= n; i++)
        {
            ans = max(ans, fight(i) - pref[i]);
        }
        cout << ans;
        return 0;
    }
    if (m <= 2)
    {
        pers a[n];
        int ed, dv;
        ed = dv = 0;
        for (i = 0; i < n; i++)
        {
            cin >> a[i].aggr;
            ed = ed + (a[i].aggr == 1);
            dv = dv + (a[i].aggr == 2);
        }
        for (i = 0; i < n; i++)
        {
            cin >> a[i].price;
        }
        money.resize(n + m + 1);
        for (i = 1; i <= n + m; i++)
        {
            cin >> money[i];
        }
        vector <par> pref(n + 1);
        for (i = 1; i <= n; i++)
        {
            pref[i].dv = pref[i - 1].dv;
            if (a[i - 1].aggr == 2)
            {
                pref[i].dv.insert(a[i - 1]);
            }
        }
        for (i = n - 1; i >= 0; i--)
        {
            pref[i].ed = pref[i + 1].ed;
            if (a[i].aggr == 1)
            {
                pref[i].ed.insert(a[i]);
            }
        }
        unordered_map <int, int> cou1, cou2;
        int num2 = 0, num1 = 0;
        cou2[0] = 0;
        cou1[0] = n;
        for (i = 1; i <= n; i++)
        {
            if (a[i - 1].aggr == 2)
            {
                cou2[num2 + 1] = i;
                num2++;
            }
            if (a[n - i].aggr == 1)
            {
                cou1[num1 + 1] = n - i;
                num1++;
            }
        }
        int ans = 0;
        for (i = 0; i <= ed; i++)
        {
            for (j = 0; j <= dv; j++)
            {
                if (cou2[j] <= cou1[i])
                {
                    ans = max(ans, getAns(i, j, cou2[j], cou1[i], pref));
                }
            }
        }
        cout << ans;
        return 0;
    }
    long long int aggr[n];
    for (i = 0; i < n; i++)
    {
        cin >> aggr[i];
    }
    long long int price[n];
    for (i = 0; i < n; i++)
    {
        cin >> price[i];
    }
    money.resize(n + m + 1);
    for (i = 1; i <= n + m; i++)
    {
        cin >> money[i];
    }
    long long int ans = -1e18;
    for (i = 0; i < (1 << n); i++)
    {
        long long int up = 0;
        set <long long int> onScene;
        bool checker = true;
        long long int minBef = 1e18;
        for (j = 0; j < n; j++)
        {
            if (i & (1 << j))
            {
                if (aggr[j] > minBef)
                {
                    checker = false;
                    break;
                }
                minBef = min(minBef, aggr[j]);
                up = up - price[j] + money[aggr[j]];
                int toAdd = aggr[j];
                while (onScene.find(toAdd) != onScene.end())
                {
                    onScene.erase(onScene.find(toAdd));
                    toAdd++;
                    up = up + money[toAdd];
                }
                onScene.insert(toAdd);
            }
        }
        if (checker)
            ans = max(ans, up);
    }
    cout << ans;
    return 0;
}
