#include <iostream>
#include <algorithm>
using namespace std;
#define MAXN 2005
#define endl '\n'
const int INF = (1 << 30);
int br, agress;
int price[MAXN];
int getty[MAXN];
int prefix[MAXN];
int main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> agress;
    for(int i = 0; i < br; ++i){
        int useless; cin >> useless;
    }
    for(int i = 0; i < br; ++i){
        cin >> price[i];
    }
    sort(price, price + br);
    for(int i = 0; i < br; ++i){
        if(i == 0) prefix[i] = price[i];
        else prefix[i] = prefix[i - 1] + price[i];
    }
    for(int i = 1; i <= br + agress; ++i){
        cin >> getty[i];
    }
    int maximum = -INF;
    for(int i = 1; i <= br; ++i){
        int buy = -prefix[i - 1];
        int coeff = i;
        for(int z = 1; z <= br; ++z){
            buy += coeff * getty[z];
            coeff /= 2;
            if(coeff == 0) break;
        }
        maximum = max(maximum, buy);
    }
    cout << maximum << endl;
    return 0;
}
