//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, m;
vector<pair<ll, ll>> a;
vector<ll> c;

/**

5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

**/

ll calc(int mask) {
    set<ll> s;
    ll res = 0;

    //cout << "calc" nl;

    /*for (int i = 0 ;i < n; ++i) {
        if ((mask >> i) & 1) {
            cout << i+1 sq;
        }
    }

    cout nl;*/

    set<int> x;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            if (x.size() && *x.begin() < a[i].first) {
                return -1e9;
            }
            x.insert(a[i].first);
        }
    }

    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            ll aggr = a[i].first;/*
            if (s.size() && *s.begin() < aggr) {
                return -1e9;
            }*/

            /*if (s.lower_bound(aggr) != s.begin() && *(--s.lower_bound(aggr)) < aggr) {
                //cout << "NO" nl nl;
                return -1e9;
            }*/
            res -= a[i].second;
            res += c[aggr];
            //cout << "add" sp c[aggr] nl;

            while (true) {
                if (s.count(aggr)) {
                    s.erase(aggr);
                    aggr += 1;
                    res += c[aggr];
                    //cout << "add" sp c[aggr] nl;
                } else {
                    s.insert(aggr);
                    break;
                }
            }
        }
    }
    //cout nl;
    //cout << "res" sp res nl nl;
    return res;
}

ll calc2(int n) {
    ll res = 0;

    set<ll> s, x;

    for (int i = 0; i < n; ++i) {
        if (x.size() && *x.begin() < a[i].first) {
            return -1e9;
        }
        x.insert(a[i].first);
    }

    for (int i = 0; i < n; ++i) {
        ll aggr = a[i].first;

        res -= a[i].second;
        res += c[aggr];
        //cout << "add" sp c[aggr] nl;

        while (true) {
            if (s.count(aggr)) {
                s.erase(aggr);
                aggr += 1;
                res += c[aggr];
                //cout << "add" sp c[aggr] nl;
            } else {
                s.insert(aggr);
                break;
            }
        }
    }
    //cout nl;
    //cout << "res" sp res nl nl;
    return res;
}

void solve2() {
    ll ans = 0;

    for (int i = 1; i <= n; ++i) {
        ans = max(ans, calc2(i));
        //cout << "i" sp i sp calc2(i) nl;
    }

    cout << ans nl;
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    c.resize(n + m);

    for (auto &i: a) (cin >> i.first), i.first--;
    for (auto &i: a) cin >> i.second;
    for (auto &i: c) cin >> i;

    if (m == 1) {
        solve2();
        return;
    }

    int mask_end = 1 << n;
    ll ans = 0;

    for (int i = 0; i < mask_end; ++i) {
        ans = max(ans, calc(i));
    }

    cout << ans nl;
}
