#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run(int n, int m, int *agr, int *s, int *c);
void one(int n, int *s, int *c);

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    for (int q = 0; q < t; q++) {
        int n, m;
        cin >> n >> m;
        auto agr = arr<int>(n);
        for (int i = 0; i < n; i++) {
            cin >> agr[i];
        }
        auto s = arr<int>(n);
        for (int i = 0; i < n; i++) {
            cin >> s[i];
        }
        auto c = arr<int>(n + m + 1);
        for (int i = 1; i <= n + m; i++) {
            cin >> c[i];
        }
        if (m == 1) {
            one(n, s, c);
        } else {
            run(n, m, agr, s, c);
        }
    }
}

void run(int n, int m, int *agr, int *s, int *c) {
    auto sum = arr<int>(n + m + 2, 0);
    for (int i = 1; i <= n + m; i++) {
        sum[i] = sum[i - 1] + c[i];
    }
    sum[n + m + 1] = sum[n + m];
    long long ans = 0;
    for (int mask = 1; mask < (1 << n); mask++) {
        int pa = 1e9;
        bool pos = true;
        for (int i = 0; i < n; i++) {
            if (!(mask & (1 << i)))
                continue;
            if (agr[i] > pa) {
                pos = false;
                break;
            }
            pa = agr[i];
        }
        if (!pos)
            continue;
        vector<int> a;
        long long cur = 0;
        for (int i = 0; i < n; i++) {
            if (!(mask & (1 << i)))
                continue;
            cur += c[agr[i]] - s[i];
            auto ca = agr[i];
            while (!a.empty() && a.back() == ca) {
                cur += c[++ca];
                a.pop_back();
            }
            a.push_back(ca);
        }
        ans = max(ans, cur);
    }
    cout << ans << endl;
}

void one(int n, int *s, int *c) {
    long long ans = 0;
    sort(s, s + n);
    reverse(s, s + n);
    long long cur = 0;
    vector<int> st;
    for (int k = 1; k < n; k++) {
        cur += s[k - 1] + c[1];
        int ca = 1;
        while (!st.empty() && st.back() == ca) {
            cur += c[++ca];
            st.pop_back();
        }
        st.push_back(ca);
        ans = max(ans, cur);
    }
    cout << ans << endl;
}
