#include<iostream>
#include<cstring>
#include<vector>

using namespace std;

const int MAXN = 2005;
const int inf = 1e9 + 5;

int n, m;
int l[MAXN], s[MAXN], c[MAXN*2];

bool mode = false;
int memo1[205][205][205], memo2[2005][2005][17];

int calcState(int ind, int currNum, int amount)
{
    if(amount>n)
    {
        return -inf;
    }
    if(ind==n)
    {
        if(amount==0) return 0;
        return -inf;
    }
    if(currNum==0)
    {
        if(amount==0) return 0;
        return -inf;
    }
    if(mode==false)
    {
        if(memo1[ind][amount][currNum]!=-1)
        {
            return memo1[ind][amount][currNum];
        }
    }
    else
    {
        if(memo2[ind][amount][currNum]!=-1)
        {
            return memo2[ind][amount][currNum];
        }
    }


    int answer = -inf;
    answer = max(answer, calcState(ind, currNum-1, 2*amount) + amount*c[currNum]);
    answer = max(answer, calcState(ind, currNum-1, 2*amount+1) + amount*c[currNum]);

    answer = max(answer, calcState(ind+1, currNum, amount));
    if(l[ind]==currNum && amount!=0)
    {
        answer = max(answer, calcState(ind+1, currNum, amount-1) - s[ind] + c[ l[ind] ]);
    }

    //cout << ind << " " << currNum << " " << amount << " -> " << answer << '\n';

    if(mode==false) memo1[ind][amount][currNum] = answer;
    else memo2[ind][amount][currNum] = answer;

    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        cin >> l[i];
    }
    for(int i = 0;i<n;i++)
    {
        cin >> s[i];
    }
    for(int i = 1;i<=n+m;i++)
    {
        cin >> c[i];
    }

    if(m<=5)
    {
        mode = true;
        memset(memo2, -1, sizeof(memo2));
    }
    else
    {
        mode = false;
        memset(memo1, -1, sizeof(memo1));
    }

    cout << calcState(0, m+11, 0) << '\n';
}