#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e3+5, INF = 1e9;

mt19937 rnd(time(0));

int n, m, L[N], s[N], c[N];
int64_t ans;
map<int,int> uchs;


inline void read(){
    cin >> n >> m;
    for(int i = 1; i <= n; ++i)
        cin >> L[i];
    for(int i = 1; i <= n; ++i)
        cin >> s[i];
    for(int i = 1; i <= n+m; ++i)
        cin >> c[i];
}

inline void expsolve(){
    for(int mask = 0; mask < (1<<n); ++mask){
        int64_t tans = 0, maxt = INF;
        bool ok = true;
        uchs.clear();
        for(int i = 1; i <= n; ++i){
            if((mask>>(i-1))&1){
                tans-=s[i];
                if(L[i]>maxt){
                    ok = false;
                }
                maxt = min(maxt,1LL*L[i]);
                ++uchs[L[i]];
                int C = L[i];
                tans+=c[C];
                bool any = false;
                do{
                    any = false;
                    while(uchs[C]>1){
                       ++uchs[C+1];
                       tans+=c[C+1];
                       uchs[C]-=2;
                       any = true;
                    } ++C;
                }while(any);
            }
        }
        if(ok) ans = max(ans,tans);
    }
}

inline void print(){
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    read();
    expsolve();
    print();

    return 0;
}


