#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
using namespace std;
const int inf = 1e9;
const int max_n = 2001, max_m = 5, max_sum = 2001 * 2;
int n, m;
int l[max_n], s[max_n], c[max_n + max_m];
int dp[max_n][max_sum][max_m];

void scan() {
    cin >> n >> m;
    for(int i = 0;i < n;i++) cin >> l[i];
    for(int i = 0;i < n;i++) cin >> s[i];
    for(int i = 1;i < n + m;i++) cin >> c[i];

    for(int i = 0;i < n;i++) {
        for(int j = 1;j < l[i];j++) {
            s[i] += c[l[i] - j] * (1 << j);
        }
    }

   /* for(int i = 0;i < n;i++) cout << s[i] << " ";
    cout << '\n';*/
}

void build() {
    for(int i = 0;i < n;i++) {
        for(int j = 0;j < max_sum;j++) {
            for(int k = 1;k <= m;k++) {
                int Min = inf;
                if (i != 0) Min = dp[i - 1][j][k];
                if (j >= (1 << (l[i] - 1)) && k <= l[i]) {
                    if (i == 0 && j == (1 << (l[i] - 1))) Min = min(Min, s[i]);
                    else if (i != 0) Min = min(Min, dp[i - 1][j - (1 << (l[i] - 1))][l[i]] + s[i]);
                }

                if (i == 0 && j == 0) {
                    dp[i][j][k] = 0;
                }else dp[i][j][k] = Min;
            }
        }
    }

    /*for(int i = 0;i < n;i++) {
        for(int j = 0;j <= 2;j++) {
            for(int k = 1;k <= m;k++) cout << dp[i][j][k] << " ";
            cout << '\n';
        }
        cout << '\n';
    }*/

}

int get(int cnt) {
    int res = 0;
    int id = 1;
    while(cnt > 0) {
        res += c[id] * cnt;
        cnt /= 2;
        id++;
    }
    return res;
}


void solve() {
    scan();
    build();

    int ans = 0;
    for(int i = 0;i < max_sum;i++) ans = max(ans, get(i) - dp[n - 1][i][1]);

    cout << ans;
}


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);


    solve();
}