#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
uniform_real_distribution<> re(0, 1);
template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 2000;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m; cin >> n >> m;
    vector <int> ar(n), cost(n);
    for (int &i : ar) cin >> i;
    for (int &i : cost) cin >> i;
    vector <int> agr(n+m+1);
    For (i, n+m) cin >> agr[i+1];
    vector<int> buf; buf.reserve(n);
    int ans = 0;
    if (m == 1) {
        sort(cost.begin(), cost.end());
        int cc = 0;
        For (i, n) {
            buf.push_back(1);
            cc += agr[1] - cost[i];
            while (buf.size() >= 2 && buf[buf.size()-1] == buf[buf.size()-2]) {
                cc += agr[buf.back()+1];
                buf.pop_back();
                buf.back()++;
            }
            umax(ans, cc);
        }
        cout << ans << endl;
        return 0;
    }

    For (msk, 1<<20) {
        buf.clear();
        int zmsk = msk;
        int mx = m;
        int cc = 0;
        For (i, n) {
            if (mx < ar[i]) continue;
            if (zmsk & 1) {
                umin(mx, ar[i]);
                buf.push_back(ar[i]);
                cc += agr[ar[i]] - cost[i];
                while (buf.size() >= 2 && buf[buf.size()-1] == buf[buf.size()-2]) {
                    cc += agr[buf.back()+1];
                    buf.pop_back();
                    buf.back()++;
                }
            }
            zmsk >>= 1;
        }
        umax(ans, cc);
    }
    cout << ans << endl;
}
