#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

#ifdef __DEBUG
const int bits = 5;
#else
const int bits = 25;
#endif

#ifdef __DEBUG
const int M = 10010;
#else
const int M = (1 << (bits + 1)) + 1;
#endif

const int INF = (int)1e9 + 10;

int l[N], s[N], c[N];

map < int, int > mp;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	int ans = 0;
	if (n <= 15) {
		for (int mask = 0; mask < (1 << n); ++mask) {
			int mn = INF;
			bool ok = true;
			int res = 0;
			mp.clear();
			for (int i = 0; i < n; ++i) {
				if ((mask >> i) & 1) {
					if (l[i] > mn) {
						ok = false;
						break;
					}
					mn = min(mn, l[i]);
					res -= s[i];
					res += c[l[i]];
					mp[l[i]]++;
					while (true) {
						bool ch = false;
						for (auto t : mp) {
							if (t.second >= 2) {
								mp[t.first] -= 2;
								mp[t.first + 1] += 1;
								res += c[t.first + 1];
								if (mp[t.first] == 0)
									mp.erase(t.first);
								ch = true;
								break;
							}
						}
						if (ch)
							continue;
						else
							break;
					}
				}
			}
			if (ok)
				ans = max(ans, res);
		}
	}
	cout << ans;
}