import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import static java.lang.Math.max;

public class A2 {
    static BufferedReader in;
    static StringTokenizer st;
    static int l[], s[], c[];
    static int n, m;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        fn();
        n = nextInt();
        m = nextInt();
        l = new int[n + 1];
        s = new int[n + 1];
        c = new int[n + m];
        fn();
        for (int i = 1; i <= n; i++) {
            l[i] = nextInt() - 1;
        }
        fn();
        for (int i = 1; i <= n; i++) {
            s[i] = nextInt();
        }
        fn();
        for (int i = 0; i < n + m; i++) {
            c[i] = nextInt();
        }
        int dp[][][] = new int[n + 1][m][n + 1];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j <= n; j++) {
                int tk = j;
                int uk = i;
                while (uk < n + m && j > 0) {
                    dp[0][i][j] += tk * c[uk];
                    uk++;
                    tk /= 2;
                }
            }
        }
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < m; j++) {
                for (int cnt = 0; cnt < n; cnt++) {
                    dp[i][j][cnt] = dp[i - 1][j][cnt];
                    if (l[i] >= j) {
                        int sm = 0;
                        int tk = cnt;
                        int uk = j;
                        while (uk < l[i]) {
                            sm += tk * c[uk];
                            uk++;
                            tk /= 2;
                        }
                        dp[i][j][cnt] = max(dp[i][j][cnt], dp[i - 1][l[i]][tk + 1] + sm - s[i]);
                    }
                }
            }
        }
        System.out.println(dp[n][0][0]);
    }

    private static int fk(int msk) {
        int pr = 1000000;
        int sum = 0;
        int ms[] = new int[n + m];
        for (int i = 0; i < n; i++) {
            if ((msk & (1 << i)) > 0) {
                if (pr < l[i]) return 0;
                pr = l[i];
                sum -= s[i];
                ms[l[i]]++;
            }
        }
        for (int i = 0; i < n + m; i++) {
            sum += ms[i] * c[i];
            if (i != n + m - 1) ms[i + 1] += ms[i] / 2;
        }
        return sum;
    }

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    private static void fn() throws IOException {
        st = new StringTokenizer(in.readLine());
    }
}
