#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;

ll n, m;
vector <ll> l, s, c;

void add(ll i, map <ll, ll> &m, ll &now) {
    now -= s[i];
    now += c[l[i]];
    m[l[i]]++;
}

ll solve1() {
    ll ans = 0;
    for (ll mask = 0; mask < (1LL << n); ++mask) {
        ll now = 0;
        bool ok = true;
        map <ll, ll> m;
        for (ll i = 0; i < n; ++i) {
            if (mask & (1LL << i)) {
                if (m.empty()) {
                    add(i, m, now);
                } else {
                    if (!(m.begin() -> first < l[i])) {
                        add(i, m, now);
                    } else {
                        ok = false;
                        break;
                    }
                }
            }
        }
        if (!ok) {
            continue;
        }
        while (!m.empty()) {
            pll t = *m.begin();
            m.erase(m.begin());
            ll x = t.first, y = t.second;
            ll cnt = y / 2;
            now += cnt * c[x + 1];
            if (cnt) {
                m[x + 1] += cnt;
            }
        }
        ans = max(ans, now);
    }
    return ans;
}

ll solve2() {
    ll ans = 0;
    sort(s.begin(), s.end());
    vector <ll> sum(n);
    for (ll i = 0; i < n; ++i) {
        if (i) {
            sum[i] = sum[i - 1] + s[i];
        } else {
            sum[i] = s[i];
        }
    }
    for (ll i = 1; i <= n; ++i) {
        ll now = 0;
        now -= sum[i - 1];
        ll ptr = l[1];
        now += c[ptr] * i;
        ll k = i;
        while (k) {
            k >>= 1;
            ++ptr;
            now += c[ptr] * k;
        }
        ans = max(ans, now);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m + 1);
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (ll i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }


    if (n <= 15) {
        cout << solve1() << endl;
    } else if (m == 1) {
        cout << solve2() << endl;
    }
    return 0;
}

/**


**/
