#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
using namespace std;
const int inf = 1e9;
const int max_n = 2001, max_m = 15, max_sum = 2001 * 5;
int n, m;
int l[max_n], s[max_n], c[max_n + max_m];
int dp[max_sum][max_m];

void scan() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 1; i < n + m; i++) cin >> c[i];

    if (m <= 5) {
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < l[i]; j++) {
                s[i] += c[l[i] - j] * (1 << j);
            }
        }

    }

    /* for(int i = 0;i < n;i++) cout << s[i] << " ";
     cout << '\n';*/
}

void build() {
    for (int i = 0; i < n; i++) {
        int new_dp[max_sum][max_m];
        for (int j = 0; j < max_sum; j++) {
            for (int k = 1; k <= m; k++) {
                int Min = inf;
                if (i != 0) Min = dp[j][k];
                if (j >= (1 << (l[i] - 1)) && k <= l[i]) {
                    if (i == 0 && j == (1 << (l[i] - 1))) Min = min(Min, s[i]);
                    else if (i != 0) Min = min(Min, dp[j - (1 << (l[i] - 1))][l[i]] + s[i]);
                }

                if (i == 0 && j == 0) {
                    new_dp[j][k] = 0;
                } else new_dp[j][k] = Min;
            }
        }
        for (int j = 0; j < max_sum; j++) {
            for (int k = 0; k < max_m; k++) dp[j][k] = new_dp[j][k];
        }
    }

    /*for(int i = 0;i < n;i++) {
        for(int j = 0;j <= 2;j++) {
            for(int k = 1;k <= m;k++) cout << dp[i][j][k] << " ";
            cout << '\n';
        }
        cout << '\n';
    }*/

}

int get(int cnt) {
    int res = 0;
    int id = 1;
    while (cnt > 0) {
        res += c[id] * cnt;
        cnt /= 2;
        id++;
    }
    return res;
}


/*void scan() {
    cin >> n >> m;
    for(int i = 0;i < n;i++) cin >> l[i];
    for(int i = 0;i < n;i++) cin >> s[i];
    for(int i = 1;i < n + m;i++) cin >> c[i];

   *//* for(int i = 0;i < n;i++) cout << s[i] << " ";
    cout << '\n';*//*
}*/

void solve() {
    scan();
    if (m <= 5) {
        build();

        int ans = 0;
        for (int i = 0; i < max_sum; i++) ans = max(ans, get(i) - dp[i][1]);

        cout << ans;
    } else {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            int new_ans = 0;
            int last = 123123;
            bool bad = false;
            int num[n + m + 1];
            for (int i = 0; i < n + m + 1; i++) num[i] = 0;


            for (int i = 0; i < n; i++) {
                if ((mask & (1 << i)) != 0) {
                    if (last < l[i]) bad = true;
                    last = l[i];
                    new_ans -= s[i];

                    num[l[i]]++;
                }
            }
            if (bad) continue;

            for (int i = 1; i < n + m + 1; i++) {
                new_ans += num[i] * c[i];
                if (i + 1 < n + m + 1) num[i + 1] += num[i] / 2;
            }

            ans = max(ans, new_ans);
        }

        cout << ans;
    }
}


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);


    solve();
}