#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m;
	vector <ll> l(n);
	for (auto& x : l) {
		cin >> x;
	}
	vector <ll> s(n);
	for (auto& x : s) {
		cin >> x;
	}
	vector <ll> c(n + m);
	for (auto& x : c) {
		cin >> x;
	}
	if (n <= 15) {
		ll ans = 0;
		for (ll mask = 0; mask < (1 << n); ++mask) {
			vector <ll> cur;
			ll mine = INF;
			ll res = 0;
			for (int i = 0; i < n; ++i) {
				if (mask & (1 << i)) {
					if (l[i] <= mine) {
						mini(mine, l[i]);
						cur.push_back(l[i]);
						res += c[l[i] - 1] - s[i];
					}
				}
			}
			bool updated = true;
			while (updated) {
				updated = false;
				for (int i = 0; i < cur.size(); ++i) {
					for (int j = i + 1; j < cur.size(); ++j) {
						if (cur[i] == cur[j]) {
							cur.push_back(cur[i] + 1);
							res += c[cur[i]];
							cur.erase(cur.begin() + j);
							cur.erase(cur.begin() + i);
							updated = true;
							break;
						}
					}
					if (updated) break;
				}
			}
			maxi(ans, res);
		}
		cout << ans << '\n';
	}
	else if (m == 1) {
		sort(s.begin(), s.end());
		ll ans = 0;
		ll base = 0;
		for (int i = 0; i < n; ++i) {
			base += c[0] - s[i];
			ll cpy = base;
			ll cur = i + 1;
			ll cl = 1;
			while (cur > 1) {
				cpy += c[cl] * (cur / 2);
				++cl;
				cur /= 2;
			}
			maxi(ans, cpy);
		}
		cout << ans << '\n';
	}
	else if (m == 2) {
		ll base = 0;
		ll ans = 0;
		ll cnt2 = 0;
		for (int i = 0; i <= n; ++i) {
			vector <ll> ns;
			for (int j = i; j < n; ++j) {
				if (l[j] == 1) {
					ns.push_back(s[j]);
				}
			}
			sort(ns.begin(), ns.end());

			ll fromo = 0;
			for (int i = 0; i < ns.size(); ++i) {
				fromo += c[0] - ns[i];
				ll cnt = i + 1;
				ll add = c[1] * (cnt / 2);
				ll ocnt = cnt2 + cnt;
				ll cl = 2;
				while (ocnt > 1) {
					add += c[cl++] * (ocnt / 2);
					ocnt /= 2;
				}
				maxi(ans, fromo + base + add);
			}
			
			if (i < n && l[i] == 2) {
				base += c[1] - s[i];
				++cnt2;
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2
0 0
2 1 -100 -100

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4
*/