#include<iostream>
#include<algorithm>
#include<cmath>
#include<queue>
#include<vector>
#include<deque>
#include<set>
#include<map>
#include<random>
#include<tuple>
#include<cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

mt19937 gen(313);
uniform_int_distribution <int> rand_int(1, 1000000000);

const int N = 5007;

int a[N], s[N], c[2 * N], ps[N];

void brute_force(int n) {
	int ans = 0;
	loop(mask, (1 << n)) {
		int last = 30, cur = 0; bool ok = 1;
		vector <int> beat;
		loop(bit, n)
			if (mask & (1 << bit)) {
				if (last < a[bit]) {
					ok = 0; break;
				}
				last = a[bit];
				cur += c[a[bit]] - s[bit];
				beat.pb(a[bit]);
				while (beat.size() > 1 && beat.back() == beat[beat.size() - 2]) {
					int x = beat.back();
					cur += c[x + 1];
					beat.pop_back(); beat.pop_back(); beat.pb(x + 1);
				}
			}
		if (!ok) continue;
		//cout << mask << " " << cur << " " << ok << "\n";
		ans = max(ans, cur);
	}
	cout << ans;
}

void solve() {
	int n, m; cin >> n >> m;
	for (int i = 0 + (n > 15 || m > 15); i < n + (n > 15 || m > 15); ++i) {
		cin >> a[i];
		if (n > 15 || m > 15) ps[i] = ps[i - 1] + (a[i] == 1);
	}
	for (int i = 0 + (n > 15 || m > 15); i < n + (n > 15 || m > 15); ++i) cin >> s[i];
	loop1(i, n + m) cin >> c[i];
	if (n <= 15 && m <= 15) {
		brute_force(n); return;
	}
	int ans = 0;
	sort(s + 1, s + n + 1);
	for (int i = 1; i <= n; ++i) s[i] = s[i - 1] + s[i];
	//loop(i, n) cout << s[i] << " ";
	loop1(i, n) {
		int cur = -s[i], x = i, cnt = 0;
		while (x > 0) {
			if (x & 1) {
				int d = 1;
				for (int bit = cnt; bit >= 0; --bit) {
					cur += c[1 + bit] * d; d *= 2;
				}
			}
			++cnt; x = (x >> 1);
		}
		ans = max(ans, cur);
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	solve();
	return 0;
}
/*
5 4
1 1 1 1 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9
*/